﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
'use strict';var cr={plugins_:{},behaviors:{}};"function"!==typeof Object.getPrototypeOf&&(Object.getPrototypeOf="object"===typeof"test".__proto__?function(a){return a.__proto__}:function(a){return a.constructor.prototype});
(function(){function a(a,b){this.x=a;this.y=b;cr.seal(this)}function b(a,b,c,d){this.set(a,b,c,d);cr.seal(this)}function c(){this.bly=this.blx=this.bry=this.brx=this.try_=this.trx=this.tly=this.tlx=0;cr.seal(this)}function d(a,b,c,d){a<b?c<d?(n=a<c?a:c,p=b>d?b:d):(n=a<d?a:d,p=b>c?b:c):c<d?(n=b<c?b:c,p=a>d?a:d):(n=b<d?b:d,p=a>c?a:c)}function e(){this.items=this.s=null;this.item_count=0;r?this.s=new Set:this.items={};this.values_cache=[];this.cache_valid=!0;cr.seal(this)}function g(a){t[s++]=a}function f(){this.sum=
this.t=this.y=this.c=0;cr.seal(this)}function l(a){this.pts_cache=[];this.bboxBottom=this.bboxRight=this.bboxTop=this.bboxLeft=0;this.convexpolys=null;this.set_pts(a);cr.seal(this)}function k(a,b){this.cellwidth=a;this.cellheight=b;this.cells={}}function h(a,b,c){var d;k.prototype.totalCellCount++;return u.length?(d=u.pop(),d.grid=a,d.x=b,d.y=c,d):new cr.GridCell(a,b,c)}function m(a,b,c){this.grid=a;this.x=b;this.y=c;this.objects=new cr.ObjectSet}cr.logexport=function(a){window.console&&window.console.log&&
window.console.log(a)};cr.seal=function(a){return a};cr.freeze=function(a){return a};cr.is_undefined=function(a){return"undefined"===typeof a};cr.is_number=function(a){return"number"===typeof a};cr.is_string=function(a){return"string"===typeof a};cr.isPOT=function(a){return 0<a&&0===(a-1&a)};cr.nextHighestPowerOfTwo=function(a){--a;for(var b=1;32>b;b<<=1)a|=a>>b;return a+1};cr.abs=function(a){return 0>a?-a:a};cr.max=function(a,b){return a>b?a:b};cr.min=function(a,b){return a<b?a:b};cr.PI=Math.PI;
cr.round=function(a){return a+0.5|0};cr.floor=function(a){return 0<=a?a|0:(a|0)-1};cr.ceil=function(a){var b=a|0;return b===a?b:b+1};a.prototype.offset=function(a,b){this.x+=a;this.y+=b;return this};a.prototype.mul=function(a,b){this.x*=a;this.y*=b;return this};cr.vector2=a;cr.segments_intersect=function(a,b,c,d,g,e,f,k){var h,u,l,m;a<c?(u=a,h=c):(u=c,h=a);g<f?(m=g,l=f):(m=f,l=g);if(h<m||u>l)return!1;b<d?(u=b,h=d):(u=d,h=b);e<k?(m=e,l=k):(m=k,l=e);if(h<m||u>l)return!1;h=g-a+f-c;u=e-b+k-d;a=c-a;b=
d-b;g=f-g;e=k-e;k=cr.abs(b*g-e*a);return cr.abs(g*u-e*h)>k?!1:cr.abs(a*u-b*h)<=k};b.prototype.set=function(a,b,c,d){this.left=a;this.top=b;this.right=c;this.bottom=d};b.prototype.copy=function(a){this.left=a.left;this.top=a.top;this.right=a.right;this.bottom=a.bottom};b.prototype.width=function(){return this.right-this.left};b.prototype.height=function(){return this.bottom-this.top};b.prototype.offset=function(a,b){this.left+=a;this.top+=b;this.right+=a;this.bottom+=b;return this};b.prototype.normalize=
function(){var a=0;this.left>this.right&&(a=this.left,this.left=this.right,this.right=a);this.top>this.bottom&&(a=this.top,this.top=this.bottom,this.bottom=a)};b.prototype.intersects_rect=function(a){return!(a.right<this.left||a.bottom<this.top||a.left>this.right||a.top>this.bottom)};b.prototype.intersects_rect_off=function(a,b,c){return!(a.right+b<this.left||a.bottom+c<this.top||a.left+b>this.right||a.top+c>this.bottom)};b.prototype.contains_pt=function(a,b){return a>=this.left&&a<=this.right&&b>=
this.top&&b<=this.bottom};b.prototype.equals=function(a){return this.left===a.left&&this.top===a.top&&this.right===a.right&&this.bottom===a.bottom};cr.rect=b;c.prototype.set_from_rect=function(a){this.tlx=a.left;this.tly=a.top;this.trx=a.right;this.try_=a.top;this.brx=a.right;this.bry=a.bottom;this.blx=a.left;this.bly=a.bottom};c.prototype.set_from_rotated_rect=function(a,b){if(0===b)this.set_from_rect(a);else{var c=Math.sin(b),d=Math.cos(b),g=a.left*c,e=a.top*c,f=a.right*c,c=a.bottom*c,k=a.left*
d,h=a.top*d,u=a.right*d,d=a.bottom*d;this.tlx=k-e;this.tly=h+g;this.trx=u-e;this.try_=h+f;this.brx=u-c;this.bry=d+f;this.blx=k-c;this.bly=d+g}};c.prototype.offset=function(a,b){this.tlx+=a;this.tly+=b;this.trx+=a;this.try_+=b;this.brx+=a;this.bry+=b;this.blx+=a;this.bly+=b;return this};var n=0,p=0;c.prototype.bounding_box=function(a){d(this.tlx,this.trx,this.brx,this.blx);a.left=n;a.right=p;d(this.tly,this.try_,this.bry,this.bly);a.top=n;a.bottom=p};c.prototype.contains_pt=function(a,b){var c=this.trx-
this.tlx,d=this.try_-this.tly,g=this.brx-this.tlx,e=this.bry-this.tly,f=a-this.tlx,k=b-this.tly,h=c*c+d*d,u=c*g+d*e,d=c*f+d*k,l=g*g+e*e,m=g*f+e*k,n=1/(h*l-u*u),c=(l*d-u*m)*n,h=(h*m-u*d)*n;if(0<=c&&0<h&&1>c+h)return!0;c=this.blx-this.tlx;d=this.bly-this.tly;h=c*c+d*d;u=c*g+d*e;d=c*f+d*k;n=1/(h*l-u*u);c=(l*d-u*m)*n;h=(h*m-u*d)*n;return 0<=c&&0<h&&1>c+h};c.prototype.at=function(a,b){if(b)switch(a){case 0:return this.tlx;case 1:return this.trx;case 2:return this.brx;case 3:return this.blx;case 4:return this.tlx;
default:return this.tlx}else switch(a){case 0:return this.tly;case 1:return this.try_;case 2:return this.bry;case 3:return this.bly;case 4:return this.tly;default:return this.tly}};c.prototype.midX=function(){return(this.tlx+this.trx+this.brx+this.blx)/4};c.prototype.midY=function(){return(this.tly+this.try_+this.bry+this.bly)/4};c.prototype.intersects_segment=function(a,b,c,d){if(this.contains_pt(a,b)||this.contains_pt(c,d))return!0;var g,e,f,h,k;for(k=0;4>k;k++)if(g=this.at(k,!0),e=this.at(k,!1),
f=this.at(k+1,!0),h=this.at(k+1,!1),cr.segments_intersect(a,b,c,d,g,e,f,h))return!0;return!1};c.prototype.intersects_quad=function(a){var b=a.midX(),c=a.midY();if(this.contains_pt(b,c))return!0;b=this.midX();c=this.midY();if(a.contains_pt(b,c))return!0;var d,g,e,f,k,h,u,l;for(u=0;4>u;u++)for(l=0;4>l;l++)if(b=this.at(u,!0),c=this.at(u,!1),d=this.at(u+1,!0),g=this.at(u+1,!1),e=a.at(l,!0),f=a.at(l,!1),k=a.at(l+1,!0),h=a.at(l+1,!1),cr.segments_intersect(b,c,d,g,e,f,k,h))return!0;return!1};cr.quad=c;cr.RGB=
function(a,b,c){return Math.max(Math.min(a,255),0)|Math.max(Math.min(b,255),0)<<8|Math.max(Math.min(c,255),0)<<16};cr.GetRValue=function(a){return a&255};cr.GetGValue=function(a){return(a&65280)>>8};cr.GetBValue=function(a){return(a&16711680)>>16};cr.shallowCopy=function(a,b,c){for(var d in b)b.hasOwnProperty(d)&&(a[d]=b[d]);return a};cr.arrayRemove=function(a,b){var c,d;b=cr.floor(b);if(!(0>b||b>=a.length))if(0===b)a.shift();else if(b===a.length-1)a.pop();else{c=b;for(d=a.length-1;c<d;c++)a[c]=a[c+
1];a.length=d}};cr.shallowAssignArray=function(a,b){a.length=b.length;var c,d;c=0;for(d=b.length;c<d;c++)a[c]=b[c]};cr.appendArray=function(a,b){a.push.apply(a,b)};cr.arrayFindRemove=function(a,b){var c=a.indexOf(b);-1!==c&&cr.arrayRemove(a,c)};cr.clamp=function(a,b,c){return a<b?b:a>c?c:a};cr.to_radians=function(a){return a/(180/cr.PI)};cr.to_degrees=function(a){return a*(180/cr.PI)};cr.clamp_angle_degrees=function(a){a%=360;0>a&&(a+=360);return a};cr.clamp_angle=function(a){a%=2*cr.PI;0>a&&(a+=
2*cr.PI);return a};cr.to_clamped_degrees=function(a){return cr.clamp_angle_degrees(cr.to_degrees(a))};cr.to_clamped_radians=function(a){return cr.clamp_angle(cr.to_radians(a))};cr.angleTo=function(a,b,c,d){return Math.atan2(d-b,c-a)};cr.angleDiff=function(a,b){if(a===b)return 0;var c=Math.sin(a),d=Math.cos(a),g=Math.sin(b),e=Math.cos(b),c=c*g+d*e;return 1<=c?0:-1>=c?cr.PI:Math.acos(c)};cr.angleRotate=function(a,b,c){var d=Math.sin(a),g=Math.cos(a),e=Math.sin(b),f=Math.cos(b);return Math.acos(d*e+
g*f)>c?0<g*e-d*f?cr.clamp_angle(a+c):cr.clamp_angle(a-c):cr.clamp_angle(b)};cr.angleClockwise=function(a,b){var c=Math.sin(a),d=Math.cos(a),g=Math.sin(b),e=Math.cos(b);return 0>=d*g-c*e};cr.rotatePtAround=function(a,b,c,d,g,e){if(0===c)return e?a:b;var f=Math.sin(c);c=Math.cos(c);a-=d;b-=g;var k=a*f;a=a*c-b*f;b=b*c+k;return e?a+d:b+g};cr.distanceTo=function(a,b,c,d){a=c-a;b=d-b;return Math.sqrt(a*a+b*b)};cr.xor=function(a,b){return!a!==!b};cr.lerp=function(a,b,c){return a+(b-a)*c};cr.unlerp=function(a,
b,c){return a===b?0:(c-a)/(b-a)};cr.anglelerp=function(a,b,c){var d=cr.angleDiff(a,b);return cr.angleClockwise(b,a)?a+d*c:a-d*c};cr.hasAnyOwnProperty=function(a){for(var b in a)if(a.hasOwnProperty(b))return!0;return!1};cr.wipe=function(a){for(var b in a)a.hasOwnProperty(b)&&delete a[b]};var q=+new Date;cr.performance_now=function(){if("undefined"!==typeof window.performance){var a=window.performance;if("undefined"!==typeof a.now)return a.now();if("undefined"!==typeof a.webkitNow)return a.webkitNow();
if("undefined"!==typeof a.mozNow)return a.mozNow();if("undefined"!==typeof a.msNow)return a.msNow()}return Date.now()-q};var r="undefined"!==typeof Set&&"undefined"!==typeof Set.prototype.forEach;e.prototype.contains=function(a){return r?this.s.has(a):this.items.hasOwnProperty(a.toString())};e.prototype.add=function(a){if(r)this.s.has(a)||(this.s.add(a),this.cache_valid=!1);else{var b=a.toString();this.items.hasOwnProperty(b)||(this.items[b]=a,this.item_count++,this.cache_valid=!1)}return this};e.prototype.remove=
function(a){r?this.s.has(a)&&(this.s["delete"](a),this.cache_valid=!1):(a=a.toString(),this.items.hasOwnProperty(a)&&(delete this.items[a],this.item_count--,this.cache_valid=!1));return this};e.prototype.clear=function(){r?this.s.clear():(this.items={},this.item_count=0);this.values_cache.length=0;this.cache_valid=!0;return this};e.prototype.isEmpty=function(){return r?0===this.s.size:0===this.item_count};e.prototype.count=function(){return r?this.s.size:this.item_count};var t=null,s=0;e.prototype.update_cache=
function(){if(!this.cache_valid){if(r)this.values_cache.length=this.s.size,t=this.values_cache,s=0,this.s.forEach(g),t=null,s=0;else{this.values_cache.length=this.item_count;var a,b=0;for(a in this.items)this.items.hasOwnProperty(a)&&(this.values_cache[b++]=this.items[a])}this.cache_valid=!0}};e.prototype.values=function(){this.update_cache();return this.values_cache.slice(0)};e.prototype.valuesRef=function(){this.update_cache();return this.values_cache};cr.ObjectSet=e;f.prototype.add=function(a){this.y=
a-this.c;this.t=this.sum+this.y;this.c=this.t-this.sum-this.y;this.sum=this.t};f.prototype.reset=function(){this.sum=this.t=this.y=this.c=0};cr.KahanAdder=f;cr.regexp_escape=function(a){return a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};l.prototype.set_pts=function(a){this.pts_array=a;this.pts_count=a.length/2;this.pts_cache.length=a.length;this.cache_height=this.cache_width=-1;this.cache_angle=0};l.prototype.is_empty=function(){return!this.pts_array.length};l.prototype.update_bbox=function(){for(var a=
this.pts_cache,b=a[0],c=b,d=a[1],g=d,e,f,k=1,h=this.pts_count;k<h;++k)f=2*k,e=a[f],f=a[f+1],e<b&&(b=e),e>c&&(c=e),f<d&&(d=f),f>g&&(g=f);this.bboxLeft=b;this.bboxRight=c;this.bboxTop=d;this.bboxBottom=g};l.prototype.set_from_rect=function(a,b,c){this.pts_cache.length=8;this.pts_count=4;var d=this.pts_cache;d[0]=a.left-b;d[1]=a.top-c;d[2]=a.right-b;d[3]=a.top-c;d[4]=a.right-b;d[5]=a.bottom-c;d[6]=a.left-b;d[7]=a.bottom-c;this.cache_width=a.right-a.left;this.cache_height=a.bottom-a.top;this.update_bbox()};
l.prototype.set_from_quad=function(a,b,c,d,e){this.pts_cache.length=8;this.pts_count=4;var g=this.pts_cache;g[0]=a.tlx-b;g[1]=a.tly-c;g[2]=a.trx-b;g[3]=a.try_-c;g[4]=a.brx-b;g[5]=a.bry-c;g[6]=a.blx-b;g[7]=a.bly-c;this.cache_width=d;this.cache_height=e;this.update_bbox()};l.prototype.set_from_poly=function(a){this.pts_count=a.pts_count;cr.shallowAssignArray(this.pts_cache,a.pts_cache);this.bboxLeft=a.bboxLeft;this.bboxTop-a.bboxTop;this.bboxRight=a.bboxRight;this.bboxBottom=a.bboxBottom};l.prototype.cache_poly=
function(a,b,c){if(this.cache_width!==a||this.cache_height!==b||this.cache_angle!==c){this.cache_width=a;this.cache_height=b;this.cache_angle=c;var d,g,e,f,k,h=0,u=1,l=this.pts_array,m=this.pts_cache;0!==c&&(h=Math.sin(c),u=Math.cos(c));c=0;for(e=this.pts_count;c<e;c++)d=2*c,g=d+1,f=l[d]*a,k=l[g]*b,m[d]=f*u-k*h,m[g]=k*u+f*h;this.update_bbox()}};l.prototype.contains_pt=function(a,b){var c=this.pts_cache;if(a===c[0]&&b===c[1])return!0;var d,g,e,f=this.pts_count,k=this.bboxLeft-110,h=this.bboxTop-101,
u=this.bboxRight+131,l=this.bboxBottom+120,m,n,q=0,r=0;for(d=0;d<f;d++)g=2*d,e=2*((d+1)%f),m=c[g],g=c[g+1],n=c[e],e=c[e+1],cr.segments_intersect(k,h,a,b,m,g,n,e)&&q++,cr.segments_intersect(u,l,a,b,m,g,n,e)&&r++;return 1===q%2||1===r%2};l.prototype.intersects_poly=function(a,b,c){var d=a.pts_cache,g=this.pts_cache;if(this.contains_pt(d[0]+b,d[1]+c)||a.contains_pt(g[0]-b,g[1]-c))return!0;var e,f,k,h,u,l,m,n,q,r,A,s;e=0;for(h=this.pts_count;e<h;e++)for(f=2*e,k=2*((e+1)%h),n=g[f],f=g[f+1],q=g[k],r=g[k+
1],k=0,m=a.pts_count;k<m;k++)if(u=2*k,l=2*((k+1)%m),A=d[u]+b,u=d[u+1]+c,s=d[l]+b,l=d[l+1]+c,cr.segments_intersect(n,f,q,r,A,u,s,l))return!0;return!1};l.prototype.intersects_segment=function(a,b,c,d,g,e){var f=this.pts_cache;if(this.contains_pt(c-a,d-b))return!0;var k,h,u,l,m,n;k=0;for(h=this.pts_count;k<h;k++)if(u=2*k,l=2*((k+1)%h),m=f[u]+a,u=f[u+1]+b,n=f[l]+a,l=f[l+1]+b,cr.segments_intersect(c,d,g,e,m,u,n,l))return!0;return!1};l.prototype.mirror=function(a){var b,c,d;b=0;for(c=this.pts_count;b<c;++b)d=
2*b,this.pts_cache[d]=2*a-this.pts_cache[d]};l.prototype.flip=function(a){var b,c,d;b=0;for(c=this.pts_count;b<c;++b)d=2*b+1,this.pts_cache[d]=2*a-this.pts_cache[d]};l.prototype.diag=function(){var a,b,c,d,g;a=0;for(b=this.pts_count;a<b;++a)c=2*a,d=c+1,g=this.pts_cache[c],this.pts_cache[c]=this.pts_cache[d],this.pts_cache[d]=g};cr.CollisionPoly=l;k.prototype.totalCellCount=0;k.prototype.getCell=function(a,b,c){var d;d=this.cells[a];return d?(d=d[b])?d:c?(d=h(this,a,b),this.cells[a][b]=d):null:c?(d=
h(this,a,b),this.cells[a]={},this.cells[a][b]=d):null};k.prototype.XToCell=function(a){return cr.floor(a/this.cellwidth)};k.prototype.YToCell=function(a){return cr.floor(a/this.cellheight)};k.prototype.update=function(a,b,c){var d,g,e,f,h;if(b)for(d=b.left,g=b.right;d<=g;++d)for(e=b.top,f=b.bottom;e<=f;++e)if(!c||!c.contains_pt(d,e))if(h=this.getCell(d,e,!1))h.remove(a),h.isEmpty()&&(k.prototype.totalCellCount--,h.objects.clear(),1E3>u.length&&u.push(h),this.cells[d][e]=null);if(c)for(d=c.left,g=
c.right;d<=g;++d)for(e=c.top,f=c.bottom;e<=f;++e)b&&b.contains_pt(d,e)||this.getCell(d,e,!0).insert(a)};k.prototype.queryRange=function(a,b){var c,d,g,e,f,k;c=this.XToCell(a.left);g=this.YToCell(a.top);d=this.XToCell(a.right);for(f=this.YToCell(a.bottom);c<=d;++c)for(e=g;e<=f;++e)(k=this.getCell(c,e,!1))&&k.dump(b)};cr.SparseGrid=k;var u=[];m.prototype.isEmpty=function(){return this.objects.isEmpty()};m.prototype.insert=function(a){this.objects.add(a)};m.prototype.remove=function(a){this.objects.remove(a)};
m.prototype.dump=function(a){cr.appendArray(a,this.objects.valuesRef())};cr.GridCell=m;var A="lighter xor copy destination-over source-in destination-in source-out destination-out source-atop destination-atop".split(" ");cr.effectToCompositeOp=function(a){return 0>=a||11<=a?"source-over":A[a-1]};cr.setGLBlend=function(a,b,c){if(c)switch(a.srcBlend=c.ONE,a.destBlend=c.ONE_MINUS_SRC_ALPHA,b){case 1:a.srcBlend=c.ONE;a.destBlend=c.ONE;break;case 3:a.srcBlend=c.ONE;a.destBlend=c.ZERO;break;case 4:a.srcBlend=
c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ONE;break;case 5:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ZERO;break;case 6:a.srcBlend=c.ZERO;a.destBlend=c.SRC_ALPHA;break;case 7:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ZERO;break;case 8:a.srcBlend=c.ZERO;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 9:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 10:a.srcBlend=c.ONE_MINUS_DST_ALPHA,a.destBlend=c.SRC_ALPHA}};cr.round6dp=function(a){return cr.round(1E6*a)/1E6};cr.equals_nocase=function(a,
b){return"string"!==typeof a||"string"!==typeof b||a.length!==b.length?!1:a===b?!0:a.toLowerCase()===b.toLowerCase()}})();var MatrixArray="undefined"!==typeof Float32Array?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};
vec3.add=function(a,b,c){if(!c||a===c)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};vec3.subtract=function(a,b,c){if(!c||a===c)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a===c)return a[0]*=b,a[1]*=b,a[2]*=b,a;c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=Math.sqrt(c*c+d*d+e*e);if(g){if(1===g)return b[0]=c,b[1]=d,b[2]=e,b}else return b[0]=0,b[1]=0,b[2]=0,b;g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1];a=a[2];var g=b[0],f=b[1];b=b[2];c[0]=e*b-a*f;c[1]=a*g-d*b;c[2]=d*f-e*g;return c};vec3.length=function(a){var b=a[0],c=a[1];a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1];a=a[2]-b[2];b=Math.sqrt(d*d+e*e+a*a);if(!b)return c[0]=0,c[1]=0,c[2]=0,c;b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[3],g=a[6],f=a[7],l=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=g;a[11]=a[14];a[12]=e;a[13]=f;a[14]=l;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],g=a[4],f=a[5],l=a[6],k=a[7],h=a[8],m=a[9],n=a[10],p=a[11],q=a[12],r=a[13],t=a[14];a=a[15];return q*m*l*e-h*r*l*e-q*f*n*e+g*r*n*e+h*f*t*e-g*m*t*e-q*m*d*k+h*r*d*k+q*c*n*k-b*r*n*k-h*c*t*k+b*m*t*k+q*f*d*p-g*r*d*p-q*c*l*p+b*r*l*p+g*c*t*p-b*f*t*p-h*f*d*a+g*m*d*a+h*c*l*a-b*m*l*a-g*c*n*a+b*f*n*a};
mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=a[4],l=a[5],k=a[6],h=a[7],m=a[8],n=a[9],p=a[10],q=a[11],r=a[12],t=a[13],s=a[14],u=a[15],A=c*l-d*f,E=c*k-e*f,I=c*h-g*f,z=d*k-e*l,v=d*h-g*l,F=e*h-g*k,x=m*t-n*r,y=m*s-p*r,B=m*u-q*r,w=n*s-p*t,G=n*u-q*t,C=p*u-q*s,D=1/(A*C-E*G+I*w+z*B-v*y+F*x);b[0]=(l*C-k*G+h*w)*D;b[1]=(-d*C+e*G-g*w)*D;b[2]=(t*F-s*v+u*z)*D;b[3]=(-n*F+p*v-q*z)*D;b[4]=(-f*C+k*B-h*y)*D;b[5]=(c*C-e*B+g*y)*D;b[6]=(-r*F+s*I-u*E)*D;b[7]=(m*F-p*I+q*E)*D;b[8]=(f*G-l*B+h*x)*D;
b[9]=(-c*G+d*B-g*x)*D;b[10]=(r*v-t*I+u*A)*D;b[11]=(-m*v+n*I-q*A)*D;b[12]=(-f*w+l*y-k*x)*D;b[13]=(c*w-d*y+e*x)*D;b[14]=(-r*z+t*E-s*A)*D;b[15]=(m*z-n*E+p*A)*D;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],g=a[4],f=a[5],l=a[6],k=a[8],h=a[9],m=a[10],n=m*f-l*h,p=-m*g+l*k,q=h*g-f*k,r=c*n+d*p+e*q;if(!r)return null;r=1/r;b||(b=mat3.create());b[0]=n*r;b[1]=(-m*d+e*h)*r;b[2]=(l*d-e*f)*r;b[3]=p*r;b[4]=(m*c-e*k)*r;b[5]=(-l*c+e*g)*r;b[6]=q*r;b[7]=(-h*c+d*k)*r;b[8]=(f*c-d*g)*r;return b};
mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],f=a[3],l=a[4],k=a[5],h=a[6],m=a[7],n=a[8],p=a[9],q=a[10],r=a[11],t=a[12],s=a[13],u=a[14];a=a[15];var A=b[0],E=b[1],I=b[2],z=b[3],v=b[4],F=b[5],x=b[6],y=b[7],B=b[8],w=b[9],G=b[10],C=b[11],D=b[12],J=b[13],T=b[14];b=b[15];c[0]=A*d+E*l+I*n+z*t;c[1]=A*e+E*k+I*p+z*s;c[2]=A*g+E*h+I*q+z*u;c[3]=A*f+E*m+I*r+z*a;c[4]=v*d+F*l+x*n+y*t;c[5]=v*e+F*k+x*p+y*s;c[6]=v*g+F*h+x*q+y*u;c[7]=v*f+F*m+x*r+y*a;c[8]=B*d+w*l+G*n+C*t;c[9]=B*e+w*k+G*p+C*s;c[10]=B*
g+w*h+G*q+C*u;c[11]=B*f+w*m+G*r+C*a;c[12]=D*d+J*l+T*n+b*t;c[13]=D*e+J*k+T*p+b*s;c[14]=D*g+J*h+T*q+b*u;c[15]=D*f+J*m+T*r+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1];b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2];b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*g+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*g+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*g+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*g+a[15]*b;return c};
mat4.translate=function(a,b,c){var d=b[0],e=b[1];b=b[2];var g,f,l,k,h,m,n,p,q,r,t,s;if(!c||a===c)return a[12]=a[0]*d+a[4]*e+a[8]*b+a[12],a[13]=a[1]*d+a[5]*e+a[9]*b+a[13],a[14]=a[2]*d+a[6]*e+a[10]*b+a[14],a[15]=a[3]*d+a[7]*e+a[11]*b+a[15],a;g=a[0];f=a[1];l=a[2];k=a[3];h=a[4];m=a[5];n=a[6];p=a[7];q=a[8];r=a[9];t=a[10];s=a[11];c[0]=g;c[1]=f;c[2]=l;c[3]=k;c[4]=h;c[5]=m;c[6]=n;c[7]=p;c[8]=q;c[9]=r;c[10]=t;c[11]=s;c[12]=g*d+h*e+q*b+a[12];c[13]=f*d+m*e+r*b+a[13];c[14]=l*d+n*e+t*b+a[14];c[15]=k*d+p*e+s*b+
a[15];return c};mat4.scale=function(a,b,c){var d=b[0],e=b[1];b=b[2];if(!c||a===c)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=e,a[5]*=e,a[6]*=e,a[7]*=e,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
mat4.rotate=function(a,b,c,d){var e=c[0],g=c[1];c=c[2];var f=Math.sqrt(e*e+g*g+c*c),l,k,h,m,n,p,q,r,t,s,u,A,E,I,z,v,F,x,y,B;if(!f)return null;1!==f&&(f=1/f,e*=f,g*=f,c*=f);l=Math.sin(b);k=Math.cos(b);h=1-k;b=a[0];f=a[1];m=a[2];n=a[3];p=a[4];q=a[5];r=a[6];t=a[7];s=a[8];u=a[9];A=a[10];E=a[11];I=e*e*h+k;z=g*e*h+c*l;v=c*e*h-g*l;F=e*g*h-c*l;x=g*g*h+k;y=c*g*h+e*l;B=e*c*h+g*l;e=g*c*h-e*l;g=c*c*h+k;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=b*I+p*z+s*v;d[1]=f*I+q*z+u*v;d[2]=m*I+r*
z+A*v;d[3]=n*I+t*z+E*v;d[4]=b*F+p*x+s*y;d[5]=f*F+q*x+u*y;d[6]=m*F+r*x+A*y;d[7]=n*F+t*x+E*y;d[8]=b*B+p*e+s*g;d[9]=f*B+q*e+u*g;d[10]=m*B+r*e+A*g;d[11]=n*B+t*e+E*g;return d};
mat4.rotateX=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[4],g=a[5],f=a[6],l=a[7],k=a[8],h=a[9],m=a[10],n=a[11];c?a!==c&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[4]=e*b+k*d;c[5]=g*b+h*d;c[6]=f*b+m*d;c[7]=l*b+n*d;c[8]=e*-d+k*b;c[9]=g*-d+h*b;c[10]=f*-d+m*b;c[11]=l*-d+n*b;return c};
mat4.rotateY=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[0],g=a[1],f=a[2],l=a[3],k=a[8],h=a[9],m=a[10],n=a[11];c?a!==c&&(c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+k*-d;c[1]=g*b+h*-d;c[2]=f*b+m*-d;c[3]=l*b+n*-d;c[8]=e*d+k*b;c[9]=g*d+h*b;c[10]=f*d+m*b;c[11]=l*d+n*b;return c};
mat4.rotateZ=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[0],g=a[1],f=a[2],l=a[3],k=a[4],h=a[5],m=a[6],n=a[7];c?a!==c&&(c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+k*d;c[1]=g*b+h*d;c[2]=f*b+m*d;c[3]=l*b+n*d;c[4]=e*-d+k*b;c[5]=g*-d+h*b;c[6]=f*-d+m*b;c[7]=l*-d+n*b;return c};
mat4.frustum=function(a,b,c,d,e,g,f){f||(f=mat4.create());var l=b-a,k=d-c,h=g-e;f[0]=2*e/l;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2*e/k;f[6]=0;f[7]=0;f[8]=(b+a)/l;f[9]=(d+c)/k;f[10]=-(g+e)/h;f[11]=-1;f[12]=0;f[13]=0;f[14]=-(2*g*e)/h;f[15]=0;return f};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,c,d,e)};
mat4.ortho=function(a,b,c,d,e,g,f){f||(f=mat4.create());var l=b-a,k=d-c,h=g-e;f[0]=2/l;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2/k;f[6]=0;f[7]=0;f[8]=0;f[9]=0;f[10]=-2/h;f[11]=0;f[12]=-(a+b)/l;f[13]=-(d+c)/k;f[14]=-(g+e)/h;f[15]=1;return f};
mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e,g,f,l,k,h,m,n,p=a[0],q=a[1];a=a[2];g=c[0];f=c[1];e=c[2];c=b[1];h=b[2];if(p===b[0]&&q===c&&a===h)return mat4.identity(d);c=p-b[0];h=q-b[1];m=a-b[2];n=1/Math.sqrt(c*c+h*h+m*m);c*=n;h*=n;m*=n;b=f*m-e*h;e=e*c-g*m;g=g*h-f*c;(n=Math.sqrt(b*b+e*e+g*g))?(n=1/n,b*=n,e*=n,g*=n):g=e=b=0;f=h*g-m*e;l=m*b-c*g;k=c*e-h*b;(n=Math.sqrt(f*f+l*l+k*k))?(n=1/n,f*=n,l*=n,k*=n):k=l=f=0;d[0]=b;d[1]=f;d[2]=c;d[3]=0;d[4]=e;d[5]=l;d[6]=h;d[7]=0;d[8]=g;d[9]=k;d[10]=m;d[11]=
0;d[12]=-(b*p+e*q+g*a);d[13]=-(f*p+l*q+k*a);d[14]=-(c*p+h*q+m*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,b,c){c||(c=mat4.create());var d=a[0],e=a[1],g=a[2],f=a[3],l=d+d,k=e+e,h=g+g;a=d*l;var m=d*k,d=d*h,n=e*k,e=e*h,g=g*h,l=l*f,k=k*f,f=f*h;c[0]=1-(n+g);c[1]=m+f;c[2]=d-k;c[3]=0;c[4]=m-f;c[5]=1-(a+g);c[6]=e+l;c[7]=0;c[8]=d+k;c[9]=e-l;c[10]=1-(a+n);c[11]=0;c[12]=b[0];c[13]=b[1];c[14]=b[2];c[15]=1;return c};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e)),a;b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2];a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=Math.sqrt(c*c+d*d+e*e+g*g);if(0===f)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;b[3]=g*f;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2];a=a[3];var f=b[0],l=b[1],k=b[2];b=b[3];c[0]=d*b+a*f+e*k-g*l;c[1]=e*b+a*l+g*f-d*k;c[2]=g*b+a*k+d*l-e*f;c[3]=a*b-d*f-e*l-g*k;return c};
quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2];b=a[0];var f=a[1],l=a[2];a=a[3];var k=a*d+f*g-l*e,h=a*e+l*d-b*g,m=a*g+b*e-f*d,d=-b*d-f*e-l*g;c[0]=k*a+d*-b+h*-l-m*-f;c[1]=h*a+d*-f+m*-b-k*-l;c[2]=m*a+d*-l+k*-f-h*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,l=d+d,k=e+e,h=c*f,m=c*l,c=c*k,n=d*l,d=d*k,e=e*k,f=f*g,l=l*g,g=g*k;b[0]=1-(n+e);b[1]=m+g;b[2]=c-l;b[3]=m-g;b[4]=1-(h+e);b[5]=d+f;b[6]=c+l;b[7]=d-f;b[8]=1-(h+n);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,l=d+d,k=e+e,h=c*f,m=c*l,c=c*k,n=d*l,d=d*k,e=e*k,f=f*g,l=l*g,g=g*k;b[0]=1-(n+e);b[1]=m+g;b[2]=c-l;b[3]=0;b[4]=m-g;b[5]=1-(h+e);b[6]=d+f;b[7]=0;b[8]=c+l;b[9]=d-f;b[10]=1-(h+n);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,c,d){d||(d=a);var e=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],g,f;if(1<=Math.abs(e))return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;g=Math.acos(e);f=Math.sqrt(1-e*e);if(0.0010>Math.abs(f))return d[0]=0.5*a[0]+0.5*b[0],d[1]=0.5*a[1]+0.5*b[1],d[2]=0.5*a[2]+0.5*b[2],d[3]=0.5*a[3]+0.5*b[3],d;e=Math.sin((1-c)*g)/f;c=Math.sin(c*g)/f;d[0]=a[0]*e+b[0]*c;d[1]=a[1]*e+b[1]*c;d[2]=a[2]*e+b[2]*c;d[3]=a[3]*e+b[3]*c;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function(){function a(a,b){this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.height=this.width=0;this.cam=vec3.create([0,0,100]);this.look=vec3.create([0,0,0]);this.up=vec3.create([0,1,0]);this.worldScale=vec3.create([1,1,1]);this.matP=mat4.create();this.matMV=mat4.create();this.lastMV=mat4.create();this.currentMV=mat4.create();this.gl=a;this.initState()}function b(a,b,c){this.gl=a;this.shaderProgram=b;this.name=c;this.locAPos=a.getAttribLocation(b,"aPos");this.locATex=
a.getAttribLocation(b,"aTex");this.locMatP=a.getUniformLocation(b,"matP");this.locMatMV=a.getUniformLocation(b,"matMV");this.locOpacity=a.getUniformLocation(b,"opacity");this.locSamplerFront=a.getUniformLocation(b,"samplerFront");this.locSamplerBack=a.getUniformLocation(b,"samplerBack");this.locDestStart=a.getUniformLocation(b,"destStart");this.locDestEnd=a.getUniformLocation(b,"destEnd");this.locSeconds=a.getUniformLocation(b,"seconds");this.locPixelWidth=a.getUniformLocation(b,"pixelWidth");this.locPixelHeight=
a.getUniformLocation(b,"pixelHeight");this.locLayerScale=a.getUniformLocation(b,"layerScale");this.locLayerAngle=a.getUniformLocation(b,"layerAngle");this.locViewOrigin=a.getUniformLocation(b,"viewOrigin");this.hasAnyOptionalUniforms=!!(this.locPixelWidth||this.locPixelHeight||this.locSeconds||this.locSamplerBack||this.locDestStart||this.locDestEnd||this.locLayerScale||this.locLayerAngle||this.locViewOrigin);this.locOpacity&&a.uniform1f(this.locOpacity,1);this.locSamplerFront&&a.uniform1i(this.locSamplerFront,
0);this.locSamplerBack&&a.uniform1i(this.locSamplerBack,1);this.locDestStart&&a.uniform2f(this.locDestStart,0,0);this.locDestEnd&&a.uniform2f(this.locDestEnd,1,1);this.locLayerScale&&a.uniform1f(this.locLayerScale,1);this.locLayerAngle&&a.uniform1f(this.locLayerAngle,0);this.locViewOrigin&&a.uniform2f(this.locViewOrigin,0,0);this.hasCurrentMatMV=!1}function c(a,b){this.type=a;this.glwrap=b;this.gl=b.gl;this.indexCount=this.startIndex=this.opacityParam=0;this.mat4param=this.texParam=null;this.shaderParams=
[];cr.seal(this)}a.prototype.initState=function(){var a=this.gl,b;this.lastOpacity=1;this.lastTexture1=this.lastTexture0=null;this.currentOpacity=1;a.clearColor(0,0,0,0);a.clear(a.COLOR_BUFFER_BIT);a.enable(a.BLEND);a.blendFunc(a.ONE,a.ONE_MINUS_SRC_ALPHA);a.disable(a.CULL_FACE);a.disable(a.DEPTH_TEST);this.maxTextureSize=a.getParameter(a.MAX_TEXTURE_SIZE);this.lastSrcBlend=a.ONE;this.lastDestBlend=a.ONE_MINUS_SRC_ALPHA;this.pointBuffer=a.createBuffer();a.bindBuffer(a.ARRAY_BUFFER,this.pointBuffer);
this.vertexBuffers=Array(4);this.texcoordBuffers=Array(4);for(b=0;4>b;b++)this.vertexBuffers[b]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[b]),this.texcoordBuffers[b]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[b]);this.curBuffer=0;this.indexBuffer=a.createBuffer();a.bindBuffer(a.ELEMENT_ARRAY_BUFFER,this.indexBuffer);this.vertexData=new Float32Array(16E3);this.texcoordData=new Float32Array(16E3);this.pointData=new Float32Array(32E3);for(var c=new Uint16Array(12E3),
d=b=0;12E3>b;)c[b++]=d,c[b++]=d+1,c[b++]=d+2,c[b++]=d,c[b++]=d+2,c[b++]=d+3,d+=4;a.bufferData(a.ELEMENT_ARRAY_BUFFER,c,a.STATIC_DRAW);this.pointPtr=this.vertexPtr=0;this.shaderPrograms=[];b=this.createShaderProgram({src:"varying mediump vec2 vTex;\nuniform lowp float opacity;\nuniform lowp sampler2D samplerFront;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, vTex);\n\tgl_FragColor *= opacity;\n}"},"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",
"<default>");this.shaderPrograms.push(b);b=this.createShaderProgram({src:"uniform mediump sampler2D samplerFront;\nvarying lowp float opacity;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, gl_PointCoord);\n\tgl_FragColor *= opacity;\n}"},"attribute vec4 aPos;\nvarying float opacity;\nuniform mat4 matP;\nuniform mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tgl_PointSize = aPos.z;\n\topacity = aPos.w;\n}","<point>");this.shaderPrograms.push(b);
for(var e in cr.shaders)cr.shaders.hasOwnProperty(e)&&this.shaderPrograms.push(this.createShaderProgram(cr.shaders[e],"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",e));a.activeTexture(a.TEXTURE0);a.bindTexture(a.TEXTURE_2D,null);this.batch=[];this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;
this.currentProgram=this.lastProgram=-1;this.currentShader=null;this.fbo=a.createFramebuffer();this.renderToTex=null;this.tmpVec3=vec3.create([0,0,0]);a=a.getParameter(a.ALIASED_POINT_SIZE_RANGE);this.minPointSize=a[0];this.maxPointSize=a[1];this.switchProgram(0);cr.seal(this)};a.prototype.createShaderProgram=function(a,c,d){var e=this.gl,h=e.createShader(e.FRAGMENT_SHADER);e.shaderSource(h,a.src);e.compileShader(h);if(!e.getShaderParameter(h,e.COMPILE_STATUS))return e.deleteShader(h),null;var m=
e.createShader(e.VERTEX_SHADER);e.shaderSource(m,c);e.compileShader(m);if(!e.getShaderParameter(m,e.COMPILE_STATUS))return e.deleteShader(h),e.deleteShader(m),null;c=e.createProgram();e.attachShader(c,h);e.attachShader(c,m);e.linkProgram(c);if(!e.getProgramParameter(c,e.LINK_STATUS))return e.deleteShader(h),e.deleteShader(m),e.deleteProgram(c),null;e.useProgram(c);e.deleteShader(h);e.deleteShader(m);d=new b(e,c,d);d.extendBoxHorizontal=a.extendBoxHorizontal||0;d.extendBoxVertical=a.extendBoxVertical||
0;d.crossSampling=!!a.crossSampling;d.animated=!!a.animated;d.parameters=a.parameters||[];a=0;for(h=d.parameters.length;a<h;a++)d.parameters[a][1]=e.getUniformLocation(c,d.parameters[a][0]),e.uniform1f(d.parameters[a][1],0);cr.seal(d);return d};a.prototype.getShaderIndex=function(a){var b,c;b=0;for(c=this.shaderPrograms.length;b<c;b++)if(this.shaderPrograms[b].name===a)return b;return-1};a.prototype.project=function(a,b,c){var d=this.matMV,e=this.matP,m=[0,0,0,0,0,0,0,0];m[0]=d[0]*a+d[4]*b+d[12];
m[1]=d[1]*a+d[5]*b+d[13];m[2]=d[2]*a+d[6]*b+d[14];m[3]=d[3]*a+d[7]*b+d[15];m[4]=e[0]*m[0]+e[4]*m[1]+e[8]*m[2]+e[12]*m[3];m[5]=e[1]*m[0]+e[5]*m[1]+e[9]*m[2]+e[13]*m[3];m[6]=e[2]*m[0]+e[6]*m[1]+e[10]*m[2]+e[14]*m[3];m[7]=-m[2];0!==m[7]&&(m[7]=1/m[7],m[4]*=m[7],m[5]*=m[7],m[6]*=m[7],c[0]=(0.5*m[4]+0.5)*this.width,c[1]=(0.5*m[5]+0.5)*this.height)};a.prototype.setSize=function(a,b,c){if(this.width!==a||this.height!==b||c){this.endBatch();this.width=a;this.height=b;this.gl.viewport(0,0,a,b);mat4.perspective(45,
a/b,1,1E3,this.matP);mat4.lookAt(this.cam,this.look,this.up,this.matMV);a=[0,0];b=[0,0];this.project(0,0,a);this.project(1,1,b);this.worldScale[0]=1/(b[0]-a[0]);this.worldScale[1]=-1/(b[1]-a[1]);a=0;for(b=this.shaderPrograms.length;a<b;a++)c=this.shaderPrograms[a],c.hasCurrentMatMV=!1,c.locMatP&&(this.gl.useProgram(c.shaderProgram),this.gl.uniformMatrix4fv(c.locMatP,!1,this.matP));this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);this.gl.bindTexture(this.gl.TEXTURE_2D,null);
this.gl.activeTexture(this.gl.TEXTURE1);this.gl.bindTexture(this.gl.TEXTURE_2D,null);this.gl.activeTexture(this.gl.TEXTURE0);this.lastTexture1=this.lastTexture0=null}};a.prototype.resetModelView=function(){mat4.lookAt(this.cam,this.look,this.up,this.matMV);mat4.scale(this.matMV,this.worldScale)};a.prototype.translate=function(a,b){if(0!==a||0!==b)this.tmpVec3[0]=a,this.tmpVec3[1]=b,this.tmpVec3[2]=0,mat4.translate(this.matMV,this.tmpVec3)};a.prototype.scale=function(a,b){if(1!==a||1!==b)this.tmpVec3[0]=
a,this.tmpVec3[1]=b,this.tmpVec3[2]=1,mat4.scale(this.matMV,this.tmpVec3)};a.prototype.rotateZ=function(a){0!==a&&mat4.rotateZ(this.matMV,a)};a.prototype.updateModelView=function(){for(var a=!1,b=0;16>b;b++)if(this.lastMV[b]!==this.matMV[b]){a=!0;break}a&&(a=this.pushBatch(),a.type=5,a.mat4param?mat4.set(this.matMV,a.mat4param):a.mat4param=mat4.create(this.matMV),mat4.set(this.matMV,this.lastMV),this.hasPointBatchTop=this.hasQuadBatchTop=!1)};c.prototype.doSetTexture=function(){this.gl.bindTexture(this.gl.TEXTURE_2D,
this.texParam)};c.prototype.doSetTexture1=function(){var a=this.gl;a.activeTexture(a.TEXTURE1);a.bindTexture(a.TEXTURE_2D,this.texParam);a.activeTexture(a.TEXTURE0)};c.prototype.doSetOpacity=function(){var a=this.opacityParam,b=this.glwrap;b.currentOpacity=a;b=b.currentShader;b.locOpacity&&this.gl.uniform1f(b.locOpacity,a)};c.prototype.doQuad=function(){this.gl.drawElements(this.gl.TRIANGLES,this.indexCount,this.gl.UNSIGNED_SHORT,2*this.startIndex)};c.prototype.doSetBlend=function(){this.gl.blendFunc(this.startIndex,
this.indexCount)};c.prototype.doUpdateModelView=function(){var a,b,c,d=this.glwrap.shaderPrograms,e=this.glwrap.currentProgram;a=0;for(b=d.length;a<b;a++)c=d[a],a===e&&c.locMatMV?(this.gl.uniformMatrix4fv(c.locMatMV,!1,this.mat4param),c.hasCurrentMatMV=!0):c.hasCurrentMatMV=!1;mat4.set(this.mat4param,this.glwrap.currentMV)};c.prototype.doRenderToTexture=function(){var a=this.gl,b=this.glwrap;this.texParam?(b.lastTexture1===this.texParam&&(a.activeTexture(a.TEXTURE1),a.bindTexture(a.TEXTURE_2D,null),
b.lastTexture1=null,a.activeTexture(a.TEXTURE0)),a.bindFramebuffer(a.FRAMEBUFFER,b.fbo),a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,this.texParam,0)):(a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,null,0),a.bindFramebuffer(a.FRAMEBUFFER,null))};c.prototype.doClear=function(){var a=this.gl;0===this.startIndex?(a.clearColor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clear(a.COLOR_BUFFER_BIT)):(a.enable(a.SCISSOR_TEST),
a.scissor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clearColor(0,0,0,0),a.clear(this.gl.COLOR_BUFFER_BIT),a.disable(a.SCISSOR_TEST))};c.prototype.doPoints=function(){var a=this.gl,b=this.glwrap,c=b.shaderPrograms[1];a.useProgram(c.shaderProgram);!c.hasCurrentMatMV&&c.locMatMV&&(a.uniformMatrix4fv(c.locMatMV,!1,b.currentMV),c.hasCurrentMatMV=!0);a.enableVertexAttribArray(c.locAPos);a.bindBuffer(a.ARRAY_BUFFER,b.pointBuffer);a.vertexAttribPointer(c.locAPos,4,a.FLOAT,
!1,0,0);a.drawArrays(a.POINTS,this.startIndex/4,this.indexCount);c=b.currentShader;a.useProgram(c.shaderProgram);0<=c.locAPos&&(a.enableVertexAttribArray(c.locAPos),a.bindBuffer(a.ARRAY_BUFFER,b.vertexBuffers[b.curBuffer]),a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0));0<=c.locATex&&(a.enableVertexAttribArray(c.locATex),a.bindBuffer(a.ARRAY_BUFFER,b.texcoordBuffers[b.curBuffer]),a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0))};c.prototype.doSetProgram=function(){var a=this.gl,b=this.glwrap,
c=b.shaderPrograms[this.startIndex];b.currentProgram=this.startIndex;b.currentShader=c;a.useProgram(c.shaderProgram);!c.hasCurrentMatMV&&c.locMatMV&&(a.uniformMatrix4fv(c.locMatMV,!1,b.currentMV),c.hasCurrentMatMV=!0);c.locOpacity&&a.uniform1f(c.locOpacity,b.currentOpacity);0<=c.locAPos&&(a.enableVertexAttribArray(c.locAPos),a.bindBuffer(a.ARRAY_BUFFER,b.vertexBuffers[b.curBuffer]),a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0));0<=c.locATex&&(a.enableVertexAttribArray(c.locATex),a.bindBuffer(a.ARRAY_BUFFER,
b.texcoordBuffers[b.curBuffer]),a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0))};c.prototype.doSetProgramParameters=function(){var a,b,c=this.glwrap.currentShader,d=this.gl;a=this.mat4param;c.locSamplerBack&&this.glwrap.lastTexture1!==this.texParam&&(d.activeTexture(d.TEXTURE1),d.bindTexture(d.TEXTURE_2D,this.texParam),this.glwrap.lastTexture1=this.texParam,d.activeTexture(d.TEXTURE0));c.locPixelWidth&&d.uniform1f(c.locPixelWidth,a[0]);c.locPixelHeight&&d.uniform1f(c.locPixelHeight,a[1]);c.locDestStart&&
d.uniform2f(c.locDestStart,a[2],a[3]);c.locDestEnd&&d.uniform2f(c.locDestEnd,a[4],a[5]);c.locLayerScale&&d.uniform1f(c.locLayerScale,a[6]);c.locLayerAngle&&d.uniform1f(c.locLayerAngle,a[7]);c.locViewOrigin&&d.uniform2f(c.locViewOrigin,a[8],a[9]);c.locSeconds&&d.uniform1f(c.locSeconds,cr.performance_now()/1E3);if(c.parameters.length)for(a=0,b=c.parameters.length;a<b;a++)d.uniform1f(c.parameters[a][1],this.shaderParams[a])};a.prototype.pushBatch=function(){this.batchPtr===this.batch.length&&this.batch.push(new c(0,
this));return this.batch[this.batchPtr++]};a.prototype.endBatch=function(){if(0!==this.batchPtr&&!this.gl.isContextLost()){var a=this.gl;0<this.pointPtr&&(a.bindBuffer(a.ARRAY_BUFFER,this.pointBuffer),a.bufferData(a.ARRAY_BUFFER,this.pointData.subarray(0,this.pointPtr),a.STREAM_DRAW),b&&0<=b.locAPos&&"<point>"===b.name&&a.vertexAttribPointer(b.locAPos,4,a.FLOAT,!1,0,0));if(0<this.vertexPtr){var b=this.currentShader;a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,
this.vertexData.subarray(0,this.vertexPtr),a.STREAM_DRAW);b&&0<=b.locAPos&&"<point>"!==b.name&&a.vertexAttribPointer(b.locAPos,2,a.FLOAT,!1,0,0);a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,this.texcoordData.subarray(0,this.vertexPtr),a.STREAM_DRAW);b&&0<=b.locATex&&"<point>"!==b.name&&a.vertexAttribPointer(b.locATex,2,a.FLOAT,!1,0,0)}for(var c,a=0,b=this.batchPtr;a<b;a++)switch(c=this.batch[a],c.type){case 1:c.doQuad();break;case 2:c.doSetTexture();
break;case 3:c.doSetOpacity();break;case 4:c.doSetBlend();break;case 5:c.doUpdateModelView();break;case 6:c.doRenderToTexture();break;case 7:c.doClear();break;case 8:c.doPoints();break;case 9:c.doSetProgram();break;case 10:c.doSetProgramParameters();break;case 11:c.doSetTexture1()}this.pointPtr=this.vertexPtr=this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;this.curBuffer++;4<=this.curBuffer&&(this.curBuffer=0)}};a.prototype.setOpacity=function(a){if(a!==this.lastOpacity){var b=this.pushBatch();
b.type=3;this.lastOpacity=b.opacityParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setTexture=function(a){if(a!==this.lastTexture0){var b=this.pushBatch();b.type=2;this.lastTexture0=b.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setBlend=function(a,b){if(a!==this.lastSrcBlend||b!==this.lastDestBlend){var c=this.pushBatch();c.type=4;c.startIndex=a;c.indexCount=b;this.lastSrcBlend=a;this.lastDestBlend=b;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.isPremultipliedAlphaBlend=
function(){return this.lastSrcBlend===this.gl.ONE&&this.lastDestBlend===this.gl.ONE_MINUS_SRC_ALPHA};a.prototype.setAlphaBlend=function(){this.setBlend(this.gl.ONE,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.setNoPremultiplyAlphaBlend=function(){this.setBlend(this.gl.SRC_ALPHA,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.quad=function(a,b,c,d,e,m,n,p){15992<=this.vertexPtr&&this.endBatch();var q=this.vertexPtr,r=this.vertexData,t=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=
6;else{var s=this.pushBatch();s.type=1;s.startIndex=3*(q/4);s.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}r[q]=a;t[q++]=0;r[q]=b;t[q++]=0;r[q]=c;t[q++]=1;r[q]=d;t[q++]=0;r[q]=e;t[q++]=1;r[q]=m;t[q++]=1;r[q]=n;t[q++]=0;r[q]=p;t[q++]=1;this.vertexPtr=q};a.prototype.quadTex=function(a,b,c,d,e,m,n,p,q){15992<=this.vertexPtr&&this.endBatch();var r=this.vertexPtr,t=this.vertexData,s=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=6;else{var u=this.pushBatch();
u.type=1;u.startIndex=3*(r/4);u.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}var u=q.left,A=q.top,E=q.right;q=q.bottom;t[r]=a;s[r++]=u;t[r]=b;s[r++]=A;t[r]=c;s[r++]=E;t[r]=d;s[r++]=A;t[r]=e;s[r++]=E;t[r]=m;s[r++]=q;t[r]=n;s[r++]=u;t[r]=p;s[r++]=q;this.vertexPtr=r};a.prototype.quadTexUV=function(a,b,c,d,e,m,n,p,q,r,t,s,u,A,E,I){15992<=this.vertexPtr&&this.endBatch();var z=this.vertexPtr,v=this.vertexData,F=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=
6;else{var x=this.pushBatch();x.type=1;x.startIndex=3*(z/4);x.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}v[z]=a;F[z++]=q;v[z]=b;F[z++]=r;v[z]=c;F[z++]=t;v[z]=d;F[z++]=s;v[z]=e;F[z++]=u;v[z]=m;F[z++]=A;v[z]=n;F[z++]=E;v[z]=p;F[z++]=I;this.vertexPtr=z};a.prototype.point=function(a,b,c,d){7996<=this.pointPtr&&this.endBatch();var e=this.pointPtr,m=this.pointData;if(this.hasPointBatchTop)this.batch[this.batchPtr-1].indexCount++;else{var n=this.pushBatch();n.type=8;n.startIndex=e;n.indexCount=
1;this.hasPointBatchTop=!0;this.hasQuadBatchTop=!1}m[e++]=a;m[e++]=b;m[e++]=c;m[e++]=d;this.pointPtr=e};a.prototype.switchProgram=function(a){if(this.lastProgram!==a){if(!this.shaderPrograms[a]){if(0===this.lastProgram)return;a=0}var b=this.pushBatch();b.type=9;this.lastProgram=b.startIndex=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.programUsesDest=function(a){a=this.shaderPrograms[a];return!(!a.locDestStart&&!a.locDestEnd)};a.prototype.programUsesCrossSampling=function(a){a=this.shaderPrograms[a];
return!!(a.locDestStart||a.locDestEnd||a.crossSampling)};a.prototype.programExtendsBox=function(a){a=this.shaderPrograms[a];return 0!==a.extendBoxHorizontal||0!==a.extendBoxVertical};a.prototype.getProgramBoxExtendHorizontal=function(a){return this.shaderPrograms[a].extendBoxHorizontal};a.prototype.getProgramBoxExtendVertical=function(a){return this.shaderPrograms[a].extendBoxVertical};a.prototype.getProgramParameterType=function(a,b){return this.shaderPrograms[a].parameters[b][2]};a.prototype.programIsAnimated=
function(a){return this.shaderPrograms[a].animated};a.prototype.setProgramParameters=function(a,b,c,d,e,m,n,p,q,r,t,s){var u=this.shaderPrograms[this.lastProgram],A,E;if(u.hasAnyOptionalUniforms||s.length){A=this.pushBatch();A.type=10;A.mat4param?mat4.set(this.matMV,A.mat4param):A.mat4param=mat4.create();E=A.mat4param;E[0]=b;E[1]=c;E[2]=d;E[3]=e;E[4]=m;E[5]=n;E[6]=p;E[7]=q;E[8]=r;E[9]=t;A.texParam=u.locSamplerBack?a:null;if(s.length)for(c=A.shaderParams,c.length=s.length,a=0,b=s.length;a<b;a++)c[a]=
s[a];this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.clear=function(a,b,c,d){var e=this.pushBatch();e.type=7;e.startIndex=0;e.mat4param||(e.mat4param=mat4.create());e.mat4param[0]=a;e.mat4param[1]=b;e.mat4param[2]=c;e.mat4param[3]=d;this.hasPointBatchTop=this.hasQuadBatchTop=!1};a.prototype.clearRect=function(a,b,c,d){var e=this.pushBatch();e.type=7;e.startIndex=1;e.mat4param||(e.mat4param=mat4.create());e.mat4param[0]=a;e.mat4param[1]=b;e.mat4param[2]=c;e.mat4param[3]=d;this.hasPointBatchTop=
this.hasQuadBatchTop=!1};a.prototype.present=function(){this.endBatch();this.gl.flush()};var d=[],e={};a.prototype.loadTexture=function(a,b,c,k,h){b=!!b;c=!!c;var m=a.src+","+b+","+c+(b?","+h:""),n=null;if("undefined"!==typeof a.src&&e.hasOwnProperty(m))return n=e[m],n.c2refcount++,n;this.endBatch();var p=this.gl,q=cr.isPOT(a.width)&&cr.isPOT(a.height),n=p.createTexture();p.bindTexture(p.TEXTURE_2D,n);p.pixelStorei(p.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);var r=p.RGBA,t=p.RGBA,s=p.UNSIGNED_BYTE;if(k&&
!this.isIE)switch(k){case 1:t=r=p.RGB;break;case 2:s=p.UNSIGNED_SHORT_4_4_4_4;break;case 3:s=p.UNSIGNED_SHORT_5_5_5_1;break;case 4:t=r=p.RGB,s=p.UNSIGNED_SHORT_5_6_5}!q&&b?(k=document.createElement("canvas"),k.width=cr.nextHighestPowerOfTwo(a.width),k.height=cr.nextHighestPowerOfTwo(a.height),k.getContext("2d").drawImage(a,0,0,a.width,a.height,0,0,k.width,k.height),p.texImage2D(p.TEXTURE_2D,0,r,t,s,k)):p.texImage2D(p.TEXTURE_2D,0,r,t,s,a);b?"repeat-x"===h?(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,
p.REPEAT),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_T,p.CLAMP_TO_EDGE)):("repeat-y"===h?p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.CLAMP_TO_EDGE):p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.REPEAT),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_T,p.REPEAT)):(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.CLAMP_TO_EDGE),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_T,p.CLAMP_TO_EDGE));c?(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MAG_FILTER,p.LINEAR),q?(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MIN_FILTER,
p.LINEAR_MIPMAP_LINEAR),p.generateMipmap(p.TEXTURE_2D)):p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MIN_FILTER,p.LINEAR)):(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MAG_FILTER,p.NEAREST),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MIN_FILTER,p.NEAREST));p.bindTexture(p.TEXTURE_2D,null);this.lastTexture0=null;n.c2width=a.width;n.c2height=a.height;n.c2refcount=1;n.c2texkey=m;d.push(n);return e[m]=n};a.prototype.createEmptyTexture=function(a,b,c,e,h){this.endBatch();var m=this.gl;this.isIE&&(e=!1);var n=m.createTexture();
m.bindTexture(m.TEXTURE_2D,n);m.texImage2D(m.TEXTURE_2D,0,m.RGBA,a,b,0,m.RGBA,e?m.UNSIGNED_SHORT_4_4_4_4:m.UNSIGNED_BYTE,null);h?(m.texParameteri(m.TEXTURE_2D,m.TEXTURE_WRAP_S,m.REPEAT),m.texParameteri(m.TEXTURE_2D,m.TEXTURE_WRAP_T,m.REPEAT)):(m.texParameteri(m.TEXTURE_2D,m.TEXTURE_WRAP_S,m.CLAMP_TO_EDGE),m.texParameteri(m.TEXTURE_2D,m.TEXTURE_WRAP_T,m.CLAMP_TO_EDGE));m.texParameteri(m.TEXTURE_2D,m.TEXTURE_MAG_FILTER,c?m.LINEAR:m.NEAREST);m.texParameteri(m.TEXTURE_2D,m.TEXTURE_MIN_FILTER,c?m.LINEAR:
m.NEAREST);m.bindTexture(m.TEXTURE_2D,null);this.lastTexture0=null;n.c2width=a;n.c2height=b;d.push(n);return n};a.prototype.videoToTexture=function(a,b,c){this.endBatch();var d=this.gl;this.isIE&&(c=!1);d.bindTexture(d.TEXTURE_2D,b);d.pixelStorei(d.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);d.texImage2D(d.TEXTURE_2D,0,d.RGBA,d.RGBA,c?d.UNSIGNED_SHORT_4_4_4_4:d.UNSIGNED_BYTE,a);d.bindTexture(d.TEXTURE_2D,null);this.lastTexture0=null};a.prototype.deleteTexture=function(a){a&&("undefined"!==typeof a.c2refcount&&
1<a.c2refcount?a.c2refcount--:(this.endBatch(),a===this.lastTexture0&&(this.gl.bindTexture(this.gl.TEXTURE_2D,null),this.lastTexture0=null),a===this.lastTexture1&&(this.gl.activeTexture(this.gl.TEXTURE1),this.gl.bindTexture(this.gl.TEXTURE_2D,null),this.gl.activeTexture(this.gl.TEXTURE0),this.lastTexture1=null),cr.arrayFindRemove(d,a),"undefined"!==typeof a.c2texkey&&delete e[a.c2texkey],this.gl.deleteTexture(a)))};a.prototype.estimateVRAM=function(){var a=8*this.width*this.height,b,c,e;b=0;for(c=
d.length;b<c;b++)e=d[b],a+=4*e.c2width*e.c2height;return a};a.prototype.textureCount=function(){return d.length};a.prototype.setRenderingToTexture=function(a){if(a!==this.renderToTex){var b=this.pushBatch();b.type=6;this.renderToTex=b.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};cr.GLWrap=a})();
(function(){function a(a){if(a&&(a.getContext||a.dc)&&!a.c2runtime){a.c2runtime=this;var b=this;this.isCrosswalk=/crosswalk/i.test(navigator.userAgent)||/xwalk/i.test(navigator.userAgent)||!("undefined"===typeof window.c2isCrosswalk||!window.c2isCrosswalk);this.isPhoneGap=!this.isCrosswalk&&"undefined"!==typeof window.device&&("undefined"!==typeof window.device.cordova||"undefined"!==typeof window.device.phonegap);this.isDirectCanvas=!!a.dc;this.isAppMobi="undefined"!==typeof window.AppMobi||this.isDirectCanvas;
if(this.isCocoonJs=!!window.c2cocoonjs)CocoonJS.App.onSuspended.addEventListener(function(){b.setSuspended(!0)}),CocoonJS.App.onActivated.addEventListener(function(){b.setSuspended(!1)});this.isDomFree=this.isDirectCanvas||this.isCocoonJs;this.isTizen=/tizen/i.test(navigator.userAgent);this.isAndroid=/android/i.test(navigator.userAgent)&&!this.isTizen;this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.isiPhone=/iphone/i.test(navigator.userAgent)||/ipod/i.test(navigator.userAgent);
this.isiPad=/ipad/i.test(navigator.userAgent);this.isiOS=this.isiPhone||this.isiPad;this.isiPhoneiOS6=this.isiPhone&&/os\s6/i.test(navigator.userAgent);this.isChrome=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent);this.isAmazonWebApp=/amazonwebappplatform/i.test(navigator.userAgent);this.isFirefox=/firefox/i.test(navigator.userAgent);this.isSafari=!this.isChrome&&/safari/i.test(navigator.userAgent);this.isWindows=/windows/i.test(navigator.userAgent);this.isNodeWebkit="undefined"!==
typeof window.c2nodewebkit||/nodewebkit/i.test(navigator.userAgent);this.isArcade="undefined"!==typeof window.is_scirra_arcade;this.isWindows8App=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.isWindowsPhone8=!("undefined"===typeof window.c2isWindowsPhone8||!window.c2isWindowsPhone8);this.isBlackberry10=!("undefined"===typeof window.c2isBlackberry10||!window.c2isBlackberry10);this.isAndroidStockBrowser=this.isAndroid&&!this.isChrome&&!this.isFirefox&&!this.isAmazonWebApp&&
!this.isDomFree;this.devicePixelRatio=1;this.isMobile=this.isPhoneGap||this.isCrosswalk||this.isAppMobi||this.isCocoonJs||this.isAndroid||this.isiOS||this.isWindowsPhone8||this.isBlackberry10||this.isTizen;this.isMobile||(this.isMobile=/(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet)/i.test(navigator.userAgent));"undefined"===typeof cr_is_preview||this.isNodeWebkit||"?nw"!==window.location.search&&!/nodewebkit/i.test(navigator.userAgent)||(this.isNodeWebkit=!0);this.isDebug=
"undefined"!==typeof cr_is_preview&&-1<window.location.search.indexOf("debug");this.canvas=a;this.canvasdiv=document.getElementById("c2canvasdiv");this.ctx=this.glwrap=this.gl=null;this.fullscreenOldMarginCss="";this.firstInFullscreen=!1;this.oldHeight=this.oldWidth=0;this.canvas.oncontextmenu=function(a){a.preventDefault&&a.preventDefault();return!1};this.canvas.onselectstart=function(a){a.preventDefault&&a.preventDefault();return!1};this.isDirectCanvas&&(window.c2runtime=this);this.isNodeWebkit&&
(window.ondragover=function(a){a.preventDefault();return!1},window.ondrop=function(a){a.preventDefault();return!1},require("nw.gui").App.clearCache());this.width=a.width;this.height=a.height;this.draw_width=this.width;this.draw_height=this.height;this.cssWidth=this.width;this.cssHeight=this.height;this.lastWindowWidth=window.innerWidth;this.lastWindowHeight=window.innerHeight;this.redraw=!0;this.blockSuspend=this.isSuspended=!1;Date.now||(Date.now=function(){return+new Date});this.plugins=[];this.types=
{};this.types_by_index=[];this.behaviors=[];this.layouts={};this.layouts_by_index=[];this.eventsheets={};this.eventsheets_by_index=[];this.wait_for_textures=[];this.triggers_to_postinit=[];this.all_global_vars=[];this.all_local_vars=[];this.jumpthruBehavior=this.solidBehavior=null;this.deathRow=new cr.ObjectSet;this.isInClearDeathRow=!1;this.isInOnDestroy=0;this.isRunningEvents=!1;this.createRow=[];this.isLoadingState=!1;this.lastSaveJson=this.loadFromJson=this.loadFromSlot=this.saveToSlot="";this.suspendDrawing=
this.signalledContinuousPreview=!1;this.zeroDtCount=this.cpuutilisation=this.logictime=this.dt1=this.dt=0;this.timescale=1;this.kahanTime=new cr.KahanAdder;this.last_tick_time=0;this.measuring_dt=!0;this.objectcount=this.framecount=this.execcount=this.tickcount=this.last_fps_time=this.fps=0;this.changelayout=null;this.destroycallbacks=[];this.event_stack=[];this.event_stack_index=-1;this.localvar_stack=[[]];this.trigger_depth=this.localvar_stack_index=0;this.pushEventStack(null);this.loop_stack=[];
this.loop_stack_index=-1;this.next_puid=this.next_uid=0;this.layout_first_tick=!0;this.family_count=0;this.suspend_events=[];this.timeout_id=this.raf_id=0;this.isloading=!0;this.loadingprogress=0;this.isNodeFullscreen=!1;this.stackLocalCount=0;this.halfFramerateMode=!1;this.lastRafTime=0;this.isInUserInputEvent=this.had_a_click=this.ranLastRaf=!1;this.objects_to_tick=new cr.ObjectSet;this.objects_to_tick2=new cr.ObjectSet;this.registered_collisions=[];this.temp_poly=new cr.CollisionPoly([]);this.temp_poly2=
new cr.CollisionPoly([]);this.allGroups=[];this.activeGroups={};this.cndsBySid={};this.actsBySid={};this.varsBySid={};this.blocksBySid={};this.layout_ctx=this.layout_canvas=this.layout_tex=this.layer_tex=this.layer_ctx=this.layer_canvas=this.running_layout=null;this.uses_background_blending=this.is_WebGL_context_lost=!1;this.fx_tex=[null,null];this.fullscreen_scaling=0;this.files_subfolder="";this.objectsByUid={};this.snapshotCanvas=this.loaderlogo=null;this.snapshotData="";this.load();this.devicePixelRatio=
(this.isRetina=!this.isDomFree&&this.useHighDpi&&!this.isAndroidStockBrowser)?window.devicePixelRatio||window.webkitDevicePixelRatio||window.mozDevicePixelRatio||window.msDevicePixelRatio||1:1;this.ClearDeathRow();var c,d=this.alphaBackground&&!(this.isNodeWebkit||this.isWindows8App||this.isWindowsPhone8);0<this.fullscreen_mode&&this.setSize(window.innerWidth,window.innerHeight,!0);try{!this.enableWebGL||!this.isCocoonJs&&this.isDomFree||(c={alpha:d,depth:!1,antialias:!1,failIfMajorPerformanceCaveat:!0},
this.gl=a.getContext("webgl",c)||a.getContext("experimental-webgl",c))}catch(e){}if(this.gl){this.isDomFree||(this.overlay_canvas=document.createElement("canvas"),jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode),this.overlay_canvas.oncontextmenu=function(a){return!1},this.overlay_canvas.onselectstart=function(a){return!1},this.overlay_canvas.width=this.cssWidth,this.overlay_canvas.height=this.cssHeight,jQuery(this.overlay_canvas).css({width:this.cssWidth+"px",height:this.cssHeight+"px"}),
this.positionOverlayCanvas(),this.overlay_ctx=this.overlay_canvas.getContext("2d"));this.glwrap=new cr.GLWrap(this.gl,this.isMobile);this.glwrap.setSize(a.width,a.height);this.ctx=null;this.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();b.onContextLost();console.log("[Construct 2] WebGL context lost");window.cr_setSuspended(!0)},!1);this.canvas.addEventListener("webglcontextrestored",function(a){b.glwrap.initState();b.glwrap.setSize(b.glwrap.width,b.glwrap.height,!0);b.layer_tex=
null;b.layout_tex=null;b.fx_tex[0]=null;b.fx_tex[1]=null;b.onContextRestored();b.redraw=!0;console.log("[Construct 2] WebGL context restored");window.cr_setSuspended(!1)},!1);var g,f,h,k,m,l;a=0;for(c=this.types_by_index.length;a<c;a++)for(f=this.types_by_index[a],d=0,g=f.effect_types.length;d<g;d++)k=f.effect_types[d],k.shaderindex=this.glwrap.getShaderIndex(k.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(k.shaderindex);a=0;for(c=this.layouts_by_index.length;a<
c;a++){m=this.layouts_by_index[a];d=0;for(g=m.effect_types.length;d<g;d++)k=m.effect_types[d],k.shaderindex=this.glwrap.getShaderIndex(k.id);d=0;for(g=m.layers.length;d<g;d++)for(l=m.layers[d],f=0,h=l.effect_types.length;f<h;f++)k=l.effect_types[f],k.shaderindex=this.glwrap.getShaderIndex(k.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(k.shaderindex)}}else{if(0<this.fullscreen_mode&&this.isDirectCanvas){this.canvas=null;document.oncontextmenu=function(a){return!1};
document.onselectstart=function(a){return!1};this.ctx=AppMobi.canvas.getContext("2d");try{this.ctx.samplingMode=this.linearSampling?"smooth":"sharp",this.ctx.globalScale=1,this.ctx.HTML5CompatibilityMode=!0,this.ctx.imageSmoothingEnabled=this.linearSampling}catch(n){}0!==this.width&&0!==this.height&&(this.ctx.width=this.width,this.ctx.height=this.height)}this.ctx||(c=this.isCocoonJs?{antialias:!!this.linearSampling,alpha:d}:{alpha:d},this.ctx=a.getContext("2d",c),this.ctx.webkitImageSmoothingEnabled=
this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling);this.overlay_ctx=this.overlay_canvas=null}this.tickFunc=function(){b.tick()};window==window.top||this.isDomFree||this.isWindows8App||(document.addEventListener("mousedown",function(){window.focus()},!0),document.addEventListener("touchstart",function(){window.focus()},!0));"undefined"!==typeof cr_is_preview&&(this.isCocoonJs&&
console.log("[Construct 2] In preview-over-wifi via CocoonJS mode"),-1<window.location.search.indexOf("continuous")&&(cr.logexport("Reloading for continuous preview"),this.loadFromSlot="__c2_continuouspreview",this.suspendDrawing=!0),this.pauseOnBlur&&!this.isMobile&&(jQuery(window).focus(function(){b.setSuspended(!1)}),jQuery(window).blur(function(){b.setSuspended(!0)})));0===this.fullscreen_mode&&this.isRetina&&1<this.devicePixelRatio&&this.setSize(this.original_width,this.original_height,!0);this.tryLockOrientation();
this.go();this.extra={};cr.seal(this)}}function b(a){a.target.result.createObjectStore("saves",{keyPath:"slot"})}function c(a,c,d,e){var g=indexedDB.open("_C2SaveStates");g.onupgradeneeded=b;g.onerror=e;g.onsuccess=function(b){b=b.target.result;b.onerror=e;b.transaction(["saves"],"readwrite").objectStore("saves").put({slot:a,data:c}).onsuccess=d}}function d(a,c,d){var e=indexedDB.open("_C2SaveStates");e.onupgradeneeded=b;e.onerror=d;e.onsuccess=function(b){b=b.target.result;b.onerror=d;var e=b.transaction(["saves"]).objectStore("saves").get(a);
e.onsuccess=function(a){e.result?c(e.result.data):c(null)}}}function e(){cr.logexport("Reloading for continuous preview");window.c2cocoonjs?CocoonJS.App.reload():-1<window.location.search.indexOf("continuous")?window.location.reload(!0):window.location+="?continuous"}function g(a){var b,c={};for(b in a)!a.hasOwnProperty(b)||a[b]instanceof cr.ObjectSet||a[b]&&"undefined"!==typeof a[b].c2userdata||(c[b]=a[b]);return c}a.prototype.setSize=function(a,b,c){var d=0,e=0,g=0,f=0,f=0,h=this.isiPhoneiOS6&&
this.isSafari&&!navigator.standalone&&!this.isDomFree&&!this.isPhoneGap;h&&(b+=60);if(this.lastWindowWidth!==a||this.lastWindowHeight!==b||c){this.lastWindowWidth=a;this.lastWindowHeight=b;var k=this.fullscreen_mode,m=document.mozFullScreen||document.webkitIsFullScreen||!!document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen;if(m||0!==this.fullscreen_mode||c)m&&0<this.fullscreen_scaling&&(k=this.fullscreen_scaling),4<=k?(c=this.original_width/this.original_height,a/b>c?(g=b*c,5===
k?(f=g/this.original_width,1<f?f=Math.floor(f):1>f&&(f=1/Math.ceil(1/f)),g=this.original_width*f,f*=this.original_height,d=(a-g)/2,e=(b-f)/2,a=g,b=f):(d=(a-g)/2,a=g)):(f=a/c,5===k?(f/=this.original_height,1<f?f=Math.floor(f):1>f&&(f=1/Math.ceil(1/f)),g=this.original_width*f,f*=this.original_height,d=(a-g)/2,e=(b-f)/2,a=g):e=(b-f)/2,b=f),m&&!this.isNodeWebkit&&(e=d=0),d=Math.floor(d),e=Math.floor(e),a=Math.floor(a),b=Math.floor(b)):this.isNodeWebkit&&this.isNodeFullscreen&&0===this.fullscreen_mode_set&&
(d=Math.floor((a-this.original_width)/2),e=Math.floor((b-this.original_height)/2),a=this.original_width,b=this.original_height),2>k&&(this.aspect_scale=this.devicePixelRatio),this.isRetina&&this.isiPad&&1<this.devicePixelRatio&&(1024<=a&&(a=1023),1024<=b&&(b=1023)),m=this.devicePixelRatio,this.cssWidth=a,this.cssHeight=b,this.width=Math.round(a*m),this.height=Math.round(b*m),this.redraw=!0,this.wantFullscreenScalingQuality?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=
!0):this.width<this.original_width&&this.height<this.original_height||1===k?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):(this.draw_width=this.original_width,this.draw_height=this.original_height,this.fullscreenScalingQuality=!1,2===k?(c=this.original_width/this.original_height,k=this.lastWindowWidth/this.lastWindowHeight,k<c?this.draw_width=this.draw_height*k:k>c&&(this.draw_height=this.draw_width/k)):3===k&&(c=this.original_width/this.original_height,
k=this.lastWindowWidth/this.lastWindowHeight,k>c?this.draw_width=this.draw_height*k:k<c&&(this.draw_height=this.draw_width/k))),this.canvasdiv&&!this.isDomFree&&(jQuery(this.canvasdiv).css({width:a+"px",height:b+"px","margin-left":d,"margin-top":e}),"undefined"!==typeof cr_is_preview&&jQuery("#borderwrap").css({width:a+"px",height:b+"px"})),this.canvas&&(this.canvas.width=Math.round(a*m),this.canvas.height=Math.round(b*m),this.isRetina&&jQuery(this.canvas).css({width:a+"px",height:b+"px"})),this.overlay_canvas&&
(this.overlay_canvas.width=a,this.overlay_canvas.height=b,jQuery(this.overlay_canvas).css({width:a+"px",height:b+"px"})),this.glwrap&&this.glwrap.setSize(Math.round(a*m),Math.round(b*m)),this.isDirectCanvas&&this.ctx&&(this.ctx.width=a,this.ctx.height=b),this.ctx&&(this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling),this.tryLockOrientation(),
h&&window.setTimeout(function(){window.scrollTo(0,1)},100)}};a.prototype.tryLockOrientation=function(){if(this.autoLockOrientation&&0!==this.orientations){var a="portrait";2===this.orientations&&(a="landscape");screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a)}};a.prototype.onContextLost=function(){this.is_WebGL_context_lost=!0;var a,
b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onLostWebGLContext)c.onLostWebGLContext()};a.prototype.onContextRestored=function(){this.is_WebGL_context_lost=!1;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onRestoreWebGLContext)c.onRestoreWebGLContext()};a.prototype.positionOverlayCanvas=function(){if(!this.isDomFree){var a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||document.msFullscreenElement||
this.isNodeFullscreen?jQuery(this.canvas).offset():jQuery(this.canvas).position();a.position="absolute";jQuery(this.overlay_canvas).css(a)}};var f=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.msCancelAnimationFrame||window.oCancelAnimationFrame;a.prototype.setSuspended=function(a){var b;if(a&&!this.isSuspended&&!this.blockSuspend)for(cr.logexport("[Construct 2] Suspending"),this.isSuspended=!0,0!==this.raf_id&&f&&f(this.raf_id),0!==this.timeout_id&&
clearTimeout(this.timeout_id),a=0,b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!0);else if(!a&&this.isSuspended){cr.logexport("[Construct 2] Resuming");this.isSuspended=!1;this.last_tick_time=cr.performance_now();this.last_fps_time=cr.performance_now();a=this.logictime=this.framecount=0;for(b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!1);this.tick()}};a.prototype.addSuspendCallback=function(a){this.suspend_events.push(a)};a.prototype.load=function(){var a=cr.getProjectModel();
this.name=a[0];this.first_layout=a[1];this.fullscreen_mode=a[11];this.fullscreen_mode_set=a[11];this.original_width=a[9];this.original_height=a[10];this.parallax_x_origin=this.original_width/2;this.parallax_y_origin=this.original_height/2;this.isDomFree&&(4<=a[11]||0===a[11])&&(cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'"),this.fullscreen_mode_set=this.fullscreen_mode=3);this.uses_loader_layout=a[17];this.loaderstyle=
a[18];0===this.loaderstyle&&(this.loaderlogo=new Image,this.loaderlogo.src="loading-logo.png");this.next_uid=a[20];this.system=new cr.system_object(this);var b,c,d,e,g,f,h,k,m;b=0;for(c=a[2].length;b<c;b++){h=a[2][b];cr.add_common_aces(h);m=new h[0](this);m.singleglobal=h[1];m.is_world=h[2];m.must_predraw=h[9];if(m.onCreate)m.onCreate();cr.seal(m);this.plugins.push(m)}a=cr.getProjectModel();b=0;for(c=a[3].length;b<c;b++){h=a[3][b];g=h[1];m=null;d=0;for(e=this.plugins.length;d<e;d++)if(this.plugins[d]instanceof
g){m=this.plugins[d];break}var l=new m.Type(m);l.name=h[0];l.is_family=h[2];l.instvar_sids=h[3].slice(0);l.vars_count=h[3].length;l.behs_count=h[4];l.fx_count=h[5];l.sid=h[11];l.is_family?(l.members=[],l.family_index=this.family_count++,l.families=null):(l.members=null,l.family_index=-1,l.families=[]);l.family_var_map=null;l.family_beh_map=null;l.family_fx_map=null;l.is_contained=!1;l.container=null;h[6]?(l.texture_file=h[6][0],l.texture_filesize=h[6][1],l.texture_pixelformat=h[6][2]):(l.texture_file=
null,l.texture_filesize=0,l.texture_pixelformat=0);l.animations=h[7]?h[7]:null;l.index=b;l.instances=[];l.deadCache=[];l.solstack=[new cr.selection(l)];l.cur_sol=0;l.default_instance=null;l.default_layerindex=0;l.stale_iids=!0;l.updateIIDs=cr.type_updateIIDs;l.getFirstPicked=cr.type_getFirstPicked;l.getPairedInstance=cr.type_getPairedInstance;l.getCurrentSol=cr.type_getCurrentSol;l.pushCleanSol=cr.type_pushCleanSol;l.pushCopySol=cr.type_pushCopySol;l.popSol=cr.type_popSol;l.getBehaviorByName=cr.type_getBehaviorByName;
l.getBehaviorIndexByName=cr.type_getBehaviorIndexByName;l.getEffectIndexByName=cr.type_getEffectIndexByName;l.applySolToContainer=cr.type_applySolToContainer;l.getInstanceByIID=cr.type_getInstanceByIID;l.collision_grid=new cr.SparseGrid(this.original_width,this.original_height);l.any_cell_changed=!0;l.any_instance_parallaxed=!1;l.extra={};l.toString=cr.type_toString;l.behaviors=[];d=0;for(e=h[8].length;d<e;d++){k=h[8][d];var n=k[1],q=null;g=0;for(f=this.behaviors.length;g<f;g++)if(this.behaviors[g]instanceof
n){q=this.behaviors[g];break}if(!q){q=new n(this);q.my_types=[];q.my_instances=new cr.ObjectSet;if(q.onCreate)q.onCreate();cr.seal(q);this.behaviors.push(q);cr.behaviors.solid&&q instanceof cr.behaviors.solid&&(this.solidBehavior=q);cr.behaviors.jumpthru&&q instanceof cr.behaviors.jumpthru&&(this.jumpthruBehavior=q)}-1===q.my_types.indexOf(l)&&q.my_types.push(l);g=new q.Type(q,l);g.name=k[0];g.sid=k[2];g.onCreate();cr.seal(g);l.behaviors.push(g)}l.global=h[9];l.isOnLoaderLayout=h[10];l.effect_types=
[];d=0;for(e=h[12].length;d<e;d++)l.effect_types.push({id:h[12][d][0],name:h[12][d][1],shaderindex:-1,active:!0,index:d});l.tile_poly_data=h[13];if(!this.uses_loader_layout||l.is_family||l.isOnLoaderLayout||!m.is_world)l.onCreate(),cr.seal(l);l.name&&(this.types[l.name]=l);this.types_by_index.push(l);m.singleglobal&&(d=new m.Instance(l),d.uid=this.next_uid++,d.puid=this.next_puid++,d.iid=0,d.get_iid=cr.inst_get_iid,d.toString=cr.inst_toString,d.properties=h[14],d.onCreate(),cr.seal(d),l.instances.push(d),
this.objectsByUid[d.uid.toString()]=d)}b=0;for(c=a[4].length;b<c;b++)for(g=a[4][b],f=this.types_by_index[g[0]],d=1,e=g.length;d<e;d++)h=this.types_by_index[g[d]],h.families.push(f),f.members.push(h);b=0;for(c=a[23].length;b<c;b++){g=a[23][b];f=[];d=0;for(e=g.length;d<e;d++)f.push(this.types_by_index[g[d]]);d=0;for(e=f.length;d<e;d++)f[d].is_contained=!0,f[d].container=f}if(0<this.family_count)for(b=0,c=this.types_by_index.length;b<c;b++)if(h=this.types_by_index[b],!h.is_family&&h.families.length){h.family_var_map=
Array(this.family_count);h.family_beh_map=Array(this.family_count);h.family_fx_map=Array(this.family_count);l=[];d=q=n=k=0;for(e=h.families.length;d<e;d++)for(m=h.families[d],h.family_var_map[m.family_index]=k,k+=m.vars_count,h.family_beh_map[m.family_index]=n,n+=m.behs_count,h.family_fx_map[m.family_index]=q,q+=m.fx_count,g=0,f=m.effect_types.length;g<f;g++)l.push(cr.shallowCopy({},m.effect_types[g]));h.effect_types=l.concat(h.effect_types);d=0;for(e=h.effect_types.length;d<e;d++)h.effect_types[d].index=
d}b=0;for(c=a[5].length;b<c;b++)h=a[5][b],d=new cr.layout(this,h),cr.seal(d),this.layouts[d.name]=d,this.layouts_by_index.push(d);b=0;for(c=a[6].length;b<c;b++)h=a[6][b],d=new cr.eventsheet(this,h),cr.seal(d),this.eventsheets[d.name]=d,this.eventsheets_by_index.push(d);b=0;for(c=this.eventsheets_by_index.length;b<c;b++)this.eventsheets_by_index[b].postInit();b=0;for(c=this.triggers_to_postinit.length;b<c;b++)this.triggers_to_postinit[b].postInit();this.triggers_to_postinit.length=0;this.files_subfolder=
a[7];this.pixel_rounding=a[8];this.aspect_scale=1;this.enableWebGL=a[12];this.linearSampling=a[13];this.alphaBackground=a[14];this.versionstr=a[15];this.useHighDpi=a[16];this.orientations=a[19];this.autoLockOrientation=0<this.orientations;this.pauseOnBlur=a[21];this.fullscreenScalingQuality=this.wantFullscreenScalingQuality=a[22];this.start_time=Date.now()};var l=!1;a.prototype.waitForImageLoad=function(a){a.onerror=function(){l=a.c2error=!0};this.wait_for_textures.push(a)};a.prototype.findWaitingTexture=
function(a){var b,c;b=0;for(c=this.wait_for_textures.length;b<c;b++)if(this.wait_for_textures[b].cr_src===a)return this.wait_for_textures[b];return null};a.prototype.areAllTexturesLoaded=function(){var a=0,b=0,c=!0,d,e,g;d=0;for(e=this.wait_for_textures.length;d<e;d++){g=this.wait_for_textures[d];var f=g.cr_filesize;if(!f||0>=f)f=5E4;a+=f;!g.complete&&!g.loaded||g.c2error?c=!1:b+=f}this.progress=0==a?0:b/a;return c};a.prototype.go=function(){if(this.ctx||this.glwrap){var a=this.ctx||this.overlay_ctx;
this.overlay_canvas&&this.positionOverlayCanvas();this.progress=0;this.last_progress=-1;if(this.areAllTexturesLoaded())this.go_textures_done();else{var b=Date.now()-this.start_time;if(a){var c=this.width,d=this.height,e=this.devicePixelRatio;this.overlay_canvas&&(c=this.cssWidth,d=this.cssHeight,e=1);if(3!==this.loaderstyle&&500<=b&&this.last_progress!=this.progress){a.clearRect(0,0,c,d);var b=c/2,d=d/2,c=0===this.loaderstyle&&this.loaderlogo.complete,g=40*e,f=0,h=80*e,k;c&&(h=this.loaderlogo.width*
e,k=this.loaderlogo.height*e,g=h/2,f=k/2,a.drawImage(this.loaderlogo,cr.floor(b-g),cr.floor(d-f),h,k));1>=this.loaderstyle?(d+=f+(c?12*e:0),b=cr.floor(b-g)+0.5,d=cr.floor(d)+0.5,a.fillStyle=l?"red":"DodgerBlue",a.fillRect(b,d,Math.floor(h*this.progress),6*e),a.strokeStyle="black",a.strokeRect(b,d,h,6*e),a.strokeStyle="white",a.strokeRect(b-1*e,d-1*e,h+2*e,8*e)):2===this.loaderstyle&&(a.font="12pt Arial",a.fillStyle=l?"#f00":"#999",a.textBaseLine="middle",e=Math.round(100*this.progress)+"%",c=a.measureText?
a.measureText(e):null,a.fillText(e,b-(c?c.width:0)/2,d))}this.last_progress=this.progress}setTimeout(function(a){return function(){a.go()}}(this),100)}}};a.prototype.go_textures_done=function(){this.overlay_canvas&&(this.canvas.parentNode.removeChild(this.overlay_canvas),this.overlay_canvas=this.overlay_ctx=null);this.start_time=Date.now();this.last_fps_time=cr.performance_now();var a,b,c;if(this.uses_loader_layout)for(a=0,b=this.types_by_index.length;a<b;a++)c=this.types_by_index[a],c.is_family||
c.isOnLoaderLayout||!c.plugin.is_world||(c.onCreate(),cr.seal(c));else this.isloading=!1;a=0;for(b=this.layouts_by_index.length;a<b;a++)this.layouts_by_index[a].createGlobalNonWorlds();2<=this.fullscreen_mode&&(a=this.original_width/this.original_height,b=this.width/this.height,this.aspect_scale=2!==this.fullscreen_mode&&b>a||2===this.fullscreen_mode&&b<a?this.height/this.original_height:this.width/this.original_width);this.first_layout?this.layouts[this.first_layout].startRunning():this.layouts_by_index[0].startRunning();
this.uses_loader_layout||(this.loadingprogress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null));navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onAppBegin)c.onAppBegin();this.tick();this.isDirectCanvas&&AppMobi.webview.execute("onGameReady();")};var k=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||
window.oRequestAnimationFrame;a.prototype.tick=function(){if(this.running_layout){var a=cr.performance_now();if(this.halfFramerateMode&&this.ranLastRaf&&29>a-this.lastRafTime)this.ranLastRaf=!1,this.lastRafTime=a,k?this.raf_id=k(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16);else{this.ranLastRaf=!0;this.lastRafTime=a;var b=this.fullscreen_mode,c=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement;(c||this.isNodeFullscreen)&&
0<this.fullscreen_scaling&&(b=this.fullscreen_scaling);if(0<b&&(!this.isiPhone||window.self!==window.top)){var b=window.innerWidth,d=window.innerHeight;this.lastWindowWidth===b&&this.lastWindowHeight===d||this.setSize(b,d)}this.isDomFree||(c?(this.firstInFullscreen||(this.fullscreenOldMarginCss=jQuery(this.canvas).css("margin")||"0",this.firstInFullscreen=!0),this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css({"margin-left":""+Math.floor((screen.width-this.width/this.devicePixelRatio)/2)+"px",
"margin-top":""+Math.floor((screen.height-this.height/this.devicePixelRatio)/2)+"px"})):this.firstInFullscreen?(this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css("margin",this.fullscreenOldMarginCss),this.fullscreenOldMarginCss="",this.firstInFullscreen=!1,0===this.fullscreen_mode&&this.setSize(Math.round(this.oldWidth/this.devicePixelRatio),Math.round(this.oldHeight/this.devicePixelRatio),!0)):(this.oldWidth=this.width,this.oldHeight=this.height));this.isloading&&(c=this.areAllTexturesLoaded(),
this.loadingprogress=this.progress,c&&(this.isloading=!1,this.progress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null)));this.logic();!this.redraw&&!this.isCocoonJs||this.is_WebGL_context_lost||this.suspendDrawing||(this.redraw=!1,this.glwrap?this.drawGL():this.draw(),this.snapshotCanvas&&(this.canvas&&this.canvas.toDataURL&&(this.snapshotData=this.canvas.toDataURL(this.snapshotCanvas[0],this.snapshotCanvas[1]),this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot,null)),
this.snapshotCanvas=null));this.hit_breakpoint||(this.tickcount++,this.execcount++,this.framecount++);this.logictime+=cr.performance_now()-a;this.isSuspended||(k?this.raf_id=k(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16))}}};a.prototype.logic=function(){var a,b,c,d,e,g,f,h,k;a=cr.performance_now();1E3<=a-this.last_fps_time&&(this.last_fps_time+=1E3,this.fps=this.framecount,this.framecount=0,this.cpuutilisation=this.logictime,this.logictime=0);this.measuring_dt&&
(0!==this.last_tick_time&&(b=a-this.last_tick_time,0!==b||this.isDebug?(this.dt1=b/1E3,0.5<this.dt1?this.dt1=0:0.1<this.dt1&&(this.dt1=0.1)):(this.zeroDtCount++,10<=this.zeroDtCout&&(this.measuring_dt=!1),this.dt1=1/60)),this.last_tick_time=a);this.dt=this.dt1*this.timescale;this.kahanTime.add(this.dt);a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement||this.isNodeFullscreen;2<=this.fullscreen_mode||a&&0<this.fullscreen_scaling?(b=this.original_width/
this.original_height,c=this.width/this.height,d=this.fullscreen_mode,a&&0<this.fullscreen_scaling&&(d=this.fullscreen_scaling),this.aspect_scale=2!==d&&c>b||2===d&&c<b?this.height/this.original_height:this.width/this.original_width,this.running_layout&&(this.running_layout.scrollToX(this.running_layout.scrollX),this.running_layout.scrollToY(this.running_layout.scrollY))):this.aspect_scale=this.isRetina?this.devicePixelRatio:1;this.ClearDeathRow();this.isInOnDestroy++;this.system.runWaits();this.isInOnDestroy--;
this.ClearDeathRow();this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(f=this.types_by_index[a],!f.is_family&&(f.behaviors.length||f.families.length))for(c=0,d=f.instances.length;c<d;c++)for(h=f.instances[c],e=0,g=h.behavior_insts.length;e<g;e++)h.behavior_insts[e].tick();a=0;for(b=this.types_by_index.length;a<b;a++)if(f=this.types_by_index[a],!f.is_family&&(f.behaviors.length||f.families.length))for(c=0,d=f.instances.length;c<d;c++)for(h=f.instances[c],e=0,g=h.behavior_insts.length;e<
g;e++)k=h.behavior_insts[e],k.posttick&&k.posttick();c=this.objects_to_tick.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick();this.isInOnDestroy--;this.handleSaveLoad();for(a=0;this.changelayout&&10>a++;)this.doChangeLayout(this.changelayout);a=0;for(b=this.eventsheets_by_index.length;a<b;a++)this.eventsheets_by_index[a].hasRun=!1;this.running_layout.event_sheet&&this.running_layout.event_sheet.run();this.registered_collisions.length=0;this.layout_first_tick=!1;this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<
b;a++)if(f=this.types_by_index[a],!f.is_family&&(f.behaviors.length||f.families.length))for(c=0,d=f.instances.length;c<d;c++)for(h=f.instances[c],e=0,g=h.behavior_insts.length;e<g;e++)k=h.behavior_insts[e],k.tick2&&k.tick2();c=this.objects_to_tick2.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick2();this.isInOnDestroy--};a.prototype.doChangeLayout=function(a){var b=this.running_layout;this.running_layout.stopRunning();var c,d,e,g,f,h,k;if(this.glwrap)for(c=0,d=this.types_by_index.length;c<d;c++)f=
this.types_by_index[c],f.is_family||!f.unloadTextures||f.global&&0!==f.instances.length||-1!==a.initial_types.indexOf(f)||f.unloadTextures();b==a&&(this.system.waits.length=0);a.startRunning();c=0;for(d=this.types_by_index.length;c<d;c++)if(f=this.types_by_index[c],f.global||f.plugin.singleglobal)for(a=0,b=f.instances.length;a<b;a++){h=f.instances[a];if(h.onLayoutChange)h.onLayoutChange();if(h.behavior_insts)for(e=0,g=h.behavior_insts.length;e<g;e++)if(k=h.behavior_insts[e],k.onLayoutChange)k.onLayoutChange()}this.layout_first_tick=
this.redraw=!0;this.ClearDeathRow()};a.prototype.tickMe=function(a){this.objects_to_tick.add(a)};a.prototype.untickMe=function(a){this.objects_to_tick.remove(a)};a.prototype.tick2Me=function(a){this.objects_to_tick2.add(a)};a.prototype.untick2Me=function(a){this.objects_to_tick2.remove(a)};a.prototype.getDt=function(a){return a&&-1!==a.my_timescale?this.dt1*a.my_timescale:this.dt};a.prototype.draw=function(){this.running_layout.draw(this.ctx);this.isDirectCanvas&&this.ctx.present()};a.prototype.drawGL=
function(){this.running_layout.drawGL(this.glwrap);this.glwrap.present()};a.prototype.addDestroyCallback=function(a){a&&this.destroycallbacks.push(a)};a.prototype.removeDestroyCallback=function(a){cr.arrayFindRemove(this.destroycallbacks,a)};a.prototype.getObjectByUID=function(a){a=a.toString();return this.objectsByUid.hasOwnProperty(a)?this.objectsByUid[a]:null};a.prototype.DestroyInstance=function(a){var b,c;if(!this.deathRow.contains(a)){this.deathRow.add(a);if(a.is_contained)for(b=0,c=a.siblings.length;b<
c;b++)this.DestroyInstance(a.siblings[b]);this.isInClearDeathRow&&this.deathRow.values_cache.push(a);this.isInOnDestroy++;this.trigger(Object.getPrototypeOf(a.type.plugin).cnds.OnDestroyed,a);this.isInOnDestroy--}};a.prototype.ClearDeathRow=function(){var a,b,c,d,e,g,f,h,k,l;this.isInClearDeathRow=!0;d=0;for(g=this.createRow.length;d<g;d++)for(a=this.createRow[d],b=a.type,b.instances.push(a),e=0,f=b.families.length;e<f;e++)b.families[e].instances.push(a),b.families[e].stale_iids=!0;this.createRow.length=
0;g=this.deathRow.valuesRef();for(d=0;d<g.length;d++){a=g[d];b=a.type;c=b.instances;e=0;for(f=this.destroycallbacks.length;e<f;e++)this.destroycallbacks[e](a);cr.arrayFindRemove(c,a);0===c.length&&(b.any_instance_parallaxed=!1);a.collcells&&b.collision_grid.update(a,a.collcells,null);a.layer&&(cr.arrayRemove(a.layer.instances,a.get_zindex()),a.layer.zindices_stale=!0);e=0;for(f=b.families.length;e<f;e++)cr.arrayFindRemove(b.families[e].instances,a),b.families[e].stale_iids=!0;if(a.behavior_insts)for(e=
0,f=a.behavior_insts.length;e<f;e++){c=a.behavior_insts[e];if(c.onDestroy)c.onDestroy();c.behavior.my_instances.remove(a)}this.objects_to_tick.remove(a);this.objects_to_tick2.remove(a);e=0;for(f=this.system.waits.length;e<f;e++)if(k=this.system.waits[e],k.sols.hasOwnProperty(b.index)&&cr.arrayFindRemove(k.sols[b.index].insts,a),!b.is_family)for(c=0,h=b.families.length;c<h;c++)l=b.families[c],k.sols.hasOwnProperty(l.index)&&cr.arrayFindRemove(k.sols[l.index].insts,a);if(a.onDestroy)a.onDestroy();this.objectsByUid.hasOwnProperty(a.uid.toString())&&
delete this.objectsByUid[a.uid.toString()];this.objectcount--;64>b.deadCache.length&&b.deadCache.push(a);b.stale_iids=!0}this.deathRow.isEmpty()||(this.redraw=!0);this.deathRow.clear();this.isInClearDeathRow=!1};a.prototype.createInstance=function(a,b,c,d){if(a.is_family){var e=cr.floor(Math.random()*a.members.length);return this.createInstance(a.members[e],b,c,d)}return a.default_instance?this.createInstanceFromInit(a.default_instance,b,!1,c,d,!1):null};var h=[];a.prototype.createInstanceFromInit=
function(a,b,c,d,e,g){var f,k,l,m;if(!a)return null;var n=this.types_by_index[a[1]],q=n.plugin.is_world;if(this.isloading&&q&&!n.isOnLoaderLayout||q&&!this.glwrap&&11===a[0][11])return null;var r=b;q||(b=null);var s;n.deadCache.length?(s=n.deadCache.pop(),s.recycled=!0,n.plugin.Instance.call(s,n)):(s=new n.plugin.Instance(n),s.recycled=!1);s.uid=c&&!g?a[2]:this.next_uid++;this.objectsByUid[s.uid.toString()]=s;s.puid=this.next_puid++;s.iid=n.instances.length;f=0;for(k=this.createRow.length;f<k;++f)this.createRow[f].type===
n&&s.iid++;s.get_iid=cr.inst_get_iid;l=a[3];if(s.recycled)cr.wipe(s.extra);else{s.extra={};if("undefined"!==typeof cr_is_preview)for(s.instance_var_names=[],s.instance_var_names.length=l.length,f=0,k=l.length;f<k;f++)s.instance_var_names[f]=l[f][1];s.instance_vars=[];s.instance_vars.length=l.length}f=0;for(k=l.length;f<k;f++)s.instance_vars[f]=l[f][0];if(q){var t=a[0];s.x=cr.is_undefined(d)?t[0]:d;s.y=cr.is_undefined(e)?t[1]:e;s.z=t[2];s.width=t[3];s.height=t[4];s.depth=t[5];s.angle=t[6];s.opacity=
t[7];s.hotspotX=t[8];s.hotspotY=t[9];s.blend_mode=t[10];f=t[11];!this.glwrap&&n.effect_types.length&&(s.blend_mode=f);s.compositeOp=cr.effectToCompositeOp(s.blend_mode);this.gl&&cr.setGLBlend(s,s.blend_mode,this.gl);if(s.recycled){f=0;for(k=t[12].length;f<k;f++)for(l=0,m=t[12][f].length;l<m;l++)s.effect_params[f][l]=t[12][f][l];s.bbox.set(0,0,0,0);s.collcells.set(0,0,-1,-1);s.bquad.set_from_rect(s.bbox);s.bbox_changed_callbacks.length=0}else{s.effect_params=t[12].slice(0);f=0;for(k=s.effect_params.length;f<
k;f++)s.effect_params[f]=t[12][f].slice(0);s.active_effect_types=[];s.active_effect_flags=[];s.active_effect_flags.length=n.effect_types.length;s.bbox=new cr.rect(0,0,0,0);s.collcells=new cr.rect(0,0,-1,-1);s.bquad=new cr.quad;s.bbox_changed_callbacks=[];s.set_bbox_changed=cr.set_bbox_changed;s.add_bbox_changed_callback=cr.add_bbox_changed_callback;s.contains_pt=cr.inst_contains_pt;s.update_bbox=cr.update_bbox;s.update_collision_cell=cr.update_collision_cell;s.get_zindex=cr.inst_get_zindex}s.tilemap_exists=
!1;s.tilemap_width=0;s.tilemap_height=0;s.tilemap_data=null;14===t.length&&(s.tilemap_exists=!0,s.tilemap_width=t[13][0],s.tilemap_height=t[13][1],s.tilemap_data=t[13][2]);f=0;for(k=n.effect_types.length;f<k;f++)s.active_effect_flags[f]=!0;s.updateActiveEffects=cr.inst_updateActiveEffects;s.updateActiveEffects();s.uses_shaders=!!s.active_effect_types.length;s.bbox_changed=!0;s.cell_changed=!0;n.any_cell_changed=!0;s.visible=!0;s.my_timescale=-1;s.layer=b;s.zindex=b.instances.length;"undefined"===
typeof s.collision_poly&&(s.collision_poly=null);this.redraw=s.collisionsEnabled=!0}s.toString=cr.inst_toString;var p;f=h.length=0;for(k=n.families.length;f<k;f++)h.push.apply(h,n.families[f].behaviors);h.push.apply(h,n.behaviors);if(s.recycled)for(f=0,k=h.length;f<k;f++){var M=h[f];p=s.behavior_insts[f];p.recycled=!0;M.behavior.Instance.call(p,M,s);t=a[4][f];l=0;for(m=t.length;l<m;l++)p.properties[l]=t[l];p.onCreate();M.behavior.my_instances.add(s)}else for(s.behavior_insts=[],f=0,k=h.length;f<k;f++)M=
h[f],p=new M.behavior.Instance(M,s),p.recycled=!1,p.properties=a[4][f].slice(0),p.onCreate(),cr.seal(p),s.behavior_insts.push(p),M.behavior.my_instances.add(s);t=a[5];if(s.recycled)for(f=0,k=t.length;f<k;f++)s.properties[f]=t[f];else s.properties=t.slice(0);this.createRow.push(s);b&&(b.instances.push(s),1!==b.parallaxX||1!==b.parallaxY)&&(n.any_instance_parallaxed=!0);this.objectcount++;if(n.is_contained){if(s.is_contained=!0,s.recycled?s.siblings.length=0:s.siblings=[],!c&&!g){f=0;for(k=n.container.length;f<
k;f++)if(n.container[f]!==n){if(!n.container[f].default_instance)return null;s.siblings.push(this.createInstanceFromInit(n.container[f].default_instance,r,!1,q?s.x:d,q?s.y:e,!0))}f=0;for(k=s.siblings.length;f<k;f++)for(s.siblings[f].siblings.push(s),l=0;l<k;l++)f!==l&&s.siblings[f].siblings.push(s.siblings[l])}}else s.is_contained=!1,s.siblings=null;s.onCreate();s.recycled||cr.seal(s);f=0;for(k=s.behavior_insts.length;f<k;f++)s.behavior_insts[f].postCreate&&s.behavior_insts[f].postCreate();return s};
a.prototype.getLayerByName=function(a){var b,c;b=0;for(c=this.running_layout.layers.length;b<c;b++){var d=this.running_layout.layers[b];if(cr.equals_nocase(d.name,a))return d}return null};a.prototype.getLayerByNumber=function(a){a=cr.floor(a);0>a&&(a=0);a>=this.running_layout.layers.length&&(a=this.running_layout.layers.length-1);return this.running_layout.layers[a]};a.prototype.getLayer=function(a){return cr.is_number(a)?this.getLayerByNumber(a):this.getLayerByName(a.toString())};a.prototype.clearSol=
function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].getCurrentSol().select_all=!0};a.prototype.pushCleanSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCleanSol()};a.prototype.pushCopySol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCopySol()};a.prototype.popSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].popSol()};a.prototype.updateAllCells=function(a){if(a.any_cell_changed){var b,c,d=a.instances;b=0;for(c=d.length;b<c;++b)d[b].update_collision_cell();d=this.createRow;
b=0;for(c=d.length;b<c;++b)d[b].type===a&&d[b].update_collision_cell();a.any_cell_changed=!1}};a.prototype.getCollisionCandidates=function(a,b,c,d){var e,f,g=a?1!==a.parallaxX||1!==a.parallaxY:!1;if(b.is_family)for(a=0,e=b.members.length;a<e;++a)f=b.members[a],g||f.any_instance_parallaxed?cr.appendArray(d,f.instances):(this.updateAllCells(f),f.collision_grid.queryRange(c,d));else g||b.any_instance_parallaxed?cr.appendArray(d,b.instances):(this.updateAllCells(b),b.collision_grid.queryRange(c,d))};
a.prototype.getTypesCollisionCandidates=function(a,b,c,d){var e,f;e=0;for(f=b.length;e<f;++e)this.getCollisionCandidates(a,b[e],c,d)};a.prototype.getSolidCollisionCandidates=function(a,b,c){var d=this.getSolidBehavior();if(!d)return null;this.getTypesCollisionCandidates(a,d.my_types,b,c)};a.prototype.getJumpthruCollisionCandidates=function(a,b,c){var d=this.getJumpthruBehavior();if(!d)return null;this.getTypesCollisionCandidates(a,d.my_types,b,c)};a.prototype.testAndSelectCanvasPointOverlap=function(a,
b,c,d){var e=a.getCurrentSol(),f,g,h,k,l,m;if(e.select_all)for(d||(e.select_all=!1,e.instances.length=0),f=0,k=a.instances.length;f<k;f++){if(h=a.instances[f],h.update_bbox(),l=h.layer.canvasToLayer(b,c,!0),m=h.layer.canvasToLayer(b,c,!1),h.contains_pt(l,m)){if(d)return!1;e.instances.push(h)}}else{f=g=0;for(k=e.instances.length;f<k;f++)if(h=e.instances[f],h.update_bbox(),l=h.layer.canvasToLayer(b,c,!0),m=h.layer.canvasToLayer(b,c,!1),h.contains_pt(l,m)){if(d)return!1;e.instances[g]=e.instances[f];
g++}d||(e.instances.length=g)}a.applySolToContainer();return d?!0:e.hasObjects()};a.prototype.testOverlap=function(a,b){if(!(a&&b&&a!==b&&a.collisionsEnabled&&b.collisionsEnabled))return!1;a.update_bbox();b.update_bbox();var c=a.layer,d=b.layer,e,f,g,h,k,l,m,n;if(c===d||c.parallaxX===d.parallaxX&&d.parallaxY===d.parallaxY&&c.scale===d.scale&&c.angle===d.angle&&c.zoomRate===d.zoomRate){if(!a.bbox.intersects_rect(b.bbox)||!a.bquad.intersects_quad(b.bquad)||a.tilemap_exists&&b.tilemap_exists)return!1;
if(a.tilemap_exists)return this.testTilemapOverlap(a,b);if(b.tilemap_exists)return this.testTilemapOverlap(b,a);m=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();if(!m&&!e)return!0;m?(a.collision_poly.cache_poly(a.width,a.height,a.angle),m=a.collision_poly):(this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height),m=this.temp_poly);e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),n=b.collision_poly):(this.temp_poly.set_from_quad(b.bquad,
b.x,b.y,b.width,b.height),n=this.temp_poly);return m.intersects_poly(n,b.x-a.x,b.y-a.y)}m=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();m?(a.collision_poly.cache_poly(a.width,a.height,a.angle),this.temp_poly.set_from_poly(a.collision_poly)):this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height);m=this.temp_poly;e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),this.temp_poly2.set_from_poly(b.collision_poly)):this.temp_poly2.set_from_quad(b.bquad,
b.x,b.y,b.width,b.height);n=this.temp_poly2;e=0;for(f=m.pts_count;e<f;e++)g=2*e,h=g+1,k=m.pts_cache[g],l=m.pts_cache[h],m.pts_cache[g]=c.layerToCanvas(k+a.x,l+a.y,!0),m.pts_cache[h]=c.layerToCanvas(k+a.x,l+a.y,!1);m.update_bbox();e=0;for(f=n.pts_count;e<f;e++)g=2*e,h=g+1,k=n.pts_cache[g],l=n.pts_cache[h],n.pts_cache[g]=d.layerToCanvas(k+b.x,l+b.y,!0),n.pts_cache[h]=d.layerToCanvas(k+b.x,l+b.y,!1);n.update_bbox();return m.intersects_poly(n,0,0)};var m=new cr.quad,n=new cr.rect(0,0,0,0),p=[];a.prototype.testTilemapOverlap=
function(a,b){var c,d,e,f,g=b.bbox,h=a.x,k=a.y;a.getCollisionRectCandidates(g,p);var l=b.collision_poly&&!b.collision_poly.is_empty();c=0;for(d=p.length;c<d;++c)if(e=p[c],f=e.rc,g.intersects_rect_off(f,h,k)&&(m.set_from_rect(f),m.offset(h,k),m.intersects_quad(b.bquad)))if(l)if(b.collision_poly.cache_poly(b.width,b.height,b.angle),e.poly){if(e.poly.intersects_poly(b.collision_poly,b.x-(h+f.left),b.y-(k+f.top)))return p.length=0,!0}else{if(this.temp_poly.set_from_quad(m,0,0,f.right-f.left,f.bottom-
f.top),this.temp_poly.intersects_poly(b.collision_poly,b.x,b.y))return p.length=0,!0}else if(e.poly){if(this.temp_poly.set_from_quad(b.bquad,0,0,b.width,b.height),e.poly.intersects_poly(this.temp_poly,-(h+f.left),-(k+f.top)))return p.length=0,!0}else return p.length=0,!0;p.length=0;return!1};a.prototype.testRectOverlap=function(a,b){if(!b||!b.collisionsEnabled)return!1;b.update_bbox();if(!b.bbox.intersects_rect(a))return!1;if(b.tilemap_exists){b.getCollisionRectCandidates(a,p);var c,d,e,f,g=b.x,h=
b.y;c=0;for(d=p.length;c<d;++c)if(e=p[c],f=e.rc,a.intersects_rect_off(f,g,h))if(e.poly){if(this.temp_poly.set_from_rect(a,0,0),e.poly.intersects_poly(this.temp_poly,-(g+f.left),-(h+f.top)))return p.length=0,!0}else return p.length=0,!0;p.length=0;return!1}m.set_from_rect(a);if(!b.bquad.intersects_quad(m))return!1;if(!b.collision_poly||b.collision_poly.is_empty())return!0;b.collision_poly.cache_poly(b.width,b.height,b.angle);m.offset(-a.left,-a.top);this.temp_poly.set_from_quad(m,0,0,1,1);return b.collision_poly.intersects_poly(this.temp_poly,
a.left-b.x,a.top-b.y)};a.prototype.testSegmentOverlap=function(a,b,c,d,e){if(!e||!e.collisionsEnabled)return!1;e.update_bbox();n.set(cr.min(a,c),cr.min(b,d),cr.max(a,c),cr.max(b,d));if(!e.bbox.intersects_rect(n))return!1;if(e.tilemap_exists){e.getCollisionRectCandidates(n,p);var f,g,h,k=e.x,l=e.y;e=0;for(f=p.length;e<f;++e)if(g=p[e],h=g.rc,n.intersects_rect_off(h,k,l)&&(m.set_from_rect(h),m.offset(k,l),m.intersects_segment(a,b,c,d)))if(g.poly){if(g.poly.intersects_segment(k+h.left,l+h.top,a,b,c,d))return p.length=
0,!0}else return p.length=0,!0;p.length=0;return!1}if(!e.bquad.intersects_segment(a,b,c,d))return!1;if(!e.collision_poly||e.collision_poly.is_empty())return!0;e.collision_poly.cache_poly(e.width,e.height,e.angle);return e.collision_poly.intersects_segment(e.x,e.y,a,b,c,d)};a.prototype.typeHasBehavior=function(a,b){if(!b)return!1;var c,d,e,f,g;c=0;for(d=a.behaviors.length;c<d;c++)if(a.behaviors[c].behavior instanceof b)return!0;if(!a.is_family)for(c=0,d=a.families.length;c<d;c++)for(g=a.families[c],
e=0,f=g.behaviors.length;e<f;e++)if(g.behaviors[e].behavior instanceof b)return!0;return!1};a.prototype.typeHasNoSaveBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.NoSave)};a.prototype.typeHasPersistBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.Persist)};a.prototype.getSolidBehavior=function(){return this.solidBehavior};a.prototype.getJumpthruBehavior=function(){return this.jumpthruBehavior};var q=[];a.prototype.testOverlapSolid=function(a){var b,c,d;a.update_bbox();
this.getSolidCollisionCandidates(a.layer,a.bbox,q);b=0;for(c=q.length;b<c;++b)if(d=q[b],d.extra.solidEnabled&&this.testOverlap(a,d))return q.length=0,d;q.length=0;return null};a.prototype.testRectOverlapSolid=function(a){var b,c,d;this.getSolidCollisionCandidates(null,a,q);b=0;for(c=q.length;b<c;++b)if(d=q[b],d.extra.solidEnabled&&this.testRectOverlap(a,d))return q.length=0,d;q.length=0;return null};var r=[];a.prototype.testOverlapJumpThru=function(a,b){var c=null;b&&(c=r,c.length=0);a.update_bbox();
this.getJumpthruCollisionCandidates(a.layer,a.bbox,q);var d,e,f;d=0;for(e=q.length;d<e;++d)if(f=q[d],f.extra.jumpthruEnabled&&this.testOverlap(a,f))if(b)c.push(f);else return q.length=0,f;q.length=0;return c};a.prototype.pushOutSolid=function(a,b,c,d,e,f){d=d||50;var g=a.x,h=a.y,k,l=null,m=null;for(k=0;k<d;k++)if(a.x=g+b*k,a.y=h+c*k,a.set_bbox_changed(),!this.testOverlap(a,l)&&((l=this.testOverlapSolid(a))&&(m=l),!l&&(e&&(l=f?this.testOverlap(a,f)?f:null:this.testOverlapJumpThru(a))&&(m=l),!l)))return m&&
this.pushInFractional(a,b,c,m,16),!0;a.x=g;a.y=h;a.set_bbox_changed();return!1};a.prototype.pushOut=function(a,b,c,d,e){d=d||50;var f=a.x,g=a.y,h;for(h=0;h<d;h++)if(a.x=f+b*h,a.y=g+c*h,a.set_bbox_changed(),!this.testOverlap(a,e))return!0;a.x=f;a.y=g;a.set_bbox_changed();return!1};a.prototype.pushInFractional=function(a,b,c,d,e){var f=2,g,h=!1;g=!1;for(var k=a.x,l=a.y;f<=e;)g=1/f,f*=2,a.x+=b*g*(h?1:-1),a.y+=c*g*(h?1:-1),a.set_bbox_changed(),this.testOverlap(a,d)?g=h=!0:(g=h=!1,k=a.x,l=a.y);g&&(a.x=
k,a.y=l,a.set_bbox_changed())};a.prototype.pushOutSolidNearest=function(a,b){var c=cr.is_undefined(b)?100:b,d=0,e=a.x,f=a.y,g=0,h=0,k=0,l=this.testOverlapSolid(a);if(!l)return!0;for(;d<=c;){switch(g){case 0:h=0;k=-1;d++;break;case 1:h=1;k=-1;break;case 2:h=1;k=0;break;case 3:k=h=1;break;case 4:h=0;k=1;break;case 5:h=-1;k=1;break;case 6:h=-1;k=0;break;case 7:k=h=-1}g=(g+1)%8;a.x=cr.floor(e+h*d);a.y=cr.floor(f+k*d);a.set_bbox_changed();if(!this.testOverlap(a,l)&&(l=this.testOverlapSolid(a),!l))return!0}a.x=
e;a.y=f;a.set_bbox_changed();return!1};a.prototype.registerCollision=function(a,b){a.collisionsEnabled&&b.collisionsEnabled&&this.registered_collisions.push([a,b])};a.prototype.checkRegisteredCollision=function(a,b){var c,d,e;c=0;for(d=this.registered_collisions.length;c<d;c++)if(e=this.registered_collisions[c],e[0]==a&&e[1]==b||e[0]==b&&e[1]==a)return!0;return!1};a.prototype.calculateSolidBounceAngle=function(a,b,c,d){var e=a.x,f=a.y,g=cr.max(10,cr.distanceTo(b,c,e,f)),h=cr.angleTo(b,c,e,f),k=d||
this.testOverlapSolid(a);if(!k)return cr.clamp_angle(h+cr.PI);var l=k,m,n,s,q,r=cr.to_radians(5);for(m=1;36>m;m++)if(n=h-m*r,a.x=b+Math.cos(n)*g,a.y=c+Math.sin(n)*g,a.set_bbox_changed(),!this.testOverlap(a,l)&&(l=d?null:this.testOverlapSolid(a),!l)){s=n;break}36===m&&(s=cr.clamp_angle(h+cr.PI));l=k;for(m=1;36>m;m++)if(n=h+m*r,a.x=b+Math.cos(n)*g,a.y=c+Math.sin(n)*g,a.set_bbox_changed(),!this.testOverlap(a,l)&&(l=d?null:this.testOverlapSolid(a),!l)){q=n;break}36===m&&(q=cr.clamp_angle(h+cr.PI));a.x=
e;a.y=f;a.set_bbox_changed();if(q===s)return q;a=cr.angleDiff(q,s)/2;a=cr.angleClockwise(q,s)?cr.clamp_angle(s+a+cr.PI):cr.clamp_angle(q+a);s=Math.cos(h);h=Math.sin(h);q=Math.cos(a);a=Math.sin(a);b=s*q+h*a;return cr.angleTo(0,0,s-2*b*q,h-2*b*a)};var t=[],s=-1;a.prototype.trigger=function(a,b,c){if(!this.running_layout)return!1;var d=this.running_layout.event_sheet;if(!d)return!1;s++;s===t.length?t.push(new cr.ObjectSet):t[s].clear();a=this.triggerOnSheet(a,b,d,c);s--;return a};a.prototype.triggerOnSheet=
function(a,b,c,d){var e=t[s];if(e.contains(c))return!1;e.add(c);var e=c.includes.valuesRef(),f=!1,g,h,k;g=0;for(h=e.length;g<h;g++)e[g].isActive()&&(k=this.triggerOnSheet(a,b,e[g].include_sheet,d),f=f||k);if(b)for(k=this.triggerOnSheetForTypeName(a,b,b.type.name,c,d),f=f||k,g=0,h=b.type.families.length;g<h;g++)k=this.triggerOnSheetForTypeName(a,b,b.type.families[g].name,c,d),f=f||k;else k=this.triggerOnSheetForTypeName(a,b,"system",c,d),f=f||k;return f};a.prototype.triggerOnSheetForTypeName=function(a,
b,c,d,e){var f,g=!1,h=!1,h="undefined"!==typeof e,k=(h?d.fasttriggers:d.triggers)[c];if(!k)return g;var l=null;d=0;for(f=k.length;d<f;d++)if(k[d].method==a){l=k[d].evs;break}if(!l)return g;a=h?l[e]:l;if(!a)return null;d=0;for(f=a.length;d<f;d++)e=a[d][0],h=a[d][1],h=this.executeSingleTrigger(b,c,e,h),g=g||h;return g};a.prototype.executeSingleTrigger=function(a,b,c,d){var e,f,g=!1;this.trigger_depth++;var h=this.getCurrentEventStack().current_event;h&&this.pushCleanSol(h.solModifiersIncludingParents);
var k=1<this.trigger_depth;this.pushCleanSol(c.solModifiersIncludingParents);k&&this.pushLocalVarStack();var l=this.pushEventStack(c);l.current_event=c;a&&(e=this.types[b].getCurrentSol(),e.select_all=!1,e.instances.length=1,e.instances[0]=a,this.types[b].applySolToContainer());a=!0;if(c.parent){b=l.temp_parents_arr;for(e=c.parent;e;)b.push(e),e=e.parent;b.reverse();e=0;for(f=b.length;e<f;e++)if(!b[e].run_pretrigger()){a=!1;break}}a&&(this.execcount++,c.orblock?c.run_orblocktrigger(d):c.run(),g=g||
l.last_event_true);this.popEventStack();k&&this.popLocalVarStack();this.popSol(c.solModifiersIncludingParents);h&&this.popSol(h.solModifiersIncludingParents);0!==this.isInOnDestroy||0!==s||this.isRunningEvents||this.deathRow.isEmpty()&&!this.createRow.length||this.ClearDeathRow();this.trigger_depth--;return g};a.prototype.getCurrentCondition=function(){var a=this.getCurrentEventStack();return a.current_event.conditions[a.cndindex]};a.prototype.getCurrentAction=function(){var a=this.getCurrentEventStack();
return a.current_event.actions[a.actindex]};a.prototype.pushLocalVarStack=function(){this.localvar_stack_index++;this.localvar_stack_index>=this.localvar_stack.length&&this.localvar_stack.push([])};a.prototype.popLocalVarStack=function(){this.localvar_stack_index--};a.prototype.getCurrentLocalVarStack=function(){return this.localvar_stack[this.localvar_stack_index]};a.prototype.pushEventStack=function(a){this.event_stack_index++;this.event_stack_index>=this.event_stack.length&&this.event_stack.push(new cr.eventStackFrame);
var b=this.getCurrentEventStack();b.reset(a);return b};a.prototype.popEventStack=function(){this.event_stack_index--};a.prototype.getCurrentEventStack=function(){return this.event_stack[this.event_stack_index]};a.prototype.pushLoopStack=function(a){this.loop_stack_index++;this.loop_stack_index>=this.loop_stack.length&&this.loop_stack.push(cr.seal({name:a,index:0,stopped:!1}));var b=this.getCurrentLoop();b.name=a;b.index=0;b.stopped=!1;return b};a.prototype.popLoopStack=function(){this.loop_stack_index--};
a.prototype.getCurrentLoop=function(){return this.loop_stack[this.loop_stack_index]};a.prototype.getEventVariableByName=function(a,b){for(var c,d,e,f,g,h;b;){c=0;for(d=b.subevents.length;c<d;c++)if(h=b.subevents[c],h instanceof cr.eventvariable&&cr.equals_nocase(a,h.name))return h;b=b.parent}c=0;for(d=this.eventsheets_by_index.length;c<d;c++)for(g=this.eventsheets_by_index[c],e=0,f=g.events.length;e<f;e++)if(h=g.events[e],h instanceof cr.eventvariable&&cr.equals_nocase(a,h.name))return h;return null};
a.prototype.getLayoutBySid=function(a){var b,c;b=0;for(c=this.layouts_by_index.length;b<c;b++)if(this.layouts_by_index[b].sid===a)return this.layouts_by_index[b];return null};a.prototype.getObjectTypeBySid=function(a){var b,c;b=0;for(c=this.types_by_index.length;b<c;b++)if(this.types_by_index[b].sid===a)return this.types_by_index[b];return null};a.prototype.getGroupBySid=function(a){var b,c;b=0;for(c=this.allGroups.length;b<c;b++)if(this.allGroups[b].sid===a)return this.allGroups[b];return null};
a.prototype.signalContinuousPreview=function(){this.signalledContinuousPreview=!0};a.prototype.handleSaveLoad=function(){var a=this,b=this.saveToSlot,f=this.lastSaveJson,g=this.loadFromSlot,h=!1;this.signalledContinuousPreview&&(h=!0,b="__c2_continuouspreview",this.signalledContinuousPreview=!1);if(b.length){this.ClearDeathRow();f=this.saveToJSONString();if(window.indexedDB&&!this.isCocoonJs)c(b,f,function(){cr.logexport("Saved state to IndexedDB storage ("+f.length+" bytes)");a.lastSaveJson=f;a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,
null);a.lastSaveJson="";h&&e()},function(c){try{localStorage.setItem("__c2save_"+b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",h&&e()}catch(d){cr.logexport("Failed to save game state: "+c+"; "+d)}});else try{localStorage.setItem("__c2save_"+b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,this.trigger(cr.system_object.prototype.cnds.OnSaveComplete,
null),a.lastSaveJson="",h&&e()}catch(k){cr.logexport("Error saving to WebStorage: "+k)}this.loadFromJson=this.loadFromSlot=this.saveToSlot=""}g.length&&(window.indexedDB&&!this.isCocoonJs?d(g,function(b){b?(a.loadFromJson=b,cr.logexport("Loaded state from IndexedDB storage ("+a.loadFromJson.length+" bytes)")):(a.loadFromJson=localStorage.getItem("__c2save_"+g)||"",cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)"));a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,
null)},function(b){a.loadFromJson=localStorage.getItem("__c2save_"+g)||"";cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)");a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)}):(this.loadFromJson=localStorage.getItem("__c2save_"+g)||"",cr.logexport("Loaded state from WebStorage ("+this.loadFromJson.length+" bytes)"),this.suspendDrawing=!1,a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,
null)),this.saveToSlot=this.loadFromSlot="");this.loadFromJson.length&&(this.ClearDeathRow(),this.loadFromJSONString(this.loadFromJson),this.lastSaveJson=this.loadFromJson,this.trigger(cr.system_object.prototype.cnds.OnLoadComplete,null),this.loadFromJson=this.lastSaveJson="")};a.prototype.saveToJSONString=function(){var a,b,c,d,e,f,h,k={c2save:!0,version:1,rt:{time:this.kahanTime.sum,timescale:this.timescale,tickcount:this.tickcount,execcount:this.execcount,next_uid:this.next_uid,running_layout:this.running_layout.sid,
start_time_offset:Date.now()-this.start_time},types:{},layouts:{},events:{groups:{},cnds:{},acts:{},vars:{}}};a=0;for(b=this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],!e.is_family&&!this.typeHasNoSaveBehavior(e)){f={instances:[]};cr.hasAnyOwnProperty(e.extra)&&(f.ex=g(e.extra));c=0;for(d=e.instances.length;c<d;c++)f.instances.push(this.saveInstanceToJSON(e.instances[c]));k.types[e.sid.toString()]=f}a=0;for(b=this.layouts_by_index.length;a<b;a++)c=this.layouts_by_index[a],k.layouts[c.sid.toString()]=
c.saveToJSON();d=k.events.groups;a=0;for(b=this.allGroups.length;a<b;a++)c=this.allGroups[a],d[c.sid.toString()]=!!this.activeGroups[c.group_name];b=k.events.cnds;for(h in this.cndsBySid)this.cndsBySid.hasOwnProperty(h)&&(a=this.cndsBySid[h],cr.hasAnyOwnProperty(a.extra)&&(b[h]={ex:g(a.extra)}));b=k.events.acts;for(h in this.actsBySid)this.actsBySid.hasOwnProperty(h)&&(a=this.actsBySid[h],cr.hasAnyOwnProperty(a.extra)&&(b[h]={ex:a.extra}));b=k.events.vars;for(h in this.varsBySid)this.varsBySid.hasOwnProperty(h)&&
(a=this.varsBySid[h],a.is_constant||a.parent&&!a.is_static||(b[h]=a.data));k.system=this.system.saveToJSON();return JSON.stringify(k)};a.prototype.refreshUidMap=function(){var a,b,c,d,e,f;this.objectsByUid={};a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],!c.is_family)for(d=0,e=c.instances.length;d<e;d++)f=c.instances[d],this.objectsByUid[f.uid.toString()]=f};a.prototype.loadFromJSONString=function(a){a=JSON.parse(a);if(a.c2save&&!(1<a.version)){var b=a.rt;this.kahanTime.reset();
this.kahanTime.sum=b.time;this.timescale=b.timescale;this.tickcount=b.tickcount;this.start_time=Date.now()-b.start_time_offset;var c=b.running_layout;if(c!==this.running_layout.sid)if(c=this.getLayoutBySid(c))this.doChangeLayout(c);else return;this.isLoadingState=!0;var d,e,f,g,h,k,l;k=a.types;for(e in k)if(k.hasOwnProperty(e)&&(g=this.getObjectTypeBySid(parseInt(e,10)))&&!g.is_family&&!this.typeHasNoSaveBehavior(g)){k[e].ex?g.extra=k[e].ex:cr.wipe(g.extra);h=g.instances;f=k[e].instances;c=0;for(d=
cr.min(h.length,f.length);c<d;c++)this.loadInstanceFromJSON(h[c],f[c]);c=f.length;for(d=h.length;c<d;c++)this.DestroyInstance(h[c]);c=h.length;for(d=f.length;c<d;c++){h=null;if(g.plugin.is_world&&(h=this.running_layout.getLayerBySid(f[c].w.l),!h))continue;h=this.createInstanceFromInit(g.default_instance,h,!1,0,0,!0);this.loadInstanceFromJSON(h,f[c])}g.stale_iids=!0}this.ClearDeathRow();this.refreshUidMap();d=a.layouts;for(e in d)d.hasOwnProperty(e)&&(c=this.getLayoutBySid(parseInt(e,10)))&&c.loadFromJSON(d[e]);
d=a.events.groups;for(e in d)d.hasOwnProperty(e)&&(c=this.getGroupBySid(parseInt(e,10)))&&(this.activeGroups[c.group_name]=d[e]);c=a.events.cnds;for(e in c)c.hasOwnProperty(e)&&this.cndsBySid.hasOwnProperty(e)&&(this.cndsBySid[e].extra=c[e].ex);c=a.events.acts;for(e in c)c.hasOwnProperty(e)&&this.actsBySid.hasOwnProperty(e)&&(this.actsBySid[e].extra=c[e].ex);c=a.events.vars;for(e in c)c.hasOwnProperty(e)&&this.varsBySid.hasOwnProperty(e)&&(this.varsBySid[e].data=c[e]);this.next_uid=b.next_uid;this.isLoadingState=
!1;this.system.loadFromJSON(a.system);c=0;for(d=this.types_by_index.length;c<d;c++)if(g=this.types_by_index[c],!g.is_family)for(e=0,a=g.instances.length;e<a;e++){h=g.instances[e];if(g.is_contained)for(k=h.get_iid(),b=h.siblings.length=0,f=g.container.length;b<f;b++)l=g.container[b],g!==l&&h.siblings.push(l.instances[k]);h.afterLoad&&h.afterLoad();if(h.behavior_insts)for(b=0,f=h.behavior_insts.length;b<f;b++)k=h.behavior_insts[b],k.afterLoad&&k.afterLoad()}this.redraw=!0}};a.prototype.saveInstanceToJSON=
function(a,b){var c,d,e,f,h;f=a.type;e=f.plugin;var k={};b?k.c2=!0:k.uid=a.uid;cr.hasAnyOwnProperty(a.extra)&&(k.ex=g(a.extra));if(a.instance_vars&&a.instance_vars.length)for(k.ivs={},c=0,d=a.instance_vars.length;c<d;c++)k.ivs[a.type.instvar_sids[c].toString()]=a.instance_vars[c];if(e.is_world){e={x:a.x,y:a.y,w:a.width,h:a.height,l:a.layer.sid,zi:a.get_zindex()};0!==a.angle&&(e.a=a.angle);1!==a.opacity&&(e.o=a.opacity);0.5!==a.hotspotX&&(e.hX=a.hotspotX);0.5!==a.hotspotY&&(e.hY=a.hotspotY);0!==a.blend_mode&&
(e.bm=a.blend_mode);a.visible||(e.v=a.visible);a.collisionsEnabled||(e.ce=a.collisionsEnabled);-1!==a.my_timescale&&(e.mts=a.my_timescale);if(f.effect_types.length)for(e.fx=[],c=0,d=f.effect_types.length;c<d;c++)h=f.effect_types[c],e.fx.push({name:h.name,active:a.active_effect_flags[h.index],params:a.effect_params[h.index]});k.w=e}if(a.behavior_insts&&a.behavior_insts.length)for(k.behs={},c=0,d=a.behavior_insts.length;c<d;c++)f=a.behavior_insts[c],f.saveToJSON&&(k.behs[f.type.sid.toString()]=f.saveToJSON());
a.saveToJSON&&(k.data=a.saveToJSON());return k};a.prototype.getInstanceVarIndexBySid=function(a,b){var c,d;c=0;for(d=a.instvar_sids.length;c<d;c++)if(a.instvar_sids[c]===b)return c;return-1};a.prototype.getBehaviorIndexBySid=function(a,b){var c,d;c=0;for(d=a.behavior_insts.length;c<d;c++)if(a.behavior_insts[c].type.sid===b)return c;return-1};a.prototype.loadInstanceFromJSON=function(a,b,c){var d,e,f,g,h;h=a.type;f=h.plugin;if(c){if(!b.c2)return}else a.uid=b.uid;b.ex?a.extra=b.ex:cr.wipe(a.extra);
if(e=b.ivs)for(d in e)e.hasOwnProperty(d)&&(c=this.getInstanceVarIndexBySid(h,parseInt(d,10)),0>c||c>=a.instance_vars.length||(a.instance_vars[c]=e[d]));if(f.is_world){f=b.w;a.layer.sid!==f.l&&(c=a.layer,a.layer=this.running_layout.getLayerBySid(f.l),a.layer?(a.layer.instances.push(a),a.layer.zindices_stale=!0,cr.arrayFindRemove(c.instances,a),c.zindices_stale=!0):(a.layer=c,this.DestroyInstance(a)));a.x=f.x;a.y=f.y;a.width=f.w;a.height=f.h;a.zindex=f.zi;a.angle=f.hasOwnProperty("a")?f.a:0;a.opacity=
f.hasOwnProperty("o")?f.o:1;a.hotspotX=f.hasOwnProperty("hX")?f.hX:0.5;a.hotspotY=f.hasOwnProperty("hY")?f.hY:0.5;a.visible=f.hasOwnProperty("v")?f.v:!0;a.collisionsEnabled=f.hasOwnProperty("ce")?f.ce:!0;a.my_timescale=f.hasOwnProperty("mts")?f.mts:-1;a.blend_mode=f.hasOwnProperty("bm")?f.bm:0;a.compositeOp=cr.effectToCompositeOp(a.blend_mode);this.gl&&cr.setGLBlend(a,a.blend_mode,this.gl);a.set_bbox_changed();if(f.hasOwnProperty("fx"))for(c=0,e=f.fx.length;c<e;c++)g=h.getEffectIndexByName(f.fx[c].name),
0>g||(a.active_effect_flags[g]=f.fx[c].active,a.effect_params[g]=f.fx[c].params);a.updateActiveEffects()}if(h=b.behs)for(d in h)h.hasOwnProperty(d)&&(f=this.getBehaviorIndexBySid(a,parseInt(d,10)),0>f||a.behavior_insts[f].loadFromJSON(h[d]));b.data&&a.loadFromJSON(b.data)};cr.runtime=a;cr.createRuntime=function(b){return new a(document.getElementById(b))};cr.createDCRuntime=function(b,c){return new a({dc:!0,width:b,height:c})};window.cr_createRuntime=cr.createRuntime;window.cr_createDCRuntime=cr.createDCRuntime;
window.createCocoonJSRuntime=function(){window.c2cocoonjs=!0;var b=document.createElement("screencanvas")||document.createElement("canvas");b.screencanvas=!0;document.body.appendChild(b);b=new a(b);window.c2runtime=b;window.addEventListener("orientationchange",function(){window.c2runtime.setSize(window.innerWidth,window.innerHeight)});window.c2runtime.setSize(window.innerWidth,window.innerHeight);return b}})();
window.cr_getC2Runtime=function(){var a=document.getElementById("c2canvas");return a?a.c2runtime:window.c2runtime?window.c2runtime:null};window.cr_sizeCanvas=function(a,b){if(0!==a&&0!==b){var c=window.cr_getC2Runtime();c&&c.setSize(a,b)}};window.cr_setSuspended=function(a){var b=window.cr_getC2Runtime();b&&b.setSuspended(a)};
(function(){function a(a,b){this.runtime=a;this.event_sheet=null;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;this.scale=1;this.angle=0;this.first_visit=!0;this.name=b[0];this.width=b[1];this.height=b[2];this.unbounded_scrolling=b[3];this.sheetname=b[4];this.sid=b[5];var c=b[6],d,k;this.layers=[];this.initial_types=[];d=0;for(k=c.length;d<k;d++){var h=new cr.layer(this,c[d]);h.number=d;cr.seal(h);this.layers.push(h)}c=b[7];this.initial_nonworld=[];d=0;for(k=
c.length;d<k;d++){var h=c[d],m=this.runtime.types_by_index[h[1]];m.default_instance||(m.default_instance=h);this.initial_nonworld.push(h);-1===this.initial_types.indexOf(m)&&this.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(k=b[8].length;d<k;d++)this.effect_types.push({id:b[8][d][0],name:b[8][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[8][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=
new cr.rect(0,0,1,1);this.persist_data={}}function b(a,b){this.layout=a;this.runtime=a.runtime;this.instances=[];this.scale=1;this.angle=0;this.disableAngle=!1;this.tmprect=new cr.rect(0,0,0,0);this.tmpquad=new cr.quad;this.viewBottom=this.viewTop=this.viewRight=this.viewLeft=0;this.zindices_stale=!1;this.name=b[0];this.index=b[1];this.sid=b[2];this.visible=b[3];this.background_color=b[4];this.transparent=b[5];this.parallaxX=b[6];this.parallaxY=b[7];this.opacity=b[8];this.forceOwnTexture=b[9];this.zoomRate=
b[10];this.blend_mode=b[11];this.effect_fallback=b[12];this.compositeOp="source-over";this.destBlend=this.srcBlend=0;this.render_offscreen=!1;var c=b[13],d,k;this.initial_instances=[];d=0;for(k=c.length;d<k;d++){var h=c[d],m=this.runtime.types_by_index[h[1]];m.default_instance||(m.default_instance=h,m.default_layerindex=this.index);this.initial_instances.push(h);-1===this.layout.initial_types.indexOf(m)&&this.layout.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=
[];d=0;for(k=b[14].length;d<k;d++)this.effect_types.push({id:b[14][d][0],name:b[14][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[14][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=new cr.rect(0,0,1,1)}function c(a,b){return a.zindex-b.zindex}a.prototype.saveObjectToPersist=function(a){var b=a.type.sid.toString();this.persist_data.hasOwnProperty(b)||(this.persist_data[b]=[]);this.persist_data[b].push(this.runtime.saveInstanceToJSON(a))};
a.prototype.hasOpaqueBottomLayer=function(){var a=this.layers[0];return!a.transparent&&1===a.opacity&&!a.forceOwnTexture&&a.visible};a.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};a.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};var d=[];a.prototype.startRunning=
function(){this.sheetname&&(this.event_sheet=this.runtime.eventsheets[this.sheetname]);this.runtime.running_layout=this;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;var a,b,f,l,k,h,m;a=0;for(f=this.runtime.types_by_index.length;a<f;a++)if(b=this.runtime.types_by_index[a],!b.is_family)for(k=b.instances,b=0,l=k.length;b<l;b++)if(h=k[b],h.layer){var n=h.layer.number;n>=this.layers.length&&(n=this.layers.length-1);h.layer=this.layers[n];h.layer.instances.push(h);
h.layer.zindices_stale=!0}d.length=0;this.boundScrolling();a=0;for(f=this.layers.length;a<f;a++)h=this.layers[a],h.createInitialInstances(),h.disableAngle=!0,b=h.canvasToLayer(0,0,!0,!0),l=h.canvasToLayer(0,0,!1,!0),h.disableAngle=!1,this.runtime.pixel_rounding&&(b=b+0.5|0,l=l+0.5|0),h.rotateViewport(b,l,null);k=!1;if(!this.first_visit){for(m in this.persist_data)if(this.persist_data.hasOwnProperty(m)&&(b=this.runtime.getObjectTypeBySid(parseInt(m,10)))&&!b.is_family&&this.runtime.typeHasPersistBehavior(b)){l=
this.persist_data[m];a=0;for(f=l.length;a<f;a++){h=null;if(b.plugin.is_world&&(h=this.getLayerBySid(l[a].w.l),!h))continue;h=this.runtime.createInstanceFromInit(b.default_instance,h,!1,0,0,!0);this.runtime.loadInstanceFromJSON(h,l[a]);k=!0;d.push(h)}l.length=0}a=0;for(f=this.layers.length;a<f;a++)this.layers[a].instances.sort(c),this.layers[a].zindices_stale=!0}k&&(this.runtime.ClearDeathRow(),this.runtime.refreshUidMap());for(a=0;a<d.length;a++)if(h=d[a],h.type.is_contained)for(f=h.get_iid(),b=0,
l=h.type.container.length;b<l;b++)m=h.type.container[b],h.type!==m&&(m.instances.length>f?h.siblings.push(m.instances[f]):m.default_instance&&(k=this.runtime.createInstanceFromInit(m.default_instance,h.layer,!0,h.x,h.y,!0),this.runtime.ClearDeathRow(),m.updateIIDs(),h.siblings.push(k),d.push(k)));a=0;for(f=this.initial_nonworld.length;a<f;a++)this.runtime.createInstanceFromInit(this.initial_nonworld[a],null,!0);this.runtime.changelayout=null;this.runtime.ClearDeathRow();if(this.runtime.ctx&&!this.runtime.isDomFree)for(a=
0,f=this.runtime.types_by_index.length;a<f;a++)m=this.runtime.types_by_index[a],!m.is_family&&m.instances.length&&m.preloadCanvas2D&&m.preloadCanvas2D(this.runtime.ctx);a=0;for(f=d.length;a<f;a++)h=d[a],this.runtime.trigger(Object.getPrototypeOf(h.type.plugin).cnds.OnCreated,h);d.length=0;this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart,null);this.first_visit=!1};a.prototype.createGlobalNonWorlds=function(){var a,b,c,d,k;b=a=0;for(c=this.initial_nonworld.length;a<c;a++)d=this.initial_nonworld[a],
k=this.runtime.types_by_index[d[1]],k.global?this.runtime.createInstanceFromInit(d,null,!0):(this.initial_nonworld[b]=d,b++);this.initial_nonworld.length=b};a.prototype.stopRunning=function(){this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd,null);this.runtime.system.waits.length=0;var a,b,c,d,k,h;a=0;for(b=this.layers.length;a<b;a++){k=this.layers[a].instances;c=0;for(d=k.length;c<d;c++)h=k[c],h.type.global||(this.runtime.typeHasPersistBehavior(h.type)&&this.saveObjectToPersist(h),
this.runtime.DestroyInstance(h));this.runtime.ClearDeathRow();k.length=0;this.layers[a].zindices_stale=!0}a=0;for(b=this.runtime.types_by_index.length;a<b;a++)if(k=this.runtime.types_by_index[a],!(k.global||k.plugin.is_world||k.plugin.singleglobal||k.is_family)){c=0;for(d=k.instances.length;c<d;c++)this.runtime.DestroyInstance(k.instances[c]);this.runtime.ClearDeathRow()}};a.prototype.draw=function(a){var b,c=a,d=!1,k=!this.runtime.fullscreenScalingQuality;k&&(this.runtime.layout_canvas||(this.runtime.layout_canvas=
document.createElement("canvas"),b=this.runtime.layout_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layout_ctx=b.getContext("2d"),d=!0),b=this.runtime.layout_canvas,c=this.runtime.layout_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,
c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=this.runtime.linearSampling));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height);var h,m,d=0;for(h=this.layers.length;d<h;d++)m=this.layers[d],m.visible&&0<m.opacity&&11!==m.blend_mode&&m.draw(c);k&&a.drawImage(b,0,0,this.runtime.width,this.runtime.height)};a.prototype.drawGL=function(a){var b=
0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality;if(b){this.runtime.layout_tex||(this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layout_tex.c2width!==this.runtime.draw_width||this.runtime.layout_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,
this.runtime.draw_height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layout_tex);this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.draw_width,this.runtime.draw_height)}else this.runtime.layout_tex&&(a.setRenderingToTexture(null),a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=null);this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&a.clear(0,0,0,0);var c,d;c=0;for(d=this.layers.length;c<d;c++)this.layers[c].visible&&0<this.layers[c].opacity&&
this.layers[c].drawGL(a);b&&(0===this.active_effect_types.length||1===this.active_effect_types.length&&this.runtime.fullscreenScalingQuality?(1===this.active_effect_types.length?(b=this.active_effect_types[0].index,a.switchProgram(this.active_effect_types[0].shaderindex),a.setProgramParameters(null,1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.scale,this.angle,0,0,this.effect_params[b]),a.programIsAnimated(this.active_effect_types[0].shaderindex)&&(this.runtime.redraw=!0)):a.switchProgram(0),
this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.width,this.runtime.height),a.setRenderingToTexture(null),a.setOpacity(1),a.setTexture(this.runtime.layout_tex),a.setAlphaBlend(),a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.renderEffectChain(a,null,null,null))};a.prototype.getRenderTarget=function(){return 0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality?
this.runtime.layout_tex:null};a.prototype.getMinLayerScale=function(){var a=this.layers[0].getScale(),b,c,d;b=1;for(c=this.layers.length;b<c;b++)d=this.layers[b],(0!==d.parallaxX||0!==d.parallaxY)&&d.getScale()<a&&(a=d.getScale());return a};a.prototype.scrollToX=function(a){if(!this.unbounded_scrolling){var b=this.runtime.draw_width*(1/this.getMinLayerScale())/2;a>this.width-b&&(a=this.width-b);a<b&&(a=b)}this.scrollX!==a&&(this.scrollX=a,this.runtime.redraw=!0)};a.prototype.scrollToY=function(a){if(!this.unbounded_scrolling){var b=
this.runtime.draw_height*(1/this.getMinLayerScale())/2;a>this.height-b&&(a=this.height-b);a<b&&(a=b)}this.scrollY!==a&&(this.scrollY=a,this.runtime.redraw=!0)};a.prototype.boundScrolling=function(){this.scrollToX(this.scrollX);this.scrollToY(this.scrollY)};a.prototype.renderEffectChain=function(a,b,c,d){var k=c?c.active_effect_types:b?b.active_effect_types:this.active_effect_types,h=1,m=0,n=0,p=0;c?(h=c.layer.getScale(),m=c.layer.getAngle(),n=c.layer.viewLeft,p=c.layer.viewTop):b&&(h=b.getScale(),
m=b.getAngle(),n=b.viewLeft,p=b.viewTop);var q=this.runtime.fx_tex,r,t,s,u,A=0,E=1,I,z=this.runtime.draw_width,v=this.runtime.draw_height,F=z/2,x=v/2,y=b?b.rcTex:this.rcTex,B=b?b.rcTex2:this.rcTex2,w=0,G=0,C=0,D=0,J=z,T=z,M=v,P=v,L=s=0,H=c?c.layer.getAngle():0;if(c){r=0;for(t=k.length;r<t;r++)s+=a.getProgramBoxExtendHorizontal(k[r].shaderindex),L+=a.getProgramBoxExtendVertical(k[r].shaderindex);u=c.bbox;w=b.layerToCanvas(u.left,u.top,!0,!0);C=b.layerToCanvas(u.left,u.top,!1,!0);J=b.layerToCanvas(u.right,
u.bottom,!0,!0);M=b.layerToCanvas(u.right,u.bottom,!1,!0);0!==H&&(r=b.layerToCanvas(u.right,u.top,!0,!0),t=b.layerToCanvas(u.right,u.top,!1,!0),G=b.layerToCanvas(u.left,u.bottom,!0,!0),D=b.layerToCanvas(u.left,u.bottom,!1,!0),u=Math.min(w,J,r,G),J=Math.max(w,J,r,G),w=u,u=Math.min(C,M,t,D),M=Math.max(C,M,t,D),C=u);w-=s;C-=L;J+=s;M+=L;B.left=w/z;B.top=1-C/v;B.right=J/z;B.bottom=1-M/v;G=w=cr.floor(w);D=C=cr.floor(C);T=J=cr.ceil(J);P=M=cr.ceil(M);G-=s;D-=L;T+=s;P+=L;0>w&&(w=0);0>C&&(C=0);J>z&&(J=z);M>
v&&(M=v);0>G&&(G=0);0>D&&(D=0);T>z&&(T=z);P>v&&(P=v);y.left=w/z;y.top=1-C/v;y.right=J/z;y.bottom=1-M/v}else y.left=B.left=0,y.top=B.top=0,y.right=B.right=1,y.bottom=B.bottom=1;L=c&&((c.angle||H)&&a.programUsesDest(k[0].shaderindex)||0!==s||0!==L||1!==c.opacity||c.type.plugin.must_predraw)||b&&!c&&1!==b.opacity;a.setAlphaBlend();if(L){q[A]||(q[A]=a.createEmptyTexture(z,v,this.runtime.linearSampling));if(q[A].c2width!==z||q[A].c2height!==v)a.deleteTexture(q[A]),q[A]=a.createEmptyTexture(z,v,this.runtime.linearSampling);
a.switchProgram(0);a.setRenderingToTexture(q[A]);I=P-D;a.clearRect(G,v-D-I,T-G,I);c?c.drawGL(a):(a.setTexture(this.runtime.layer_tex),a.setOpacity(b.opacity),a.resetModelView(),a.translate(-F,-x),a.updateModelView(),a.quadTex(w,M,J,M,J,C,w,C,y));B.left=B.top=0;B.right=B.bottom=1;c&&(u=y.top,y.top=y.bottom,y.bottom=u);A=1;E=0}a.setOpacity(1);s=k.length-1;var H=a.programUsesCrossSampling(k[s].shaderindex)||!b&&!c&&!this.runtime.fullscreenScalingQuality,U=0;r=0;for(t=k.length;r<t;r++){q[A]||(q[A]=a.createEmptyTexture(z,
v,this.runtime.linearSampling));if(q[A].c2width!==z||q[A].c2height!==v)a.deleteTexture(q[A]),q[A]=a.createEmptyTexture(z,v,this.runtime.linearSampling);a.switchProgram(k[r].shaderindex);U=k[r].index;a.programIsAnimated(k[r].shaderindex)&&(this.runtime.redraw=!0);0!=r||L?(a.setProgramParameters(d,1/z,1/v,B.left,B.top,B.right,B.bottom,h,m,n,p,c?c.effect_params[U]:b?b.effect_params[U]:this.effect_params[U]),a.setTexture(null),r!==s||H?(a.setRenderingToTexture(q[A]),I=P-D,u=v-D-I,a.clearRect(G,u,T-G,
I)):(c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(d)),a.setTexture(q[E]),a.resetModelView(),a.translate(-F,-x),a.updateModelView(),a.quadTex(w,M,J,M,J,C,w,C,y),r!==s||H||a.setTexture(null)):(a.setRenderingToTexture(q[A]),I=P-D,u=v-D-I,a.clearRect(G,u,T-G,I),c?(a.setProgramParameters(d,1/c.width,1/c.height,B.left,B.top,B.right,B.bottom,h,m,n,p,c.effect_params[U]),c.drawGL(a)):(a.setProgramParameters(d,1/z,1/v,0,0,1,1,h,m,n,p,b?b.effect_params[U]:
this.effect_params[U]),a.setTexture(b?this.runtime.layer_tex:this.runtime.layout_tex),a.resetModelView(),a.translate(-F,-x),a.updateModelView(),a.quadTex(w,M,J,M,J,C,w,C,y)),B.left=B.top=0,B.right=B.bottom=1,c&&!H&&(u=M,M=C,C=u));A=0===A?1:0;E=0===A?1:0}H&&(a.switchProgram(0),c?a.setBlend(c.srcBlend,c.destBlend):b?a.setBlend(b.srcBlend,b.destBlend):this.runtime.fullscreenScalingQuality||(a.setSize(this.runtime.width,this.runtime.height),F=this.runtime.width/2,x=this.runtime.height/2,C=w=0,J=this.runtime.width,
M=this.runtime.height),a.setRenderingToTexture(d),a.setTexture(q[E]),a.resetModelView(),a.translate(-F,-x),a.updateModelView(),c&&1===k.length&&!L?a.quadTex(w,C,J,C,J,M,w,M,y):a.quadTex(w,M,J,M,J,C,w,C,y),a.setTexture(null))};a.prototype.getLayerBySid=function(a){var b,c;b=0;for(c=this.layers.length;b<c;b++)if(this.layers[b].sid===a)return this.layers[b];return null};a.prototype.saveToJSON=function(){var a,b,c,d={sx:this.scrollX,sy:this.scrollY,s:this.scale,a:this.angle,w:this.width,h:this.height,
fv:this.first_visit,persist:this.persist_data,fx:[],layers:{}};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});a=0;for(b=this.layers.length;a<b;a++)c=this.layers[a],d.layers[c.sid.toString()]=c.saveToJSON();return d};a.prototype.loadFromJSON=function(a){var b,c,d,k;this.scrollX=a.sx;this.scrollY=a.sy;this.scale=a.s;this.angle=a.a;this.width=a.w;this.height=a.h;this.persist_data=a.persist;"undefined"!==typeof a.fv&&
(this.first_visit=a.fv);var h=a.fx;b=0;for(c=h.length;b<c;b++)if(d=this.getEffectByName(h[b].name))d.active=h[b].active,this.effect_params[d.index]=h[b].params;this.updateActiveEffects();b=a.layers;for(k in b)b.hasOwnProperty(k)&&(a=this.getLayerBySid(parseInt(k,10)))&&a.loadFromJSON(b[k])};cr.layout=a;b.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};
b.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};b.prototype.createInitialInstances=function(){var a,b,c,l,k,h;b=a=0;for(c=this.initial_instances.length;a<c;a++){l=this.initial_instances[a];k=this.runtime.types_by_index[l[1]];h=this.runtime.typeHasPersistBehavior(k);k=!0;if(!h||this.layout.first_visit)l=this.runtime.createInstanceFromInit(l,this,!0),d.push(l),l.type.global&&(k=!1);k&&(this.initial_instances[b]=
this.initial_instances[a],b++)}this.initial_instances.length=b;this.runtime.ClearDeathRow();!this.runtime.glwrap&&this.effect_types.length&&(this.blend_mode=this.effect_fallback);this.compositeOp=cr.effectToCompositeOp(this.blend_mode);this.runtime.gl&&cr.setGLBlend(this,this.blend_mode,this.runtime.gl)};b.prototype.updateZIndices=function(){if(this.zindices_stale){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].zindex=a;this.zindices_stale=!1}};b.prototype.getScale=function(a){return this.getNormalScale()*
(this.runtime.fullscreenScalingQuality||a?this.runtime.aspect_scale:1)};b.prototype.getNormalScale=function(){return(this.scale*this.layout.scale-1)*this.zoomRate+1};b.prototype.getAngle=function(){return this.disableAngle?0:cr.clamp_angle(this.layout.angle+this.angle)};b.prototype.draw=function(a){this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0!==this.blend_mode;var b=this.runtime.canvas,c=a,d=!1;a.globalAlpha=1;a.globalCompositeOperation="source-over";this.render_offscreen&&(this.runtime.layer_canvas||
(this.runtime.layer_canvas=document.createElement("canvas"),b=this.runtime.layer_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layer_ctx=b.getContext("2d"),d=!0),b=this.runtime.layer_canvas,c=this.runtime.layer_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,
c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=this.runtime.linearSampling),this.transparent&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height));this.transparent||(c.fillStyle="rgb("+this.background_color[0]+","+this.background_color[1]+","+this.background_color[2]+")",c.fillRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.save();this.disableAngle=!0;var d=this.canvasToLayer(0,0,!0,!0),k=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;
this.runtime.pixel_rounding&&(d=d+0.5|0,k=k+0.5|0);this.rotateViewport(d,k,c);var h=this.getScale();c.scale(h,h);c.translate(-d,-k);for(var m,d=0,k=this.instances.length;d<k;d++)h=this.instances[d],h.visible&&0!==h.width&&0!==h.height&&(h.update_bbox(),m=h.bbox,m.right<this.viewLeft||m.bottom<this.viewTop||m.left>this.viewRight||m.top>this.viewBottom||(c.globalCompositeOperation=h.compositeOp,h.draw(c)));c.restore();this.render_offscreen&&(a.globalCompositeOperation=this.compositeOp,a.globalAlpha=
this.opacity,a.drawImage(b,0,0))};b.prototype.rotateViewport=function(a,b,c){var d=this.getScale();this.viewLeft=a;this.viewTop=b;this.viewRight=a+this.runtime.draw_width*(1/d);this.viewBottom=b+this.runtime.draw_height*(1/d);a=this.getAngle();0!==a&&(c&&(c.translate(this.runtime.draw_width/2,this.runtime.draw_height/2),c.rotate(-a),c.translate(this.runtime.draw_width/-2,this.runtime.draw_height/-2)),this.tmprect.set(this.viewLeft,this.viewTop,this.viewRight,this.viewBottom),this.tmprect.offset((this.viewLeft+
this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),this.tmpquad.set_from_rotated_rect(this.tmprect,a),this.tmpquad.bounding_box(this.tmprect),this.tmprect.offset((this.viewLeft+this.viewRight)/2,(this.viewTop+this.viewBottom)/2),this.viewLeft=this.tmprect.left,this.viewTop=this.tmprect.top,this.viewRight=this.tmprect.right,this.viewBottom=this.tmprect.bottom)};b.prototype.drawGL=function(a){var b=this.runtime.draw_width,c=this.runtime.draw_height,d=0,k=0;if(this.render_offscreen=this.forceOwnTexture||
1!==this.opacity||0<this.active_effect_types.length||0!==this.blend_mode){this.runtime.layer_tex||(this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layer_tex.c2width!==this.runtime.draw_width||this.runtime.layer_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layer_tex),this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling);
a.setRenderingToTexture(this.runtime.layer_tex);this.transparent&&a.clear(0,0,0,0)}this.transparent||a.clear(this.background_color[0]/255,this.background_color[1]/255,this.background_color[2]/255,1);this.disableAngle=!0;var k=this.canvasToLayer(0,0,!0,!0),h=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;this.runtime.pixel_rounding&&(k=k+0.5|0,h=h+0.5|0);this.rotateViewport(k,h,null);h=this.getScale();a.resetModelView();a.scale(h,h);a.rotateZ(-this.getAngle());a.translate((this.viewLeft+this.viewRight)/
-2,(this.viewTop+this.viewBottom)/-2);a.updateModelView();var m,n,p;m=0;for(n=this.instances.length;m<n;m++)if(p=this.instances[m],p.visible&&0!==p.width&&0!==p.height&&(p.update_bbox(),d=p.bbox,!(d.right<this.viewLeft||d.bottom<this.viewTop||d.left>this.viewRight||d.top>this.viewBottom)))if(p.uses_shaders)if(d=p.active_effect_types[0].shaderindex,k=p.active_effect_types[0].index,1!==p.active_effect_types.length||a.programUsesCrossSampling(d)||a.programExtendsBox(d)||(p.angle||p.layer.getAngle())&&
a.programUsesDest(d)||1!==p.opacity||p.type.plugin.must_predraw)this.layout.renderEffectChain(a,this,p,this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget()),a.resetModelView(),a.scale(h,h),a.rotateZ(-this.getAngle()),a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),a.updateModelView();else{a.switchProgram(d);a.setBlend(p.srcBlend,p.destBlend);a.programIsAnimated(d)&&(this.runtime.redraw=!0);var q=0,r=0,t=0,s=0;a.programUsesDest(d)&&(d=p.bbox,q=
this.layerToCanvas(d.left,d.top,!0,!0),r=this.layerToCanvas(d.left,d.top,!1,!0),t=this.layerToCanvas(d.right,d.bottom,!0,!0),d=this.layerToCanvas(d.right,d.bottom,!1,!0),q/=b,r=1-r/c,t/=b,s=1-d/c);a.setProgramParameters(this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget(),1/p.width,1/p.height,q,r,t,s,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,p.effect_params[k]);p.drawGL(a)}else a.switchProgram(0),a.setBlend(p.srcBlend,p.destBlend),p.drawGL(a);this.render_offscreen&&
(d=this.active_effect_types.length?this.active_effect_types[0].shaderindex:0,k=this.active_effect_types.length?this.active_effect_types[0].index:0,0===this.active_effect_types.length||1===this.active_effect_types.length&&!a.programUsesCrossSampling(d)&&1===this.opacity?(1===this.active_effect_types.length?(a.switchProgram(d),a.setProgramParameters(this.layout.getRenderTarget(),1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,this.effect_params[k]),
a.programIsAnimated(d)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(this.layout.getRenderTarget()),a.setOpacity(this.opacity),a.setTexture(this.runtime.layer_tex),a.setBlend(this.srcBlend,this.destBlend),a.resetModelView(),a.updateModelView(),b=this.runtime.draw_width/2,c=this.runtime.draw_height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.layout.renderEffectChain(a,this,null,this.layout.getRenderTarget()))};b.prototype.canvasToLayer=function(a,b,c,d){var k=this.runtime.devicePixelRatio;
this.runtime.isRetina&&(a*=k,b*=k);var k=this.runtime.parallax_x_origin,h=this.runtime.parallax_y_origin,k=(this.layout.scrollX-k)*this.parallaxX+k,h=(this.layout.scrollY-h)*this.parallaxY+h,m=1/this.getScale(!d);d?(k-=this.runtime.draw_width*m/2,h-=this.runtime.draw_height*m/2):(k-=this.runtime.width*m/2,h-=this.runtime.height*m/2);k+=a*m;h+=b*m;b=this.getAngle();0!==b&&(k-=this.layout.scrollX,h-=this.layout.scrollY,a=Math.cos(b),b=Math.sin(b),d=k*a-h*b,h=h*a+k*b,k=d+this.layout.scrollX,h+=this.layout.scrollY);
return c?k:h};b.prototype.layerToCanvas=function(a,b,c,d){var k=this.getAngle();if(0!==k){a-=this.layout.scrollX;b-=this.layout.scrollY;var h=Math.cos(-k),k=Math.sin(-k),m=a*h-b*k;b=b*h+a*k;a=m+this.layout.scrollX;b+=this.layout.scrollY}h=this.runtime.parallax_x_origin;k=this.runtime.parallax_y_origin;h=(this.layout.scrollX-h)*this.parallaxX+h;k=(this.layout.scrollY-k)*this.parallaxY+k;m=1/this.getScale(!d);d?(h-=this.runtime.draw_width*m/2,k-=this.runtime.draw_height*m/2):(h-=this.runtime.width*
m/2,k-=this.runtime.height*m/2);h=(a-h)/m;k=(b-k)/m;a=this.runtime.devicePixelRatio;this.runtime.isRetina&&(h/=a,k/=a);return c?h:k};b.prototype.rotatePt=function(a,b,c){if(0===this.getAngle())return c?a:b;var d=this.layerToCanvas(a,b,!0);b=this.layerToCanvas(a,b,!1);this.disableAngle=!0;a=this.canvasToLayer(d,b,!0);d=this.canvasToLayer(d,b,!0);this.disableAngle=!1;return c?a:d};b.prototype.saveToJSON=function(){var a,b,c,d={s:this.scale,a:this.angle,vl:this.viewLeft,vt:this.viewTop,vr:this.viewRight,
vb:this.viewBottom,v:this.visible,bc:this.background_color,t:this.transparent,px:this.parallaxX,py:this.parallaxY,o:this.opacity,zr:this.zoomRate,fx:[],instances:[]};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});return d};b.prototype.loadFromJSON=function(a){var b,d;this.scale=a.s;this.angle=a.a;this.viewLeft=a.vl;this.viewTop=a.vt;this.viewRight=a.vr;this.viewBottom=a.vb;this.visible=a.v;this.background_color=
a.bc;this.transparent=a.t;this.parallaxX=a.px;this.parallaxY=a.py;this.opacity=a.o;this.zoomRate=a.zr;var l=a.fx;a=0;for(b=l.length;a<b;a++)if(d=this.getEffectByName(l[a].name))d.active=l[a].active,this.effect_params[d.index]=l[a].params;this.updateActiveEffects();this.instances.sort(c);this.zindices_stale=!0};cr.layer=b})();
(function(){function a(a,b){var c,d=a.length;switch(d){case 0:return!0;case 1:return a[0]===b[0];case 2:return a[0]===b[0]&&a[1]===b[1];default:for(c=0;c<d;c++)if(a[c]!==b[c])return!1;return!0}}function b(a,b){return a.index-b.index}function c(c){var d,e,f,h;2===c.length?c[0].index>c[1].index&&(d=c[0],c[0]=c[1],c[1]=d):2<c.length&&c.sort(b);c.length>=q.length&&(q.length=c.length+1);q[c.length]||(q[c.length]=[]);h=q[c.length];d=0;for(e=h.length;d<e;d++)if(f=h[d],a(c,f))return f;h.push(c);return c}
function d(a,b){this.runtime=a;this.triggers={};this.fasttriggers={};this.hasRun=!1;this.includes=new cr.ObjectSet;this.name=b[0];var c=b[1];this.events=[];var d,e;d=0;for(e=c.length;d<e;d++)this.init_event(c[d],null,this.events)}function e(a){this.type=a;this.instances=[];this.else_instances=[];this.select_all=!0}function g(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.solModifiersIncludingParents=[];this.has_else_block=this.toplevelgroup=this.toplevelevent=this.initially_activated=
this.group=this.solWriterAfterCnds=!1;this.conditions=[];this.actions=[];this.subevents=[];c[1]?(this.group_name=c[1][1].toLowerCase(),this.group=!0,this.initially_activated=!!c[1][0],this.runtime.allGroups.push(this),this.runtime.activeGroups[this.group_name.toLowerCase()]=this.initially_activated):(this.group_name="",this.initially_activated=this.group=!1);this.orblock=c[2];this.sid=c[4];this.group||(this.runtime.blocksBySid[this.sid.toString()]=this);var d=c[5];a=0;for(b=d.length;a<b;a++){var e=
new cr.condition(this,d[a]);e.index=a;cr.seal(e);this.conditions.push(e);this.addSolModifier(e.type)}d=c[6];a=0;for(b=d.length;a<b;a++)e=new cr.action(this,d[a]),e.index=a,cr.seal(e),this.actions.push(e);if(8===c.length)for(c=c[7],a=0,b=c.length;a<b;a++)this.sheet.init_event(c[a],this,this.subevents);this.is_else_block=!1;this.conditions.length&&(this.is_else_block=null==this.conditions[0].type&&this.conditions[0].func==cr.system_object.prototype.cnds.Else)}function f(a,b){var c,d,e;if(a&&(-1===b.indexOf(a)&&
b.push(a),a.is_contained))for(c=0,d=a.container.length;c<d;c++)e=a.container[c],a!==e&&-1===b.indexOf(e)&&b.push(e)}function l(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.func=b[1];this.trigger=0<b[3];this.fasttrigger=2===b[3];this.looping=b[4];this.inverted=b[5];this.isstatic=b[6];this.sid=b[7];this.runtime.cndsBySid[this.sid.toString()]=this;-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,
this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.isstatic?this.run_static:this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1),this.block.parent&&this.block.parent.setSolWriterAfterCnds());this.fasttrigger&&(this.run=this.run_true);if(10===b.length){var c,d,e=b[9];c=0;for(d=e.length;c<d;c++){var f=new cr.parameter(this,e[c]);cr.seal(f);this.parameters.push(f)}this.results.length=
e.length}}function k(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.func=b[1];-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1));this.sid=b[3];this.runtime.actsBySid[this.sid.toString()]=
this;if(6===b.length){var c,d,e=b[5];c=0;for(d=e.length;c<d;c++){var f=new cr.parameter(this,e[c]);cr.seal(f);this.parameters.push(f)}this.results.length=e.length}}function h(a,b){this.owner=a;this.block=a.block;this.sheet=a.sheet;this.runtime=a.runtime;this.type=b[0];this.expression=null;this.combosel=this.solindex=0;this.layout=null;this.key=0;this.object=null;this.index=0;this.variadicret=this.subparams=this.fileinfo=this.eventvar=this.varname=null;var c,d,e;switch(b[0]){case 0:case 7:this.expression=
new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp;break;case 1:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp_str;break;case 5:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_layer;break;case 3:case 8:this.combosel=b[1];this.get=this.get_combosel;break;case 6:this.layout=this.runtime.layouts[b[1]];this.get=this.get_layout;break;case 9:this.key=b[1];this.get=this.get_key;break;case 4:this.object=this.runtime.types_by_index[b[1]];
this.get=this.get_object;this.block.addSolModifier(this.object);this.owner instanceof cr.action?this.block.setSolWriterAfterCnds():this.block.parent&&this.block.parent.setSolWriterAfterCnds();break;case 10:this.index=b[1];this.get=a.type.is_family?this.get_familyvar:this.get_instvar;break;case 11:this.varname=b[1];this.eventvar=null;this.get=this.get_eventvar;break;case 2:case 12:this.fileinfo=b[1];this.get=this.get_audiofile;break;case 13:for(this.get=this.get_variadic,this.subparams=[],this.variadicret=
[],c=1,d=b.length;c<d;c++)e=new cr.parameter(this.owner,b[c]),cr.seal(e),this.subparams.push(e),this.variadicret.push(0)}}function m(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.name=c[1];this.vartype=c[2];this.initial=c[3];this.is_static=!!c[4];this.is_constant=!!c[5];this.sid=c[6];this.runtime.varsBySid[this.sid.toString()]=this;this.data=this.initial;this.parent?(this.localIndex=this.is_static||this.is_constant?-1:this.runtime.stackLocalCount++,this.runtime.all_local_vars.push(this)):
(this.localIndex=-1,this.runtime.all_global_vars.push(this))}function n(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.include_sheet=null;this.include_sheet_name=c[1]}function p(){this.temp_parents_arr=[];this.reset(null);cr.seal(this)}var q=[];d.prototype.toString=function(){return this.name};d.prototype.init_event=function(a,b,c){switch(a[0]){case 0:a=new cr.eventblock(this,b,a);cr.seal(a);if(a.orblock)for(c.push(a),c=0,b=a.conditions.length;c<b;c++)a.conditions[c].trigger&&
this.init_trigger(a,c);else a.is_trigger()?this.init_trigger(a,0):c.push(a);break;case 1:a=new cr.eventvariable(this,b,a);cr.seal(a);c.push(a);break;case 2:a=new cr.eventinclude(this,b,a),cr.seal(a),c.push(a)}};d.prototype.postInit=function(){var a,b;a=0;for(b=this.events.length;a<b;a++)this.events[a].postInit(a<b-1&&this.events[a+1].is_else_block)};d.prototype.run=function(a){this.runtime.resuming_breakpoint||(this.hasRun=!0,a||(this.runtime.isRunningEvents=!0));var b,c;b=0;for(c=this.events.length;b<
c;b++){var d=this.events[b];d.run();this.runtime.clearSol(d.solModifiers);this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()}a||(this.runtime.isRunningEvents=!1)};d.prototype.init_trigger=function(a,b){a.orblock||this.runtime.triggers_to_postinit.push(a);var c,d,e=a.conditions[b],f;f=e.type?e.type.name:"system";var h=(c=e.fasttrigger)?this.fasttriggers:this.triggers;h[f]||(h[f]=[]);f=h[f];h=e.func;if(c){if(e.parameters.length&&(e=e.parameters[0],1===e.type&&
2===e.expression.type)){e=e.expression.value.toLowerCase();c=0;for(d=f.length;c<d;c++)if(f[c].method==h){c=f[c].evs;c[e]?c[e].push([a,b]):c[e]=[[a,b]];return}c={};c[e]=[[a,b]];f.push({method:h,evs:c})}}else{c=0;for(d=f.length;c<d;c++)if(f[c].method==h){f[c].evs.push([a,b]);return}f.push({method:h,evs:[[a,b]]})}};cr.eventsheet=d;e.prototype.hasObjects=function(){return this.select_all?this.type.instances.length:this.instances.length};e.prototype.getObjects=function(){return this.select_all?this.type.instances:
this.instances};e.prototype.pick_one=function(a){a&&(a.runtime.getCurrentEventStack().current_event.orblock?(this.select_all&&(this.instances.length=0,cr.shallowAssignArray(this.else_instances,a.type.instances),this.select_all=!1),a=this.else_instances.indexOf(a),-1!==a&&(this.instances.push(this.else_instances[a]),this.else_instances.splice(a,1))):(this.select_all=!1,this.instances.length=1,this.instances[0]=a))};cr.selection=e;window._c2hh_="DA39A3EE5E6B4B0D3255BFEF95601890AFD80709";g.prototype.postInit=
function(a){var b,d=this.parent;if(this.group)for(this.toplevelgroup=!0;d;){if(!d.group){this.toplevelgroup=!1;break}d=d.parent}this.toplevelevent=!this.is_trigger()&&(!this.parent||this.parent.group&&this.parent.toplevelgroup);this.has_else_block=!!a;this.solModifiersIncludingParents=this.solModifiers.slice(0);for(d=this.parent;d;){a=0;for(b=d.solModifiers.length;a<b;a++)this.addParentSolModifier(d.solModifiers[a]);d=d.parent}this.solModifiers=c(this.solModifiers);this.solModifiersIncludingParents=
c(this.solModifiersIncludingParents);a=0;for(b=this.conditions.length;a<b;a++)this.conditions[a].postInit();a=0;for(b=this.actions.length;a<b;a++)this.actions[a].postInit();a=0;for(b=this.subevents.length;a<b;a++)this.subevents[a].postInit(a<b-1&&this.subevents[a+1].is_else_block)};g.prototype.addSolModifier=function(a){f(a,this.solModifiers)};g.prototype.addParentSolModifier=function(a){f(a,this.solModifiersIncludingParents)};g.prototype.setSolWriterAfterCnds=function(){this.solWriterAfterCnds=!0;
this.parent&&this.parent.setSolWriterAfterCnds()};g.prototype.is_trigger=function(){return this.conditions.length?this.conditions[0].trigger:!1};g.prototype.run=function(){var a,b=!1,c,d=this.runtime.getCurrentEventStack();d.current_event=this;this.is_else_block||(d.else_branch_ran=!1);if(this.orblock){0===this.conditions.length&&(b=!0);d.cndindex=0;for(a=this.conditions.length;d.cndindex<a;d.cndindex++)this.conditions[d.cndindex].trigger||(c=this.conditions[d.cndindex].run())&&(b=!0);(d.last_event_true=
b)&&this.run_actions_and_subevents()}else{d.cndindex=0;for(a=this.conditions.length;d.cndindex<a;d.cndindex++)if(c=this.conditions[d.cndindex].run(),!c){d.last_event_true=!1;!this.toplevelevent||this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow();return}d.last_event_true=!0;this.run_actions_and_subevents()}this.end_run(d)};g.prototype.end_run=function(a){a.last_event_true&&this.has_else_block&&(a.else_branch_ran=!0);!this.toplevelevent||this.runtime.deathRow.isEmpty()&&
!this.runtime.createRow.length||this.runtime.ClearDeathRow()};g.prototype.run_orblocktrigger=function(a){this.runtime.getCurrentEventStack().current_event=this;this.conditions[a].run()&&(this.run_actions_and_subevents(),this.runtime.getCurrentEventStack().last_event_true=!0)};g.prototype.run_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;a.actindex=0;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};g.prototype.resume_actions_and_subevents=
function(){var a=this.runtime.getCurrentEventStack(),b;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};g.prototype.run_subevents=function(){if(this.subevents.length){var a,b,c,d,e=this.subevents.length-1;this.runtime.pushEventStack(this);if(this.solWriterAfterCnds)for(a=0,b=this.subevents.length;a<b;a++)c=this.subevents[a],(d=!this.toplevelgroup||!this.group&&a<e)&&this.runtime.pushCopySol(c.solModifiers),c.run(),d?this.runtime.popSol(c.solModifiers):
this.runtime.clearSol(c.solModifiers);else for(a=0,b=this.subevents.length;a<b;a++)this.subevents[a].run();this.runtime.popEventStack()}};g.prototype.run_pretrigger=function(){var a=this.runtime.getCurrentEventStack();a.current_event=this;var b=!1,c;a.cndindex=0;for(c=this.conditions.length;a.cndindex<c;a.cndindex++)if(this.conditions[a.cndindex].run())b=!0;else if(!this.orblock)return!1;return this.orblock?b:!0};g.prototype.retrigger=function(){this.runtime.execcount++;var a=this.runtime.getCurrentEventStack().cndindex,
b=this.runtime.pushEventStack(this);if(!this.orblock)for(b.cndindex=a+1,a=this.conditions.length;b.cndindex<a;b.cndindex++)if(!this.conditions[b.cndindex].run())return this.runtime.popEventStack(),!1;this.run_actions_and_subevents();this.runtime.popEventStack();return!0};g.prototype.isFirstConditionOfType=function(a){var b=a.index;if(0===b)return!0;for(--b;0<=b;--b)if(this.conditions[b].type===a.type)return!1;return!0};cr.eventblock=g;l.prototype.postInit=function(){var a,b;a=0;for(b=this.parameters.length;a<
b;a++)this.parameters[a].postInit()};l.prototype.run_true=function(){return!0};l.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return cr.xor(this.func.apply(this.runtime.system,this.results),this.inverted)};l.prototype.run_static=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get(a);a=this.func.apply(this.behaviortype?this.behaviortype:this.type,this.results);this.type.applySolToContainer();
return a};l.prototype.run_object=function(){var a,b,c,d,e,f,h,g=this.type.getCurrentSol(),k=this.block.orblock&&!this.trigger,m=0,l=this.type.is_contained;if(g.select_all){g.instances.length=0;a=g.else_instances.length=0;for(c=this.type.instances.length;a<c;a++){f=this.type.instances[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);-1<this.beh_index?(this.type.is_family&&(m=f.type.family_beh_map[this.type.family_index]),b=this.func.apply(f.behavior_insts[this.beh_index+
m],this.results)):b=this.func.apply(f,this.results);(e=cr.xor(b,this.inverted))?g.instances.push(f):k&&g.else_instances.push(f)}this.type.finish&&this.type.finish(!0);g.select_all=!1;this.type.applySolToContainer();return g.hasObjects()}var n=0,q=(e=k&&!this.block.isFirstConditionOfType(this))?g.else_instances:g.instances,r=!1;a=0;for(c=q.length;a<c;a++){f=q[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);-1<this.beh_index?(this.type.is_family&&(m=f.type.family_beh_map[this.type.family_index]),
b=this.func.apply(f.behavior_insts[this.beh_index+m],this.results)):b=this.func.apply(f,this.results);if(cr.xor(b,this.inverted))if(r=!0,e){if(g.instances.push(f),l)for(b=0,d=f.siblings.length;b<d;b++)h=f.siblings[b],h.type.getCurrentSol().instances.push(h)}else{q[n]=f;if(l)for(b=0,d=f.siblings.length;b<d;b++)h=f.siblings[b],h.type.getCurrentSol().instances[n]=h;n++}else if(e){q[n]=f;if(l)for(b=0,d=f.siblings.length;b<d;b++)h=f.siblings[b],h.type.getCurrentSol().else_instances[n]=h;n++}else if(k&&
(g.else_instances.push(f),l))for(b=0,d=f.siblings.length;b<d;b++)h=f.siblings[b],h.type.getCurrentSol().else_instances.push(h)}q.length=n;if(l)for(a=0,c=this.type.container.length;a<c;a++)f=this.type.container[a].getCurrentSol(),e?f.else_instances.length=n:f.instances.length=n;m=r;if(e&&!r)for(a=0,c=g.instances.length;a<c;a++){f=g.instances[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);b=-1<this.beh_index?this.func.apply(f.behavior_insts[this.beh_index],this.results):
this.func.apply(f,this.results);if(cr.xor(b,this.inverted)){r=!0;break}}this.type.finish&&this.type.finish(m||k);return k?r:g.hasObjects()};cr.condition=l;k.prototype.postInit=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()};k.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return this.func.apply(this.runtime.system,this.results)};k.prototype.run_object=function(){var a=this.type.getCurrentSol().getObjects(),
b,c,d,e,f;b=0;for(d=a.length;b<d;b++){f=a[b];c=0;for(e=this.parameters.length;c<e;c++)this.results[c]=this.parameters[c].get(b);-1<this.beh_index?(c=0,this.type.is_family&&(c=f.type.family_beh_map[this.type.family_index]),this.func.apply(f.behavior_insts[this.beh_index+c],this.results)):this.func.apply(f,this.results)}return!1};cr.action=k;var r=[],t=-1;h.prototype.postInit=function(){var a,b;if(11===this.type)this.eventvar=this.runtime.getEventVariableByName(this.varname,this.block.parent);else if(13===
this.type)for(a=0,b=this.subparams.length;a<b;a++)this.subparams[a].postInit();this.expression&&this.expression.postInit()};h.prototype.pushTempValue=function(){t++;r.length===t&&r.push(new cr.expvalue);return r[t]};h.prototype.popTempValue=function(){t--};h.prototype.get_exp=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.data};h.prototype.get_exp_str=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();
return cr.is_string(a.data)?a.data:""};h.prototype.get_object=function(){return this.object};h.prototype.get_combosel=function(){return this.combosel};h.prototype.get_layer=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.is_number()?this.runtime.getLayerByNumber(a.data):this.runtime.getLayerByName(a.data)};h.prototype.get_layout=function(){return this.layout};h.prototype.get_key=function(){return this.key};h.prototype.get_instvar=function(){return this.index};
h.prototype.get_familyvar=function(a){var b=this.owner.type,c=null,c=b.getCurrentSol(),d=c.getObjects(),c=d.length?d[a%d.length].type:c.else_instances[a%c.else_instances.length].type;return this.index+c.family_var_map[b.family_index]};h.prototype.get_eventvar=function(){return this.eventvar};h.prototype.get_audiofile=function(){return this.fileinfo};h.prototype.get_variadic=function(){var a,b;a=0;for(b=this.subparams.length;a<b;a++)this.variadicret[a]=this.subparams[a].get();return this.variadicret};
cr.parameter=h;m.prototype.postInit=function(){this.solModifiers=c(this.solModifiers)};m.prototype.setValue=function(a){var b=this.runtime.getCurrentLocalVarStack();this.parent&&!this.is_static&&b?(this.localIndex>=b.length&&(b.length=this.localIndex+1),b[this.localIndex]=a):this.data=a};m.prototype.getValue=function(){var a=this.runtime.getCurrentLocalVarStack();return!this.parent||this.is_static||!a||this.is_constant?this.data:this.localIndex>=a.length||"undefined"===typeof a[this.localIndex]?this.initial:
a[this.localIndex]};m.prototype.run=function(){!this.parent||this.is_static||this.is_constant||this.setValue(this.initial)};cr.eventvariable=m;n.prototype.toString=function(){return"include:"+this.include_sheet.toString()};n.prototype.postInit=function(){this.include_sheet=this.runtime.eventsheets[this.include_sheet_name];this.sheet.includes.add(this);this.solModifiers=c(this.solModifiers)};n.prototype.run=function(){this.parent&&this.runtime.pushCleanSol(this.runtime.types_by_index);this.include_sheet.hasRun||
this.include_sheet.run(!0);this.parent&&this.runtime.popSol(this.runtime.types_by_index)};n.prototype.isActive=function(){for(var a=this.parent;a;){if(a.group&&!this.runtime.activeGroups[a.group_name.toLowerCase()])return!1;a=a.parent}return!0};cr.eventinclude=n;p.prototype.reset=function(a){this.current_event=a;this.actindex=this.cndindex=0;this.temp_parents_arr.length=0;this.any_true_state=this.else_branch_ran=this.last_event_true=!1};p.prototype.isModifierAfterCnds=function(){return this.current_event.solWriterAfterCnds?
!0:this.cndindex<this.current_event.conditions.length-1?!!this.current_event.solModifiers.length:!1};cr.eventStackFrame=p})();
(function(){function a(a,b){this.owner=a;this.runtime=a.runtime;this.type=b[0];this.get=[this.eval_int,this.eval_float,this.eval_string,this.eval_unaryminus,this.eval_add,this.eval_subtract,this.eval_multiply,this.eval_divide,this.eval_mod,this.eval_power,this.eval_and,this.eval_or,this.eval_equal,this.eval_notequal,this.eval_less,this.eval_lessequal,this.eval_greater,this.eval_greaterequal,this.eval_conditional,this.eval_system_exp,this.eval_object_behavior_exp,this.eval_instvar_exp,this.eval_object_behavior_exp,
this.eval_eventvar_exp][this.type];var e=null;this.object_type=this.parameters=this.results=this.func=this.third=this.second=this.first=this.value=null;this.beh_index=-1;this.instance_expr=null;this.varindex=-1;this.eventvar=this.varname=this.behavior_type=null;this.return_string=!1;switch(this.type){case 0:case 1:case 2:this.value=b[1];break;case 3:this.first=new cr.expNode(a,b[1]);break;case 18:this.first=new cr.expNode(a,b[1]);this.second=new cr.expNode(a,b[2]);this.third=new cr.expNode(a,b[3]);
break;case 19:this.func=b[1];this.results=[];this.parameters=[];3===b.length?(e=b[2],this.results.length=e.length+1):this.results.length=1;break;case 20:this.object_type=this.runtime.types_by_index[b[1]];this.beh_index=-1;this.func=b[2];this.return_string=b[3];this.instance_expr=b[4]?new cr.expNode(a,b[4]):null;this.results=[];this.parameters=[];6===b.length?(e=b[5],this.results.length=e.length+1):this.results.length=1;break;case 21:this.object_type=this.runtime.types_by_index[b[1]];this.return_string=
b[2];this.instance_expr=b[3]?new cr.expNode(a,b[3]):null;this.varindex=b[4];break;case 22:this.object_type=this.runtime.types_by_index[b[1]];this.behavior_type=this.object_type.getBehaviorByName(b[2]);this.beh_index=this.object_type.getBehaviorIndexByName(b[2]);this.func=b[3];this.return_string=b[4];this.instance_expr=b[5]?new cr.expNode(a,b[5]):null;this.results=[];this.parameters=[];7===b.length?(e=b[6],this.results.length=e.length+1):this.results.length=1;break;case 23:this.varname=b[1],this.eventvar=
null}4<=this.type&&17>=this.type&&(this.first=new cr.expNode(a,b[1]),this.second=new cr.expNode(a,b[2]));if(e){var g,f;g=0;for(f=e.length;g<f;g++)this.parameters.push(new cr.expNode(a,e[g]))}cr.seal(this)}function b(a,b){this.type=a||cr.exptype.Integer;this.data=b||0;this.object_class=null;this.type==cr.exptype.Integer&&(this.data=Math.floor(this.data));cr.seal(this)}a.prototype.postInit=function(){23===this.type&&(this.eventvar=this.owner.runtime.getEventVariableByName(this.varname,this.owner.block.parent));
this.first&&this.first.postInit();this.second&&this.second.postInit();this.third&&this.third.postInit();this.instance_expr&&this.instance_expr.postInit();if(this.parameters){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()}};a.prototype.eval_system_exp=function(a){this.results[0]=a;a=this.owner.pushTempValue();var b,e;b=0;for(e=this.parameters.length;b<e;b++)this.parameters[b].get(a),this.results[b+1]=a.data;this.owner.popTempValue();this.func.apply(this.runtime.system,
this.results)};a.prototype.eval_object_behavior_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}this.results[0]=a;a.object_class=this.object_type;a=this.owner.pushTempValue();var g,b=0;for(g=this.parameters.length;b<g;b++)this.parameters[b].get(a),this.results[b+1]=a.data;b=this.owner.solindex;this.instance_expr&&(this.instance_expr.get(a),a.is_number()&&
(b=a.data,e=this.object_type.instances));this.owner.popTempValue();b%=e.length;0>b&&(b+=e.length);e=e[b];-1<this.beh_index?(a=0,this.object_type.is_family&&(a=e.type.family_beh_map[this.object_type.family_index]),this.func.apply(e.behavior_insts[this.beh_index+a],this.results)):this.func.apply(e,this.results)};a.prototype.eval_instvar_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):
a.set_int(0);return}b=this.owner.solindex;if(this.instance_expr){var g=this.owner.pushTempValue();this.instance_expr.get(g);if(g.is_number()){b=g.data;e=this.object_type.instances;b%=e.length;0>b&&(b+=e.length);e=e[b].instance_vars[this.varindex];cr.is_string(e)?a.set_string(e):a.set_float(e);this.owner.popTempValue();return}this.owner.popTempValue()}b%=e.length;0>b&&(b+=e.length);e=e[b];b=0;this.object_type.is_family&&(b=e.type.family_var_map[this.object_type.family_index]);e=e.instance_vars[this.varindex+
b];cr.is_string(e)?a.set_string(e):a.set_float(e)};a.prototype.eval_int=function(a){a.type=cr.exptype.Integer;a.data=this.value};a.prototype.eval_float=function(a){a.type=cr.exptype.Float;a.data=this.value};a.prototype.eval_string=function(a){a.type=cr.exptype.String;a.data=this.value};a.prototype.eval_unaryminus=function(a){this.first.get(a);a.is_number()&&(a.data=-a.data)};a.prototype.eval_add=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&
(a.data+=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_subtract=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data-=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_multiply=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data*=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_divide=
function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data/=b.data,a.make_float());this.owner.popTempValue()};a.prototype.eval_mod=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data%=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_power=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&
(a.data=Math.pow(a.data,b.data),b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_and=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()?b.is_string()?a.set_string(a.data.toString()+b.data):a.data&&b.data?a.set_int(1):a.set_int(0):a.is_string()&&(b.is_string()?a.data+=b.data:a.data+=(Math.round(1E10*b.data)/1E10).toString());this.owner.popTempValue()};a.prototype.eval_or=function(a){this.first.get(a);var b=this.owner.pushTempValue();
this.second.get(b);a.is_number()&&b.is_number()&&(a.data||b.data?a.set_int(1):a.set_int(0));this.owner.popTempValue()};a.prototype.eval_conditional=function(a){this.first.get(a);a.data?this.second.get(a):this.third.get(a)};a.prototype.eval_equal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data===b.data?1:0);this.owner.popTempValue()};a.prototype.eval_notequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data!==
b.data?1:0);this.owner.popTempValue()};a.prototype.eval_less=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<b.data?1:0);this.owner.popTempValue()};a.prototype.eval_lessequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greater=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>b.data?1:0);
this.owner.popTempValue()};a.prototype.eval_greaterequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_eventvar_exp=function(a){var b=this.eventvar.getValue();cr.is_number(b)?a.set_float(b):a.set_string(b)};cr.expNode=a;b.prototype.is_int=function(){return this.type===cr.exptype.Integer};b.prototype.is_float=function(){return this.type===cr.exptype.Float};b.prototype.is_number=function(){return this.type===
cr.exptype.Integer||this.type===cr.exptype.Float};b.prototype.is_string=function(){return this.type===cr.exptype.String};b.prototype.make_int=function(){this.is_int()||(this.is_float()?this.data=Math.floor(this.data):this.is_string()&&(this.data=parseInt(this.data,10)),this.type=cr.exptype.Integer)};b.prototype.make_float=function(){this.is_float()||(this.is_string()&&(this.data=parseFloat(this.data)),this.type=cr.exptype.Float)};b.prototype.make_string=function(){this.is_string()||(this.data=this.data.toString(),
this.type=cr.exptype.String)};b.prototype.set_int=function(a){this.type=cr.exptype.Integer;this.data=Math.floor(a)};b.prototype.set_float=function(a){this.type=cr.exptype.Float;this.data=a};b.prototype.set_string=function(a){this.type=cr.exptype.String;this.data=a};b.prototype.set_any=function(a){cr.is_number(a)?(this.type=cr.exptype.Float,this.data=a):cr.is_string(a)?(this.type=cr.exptype.String,this.data=a.toString()):(this.type=cr.exptype.Integer,this.data=0)};cr.expvalue=b;cr.exptype={Integer:0,
Float:1,String:2}})();cr.system_object=function(a){this.runtime=a;this.waits=[]};
cr.system_object.prototype.saveToJSON=function(){var a={},b,c,d,e,g,f,l,k;a.waits=[];var h=a.waits,m;b=0;for(c=this.waits.length;b<c;b++){f=this.waits[b];m={t:f.time,ev:f.ev.sid,sm:[],sols:{}};f.ev.actions[f.actindex]&&(m.act=f.ev.actions[f.actindex].sid);d=0;for(e=f.solModifiers.length;d<e;d++)m.sm.push(f.solModifiers[d].sid);for(g in f.sols)if(f.sols.hasOwnProperty(g)){l=this.runtime.types_by_index[parseInt(g,10)];k={sa:f.sols[g].sa,insts:[]};d=0;for(e=f.sols[g].insts.length;d<e;d++)k.insts.push(f.sols[g].insts[d].uid);
m.sols[l.sid.toString()]=k}h.push(m)}return a};
cr.system_object.prototype.loadFromJSON=function(a){a=a.waits;var b,c,d,e,g,f,l,k,h,m,n;b=this.waits.length=0;for(c=a.length;b<c;b++)if(f=a[b],k=this.runtime.blocksBySid[f.ev.toString()]){h=-1;d=0;for(e=k.actions.length;d<e;d++)if(k.actions[d].sid===f.act){h=d;break}if(-1!==h){l={sols:{},solModifiers:[],deleteme:!1};l.time=f.t;l.ev=k;l.actindex=h;d=0;for(e=f.sm.length;d<e;d++)(k=this.runtime.getObjectTypeBySid(f.sm[d]))&&l.solModifiers.push(k);for(g in f.sols)if(f.sols.hasOwnProperty(g)&&(k=this.runtime.getObjectTypeBySid(parseInt(g,
10)))){h=f.sols[g];m={sa:h.sa,insts:[]};d=0;for(e=h.insts.length;d<e;d++)(n=this.runtime.getObjectByUID(h.insts[d]))&&m.insts.push(n);l.sols[k.index.toString()]=m}this.waits.push(l)}}};
(function(){function a(){}function b(a,b){var c=a.extra.c2_foreachordered_val,d=b.extra.c2_foreachordered_val;if(cr.is_number(c)&&cr.is_number(d))return c-d;c=""+c;d=""+d;return c<d?-1:c>d?1:0}function c(a,b){h&&a===m&&b===n||(h=RegExp(a,b),m=a,n=b);h.lastIndex=0;return h}function d(){}function e(){}function g(a,b,d){if(a!==s||b!==u||d!==A){var e=c(b,d);t=a.match(e);s=a;u=b;A=d}}var f=cr.system_object.prototype;a.prototype.EveryTick=function(){return!0};a.prototype.OnLayoutStart=function(){return!0};
a.prototype.OnLayoutEnd=function(){return!0};a.prototype.Compare=function(a,b,c){return cr.do_cmp(a,b,c)};a.prototype.CompareTime=function(a,b){var c=this.runtime.kahanTime.sum;if(0===a){var d=this.runtime.getCurrentCondition();return!d.extra.CompareTime_executed&&c>=b?d.extra.CompareTime_executed=!0:!1}return cr.do_cmp(c,a,b)};a.prototype.LayerVisible=function(a){return a?a.visible:!1};a.prototype.LayerCmpOpacity=function(a,b,c){return a?cr.do_cmp(100*a.opacity,b,c):!1};a.prototype.Repeat=function(a){var b=
this.runtime.getCurrentEventStack(),c=b.current_event,d=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(d)for(d=0;d<a&&!b.stopped;d++)this.runtime.pushCopySol(c.solModifiers),b.index=d,c.retrigger(),this.runtime.popSol(c.solModifiers);else for(d=0;d<a&&!b.stopped;d++)b.index=d,c.retrigger();this.runtime.popLoopStack();return!1};a.prototype.While=function(a){var b=this.runtime.getCurrentEventStack();a=b.current_event;var c=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(c)for(c=
0;!b.stopped;c++)this.runtime.pushCopySol(a.solModifiers),b.index=c,a.retrigger()||(b.stopped=!0),this.runtime.popSol(a.solModifiers);else for(c=0;!b.stopped;c++)b.index=c,a.retrigger()||(b.stopped=!0);this.runtime.popLoopStack();return!1};a.prototype.For=function(a,b,c){var d=this.runtime.getCurrentEventStack(),e=d.current_event,d=d.isModifierAfterCnds();a=this.runtime.pushLoopStack(a);if(c<b)if(d)for(;b>=c&&!a.stopped;--b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);
else for(;b>=c&&!a.stopped;--b)a.index=b,e.retrigger();else if(d)for(;b<=c&&!a.stopped;++b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);else for(;b<=c&&!a.stopped;++b)a.index=b,e.retrigger();this.runtime.popLoopStack();return!1};var l=[],k=-1;a.prototype.ForEach=function(a){var b=a.getCurrentSol();k++;l.length===k&&l.push([]);var c=l[k];cr.shallowAssignArray(c,b.getObjects());var d=this.runtime.getCurrentEventStack(),e=d.current_event,f=d.isModifierAfterCnds(),
d=this.runtime.pushLoopStack(),h,g,m,n,q,r,t=a.is_contained;if(f)for(f=0,h=c.length;f<h&&!d.stopped;f++){this.runtime.pushCopySol(e.solModifiers);n=c[f];b=a.getCurrentSol();b.select_all=!1;b.instances.length=1;b.instances[0]=n;if(t)for(g=0,m=n.siblings.length;g<m;g++)q=n.siblings[g],r=q.type.getCurrentSol(),r.select_all=!1,r.instances.length=1,r.instances[0]=q;d.index=f;e.retrigger();this.runtime.popSol(e.solModifiers)}else for(b.select_all=!1,b.instances.length=1,f=0,h=c.length;f<h&&!d.stopped;f++){n=
c[f];b.instances[0]=n;if(t)for(g=0,m=n.siblings.length;g<m;g++)q=n.siblings[g],r=q.type.getCurrentSol(),r.select_all=!1,r.instances.length=1,r.instances[0]=q;d.index=f;e.retrigger()}c.length=0;this.runtime.popLoopStack();k--;return!1};a.prototype.ForEachOrdered=function(a,c,d){c=a.getCurrentSol();k++;l.length===k&&l.push([]);var e=l[k];cr.shallowAssignArray(e,c.getObjects());var f=this.runtime.getCurrentEventStack(),h=f.current_event,g=this.runtime.getCurrentCondition(),m=f.isModifierAfterCnds(),
f=this.runtime.pushLoopStack(),n,q,r,t,p;n=0;for(q=e.length;n<q;n++)e[n].extra.c2_foreachordered_val=g.parameters[1].get(n);e.sort(b);1===d&&e.reverse();d=a.is_contained;if(m)for(n=0,q=e.length;n<q&&!f.stopped;n++){this.runtime.pushCopySol(h.solModifiers);r=e[n];c=a.getCurrentSol();c.select_all=!1;c.instances.length=1;c.instances[0]=r;if(d)for(g=0,m=r.siblings.length;g<m;g++)t=r.siblings[g],p=t.type.getCurrentSol(),p.select_all=!1,p.instances.length=1,p.instances[0]=t;f.index=n;h.retrigger();this.runtime.popSol(h.solModifiers)}else for(c.select_all=
!1,c.instances.length=1,n=0,q=e.length;n<q&&!f.stopped;n++){r=e[n];c.instances[0]=r;if(d)for(g=0,m=r.siblings.length;g<m;g++)t=r.siblings[g],p=t.type.getCurrentSol(),p.select_all=!1,p.instances.length=1,p.instances[0]=t;f.index=n;h.retrigger()}e.length=0;this.runtime.popLoopStack();k--;return!1};a.prototype.PickByComparison=function(a,b,c,d){var e,f,h,g;if(a){k++;l.length===k&&l.push([]);var m=l[k],n=a.getCurrentSol();cr.shallowAssignArray(m,n.getObjects());n.select_all&&(n.else_instances.length=
0);var q=this.runtime.getCurrentCondition();h=e=0;for(f=m.length;e<f;e++)g=m[e],m[h]=g,b=q.parameters[1].get(e),d=q.parameters[3].get(e),cr.do_cmp(b,c,d)?h++:n.else_instances.push(g);m.length=h;n.select_all=!1;cr.shallowAssignArray(n.instances,m);m.length=0;k--;a.applySolToContainer();return!!n.instances.length}};a.prototype.PickByEvaluate=function(a,b){var c,d,e,f;if(a){k++;l.length===k&&l.push([]);var h=l[k],g=a.getCurrentSol();cr.shallowAssignArray(h,g.getObjects());g.select_all&&(g.else_instances.length=
0);var m=this.runtime.getCurrentCondition();e=c=0;for(d=h.length;c<d;c++)f=h[c],h[e]=f,(b=m.parameters[1].get(c))?e++:g.else_instances.push(f);h.length=e;g.select_all=!1;cr.shallowAssignArray(g.instances,h);h.length=0;k--;a.applySolToContainer();return!!g.instances.length}};a.prototype.TriggerOnce=function(){var a=this.runtime.getCurrentCondition().extra;"undefined"===typeof a.TriggerOnce_lastTick&&(a.TriggerOnce_lastTick=-1);var b=a.TriggerOnce_lastTick,c=this.runtime.tickcount;a.TriggerOnce_lastTick=
c;return this.runtime.layout_first_tick||b!==c-1};a.prototype.Every=function(a){var b=this.runtime.getCurrentCondition(),c=b.extra.Every_lastTime||0,d=this.runtime.kahanTime.sum;"undefined"===typeof b.extra.Every_seconds&&(b.extra.Every_seconds=a);var e=b.extra.Every_seconds;return d>=c+e?(b.extra.Every_lastTime=c+e,d>=b.extra.Every_lastTime+0.04&&(b.extra.Every_lastTime=d),b.extra.Every_seconds=a,!0):!1};a.prototype.PickNth=function(a,b){if(!a)return!1;var c=a.getCurrentSol(),d=c.getObjects();b=
cr.floor(b);if(0>b||b>=d.length)return!1;c.pick_one(d[b]);a.applySolToContainer();return!0};a.prototype.PickRandom=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d=cr.floor(Math.random()*c.length);if(d>=c.length)return!1;b.pick_one(c[d]);a.applySolToContainer();return!0};a.prototype.CompareVar=function(a,b,c){return cr.do_cmp(a.getValue(),b,c)};a.prototype.IsGroupActive=function(a){return this.runtime.activeGroups[a.toLowerCase()]};a.prototype.IsPreview=function(){return"undefined"!==
typeof cr_is_preview};a.prototype.PickAll=function(a){if(!a||!a.instances.length)return!1;a.getCurrentSol().select_all=!0;a.applySolToContainer();return!0};a.prototype.IsMobile=function(){return this.runtime.isMobile};a.prototype.CompareBetween=function(a,b,c){return a>=b&&a<=c};a.prototype.Else=function(){var a=this.runtime.getCurrentEventStack();return a.else_branch_ran?!1:!a.last_event_true};a.prototype.OnLoadFinished=function(){return!0};a.prototype.OnCanvasSnapshot=function(){return!0};a.prototype.EffectsSupported=
function(){return!!this.runtime.glwrap};a.prototype.OnSaveComplete=function(){return!0};a.prototype.OnLoadComplete=function(){return!0};a.prototype.OnLoadFailed=function(){return!0};a.prototype.ObjectUIDExists=function(a){return!!this.runtime.getObjectByUID(a)};a.prototype.IsOnPlatform=function(a){var b=this.runtime;switch(a){case 0:return!b.isDomFree&&!b.isNodeWebkit&&!b.isPhoneGap&&!b.isCrosswalk&&!b.isWindows8App&&!b.isWindowsPhone8&&!b.isBlackberry10&&!b.isAmazonWebApp;case 1:return b.isiOS;case 2:return b.isAndroid;
case 3:return b.isWindows8App;case 4:return b.isWindowsPhone8;case 5:return b.isBlackberry10;case 6:return b.isTizen;case 7:return b.isCocoonJs;case 8:return b.isPhoneGap;case 9:return b.isArcade;case 10:return b.isNodeWebkit;case 11:return b.isCrosswalk;case 12:return b.isAmazonWebApp;default:return!1}};var h=null,m="",n="";a.prototype.RegexTest=function(a,b,d){return c(b,d).test(a)};var p=[];a.prototype.PickOverlappingPoint=function(a,b,c){if(!a)return!1;var d=a.getCurrentSol(),e=d.getObjects(),
f=this.runtime.getCurrentEventStack().current_event.orblock,h=this.runtime.getCurrentCondition(),g,k;d.select_all?(cr.shallowAssignArray(p,e),d.else_instances.length=0,d.select_all=!1,d.instances.length=0):f?(cr.shallowAssignArray(p,d.else_instances),d.else_instances.length=0):(cr.shallowAssignArray(p,e),d.instances.length=0);e=0;for(f=p.length;e<f;++e)g=p[e],(k=cr.xor(g.contains_pt(b,c),h.inverted))?d.instances.push(g):d.else_instances.push(g);a.applySolToContainer();return cr.xor(!!d.instances.length,
h.inverted)};f.cnds=new a;d.prototype.GoToLayout=function(a){this.runtime.isloading||this.runtime.changelayout||(this.runtime.changelayout=a)};d.prototype.CreateObject=function(a,b,c,d){if(b&&a&&(b=this.runtime.createInstance(a,b,c,d))){this.runtime.isInOnDestroy++;var e;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],this.runtime.trigger(Object.getPrototypeOf(e.type.plugin).cnds.OnCreated,e);this.runtime.isInOnDestroy--;
a=a.getCurrentSol();a.select_all=!1;a.instances.length=1;a.instances[0]=b;if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],a=e.type.getCurrentSol(),a.select_all=!1,a.instances.length=1,a.instances[0]=e}};d.prototype.SetLayerVisible=function(a,b){a&&a.visible!==b&&(a.visible=b,this.runtime.redraw=!0)};d.prototype.SetLayerOpacity=function(a,b){a&&(b=cr.clamp(b/100,0,1),a.opacity!==b&&(a.opacity=b,this.runtime.redraw=!0))};d.prototype.SetLayerScaleRate=function(a,b){a&&a.zoomRate!==
b&&(a.zoomRate=b,this.runtime.redraw=!0)};d.prototype.SetLayoutScale=function(a){this.runtime.running_layout&&this.runtime.running_layout.scale!==a&&(this.runtime.running_layout.scale=a,this.runtime.running_layout.boundScrolling(),this.runtime.redraw=!0)};d.prototype.ScrollX=function(a){this.runtime.running_layout.scrollToX(a)};d.prototype.ScrollY=function(a){this.runtime.running_layout.scrollToY(a)};d.prototype.Scroll=function(a,b){this.runtime.running_layout.scrollToX(a);this.runtime.running_layout.scrollToY(b)};
d.prototype.ScrollToObject=function(a){if(a=a.getFirstPicked())this.runtime.running_layout.scrollToX(a.x),this.runtime.running_layout.scrollToY(a.y)};d.prototype.SetVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(b):a.setValue(parseFloat(b)):1===a.vartype&&a.setValue(b.toString())};d.prototype.AddVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(a.getValue()+b):a.setValue(a.getValue()+parseFloat(b)):1===a.vartype&&a.setValue(a.getValue()+b.toString())};d.prototype.SubVar=function(a,
b){0===a.vartype&&(cr.is_number(b)?a.setValue(a.getValue()-b):a.setValue(a.getValue()-parseFloat(b)))};d.prototype.SetGroupActive=function(a,b){var c=this.runtime.activeGroups,d=a.toLowerCase();switch(b){case 0:c[d]=!1;break;case 1:c[d]=!0;break;case 2:c[d]=!c[d]}};d.prototype.SetTimescale=function(a){0>a&&(a=0);this.runtime.timescale=a};d.prototype.SetObjectTimescale=function(a,b){var c=b;0>c&&(c=0);if(a){var d=a.getCurrentSol().getObjects(),e,f;e=0;for(f=d.length;e<f;e++)d[e].my_timescale=c}};d.prototype.RestoreObjectTimescale=
function(a){if(!a)return!1;a=a.getCurrentSol().getObjects();var b,c;b=0;for(c=a.length;b<c;b++)a[b].my_timescale=-1};var q=[],r=[];d.prototype.Wait=function(a){if(!(0>a)){var b,c,d,e=this.runtime.getCurrentEventStack(),f;f=q.length?q.pop():{sols:{},solModifiers:[]};f.deleteme=!1;f.time=this.runtime.kahanTime.sum+a;f.ev=e.current_event;f.actindex=e.actindex+1;a=0;for(b=this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===e.current_event.solModifiers.indexOf(d)||
(f.solModifiers.push(d),d=void 0,d=r.length?r.pop():{insts:[]},d.sa=!1,d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),f.sols[a.toString()]=d);this.waits.push(f);return!0}};d.prototype.SetLayerScale=function(a,b){a&&a.scale!==b&&(a.scale=b,this.runtime.redraw=!0)};d.prototype.ResetGlobals=function(){var a,b,c;a=0;for(b=this.runtime.all_global_vars.length;a<b;a++)c=this.runtime.all_global_vars[a],c.data=c.initial};d.prototype.SetLayoutAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);
this.runtime.running_layout&&this.runtime.running_layout.angle!==a&&(this.runtime.running_layout.angle=a,this.runtime.redraw=!0)};d.prototype.SetLayerAngle=function(a,b){a&&(b=cr.to_radians(b),b=cr.clamp_angle(b),a.angle!==b&&(a.angle=b,this.runtime.redraw=!0))};d.prototype.SetLayerParallax=function(a,b,c){if(a&&(a.parallaxX!==b/100||a.parallaxY!==c/100)){a.parallaxX=b/100;a.parallaxY=c/100;if(1!==a.parallaxX||1!==a.parallaxY)for(c=a.instances,a=0,b=c.length;a<b;++a)c[a].type.any_instance_parallaxed=
!0;this.runtime.redraw=!0}};d.prototype.SetLayerBackground=function(a,b){if(a){var c=cr.GetRValue(b),d=cr.GetGValue(b),e=cr.GetBValue(b);if(a.background_color[0]!==c||a.background_color[1]!==d||a.background_color[2]!==e)a.background_color[0]=c,a.background_color[1]=d,a.background_color[2]=e,this.runtime.redraw=!0}};d.prototype.SetLayerTransparent=function(a,b){a&&!!b!==!!a.transparent&&(a.transparent=!!b,this.runtime.redraw=!0)};d.prototype.StopLoop=function(){0>this.runtime.loop_stack_index||(this.runtime.getCurrentLoop().stopped=
!0)};d.prototype.GoToLayoutByName=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout)for(var b in this.runtime.layouts)if(this.runtime.layouts.hasOwnProperty(b)&&cr.equals_nocase(b,a)){this.runtime.changelayout=this.runtime.layouts[b];break}};d.prototype.RestartLayout=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout&&this.runtime.running_layout){this.runtime.changelayout=this.runtime.running_layout;var b,c;a=0;for(b=this.runtime.allGroups.length;a<b;a++)c=this.runtime.allGroups[a],
this.runtime.activeGroups[c.group_name.toLowerCase()]=c.initially_activated}};d.prototype.SnapshotCanvas=function(a,b){this.runtime.snapshotCanvas=[0===a?"image/png":"image/jpeg",b/100];this.runtime.redraw=!0};d.prototype.SetCanvasSize=function(a,b){if(!(0>=a||0>=b)){var c=this.runtime.fullscreen_mode;(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.runtime.isNodeFullscreen)&&0<this.runtime.fullscreen_scaling&&(c=this.runtime.fullscreen_scaling);
0===c?this.runtime.setSize(a,b,!0):(this.runtime.original_width=a,this.runtime.original_height=b,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0))}};d.prototype.SetLayoutEffectEnabled=function(a,b){if(this.runtime.running_layout&&this.runtime.glwrap){var c=this.runtime.running_layout.getEffectByName(b);if(c){var d=1===a;c.active!=d&&(c.active=d,this.runtime.running_layout.updateActiveEffects(),this.runtime.redraw=!0)}}};d.prototype.SetLayerEffectEnabled=function(a,
b,c){a&&this.runtime.glwrap&&(c=a.getEffectByName(c))&&(b=1===b,c.active!=b&&(c.active=b,a.updateActiveEffects(),this.runtime.redraw=!0))};d.prototype.SetLayoutEffectParam=function(a,b,c){if(this.runtime.running_layout&&this.runtime.glwrap&&(a=this.runtime.running_layout.getEffectByName(a))){var d=this.runtime.running_layout.effect_params[a.index];b=Math.floor(b);0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=
!0)))}};d.prototype.SetLayerEffectParam=function(a,b,c,d){a&&this.runtime.glwrap&&(b=a.getEffectByName(b))&&(a=a.effect_params[b.index],c=Math.floor(c),0>c||c>=a.length||(1===this.runtime.glwrap.getProgramParameterType(b.shaderindex,c)&&(d/=100),a[c]!==d&&(a[c]=d,b.active&&(this.runtime.redraw=!0))))};d.prototype.SaveState=function(a){this.runtime.saveToSlot=a};d.prototype.LoadState=function(a){this.runtime.loadFromSlot=a};d.prototype.LoadStateJSON=function(a){this.runtime.loadFromJson=a};d.prototype.SetHalfFramerateMode=
function(a){this.runtime.halfFramerateMode=0!==a};d.prototype.SetFullscreenQuality=function(a){if(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen||0!==this.runtime.fullscreen_mode)this.runtime.wantFullscreenScalingQuality=0!==a,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0)};f.acts=new d;e.prototype["int"]=function(a,b){cr.is_string(b)?(a.set_int(parseInt(b,10)),isNaN(a.data)&&(a.data=
0)):a.set_int(b)};e.prototype["float"]=function(a,b){cr.is_string(b)?(a.set_float(parseFloat(b)),isNaN(a.data)&&(a.data=0)):a.set_float(b)};e.prototype.str=function(a,b){cr.is_string(b)?a.set_string(b):a.set_string(b.toString())};e.prototype.len=function(a,b){a.set_int(b.length||0)};e.prototype.random=function(a,b,c){void 0===c?a.set_float(Math.random()*b):a.set_float(Math.random()*(c-b)+b)};e.prototype.sqrt=function(a,b){a.set_float(Math.sqrt(b))};e.prototype.abs=function(a,b){a.set_float(Math.abs(b))};
e.prototype.round=function(a,b){a.set_int(Math.round(b))};e.prototype.floor=function(a,b){a.set_int(Math.floor(b))};e.prototype.ceil=function(a,b){a.set_int(Math.ceil(b))};e.prototype.sin=function(a,b){a.set_float(Math.sin(cr.to_radians(b)))};e.prototype.cos=function(a,b){a.set_float(Math.cos(cr.to_radians(b)))};e.prototype.tan=function(a,b){a.set_float(Math.tan(cr.to_radians(b)))};e.prototype.asin=function(a,b){a.set_float(cr.to_degrees(Math.asin(b)))};e.prototype.acos=function(a,b){a.set_float(cr.to_degrees(Math.acos(b)))};
e.prototype.atan=function(a,b){a.set_float(cr.to_degrees(Math.atan(b)))};e.prototype.exp=function(a,b){a.set_float(Math.exp(b))};e.prototype.ln=function(a,b){a.set_float(Math.log(b))};e.prototype.log10=function(a,b){a.set_float(Math.log(b)/Math.LN10)};e.prototype.max=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b<arguments[c]&&(b=arguments[c]);a.set_float(b)};e.prototype.min=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b>arguments[c]&&(b=arguments[c]);
a.set_float(b)};e.prototype.dt=function(a){a.set_float(this.runtime.dt)};e.prototype.timescale=function(a){a.set_float(this.runtime.timescale)};e.prototype.wallclocktime=function(a){a.set_float((Date.now()-this.runtime.start_time)/1E3)};e.prototype.time=function(a){a.set_float(this.runtime.kahanTime.sum)};e.prototype.tickcount=function(a){a.set_int(this.runtime.tickcount)};e.prototype.objectcount=function(a){a.set_int(this.runtime.objectcount)};e.prototype.fps=function(a){a.set_int(this.runtime.fps)};
e.prototype.loopindex=function(a,b){var c,d,e;if(this.runtime.loop_stack.length)if(b){d=0;for(e=this.runtime.loop_stack.length;d<e;d++)if(c=this.runtime.loop_stack[d],c.name===b){a.set_int(c.index);return}a.set_int(0)}else c=this.runtime.getCurrentLoop(),a.set_int(c?c.index:-1);else a.set_int(0)};e.prototype.distance=function(a,b,c,d,e){a.set_float(cr.distanceTo(b,c,d,e))};e.prototype.angle=function(a,b,c,d,e){a.set_float(cr.to_degrees(cr.angleTo(b,c,d,e)))};e.prototype.scrollx=function(a){a.set_float(this.runtime.running_layout.scrollX)};
e.prototype.scrolly=function(a){a.set_float(this.runtime.running_layout.scrollY)};e.prototype.newline=function(a){a.set_string("\n")};e.prototype.lerp=function(a,b,c,d){a.set_float(cr.lerp(b,c,d))};e.prototype.windowwidth=function(a){a.set_int(this.runtime.width)};e.prototype.windowheight=function(a){a.set_int(this.runtime.height)};e.prototype.uppercase=function(a,b){a.set_string(cr.is_string(b)?b.toUpperCase():"")};e.prototype.lowercase=function(a,b){a.set_string(cr.is_string(b)?b.toLowerCase():
"")};e.prototype.clamp=function(a,b,c,d){b<c?a.set_float(c):b>d?a.set_float(d):a.set_float(b)};e.prototype.layerscale=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.scale):a.set_float(0)};e.prototype.layeropacity=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.opacity):a.set_float(0)};e.prototype.layerscalerate=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.zoomRate):a.set_float(0)};e.prototype.layerparallaxx=function(a,b){var c=this.runtime.getLayer(b);
c?a.set_float(100*c.parallaxX):a.set_float(0)};e.prototype.layerparallaxy=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxY):a.set_float(0)};e.prototype.layoutscale=function(a){this.runtime.running_layout?a.set_float(this.runtime.running_layout.scale):a.set_float(0)};e.prototype.layoutangle=function(a){a.set_float(cr.to_degrees(this.runtime.running_layout.angle))};e.prototype.layerangle=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(cr.to_degrees(c.angle)):a.set_float(0)};
e.prototype.layoutwidth=function(a){a.set_int(this.runtime.running_layout.width)};e.prototype.layoutheight=function(a){a.set_int(this.runtime.running_layout.height)};e.prototype.find=function(a,b,c){cr.is_string(b)&&cr.is_string(c)?a.set_int(b.search(RegExp(cr.regexp_escape(c),"i"))):a.set_int(-1)};e.prototype.left=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(0,c):"")};e.prototype.right=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(b.length-c):"")};e.prototype.mid=function(a,b,c,
d){a.set_string(cr.is_string(b)?b.substr(c,d):"")};e.prototype.tokenat=function(a,b,c,d){cr.is_string(b)&&cr.is_string(d)?(b=b.split(d),c=cr.floor(c),0>c||c>=b.length?a.set_string(""):a.set_string(b[c])):a.set_string("")};e.prototype.tokencount=function(a,b,c){cr.is_string(b)&&b.length?a.set_int(b.split(c).length):a.set_int(0)};e.prototype.replace=function(a,b,c,d){cr.is_string(b)&&cr.is_string(c)&&cr.is_string(d)?a.set_string(b.replace(RegExp(cr.regexp_escape(c),"gi"),d)):a.set_string(cr.is_string(b)?
b:"")};e.prototype.trim=function(a,b){a.set_string(cr.is_string(b)?b.trim():"")};e.prototype.pi=function(a){a.set_float(cr.PI)};e.prototype.layoutname=function(a){this.runtime.running_layout?a.set_string(this.runtime.running_layout.name):a.set_string("")};e.prototype.renderer=function(a){a.set_string(this.runtime.gl?"webgl":"canvas2d")};e.prototype.anglediff=function(a,b,c){a.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(b),cr.to_radians(c))))};e.prototype.choose=function(a){var b=cr.floor(Math.random()*
(arguments.length-1));a.set_any(arguments[b+1])};e.prototype.rgb=function(a,b,c,d){a.set_int(cr.RGB(b,c,d))};e.prototype.projectversion=function(a){a.set_string(this.runtime.versionstr)};e.prototype.anglelerp=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);var e=cr.angleDiff(b,c);cr.angleClockwise(c,b)?a.set_float(cr.to_clamped_degrees(b+e*d)):a.set_float(cr.to_clamped_degrees(b-e*d))};e.prototype.anglerotate=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);d=cr.to_radians(d);a.set_float(cr.to_clamped_degrees(cr.angleRotate(b,
c,d)))};e.prototype.zeropad=function(a,b,c){var d=0>b?"-":"";0>b&&(b=-b);c-=b.toString().length;for(var e=0;e<c;e++)d+="0";a.set_string(d+b.toString())};e.prototype.cpuutilisation=function(a){a.set_float(this.runtime.cpuutilisation/1E3)};e.prototype.viewportleft=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewLeft:0)};e.prototype.viewporttop=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewTop:0)};e.prototype.viewportright=function(a,b){var c=this.runtime.getLayer(b);
a.set_float(c?c.viewRight:0)};e.prototype.viewportbottom=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewBottom:0)};e.prototype.loadingprogress=function(a){a.set_float(this.runtime.loadingprogress)};e.prototype.unlerp=function(a,b,c,d){a.set_float(cr.unlerp(b,c,d))};e.prototype.canvassnapshot=function(a){a.set_string(this.runtime.snapshotData)};e.prototype.urlencode=function(a,b){a.set_string(encodeURIComponent(b))};e.prototype.urldecode=function(a,b){a.set_string(decodeURIComponent(b))};
e.prototype.canvastolayerx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!0):0)};e.prototype.canvastolayery=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!1):0)};e.prototype.layertocanvasx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!0):0)};e.prototype.layertocanvasy=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!1):0)};e.prototype.savestatejson=function(a){a.set_string(this.runtime.lastSaveJson)};
e.prototype.imagememoryusage=function(a){this.runtime.glwrap?a.set_float(Math.round(100*this.runtime.glwrap.estimateVRAM()/1048576)/100):a.set_float(0)};e.prototype.regexsearch=function(a,b,d,e){d=c(d,e);a.set_int(b?b.search(d):-1)};e.prototype.regexreplace=function(a,b,d,e,f){d=c(d,e);a.set_string(b?b.replace(d,f):"")};var t=[],s="",u="",A="";e.prototype.regexmatchcount=function(a,b,d,e){c(d,e);g(b,d,e);a.set_int(t?t.length:0)};e.prototype.regexmatchat=function(a,b,d,e,f){f=Math.floor(f);c(d,e);
g(b,d,e);!t||0>f||f>=t.length?a.set_string(""):a.set_string(t[f])};e.prototype.infinity=function(a){a.set_float(Infinity)};e.prototype.setbit=function(a,b,c,d){c|=0;a.set_int((b|0)&~(1<<c)|(0!==d?1:0)<<c)};e.prototype.togglebit=function(a,b,c){a.set_int((b|0)^1<<(c|0))};e.prototype.getbit=function(a,b,c){a.set_int((b|0)&1<<(c|0)?1:0)};f.exps=new e;f.runWaits=function(){var a,b,c,d,e,f,h=this.runtime.getCurrentEventStack();a=0;for(c=this.waits.length;a<c;a++)if(d=this.waits[a],!(d.time>this.runtime.kahanTime.sum)){h.current_event=
d.ev;h.actindex=d.actindex;h.cndindex=0;for(b in d.sols)d.sols.hasOwnProperty(b)&&(e=this.runtime.types_by_index[parseInt(b,10)].getCurrentSol(),f=d.sols[b],e.select_all=f.sa,cr.shallowAssignArray(e.instances,f.insts),e=f,e.insts.length=0,r.push(e));d.ev.resume_actions_and_subevents();this.runtime.clearSol(d.solModifiers);d.deleteme=!0}b=a=0;for(c=this.waits.length;a<c;a++)d=this.waits[a],this.waits[b]=d,d.deleteme?(cr.wipe(d.sols),d.solModifiers.length=0,q.push(d)):b++;this.waits.length=b}})();
(function(){cr.add_common_aces=function(a){var c=a[0].prototype,d=a[1],e=a[3],g=a[4],f=a[5],l=a[6],k=a[7];a=a[8];c.cnds||(c.cnds={});c.acts||(c.acts={});c.exps||(c.exps={});var h=c.cnds,m=c.acts,c=c.exps;e&&(h.CompareX=function(a,b){return cr.do_cmp(this.x,a,b)},h.CompareY=function(a,b){return cr.do_cmp(this.y,a,b)},h.IsOnScreen=function(){var a=this.layer;this.update_bbox();var b=this.bbox;return!(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)},h.IsOutsideLayout=
function(){this.update_bbox();var a=this.bbox,b=this.runtime.running_layout;return 0>a.right||0>a.bottom||a.left>b.width||a.top>b.height},h.PickDistance=function(a,b,c){var d=this.getCurrentSol(),e=d.getObjects();if(!e.length)return!1;var f=e[0],h=f,g=cr.distanceTo(f.x,f.y,b,c),k,m,l;k=1;for(m=e.length;k<m;k++)if(f=e[k],l=cr.distanceTo(f.x,f.y,b,c),0===a&&l<g||1===a&&l>g)g=l,h=f;d.pick_one(h);return!0},m.SetX=function(a){this.x!==a&&(this.x=a,this.set_bbox_changed())},m.SetY=function(a){this.y!==
a&&(this.y=a,this.set_bbox_changed())},m.SetPos=function(a,b){if(this.x!==a||this.y!==b)this.x=a,this.y=b,this.set_bbox_changed()},m.SetPosToObject=function(a,b){var c=a.getPairedInstance(this);if(c){var d;c.getImagePoint?(d=c.getImagePoint(b,!0),c=c.getImagePoint(b,!1)):(d=c.x,c=c.y);if(this.x!==d||this.y!==c)this.x=d,this.y=c,this.set_bbox_changed()}},m.MoveForward=function(a){0!==a&&(this.x+=Math.cos(this.angle)*a,this.y+=Math.sin(this.angle)*a,this.set_bbox_changed())},m.MoveAtAngle=function(a,
b){0!==b&&(this.x+=Math.cos(cr.to_radians(a))*b,this.y+=Math.sin(cr.to_radians(a))*b,this.set_bbox_changed())},c.X=function(a){a.set_float(this.x)},c.Y=function(a){a.set_float(this.y)},c.dt=function(a){a.set_float(this.runtime.getDt(this))});g&&(h.CompareWidth=function(a,b){return cr.do_cmp(this.width,a,b)},h.CompareHeight=function(a,b){return cr.do_cmp(this.height,a,b)},m.SetWidth=function(a){this.width!==a&&(this.width=a,this.set_bbox_changed())},m.SetHeight=function(a){this.height!==a&&(this.height=
a,this.set_bbox_changed())},m.SetSize=function(a,b){if(this.width!==a||this.height!==b)this.width=a,this.height=b,this.set_bbox_changed()},c.Width=function(a){a.set_float(this.width)},c.Height=function(a){a.set_float(this.height)},c.BBoxLeft=function(a){this.update_bbox();a.set_float(this.bbox.left)},c.BBoxTop=function(a){this.update_bbox();a.set_float(this.bbox.top)},c.BBoxRight=function(a){this.update_bbox();a.set_float(this.bbox.right)},c.BBoxBottom=function(a){this.update_bbox();a.set_float(this.bbox.bottom)});
f&&(h.AngleWithin=function(a,b){return cr.angleDiff(this.angle,cr.to_radians(b))<=cr.to_radians(a)},h.IsClockwiseFrom=function(a){return cr.angleClockwise(this.angle,cr.to_radians(a))},h.IsBetweenAngles=function(a,b){var c=cr.to_clamped_radians(a),d=cr.to_clamped_radians(b),e=cr.clamp_angle(this.angle);return cr.angleClockwise(d,c)?cr.angleClockwise(e,c)&&!cr.angleClockwise(e,d):!(!cr.angleClockwise(e,c)&&cr.angleClockwise(e,d))},m.SetAngle=function(a){a=cr.to_radians(cr.clamp_angle_degrees(a));isNaN(a)||
this.angle===a||(this.angle=a,this.set_bbox_changed())},m.RotateClockwise=function(a){0===a||isNaN(a)||(this.angle+=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},m.RotateCounterclockwise=function(a){0===a||isNaN(a)||(this.angle-=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},m.RotateTowardAngle=function(a,b){var c=cr.angleRotate(this.angle,cr.to_radians(b),cr.to_radians(a));isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},
m.RotateTowardPosition=function(a,b,c){b=Math.atan2(c-this.y,b-this.x);a=cr.angleRotate(this.angle,b,cr.to_radians(a));isNaN(a)||this.angle===a||(this.angle=a,this.set_bbox_changed())},m.SetTowardPosition=function(a,b){var c=Math.atan2(b-this.y,a-this.x);isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},c.Angle=function(a){a.set_float(cr.to_clamped_degrees(this.angle))});d||(h.CompareInstanceVar=function(a,b,c){return cr.do_cmp(this.instance_vars[a],b,c)},h.IsBoolInstanceVarSet=function(a){return this.instance_vars[a]},
h.PickInstVarHiLow=function(a,b){var c=this.getCurrentSol(),d=c.getObjects();if(!d.length)return!1;var e=d[0],f=e,h=e.instance_vars[b],g,k,m;g=1;for(k=d.length;g<k;g++)if(e=d[g],m=e.instance_vars[b],0===a&&m<h||1===a&&m>h)h=m,f=e;c.pick_one(f);return!0},h.PickByUID=function(a){var b,c,d,e,f;if(this.runtime.getCurrentCondition().inverted){f=this.getCurrentSol();if(f.select_all)for(f.select_all=!1,f.instances.length=0,f.else_instances.length=0,d=this.instances,b=0,c=d.length;b<c;b++)e=d[b],e.uid===
a?f.else_instances.push(e):f.instances.push(e);else{d=b=0;for(c=f.instances.length;b<c;b++)e=f.instances[b],f.instances[d]=e,e.uid===a?f.else_instances.push(e):d++;f.instances.length=d}this.applySolToContainer();return!!f.instances.length}e=this.runtime.getObjectByUID(a);if(!e)return!1;f=this.getCurrentSol();if(!f.select_all&&-1===f.instances.indexOf(e))return!1;if(this.is_family)for(a=e.type.families,b=0,c=a.length;b<c;b++){if(a[b]===this)return f.pick_one(e),this.applySolToContainer(),!0}else if(e.type===
this)return f.pick_one(e),this.applySolToContainer(),!0;return!1},h.OnCreated=function(){return!0},h.OnDestroyed=function(){return!0},m.SetInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]=b:c[a]=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]=b:c[a]=b.toString())},m.AddInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]+=b:c[a]+=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]+=b:c[a]+=b.toString())},m.SubInstanceVar=
function(a,b){var c=this.instance_vars;cr.is_number(c[a])&&(cr.is_number(b)?c[a]-=b:c[a]-=parseFloat(b))},m.SetBoolInstanceVar=function(a,b){this.instance_vars[a]=b?1:0},m.ToggleBoolInstanceVar=function(a){this.instance_vars[a]=1-this.instance_vars[a]},m.Destroy=function(){this.runtime.DestroyInstance(this)},m.LoadFromJsonString||(m.LoadFromJsonString=function(a){var b,c;try{b=JSON.parse(a)}catch(d){return}this.runtime.loadInstanceFromJSON(this,b,!0);this.afterLoad&&this.afterLoad();if(this.behavior_insts)for(a=
0,b=this.behavior_insts.length;a<b;++a)c=this.behavior_insts[a],c.afterLoad&&c.afterLoad()}),c.Count=function(a){var b=a.object_class.instances.length,c,d,e;c=0;for(d=this.runtime.createRow.length;c<d;c++)e=this.runtime.createRow[c],a.object_class.is_family?0<=e.type.families.indexOf(a.object_class)&&b++:e.type===a.object_class&&b++;a.set_int(b)},c.PickedCount=function(a){a.set_int(a.object_class.getCurrentSol().getObjects().length)},c.UID=function(a){a.set_int(this.uid)},c.IID=function(a){a.set_int(this.get_iid())},
c.AsJSON||(c.AsJSON=function(a){a.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this,!0)))}));l&&(h.IsVisible=function(){return this.visible},m.SetVisible=function(a){!a!==!this.visible&&(this.visible=a,this.runtime.redraw=!0)},h.CompareOpacity=function(a,b){return cr.do_cmp(cr.round6dp(100*this.opacity),a,b)},m.SetOpacity=function(a){a/=100;0>a?a=0:1<a&&(a=1);a!==this.opacity&&(this.opacity=a,this.runtime.redraw=!0)},c.Opacity=function(a){a.set_float(cr.round6dp(100*this.opacity))});
k&&(h.IsOnLayer=function(a){return a?this.layer===a:!1},h.PickTopBottom=function(a){var b=this.getCurrentSol(),c=b.getObjects();if(!c.length)return!1;var d=c[0],e=d,f,h;f=1;for(h=c.length;f<h;f++)if(d=c[f],0===a){if(d.layer.index>e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()>e.get_zindex())e=d}else if(d.layer.index<e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()<e.get_zindex())e=d;b.pick_one(e);return!0},m.MoveToTop=function(){var a=this.get_zindex();a!==this.layer.instances.length-
1&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.push(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},m.MoveToBottom=function(){var a=this.get_zindex();0!==a&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.unshift(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},m.MoveToLayer=function(a){a&&a!=this.layer&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=a,this.zindex=a.instances.length,a.instances.push(this),
this.runtime.redraw=!0)},m.ZMoveToObject=function(a,b){var c=0===a;if(b){var d=b.getFirstPicked(this);if(d&&d.uid!==this.uid){this.layer.index!==d.layer.index&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=d.layer,this.zindex=d.layer.instances.length,d.layer.instances.push(this));var e=this.get_zindex(),d=d.get_zindex();cr.arrayRemove(this.layer.instances,e);e<d&&d--;c&&d++;d===this.layer.instances.length?this.layer.instances.push(this):this.layer.instances.splice(d,
0,this);this.layer.zindices_stale=!0;this.runtime.redraw=!0}}},c.LayerNumber=function(a){a.set_int(this.layer.number)},c.LayerName=function(a){a.set_string(this.layer.name)},c.ZIndex=function(a){a.set_int(this.get_zindex())});a&&(m.SetEffectEnabled=function(a,b){if(this.runtime.glwrap){var c=this.type.getEffectIndexByName(b);if(!(0>c)){var d=1===a;this.active_effect_flags[c]!==d&&(this.active_effect_flags[c]=d,this.updateActiveEffects(),this.runtime.redraw=!0)}}},m.SetEffectParam=function(a,b,c){if(this.runtime.glwrap){var d=
this.type.getEffectIndexByName(a);0>d||(a=this.type.effect_types[d],d=this.effect_params[d],b=Math.floor(b),0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0))))}})};cr.set_bbox_changed=function(){this.cell_changed=this.bbox_changed=!0;this.type.any_cell_changed=!0;this.runtime.redraw=!0;var a,c,d=this.bbox_changed_callbacks;a=0;for(c=d.length;a<c;++a)d[a](this)};cr.add_bbox_changed_callback=function(a){a&&
this.bbox_changed_callbacks.push(a)};cr.update_bbox=function(){if(this.bbox_changed){var a=this.bbox,c=this.bquad;a.set(this.x,this.y,this.x+this.width,this.y+this.height);a.offset(-this.hotspotX*this.width,-this.hotspotY*this.height);this.angle?(a.offset(-this.x,-this.y),c.set_from_rotated_rect(a,this.angle),c.offset(this.x,this.y),c.bounding_box(a)):c.set_from_rect(a);a.normalize();this.bbox_changed=!1}};var a=new cr.rect(0,0,0,0);cr.update_collision_cell=function(){if(this.cell_changed&&this.collisionsEnabled){this.update_bbox();
var b=this.type.collision_grid,c=this.collcells,d=this.bbox;a.set(b.XToCell(d.left),b.YToCell(d.top),b.XToCell(d.right),b.YToCell(d.bottom));c.equals(a)||(c.right<c.left?b.update(this,null,a):b.update(this,c,a),c.copy(a),this.cell_changed=!1)}};cr.inst_contains_pt=function(a,c){return this.bbox.contains_pt(a,c)&&this.bquad.contains_pt(a,c)?this.collision_poly&&!this.collision_poly.is_empty()?(this.collision_poly.cache_poly(this.width,this.height,this.angle),this.collision_poly.contains_pt(a-this.x,
c-this.y)):!0:!1};cr.inst_get_iid=function(){this.type.updateIIDs();return this.iid};cr.inst_get_zindex=function(){this.layer.updateZIndices();return this.zindex};cr.inst_updateActiveEffects=function(){this.active_effect_types.length=0;var a,c;a=0;for(c=this.active_effect_flags.length;a<c;a++)this.active_effect_flags[a]&&this.active_effect_types.push(this.type.effect_types[a]);this.uses_shaders=!!this.active_effect_types.length};cr.inst_toString=function(){return"Inst"+this.puid};cr.type_getFirstPicked=
function(a){if(a&&a.is_contained&&a.type!=this){var c,d,e;c=0;for(d=a.siblings.length;c<d;c++)if(e=a.siblings[c],e.type==this)return e}a=this.getCurrentSol().getObjects();return a.length?a[0]:null};cr.type_getPairedInstance=function(a){var c=this.getCurrentSol().getObjects();return c.length?c[a.get_iid()%c.length]:null};cr.type_updateIIDs=function(){if(this.stale_iids&&!this.is_family){var a,c;a=0;for(c=this.instances.length;a<c;a++)this.instances[a].iid=a;var d=a,e=this.runtime.createRow;a=0;for(c=
e.length;a<c;++a)e[a].type===this&&(e[a].iid=d++);this.stale_iids=!1}};cr.type_getInstanceByIID=function(a){if(a<this.instances.length)return this.instances[a];a-=this.instances.length;var c=this.runtime.createRow,d,e;d=0;for(e=c.length;d<e;++d)if(c[d].type===this){if(0===a)return c[d];--a}return null};cr.type_getCurrentSol=function(){return this.solstack[this.cur_sol]};cr.type_pushCleanSol=function(){this.cur_sol++;this.cur_sol===this.solstack.length?this.solstack.push(new cr.selection(this)):this.solstack[this.cur_sol].select_all=
!0};cr.type_pushCopySol=function(){this.cur_sol++;this.cur_sol===this.solstack.length&&this.solstack.push(new cr.selection(this));var a=this.solstack[this.cur_sol],c=this.solstack[this.cur_sol-1];c.select_all?a.select_all=!0:(a.select_all=!1,cr.shallowAssignArray(a.instances,c.instances),cr.shallowAssignArray(a.else_instances,c.else_instances))};cr.type_popSol=function(){this.cur_sol--};cr.type_getBehaviorByName=function(a){var c,d,e,g,f,l=0;if(!this.is_family)for(c=0,d=this.families.length;c<d;c++)for(f=
this.families[c],e=0,g=f.behaviors.length;e<g;e++){if(a===f.behaviors[e].name)return this.extra.lastBehIndex=l,f.behaviors[e];l++}c=0;for(d=this.behaviors.length;c<d;c++){if(a===this.behaviors[c].name)return this.extra.lastBehIndex=l,this.behaviors[c];l++}return null};cr.type_getBehaviorIndexByName=function(a){return this.getBehaviorByName(a)?this.extra.lastBehIndex:-1};cr.type_getEffectIndexByName=function(a){var c,d;c=0;for(d=this.effect_types.length;c<d;c++)if(this.effect_types[c].name===a)return c;
return-1};cr.type_applySolToContainer=function(){if(this.is_contained&&!this.is_family){var a,c,d,e,g,f,l;this.updateIIDs();f=this.getCurrentSol();var k=f.select_all,h=(a=this.runtime.getCurrentEventStack())&&a.current_event&&a.current_event.orblock;a=0;for(c=this.container.length;a<c;a++)if(g=this.container[a],g!==this&&(g.updateIIDs(),l=g.getCurrentSol(),l.select_all=k,!k)){l.instances.length=f.instances.length;d=0;for(e=f.instances.length;d<e;d++)l.instances[d]=g.getInstanceByIID(f.instances[d].iid);
if(h)for(l.else_instances.length=f.else_instances.length,d=0,e=f.else_instances.length;d<e;d++)l.else_instances[d]=g.getInstanceByIID(f.else_instances[d].iid)}}};cr.type_toString=function(){return"Type"+this.sid};cr.do_cmp=function(a,c,d){if("undefined"===typeof a||"undefined"===typeof d)return!1;switch(c){case 0:return a===d;case 1:return a!==d;case 2:return a<d;case 3:return a<=d;case 4:return a>d;case 5:return a>=d;default:return!1}}})();cr.shaders={};
cr.plugins_.Audio=function(a){this.runtime=a};
(function(){function a(a){a=Math.pow(10,a/20);0>a&&(a=0);1<a&&(a=1);return a}function b(a){0>a&&(a=0);1<a&&(a=1);return 20*(Math.log(a)/Math.log(10))}function c(a){a=a.toLowerCase();return Q.hasOwnProperty(a)&&Q[a].length?Q[a][0].getInputNode():K.destination}function d(){return K.createGain?K.createGain():K.createGainNode()}function e(a){return K.createDelay?K.createDelay(a):K.createDelayNode(a)}function g(a){a.start?a.start(0):a.noteOn(0)}function f(a,b,c){a.start?a.start(0,b):a.noteGrainOn(0,b,
c-b)}function l(a){try{a.stop?a.stop(0):a.noteOff(0)}catch(b){}}function k(a,b,c,d){if(a)if(a.cancelScheduledValues(0),0===d)a.value=b;else{var e=K.currentTime;d+=e;switch(c){case 0:a.setValueAtTime(b,d);break;case 1:a.setValueAtTime(a.value,e);a.linearRampToValueAtTime(b,d);break;case 2:a.setValueAtTime(a.value,e),a.exponentialRampToValueAtTime(b,d)}}}function h(a,b,c,e,f,h){this.type="filter";this.params=[a,b,c,e,f,h];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=h;this.dryNode=d();
this.dryNode.gain.value=1-h;this.filterNode=K.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?a:la[a];this.filterNode.frequency.value=b;this.filterNode.detune&&(this.filterNode.detune.value=c);this.filterNode.Q.value=e;this.filterNode.gain.value=f;this.inputNode.connect(this.filterNode);this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode)}function m(a,b,c){this.type="delay";this.params=[a,b,c];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=
c;this.dryNode=d();this.dryNode.gain.value=1-c;this.mainNode=d();this.delayNode=e(a);this.delayNode.delayTime.value=a;this.delayGainNode=d();this.delayGainNode.gain.value=b;this.inputNode.connect(this.mainNode);this.inputNode.connect(this.dryNode);this.mainNode.connect(this.wetNode);this.mainNode.connect(this.delayNode);this.delayNode.connect(this.delayGainNode);this.delayGainNode.connect(this.mainNode)}function n(a,b,c,e){this.type="convolve";this.params=[b,c,e];this.inputNode=d();this.wetNode=d();
this.wetNode.gain.value=c;this.dryNode=d();this.dryNode.gain.value=1-c;this.convolveNode=K.createConvolver();a&&(this.convolveNode.normalize=b,this.convolveNode.buffer=a);this.inputNode.connect(this.convolveNode);this.inputNode.connect(this.dryNode);this.convolveNode.connect(this.wetNode)}function p(a,b,c,f,h){this.type="flanger";this.params=[a,b,c,f,h];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-h/2;this.wetNode=d();this.wetNode.gain.value=h/2;this.feedbackNode=d();this.feedbackNode.gain.value=
f;this.delayNode=e(a+b);this.delayNode.delayTime.value=a;this.oscNode=K.createOscillator();this.oscNode.frequency.value=c;this.oscGainNode=d();this.oscGainNode.gain.value=b;this.inputNode.connect(this.delayNode);this.inputNode.connect(this.dryNode);this.delayNode.connect(this.wetNode);this.delayNode.connect(this.feedbackNode);this.feedbackNode.connect(this.delayNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.delayNode.delayTime);g(this.oscNode)}function q(a,b,c,e,f,h){this.type=
"phaser";this.params=[a,b,c,e,f,h];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-h/2;this.wetNode=d();this.wetNode.gain.value=h/2;this.filterNode=K.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?7:"allpass";this.filterNode.frequency.value=a;this.filterNode.detune&&(this.filterNode.detune.value=b);this.filterNode.Q.value=c;this.oscNode=K.createOscillator();this.oscNode.frequency.value=f;this.oscGainNode=d();this.oscGainNode.gain.value=e;this.inputNode.connect(this.filterNode);
this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.filterNode.frequency);g(this.oscNode)}function r(a){this.type="gain";this.params=[a];this.node=d();this.node.gain.value=a}function t(a,b){this.type="tremolo";this.params=[a,b];this.node=d();this.node.gain.value=1-b/2;this.oscNode=K.createOscillator();this.oscNode.frequency.value=a;this.oscGainNode=d();this.oscGainNode.gain.value=b/2;this.oscNode.connect(this.oscGainNode);
this.oscGainNode.connect(this.node.gain);g(this.oscNode)}function s(a,b){this.type="ringmod";this.params=[a,b];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=b;this.dryNode=d();this.dryNode.gain.value=1-b;this.ringNode=d();this.ringNode.gain.value=0;this.oscNode=K.createOscillator();this.oscNode.frequency.value=a;this.oscNode.connect(this.ringNode.gain);g(this.oscNode);this.inputNode.connect(this.ringNode);this.inputNode.connect(this.dryNode);this.ringNode.connect(this.wetNode)}function u(a,
b,c,e,f){this.type="distortion";this.params=[a,b,c,e,f];this.inputNode=d();this.preGain=d();this.postGain=d();this.setDrive(c,Math.pow(10,e/20));this.wetNode=d();this.wetNode.gain.value=f;this.dryNode=d();this.dryNode.gain.value=1-f;this.waveShaper=K.createWaveShaper();this.curve=new Float32Array(65536);this.generateColortouchCurve(a,b);this.waveShaper.curve=this.curve;this.inputNode.connect(this.preGain);this.inputNode.connect(this.dryNode);this.preGain.connect(this.waveShaper);this.waveShaper.connect(this.postGain);
this.postGain.connect(this.wetNode)}function A(a,b,c,d,e){this.type="compressor";this.params=[a,b,c,d,e];this.node=K.createDynamicsCompressor();try{this.node.threshold.value=a,this.node.knee.value=b,this.node.ratio.value=c,this.node.attack.value=d,this.node.release.value=e}catch(f){}}function E(a,b){this.type="analyser";this.params=[a,b];this.node=K.createAnalyser();this.node.fftSize=a;this.node.smoothingTimeConstant=b;this.freqBins=new Float32Array(this.node.frequencyBinCount);this.signal=new Uint8Array(a);
this.rms=this.peak=0}function I(){this.obj=null;this.loadUid=0;this.speeds=[];this.moveAngle=this.lastY=this.lastX=0}function z(a,b){this.src=a;this.myapi=N;this.is_music=b;this.added_end_listener=!1;var c=this;this.mediaSourceNode=this.outNode=null;this.panWhenReady=[];this.seekWhenReady=0;this.supportWebAudioAPI=this.pauseWhenReady=!1;N===H&&b&&(this.myapi=L,this.outNode=d());this.audioData=this.bufferObject=null;var e;switch(this.myapi){case L:this.bufferObject=new Audio;N===H&&K.createMediaElementSource&&
!J.isFirefox&&(this.supportWebAudioAPI=!0,this.bufferObject.addEventListener("canplay",function(){c.mediaSourceNode||(c.mediaSourceNode=K.createMediaElementSource(c.bufferObject),c.mediaSourceNode.connect(c.outNode))}));this.bufferObject.autoplay=!1;this.bufferObject.preload="auto";this.bufferObject.src=a;break;case H:e=new XMLHttpRequest;e.open("GET",a,!0);e.responseType="arraybuffer";e.onload=function(){c.audioData=e.response;c.decodeAudioBuffer()};e.send();break;case U:this.bufferObject=!0;break;
case W:this.bufferObject=!0}}function v(a,b){var e=this;this.tag=b;this.stopped=this.fresh=!0;this.src=a.src;this.buffer=a;this.myapi=N;this.is_music=a.is_music;this.playbackRate=1;this.pgended=!0;this.is_paused=this.resume_me=!1;this.resume_position=0;this.is_silent=this.is_muted=this.looping=!1;this.mutevol=this.volume=1;this.startTime=J.kahanTime.sum;this.pannerNode=this.gainNode=null;this.pannerEnabled=!1;this.objectTracker=null;this.panConeOuterGain=this.panConeOuter=this.panConeInner=this.panAngle=
this.panY=this.panX=0;this.instanceObject=null;var f=!1;this.myapi!==H||this.buffer.myapi!==L||this.buffer.supportWebAudioAPI||(this.myapi=L);switch(this.myapi){case L:this.is_music?(this.instanceObject=a.bufferObject,f=!a.added_end_listener,a.added_end_listener=!0):(this.instanceObject=new Audio,this.instanceObject.autoplay=!1,this.instanceObject.src=a.bufferObject.src,f=!0);f&&this.instanceObject.addEventListener("ended",function(){M=e.tag;e.stopped=!0;J.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
T)});break;case H:this.gainNode=d();this.gainNode.connect(c(b));this.buffer.myapi===H?a.bufferObject&&(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=a.bufferObject,this.instanceObject.connect(this.gainNode)):(this.instanceObject=this.buffer.bufferObject,this.buffer.outNode.connect(this.gainNode));break;case U:this.instanceObject=new window.Media(P+this.src,null,null,function(a){a===window.Media.MEDIA_STOPPED&&(e.pgended=!0,e.stopped=!0,M=e.tag,J.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
T))});break;case W:this.instanceObject=!0}}function F(a){R.length=0;if(a.length){var b,c,d;b=0;for(c=O.length;b<c;b++)d=O[b],cr.equals_nocase(a,d.tag)&&R.push(d)}else S&&!S.hasEnded()&&(R.length=1,R[0]=S)}function x(a){var b,c,d,e,f=K.destination;if(Q.hasOwnProperty(a)&&(d=Q[a],d.length))for(f=d[0].getInputNode(),b=0,c=d.length;b<c;b++)e=d[b],b+1===c?e.connectTo(K.destination):e.connectTo(d[b+1].getInputNode());F(a);b=0;for(c=R.length;b<c;b++)R[b].reconnect(f);ca&&ia===a&&(ca.disconnect(),ca.connect(f))}
function y(a,b){Q.hasOwnProperty(a)?Q[a].push(b):Q[a]=[b];x(a)}function B(){}function w(){}function G(){}function C(a,b){var c=null;Q.hasOwnProperty(a)&&(c=Q[a]);return c&&0<=b&&b<c.length&&c[b].freqBins?c[b]:null}var D=cr.plugins_.Audio.prototype;D.Type=function(a){this.plugin=a;this.runtime=a.runtime};D.Type.prototype.onCreate=function(){};var J=null,T=null,M="",P="",L=0,H=1,U=2,W=3,N=L,K=null,da=[],O=[],S=null,X=!1,ha=0,V=!1,Y=1,Z=0,aa=0,ja=1,ka=1,ma=10,na=1E4,oa=1,ca=null,ia="",ea=!1,fa=[],Q=
{},la="lowpass highpass bandpass lowshelf highshelf peaking notch allpass".split(" ");h.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};h.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};h.prototype.getInputNode=function(){return this.inputNode};h.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=
1);this.params[5]=b;k(this.wetNode.gain,b,c,d);k(this.dryNode.gain,1-b,c,d);break;case 1:this.params[1]=b;k(this.filterNode.frequency,b,c,d);break;case 2:this.params[2]=b;k(this.filterNode.detune,b,c,d);break;case 3:this.params[3]=b;k(this.filterNode.Q,b,c,d);break;case 4:this.params[4]=b,k(this.filterNode.gain,b,c,d)}};m.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};m.prototype.remove=function(){this.inputNode.disconnect();
this.mainNode.disconnect();this.delayNode.disconnect();this.delayGainNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};m.prototype.getInputNode=function(){return this.inputNode};m.prototype.setParam=function(b,c,d,e){switch(b){case 0:c/=100;0>c&&(c=0);1<c&&(c=1);this.params[2]=c;k(this.wetNode.gain,c,d,e);k(this.dryNode.gain,1-c,d,e);break;case 4:this.params[1]=a(c);k(this.delayGainNode.gain,a(c),d,e);break;case 5:this.params[0]=c,k(this.delayNode.delayTime,c,d,e)}};n.prototype.connectTo=
function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};n.prototype.remove=function(){this.inputNode.disconnect();this.convolveNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};n.prototype.getInputNode=function(){return this.inputNode};n.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[1]=b,k(this.wetNode.gain,b,c,d),k(this.dryNode.gain,1-b,c,d)}};p.prototype.connectTo=function(a){this.dryNode.disconnect();
this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};p.prototype.remove=function(){this.inputNode.disconnect();this.delayNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect();this.feedbackNode.disconnect()};p.prototype.getInputNode=function(){return this.inputNode};p.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;k(this.wetNode.gain,b/2,c,d);k(this.dryNode.gain,
1-b/2,c,d);break;case 6:this.params[1]=b/1E3;k(this.oscGainNode.gain,b/1E3,c,d);break;case 7:this.params[2]=b;k(this.oscNode.frequency,b,c,d);break;case 8:this.params[3]=b/100,k(this.feedbackNode.gain,b/100,c,d)}};q.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};q.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();
this.wetNode.disconnect()};q.prototype.getInputNode=function(){return this.inputNode};q.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;k(this.wetNode.gain,b/2,c,d);k(this.dryNode.gain,1-b/2,c,d);break;case 1:this.params[0]=b;k(this.filterNode.frequency,b,c,d);break;case 2:this.params[1]=b;k(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;k(this.filterNode.Q,b,c,d);break;case 6:this.params[3]=b;k(this.oscGainNode.gain,b,c,d);break;case 7:this.params[4]=
b,k(this.oscNode.frequency,b,c,d)}};r.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};r.prototype.remove=function(){this.node.disconnect()};r.prototype.getInputNode=function(){return this.node};r.prototype.setParam=function(b,c,d,e){switch(b){case 4:this.params[0]=a(c),k(this.node.gain,a(c),d,e)}};t.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};t.prototype.remove=function(){this.oscNode.disconnect();this.oscGainNode.disconnect();this.node.disconnect()};
t.prototype.getInputNode=function(){return this.node};t.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;k(this.node.gain.value,1-b/2,c,d);k(this.oscGainNode.gain.value,b/2,c,d);break;case 7:this.params[0]=b,k(this.oscNode.frequency,b,c,d)}};s.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};s.prototype.remove=function(){this.oscNode.disconnect();this.ringNode.disconnect();
this.inputNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};s.prototype.getInputNode=function(){return this.inputNode};s.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;k(this.wetNode.gain,b,c,d);k(this.dryNode.gain,1-b,c,d);break;case 7:this.params[0]=b,k(this.oscNode.frequency,b,c,d)}};u.prototype.setDrive=function(a,b){0.01>a&&(a=0.01);this.preGain.gain.value=a;this.postGain.gain.value=Math.pow(1/a,0.6)*b};u.prototype.shape=
function(a,b,c){var d=1.05*c*b-b;c=0>a?-1:1;a=0>a?-a:a;b=a<b?a:b+d*(1-Math.exp(-(1/d)*(a-b)));return b*c};u.prototype.generateColortouchCurve=function(a,b){for(var c=Math.pow(10,a/20),d=Math.pow(10,b/20),e=0,f=0;32768>f;++f)e=f/32768,e=this.shape(e,c,d),this.curve[32768+f]=e,this.curve[32768-f-1]=-e};u.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};u.prototype.remove=function(){this.inputNode.disconnect();this.preGain.disconnect();
this.waveShaper.disconnect();this.postGain.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};u.prototype.getInputNode=function(){return this.inputNode};u.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[4]=b,k(this.wetNode.gain,b,c,d),k(this.dryNode.gain,1-b,c,d)}};A.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};A.prototype.remove=function(){this.node.disconnect()};A.prototype.getInputNode=function(){return this.node};
A.prototype.setParam=function(a,b,c,d){};E.prototype.tick=function(){this.node.getFloatFrequencyData(this.freqBins);this.node.getByteTimeDomainData(this.signal);for(var a=this.node.fftSize,c=0,d=this.peak=0,e=0;c<a;c++)e=(this.signal[c]-128)/128,0>e&&(e=-e),this.peak<e&&(this.peak=e),d+=e*e;this.peak=b(this.peak);this.rms=b(Math.sqrt(d/a))};E.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};E.prototype.remove=function(){this.node.disconnect()};E.prototype.getInputNode=
function(){return this.node};E.prototype.setParam=function(a,b,c,d){};I.prototype.setObject=function(a){if(this.obj=a)this.lastX=this.obj.x,this.lastY=this.obj.y;this.speeds.length=0};I.prototype.hasObject=function(){return!!this.obj};I.prototype.tick=function(a){this.obj&&0!==a&&(this.moveAngle=cr.angleTo(this.lastX,this.lastY,this.obj.x,this.obj.y),a=cr.distanceTo(this.lastX,this.lastY,this.obj.x,this.obj.y)/a,4>this.speeds.length||this.speeds.shift(),this.speeds.push(a),this.lastX=this.obj.x,this.lastY=
this.obj.y)};I.prototype.getSpeed=function(){if(!this.speeds.length)return 0;var a,b,c=0;a=0;for(b=this.speeds.length;a<b;a++)c+=this.speeds[a];return c/this.speeds.length};I.prototype.getVelocityX=function(){return Math.cos(this.moveAngle)*this.getSpeed()};I.prototype.getVelocityY=function(){return Math.sin(this.moveAngle)*this.getSpeed()};var pa=!1;z.prototype.decodeAudioBuffer=function(){if(!this.bufferObject&&this.audioData){var a=this;if(K.decodeAudioData)K.decodeAudioData(this.audioData,function(b){a.bufferObject=
b;var c,d,e;if(cr.is_undefined(a.playTagWhenReady)||V)cr.is_undefined(a.convolveWhenReady)||(c=a.convolveWhenReady.convolveNode,c.normalize=a.normalizeWhenReady,c.buffer=b);else if(a.panWhenReady.length){c=0;for(d=a.panWhenReady.length;c<d;c++){b=a.panWhenReady[c];e=new v(a,b.thistag);e.setPannerEnabled(!0);if("undefined"!==typeof b.objUid&&(b.obj=J.getObjectByUID(b.objUid),!b.obj))continue;if(b.obj){var f=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),Z,aa,!0),h=cr.rotatePtAround(b.obj.x,
b.obj.y,-b.obj.layer.getAngle(),Z,aa,!1);e.setPan(f,h,cr.to_degrees(b.obj.angle-b.obj.layer.getAngle()),b.ia,b.oa,b.og);e.setObject(b.obj)}else e.setPan(b.x,b.y,b.a,b.ia,b.oa,b.og);e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady);a.pauseWhenReady&&e.pause();O.push(e)}a.panWhenReady.length=0}else e=new v(a,a.playTagWhenReady),e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady),a.pauseWhenReady&&e.pause(),O.push(e)});else if(this.bufferObject=K.createBuffer(this.audioData,!1),cr.is_undefined(this.playTagWhenReady)||
V)cr.is_undefined(this.convolveWhenReady)||(b=this.convolveWhenReady.convolveNode,b.normalize=this.normalizeWhenReady,b.buffer=this.bufferObject);else{var b=new v(this,this.playTagWhenReady);b.play(this.loopWhenReady,this.volumeWhenReady,this.seekWhenReady);this.pauseWhenReady&&b.pause();O.push(b)}}};z.prototype.isLoaded=function(){switch(this.myapi){case L:return 4===this.bufferObject.readyState;case H:return!!this.audioData;case U:return!0;case W:return!0}return!1};v.prototype.hasEnded=function(){switch(this.myapi){case L:return this.instanceObject.ended;
case H:return this.buffer.myapi===H?!this.fresh&&!this.stopped&&this.instanceObject.loop||this.is_paused?!1:J.kahanTime.sum-this.startTime>this.buffer.bufferObject.duration:this.instanceObject.ended;case U:return this.pgended;case W:!0}return!0};v.prototype.canBeRecycled=function(){return this.fresh||this.stopped?!0:this.hasEnded()};v.prototype.setPannerEnabled=function(a){N===H&&(!this.pannerEnabled&&a?this.gainNode&&(this.pannerNode||(this.pannerNode=K.createPanner(),this.pannerNode.panningModel=
"number"===typeof this.pannerNode.panningModel?ja:["equalpower","HRTF","soundfield"][ja],this.pannerNode.distanceModel="number"===typeof this.pannerNode.distanceModel?ka:["linear","inverse","exponential"][ka],this.pannerNode.refDistance=ma,this.pannerNode.maxDistance=na,this.pannerNode.rolloffFactor=oa),this.gainNode.disconnect(),this.gainNode.connect(this.pannerNode),this.pannerNode.connect(c(this.tag)),this.pannerEnabled=!0):this.pannerEnabled&&!a&&this.gainNode&&(this.pannerNode.disconnect(),this.gainNode.disconnect(),
this.gainNode.connect(c(this.tag)),this.pannerEnabled=!1))};v.prototype.setPan=function(a,b,c,d,e,f){this.pannerEnabled&&N===H&&(this.pannerNode.setPosition(a,b,0),this.pannerNode.setOrientation(Math.cos(cr.to_radians(c)),Math.sin(cr.to_radians(c)),0),this.pannerNode.coneInnerAngle=d,this.pannerNode.coneOuterAngle=e,this.pannerNode.coneOuterGain=f,this.panX=a,this.panY=b,this.panAngle=c,this.panConeInner=d,this.panConeOuter=e,this.panConeOuterGain=f)};v.prototype.setObject=function(a){this.pannerEnabled&&
N===H&&(this.objectTracker||(this.objectTracker=new I),this.objectTracker.setObject(a))};v.prototype.tick=function(a){if(this.pannerEnabled&&N===H&&this.objectTracker&&this.objectTracker.hasObject()&&this.isPlaying()){this.objectTracker.tick(a);a=this.objectTracker.obj;var b=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!1);this.pannerNode.setPosition(b,c,0);b=0;"undefined"!==typeof this.objectTracker.obj.angle&&(b=a.angle-a.layer.getAngle(),
this.pannerNode.setOrientation(Math.cos(b),Math.sin(b),0));b=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!0);c=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!1);this.pannerNode.setVelocity(b,c,0)}};v.prototype.play=function(a,b,c){var d=this.instanceObject;this.looping=a;this.volume=b;c=c||0;switch(this.myapi){case L:1!==d.playbackRate&&(d.playbackRate=1);d.volume!==b*
Y&&(d.volume=b*Y);d.loop!==a&&(d.loop=a);d.muted&&(d.muted=!1);if(d.currentTime!==c)try{d.currentTime=c}catch(e){}this.is_music&&ea&&!J.isInUserInputEvent?fa.push(this):this.instanceObject.play();break;case H:this.muted=!1;this.mutevol=1;if(this.buffer.myapi===H)this.fresh||(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode)),this.instanceObject.loop=a,this.gainNode.gain.value=b*Y,0===c?g(this.instanceObject):f(this.instanceObject,
c,this.getDuration());else{1!==d.playbackRate&&(d.playbackRate=1);d.loop!==a&&(d.loop=a);this.gainNode.gain.value=b*Y;if(d.currentTime!==c)try{d.currentTime=c}catch(h){}this.is_music&&ea&&!J.isInUserInputEvent?fa.push(this):d.play()}break;case U:(!this.fresh&&this.stopped||0!==c)&&d.seekTo(c);d.play();this.pgended=!1;break;case W:J.isDirectCanvas?AppMobi.context.playSound(this.src,a):AppMobi.player.playSound(this.src,a)}this.playbackRate=1;this.startTime=J.kahanTime.sum-c;this.is_paused=this.stopped=
this.fresh=!1};v.prototype.stop=function(){switch(this.myapi){case L:this.instanceObject.paused||this.instanceObject.pause();break;case H:this.buffer.myapi===H?l(this.instanceObject):this.instanceObject.paused||this.instanceObject.pause();break;case U:this.instanceObject.stop();break;case W:J.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.stopped=!0;this.is_paused=!1};v.prototype.pause=function(){if(!(this.fresh||this.stopped||this.hasEnded()||this.is_paused)){switch(this.myapi){case L:this.instanceObject.paused||
this.instanceObject.pause();break;case H:this.buffer.myapi===H?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),l(this.instanceObject)):this.instanceObject.paused||this.instanceObject.pause();break;case U:this.instanceObject.pause();break;case W:J.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.is_paused=!0}};v.prototype.resume=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&this.is_paused){switch(this.myapi){case L:this.instanceObject.play();
break;case H:this.buffer.myapi===H?(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Y*this.volume*this.mutevol,this.startTime=J.kahanTime.sum-this.resume_position,f(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play();break;case U:this.instanceObject.play();break;case W:J.isDirectCanvas&&AppMobi.context.resumeSound(this.src)}this.is_paused=
!1}};v.prototype.seek=function(a){if(!(this.fresh||this.stopped||this.hasEnded()))switch(this.myapi){case L:try{this.instanceObject.currentTime=a}catch(b){}break;case H:if(this.buffer.myapi===H)this.is_paused?this.resume_position=a:(this.pause(),this.resume_position=a,this.resume());else try{this.instanceObject.currentTime=a}catch(c){}break;case W:J.isDirectCanvas&&AppMobi.context.seekSound(this.src,a)}};v.prototype.reconnect=function(a){this.myapi===H&&(this.pannerEnabled?(this.pannerNode.disconnect(),
this.pannerNode.connect(a)):(this.gainNode.disconnect(),this.gainNode.connect(a)))};v.prototype.getDuration=function(){switch(this.myapi){case L:if("undefined"!==typeof this.instanceObject.duration)return this.instanceObject.duration;break;case H:return this.buffer.bufferObject.duration;case U:return this.instanceObject.getDuration();case W:if(J.isDirectCanvas)return AppMobi.context.getDurationSound(this.src)}return 0};v.prototype.getPlaybackTime=function(){var a=this.getDuration(),b=0;switch(this.myapi){case L:"undefined"!==
typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case H:if(this.buffer.myapi===H){if(this.is_paused)return this.resume_position;b=J.kahanTime.sum-this.startTime}else"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case W:J.isDirectCanvas&&(b=AppMobi.context.getPlaybackTimeSound(this.src))}!this.looping&&b>a&&(b=a);return b};v.prototype.isPlaying=function(){return!this.is_paused&&!this.fresh&&!this.stopped&&!this.hasEnded()};
v.prototype.setVolume=function(a){this.volume=a;this.updateVolume()};v.prototype.updateVolume=function(){var a=this.volume*Y;switch(this.myapi){case L:this.instanceObject.volume&&this.instanceObject.volume!==a&&(this.instanceObject.volume=a);break;case H:this.gainNode.gain.value=a*this.mutevol}};v.prototype.getVolume=function(){return this.volume};v.prototype.doSetMuted=function(a){switch(this.myapi){case L:this.instanceObject.muted!==!!a&&(this.instanceObject.muted=!!a);break;case H:this.mutevol=
a?0:1,this.gainNode.gain.value=Y*this.volume*this.mutevol}};v.prototype.setMuted=function(a){this.is_muted=!!a;this.doSetMuted(this.is_muted||this.is_silent)};v.prototype.setSilent=function(a){this.is_silent=!!a;this.doSetMuted(this.is_muted||this.is_silent)};v.prototype.setLooping=function(a){this.looping=a;switch(this.myapi){case L:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case H:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case W:J.isDirectCanvas&&
AppMobi.context.setLoopingSound(this.src,a)}};v.prototype.setPlaybackRate=function(a){this.playbackRate=a;this.updatePlaybackRate()};v.prototype.updatePlaybackRate=function(){var a=this.playbackRate;if(1===ha&&!this.is_music||2===ha)a*=J.timescale;switch(this.myapi){case L:this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a);break;case H:this.buffer.myapi===H?this.instanceObject.playbackRate.value!==a&&(this.instanceObject.playbackRate.value=a):this.instanceObject.playbackRate!==
a&&(this.instanceObject.playbackRate=a)}};v.prototype.setSuspended=function(a){switch(this.myapi){case L:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play();break;case H:a?this.isPlaying()?(this.buffer.myapi===H?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),l(this.instanceObject)):this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&(this.buffer.myapi===
H?(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Y*this.volume*this.mutevol,this.startTime=J.kahanTime.sum-this.resume_position,f(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play());break;case U:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play()}};
D.Instance=function(a){this.type=a;J=this.runtime=a.runtime;T=this;this.listenerTracker=null;this.listenerZ=-600;!(this.runtime.isiOS||this.runtime.isAndroid&&(this.runtime.isChrome||this.runtime.isAndroidStockBrowser))||this.runtime.isCrosswalk||this.runtime.isDomFree||(ea=!0);K=null;"undefined"!==typeof AudioContext?(N=H,K=new AudioContext):"undefined"!==typeof webkitAudioContext&&(N=H,K=new webkitAudioContext);(this.runtime.isiOS&&N===H||ea)&&document.addEventListener("touchstart",function(){var a,
b,c;!pa&&K&&(a=K.createBuffer(1,1,22050),b=K.createBufferSource(),b.buffer=a,b.connect(K.destination),g(b),pa=!0);if(ea){if(!V)for(a=0,b=fa.length;a<b;++a)c=fa[a],c.stopped||c.is_paused||c.instanceObject.play();fa.length=0}},!0);N!==H&&(this.runtime.isPhoneGap?N=U:this.runtime.isAppMobi&&(N=W));N===U&&(P=location.href,a=P.lastIndexOf("/"),-1<a&&(P=P.substr(0,a+1)),P=P.replace("file://",""));if(this.runtime.isSafari&&this.runtime.isWindows&&"undefined"===typeof Audio)alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed."),
this.runtime.DestroyInstance(this);else{if(this.runtime.isDirectCanvas)X=this.runtime.isAndroid;else try{X=!!(new Audio).canPlayType('audio/ogg; codecs="vorbis"')}catch(b){X=!1}this.runtime.tickMe(this)}};var ba=D.Instance.prototype;ba.onCreate=function(){ha=this.properties[0];this.saveload=this.properties[1];ja=this.properties[2];ka=this.properties[3];this.listenerZ=-this.properties[4];ma=this.properties[5];na=this.properties[6];oa=this.properties[7];this.listenerTracker=new I;N===H&&(K.listener.speedOfSound=
this.properties[8],K.listener.dopplerFactor=this.properties[9],K.listener.setPosition(this.runtime.draw_width/2,this.runtime.draw_height/2,this.listenerZ),K.listener.setOrientation(0,0,1,0,-1,0),window.c2OnAudioMicStream=function(a,b){ca&&ca.disconnect();ia=b.toLowerCase();ca=K.createMediaStreamSource(a);ca.connect(c(ia))});this.runtime.addSuspendCallback(function(a){T.onSuspend(a)});var a=this;this.runtime.addDestroyCallback(function(b){a.onInstanceDestroyed(b)})};ba.onInstanceDestroyed=function(a){var b,
c,d;b=0;for(c=O.length;b<c;b++)d=O[b],d.objectTracker&&d.objectTracker.obj===a&&(d.objectTracker.obj=null,d.pannerEnabled&&d.isPlaying()&&d.looping&&d.stop());this.listenerTracker.obj===a&&(this.listenerTracker.obj=null)};ba.saveToJSON=function(){var a={silent:V,masterVolume:Y,listenerZ:this.listenerZ,listenerUid:this.listenerTracker.hasObject()?this.listenerTracker.obj.uid:-1,playing:[],effects:{}},b=a.playing,c,d,e,f,h,g;c=0;for(d=O.length;c<d;c++)e=O[c],!e.isPlaying()||3===this.saveload||e.is_music&&
1===this.saveload||!e.is_music&&2===this.saveload||(f=e.getPlaybackTime(),e.looping&&(f%=e.getDuration()),f={tag:e.tag,buffersrc:e.buffer.src,is_music:e.is_music,playbackTime:f,volume:e.volume,looping:e.looping,muted:e.is_muted,playbackRate:e.playbackRate,paused:e.is_paused,resume_position:e.resume_position},e.pannerEnabled&&(f.pan={},g=f.pan,e.objectTracker&&e.objectTracker.hasObject()?g.objUid=e.objectTracker.obj.uid:(g.x=e.panX,g.y=e.panY,g.a=e.panAngle),g.ia=e.panConeInner,g.oa=e.panConeOuter,
g.og=e.panConeOuterGain),b.push(f));b=a.effects;for(h in Q)if(Q.hasOwnProperty(h)){e=[];c=0;for(d=Q[h].length;c<d;c++)e.push({type:Q[h][c].type,params:Q[h][c].params});b[h]=e}return a};var ga=[];ba.loadFromJSON=function(a){var b=a.silent;Y=a.masterVolume;this.listenerZ=a.listenerZ;this.listenerTracker.setObject(null);var c=a.listenerUid;-1!==c&&(this.listenerTracker.loadUid=c,ga.push(this.listenerTracker));var c=a.playing,d,e,f,g,k,l,B,z,v,w,x;if(3!==this.saveload)for(d=0,e=O.length;d<e;d++)v=O[d],
v.is_music&&1===this.saveload||(v.is_music||2!==this.saveload)&&v.stop();for(k in Q)if(Q.hasOwnProperty(k))for(d=0,e=Q[k].length;d<e;d++)Q[k][d].remove();cr.wipe(Q);for(k in a.effects)if(a.effects.hasOwnProperty(k))for(l=a.effects[k],d=0,e=l.length;d<e;d++)switch(f=l[d].type,w=l[d].params,f){case "filter":y(k,new h(w[0],w[1],w[2],w[3],w[4],w[5]));break;case "delay":y(k,new m(w[0],w[1],w[2]));break;case "convolve":f=w[2];v=this.getAudioBuffer(f,!1);v.bufferObject?f=new n(v.bufferObject,w[0],w[1],f):
(f=new n(null,w[0],w[1],f),v.normalizeWhenReady=w[0],v.convolveWhenReady=f);y(k,f);break;case "flanger":y(k,new p(w[0],w[1],w[2],w[3],w[4]));break;case "phaser":y(k,new q(w[0],w[1],w[2],w[3],w[4],w[5]));break;case "gain":y(k,new r(w[0]));break;case "tremolo":y(k,new t(w[0],w[1]));break;case "ringmod":y(k,new s(w[0],w[1]));break;case "distortion":y(k,new u(w[0],w[1],w[2],w[3],w[4]));break;case "compressor":y(k,new A(w[0],w[1],w[2],w[3],w[4]));break;case "analyser":y(k,new E(w[0],w[1]))}d=0;for(e=c.length;d<
e;d++)3===this.saveload||(a=c[d],f=a.buffersrc,g=a.is_music,k=a.tag,l=a.playbackTime,B=a.looping,z=a.volume,x=(w=a.pan)&&w.hasOwnProperty("objUid")?w.objUid:-1,g&&1===this.saveload)||!g&&2===this.saveload||((v=this.getAudioInstance(f,k,g,B,z))?(v.resume_position=a.resume_position,v.setPannerEnabled(!!w),v.play(B,z,l),v.updatePlaybackRate(),v.updateVolume(),v.doSetMuted(v.is_muted||v.is_silent),a.paused&&v.pause(),a.muted&&v.setMuted(!0),v.doSetMuted(v.is_muted||v.is_silent),w&&(-1!==x?(v.objectTracker=
v.objectTracker||new I,v.objectTracker.loadUid=x,ga.push(v.objectTracker)):v.setPan(w.x,w.y,w.a,w.ia,w.oa,w.og))):(v=this.getAudioBuffer(f,g),v.seekWhenReady=l,v.pauseWhenReady=a.paused,w&&(-1!==x?v.panWhenReady.push({objUid:x,ia:w.ia,oa:w.oa,og:w.og,thistag:k}):v.panWhenReady.push({x:w.x,y:w.y,a:w.a,ia:w.ia,oa:w.oa,og:w.og,thistag:k}))));if(b&&!V){d=0;for(e=O.length;d<e;d++)O[d].setSilent(!0);V=!0}else if(!b&&V){d=0;for(e=O.length;d<e;d++)O[d].setSilent(!1);V=!1}};ba.afterLoad=function(){var a,b,
c,d;a=0;for(b=ga.length;a<b;a++)c=ga[a],d=this.runtime.getObjectByUID(c.loadUid),c.setObject(d),c.loadUid=-1,d&&(Z=d.x,aa=d.y);ga.length=0};ba.onSuspend=function(a){var b,c;b=0;for(c=O.length;b<c;b++)O[b].setSuspended(a)};ba.tick=function(){var a=this.runtime.dt,b,c,d;b=0;for(c=O.length;b<c;b++)d=O[b],d.tick(a),d.myapi===L||d.myapi===W||d.fresh||d.stopped||!d.hasEnded()||(d.stopped=!0,M=d.tag,J.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,T)),0!==ha&&d.updatePlaybackRate();var e,f;for(e in Q)if(Q.hasOwnProperty(e))for(d=
Q[e],b=0,c=d.length;b<c;b++)f=d[b],f.tick&&f.tick();N===H&&this.listenerTracker.hasObject()&&(this.listenerTracker.tick(a),Z=this.listenerTracker.obj.x,aa=this.listenerTracker.obj.y,K.listener.setPosition(this.listenerTracker.obj.x,this.listenerTracker.obj.y,this.listenerZ),K.listener.setVelocity(this.listenerTracker.getVelocityX(),this.listenerTracker.getVelocityY(),0))};ba.getAudioBuffer=function(a,b){var c,d,e,f=null;c=0;for(d=da.length;c<d;c++)if(e=da[c],e.src===a){f=e;break}f||(f=new z(a,b),
da.push(f));return f};ba.getAudioInstance=function(a,b,c,d,e){var f,h,g;f=0;for(h=O.length;f<h;f++)if(g=O[f],g.src===a&&(g.canBeRecycled()||c))return g.tag=b,g;a=this.getAudioBuffer(a,c);if(!a.bufferObject)return"<preload>"!==b&&(a.playTagWhenReady=b,a.loopWhenReady=d,a.volumeWhenReady=e),null;g=new v(a,b);O.push(g);return g};var R=[];B.prototype.OnEnded=function(a){return cr.equals_nocase(M,a)};B.prototype.PreloadsComplete=function(){var a,b;a=0;for(b=da.length;a<b;a++)if(!da[a].isLoaded())return!1;
return!0};B.prototype.AdvancedAudioSupported=function(){return N===H};B.prototype.IsSilent=function(){return V};B.prototype.IsAnyPlaying=function(){var a,b;a=0;for(b=O.length;a<b;a++)if(O[a].isPlaying())return!0;return!1};B.prototype.IsTagPlaying=function(a){F(a);var b;a=0;for(b=R.length;a<b;a++)if(R[a].isPlaying())return!0;return!1};D.cnds=new B;w.prototype.Play=function(b,c,d,e){!V&&(d=a(d),S=this.getAudioInstance(this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a"),e,b[1],0!==c,d))&&(S.setPannerEnabled(!1),
S.play(0!==c,d))};w.prototype.PlayAtPosition=function(b,c,d,e,f,h,g,k,m,l){if(!V){d=a(d);var n=b[1];b=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");(S=this.getAudioInstance(b,l,n,0!==c,d))?(S.setPannerEnabled(!0),S.setPan(e,f,h,g,k,a(m)),S.play(0!==c,d)):this.getAudioBuffer(b,n).panWhenReady.push({x:e,y:f,a:h,ia:g,oa:k,og:a(m),thistag:l})}};w.prototype.PlayAtObject=function(b,c,d,e,f,h,g,k){if(!V&&e&&(e=e.getFirstPicked())){d=a(d);var m=b[1];b=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");
(S=this.getAudioInstance(b,k,m,0!==c,d))?(S.setPannerEnabled(!0),k=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Z,aa,!0),b=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Z,aa,!1),S.setPan(k,b,cr.to_degrees(e.angle-e.layer.getAngle()),f,h,a(g)),S.setObject(e),S.play(0!==c,d)):this.getAudioBuffer(b,m).panWhenReady.push({obj:e,ia:f,oa:h,og:a(g),thistag:k})}};w.prototype.PlayByName=function(b,c,d,e,f){!V&&(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),S=this.getAudioInstance(c,
f,b,0!==d,e))&&(S.setPannerEnabled(!1),S.play(0!==d,e))};w.prototype.PlayAtPositionByName=function(b,c,d,e,f,h,g,k,m,l,n){V||(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),(S=this.getAudioInstance(c,n,b,0!==d,e))?(S.setPannerEnabled(!0),S.setPan(f,h,g,k,m,a(l)),S.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({x:f,y:h,a:g,ia:k,oa:m,og:a(l),thistag:n}))};w.prototype.PlayAtObjectByName=function(b,c,d,e,f,h,g,k,m){!V&&f&&(f=f.getFirstPicked())&&(e=a(e),b=
1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),(S=this.getAudioInstance(c,m,b,0!==d,e))?(S.setPannerEnabled(!0),m=cr.rotatePtAround(f.x,f.y,-f.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(f.x,f.y,-f.layer.getAngle(),Z,aa,!1),S.setPan(m,c,cr.to_degrees(f.angle-f.layer.getAngle()),h,g,a(k)),S.setObject(f),S.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({obj:f,ia:h,oa:g,og:a(k),thistag:m}))};w.prototype.SetLooping=function(a,b){F(a);var c,d;c=0;for(d=R.length;c<d;c++)R[c].setLooping(0===
b)};w.prototype.SetMuted=function(a,b){F(a);var c,d;c=0;for(d=R.length;c<d;c++)R[c].setMuted(0===b)};w.prototype.SetVolume=function(b,c){F(b);var d=a(c),e,f;e=0;for(f=R.length;e<f;e++)R[e].setVolume(d)};w.prototype.Preload=function(a){if(!V){var b=a[1];a=this.runtime.files_subfolder+a[0]+(X?".ogg":".m4a");N===W?this.runtime.isDirectCanvas?AppMobi.context.loadSound(a):AppMobi.player.loadSound(a):N!==U&&this.getAudioInstance(a,"<preload>",b,!1)}};w.prototype.PreloadByName=function(a,b){if(!V){var c=
1===a,d=this.runtime.files_subfolder+b.toLowerCase()+(X?".ogg":".m4a");N===W?this.runtime.isDirectCanvas?AppMobi.context.loadSound(d):AppMobi.player.loadSound(d):N!==U&&this.getAudioInstance(d,"<preload>",c,!1)}};w.prototype.SetPlaybackRate=function(a,b){F(a);0>b&&(b=0);var c,d;c=0;for(d=R.length;c<d;c++)R[c].setPlaybackRate(b)};w.prototype.Stop=function(a){F(a);var b;a=0;for(b=R.length;a<b;a++)R[a].stop()};w.prototype.StopAll=function(){var a,b;a=0;for(b=O.length;a<b;a++)O[a].stop()};w.prototype.SetPaused=
function(a,b){F(a);var c,d;c=0;for(d=R.length;c<d;c++)0===b?R[c].pause():R[c].resume()};w.prototype.Seek=function(a,b){F(a);var c,d;c=0;for(d=R.length;c<d;c++)R[c].seek(b)};w.prototype.SetSilent=function(a){var b;2===a&&(a=V?1:0);if(0===a&&!V){a=0;for(b=O.length;a<b;a++)O[a].setSilent(!0);V=!0}else if(1===a&&V){a=0;for(b=O.length;a<b;a++)O[a].setSilent(!1);V=!1}};w.prototype.SetMasterVolume=function(b){Y=a(b);var c;b=0;for(c=O.length;b<c;b++)O[b].updateVolume()};w.prototype.AddFilterEffect=function(a,
b,c,d,e,f,g){N!==H||0>b||b>=la.length||!K.createBiquadFilter||(a=a.toLowerCase(),g/=100,0>g&&(g=0),1<g&&(g=1),y(a,new h(b,c,d,e,f,g)))};w.prototype.AddDelayEffect=function(b,c,d,e){N===H&&(b=b.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),y(b,new m(c,a(d),e)))};w.prototype.AddFlangerEffect=function(a,b,c,d,e,f){N===H&&K.createOscillator&&(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),y(a,new p(b/1E3,c/1E3,d,e/100,f)))};w.prototype.AddPhaserEffect=function(a,b,c,d,e,f,h){N===H&&K.createOscillator&&(a=
a.toLowerCase(),h/=100,0>h&&(h=0),1<h&&(h=1),y(a,new q(b,c,d,e,f,h)))};w.prototype.AddConvolutionEffect=function(a,b,c,d){if(N===H&&K.createConvolver){c=0===c;var e=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");b=this.getAudioBuffer(e,!1);a=a.toLowerCase();d/=100;0>d&&(d=0);1<d&&(d=1);b.bufferObject?d=new n(b.bufferObject,c,d,e):(d=new n(null,c,d,e),b.normalizeWhenReady=c,b.convolveWhenReady=d);y(a,d)}};w.prototype.AddGainEffect=function(b,c){N===H&&(b=b.toLowerCase(),y(b,new r(a(c))))};w.prototype.AddMuteEffect=
function(a){N===H&&(a=a.toLowerCase(),y(a,new r(0)))};w.prototype.AddTremoloEffect=function(a,b,c){N===H&&K.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),y(a,new t(b,c)))};w.prototype.AddRingModEffect=function(a,b,c){N===H&&K.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),y(a,new s(b,c)))};w.prototype.AddDistortionEffect=function(a,b,c,d,e,f){N===H&&K.createWaveShaper&&(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),y(a,new u(b,c,d,e,f)))};w.prototype.AddCompressorEffect=
function(a,b,c,d,e,f){N===H&&K.createDynamicsCompressor&&(a=a.toLowerCase(),y(a,new A(b,c,d,e/1E3,f/1E3)))};w.prototype.AddAnalyserEffect=function(a,b,c){N===H&&(a=a.toLowerCase(),y(a,new E(b,c)))};w.prototype.RemoveEffects=function(a){if(N===H){a=a.toLowerCase();var b,c,d;if(Q.hasOwnProperty(a)&&(d=Q[a],d.length)){b=0;for(c=d.length;b<c;b++)d[b].remove();d.length=0;x(a)}}};w.prototype.SetEffectParameter=function(a,b,c,d,e,f){N===H&&(a=a.toLowerCase(),b=Math.floor(b),Q.hasOwnProperty(a)&&(a=Q[a],
0>b||b>=a.length||a[b].setParam(c,d,e,f)))};w.prototype.SetListenerObject=function(a){a&&N===H&&(a=a.getFirstPicked())&&(this.listenerTracker.setObject(a),Z=a.x,aa=a.y)};w.prototype.SetListenerZ=function(a){this.listenerZ=a};D.acts=new w;G.prototype.Duration=function(a,b){F(b);R.length?a.set_float(R[0].getDuration()):a.set_float(0)};G.prototype.PlaybackTime=function(a,b){F(b);R.length?a.set_float(R[0].getPlaybackTime()):a.set_float(0)};G.prototype.Volume=function(a,c){F(c);if(R.length){var d=R[0].getVolume();
a.set_float(b(d))}else a.set_float(0)};G.prototype.MasterVolume=function(a){a.set_float(Y)};G.prototype.EffectCount=function(a,b){b=b.toLowerCase();var c=null;Q.hasOwnProperty(b)&&(c=Q[b]);a.set_int(c?c.length:0)};G.prototype.AnalyserFreqBinCount=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);b=C(b,c);a.set_int(b?b.node.frequencyBinCount:0)};G.prototype.AnalyserFreqBinAt=function(a,b,c,d){b=b.toLowerCase();c=Math.floor(c);d=Math.floor(d);(b=C(b,c))?0>d||d>=b.node.frequencyBinCount?a.set_float(0):
a.set_float(b.freqBins[d]):a.set_float(0)};G.prototype.AnalyserPeakLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=C(b,c))?a.set_float(b.peak):a.set_float(0)};G.prototype.AnalyserRMSLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=C(b,c))?a.set_float(b.rms):a.set_float(0)};D.exps=new G})();cr.plugins_.Browser=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){"undefined"!==typeof jQuery&&f.setSize(jQuery(window).width(),jQuery(window).height())}function d(){}var e=cr.plugins_.Browser.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};e.Instance.prototype.onCreate=function(){var a=this;window.addEventListener("resize",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize,
a)});"undefined"!==typeof navigator.onLine&&(window.addEventListener("online",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline,a)}),window.addEventListener("offline",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline,a)}));"undefined"!==typeof window.applicationCache&&(window.applicationCache.addEventListener("updateready",function(){a.runtime.loadingprogress=1;a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),window.applicationCache.addEventListener("progress",
function(b){a.runtime.loadingprogress=b.loaded/b.total}));this.runtime.isDirectCanvas||(document.addEventListener("appMobi.device.update.available",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),document.addEventListener("backbutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a)}),document.addEventListener("menubutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a)}),document.addEventListener("searchbutton",
function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton,a)}),document.addEventListener("tizenhwkey",function(b){var c;switch(b.keyName){case "back":c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a);!c&&window.tizen&&window.tizen.application.getCurrentApplication().exit();break;case "menu":(c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a))||b.preventDefault()}}));this.runtime.addSuspendCallback(function(b){b?a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden,
a):a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible,a)});this.is_arcade="undefined"!==typeof window.is_scirra_arcade};a.prototype.CookiesEnabled=function(){return navigator?navigator.cookieEnabled:!1};a.prototype.IsOnline=function(){return navigator?navigator.onLine:!1};a.prototype.HasJava=function(){return navigator?navigator.javaEnabled():!1};a.prototype.OnOnline=function(){return!0};a.prototype.OnOffline=function(){return!0};a.prototype.IsDownloadingUpdate=function(){return"undefined"===
typeof window.applicationCache?!1:window.applicationCache.status===window.applicationCache.DOWNLOADING};a.prototype.OnUpdateReady=function(){return!0};a.prototype.PageVisible=function(){return!this.runtime.isSuspended};a.prototype.OnPageVisible=function(){return!0};a.prototype.OnPageHidden=function(){return!0};a.prototype.OnResize=function(){return!0};a.prototype.IsFullscreen=function(){return!!(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.runtime.isNodeFullscreen)};
a.prototype.OnBackButton=function(){return!0};a.prototype.OnMenuButton=function(){return!0};a.prototype.OnSearchButton=function(){return!0};a.prototype.IsMetered=function(){var a=navigator.connection||navigator.mozConnection||navigator.webkitConnection;return a?a.metered:!1};a.prototype.IsCharging=function(){var a=navigator.battery||navigator.mozBattery||navigator.webkitBattery;return a?a.charging:!0};a.prototype.IsPortraitLandscape=function(a){return(window.innerWidth<=window.innerHeight?0:1)===
a};e.cnds=new a;b.prototype.Alert=function(a){this.runtime.isDomFree||alert(a.toString())};b.prototype.Close=function(){this.runtime.isCocoonJs?CocoonJS.App.forceToFinish():window.tizen?window.tizen.application.getCurrentApplication().exit():navigator.app&&navigator.app.exitApp?navigator.app.exitApp():navigator.device&&navigator.device.exitApp?navigator.device.exitApp():this.is_arcade||this.runtime.isDomFree||window.close()};b.prototype.Focus=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().focus():
this.is_arcade||this.runtime.isDomFree||window.focus()};b.prototype.Blur=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().blur():this.is_arcade||this.runtime.isDomFree||window.blur()};b.prototype.GoBack=function(){navigator.app&&navigator.app.backHistory?navigator.app.backHistory():this.is_arcade||this.runtime.isDomFree||!window.back||window.back()};b.prototype.GoForward=function(){this.is_arcade||this.runtime.isDomFree||!window.forward||window.forward()};b.prototype.GoHome=function(){this.is_arcade||
this.runtime.isDomFree||!window.home||window.home()};b.prototype.GoToURL=function(a){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.is_arcade||this.runtime.isDomFree||(window.location=a)};b.prototype.GoToURLWindow=function(a,b){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.is_arcade||this.runtime.isDomFree||window.open(a,b)};b.prototype.Reload=function(){this.is_arcade||this.runtime.isDomFree||window.location.reload()};var g=!0,f=null;b.prototype.RequestFullScreen=function(a){this.runtime.isDomFree?
cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored"):(2<=a&&(a+=1),6===a&&(a=2),this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen||(window.nwgui.Window.get().enterFullscreen(),this.runtime.isNodeFullscreen=!0):document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||(this.runtime.fullscreen_scaling=2<=a?a:0,a=this.runtime.canvasdiv||this.runtime.canvas,g&&(g=!1,f=this.runtime,a.addEventListener("mozfullscreenerror",
c),a.addEventListener("webkitfullscreenerror",c),a.addEventListener("msfullscreenerror",c),a.addEventListener("fullscreenerror",c)),cr.is_undefined(a.requestFullscreen)?cr.is_undefined(a.webkitRequestFullScreen)?cr.is_undefined(a.mozRequestFullScreen)?cr.is_undefined(a.msRequestFullscreen)||a.msRequestFullscreen():a.mozRequestFullScreen():"undefined"!==typeof Element&&"undefined"!==typeof Element.ALLOW_KEYBOARD_INPUT?a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):a.webkitRequestFullScreen():
a.requestFullscreen()))};b.prototype.CancelFullScreen=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored"):this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen&&(window.nwgui.Window.get().leaveFullscreen(),this.runtime.isNodeFullscreen=!1):cr.is_undefined(document.exitFullscreen)?cr.is_undefined(document.webkitCancelFullScreen)?cr.is_undefined(document.mozCancelFullScreen)?cr.is_undefined(document.msExitFullscreen)||
document.msExitFullscreen():document.mozCancelFullScreen():document.webkitCancelFullScreen():document.exitFullscreen()};b.prototype.Vibrate=function(a){try{var b=a.split(","),c,d;c=0;for(d=b.length;c<d;c++)b[c]=parseInt(b[c],10);navigator.vibrate?navigator.vibrate(b):navigator.mozVibrate?navigator.mozVibrate(b):navigator.webkitVibrate?navigator.webkitVibrate(b):navigator.msVibrate&&navigator.msVibrate(b)}catch(e){}};b.prototype.InvokeDownload=function(a,b){var c=document.createElement("a");if("undefined"===
typeof c.download)window.open(a);else{var d=document.getElementsByTagName("body")[0];c.textContent=b;c.href=a;c.download=b;d.appendChild(c);var e=document.createEvent("MouseEvent");e.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);c.dispatchEvent(e);d.removeChild(c)}};b.prototype.InvokeDownloadString=function(a,b,c){var d="data:"+b+","+encodeURIComponent(a);a=document.createElement("a");"undefined"===typeof a.download?window.open(d):(b=document.getElementsByTagName("body")[0],a.textContent=
c,a.href=d,a.download=c,b.appendChild(a),c=document.createEvent("MouseEvent"),c.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null),a.dispatchEvent(c),b.removeChild(a))};b.prototype.ConsoleLog=function(a,b){"undefined"!==typeof console&&(0===a&&console.log&&console.log(b.toString()),1===a&&console.warn&&console.warn(b.toString()),2===a&&console.error&&console.error(b.toString()))};b.prototype.ConsoleGroup=function(a){console&&console.group&&console.group(a)};b.prototype.ConsoleGroupEnd=
function(){console&&console.groupEnd&&console.groupEnd()};b.prototype.ExecJs=function(a){eval&&eval(a)};var l="portrait landscape portrait-primary portrait-secondary landscape-primary landscape-secondary".split(" ");b.prototype.LockOrientation=function(a){a=Math.floor(a);0>a||a>=l.length||(this.runtime.autoLockOrientation=!1,a=l[a],screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&
screen.msLockOrientation(a))};b.prototype.UnlockOrientation=function(){this.runtime.autoLockOrientation=!1;screen.unlockOrientation?screen.unlockOrientation():screen.webkitUnlockOrientation?screen.webkitUnlockOrientation():screen.mozUnlockOrientation?screen.mozUnlockOrientation():screen.msUnlockOrientation&&screen.msUnlockOrientation()};e.acts=new b;d.prototype.URL=function(a){a.set_string(this.runtime.isDomFree?"":window.location.toString())};d.prototype.Protocol=function(a){a.set_string(this.runtime.isDomFree?
"":window.location.protocol)};d.prototype.Domain=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hostname)};d.prototype.PathName=function(a){a.set_string(this.runtime.isDomFree?"":window.location.pathname)};d.prototype.Hash=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hash)};d.prototype.Referrer=function(a){a.set_string(this.runtime.isDomFree?"":document.referrer)};d.prototype.Title=function(a){a.set_string(this.runtime.isDomFree?"":document.title)};d.prototype.Name=
function(a){a.set_string(this.runtime.isDomFree?"":navigator.appName)};d.prototype.Version=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appVersion)};d.prototype.Language=function(a){navigator&&navigator.language?a.set_string(navigator.language):a.set_string("")};d.prototype.Platform=function(a){a.set_string(this.runtime.isDomFree?"":navigator.platform)};d.prototype.Product=function(a){navigator&&navigator.product?a.set_string(navigator.product):a.set_string("")};d.prototype.Vendor=
function(a){navigator&&navigator.vendor?a.set_string(navigator.vendor):a.set_string("")};d.prototype.UserAgent=function(a){a.set_string(this.runtime.isDomFree?"":navigator.userAgent)};d.prototype.QueryString=function(a){a.set_string(this.runtime.isDomFree?"":window.location.search)};d.prototype.QueryParam=function(a,b){if(this.runtime.isDomFree)a.set_string("");else{var c=RegExp("[?&]"+b+"=([^&]*)").exec(window.location.search);c?a.set_string(decodeURIComponent(c[1].replace(/\+/g," "))):a.set_string("")}};
d.prototype.Bandwidth=function(a){var b=navigator.connection||navigator.mozConnection||navigator.webkitConnection;b?a.set_float(b.bandwidth):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.BatteryLevel=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.level):a.set_float(1)};d.prototype.BatteryTimeLeft=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.dischargingTime):a.set_float(Number.POSITIVE_INFINITY)};
d.prototype.ExecJS=function(a,b){if(eval){var c=eval(b);"number"===typeof c?a.set_any(c):"string"===typeof c?a.set_any(c):"boolean"===typeof c?a.set_any(c?1:0):a.set_any(0)}else a.set_any(0)};d.prototype.ScreenWidth=function(a){a.set_int(screen.width)};d.prototype.ScreenHeight=function(a){a.set_int(screen.height)};d.prototype.DevicePixelRatio=function(a){a.set_float(this.runtime.devicePixelRatio)};e.exps=new d})();cr.plugins_.Button=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.plugins_.Button.prototype;c.Type=function(a){this.plugin=a;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a){this.type=a;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Button plugin not supported on this platform - the object will not be created"):(this.isCheckbox=1===this.properties[0],this.inputElem=document.createElement("input"),this.elem=
this.isCheckbox?document.createElement("label"):this.inputElem,this.labelText=null,this.inputElem.type=this.isCheckbox?"checkbox":"button",this.inputElem.id=this.properties[6],jQuery(this.elem).appendTo(this.runtime.canvasdiv?this.runtime.canvasdiv:"body"),this.isCheckbox?(jQuery(this.inputElem).appendTo(this.elem),this.labelText=document.createTextNode(this.properties[1]),jQuery(this.elem).append(this.labelText),this.inputElem.checked=0!==this.properties[7],jQuery(this.elem).css("font-family","sans-serif"),
jQuery(this.elem).css("display","inline-block"),jQuery(this.elem).css("color","black")):this.inputElem.value=this.properties[1],this.elem.title=this.properties[2],this.inputElem.disabled=0===this.properties[4],this.autoFontSize=0!==this.properties[5],this.element_hidden=!1,0===this.properties[3]&&(jQuery(this.elem).hide(),this.visible=!1,this.element_hidden=!0),this.inputElem.onclick=function(a){return function(b){b.stopPropagation();a.runtime.isInUserInputEvent=!0;a.runtime.trigger(cr.plugins_.Button.prototype.cnds.OnClicked,
a);a.runtime.isInUserInputEvent=!1}}(this),this.elem.addEventListener("touchstart",function(a){a.stopPropagation()},!1),this.elem.addEventListener("touchmove",function(a){a.stopPropagation()},!1),this.elem.addEventListener("touchend",function(a){a.stopPropagation()},!1),jQuery(this.elem).mousedown(function(a){a.stopPropagation()}),jQuery(this.elem).mouseup(function(a){a.stopPropagation()}),jQuery(this.elem).keydown(function(a){a.stopPropagation()}),jQuery(this.elem).keyup(function(a){a.stopPropagation()}),
this.lastWinHeight=this.lastWinWidth=this.lastBottom=this.lastRight=this.lastTop=this.lastLeft=0,this.updatePosition(!0),this.runtime.tickMe(this))};d.saveToJSON=function(){var a={tooltip:this.elem.title,disabled:!!this.inputElem.disabled};this.isCheckbox?(a.checked=!!this.inputElem.checked,a.text=this.labelText.nodeValue):a.text=this.elem.value;return a};d.loadFromJSON=function(a){this.elem.title=a.tooltip;this.inputElem.disabled=a.disabled;this.isCheckbox?(this.inputElem.checked=a.checked,this.labelText.nodeValue=
a.text):this.elem.value=a.text};d.onDestroy=function(){this.runtime.isDomFree||(jQuery(this.elem).remove(),this.elem=null)};d.tick=function(){this.updatePosition()};d.updatePosition=function(a){if(!this.runtime.isDomFree){var b=this.layer.layerToCanvas(this.x,this.y,!0),c=this.layer.layerToCanvas(this.x,this.y,!1),d=this.layer.layerToCanvas(this.x+this.width,this.y+this.height,!0),k=this.layer.layerToCanvas(this.x+this.width,this.y+this.height,!1);if(!this.visible||!this.layer.visible||0>=d||0>=k||
b>=this.runtime.width||c>=this.runtime.height)this.element_hidden||jQuery(this.elem).hide(),this.element_hidden=!0;else{1>b&&(b=1);1>c&&(c=1);d>=this.runtime.width&&(d=this.runtime.width-1);k>=this.runtime.height&&(k=this.runtime.height-1);var h=window.innerWidth,m=window.innerHeight;a||this.lastLeft!==b||this.lastTop!==c||this.lastRight!==d||this.lastBottom!==k||this.lastWinWidth!==h||this.lastWinHeight!==m?(this.lastLeft=b,this.lastTop=c,this.lastRight=d,this.lastBottom=k,this.lastWinWidth=h,this.lastWinHeight=
m,this.element_hidden&&(jQuery(this.elem).show(),this.element_hidden=!1),a=Math.round(b)+jQuery(this.runtime.canvas).offset().left,h=Math.round(c)+jQuery(this.runtime.canvas).offset().top,jQuery(this.elem).css("position","absolute"),jQuery(this.elem).offset({left:a,top:h}),jQuery(this.elem).width(Math.round(d-b)),jQuery(this.elem).height(Math.round(k-c)),this.autoFontSize&&jQuery(this.elem).css("font-size",this.layer.getScale(!0)/this.runtime.devicePixelRatio-0.2+"em")):this.element_hidden&&(jQuery(this.elem).show(),
this.element_hidden=!1)}}};d.draw=function(a){};d.drawGL=function(a){};a.prototype.OnClicked=function(){return!0};a.prototype.IsChecked=function(){return this.isCheckbox&&this.inputElem.checked};c.cnds=new a;b.prototype.SetText=function(a){this.runtime.isDomFree||(this.isCheckbox?this.labelText.nodeValue=a:this.elem.value=a)};b.prototype.SetTooltip=function(a){this.runtime.isDomFree||(this.elem.title=a)};b.prototype.SetVisible=function(a){this.runtime.isDomFree||(this.visible=0!==a)};b.prototype.SetEnabled=
function(a){this.runtime.isDomFree||(this.inputElem.disabled=0===a)};b.prototype.SetFocus=function(){this.runtime.isDomFree||this.inputElem.focus()};b.prototype.SetBlur=function(){this.runtime.isDomFree||this.inputElem.blur()};b.prototype.SetCSSStyle=function(a,b){this.runtime.isDomFree||jQuery(this.elem).css(a,b)};b.prototype.SetChecked=function(a){!this.runtime.isDomFree&&this.isCheckbox&&(this.inputElem.checked=1===a)};b.prototype.ToggleChecked=function(){!this.runtime.isDomFree&&this.isCheckbox&&
(this.inputElem.checked=!this.inputElem.checked)};c.acts=new b;c.exps=new function(){}})();cr.plugins_.CJSAds=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d="",e=[],g=0,f=0,l=!1,k=!1,h=!1,m=cr.plugins_.CJSAds.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};m.Type.prototype.onCreate=function(){};m.Instance=function(a){this.type=a;this.runtime=a.runtime};m.Instance.prototype.onCreate=function(){this.isShowingFullscreen=this.isShowingBanner=!1;this.triggerProduct="";this.socialService=null;this.socialServiceAvailable=!1;this.storeServiceAvailable=this.runtime.isCocoonJs&&"undefined"!==
typeof CocoonJS.Store.nativeExtensionObjectAvailable;this.storeManaged=1!==this.properties[0];this.storeSandboxed=0!==this.properties[1];this.onConsumePurchaseCompleted=this.onConsumePurchaseFailedTransactionId="";var a=this;this.runtime.isCocoonJs&&(CocoonJS.App.onTextDialogFinished.addEventListener(function(b){d=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK,a)}),CocoonJS.App.onTextDialogCancelled.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
a)}),CocoonJS.Ad.onBannerShown.addEventListener(function(){a.isShowingBanner=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,a)}),CocoonJS.Ad.onBannerReady.addEventListener(function(){k=!0;l||(CocoonJS.Ad.setBannerLayout(f),CocoonJS.Ad.showBanner())}),CocoonJS.Ad.onFullScreenShown.addEventListener(function(){a.isShowingFullscreen=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown,a)}),CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){a.isShowingFullscreen=
!1;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden,a)}),CocoonJS.Ad.onFullScreenReady.addEventListener(function(){h=!0;preloadFullScreen||CocoonJS.Ad.showFullScreen()}),this.storeServiceAvailable&&(CocoonJS.Store.onProductPurchaseCompleted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,a);CocoonJS.Store.addPurchase(b);CocoonJS.Store.consumePurchase(b.transactionId,b.productId);CocoonJS.Store.finishPurchase(b.transactionId)}),
CocoonJS.Store.onConsumePurchaseFailed.addEventListener(function(b,c){this.onConsumePurchaseFailedTransactionId=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed,a)}),CocoonJS.Store.onConsumePurchaseCompleted.addEventListener(function(b){this.onConsumePurchaseCompleted=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted,a)}),CocoonJS.Store.onProductPurchaseFailed.addEventListener(function(b,c){a.triggerProduct=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
a)}),CocoonJS.Store.onProductPurchaseStarted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,a)}),CocoonJS.Store.onProductsFetchStarted.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted,a)}),CocoonJS.Store.onProductsFetchFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,a)}),CocoonJS.Store.onProductsFetchCompleted.addEventListener(function(b){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,
a)}),CocoonJS.Store.requestInitialization({managed:this.storeManaged,sandbox:this.storeSandboxed}),CocoonJS.Store.start()),this.socialService=CocoonJS.SocialGaming.GameCenter,this.socialServiceAvailable=!!this.socialService.nativeExtensionObjectAvailable,this.socialService.onRequestLoginSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess,a)}),this.socialService.onRequestLoginFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail,
a)}),this.socialService.onLogout.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout,a)}),this.socialService.onRequestUserScoreSucceed.addEventListener(function(b){g=b.score||0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived,a)}),this.socialService.onRequestUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable,a)}),this.socialService.onSubmitUserScoreSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess,
a)}),this.socialService.onSubmitUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail,a)}),this.socialService.onLeaderboardViewSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen,a)}),this.socialService.onLeaderboardViewClosed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose,a)}))};a.prototype.IsShowingBanner=function(){return this.isShowingBanner};
a.prototype.IsCocoonJS=function(){return this.runtime.isCocoonJs};a.prototype.OnBannerShown=function(){return!0};a.prototype.OnFullscreenShown=function(){return!0};a.prototype.OnFullscreenHidden=function(){return!0};a.prototype.IsShowingFullscreen=function(){return this.isShowingFullscreen};a.prototype.IsStoreAvailable=function(){return this.runtime.isCocoonJs?this.storeServiceAvailable&&CocoonJS.Store.canPurchase():!1};a.prototype.OnPurchaseStart=function(a){return this.triggerProduct===a};a.prototype.OnPurchaseComplete=
function(a){return this.triggerProduct===a};a.prototype.OnPurchaseFail=function(a){return this.triggerProduct===a};a.prototype.onProductsFetchStarted=function(){return!0};a.prototype.onConsumePurchaseFailed=function(){return!0};a.prototype.onProductsFetchCompleted=function(){return!0};a.prototype.onProductsFetchFailed=function(){return!0};a.prototype.IsProductPurchased=function(a){return this.runtime.isCocoonJs?CocoonJS.Store.isProductPurchased(a):!1};a.prototype.OnKeyboardCancelled=function(){return!0};
a.prototype.OnKeyboardOK=function(){return!0};a.prototype.IsGCAvailable=function(){return this.socialServiceAvailable};a.prototype.IsGCLoggedIn=function(){return this.socialServiceAvailable?this.socialService.isLoggedIn():!1};a.prototype.OnGCLoginSuccess=function(){return!0};a.prototype.OnGCLoginFail=function(){return!0};a.prototype.OnGCLogout=function(){return!0};a.prototype.OnGCScoreReceived=function(){return!0};a.prototype.OnGCScoreUnavailable=function(){return!0};a.prototype.OnGCScoreSubmitSuccess=
function(){return!0};a.prototype.OnGCScoreSubmitFail=function(){return!0};a.prototype.OnGCLeaderboardOpen=function(){return!0};a.prototype.OnGCLeaderboardClose=function(){return!0};m.cnds=new a;b.prototype.ShowBanner=function(a){this.runtime.isCocoonJs&&(f=0===a?CocoonJS.Ad.BannerLayout.TOP_CENTER:CocoonJS.Ad.BannerLayout.BOTTOM_CENTER,l=!1,k?(CocoonJS.Ad.setBannerLayout(f),CocoonJS.Ad.showBanner()):CocoonJS.Ad.preloadBanner())};b.prototype.ShowFullscreen=function(){this.runtime.isCocoonJs&&(h?CocoonJS.Ad.showFullScreen():
CocoonJS.Ad.preloadFullScreen())};b.prototype.HideBanner=function(){this.runtime.isCocoonJs&&(CocoonJS.Ad.hideBanner(),this.isShowingBanner=!1)};b.prototype.PreloadBanner=function(){this.runtime.isCocoonJs&&(l=!0,CocoonJS.Ad.preloadBanner())};b.prototype.PreloadFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.preloadFullScreen()};b.prototype.RefreshBanner=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshBanner()};b.prototype.RefreshFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshFullScreen()};
b.prototype.Purchase=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProduct(a)};b.prototype.fetchProductsFromStore=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.fetchProductsFromStore(a.split(","))};b.prototype.restorePurchases=function(){if(this.runtime.isCocoonJs)return CocoonJS.Store.restorePurchases()};b.prototype.PurchasePreview=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProductModalWithPreview(a)};b.prototype.RestorePurchases=function(){this.runtime.isCocoonJs&&
CocoonJS.Store.restorePurchases()};b.prototype.PromptKeyboard=function(a,b,c,d,e,f){this.runtime.isCocoonJs&&CocoonJS.App.showTextDialog(a,b,c,["text","num","phone","email","url"][d],e,f)};b.prototype.UpdateProductsList=function(){this.runtime.isCocoonJs&&CocoonJS.Store.canPurchase()&&(e=CocoonJS.Store.getProducts())};b.prototype.GCLogin=function(){this.socialServiceAvailable&&!this.socialService.isLoggedIn()&&this.socialService.requestLogin()};b.prototype.GCLogout=function(){this.socialServiceAvailable&&
this.socialService.isLoggedIn()&&this.socialService.requestLogout()};b.prototype.GCSubmitScore=function(a,b){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.submitUserScore(a,b)};b.prototype.GCRequestScore=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.requestUserScore(a)};b.prototype.GCOpenLeaderboard=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.showLeaderboardView(a)};m.acts=
new b;c.prototype.InputText=function(a){a.set_string(d)};c.prototype.ProductCount=function(a){a.set_int(e.length)};c.prototype.ProductDescription=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].description)};c.prototype.ProductLocalizedPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].localizedPrice)};c.prototype.ProductPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].price)};c.prototype.ProductAlias=
function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productAlias)};c.prototype.ProductID=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productId)};c.prototype.ProductTitle=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].title)};c.prototype.GameCenterScore=function(a){a.set_float(g)};m.exps=new c})();cr.plugins_.Clay=function(a){this.runtime=a};
(function(){var a=cr.plugins_.Clay.prototype;a.Type=function(a){this.plugin=a;this.runtime=a.runtime};var b=null,c=null,d,e,g,f=!1,l=!1,k={},h,m="",n,p=0,q=0,r=0,t="",s=0,u=0,A=0,E,I="",z,v,F=0;a.Type.prototype.onCreate=function(){};a.Instance=function(a){this.type=a;this.runtime=a.runtime};var x=a.Instance.prototype,y=function(){if(cr_getC2Runtime().uses_loader_layout)return!1;var a=cr_getC2Runtime(),b=a&&a.progress?a.progress:0,c,d,e,f,h,g,k,m,l,q,r=document.getElementById("c2canvas");c=document.createElement("canvas");
c.style.background="#000";d=c.getContext("2d");document.getElementById("c2canvasdiv").appendChild(c);var n=new Image;n.src="http://clay.io/images/full-logo-free-games.svg";var t=new Image;t.src="http://clay.io/images/docs/c2.svg";var s=a.loaderlogo,p=function(){s.onload=n.onload=t.onload=function(){};c.width=a.width;c.height=a.height;c.style.position="absolute";c.style.zIndex="5";c.style.left=r.offsetLeft+"px";c.style.top=r.offsetTop+"px";c.setAttribute("style",c.getAttribute("style")+" -ms-touch-action: none;");
l=c.width/1E3;q=c.height/1E3;k=0;var b=200*q,p=k+=50*q,I=function(){var a=s.width/s.height*b;d.drawImage(s,500*l-a/2,p,a,b)};s&&s.complete?I():s&&(s.onload=function(){I()});k+=b;e=750*l;f=100*q;h=125*l;g=30*q;m=k+=g;var u=d.createLinearGradient(0,m,0,m+f);u.addColorStop(0,"#fff");u.addColorStop(1,"#ccc");d.fillStyle=u;d.strokeStyle="#777";d.lineWidth=4*l;k+=30*q;u=30*q;d.font=u+"px sans-serif, Verdana, Arial";var v=d.measureText("Powered By"),v=500*l-v.width/2;k+=f+u;d.fillText("Powered By",v,k);
k+=10*q;var w=function(){var a=100*q,b=n.width/n.height*a,e=450*l-b,f=k;d.drawImage(n,e,f,b,a);var h=!1;c.onmousemove=function(d){var g=d.pageX||d.clientX;d=d.pageY||d.clientY;g-=c.offsetLeft;d-=c.offsetTop;g>=e&&g<=e+b&&d>=f&&d<=f+a?(h=!0,c.style.cursor="pointer"):h&&(h=!1,c.style.cursor="default")};c.onclick=function(){h&&window.open("http://clay.io/play")}};n&&n.complete?w():n&&(n.onload=function(){w()});var z=function(){var a=100*q;d.drawImage(t,650*l,k,t.width/t.height*a,a)};t&&t.complete?z():
t&&(t.onload=function(){z()})},I=r.width,u=r.height,v=function(){if(I!=r.width||u!=r.height)p(),I=r.width,u=r.height;var g=a&&a.progress?a.progress:0;b<g&&(b+=0.01);1<=g&&(b=1);d.fillRect(h,m,b*e,f);d.strokeRect(h,m,e,f);1>g?setTimeout(v,32):c.parentNode.removeChild(c)};v()};x.onCreate=function(){0==this.properties[3]&&y();b=this.runtime;c=this;var a=0==this.properties[1],h=0==this.properties[2]?!1:"c2canvasdiv";if(window.c2cocoonjs){var g=this,k=!1;"undefined"===typeof window.Clay&&(window.Clay=
{});d=window.Clay;d.UI={modalsOpen:function(){return F}};CocoonJS.App.onLoadInTheWebViewSucceed.addEventListener(function(){k||(k=!0,CocoonJS.App.forwardAsync("CocoonJS['App']['hide']();"),CocoonJS.App.forwardAsync("load_clay( '"+g.properties[0]+"', "+a+" );"))});CocoonJS.App.loadInTheWebView("webview/webview.html")}else"undefined"===typeof window.Clay&&(window.Clay={}),d=window.Clay,d.options=d.options||{},d.options.debug=a,d.options.DOMid=h,d.options.fail=function(){l=!0},d.gameKey=this.properties[0],
d.readyFunctions=d.readyFunctions||[],d.ready=function(a){d.readyFunctions.push(a)},d.documentReadyFunctions=d.documentReadyFunctions||[],d.documentReady=function(a){d.documentReadyFunctions.push(a)},d.Stats=d.Stats||{},d.Stats.level=d.Stats.level||function(){},d.PROTOCOL="chrome-extension:"==document.location.protocol||"file:"==document.location.protocol?"https://":"ms-appx:"==document.location.protocol?"http://":document.location.protocol+"//",d.source||function(){var a=document.createElement("script");
a.src=window.Clay.PROTOCOL+"clay.io/api/api.js";var b=document.getElementsByTagName("script")[0];b.parentNode.insertBefore(a,b)}(),d.ready(function(){f=!0;e=new d.Payment})};x.draw=function(a){};x.drawGL=function(a){};a.cnds={};x=a.cnds;x.clayready=function(){var a=f;a&&(f=!1);return a};x.cdns_failed_to_load=function(){var a=l;a&&(l=!1);return a};x.cdns_leaderboard_post=function(){return!0};x.cdns_leaderboard_fetch=function(){return!0};x.cdns_achievement_award=function(){return!0};x.cdns_achievement_fetch=
function(){return!0};x.cdns_screenshot_take=function(){return!0};x.cdns_facebook_post=function(){return!0};x.cdns_facebook_invite=function(){return!0};x.cdns_twitter_post=function(){return!0};x.cdns_clay_post=function(){return!0};x.cdns_social_share=function(){return!0};x.cdns_clay_add_payment_item=function(){return!0};x.cdns_clay_checkout=function(){return!0};x.cdns_clay_checkout_fail=function(){return!0};x.cdns_clay_rooms_show=function(){return!0};x.cdns_clay_rooms_full=function(){return!0};x.cdns_clay_fetch_data=
function(){return!0};x.cdns_clay_save_data=function(){return!0};x.cdns_clay_prompt_login=function(){return!0};x.cdns_clay_prompt_logout=function(){return!0};x.cdns_clay_fetch_items=function(){return!0};x.cdns_clay_set_game_key=function(){return!0};a.acts={};x=a.acts;window.clay_from_cocoon_ready=function(a,b,c,e,h){d.isReady=!0;d.Player={identifier:a,data:{username:b},loggedIn:c,clearance:e,hasInstalled:function(){return h}};f=!0};window.clay_from_cocoon_user_ready=function(a,b,c,e,f){d.Player={identifier:a,
data:{username:b},loggedIn:c,clearance:e,hasInstalled:function(){return f}}};window.clay_from_cocoon_fail=function(){l=!0};window.clay_modal_count=function(a){F=parseInt(a)};x.log_play=function(){d.Stats.logStat({name:"Plays"})};x.log_stat=function(a,b){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['logStat']( { name: '"+a+"', quantity: "+b+" } );"):d.Stats.logStat({name:a,quantity:b})};x.level_start=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['level']( { action: 'start', level: level } );"):
d.Stats.level({action:"start",level:a})};x.level_success=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['level']( { action: 'pass', level: level } );"):d.Stats.level({action:"pass",level:a})};x.level_fail=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['level']( { action: 'fail', level: level } );"):d.Stats.level({action:"fail",level:a})};x.leaderboards_post=function(a,e,f,h){if(window.c2cocoonjs){var g="";"string"==typeof f&&(g+="'");g+=f;"string"==
typeof f&&(g+="'");CocoonJS.App.forwardAsync("leaderboards_post( '"+a+"', '"+e+"', "+g+", '"+h+"' );")}else a={name:a},a.score=e?e:0,0!=h&&(a.hideUI=!0),(new d.Leaderboard({id:f})).post(a,function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_post,c)})};window.clay_from_cocoon_leaderboards_post=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_post,c)};x.leaderboards_post_encrypted=function(a,e){if(window.c2cocoonjs){var f="";"string"==typeof a&&(f+="'");f+=a;"string"==
typeof a&&(f+="'");CocoonJS.App.forwardAsync("leaderboards_post_encrypted( "+f+", '"+e+"' );")}else(new d.Leaderboard({id:a})).post(e,function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_post,c)})};x.leaderboards_show=function(a,b,c,e,f,h){if(window.c2cocoonjs){var g="";"string"==typeof a&&(g+="'");g+=a;"string"==typeof a&&(g+="'");CocoonJS.App.forwardAsync("leaderboards_show( "+g+", "+b+", "+c+", "+e+", "+f+", "+h+" );")}else{g=0;h||(h=10);switch(b){case 0:g=0;break;case 1:g=2592E3;
break;case 2:g=604800;break;case 3:g=86400;break;default:g=0}b={cumulative:1===c,best:2===c,self:1===f?!0:!1,friends:2===f?!0:!1,recent:g,sort:1===e?"asc":"desc",limit:h};(new d.Leaderboard({id:a})).show(b)}};x.leaderboards_fetch=function(a,e,f,h,g,k){if(window.c2cocoonjs){var m="";"string"==typeof a&&(m+="'");m+=a;"string"==typeof a&&(m+="'");CocoonJS.App.forwardAsync("leaderboards_fetch( "+m+", "+e+", "+f+", "+h+", "+g+", "+k+" );")}else{m=0;k||(k=10);switch(e){case 0:m=0;break;case 1:m=2592E3;
break;case 2:m=604800;break;case 3:m=86400;break;default:m=0}e={cumulative:1===f,best:2===f,self:1===g?!0:!1,friends:2===g?!0:!1,recent:m,sort:1===h?"asc":"desc",limit:k,getRank:!0};(new d.Leaderboard({id:a})).fetch(e,function(d){n=d.data||[];d.rank.rank&&(q=d.rank.rank,r=d.rank.row.score,t=d.rank.row.name);p=d&&d.data?d.data.length-1:-1;0>p&&(p=0);z=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_fetch,c)})}};window.clay_from_cocoon_leaderboards_fetch=function(a,d,e,f,h,g){n=JSON.parse(d);
p=e;q=f;r=h;t=g;z=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_fetch,c)};x.leaderboards_hide=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-leaderboard-wrapper' );"):d.UI.closeModal("clay-leaderboard-wrapper")};x.close_modal=function(a){window.c2cocoonjs?a?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-"+a+"-wrapper' );"):CocoonJS.App.forwardAsync("Clay['UI']['closeModal']();"):a?d.UI.closeModal("clay-"+a+"-wrapper"):d.UI.closeModal()};
x.achievements_award=function(a,e){if(window.c2cocoonjs){var f="";"string"==typeof a&&(f+="'");f+=a;"string"==typeof a&&(f+="'");CocoonJS.App.forwardAsync("achievements_award( "+f+", "+e+" );")}else f={id:a},0!=e&&(f.hideUI=!0),(new d.Achievement(f)).award(function(d){d.success&&(k[a]=d,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_award,c))})};window.clay_from_cocoon_achievements_award=function(a,d){k[a]=JSON.parse(d);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_award,
c)};x.achievements_fetch=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("achievements_fetch_all();"):d.Achievement.fetchAll({},function(a){h=a.data;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_fetch,c)})};window.clay_from_cocoon_achievements_fetch=function(a){h=JSON.parse(a);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_fetch,c)};x.achievements_award_encrypted=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("achievements_award_encrypted( '"+a+"' );"):(new d.Achievement({jwt:a})).award(function(a){a.success&&
b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_award,c)})};x.achievements_show_all=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("achievements_show_all();"):d.Achievement.showAll()};x.screenshot_show=function(a,e){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("screenshot_show( '"+a+"', "+e+" );");else{var f=new d.Screenshot({prompt:!1});f.data=a;var h={};0!=e&&(h.hideUI=!0);f.save(h,function(a){a.success&&(m=a.imageSrc,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_screenshot_take,
c))})}};window.clay_from_cocoon_screenshot_show=function(a){m=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_screenshot_take,c)};x.suggestions_show=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("new Clay['Suggestions']();"):new d.Suggestions};x.suggestions_hide=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-suggestions-wrapper' );"):d.UI.closeModal("clay-suggestions-wrapper")};x.ratings_show=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("new Clay['Ratings']();"):
new d.Ratings};x.ratings_hide=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-ratings-wrapper' );"):d.UI.closeModal("clay-ratings-wrapper")};x.facebook_post=function(a,e,f,h){window.c2cocoonjs?CocoonJS.App.forwardAsync("facebook_post( '"+a+"', '"+e+"', '"+f+"', "+h+" );"):(a={message:a},""!=e&&(a.link=e),""!=f&&(a.picture=f),0!=h&&(a.hideUI=!0),d.Facebook.post(a,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_post,c)}))};window.clay_from_cocoon_facebook_post=
function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_post,c)};x.facebook_invite=function(a){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("facebook_invite( '"+a+"' );");else{var e={};""!==a&&(e.caption=a);d.Facebook.invite(e,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_invite,c)})}};window.clay_from_cocoon_facebook_invite=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_invite,c)};x.twitter_post=function(a,e){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("twitter_post( '"+
a.replace("'","'")+"', "+e+" );");else{var f={message:a};0!=e&&(f.hideUI=!0);d.Twitter.post(f,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_twitter_post,c)})}};window.clay_from_cocoon_twitter_post=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_twitter_post,c)};x.clay_post=function(a,e){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("clay_post( '"+a.replace("'","'")+"', "+e+" );");else{var f={message:a};0!=e&&(f.hideUI=!0);d.Stream.post(f,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_post,
c)})}};window.clay_from_cocoon_clay_post=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_post,c)};x.social_share=function(a){d.Social.share({message:a},function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_social_share,c)})};x.clay_add_payment_item=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("add_payment_item( "+a+" );"):e.addItem({id:a},function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_add_payment_item,c)})};window.clay_from_cocoon_add_payment_item=
function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_add_payment_item,c)};x.clay_remove_payment_item=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("ClayPay['removeItem']( { id: "+a+" } );"):e.removeItem({id:a})};x.clay_checkout=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_checkout();"):e.checkout(function(a){a.success?(s=a.itemIds,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)):a.jwt?(s=a.jwt,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,
c)):b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout_fail,c)})};window.clay_from_cocoon_clay_checkout=function(a){s=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)};window.clay_from_cocoon_clay_checkout_fail=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout_fail,c)};x.clay_fetch_items=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_fetch_items();"):d.Player.fetchItems(function(a){v=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_items,
c)})};window.clay_from_cocoon_clay_fetch_items=function(a){v=JSON.parse(a);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_items,c)};x.clay_purchase_game=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_purchase_game();"):d.Player.purchaseGame(function(a){a.success?(s=a.itemIds,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)):a.jwt?(s=a.jwt,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)):b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout_fail,
c)})};x.clay_remove_player_item=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_remove_player_item( "+a+" );"):d.Player.removeItem({id:a},function(a){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_remove_player_item,c)})};window.clay_from_cocoon_remove_player_item=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_remove_player_item,c)};x.clay_rooms=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_rooms();"):(g||(g=new d.Rooms(function(a){u=a.count;A=a.id;
b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_full,c)})),g.show(function(a){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_show,c)}))};window.clay_from_cocoon_clay_rooms_show=function(){v=JSON.parse(items);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_show,c)};window.clay_from_cocoon_clay_rooms_full=function(){v=JSON.parse(items);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_full,c)};x.clay_rooms_force_leave=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("ClayRooms['leaveRoom']();"):
g.leaveRoom()};x.clay_fetch_data=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_fetch_data( '"+a.replace("'","'")+"' );"):d.Player.fetchUserData(a,function(d){E=d.data;I=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_data,c)})};window.clay_from_cocoon_clay_fetch_data=function(a,d){E=JSON.parse(a);I=d;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_data,c)};x.clay_save_data=function(a,e){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_save_data( '"+a.replace("'",
"'")+"', '"+e.replace("'","'")+"' );"):d.Player.saveUserData(a,e,function(a){a.success?b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_save_data,c):d.log(a.error)})};window.clay_from_cocoon_clay_save_data=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_save_data,c)};x.clay_prompt_login=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_prompt_login();"):d.Player.signup(function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_login,c)})};window.clay_from_cocoon_clay_prompt_login=
function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_login,c)};x.clay_prompt_logout=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_prompt_logout();"):d.Player.logout({},function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_logout,c)})};window.clay_from_cocoon_clay_prompt_logout=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_logout,c);d.Player.clearance="site";d.Player.data={};d.Player.identifier=0};x.clay_set_game_key=
function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_set_game_key( '"+a+"' );"):d.Game.set({key:a,options:{debug:0==this.properties[1]}},function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_set_game_key,c)})};window.clay_from_cocoon_clay_set_game_key=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_set_game_key,c)};x.cocoon_go_to_link=function(a){window.c2cocoonjs?CocoonJS.App.openURL(a):window.open(a)};a.exps={};a=a.exps;a.Ready=function(a){a.set_int(d&&d.isReady?
1:0)};a.ScreenshotSrc=function(a){a.set_string(m)};a.AwardedAchievementTitle=function(a,b){k[b]&&k[b].title?a.set_string(k[b].title):a.set_string("")};a.AwardedAchievementDescription=function(a,b){k[b]&&k[b].description?a.set_string(k[b].description):a.set_string("")};a.AwardedAchievementIcon=function(a,b){k[b]&&k[b].icon?a.set_string(k[b].icon):a.set_string("")};a.FetchedAchievementTitle=function(a,b){h[b]&&h[b].title?a.set_string(h[b].title):a.set_string("")};a.FetchedAchievementDescription=function(a,
b){h[b]&&h[b].description?a.set_string(h[b].description):a.set_string("")};a.FetchedAchievementIcon=function(a,b){h[b]&&h[b].icon?a.set_string(h[b].icon):a.set_string("")};a.FetchedAchievementEarned=function(a,b){h[b]?a.set_int(h[b].earned?1:0):a.set_int(0)};a.FetchedAchievementCount=function(a){a.set_int(0<h.length?h.length-1:-1)};a.LeaderboardScoreCount=function(a){a.set_int(p)};a.LeaderboardName=function(a,b){"object"!==typeof n||"undefined"===typeof n[b]?a.set_string(""):a.set_string(n[b].name)};
a.LeaderboardScore=function(a,b){"object"!==typeof n||"undefined"===typeof n[b]?a.set_int(0):a.set_int(n[b].score)};a.LeaderboardScoreMe=function(a,b){"object"!==typeof n||"undefined"===typeof n[b]?a.set_int(0):a.set_int(n[b].me?1:0)};a.LeaderboardRank=function(a){a.set_int(q)};a.LeaderboardRankName=function(a){a.set_string(t)};a.LeaderboardRankScore=function(a){a.set_int(r)};a.FetchedLeaderboardID=function(a){a.set_string(z)};a.PaymentItemCount=function(a){a.set_int(s.length-1)};a.PaymentItemId=
function(a,b){"undefined"===typeof s[b]?a.set_int(0):a.set_int(s[b])};a.EncryptedPaymentResponse=function(a){a.set_string(s)};a.RoomCount=function(a){a.set_int(u)};a.RoomId=function(a){a.set_int(A)};a.Data=function(a,b){var c;c="undefined"!==typeof b&&null!==b?E[b]:E;"undefined"===typeof c||null==c?a.set_string(""):"number"===typeof c&&parseInt(c)==c?a.set_int(c):"number"===typeof c?a.set_float(c):"string"===typeof c&&a.set_string(c)};a.FetchedKey=function(a){a.set_string(I)};a.PlayerIdentifier=function(a){a.set_string(d.Player&&
d.Player.identifier?d.Player.identifier:"")};a.PlayerUsername=function(a){a.set_string(d.Player&&d.Player.data&&d.Player.data.username?d.Player.data.username:"Anonymous")};a.LoggedIn=function(a){a.set_int(d.Player?d.Player.loggedIn?1:0:0)};a.Clearance=function(a){a.set_string(d.Player?d.Player.clearance:"none")};a.FetchedItemCount=function(a){a.set_int(v?v.length-1:-1)};a.FetchedItemId=function(a,b){"undefined"===typeof v[b]?a.set_int(0):a.set_int(v[b].id)};a.FetchedItemQuantity=function(a,b){"undefined"===
typeof v[b]?a.set_int(0):a.set_int(v[b].quantity)};a.EncryptedFetchedItems=function(a){a.set_string(v)};a.HasInstalled=function(a){a.set_int(d.Player?d.Player.hasInstalled()?1:0:0)};a.ModalsOpen=function(a){a.set_int(d.UI&&d.UI.modalsOpen?parseInt(d.UI.modalsOpen()):0)}})();cr.plugins_.Keyboard=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(a){a=Math.floor(a);switch(a){case 8:return"backspace";case 9:return"tab";case 13:return"enter";case 16:return"shift";case 17:return"control";case 18:return"alt";case 19:return"pause";case 20:return"capslock";case 27:return"esc";case 33:return"pageup";case 34:return"pagedown";case 35:return"end";case 36:return"home";case 37:return"\u2190";case 38:return"\u2191";case 39:return"\u2192";case 40:return"\u2193";case 45:return"insert";case 46:return"del";
case 91:return"left window key";case 92:return"right window key";case 93:return"select";case 96:return"numpad 0";case 97:return"numpad 1";case 98:return"numpad 2";case 99:return"numpad 3";case 100:return"numpad 4";case 101:return"numpad 5";case 102:return"numpad 6";case 103:return"numpad 7";case 104:return"numpad 8";case 105:return"numpad 9";case 106:return"numpad *";case 107:return"numpad +";case 109:return"numpad -";case 110:return"numpad .";case 111:return"numpad /";case 112:return"F1";case 113:return"F2";
case 114:return"F3";case 115:return"F4";case 116:return"F5";case 117:return"F6";case 118:return"F7";case 119:return"F8";case 120:return"F9";case 121:return"F10";case 122:return"F11";case 123:return"F12";case 144:return"numlock";case 145:return"scroll lock";case 186:return";";case 187:return"=";case 188:return",";case 189:return"-";case 190:return".";case 191:return"/";case 192:return"'";case 219:return"[";case 220:return"\\";case 221:return"]";case 222:return"#";case 223:return"`";default:return String.fromCharCode(a)}}
var d=cr.plugins_.Keyboard.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a){this.type=a;this.runtime=a.runtime;this.keyMap=Array(256);this.usedKeys=Array(256);this.triggerKey=0};var e=d.Instance.prototype;e.onCreate=function(){var a=this;this.runtime.isDomFree||(jQuery(document).keydown(function(b){a.onKeyDown(b)}),jQuery(document).keyup(function(b){a.onKeyUp(b)}))};var g=[32,33,34,35,36,37,38,39,40,44];e.onKeyDown=function(a){var b=
!1;window!=window.top&&-1<g.indexOf(a.which)&&(a.preventDefault(),b=!0,a.stopPropagation());if(this.keyMap[a.which])this.usedKeys[a.which]&&!b&&a.preventDefault();else{this.keyMap[a.which]=!0;this.triggerKey=a.which;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,this);var c=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKey,this),d=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCode,this);this.runtime.isInUserInputEvent=
!1;if(c||d)this.usedKeys[a.which]=!0,b||a.preventDefault()}};e.onKeyUp=function(a){this.keyMap[a.which]=!1;this.triggerKey=a.which;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKeyReleased,this);var b=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyReleased,this),c=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCodeReleased,this);this.runtime.isInUserInputEvent=!1;if(b||c||this.usedKeys[a.which])this.usedKeys[a.which]=
!0,a.preventDefault()};e.saveToJSON=function(){return{triggerKey:this.triggerKey}};e.loadFromJSON=function(a){this.triggerKey=a.triggerKey};a.prototype.IsKeyDown=function(a){return this.keyMap[a]};a.prototype.OnKey=function(a){return a===this.triggerKey};a.prototype.OnAnyKey=function(a){return!0};a.prototype.OnAnyKeyReleased=function(a){return!0};a.prototype.OnKeyReleased=function(a){return a===this.triggerKey};a.prototype.IsKeyCodeDown=function(a){a=Math.floor(a);return 0>a||a>=this.keyMap.length?
!1:this.keyMap[a]};a.prototype.OnKeyCode=function(a){return a===this.triggerKey};a.prototype.OnKeyCodeReleased=function(a){return a===this.triggerKey};d.cnds=new a;d.acts=new function(){};b.prototype.LastKeyCode=function(a){a.set_int(this.triggerKey)};b.prototype.StringFromKeyCode=function(a,b){a.set_string(c(b))};d.exps=new b})();cr.plugins_.Mouse=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.plugins_.Mouse.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a){this.type=a;this.runtime=a.runtime;this.buttonMap=Array(4);this.triggerDir=this.triggerType=this.triggerButton=this.mouseYcanvas=this.mouseXcanvas=0;this.handled=!1};var e=d.Instance.prototype;e.onCreate=function(){var a=this;if(!this.runtime.isDomFree){jQuery(document).mousemove(function(b){a.onMouseMove(b)});
jQuery(document).mousedown(function(b){a.onMouseDown(b)});jQuery(document).mouseup(function(b){a.onMouseUp(b)});jQuery(document).dblclick(function(b){a.onDoubleClick(b)});var b=function(b){a.onWheel(b)};document.addEventListener("mousewheel",b,!1);document.addEventListener("DOMMouseScroll",b,!1)}};var g={left:0,top:0};e.onMouseMove=function(a){var b=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset();this.mouseXcanvas=a.pageX-b.left;this.mouseYcanvas=a.pageY-b.top};e.mouseInGame=function(){return 0<
this.runtime.fullscreen_mode?!0:0<=this.mouseXcanvas&&0<=this.mouseYcanvas&&this.mouseXcanvas<this.runtime.width&&this.mouseYcanvas<this.runtime.height};e.onMouseDown=function(a){this.mouseInGame()&&(this.runtime.had_a_click&&a.preventDefault(),this.buttonMap[a.which]=!0,this.runtime.isInUserInputEvent=!0,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnAnyClick,this),this.triggerButton=a.which-1,this.triggerType=0,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick,this),this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked,
this),this.runtime.isInUserInputEvent=!1)};e.onMouseUp=function(a){this.buttonMap[a.which]&&(this.runtime.had_a_click&&a.preventDefault(),this.runtime.had_a_click=!0,this.buttonMap[a.which]=!1,this.runtime.isInUserInputEvent=!0,this.triggerButton=a.which-1,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnRelease,this),this.runtime.isInUserInputEvent=!1)};e.onDoubleClick=function(a){this.mouseInGame()&&(a.preventDefault(),this.runtime.isInUserInputEvent=!0,this.triggerButton=a.which-1,this.triggerType=
1,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick,this),this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked,this),this.runtime.isInUserInputEvent=!1)};e.onWheel=function(a){this.triggerDir=0>(a.wheelDelta?a.wheelDelta:a.detail?-a.detail:0)?0:1;this.handled=!1;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnWheel,this);this.runtime.isInUserInputEvent=!1;this.handled&&a.preventDefault()};a.prototype.OnClick=function(a,b){return a===
this.triggerButton&&b===this.triggerType};a.prototype.OnAnyClick=function(){return!0};a.prototype.IsButtonDown=function(a){return this.buttonMap[a+1]};a.prototype.OnRelease=function(a){return a===this.triggerButton};a.prototype.IsOverObject=function(a){var b=this.runtime.getCurrentCondition();return cr.xor(this.runtime.testAndSelectCanvasPointOverlap(a,this.mouseXcanvas,this.mouseYcanvas,b.inverted),b.inverted)};a.prototype.OnObjectClicked=function(a,b,c){return a!==this.triggerButton||b!==this.triggerType?
!1:this.runtime.testAndSelectCanvasPointOverlap(c,this.mouseXcanvas,this.mouseYcanvas,!1)};a.prototype.OnWheel=function(a){this.handled=!0;return a===this.triggerDir};d.cnds=new a;b.prototype.SetCursor=function(a){a="auto pointer text crosshair move help wait none".split(" ")[a];this.runtime.canvas&&this.runtime.canvas.style&&(this.runtime.canvas.style.cursor=a)};b.prototype.SetCursorSprite=function(a){this.runtime.isDomFree||this.runtime.isMobile||!a||(a=a.getFirstPicked())&&a.curFrame&&(a=a.curFrame,
a="url("+a.getDataUri()+") "+Math.round(a.hotspotX*a.width)+" "+Math.round(a.hotspotY*a.height)+", auto",jQuery(this.runtime.canvas).css("cursor",a))};d.acts=new b;c.prototype.X=function(a,b){var c,d,e,g,p;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxX,p=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.mouseXcanvas,this.mouseYcanvas,!0)),c.scale=d,c.zoomRate=
e,c.parallaxX=g,c.angle=p):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.mouseXcanvas,this.mouseYcanvas,!0)):a.set_float(0)};c.prototype.Y=function(a,b){var c,d,e,g,p;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxY,p=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.mouseXcanvas,this.mouseYcanvas,
!1)),c.scale=d,c.zoomRate=e,c.parallaxY=g,c.angle=p):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.mouseXcanvas,this.mouseYcanvas,!1)):a.set_float(0)};c.prototype.AbsoluteX=function(a){a.set_float(this.mouseXcanvas)};c.prototype.AbsoluteY=function(a){a.set_float(this.mouseYcanvas)};d.exps=new c})();cr.plugins_.NodeWebkit=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=!1,e=null,g=null,f=null,l=null,k="",h="",m="\\",n=[],p="",q="",r=cr.plugins_.NodeWebkit.prototype;r.Type=function(a){this.plugin=a;this.runtime=a.runtime};r.Type.prototype.onCreate=function(){};r.Instance=function(a){this.type=a;this.runtime=a.runtime};var t=r.Instance.prototype;t.onCreate=function(){d=this.runtime.isNodeWebkit;var a=this;d&&(e=require("path"),g=require("fs"),l=require("child_process"),"win32"!==process.platform&&(m="/"),
k=e.dirname(process.execPath)+m,h=(process.env.HOME||process.env.HOMEPATH||process.env.USERPROFILE)+m,f=require("nw.gui"),window.ondrop=function(b){b.preventDefault();for(var c=0;c<b.dataTransfer.files.length;++c)p=b.dataTransfer.files[c].path,a.runtime.trigger(cr.plugins_.NodeWebkit.prototype.cnds.OnFileDrop,a);return!1},jQuery("#c2nwOpenFileDialog").change(function(b){q=jQuery(this).val();a.runtime.trigger(cr.plugins_.NodeWebkit.prototype.cnds.OnOpenDlg,a)}),jQuery("#c2nwChooseFolderDialog").change(function(b){q=
jQuery(this).val();a.runtime.trigger(cr.plugins_.NodeWebkit.prototype.cnds.OnFolderDlg,a)}),jQuery("#c2nwSaveDialog").change(function(b){q=jQuery(this).val();a.runtime.trigger(cr.plugins_.NodeWebkit.prototype.cnds.OnSaveDlg,a)}))};t.onDestroy=function(){};t.saveToJSON=function(){return{}};t.loadFromJSON=function(a){};a.prototype.PathExists=function(a){return d?g.existsSync(a):!1};a.prototype.OnFileDrop=function(){return!0};a.prototype.OnOpenDlg=function(){return!0};a.prototype.OnFolderDlg=function(){return!0};
a.prototype.OnSaveDlg=function(){return!0};r.cnds=new a;b.prototype.WriteFile=function(a,b){if(d)try{g.writeFileSync(a,b,{encoding:"utf8"})}catch(c){}};b.prototype.RenameFile=function(a,b){if(d)try{g.renameSync(a,b)}catch(c){}};b.prototype.DeleteFile=function(a){if(d)try{g.unlinkSync(a)}catch(b){}};b.prototype.CopyFile=function(a,b){if(d&&a!==b)try{var c=g.readFileSync(a,{flags:"rb"});g.writeFileSync(b,c,{flags:"wb"})}catch(e){}};b.prototype.MoveFile=function(a,b){if(d&&a!==b)try{var c=g.readFileSync(a,
{flags:"rb"});g.writeFileSync(b,c,{flags:"wb"});g.existsSync(b)&&g.unlinkSync(a)}catch(e){}};b.prototype.RunFile=function(a){d&&l.exec(a,function(){})};b.prototype.OpenBrowser=function(a){if(d){var b;switch(process.platform){case "win32":b='start ""';break;case "darwin":b="open";break;default:b=e.join(__dirname,"../vendor/xdg-open")}l.exec(b+' "'+a.replace(/"/,'\\"')+'"')}};b.prototype.CreateFolder=function(a){if(d)try{g.mkdirSync(a)}catch(b){}};b.prototype.AppendFile=function(a,b){if(d)try{g.appendFileSync(a,
b,{encoding:"utf8"})}catch(c){}};b.prototype.ListFiles=function(a){if(d){try{n=g.readdirSync(a)}catch(b){}n||(n=[])}};b.prototype.ShowOpenDlg=function(a){if(d){var b=jQuery("#c2nwOpenFileDialog");b.attr("accept",a);b.trigger("click")}};b.prototype.ShowFolderDlg=function(a){d&&jQuery("#c2nwChooseFolderDialog").trigger("click")};b.prototype.ShowSaveDlg=function(a){if(d){var b=jQuery("#c2nwSaveDialog");b.attr("accept",a);b.trigger("click")}};b.prototype.SetWindowX=function(a){d&&(f.Window.get().x=a)};
b.prototype.SetWindowY=function(a){d&&(f.Window.get().y=a)};b.prototype.SetWindowWidth=function(a){d&&(f.Window.get().width=a)};b.prototype.SetWindowHeight=function(a){d&&(f.Window.get().height=a)};b.prototype.SetWindowTitle=function(a){d&&(f.Window.get().title=a)};b.prototype.WindowMinimize=function(){if(d){var a=f.Window.get();setTimeout(function(){a.minimize()},100)}};b.prototype.WindowMaximize=function(){if(d){var a=f.Window.get();setTimeout(function(){a.maximize()},100)}};b.prototype.WindowUnmaximize=
function(){if(d){var a=f.Window.get();setTimeout(function(){a.unmaximize()},100)}};b.prototype.WindowRestore=function(){if(d){var a=f.Window.get();setTimeout(function(){a.restore()},100)}};b.prototype.WindowRequestAttention=function(a){d&&f.Window.get().requestAttention(0===a)};b.prototype.WindowSetMaxSize=function(a,b){d&&f.Window.get().setMaximumSize(a,b)};b.prototype.WindowSetMinSize=function(a,b){d&&f.Window.get().setMinimumSize(a,b)};b.prototype.WindowSetResizable=function(a){d&&f.Window.get().setResizable(0!==
a)};b.prototype.WindowSetAlwaysOnTop=function(a){d&&f.Window.get().setAlwaysOnTop(0!==a)};b.prototype.ShowDevTools=function(){d&&f.Window.get().showDevTools()};b.prototype.SetClipboardText=function(a){d&&f.Clipboard.get().set(a)};b.prototype.ClearClipboard=function(){d&&f.Clipboard.get().clear()};r.acts=new b;c.prototype.AppFolder=function(a){a.set_string(k)};c.prototype.UserFolder=function(a){a.set_string(h)};c.prototype.ReadFile=function(a,b){if(d){var c="";try{c=g.readFileSync(b,{encoding:"utf8"})}catch(e){}a.set_string(c)}else a.set_string("")};
c.prototype.ListCount=function(a){a.set_int(n.length)};c.prototype.ListAt=function(a,b){b=Math.floor(b);0>b||b>=n.length?a.set_string(""):a.set_string(n[b])};c.prototype.DroppedFile=function(a){a.set_string(p)};c.prototype.ChosenPath=function(a){a.set_string(q)};c.prototype.WindowX=function(a){a.set_int(d?f.Window.get().x:0)};c.prototype.WindowY=function(a){a.set_int(d?f.Window.get().y:0)};c.prototype.WindowWidth=function(a){a.set_int(d?f.Window.get().width:0)};c.prototype.WindowHeight=function(a){a.set_int(d?
f.Window.get().height:0)};c.prototype.WindowTitle=function(a){a.set_string(d?f.Window.get().title||"":0)};c.prototype.ClipboardText=function(a){a.set_string(d?f.Clipboard.get().get()||"":0)};r.exps=new c})();cr.plugins_.Sprite=function(a){this.runtime=a};
(function(){function a(){if(0===this.datauri.length){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;var b=a.getContext("2d");this.spritesheeted?b.drawImage(this.texture_img,this.offx,this.offy,this.width,this.height,0,0,this.width,this.height):b.drawImage(this.texture_img,0,0,this.width,this.height);this.datauri=a.toDataURL("image/png")}return this.datauri}function b(){}function c(a){a[0]=0;a[1]=0;a[2]=0;r.push(a)}function d(a,b){return a<b?""+a+","+b:""+b+","+a}function e(a,
b,c,e){b=b.uid;c=c.uid;var f=d(b,c);if(a.hasOwnProperty(f))a[f][2]=e;else{var h;h=r.length?r.pop():[0,0,0];h[0]=b;h[1]=c;h[2]=e;a[f]=h}}function g(a,b,e){b=d(b.uid,e.uid);a.hasOwnProperty(b)&&(c(a[b]),delete a[b])}function f(a,b,c){b=d(b.uid,c.uid);if(a.hasOwnProperty(b))return t=a[b][2],!0;t=-2;return!1}function l(a,b,c){if(!a)return!1;var d=0!==b||0!==c,e,f,h=!1,g,k=this.runtime.getCurrentCondition(),m=k.type,k=k.inverted,l=a.getCurrentSol();g=this.runtime.getCurrentEventStack().current_event.orblock;
l.select_all?(this.update_bbox(),this.runtime.getCollisionCandidates(this.layer,a,this.bbox,s),l=s):l=g?l.else_instances:l.instances;u=a;E=m!==a&&!k;d&&(e=this.x,f=this.y,this.x+=b,this.y+=c,this.set_bbox_changed());b=0;for(c=l.length;b<c;b++)if(g=l[b],this.runtime.testOverlap(this,g)){h=!0;if(k)break;m!==a&&A.add(g)}d&&(this.x=e,this.y=f,this.set_bbox_changed());s.length=0;return h}function k(){}function h(){}var m=cr.plugins_.Sprite.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};
var n=m.Type.prototype;n.onCreate=function(){if(!this.is_family){var b,c,d,e,f,h,g,k,m;this.all_frames=[];this.has_loaded_textures=!1;b=0;for(c=this.animations.length;b<c;b++){f=this.animations[b];g={};g.name=f[0];g.speed=f[1];g.loop=f[2];g.repeatcount=f[3];g.repeatto=f[4];g.pingpong=f[5];g.sid=f[6];g.frames=[];d=0;for(e=f[7].length;d<e;d++)h=f[7][d],k={},k.texture_file=h[0],k.texture_filesize=h[1],k.offx=h[2],k.offy=h[3],k.width=h[4],k.height=h[5],k.duration=h[6],k.hotspotX=h[7],k.hotspotY=h[8],
k.image_points=h[9],k.poly_pts=h[10],k.pixelformat=h[11],k.spritesheeted=0!==k.width,k.datauri="",k.getDataUri=a,m={left:0,top:0,right:1,bottom:1},k.sheetTex=m,k.webGL_texture=null,(m=this.runtime.findWaitingTexture(h[0]))?k.texture_img=m:(k.texture_img=new Image,k.texture_img.idtkLoadDisposed=!0,k.texture_img.src=h[0],k.texture_img.cr_src=h[0],k.texture_img.cr_filesize=h[1],k.texture_img.c2webGL_texture=null,this.runtime.waitForImageLoad(k.texture_img)),cr.seal(k),g.frames.push(k),this.all_frames.push(k);
cr.seal(g);this.animations[b]=g}}};n.updateAllCurrentTexture=function(){var a,b,c;a=0;for(b=this.instances.length;a<b;a++)c=this.instances[a],c.curWebGLTexture=c.curFrame.webGL_texture};n.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.texture_img.c2webGL_texture=null,c.webGL_texture=null}};n.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],
c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.updateAllCurrentTexture()}};n.loadTextures=function(){if(!this.is_family&&!this.has_loaded_textures&&this.runtime.glwrap){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.has_loaded_textures=!0}};n.unloadTextures=function(){if(!this.is_family&&!this.instances.length&&
this.has_loaded_textures){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],this.runtime.glwrap.deleteTexture(c.webGL_texture);this.has_loaded_textures=!1}};var p=[];n.preloadCanvas2D=function(a){var b,c,d;b=p.length=0;for(c=this.all_frames.length;b<c;++b)d=this.all_frames[b].texture_img,-1===p.indexOf(d)&&(a.drawImage(d,0,0),p.push(d))};m.Instance=function(a){this.type=a;this.runtime=a.runtime;a=this.type.animations[0].frames[0].poly_pts;this.recycled?this.collision_poly.set_pts(a):
this.collision_poly=new cr.CollisionPoly(a)};var q=m.Instance.prototype;q.onCreate=function(){this.visible=0===this.properties[0];this.inAnimTrigger=this.isTicking=!1;this.collisionsEnabled=0!==this.properties[3];1===this.type.animations.length&&1===this.type.animations[0].frames.length||0===this.type.animations[0].speed||(this.runtime.tickMe(this),this.isTicking=!0);this.cur_animation=this.getAnimationByName(this.properties[1])||this.type.animations[0];this.cur_frame=this.properties[2];0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);var a=this.cur_animation.frames[this.cur_frame];this.collision_poly.set_pts(a.poly_pts);this.hotspotX=a.hotspotX;this.hotspotY=a.hotspotY;this.cur_anim_speed=this.cur_animation.speed;this.recycled?this.animTimer.reset():this.animTimer=new cr.KahanAdder;this.frameStart=this.getNowTime();this.animPlaying=!0;this.animRepeats=0;this.animForwards=!0;this.changeAnimName=this.animTriggerName=
"";this.changeAnimFrom=0;this.changeAnimFrame=-1;this.type.loadTextures();var b,c,d,e,f,h,g,a=0;for(b=this.type.animations.length;a<b;a++)for(e=this.type.animations[a],c=0,d=e.frames.length;c<d;c++)f=e.frames[c],0===f.width&&(f.width=f.texture_img.width,f.height=f.texture_img.height),f.spritesheeted&&(g=f.texture_img,h=f.sheetTex,h.left=f.offx/g.width,h.top=f.offy/g.height,h.right=(f.offx+f.width)/g.width,h.bottom=(f.offy+f.height)/g.height,0===f.offx&&0===f.offy&&f.width===g.width&&f.height===g.height&&
(f.spritesheeted=!1));this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture};q.saveToJSON=function(){var a={a:this.cur_animation.sid,f:this.cur_frame,cas:this.cur_anim_speed,fs:this.frameStart,ar:this.animRepeats,at:this.animTimer.sum};this.animPlaying||(a.ap=this.animPlaying);this.animForwards||(a.af=this.animForwards);return a};q.loadFromJSON=function(a){var b=this.getAnimationBySid(a.a);b&&(this.cur_animation=b);this.cur_frame=a.f;0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);this.cur_anim_speed=a.cas;this.frameStart=a.fs;this.animRepeats=a.ar;this.animTimer.reset();this.animTimer.sum=a.at;this.animPlaying=a.hasOwnProperty("ap")?a.ap:!0;this.animForwards=a.hasOwnProperty("af")?a.af:!0;this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture;this.collision_poly.set_pts(this.curFrame.poly_pts);this.hotspotX=
this.curFrame.hotspotX;this.hotspotY=this.curFrame.hotspotY};q.animationFinish=function(a){this.cur_frame=a?0:this.cur_animation.frames.length-1;this.animPlaying=!1;this.animTriggerName=this.cur_animation.name;this.inAnimTrigger=!0;this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,this);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,this);this.inAnimTrigger=!1;this.animRepeats=0};q.getNowTime=function(){return this.animTimer.sum};q.tick=function(){this.animTimer.add(this.runtime.getDt(this));
this.changeAnimName.length&&this.doChangeAnim();0<=this.changeAnimFrame&&this.doChangeAnimFrame();var a=this.getNowTime(),b=this.cur_animation,c=b.frames[this.cur_frame],d=c.duration/this.cur_anim_speed;this.animPlaying&&a>=this.frameStart+d&&(this.animForwards?this.cur_frame++:this.cur_frame--,this.frameStart+=d,this.cur_frame>=b.frames.length&&(b.pingpong?(this.animForwards=!1,this.cur_frame=b.frames.length-2):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?
this.animationFinish(!1):this.cur_frame=b.repeatto)),0>this.cur_frame&&(b.pingpong?(this.cur_frame=1,this.animForwards=!0,b.loop||(this.animRepeats++,this.animRepeats>=b.repeatcount&&this.animationFinish(!0))):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?this.animationFinish(!0):this.cur_frame=b.repeatto)),0>this.cur_frame?this.cur_frame=0:this.cur_frame>=b.frames.length&&(this.cur_frame=b.frames.length-1),a>this.frameStart+b.frames[this.cur_frame].duration/
this.cur_anim_speed&&(this.frameStart=a),a=b.frames[this.cur_frame],this.OnFrameChanged(c,a),this.runtime.redraw=!0)};q.getAnimationByName=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],cr.equals_nocase(d.name,a))return d;return null};q.getAnimationBySid=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],d.sid===a)return d;return null};q.doChangeAnim=function(){var a=this.cur_animation.frames[this.cur_frame],
b=this.getAnimationByName(this.changeAnimName);this.changeAnimName="";!b||cr.equals_nocase(b.name,this.cur_animation.name)&&this.animPlaying||(this.cur_animation=b,this.cur_anim_speed=b.speed,0>this.cur_frame&&(this.cur_frame=0),this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1),1===this.changeAnimFrom&&(this.cur_frame=0),this.animPlaying=!0,this.frameStart=this.getNowTime(),this.animForwards=!0,this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),
this.runtime.redraw=!0)};q.doChangeAnimFrame=function(){var a=this.cur_animation.frames[this.cur_frame],b=this.cur_frame;this.cur_frame=cr.floor(this.changeAnimFrame);0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);b!==this.cur_frame&&(this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),this.frameStart=this.getNowTime(),this.runtime.redraw=!0);this.changeAnimFrame=-1};q.OnFrameChanged=function(a,
b){var c=a.width,d=a.height,e=b.width,f=b.height;c!=e&&(this.width*=e/c);d!=f&&(this.height*=f/d);this.hotspotX=b.hotspotX;this.hotspotY=b.hotspotY;this.collision_poly.set_pts(b.poly_pts);this.set_bbox_changed();this.curFrame=b;this.curWebGLTexture=b.webGL_texture;c=0;for(d=this.behavior_insts.length;c<d;c++)if(e=this.behavior_insts[c],e.onSpriteFrameChanged)e.onSpriteFrameChanged(a,b);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged,this)};q.draw=function(a){a.globalAlpha=this.opacity;
var b=this.curFrame,c=b.spritesheeted,d=b.texture_img,e=this.x,f=this.y,h=this.width,g=this.height;if(0===this.angle&&0<=h&&0<=g)e-=this.hotspotX*h,f-=this.hotspotY*g,this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0),c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,h,g):a.drawImage(d,e,f,h,g);else{this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0);a.save();var k=0<h?1:-1,m=0<g?1:-1;a.translate(e,f);1===k&&1===m||a.scale(k,m);a.rotate(this.angle*k*m);e=0-this.hotspotX*cr.abs(h);f=0-this.hotspotY*
cr.abs(g);c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,cr.abs(h),cr.abs(g)):a.drawImage(d,e,f,cr.abs(h),cr.abs(g));a.restore()}};q.drawGL=function(a){a.setTexture(this.curWebGLTexture);a.setOpacity(this.opacity);var b=this.curFrame,c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;b.spritesheeted?a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b.sheetTex):a.quad(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,
c.bly+e)}else b.spritesheeted?a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b.sheetTex):a.quad(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly)};q.getImagePointIndexByName=function(a){var b=this.curFrame,c,d;c=0;for(d=b.image_points.length;c<d;c++)if(cr.equals_nocase(a,b.image_points[c][0]))return c;return-1};q.getImagePoint=function(a,b){var c=this.curFrame,d=c.image_points,e;e=cr.is_string(a)?this.getImagePointIndexByName(a):a-1;e=cr.floor(e);if(0>e||e>=d.length)return b?this.x:this.y;
var f=(d[e][1]-c.hotspotX)*this.width,d=d[e][2],d=(d-c.hotspotY)*this.height,c=Math.cos(this.angle);e=Math.sin(this.angle);var h=f*c-d*e,d=d*c+f*e,f=h+this.x,d=d+this.y;return b?f:d};var r=[],t=-2,s=[];b.prototype.OnCollision=function(a){if(!a)return!1;var b=this.runtime,d=b.getCurrentCondition(),h=d.type;d.extra.collmemory||(d.extra.collmemory={},b.addDestroyCallback(function(a){return function(b){b=b.uid;var d,e;for(d in a)a.hasOwnProperty(d)&&(e=a[d],e[0]===b||e[1]===b)&&(c(a[d]),delete a[d])}}(d.extra.collmemory)));
var d=d.extra.collmemory,k=h.getCurrentSol(),m=a.getCurrentSol(),k=k.getObjects(),l,q,r,n,p,u,A,E=this.runtime.tickcount,P=E-1,L=b.getCurrentEventStack().current_event;for(q=0;q<k.length;q++){r=k[q];m.select_all?(r.update_bbox(),this.runtime.getCollisionCandidates(r.layer,a,r.bbox,s),l=s):l=m.getObjects();for(n=0;n<l.length;n++)p=l[n],b.testOverlap(r,p)||b.checkRegisteredCollision(r,p)?(u=f(d,r,p),u=!u||t<P,e(d,r,p,E),u&&(b.pushCopySol(L.solModifiers),u=h.getCurrentSol(),A=a.getCurrentSol(),u.select_all=
!1,A.select_all=!1,h===a?(u.instances.length=2,u.instances[0]=r,u.instances[1]=p,h.applySolToContainer()):(u.instances.length=1,A.instances.length=1,u.instances[0]=r,A.instances[0]=p,h.applySolToContainer(),a.applySolToContainer()),L.retrigger(),b.popSol(L.solModifiers))):g(d,r,p);s.length=0}return!1};var u=null,A=new cr.ObjectSet,E=!1;n.finish=function(a){if(E){if(a){var b=this.runtime.getCurrentEventStack().current_event.orblock;a=u.getCurrentSol();var c=A.valuesRef(),d,e;if(a.select_all){a.select_all=
!1;a.instances.length=c.length;d=0;for(e=c.length;d<e;d++)a.instances[d]=c[d];if(b)for(d=a.else_instances.length=0,e=u.instances.length;d<e;d++)c=u.instances[d],A.contains(c)||a.else_instances.push(c)}else if(b)for(b=a.instances.length,a.instances.length=b+c.length,d=0,e=c.length;d<e;d++)a.instances[b+d]=c[d],cr.arrayFindRemove(a.else_instances,c[d]);else cr.shallowAssignArray(a.instances,c);u.applySolToContainer()}A.clear();E=!1}};b.prototype.IsOverlapping=function(a){return l.call(this,a,0,0)};
b.prototype.IsOverlappingOffset=function(a,b,c){return l.call(this,a,b,c)};b.prototype.IsAnimPlaying=function(a){return this.changeAnimName.length?cr.equals_nocase(this.changeAnimName,a):cr.equals_nocase(this.cur_animation.name,a)};b.prototype.CompareFrame=function(a,b){return cr.do_cmp(this.cur_frame,a,b)};b.prototype.CompareAnimSpeed=function(a,b){return cr.do_cmp(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed,a,b)};b.prototype.OnAnimFinished=function(a){return cr.equals_nocase(this.animTriggerName,
a)};b.prototype.OnAnyAnimFinished=function(){return!0};b.prototype.OnFrameChanged=function(){return!0};b.prototype.IsMirrored=function(){return 0>this.width};b.prototype.IsFlipped=function(){return 0>this.height};b.prototype.OnURLLoaded=function(){return!0};b.prototype.IsCollisionEnabled=function(){return this.collisionsEnabled};m.cnds=new b;k.prototype.Spawn=function(a,b,c){if(a&&b&&(b=this.runtime.createInstance(a,b,this.getImagePoint(c,!0),this.getImagePoint(c,!1)))){"undefined"!==typeof b.angle&&
(b.angle=this.angle,b.set_bbox_changed());this.runtime.isInOnDestroy++;var d,e,f;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(d=0,e=b.siblings.length;d<e;d++)f=b.siblings[d],this.runtime.trigger(Object.getPrototypeOf(f.type.plugin).cnds.OnCreated,f);this.runtime.isInOnDestroy--;d=this.runtime.getCurrentAction();c=!1;if(cr.is_undefined(d.extra.Spawn_LastExec)||d.extra.Spawn_LastExec<this.runtime.execcount)c=!0,d.extra.Spawn_LastExec=this.runtime.execcount;
if(a!=this.type&&(a=a.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=b):a.instances.push(b),b.is_contained))for(d=0,e=b.siblings.length;d<e;d++)f=b.siblings[d],a=f.type.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=f):a.instances.push(f)}};k.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};k.prototype.StopAnim=function(){this.animPlaying=!1};k.prototype.StartAnim=
function(a){this.animPlaying=!0;this.frameStart=this.getNowTime();1===a&&0!==this.cur_frame&&(this.changeAnimFrame=0,this.inAnimTrigger||this.doChangeAnimFrame());this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};k.prototype.SetAnim=function(a,b){this.changeAnimName=a;this.changeAnimFrom=b;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnim()};k.prototype.SetAnimFrame=function(a){this.changeAnimFrame=a;this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0);this.inAnimTrigger||this.doChangeAnimFrame()};k.prototype.SetAnimSpeed=function(a){this.cur_anim_speed=cr.abs(a);this.animForwards=0<=a;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};k.prototype.SetMirrored=function(a){a=cr.abs(this.width)*(0===a?-1:1);this.width!==a&&(this.width=a,this.set_bbox_changed())};k.prototype.SetFlipped=function(a){a=cr.abs(this.height)*(0===a?-1:1);this.height!==a&&(this.height=a,this.set_bbox_changed())};k.prototype.SetScale=function(a){var b=
this.curFrame,c=b.width*a*(0>this.width?-1:1);a=b.height*a*(0>this.height?-1:1);if(this.width!==c||this.height!==a)this.width=c,this.height=a,this.set_bbox_changed()};k.prototype.LoadURL=function(a,b){var c=new Image,d=this,e=this.curFrame;c.onload=function(){e.texture_img.src===c.src?d.runtime.glwrap&&d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture):(e.texture_img=c,e.offx=0,e.offy=0,e.width=c.width,e.height=c.height,e.spritesheeted=!1,e.datauri="",d.runtime.glwrap&&(e.webGL_texture&&d.runtime.glwrap.deleteTexture(e.webGL_texture),
e.webGL_texture=d.runtime.glwrap.loadTexture(c,!1,d.runtime.linearSampling),d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture),d.type.updateAllCurrentTexture()),0===b&&(d.width=c.width,d.height=c.height,d.set_bbox_changed()));d.runtime.redraw=!0;d.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded,d)};"data:"!==a.substr(0,5)&&(c.crossOrigin="anonymous");c.src=a};k.prototype.SetCollisions=function(a){this.collisionsEnabled!==(0!==a)&&((this.collisionsEnabled=0!==a)?this.set_bbox_changed():
(this.collcells.right>=this.collcells.left&&this.type.collision_grid.update(this,this.collcells,null),this.collcells.set(0,0,-1,-1)))};m.acts=new k;h.prototype.AnimationFrame=function(a){a.set_int(this.cur_frame)};h.prototype.AnimationFrameCount=function(a){a.set_int(this.cur_animation.frames.length)};h.prototype.AnimationName=function(a){a.set_string(this.cur_animation.name)};h.prototype.AnimationSpeed=function(a){a.set_float(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed)};h.prototype.ImagePointX=
function(a,b){a.set_float(this.getImagePoint(b,!0))};h.prototype.ImagePointY=function(a,b){a.set_float(this.getImagePoint(b,!1))};h.prototype.ImagePointCount=function(a){a.set_int(this.curFrame.image_points.length)};h.prototype.ImageWidth=function(a){a.set_float(this.curFrame.width)};h.prototype.ImageHeight=function(a){a.set_float(this.curFrame.height)};m.exps=new h})();cr.plugins_.Spritefont2=function(a){this.runtime=a};
(function(){function a(a,b,c){if(c){var d;c=0;for(d=b.length;c<d;c++)a.length<l&&a.push(b[c]);b.length=0}else for(d in b)Object.prototype.hasOwnProperty.call(b,d)&&(a.length<l&&a.push(b[d]),delete b[d])}function b(a,b,c){var d=a.lines;c=c.replace(/\s\s*$/,"");b>=d.length&&d.push(k.length?k.pop():{});b=d[b];b.text=c;b.width=a.measureWidth(c);a.textWidth=cr.max(a.textWidth,b.width)}function c(){}function d(){}function e(){}var g=cr.plugins_.Spritefont2.prototype;g.onCreate=function(){};g.Type=function(a){this.plugin=
a;this.runtime=a.runtime};var f=g.Type.prototype;f.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.runtime.waitForImageLoad(this.texture_img),this.webGL_texture=null)};f.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=null)};f.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,
!1,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};f.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};f.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};g.Instance=function(a){this.type=a;this.runtime=a.runtime};f=g.Instance.prototype;f.onDestroy=function(){a(k,
this.lines,!0);a(h,this.clipList,!1);a(m,this.clipUV,!1);cr.wipe(this.characterWidthList)};f.onCreate=function(){this.texture_img=this.type.texture_img;this.characterWidth=this.properties[0];this.characterHeight=this.properties[1];this.characterSet=this.properties[2];this.text=this.properties[3];this.characterScale=this.properties[4];this.visible=0===this.properties[5];this.halign=this.properties[6]/2;this.valign=this.properties[7]/2;this.wrapbyword=0===this.properties[9];this.characterSpacing=this.properties[10];
this.lineHeight=this.properties[11];this.textHeight=this.textWidth=0;this.recycled?(this.lines.length=0,cr.wipe(this.clipList),cr.wipe(this.clipUV),cr.wipe(this.characterWidthList)):(this.lines=[],this.clipList={},this.clipUV={},this.characterWidthList={});this.text_changed=!0;this.lastwrapwidth=this.width;this.runtime.glwrap&&(this.type.webGL_texture||(this.type.webGL_texture=this.runtime.glwrap.loadTexture(this.type.texture_img,!1,this.runtime.linearSampling,this.type.texture_pixelformat)),this.webGL_texture=
this.type.webGL_texture);this.SplitSheet()};f.saveToJSON=function(){var a={t:this.text,csc:this.characterScale,csp:this.characterSpacing,lh:this.lineHeight,tw:this.textWidth,th:this.textHeight,lrt:this.last_render_tick,cw:{}},b;for(b in this.characterWidthList)a.cw[b]=this.characterWidthList[b];return a};f.loadFromJSON=function(a){this.text=a.t;this.characterScale=a.csc;this.characterSpacing=a.csp;this.lineHeight=a.lh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;for(var b in a.cw)this.characterWidthList[b]=
a.cw[b];this.text_changed=!0;this.lastwrapwidth=this.width};var l=1E3,k=[],h=[],m=[];f.SplitSheet=function(){for(var a=this.texture_img,b=a.width,c=a.height,a=this.characterWidth,d=this.characterHeight,e=a/b,f=d/c,g=this.characterSet,b=Math.floor(b/a),c=Math.floor(c/d),k=0;k<g.length&&!(k>=b*c);k++){var l=k%b,n=Math.floor(k/b),p=g.charAt(k);if(this.runtime.glwrap){var x=this.clipUV,y=l*e,B=n*f,l=(l+1)*e,n=(n+1)*f;void 0===x[p]&&(x[p]=m.length?m.pop():new cr.rect);x[p].left=y;x[p].top=B;x[p].right=
l;x[p].bottom=n}else x=this.clipList,l*=a,n*=d,y=a,B=d,void 0===x[p]&&(x[p]=h.length?h.pop():{}),x[p].x=l,x[p].y=n,x[p].w=y,x[p].h=B}};var n=[];g.TokeniseWords=function(a){n.length=0;for(var b="",c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(n.push(b),b=""),n.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));n.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&n.push(b)};g.WordWrap=function(b){var c=b.text,
d=b.lines;if(c&&c.length){var e=b.width;if(2>=e)a(k,d,!0);else{var f=b.characterScale,h=b.characterSpacing;if(c.length*(b.characterWidth*f+h)-h<=e&&-1===c.indexOf("\n")&&(h=b.measureWidth(c),h<=e)){a(k,d,!0);d.push(k.length?k.pop():{});d[0].text=c;d[0].width=h;b.textWidth=h;b.textHeight=b.characterHeight*f+b.lineHeight;return}this.WrapText(b);b.textHeight=d.length*(b.characterHeight*f+b.lineHeight)}}else a(k,d,!0)};g.WrapText=function(a){var c=a.wrapbyword,d=a.text,e=a.lines,f=a.width;c&&(this.TokeniseWords(d),
d=n);var h="",g,m,p,v=0,F=!1;for(p=0;p<d.length;p++)"\n"===d[p]?(!0===F?F=!1:(b(a,v,h),v++),h=""):(F=!1,g=h,h+=d[p],m=a.measureWidth(h.replace(/\s\s*$/,"")),m>f&&(""===g?(b(a,v,h),h="",F=!0):(b(a,v,g),h=d[p]),v++,c||" "!==h||(h="")));h.replace(/\s\s*$/,"").length&&(b(a,v,h),v++);for(p=v;p<e.length;p++)k.length<l&&k.push(e[p]);e.length=v};f.measureWidth=function(a){for(var b=this.characterSpacing,c=a.length,d=0,e=0;e<c;e++)d+=this.getCharacterWidth(a.charAt(e))*this.characterScale+b;return d-(0<d?
b:0)};f.getCharacterWidth=function(a){var b=this.characterWidthList;return void 0!==b[a]?b[a]:this.characterWidth};f.rebuildText=function(){if(this.text_changed||this.width!==this.lastwrapwidth)this.textHeight=this.textWidth=0,this.type.plugin.WordWrap(this),this.text_changed=!1,this.lastwrapwidth=this.width};f.draw=function(a,b){var c=this.texture_img;if(""!==this.text&&null!=c&&(this.rebuildText(),!(this.height<this.characterHeight*this.characterScale+this.lineHeight))){a.globalAlpha=this.opacity;
var c=this.x,d=this.y;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);a.save();a.translate(c,d);a.rotate(this.angle);for(var c=this.halign,d=this.characterScale,e=this.characterHeight*d,f=this.lineHeight,h=this.characterSpacing,g=this.lines,k,m=this.valign*cr.max(0,this.height-this.textHeight),l=-(this.hotspotX*this.width),n=-(this.hotspotY*this.height),m=n+m,p,B,n=0;n<g.length;n++){var w=g[n].text;k=c*cr.max(0,this.width-g[n].width);k=l+k;for(var m=m+f,G=0;G<w.length;G++){var C=w.charAt(G),D=
this.clipList[C];if(k+this.getCharacterWidth(C)*d>this.width+1E-5)break;void 0!==D&&(p=k,B=m,0===this.angle&&(p=Math.round(p),B=Math.round(B)),a.drawImage(this.texture_img,D.x,D.y,D.w,D.h,p,B,D.w*d,D.h*d));k+=this.getCharacterWidth(C)*d+h}m+=e;if(m+e+f>this.height)break}a.restore()}};var p=new cr.quad;f.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);if(""!==this.text&&(this.rebuildText(),!(this.height<this.characterHeight*this.characterScale+this.lineHeight))){this.update_bbox();
var b=this.bquad,c=0,d=0;this.runtime.pixel_rounding&&(c=(this.x+0.5|0)-this.x,d=(this.y+0.5|0)-this.y);var e=this.angle,f=this.halign,h=this.valign,g=this.characterScale,k=this.characterHeight*g,m=this.lineHeight,l=this.characterSpacing,n=this.lines,y=this.textHeight,B,w;0!==e&&(B=Math.cos(e),w=Math.sin(e));for(var G,h=h*cr.max(0,this.height-y),c=b.tlx+c,b=b.tly+d,d=h,C,D,h=0;h<n.length;h++){y=n[h].text;G=f*cr.max(0,this.width-n[h].width);for(var d=d+m,J=0;J<y.length;J++){var T=y.charAt(J),M=this.clipUV[T];
if(G+this.getCharacterWidth(T)*g>this.width+1E-5)break;if(void 0!==M){var P=this.characterWidth*g,L=this.characterHeight*g;C=G;D=d;0===e&&(C=Math.round(C),D=Math.round(D));p.tlx=C;p.tly=D;p.trx=C+P;p.try_=D;p.blx=C;p.bly=D+L;p.brx=C+P;p.bry=D+L;0!==e&&(C=p,D=B,P=w,L=void 0,L=C.tlx*D-C.tly*P,C.tly=C.tly*D+C.tlx*P,C.tlx=L,L=C.trx*D-C.try_*P,C.try_=C.try_*D+C.trx*P,C.trx=L,L=C.blx*D-C.bly*P,C.bly=C.bly*D+C.blx*P,C.blx=L,L=C.brx*D-C.bry*P,C.bry=C.bry*D+C.brx*P,C.brx=L);p.offset(c,b);a.quadTex(p.tlx,p.tly,
p.trx,p.try_,p.brx,p.bry,p.blx,p.bly,M)}G+=this.getCharacterWidth(T)*g+l}d+=k;if(d+k+m>this.height)break}}};c.prototype.CompareText=function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};g.cnds=new c;d.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=
!0,this.runtime.redraw=!0};d.prototype.SetScale=function(a){a!==this.characterScale&&(this.characterScale=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.SetCharacterSpacing=function(a){a!==this.CharacterSpacing&&(this.characterSpacing=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.SetLineHeight=function(a){a!==this.lineHeight&&(this.lineHeight=a,this.text_changed=!0,this.runtime.redraw=!0)};f.SetCharWidth=function(a,b){var c=parseInt(b,10);this.characterWidthList[a]!==c&&
(this.characterWidthList[a]=c,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.SetCharacterWidth=function(a,b){if(""!==a)for(var c=0;c<a.length;c++)this.SetCharWidth(a.charAt(c),b)};d.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};d.prototype.SetHAlign=function(a){this.halign=a/2;this.text_changed=!0;this.runtime.redraw=!0};d.prototype.SetVAlign=function(a){this.valign=a/2;this.text_changed=!0;this.runtime.redraw=
!0};g.acts=new d;e.prototype.CharacterWidth=function(a,b){a.set_int(this.getCharacterWidth(b))};e.prototype.CharacterHeight=function(a){a.set_int(this.characterHeight)};e.prototype.CharacterScale=function(a){a.set_float(this.characterScale)};e.prototype.CharacterSpacing=function(a){a.set_int(this.characterSpacing)};e.prototype.LineHeight=function(a){a.set_int(this.lineHeight)};e.prototype.Text=function(a){a.set_string(this.text)};e.prototype.TextWidth=function(a){this.rebuildText();a.set_float(this.textWidth)};
e.prototype.TextHeight=function(a){this.rebuildText();a.set_float(this.textHeight)};g.exps=new e})();cr.plugins_.Text=function(a){this.runtime=a};
(function(){function a(){return h.length?h.pop():{}}function b(a){var b,c;b=0;for(c=a.length;b<c;b++)h.push(a[b]);a.length=0}function c(){}function d(){}function e(){}var g=cr.plugins_.Text.prototype;g.onCreate=function(){g.acts.SetWidth=function(a){this.width!==a&&(this.width=a,this.text_changed=!0,this.set_bbox_changed())}};g.Type=function(a){this.plugin=a;this.runtime=a.runtime};var f=g.Type.prototype;f.onCreate=function(){};f.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=
this.instances.length;a<b;a++)c=this.instances[a],c.mycanvas=null,c.myctx=null,c.mytex=null}};g.Instance=function(a){this.type=a;this.runtime=a.runtime;this.recycled?this.lines.length=0:this.lines=[];this.text_changed=!0};var f=g.Instance.prototype,l={};f.onCreate=function(){this.text=this.properties[0];this.visible=0===this.properties[1];this.font=this.properties[2];this.color=this.properties[3];this.halign=this.properties[4];this.valign=this.properties[5];this.wrapbyword=0===this.properties[7];
this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height;this.line_height_offset=this.properties[8];this.fontstyle=this.facename="";this.textHeight=this.textWidth=this.ptSize=0;this.parseFont();this.mytex=this.myctx=this.mycanvas=null;this.need_text_redraw=!1;this.last_render_tick=this.runtime.tickcount;this.recycled?this.rcTex.set(0,0,1,1):this.rcTex=new cr.rect(0,0,1,1);this.runtime.glwrap&&this.runtime.tickMe(this)};f.parseFont=function(){var a=this.font.split(" "),b;for(b=0;b<
a.length;b++)if("pt"===a[b].substr(a[b].length-2,2)){this.ptSize=parseInt(a[b].substr(0,a[b].length-2));this.pxHeight=Math.ceil(96*(this.ptSize/72))+4;0<b&&(this.fontstyle=a[b-1]);this.facename=a[b+1];for(b+=2;b<a.length;b++)this.facename+=" "+a[b];break}};f.saveToJSON=function(){return{t:this.text,f:this.font,c:this.color,ha:this.halign,va:this.valign,wr:this.wrapbyword,lho:this.line_height_offset,fn:this.facename,fs:this.fontstyle,ps:this.ptSize,pxh:this.pxHeight,tw:this.textWidth,th:this.textHeight,
lrt:this.last_render_tick}};f.loadFromJSON=function(a){this.text=a.t;this.font=a.f;this.color=a.c;this.halign=a.ha;this.valign=a.va;this.wrapbyword=a.wr;this.line_height_offset=a.lho;this.facename=a.fn;this.fontstyle=a.fs;this.ptSize=a.ps;this.pxHeight=a.pxh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;this.text_changed=!0;this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height};f.tick=function(){if(this.runtime.glwrap&&this.mytex&&300<=this.runtime.tickcount-
this.last_render_tick){var a=this.layer;this.update_bbox();var b=this.bbox;if(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)this.runtime.glwrap.deleteTexture(this.mytex),this.mycanvas=this.myctx=this.mytex=null}};f.onDestroy=function(){this.mycanvas=this.myctx=null;this.runtime.glwrap&&this.mytex&&this.runtime.glwrap.deleteTexture(this.mytex);this.mytex=null};f.updateFont=function(){this.font=this.fontstyle+" "+this.ptSize.toString()+"pt "+this.facename;this.text_changed=
!0;this.runtime.redraw=!0};f.draw=function(a,b){a.font=this.font;a.textBaseline="top";a.fillStyle=this.color;a.globalAlpha=b?1:this.opacity;var c=1;b&&(c=this.layer.getScale(),a.save(),a.scale(c,c));if(this.text_changed||this.width!==this.lastwrapwidth)this.type.plugin.WordWrap(this.text,this.lines,a,this.width,this.wrapbyword),this.text_changed=!1,this.lastwrapwidth=this.width;this.update_bbox();var c=b?0:this.bquad.tlx,d=b?0:this.bquad.tly;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);0===
this.angle||b||(a.save(),a.translate(c,d),a.rotate(this.angle),d=c=0);var e=d+this.height,f=this.pxHeight,f=f+this.line_height_offset,h,g;1===this.valign?d+=Math.max(this.height/2-this.lines.length*f/2,0):2===this.valign&&(d+=Math.max(this.height-this.lines.length*f-2,0));for(g=0;g<this.lines.length&&!(h=c,1===this.halign?h=c+(this.width-this.lines[g].width)/2:2===this.halign&&(h=c+(this.width-this.lines[g].width)),a.fillText(this.lines[g].text,h,d),d+=f,d>=e-f);g++);(0!==this.angle||b)&&a.restore();
this.last_render_tick=this.runtime.tickcount};f.drawGL=function(a){if(!(1>this.width||1>this.height)){var b=this.text_changed||this.need_text_redraw;this.need_text_redraw=!1;var c=this.layer.getScale(),d=this.layer.getAngle(),e=this.rcTex,f=c*this.width,h=c*this.height,g=Math.ceil(f),k=Math.ceil(h),l=this.runtime.draw_width/2,I=this.runtime.draw_height/2;this.myctx||(this.mycanvas=document.createElement("canvas"),this.mycanvas.width=g,this.mycanvas.height=k,this.lastwidth=g,this.lastheight=k,b=!0,
this.myctx=this.mycanvas.getContext("2d"));if(g!==this.lastwidth||k!==this.lastheight)this.mycanvas.width=g,this.mycanvas.height=k,this.mytex&&(a.deleteTexture(this.mytex),this.mytex=null),b=!0;b&&(this.myctx.clearRect(0,0,g,k),this.draw(this.myctx,!0),this.mytex||(this.mytex=a.createEmptyTexture(g,k,this.runtime.linearSampling,this.runtime.isMobile)),a.videoToTexture(this.mycanvas,this.mytex,this.runtime.isMobile));this.lastwidth=g;this.lastheight=k;a.setTexture(this.mytex);a.setOpacity(this.opacity);
a.resetModelView();a.translate(-l,-I);a.updateModelView();var z=this.bquad,v=this.runtime.devicePixelRatio;this.runtime.devicePixelRatio=1;var b=this.layer.layerToCanvas(z.tlx,z.tly,!0,!0),l=this.layer.layerToCanvas(z.tlx,z.tly,!1,!0),I=this.layer.layerToCanvas(z.trx,z.try_,!0,!0),F=this.layer.layerToCanvas(z.trx,z.try_,!1,!0),x=this.layer.layerToCanvas(z.brx,z.bry,!0,!0),y=this.layer.layerToCanvas(z.brx,z.bry,!1,!0),B=this.layer.layerToCanvas(z.blx,z.bly,!0,!0),z=this.layer.layerToCanvas(z.blx,z.bly,
!1,!0);this.runtime.devicePixelRatio=v;if(this.runtime.pixel_rounding||0===this.angle&&0===d)var v=(b+0.5|0)-b,w=(l+0.5|0)-l,b=b+v,l=l+w,I=I+v,F=F+w,x=x+v,y=y+w,B=B+v,z=z+w;0===this.angle&&0===d?(I=b+g,F=l,x=I,y=l+k,B=b,z=y,e.right=1,e.bottom=1):(e.right=f/g,e.bottom=h/k);a.quadTex(b,l,I,F,x,y,B,z,e);a.resetModelView();a.scale(c,c);a.rotateZ(-this.layer.getAngle());a.translate((this.layer.viewLeft+this.layer.viewRight)/-2,(this.layer.viewTop+this.layer.viewBottom)/-2);a.updateModelView();this.last_render_tick=
this.runtime.tickcount}};var k=[];g.TokeniseWords=function(a){k.length=0;for(var b="",c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(k.push(b),b=""),k.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));k.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&k.push(b)};var h=[];g.WordWrap=function(c,d,e,f,h){if(c&&c.length)if(2>=f)b(d);else{if(100>=c.length&&-1===c.indexOf("\n")){var g=e.measureText(c).width;if(g<=
f){b(d);d.push(a());d[0].text=c;d[0].width=g;return}}this.WrapText(c,d,e,f,h)}else b(d)};g.WrapText=function(b,c,d,e,f){f&&(this.TokeniseWords(b),b=k);var g="",l,u,A,E=0;for(A=0;A<b.length;A++)"\n"===b[A]?(E>=c.length&&c.push(a()),u=c[E],u.text=g,u.width=d.measureText(g).width,E++,g=""):(l=g,g+=b[A],u=d.measureText(g).width,u>=e&&(E>=c.length&&c.push(a()),u=c[E],u.text=l,u.width=d.measureText(l).width,E++,g=b[A],f||" "!==g||(g="")));g.length&&(E>=c.length&&c.push(a()),u=c[E],u.text=g,u.width=d.measureText(g).width,
E++);for(A=E;A<c.length;A++)h.push(c[A]);c.length=E};c.prototype.CompareText=function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};g.cnds=new c;d.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=!0,this.runtime.redraw=!0};d.prototype.SetFontFace=
function(a,b){var c="";switch(b){case 1:c="bold";break;case 2:c="italic";break;case 3:c="bold italic"}if(a!==this.facename||c!==this.fontstyle)this.facename=a,this.fontstyle=c,this.updateFont()};d.prototype.SetFontSize=function(a){this.ptSize!==a&&(this.ptSize=a,this.pxHeight=Math.ceil(96*(this.ptSize/72))+4,this.updateFont())};d.prototype.SetFontColor=function(a){a="rgb("+cr.GetRValue(a).toString()+","+cr.GetGValue(a).toString()+","+cr.GetBValue(a).toString()+")";a!==this.color&&(this.color=a,this.need_text_redraw=
!0,this.runtime.redraw=!0)};d.prototype.SetWebFont=function(a,b){if(this.runtime.isDomFree)cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");else{var c=this,d=function(){c.runtime.redraw=!0;c.text_changed=!0};if(l.hasOwnProperty(b)){var e="'"+a+"'";if(this.facename!==e)for(this.facename=e,this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}else for(e=document.createElement("link"),e.href=b,e.rel="stylesheet",e.type=
"text/css",e.onload=d,document.getElementsByTagName("head")[0].appendChild(e),l[b]=!0,this.facename="'"+a+"'",this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}};d.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};g.acts=new d;e.prototype.Text=function(a){a.set_string(this.text)};e.prototype.FaceName=function(a){a.set_string(this.facename)};e.prototype.FaceSize=function(a){a.set_int(this.ptSize)};
e.prototype.TextWidth=function(a){var b=0,c,d,e;c=0;for(d=this.lines.length;c<d;c++)e=this.lines[c].width,b<e&&(b=e);a.set_int(b)};e.prototype.TextHeight=function(a){a.set_int(this.lines.length*(this.pxHeight+this.line_height_offset)-this.line_height_offset)};g.exps=new e})();cr.plugins_.TiledBg=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.plugins_.TiledBg.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};var e=d.Type.prototype;e.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,this.runtime.waitForImageLoad(this.texture_img),this.webGL_texture=this.pattern=null)};e.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=
null)};e.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};e.loadTextures=function(){this.is_family||this.webGL_texture||!this.runtime.glwrap||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,
this.texture_pixelformat))};e.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};e.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};d.Instance=function(a){this.type=a;this.runtime=a.runtime};e=d.Instance.prototype;e.onCreate=function(){this.visible=0===this.properties[0];this.rcTex=new cr.rect(0,0,0,0);this.has_own_texture=!1;this.texture_img=this.type.texture_img;this.runtime.glwrap?
(this.type.loadTextures(),this.webGL_texture=this.type.webGL_texture):(this.type.pattern||(this.type.pattern=this.runtime.ctx.createPattern(this.type.texture_img,"repeat")),this.pattern=this.type.pattern)};e.afterLoad=function(){this.has_own_texture=!1;this.texture_img=this.type.texture_img};e.onDestroy=function(){this.runtime.glwrap&&this.has_own_texture&&this.webGL_texture&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};e.draw=function(a){a.globalAlpha=this.opacity;
a.save();a.fillStyle=this.pattern;var b=this.x,c=this.y;this.runtime.pixel_rounding&&(b=b+0.5|0,c=c+0.5|0);var d=-(this.hotspotX*this.width),e=-(this.hotspotY*this.height),m=d%this.texture_img.width,n=e%this.texture_img.height;0>m&&(m+=this.texture_img.width);0>n&&(n+=this.texture_img.height);a.translate(b,c);a.rotate(this.angle);a.translate(m,n);a.fillRect(d-m,e-n,this.width,this.height);a.restore()};e.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);var b=this.rcTex;
b.right=this.width/this.texture_img.width;b.bottom=this.height/this.texture_img.height;var c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b)}else a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b)};a.prototype.OnURLLoaded=function(){return!0};d.cnds=new a;b.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);
this.runtime.redraw=!0};b.prototype.LoadURL=function(a){var b=new Image,c=this;b.onload=function(){c.texture_img=b;c.runtime.glwrap?(c.has_own_texture&&c.webGL_texture&&c.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=c.runtime.glwrap.loadTexture(b,!0,c.runtime.linearSampling)):c.pattern=c.runtime.ctx.createPattern(b,"repeat");c.has_own_texture=!0;c.runtime.redraw=!0;c.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded,c)};"data:"!==a.substr(0,5)&&(b.crossOrigin="anonymous");
b.src=a};d.acts=new b;c.prototype.ImageWidth=function(a){a.set_float(this.texture_img.width)};c.prototype.ImageHeight=function(a){a.set_float(this.texture_img.height)};d.exps=new c})();cr.plugins_.Touch=function(a){this.runtime=a};
(function(){function a(a){l=a.x;k=a.y;h=a.z}function b(a){m=a.x;n=a.y;p=a.z}function c(){}function d(){}var e=cr.plugins_.Touch.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime;this.touches=[];this.mouseDown=!1};var g=e.Instance.prototype,f={left:0,top:0};g.findTouch=function(a){var b,c;b=0;for(c=this.touches.length;b<c;b++)if(this.touches[b].id===a)return b;return-1};var l=0,k=0,h=0,
m=0,n=0,p=0;g.onCreate=function(){this.isWindows8=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.trigger_id=this.trigger_index=this.curTouchY=this.curTouchX=this.acc_z=this.acc_y=this.acc_x=this.acc_g_z=this.acc_g_y=this.acc_g_x=this.orient_gamma=this.orient_beta=this.orient_alpha=0;this.useMouseInput=0!==this.properties[0];var c=0<this.runtime.fullscreen_mode?document:this.runtime.canvas,d=document;this.runtime.isDirectCanvas?d=c=window.Canvas:this.runtime.isCocoonJs&&(d=
c=window);var e=this;window.navigator.pointerEnabled?(c.addEventListener("pointerdown",function(a){e.onPointerStart(a)},!1),c.addEventListener("pointermove",function(a){e.onPointerMove(a)},!1),d.addEventListener("pointerup",function(a){e.onPointerEnd(a)},!1),d.addEventListener("pointercancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},
!1),this.runtime.canvas.addEventListener("gesturehold",function(a){a.preventDefault()},!1),document.addEventListener("gesturehold",function(a){a.preventDefault()},!1))):window.navigator.msPointerEnabled?(c.addEventListener("MSPointerDown",function(a){e.onPointerStart(a)},!1),c.addEventListener("MSPointerMove",function(a){e.onPointerMove(a)},!1),d.addEventListener("MSPointerUp",function(a){e.onPointerEnd(a)},!1),d.addEventListener("MSPointerCancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&
(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1))):(c.addEventListener("touchstart",function(a){e.onTouchStart(a)},!1),c.addEventListener("touchmove",function(a){e.onTouchMove(a)},!1),d.addEventListener("touchend",function(a){e.onTouchEnd(a)},!1),d.addEventListener("touchcancel",function(a){e.onTouchEnd(a)},!1));if(this.isWindows8){var f=function(a){a=a.reading;e.acc_x=a.accelerationX;
e.acc_y=a.accelerationY;e.acc_z=a.accelerationZ},h=function(a){a=a.reading;e.orient_alpha=a.yawDegrees;e.orient_beta=a.pitchDegrees;e.orient_gamma=a.rollDegrees},g=Windows.Devices.Sensors.Accelerometer.getDefault();g&&(g.reportInterval=Math.max(g.minimumReportInterval,16),g.addEventListener("readingchanged",f));var k=Windows.Devices.Sensors.Inclinometer.getDefault();k&&(k.reportInterval=Math.max(k.minimumReportInterval,16),k.addEventListener("readingchanged",h));document.addEventListener("visibilitychange",
function(a){document.hidden||document.msHidden?(g&&g.removeEventListener("readingchanged",f),k&&k.removeEventListener("readingchanged",h)):(g&&g.addEventListener("readingchanged",f),k&&k.addEventListener("readingchanged",h))},!1)}else window.addEventListener("deviceorientation",function(a){e.orient_alpha=a.alpha||0;e.orient_beta=a.beta||0;e.orient_gamma=a.gamma||0},!1),window.addEventListener("devicemotion",function(a){a.accelerationIncludingGravity&&(e.acc_g_x=a.accelerationIncludingGravity.x||0,
e.acc_g_y=a.accelerationIncludingGravity.y||0,e.acc_g_z=a.accelerationIncludingGravity.z||0);a.acceleration&&(e.acc_x=a.acceleration.x||0,e.acc_y=a.acceleration.y||0,e.acc_z=a.acceleration.z||0)},!1);this.useMouseInput&&!this.runtime.isDomFree&&(jQuery(document).mousemove(function(a){e.onMouseMove(a)}),jQuery(document).mousedown(function(a){e.onMouseDown(a)}),jQuery(document).mouseup(function(a){e.onMouseUp(a)}));this.runtime.isAppMobi&&!this.runtime.isDirectCanvas&&AppMobi.accelerometer.watchAcceleration(a,
{frequency:40,adjustForRotation:!0});this.runtime.isPhoneGap&&navigator.accelerometer.watchAcceleration(b,null,{frequency:40});this.runtime.tick2Me(this)};g.onPointerMove=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.findTouch(a.pointerId),c=cr.performance_now();if(0<=b){var d=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset(),b=this.touches[b];2>c-b.time||(b.lasttime=b.time,b.lastx=b.x,b.lasty=b.y,b.time=
c,b.x=a.pageX-d.left,b.y=a.pageY-d.top)}}};g.onPointerStart=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset(),c=a.pageX-b.left,b=a.pageY-b.top,d=cr.performance_now();this.trigger_index=this.touches.length;this.trigger_id=a.pointerId;this.touches.push({time:d,x:c,y:b,lasttime:d,lastx:c,lasty:b,id:a.pointerId,startindex:this.trigger_index});this.runtime.isInUserInputEvent=
!0;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=c;this.curTouchY=b;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this);this.runtime.isInUserInputEvent=!1}};g.onPointerEnd=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),a=this.findTouch(a.pointerId),this.trigger_index=0<=a?this.touches[a].startindex:
-1,this.trigger_id=0<=a?this.touches[a].id:-1,this.runtime.isInUserInputEvent=!0,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.runtime.isInUserInputEvent=!1,0<=a&&this.touches.splice(a,1))};g.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b=cr.performance_now(),c,d,e,h;c=0;for(d=a.changedTouches.length;c<d;c++)if(e=a.changedTouches[c],h=this.findTouch(e.identifier),0<=h){var g=
this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset();h=this.touches[h];2>b-h.time||(h.lasttime=h.time,h.lastx=h.x,h.lasty=h.y,h.time=b,h.x=e.pageX-g.left,h.y=e.pageY-g.top)}};g.onTouchStart=function(a){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset(),c=cr.performance_now();this.runtime.isInUserInputEvent=!0;var d,e,h,g;d=0;for(e=a.changedTouches.length;d<e;d++)if(h=a.changedTouches[d],g=this.findTouch(h.identifier),-1===g){g=h.pageX-
b.left;var k=h.pageY-b.top;this.trigger_index=this.touches.length;this.trigger_id=h.identifier;this.touches.push({time:c,x:g,y:k,lasttime:c,lastx:g,lasty:k,id:h.identifier,startindex:this.trigger_index});this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=g;this.curTouchY=k;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}this.runtime.isInUserInputEvent=!1};g.onTouchEnd=
function(a){a.preventDefault&&a.preventDefault();this.runtime.isInUserInputEvent=!0;var b,c,d;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],d=this.findTouch(d.identifier),0<=d&&(this.trigger_index=this.touches[d].startindex,this.trigger_id=this.touches[d].id,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.touches.splice(d,1));this.runtime.isInUserInputEvent=!1};g.getAlpha=function(){return this.runtime.isAppMobi&&
0===this.orient_alpha&&0!==h?90*h:this.runtime.isPhoneGap&&0===this.orient_alpha&&0!==p?90*p:this.orient_alpha};g.getBeta=function(){return this.runtime.isAppMobi&&0===this.orient_beta&&0!==k?-90*k:this.runtime.isPhoneGap&&0===this.orient_beta&&0!==n?-90*n:this.orient_beta};g.getGamma=function(){return this.runtime.isAppMobi&&0===this.orient_gamma&&0!==l?90*l:this.runtime.isPhoneGap&&0===this.orient_gamma&&0!==m?90*m:this.orient_gamma};g.onMouseDown=function(a){a.preventDefault&&this.runtime.had_a_click&&
a.preventDefault();this.onTouchStart({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!0};g.onMouseMove=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();if(this.mouseDown)this.onTouchMove({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]})};g.onMouseUp=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();this.runtime.had_a_click=!0;this.onTouchEnd({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});
this.mouseDown=!1};g.tick2=function(){var a,b,c,d=cr.performance_now();a=0;for(b=this.touches.length;a<b;a++)c=this.touches[a],c.time<=d-50&&(c.lasttime=d)};c.prototype.OnTouchStart=function(){return!0};c.prototype.OnTouchEnd=function(){return!0};c.prototype.IsInTouch=function(){return this.touches.length};c.prototype.OnTouchObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};c.prototype.IsTouchingObject=function(a){if(!a)return!1;var b=
a.getCurrentSol(),c=b.getObjects(),d,e,f=[],h,g,k,m;h=0;for(g=c.length;h<g;h++){var l=c[h];l.update_bbox();k=0;for(m=this.touches.length;k<m;k++)if(e=this.touches[k],d=l.layer.canvasToLayer(e.x,e.y,!0),e=l.layer.canvasToLayer(e.x,e.y,!1),l.contains_pt(d,e)){f.push(l);break}}return f.length?(b.select_all=!1,b.instances=f,a.applySolToContainer(),!0):!1};c.prototype.CompareTouchSpeed=function(a,b,c){a=Math.floor(a);if(0>a||a>=this.touches.length)return!1;var d=this.touches[a];a=cr.distanceTo(d.x,d.y,
d.lastx,d.lasty);var d=(d.time-d.lasttime)/1E3,e=0;0<d&&(e=a/d);return cr.do_cmp(e,b,c)};c.prototype.OrientationSupported=function(){return"undefined"!==typeof window.DeviceOrientationEvent};c.prototype.MotionSupported=function(){return"undefined"!==typeof window.DeviceMotionEvent};c.prototype.CompareOrientation=function(a,b,c){var d=0,d=0===a?this.getAlpha():1===a?this.getBeta():this.getGamma();return cr.do_cmp(d,b,c)};c.prototype.CompareAcceleration=function(a,b,c){var d=0;0===a?d=this.acc_g_x:
1===a?d=this.acc_g_y:2===a?d=this.acc_g_z:3===a?d=this.acc_x:4===a?d=this.acc_y:5===a&&(d=this.acc_z);return cr.do_cmp(d,b,c)};c.prototype.OnNthTouchStart=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.OnNthTouchEnd=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.HasNthTouch=function(a){a=Math.floor(a);return this.touches.length>=a+1};e.cnds=new c;d.prototype.TouchCount=function(a){a.set_int(this.touches.length)};d.prototype.X=function(a,b){if(this.touches.length){var c,
d,e,f,h;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=h):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)):a.set_float(0)}else a.set_float(0)};
d.prototype.XAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=h):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?
a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)):a.set_float(0)}};d.prototype.XForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=h):(c=
cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!0)):a.set_float(0)}};d.prototype.Y=function(a,b){if(this.touches.length){var c,d,e,f,h;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)),c.scale=d,c.zoomRate=
e,c.parallaxY=f,c.angle=h):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)):a.set_float(0)}else a.set_float(0)};d.prototype.YAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=
this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=h):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)):a.set_float(0)}};d.prototype.YForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,
f=c.parallaxY,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=h):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!1)):a.set_float(0)}};d.prototype.AbsoluteX=function(a){this.touches.length?a.set_float(this.touches[0].x):a.set_float(0)};d.prototype.AbsoluteXAt=function(a,
b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].x)};d.prototype.AbsoluteXForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].x)};d.prototype.AbsoluteY=function(a){this.touches.length?a.set_float(this.touches[0].y):a.set_float(0)};d.prototype.AbsoluteYAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].y)};d.prototype.AbsoluteYForID=function(a,b){var c=this.findTouch(b);
0>c?a.set_float(0):a.set_float(this.touches[c].y)};d.prototype.SpeedAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b],d=cr.distanceTo(c.x,c.y,c.lastx,c.lasty),c=(c.time-c.lasttime)/1E3;0===c?a.set_float(0):a.set_float(d/c)}};d.prototype.SpeedForID=function(a,b){var c=this.findTouch(b);if(0>c)a.set_float(0);else{var d=this.touches[c],c=cr.distanceTo(d.x,d.y,d.lastx,d.lasty),d=(d.time-d.lasttime)/1E3;0===d?a.set_float(0):a.set_float(c/d)}};d.prototype.AngleAt=
function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b];a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y)))}};d.prototype.AngleForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):(c=this.touches[c],a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y))))};d.prototype.Alpha=function(a){a.set_float(this.getAlpha())};d.prototype.Beta=function(a){a.set_float(this.getBeta())};d.prototype.Gamma=function(a){a.set_float(this.getGamma())};
d.prototype.AccelerationXWithG=function(a){a.set_float(this.acc_g_x)};d.prototype.AccelerationYWithG=function(a){a.set_float(this.acc_g_y)};d.prototype.AccelerationZWithG=function(a){a.set_float(this.acc_g_z)};d.prototype.AccelerationX=function(a){a.set_float(this.acc_x)};d.prototype.AccelerationY=function(a){a.set_float(this.acc_y)};d.prototype.AccelerationZ=function(a){a.set_float(this.acc_z)};d.prototype.TouchIndex=function(a){a.set_int(this.trigger_index)};d.prototype.TouchID=function(a){a.set_float(this.trigger_id)};
e.exps=new d})();cr.plugins_.win8=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(a){var b,c,d,e,f=0,h=[];do b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(f++)),c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(f++)),d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(f++)),e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(f++)),d=b<<18|c<<12|d<<6|e,b=d>>16&255,c=d>>8&255,d&=255,
h.push(b),h.push(c),h.push(d);while(f<a.length);return h}function d(a,b){if("data:"!==a.substr(0,5))return!1;var d=a.substring(5).split(",");if(2!==d.length)return!1;var e;if(-1<d[0].indexOf("image/png"))e="png";else if(-1<d[0].indexOf("image/jpeg"))e="jpg";else return!1;e="shareimage."+e;if(-1===d[0].indexOf(";base64"))return!1;var f=c(d[1]);Windows.Storage.ApplicationData.current.localFolder.createFileAsync(e,Windows.Storage.CreationCollisionOption.replaceExisting).then(function(a){Windows.Storage.FileIO.writeBytesAsync(a,
f).then(function(){b&&b(a)})})}function e(){}var g=cr.plugins_.win8.prototype;g.Type=function(a){this.plugin=a;this.runtime=a.runtime};g.Type.prototype.onCreate=function(){};g.Instance=function(a){this.type=a;this.runtime=a.runtime};var f=g.Instance.prototype,l=null,k=!1;f.onCreate=function(){this.isWindows8=this.runtime.isWindows8App;this.triggerViewState=0;this.isTestMode=0!==this.properties[0];this.showAbout=0!==this.properties[1];this.showSupport=0!==this.properties[2];this.showPrivacy=0!==this.properties[3];
this.appFormattedPrice="";this.currentApp=this.lastProductListings=null;var a=this;if(this.isWindows8){var b=Windows.ApplicationModel.Store;this.currentApp=this.isTestMode?b.CurrentAppSimulator:b.CurrentApp;this.isTestMode&&(new Windows.UI.Popups.MessageDialog("Note: this Windows 8 app is in Test Mode, designed for testing purchases. Before publishing, be sure to set Test Mode to 'No' in the Windows 8 object's properties.")).showAsync();window.addEventListener("resize",function(){a.triggerViewState=
Windows.UI.ViewManagement.ApplicationView.value;a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnViewStateChange,a)});Windows.Storage.ApplicationData.current.addEventListener("datachanged",function(){a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnDataChanged,a)});Windows.ApplicationModel.DataTransfer.DataTransferManager.getForCurrentView().addEventListener("datarequested",function(b){l=b;k=!1;a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnShare,a);l=null;k||b.request.failWithDisplayText("Try selecting a different option before sharing.")});
this.currentApp.licenseInformation.addEventListener("licensechanged",function(){a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnLicenseChanged,a)});(this.showAbout||this.showSupport||this.showPrivacy)&&WinJS.Application.addEventListener("settings",function(b){var c={};a.showAbout&&(c.about={title:"About",href:"/about.html"});a.showSupport&&(c.support={title:"Support",href:"/support.html"});a.showPrivacy&&(c.privacy={title:"Privacy Policy",href:"/privacy.html"});b.detail.applicationcommands=c;
WinJS.UI.SettingsFlyout.populateSettings(b)});this.isTestMode&&Windows.ApplicationModel.Package.current.installedLocation.getFileAsync("WindowsStoreProxy.xml").done(function(a){Windows.ApplicationModel.Store.CurrentAppSimulator.reloadSimulatorAsync(a).done(function(){console.log("[Construct 2] Test mode; loaded WindowsStoreProxy.xml")},function(a){console.log("[Construct 2] Error loading WindowsStoreProxy.xml: "+a)})},function(a){console.log("[Construct 2] Error loading WindowsStoreProxy.xml: "+a)})}};
f.roamingValues=function(){return this.isWindows8?Windows.Storage.ApplicationData.current.roamingSettings.values:null};a.prototype.IsWindows8=function(){return this.isWindows8};a.prototype.OnViewStateChange=function(a){return this.isWindows8?a===this.triggerViewState:!1};a.prototype.CompareViewState=function(a){return this.isWindows8?Windows.UI.ViewManagement.ApplicationView.value===a:!1};a.prototype.OnDataChanged=function(){return!0};a.prototype.RoamingKeyExists=function(a){return this.isWindows8?
this.roamingValues().hasKey(a):!1};a.prototype.OnShare=function(){return!0};a.prototype.OnLicenseChanged=function(){return!0};a.prototype.OnPurchaseSuccess=function(){return!0};a.prototype.OnPurchaseFail=function(){return!0};a.prototype.OnStoreListing=function(){return!0};a.prototype.IsTrial=function(){return this.isWindows8&&this.currentApp.licenseInformation.isTrial&&this.currentApp.licenseInformation.isActive};a.prototype.IsLicensed=function(){return this.isWindows8&&!this.currentApp.licenseInformation.isTrial&&
this.currentApp.licenseInformation.isActive};a.prototype.IsExpiredTrial=function(){return this.isWindows8&&this.currentApp.licenseInformation.isTrial&&!this.currentApp.licenseInformation.isActive};a.prototype.HasProduct=function(a){if(!this.isWindows8)return!1;var b=this.currentApp.licenseInformation.productLicenses;return b.hasKey(a)?b.lookup(a).isActive:!1};g.cnds=new a;b.prototype.TryUnsnap=function(){this.isWindows8&&Windows.UI.ViewManagement.ApplicationView.tryUnsnap()};b.prototype.SetRoamingValue=
function(a,b){this.isWindows8&&(this.roamingValues()[a]=b.toString())};b.prototype.RemoveRoamingValue=function(a){this.isWindows8&&this.roamingValues().remove(a)};b.prototype.ClearRoamingData=function(){this.isWindows8&&this.roamingValues().clear()};b.prototype.ShowShareUI=function(){this.isWindows8&&Windows.ApplicationModel.DataTransfer.DataTransferManager.showShareUI()};b.prototype.ShareText=function(a,b,c){if(this.isWindows8&&l){var d=l.request;d.data.properties.title=a;d.data.properties.description=
b;d.data.setText(c);k=!0}};b.prototype.ShareLink=function(a,b,c){if(this.isWindows8&&l){var d=l.request;d.data.properties.title=a;d.data.properties.description=b;d.data.setUri(new Windows.Foundation.Uri(c));k=!0}};b.prototype.ShareHTML=function(a,b,c){if(this.isWindows8&&l){var d=l.request;d.data.properties.title=a;d.data.properties.description=b;a=Windows.ApplicationModel.DataTransfer.HtmlFormatHelper.createHtmlFormat(c);d.data.setHtmlFormat(a);k=!0}};b.prototype.ShareSpriteImage=function(a,b,c){if(this.isWindows8&&
l&&c&&(c=c.getFirstPicked())&&c.curFrame){c=c.curFrame.getDataUri();var e=l.request;e.data.properties.title=a;e.data.properties.description=b;var f=e.getDeferral();d(c,function(a){e.data.setBitmap(Windows.Storage.Streams.RandomAccessStreamReference.createFromFile(a));f.complete()});k=!0}};b.prototype.ShareDataUri=function(a,b,c){if(this.isWindows8&&l){var e=l.request;e.data.properties.title=a;e.data.properties.description=b;var f=e.getDeferral();d(c,function(a){e.data.setBitmap(Windows.Storage.Streams.RandomAccessStreamReference.createFromFile(a));
f.complete()});k=!0}};b.prototype.FailShare=function(a){this.isWindows8&&l&&(l.request.failWithDisplayText(a),k=!0)};var h="tileSquareBlock tileSquareText02 tileSquareText04 tileWideText03 tileWideText04 tileWideText09".split(" ");b.prototype.SetLiveTileText=function(a,b,c){a=Math.floor(a);if(this.isWindows8&&0<=a&&a<h.length){var d=Windows.UI.Notifications;a=d.TileUpdateManager.getTemplateContent(d.TileTemplateType[h[a]]);var e=a.getElementsByTagName("text");e[0].appendChild(a.createTextNode(b));
2<=e.length&&e[1].appendChild(a.createTextNode(c));b=new d.TileNotification(a);d.TileUpdateManager.createTileUpdaterForApplication().update(b)}};b.prototype.PurchaseApp=function(){if(this.isWindows8){var a=this;this.currentApp.requestAppPurchaseAsync(!1).then(function(){console.log("[Construct 2] App purchased OK");a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseSuccess,a)},function(b){console.log("[Construct 2] App purchase failed: "+b);a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseFail,
a)})}};b.prototype.PurchaseProduct=function(a){if(this.isWindows8){var b=this;this.currentApp.requestProductPurchaseAsync(a,!1).then(function(){console.log("[Construct 2] Product '"+a+"' purchased OK");b.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseSuccess,b)},function(c){console.log("[Construct 2] Product '"+a+"' purchase failed: "+c);b.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseFail,b)})}};b.prototype.RequestStoreListing=function(){if(this.isWindows8){var a=this;this.currentApp.loadListingInformationAsync().then(function(b){console.log("[Construct 2] Listing information loaded");
a.appFormattedPrice=b.formattedPrice;a.lastProductListings=b.productListings;a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnStoreListing,a)})}};g.acts=new b;e.prototype.RoamingValue=function(a,b){if(this.isWindows8){var c=this.roamingValues()[b];a.set_string(c?c.toString():"")}else a.set_string("")};e.prototype.TrialTimeLeft=function(a){this.isWindows8?a.set_float((this.currentApp.licenseInformation.expirationDate.getTime()-Date.now())/1E3):a.set_float(0)};e.prototype.AppFormattedPrice=function(a){a.set_string(this.appFormattedPrice)};
e.prototype.ProductName=function(a,b){var c="";this.isWindows8&&this.lastProductListings&&this.lastProductListings.hasKey(b)&&(c=this.lastProductListings.lookup(b).name);a.set_string(c)};e.prototype.ProductFormattedPrice=function(a,b){var c="";this.isWindows8&&this.lastProductListings&&this.lastProductListings.hasKey(b)&&(c=this.lastProductListings.lookup(b).formattedPrice);a.set_string(c)};g.exps=new e})();
cr.behaviors.DragnDrop=function(a){this.runtime=a;var b=this;this.runtime.isDomFree||(jQuery(document).mousemove(function(a){b.onMouseMove(a)}),jQuery(document).mousedown(function(a){b.onMouseDown(a)}),jQuery(document).mouseup(function(a){b.onMouseUp(a)}));a=0<this.runtime.fullscreen_mode?document:this.runtime.canvas;this.runtime.isDirectCanvas?a=window.Canvas:this.runtime.isCocoonJs&&(a=window);window.navigator.pointerEnabled?(a.addEventListener("pointerdown",function(a){b.onPointerStart(a)},!1),
a.addEventListener("pointermove",function(a){b.onPointerMove(a)},!1),a.addEventListener("pointerup",function(a){b.onPointerEnd(a)},!1),a.addEventListener("pointercancel",function(a){b.onPointerEnd(a)},!1)):window.navigator.msPointerEnabled?(a.addEventListener("MSPointerDown",function(a){b.onPointerStart(a)},!1),a.addEventListener("MSPointerMove",function(a){b.onPointerMove(a)},!1),a.addEventListener("MSPointerUp",function(a){b.onPointerEnd(a)},!1),a.addEventListener("MSPointerCancel",function(a){b.onPointerEnd(a)},
!1)):(a.addEventListener("touchstart",function(a){b.onTouchStart(a)},!1),a.addEventListener("touchmove",function(a){b.onTouchMove(a)},!1),a.addEventListener("touchend",function(a){b.onTouchEnd(a)},!1),a.addEventListener("touchcancel",function(a){b.onTouchEnd(a)},!1))};
(function(){function a(a){var b,c;b=0;for(c=a.behavior_insts.length;b<c;b++)if(a.behavior_insts[b]instanceof d.Instance)return a.behavior_insts[b];return null}function b(){}function c(){}var d=cr.behaviors.DragnDrop.prototype,e={left:0,top:0};d.onMouseDown=function(a){if(1===a.which)this.onInputDown("leftmouse",a.pageX,a.pageY)};d.onMouseMove=function(a){if(1===a.which)this.onInputMove("leftmouse",a.pageX,a.pageY)};d.onMouseUp=function(a){if(1===a.which)this.onInputUp("leftmouse")};d.onTouchStart=
function(a){a.preventDefault&&a.preventDefault();var b,c,d,e;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],e=d.identifier,this.onInputDown(e?e.toString():"<none>",d.pageX,d.pageY)};d.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b,c,d,e;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],e=d.identifier,this.onInputMove(e?e.toString():"<none>",d.pageX,d.pageY)};d.onTouchEnd=function(a){a.preventDefault&&a.preventDefault();var b,c,d;b=0;for(c=a.changedTouches.length;b<
c;b++)d=a.changedTouches[b],d=d.identifier,this.onInputUp(d?d.toString():"<none>")};d.onPointerStart=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputDown(a.pointerId.toString(),a.pageX,a.pageY))};d.onPointerMove=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputMove(a.pointerId.toString(),a.pageX,a.pageY))};d.onPointerEnd=function(a){a.pointerType!==
a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputUp(a.pointerId.toString()))};d.onInputDown=function(b,c,d){var h=this.runtime.isDomFree?e:jQuery(this.runtime.canvas).offset();c-=h.left;d-=h.top;var g,n,p,q,h=this.my_instances.valuesRef(),r,t,s,u=null;r=0;for(t=h.length;r<t;r++)if(s=h[r],g=a(s),g.enabled&&!g.dragging&&(g=s.layer.canvasToLayer(c,d,!0),n=s.layer.canvasToLayer(c,d,!1),s.update_bbox(),s.contains_pt(g,n)))u?s.layer.index>u.layer.index?
(u=s,p=g,q=n):s.layer.index===u.layer.index&&s.get_zindex()>u.get_zindex()&&(u=s,p=g,q=n):(u=s,p=g,q=n);if(u)a(u).onDown(b,p,q)};d.onInputMove=function(b,c,d){var h=this.runtime.isDomFree?e:jQuery(this.runtime.canvas).offset();c-=h.left;d-=h.top;var g,n=this.my_instances.valuesRef(),p,q,r;p=0;for(q=n.length;p<q;p++)g=n[p],r=a(g),!r.enabled||!r.dragging||r.dragging&&r.dragsource!==b||(h=g.layer.canvasToLayer(c,d,!0),g=g.layer.canvasToLayer(c,d,!1),r.onMove(h,g))};d.onInputUp=function(b){var c=this.my_instances.valuesRef(),
d,e,g;d=0;for(e=c.length;d<e;d++)if(g=c[d],g=a(g),g.dragging&&g.dragsource===b)g.onUp()};d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var g=d.Instance.prototype;g.onCreate=function(){this.dragging=!1;this.dy=this.dx=0;this.dragsource="<none>";this.axes=this.properties[0];this.enabled=0!==this.properties[1]};g.saveToJSON=function(){return{enabled:this.enabled}};
g.loadFromJSON=function(a){this.enabled=a.enabled;this.dragging=!1};g.onDown=function(a,b,c){this.dx=b-this.inst.x;this.dy=c-this.inst.y;this.dragging=!0;this.dragsource=a;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDragStart,this.inst);this.runtime.isInUserInputEvent=!1};g.onMove=function(a,b){var c=a-this.dx,d=b-this.dy;if(0===this.axes){if(this.inst.x!==c||this.inst.y!==d)this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed()}else 1===this.axes?
this.inst.x!==c&&(this.inst.x=c,this.inst.set_bbox_changed()):2===this.axes&&this.inst.y!==d&&(this.inst.y=d,this.inst.set_bbox_changed())};g.onUp=function(){this.dragging=!1;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDrop,this.inst);this.runtime.isInUserInputEvent=!1};g.tick=function(){};b.prototype.IsDragging=function(){return this.dragging};b.prototype.OnDragStart=function(){return!0};b.prototype.OnDrop=function(){return!0};b.prototype.IsEnabled=
function(){return!!this.enabled};d.cnds=new b;c.prototype.SetEnabled=function(a){this.enabled=0!==a;this.enabled||(this.dragging=!1)};c.prototype.Drop=function(){if(this.dragging)this.onUp()};d.acts=new c;d.exps=new function(){}})();cr.behaviors.Fade=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Fade.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){var a=1===this.properties[0];this.fadeInTime=this.properties[1];this.waitTime=this.properties[2];this.fadeOutTime=this.properties[3];this.destroy=this.properties[4];
this.stage=a?0:3;this.recycled?this.stageTime.reset():this.stageTime=new cr.KahanAdder;this.maxOpacity=this.inst.opacity?this.inst.opacity:1;a&&(0===this.fadeInTime?(this.stage=1,0===this.waitTime&&(this.stage=2)):(this.inst.opacity=0,this.runtime.redraw=!0))};d.saveToJSON=function(){return{fit:this.fadeInTime,wt:this.waitTime,fot:this.fadeOutTime,s:this.stage,st:this.stageTime.sum,mo:this.maxOpacity}};d.loadFromJSON=function(a){this.fadeInTime=a.fit;this.waitTime=a.wt;this.fadeOutTime=a.fot;this.stage=
a.s;this.stageTime.reset();this.stageTime.sum=a.st;this.maxOpacity=a.mo};d.tick=function(){this.stageTime.add(this.runtime.getDt(this.inst));0===this.stage&&(this.inst.opacity=this.stageTime.sum/this.fadeInTime*this.maxOpacity,this.runtime.redraw=!0,this.inst.opacity>=this.maxOpacity&&(this.inst.opacity=this.maxOpacity,this.stage=1,this.stageTime.reset()));1===this.stage&&this.stageTime.sum>=this.waitTime&&(this.stage=2,this.stageTime.reset());2===this.stage&&0!==this.fadeOutTime&&(this.inst.opacity=
this.maxOpacity-this.stageTime.sum/this.fadeOutTime*this.maxOpacity,this.runtime.redraw=!0,0>this.inst.opacity&&(this.inst.opacity=0,this.stage=3,this.stageTime.reset(),this.runtime.trigger(cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,this.inst),1===this.destroy&&this.runtime.DestroyInstance(this.inst)))};d.doStart=function(){this.stage=0;this.stageTime.reset();0===this.fadeInTime?(this.stage=1,0===this.waitTime&&(this.stage=2)):(this.inst.opacity=0,this.runtime.redraw=!0)};a.prototype.OnFadeOutEnd=
function(){return!0};c.cnds=new a;b.prototype.StartFade=function(){3===this.stage&&this.doStart()};b.prototype.RestartFade=function(){this.doStart()};c.acts=new b})();cr.behaviors.Flash=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Flash.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.timeleft=this.stagetimeleft=this.stage=this.offtime=this.ontime=0};d.saveToJSON=function(){return{ontime:this.ontime,offtime:this.offtime,stage:this.stage,stagetimeleft:this.stagetimeleft,
timeleft:this.timeleft}};d.loadFromJSON=function(a){this.ontime=a.ontime;this.offtime=a.offtime;this.stage=a.stage;this.stagetimeleft=a.stagetimeleft;this.timeleft=a.timeleft};d.tick=function(){if(!(0>=this.timeleft)){var a=this.runtime.getDt(this.inst);this.timeleft-=a;0>=this.timeleft?(this.timeleft=0,this.inst.visible=!0,this.runtime.redraw=!0,this.runtime.trigger(cr.behaviors.Flash.prototype.cnds.OnFlashEnded,this.inst)):(this.stagetimeleft-=a,0>=this.stagetimeleft&&(0===this.stage?(this.inst.visible=
!1,this.stage=1,this.stagetimeleft+=this.offtime):(this.inst.visible=!0,this.stage=0,this.stagetimeleft+=this.ontime),this.runtime.redraw=!0))}};a.prototype.IsFlashing=function(){return 0<this.timeleft};a.prototype.OnFlashEnded=function(){return!0};c.cnds=new a;b.prototype.Flash=function(a,b,c){this.ontime=a;this.offtime=b;this.stage=1;this.stagetimeleft=b;this.timeleft=c;this.inst.visible=!1;this.runtime.redraw=!0};b.prototype.StopFlashing=function(){this.timeleft=0;this.inst.visible=!0;this.runtime.redraw=
!0};c.acts=new b;c.exps=new function(){}})();var Box2D={Dynamics:{}};Box2D.Dynamics.Joints={};Box2D.Common={};Box2D.Common.Math={};Box2D.Collision={};Box2D.Collision.Shapes={};function c2inherit(a,b){for(var c in b.prototype)b.prototype.hasOwnProperty(c)&&(a.prototype[c]=b.prototype[c])}
if(navigator.isCocoonJS&&"undefined"!==typeof window.cr_cjs_accelerated_physics)cr.logexport("Using CocoonJS native physics"),window.ext&&"undefined"!==typeof window.ext.IDTK_SRV_BOX2D?function(){var a=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};Box2D.Common.Math.b2Vec2=a;a._freeCache=[];a.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,b)};a.Free=function(a){1E4>
Box2D.Common.Math.b2Vec2._freeCache.length&&Box2D.Common.Math.b2Vec2._freeCache.push(a)};a.prototype.SetZero=function(){this.y=this.x=0};a.prototype.Set=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};a.prototype.SetV=function(a){this.x=a.x;this.y=a.y};a.Make=function(b,c){void 0===b&&(b=0);void 0===c&&(c=0);return a.Get(b,c)};a.prototype.Copy=function(){return a.Get(this.x,this.y)};a.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};a.prototype.Subtract=function(a){this.x-=
a.x;this.y-=a.y};a.prototype.Multiply=function(a){void 0===a&&(a=0);this.x*=a;this.y*=a};a.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)};a.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};a.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};a.prototype.NegativeSelf=function(){this.x=-this.x;this.y=-this.y};var b=function(){this.col1=a.Get(0,0);this.col2=
a.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22=b;b.FromAngle=function(a){void 0===a&&(a=0);var c=new b;c.Set(a);return c};b.FromVV=function(a,c){var d=new b;d.SetVV(a,c);return d};b.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a);a=Math.sin(a);this.col1.x=b;this.col2.x=-a;this.col1.y=a;this.col2.y=b};b.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};b.prototype.Copy=function(){var a=new b;a.SetM(this);return a};b.prototype.SetM=function(a){this.col1.SetV(a.col1);
this.col2.SetV(a.col2)};b.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y};b.prototype.SetIdentity=function(){this.col1.x=1;this.col2.x=0;this.col1.y=0;this.col2.y=1};b.prototype.SetZero=function(){this.col1.x=0;this.col2.x=0;this.col1.y=0;this.col2.y=0};b.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};b.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,f=b*e-c*
d;0!==f&&(f=1/f);a.col1.x=f*e;a.col2.x=-f*c;a.col1.y=-f*d;a.col2.y=f*b;return a};b.prototype.Solve=function(a,b,c){void 0===b&&(b=0);void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,f=this.col1.y,g=this.col2.y,k=d*g-e*f;0!==k&&(k=1/k);a.x=k*(g*b-e*c);a.y=k*(d*c-f*b);return a};b.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};var c=function(c,d){this.position=a.Get(0,0);this.R=new b;void 0===c&&(c=null);void 0===d&&(d=null);c&&(this.position.SetV(c),this.R.SetM(d))};Box2D.Common.Math.b2Transform=
c;c.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};c.prototype.SetIdentity=function(){this.position.SetZero();this.R.SetIdentity()};c.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};c.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var d=function(){};Box2D.Common.Math.b2Math=d;d.IsValid=function(a){void 0===a&&(a=0);return isFinite(a)};d.Dot=function(a,b){return a.x*b.x+a.y*b.y};d.CrossVV=function(a,b){return a.x*b.y-
a.y*b.x};d.CrossVF=function(b,c){void 0===c&&(c=0);return a.Get(c*b.y,-c*b.x)};d.CrossFV=function(b,c){void 0===b&&(b=0);return a.Get(-b*c.y,b*c.x)};d.MulMV=function(b,c){return a.Get(b.col1.x*c.x+b.col2.x*c.y,b.col1.y*c.x+b.col2.y*c.y)};d.MulTMV=function(b,c){return a.Get(d.Dot(c,b.col1),d.Dot(c,b.col2))};d.MulX=function(a,b){var c=d.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};d.MulXT=function(a,b){var c=d.SubtractVV(b,a.position),e=c.x*a.R.col1.x+c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+
c.y*a.R.col2.y;c.x=e;return c};d.AddVV=function(b,c){return a.Get(b.x+c.x,b.y+c.y)};d.SubtractVV=function(b,c){return a.Get(b.x-c.x,b.y-c.y)};d.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)};d.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};d.MulFV=function(b,c){void 0===b&&(b=0);return a.Get(b*c.x,b*c.y)};d.AddMM=function(a,c){return b.FromVV(d.AddVV(a.col1,c.col1),d.AddVV(a.col2,c.col2))};d.MulMM=function(a,c){return b.FromVV(d.MulMV(a,c.col1),d.MulMV(a,
c.col2))};d.MulTMM=function(c,e){var f=a.Get(d.Dot(c.col1,e.col1),d.Dot(c.col2,e.col1)),g=a.Get(d.Dot(c.col1,e.col2),d.Dot(c.col2,e.col2));return b.FromVV(f,g)};d.Abs=function(a){void 0===a&&(a=0);return 0<a?a:-a};d.AbsV=function(b){return a.Get(d.Abs(b.x),d.Abs(b.y))};d.AbsM=function(a){return b.FromVV(d.AbsV(a.col1),d.AbsV(a.col2))};d.Min=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);return a<b?a:b};d.MinV=function(b,c){return a.Get(d.Min(b.x,c.x),d.Min(b.y,c.y))};d.Max=function(a,b){void 0===
a&&(a=0);void 0===b&&(b=0);return a>b?a:b};d.MaxV=function(b,c){return a.Get(d.Max(b.x,c.x),d.Max(b.y,c.y))};d.Clamp=function(a,b,c){void 0===a&&(a=0);void 0===b&&(b=0);void 0===c&&(c=0);return a<b?b:a>c?c:a};d.ClampV=function(a,b,c){return d.MaxV(b,d.MinV(a,c))};d.Swap=function(a,b){var c=a[0];a[0]=b[0];b[0]=c};d.Random=function(){return 2*Math.random()-1};d.RandomRange=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);var c=Math.random();return(b-a)*c+a};d.NextPowerOfTwo=function(a){void 0===a&&
(a=0);a|=a>>1&2147483647;a|=a>>2&1073741823;a|=a>>4&268435455;a|=a>>8&16777215;return(a|a>>16&65535)+1};d.IsPowerOfTwo=function(a){void 0===a&&(a=0);return 0<a&&0===(a&a-1)};d.b2Vec2_zero=new a(0,0);d.b2Mat22_identity=b.FromVV(new a(1,0),new a(0,1));d.b2Transform_identity=new c(d.b2Vec2_zero,d.b2Mat22_identity);var e=function(){this.e_aabbBit=4;this.e_centerOfMassBit=16;this.e_controllerBit=32;this.e_jointBit=2;this.e_pairBit=8;this.e_shapeBit=0};Box2D.Dynamics.b2DebugDraw=e;e.prototype.AppendFlags=
function(){};e.prototype.ClearFlags=function(){};e.prototype.DrawCircle=function(){};e.prototype.DrawPolygon=function(){};e.prototype.DrawSegment=function(){};e.prototype.DrawSolidCircle=function(){};e.prototype.DrawSolidPolygon=function(){};e.prototype.DrawTransform=function(){};e.prototype.GetAlpha=function(){};e.prototype.GetDrawScale=function(){};e.prototype.GetFillAlpha=function(){};e.prototype.GetFlags=function(){};e.prototype.GetLineThickness=function(){};e.prototype.GetSprite=function(){};
e.prototype.GetXFormScale=function(){};e.prototype.SetAlpha=function(){};e.prototype.SetDrawScale=function(){};e.prototype.SetFillAlpha=function(){};e.prototype.SetFlags=function(){};e.prototype.SetLineThickness=function(){};e.prototype.SetSprite=function(){};e.prototype.SetXFormScale=function(){};Box2D.Dynamics.b2BodyDef=function(){this.position=a.Get(0,0);this.linearVelocity=a.Get(0,0);this.userData=null;this.angle=0;this.linearVelocity.Set(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=
0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=f.b2_staticBody;this.active=!0;this.inertiaScale=1};var g=function(b,c,d,e){this.m_body=b;this.m_userData=c;this.m_fixtureID=d;this.m_shape={};this.m_shape.m_centroid=a.Get(0,0);this.m_isSensor=!1;this.m_density=e.density;this.m_friction=e.friction;this.m_restitution=e.restitution;this.m_isSensor=e.isSensor};Box2D.Dynamics.b2Fixture=g;g.prototype.GetBody=function(){return this.m_body};g.prototype.GetShape=function(){console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding");
return null};g.prototype.GetUserData=function(){return this.m_userData};g.prototype.SetSensor=function(a){this.m_isSensor=a;window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)};g.prototype.IsSensor=function(){return this.m_isSensor};g.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_density=a};g.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",
this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_friction=a};g.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_restitution=a};g.prototype.GetDensity=function(){return this.m_density};g.prototype.GetFriction=function(){return this.m_friction};g.prototype.GetRestitution=function(){return this.m_restitution};var f=function(a,d){var e=a.userData;a.userData=null;this.m_world=d;this.m_xf=new c(a.position,
b.FromAngle(a.angle));this.m_fixtures=[];this.m_active=a.active;a.type===f.b2_staticBody&&(a.density=0);this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",d.m_worldID,a);this.m_userData=e;a.userData=e};Box2D.Dynamics.b2Body=f;f.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;a=new g(this,b,c,a);this.m_world.m_fixturesList[c]=a;this.m_fixtures.push(a);return a};
f.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]};f.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID);delete this.m_world.m_fixturesList[a.m_fixtureID]};f.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b);this.m_xf.R.Set(b);this.m_xf.position.SetV(a)};f.prototype.GetPosition=function(){return this.m_xf.position};
f.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};f.prototype.GetLinearVelocity=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};f.prototype.GetWorldCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};f.prototype.GetLocalCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",
this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};f.prototype.GetLocalPoint=function(a){return d.MulXT(this.m_xf,a)};f.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};f.prototype.GetMass=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getMass",this.m_world.m_worldID,this.m_bodyID)};f.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,
this.m_bodyID)};f.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)};f.prototype.SetFixedRotation=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFixedRotation",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",
this.m_world.m_worldID,this.m_bodyID,a.x,a.y)};f.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)};f.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};f.prototype.ApplyTorque=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)};f.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",
this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetActive=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a);this.m_active=a};f.prototype.IsActive=function(){return this.m_active};f.prototype.GetAngle=
function(){return this.m_xf.R.GetAngle()};f.prototype.SetAngle=function(a){void 0===a&&(a=0);this.SetPositionAndAngle(this.GetPosition(),a)};f.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);return b};f.prototype.SetUserData=function(a){this.m_userData=a};f.prototype.GetUserData=function(){return this.m_userData};f.prototype.GetWorld=function(){return this.m_world};
Box2D.Dynamics.b2Body.b2_staticBody=0;Box2D.Dynamics.b2Body.b2_kinematicBody=1;Box2D.Dynamics.b2Body.b2_dynamicBody=2;var l=function(a,b,c){this.m_fixtureA=a;this.m_fixtureB=b;this.m_touching=c};Box2D.Dynamics.b2Contact=l;l.prototype.GetFixtureA=function(){return this.m_fixtureA};l.prototype.GetFixtureB=function(){return this.m_fixtureB};l.prototype.IsTouching=function(){return this.m_touching};e=function(){};Box2D.Dynamics.b2ContactListener=e;e.prototype.BeginContact=function(){};e.prototype.EndContact=
function(){};e.prototype.PreSolve=function(){};e.prototype.PostSolve=function(){};Box2D.Dynamics.b2ContactListener.b2_defaultListener=new e;Box2D.Dynamics.b2ContactFilter=function(){};e=function(a,b){this.m_bodyList=[];this.m_jointList=[];this.m_fixturesList=[];this.m_contactListener=null;this.m_jointsList=[];this.m_worldID=window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};Box2D.Dynamics.b2World=e;e.prototype.SetContactListener=function(a){this.m_contactListener=a};e.prototype.SetContactFilter=
function(a){var b=this;window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",this.m_worldID,function(c,d){return a.ShouldCollide(b.m_fixturesList[c],b.m_fixturesList[d])})};e.prototype.CreateBody=function(a){a=new f(a,this);return this.m_bodyList[a.m_bodyID]=a};e.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",this.m_worldID,a.m_bodyID);delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]};
e.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID;a.bodyB=c.m_bodyID;var d="createDistanceJoint";a.type===k.e_revoluteJoint&&(d="createRevoluteJoint");var e=new k(a);e.m_jointID=window.ext.IDTK_SRV_BOX2D.makeCall(d,this.m_worldID,a);a.bodyA=b;a.bodyB=c;this.m_jointsList.push(e);return e}};e.prototype.DestroyJoint=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("destroyJoint",this.m_worldID,a.m_jointID)};e.prototype.GetJointList=function(){if(0===
this.m_jointsList.length)return null;for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];this.m_jointsList[this.m_jointsList.length-1].next=null;return this.m_jointsList[0]};e.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)};e.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)};e.prototype.Step=function(a,b,c){c=window.ext.IDTK_SRV_BOX2D.makeCall("step",
this.m_worldID,a,b,c);b=c[0];for(a=1;a<=4*b;a+=4){var d=this.m_bodyList[c[a+0]];if(null===d)break;d.m_xf.position.Set(c[a+1],c[a+2]);d.m_xf.R.Set(c[a+3])}if(null!==this.m_contactListener)for(c=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID),b=c[0],a=1;a<=3*b;a+=3){var d=c[a+2],e=this.m_fixturesList[c[a+0]],f=this.m_fixturesList[c[a+1]];"undefined"===typeof e||"undefined"===typeof f?console.log("One of the fixtures in a contact DOESN'T EXIST!!"):this.m_contactListener.BeginContact(new l(e,
f,d))}};e.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)};e.prototype.SetDebugDraw=function(){};e.prototype.DrawDebugData=function(){};Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a;this.type="circle"};Box2D.Collision.Shapes.b2PolygonShape=function(){};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.type="box";this.width=a;this.height=b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,
b){this.type="edge";this.p1x=a.x;this.p1y=a.y;this.p2x=b.x;this.p2y=b.y};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a,b){this.type="polygon";this.vertices=[];for(var c=0;c<b;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)};Box2D.Dynamics.b2FixtureDef=function(){this.userData=this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1;this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};var k=function(a){this.bodyA=a.bodyA;this.bodyB=a.bodyB;
this.userData=a.userData;this.type=a.type;this.next=null};Box2D.Dynamics.Joints.b2Joint=k;k.prototype.GetBodyA=function(){return this.bodyA};k.prototype.GetBodyB=function(){return this.bodyB};k.prototype.GetUserData=function(){return this.userData};k.prototype.GetType=function(){return this.type};k.prototype.GetNext=function(){return this.next};k.e_distanceJoint=0;k.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2DistanceJointDef=function(b,c,d,e){this.type=k.e_distanceJoint;this.localAnchorA=a.Get(0,0);
this.localAnchorB=a.Get(0,0);this.userData=null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==e&&this.localAnchorB.SetV(e);void 0!==d&&void 0!==e&&(b=e.x-d.x,d=e.y-d.y,this.length=Math.sqrt(b*b+d*d));this.dampingRatio=this.frequencyHz=0};e=function(b,c,d,e){this.type=k.e_revoluteJoint;this.localAnchorA=new a;this.localAnchorB=new a;this.userData=null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==
e&&this.localAnchorB.SetV(e);this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};e.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef=e}():console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available");
else{Box2D.Collision.b2Collision={};Box2D.Collision.b2Distance={};Box2D.Common.b2Settings={};Box2D.Common.Math.b2Math={};Box2D.Consts={};Box2D.Dynamics.Contacts={};Box2D.Dynamics.Controllers={};Box2D.generateCallback=function(a,b){return function(){b.apply(a,arguments)}};Box2D.Consts.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.b2Settings.b2MixFriction=function(a,b){return Math.sqrt(a*b)};Box2D.Common.b2Settings.b2MixRestitution=function(a,b){return a>b?a:b};Box2D.Common.b2Settings.VERSION=
"2.1alpha-illandril";Box2D.Common.b2Settings.USHRT_MAX=65535;Box2D.Common.b2Settings.b2_maxManifoldPoints=2;Box2D.Common.b2Settings.b2_aabbExtension=0.1;Box2D.Common.b2Settings.b2_aabbMultiplier=2;Box2D.Common.b2Settings.b2_polygonRadius=2*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_linearSlop=0.0050;Box2D.Common.b2Settings.b2_angularSlop=2/180*Math.PI;Box2D.Common.b2Settings.b2_toiSlop=8*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland=
32;Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland=32;Box2D.Common.b2Settings.b2_velocityThreshold=1;Box2D.Common.b2Settings.b2_maxLinearCorrection=0.2;Box2D.Common.b2Settings.b2_maxAngularCorrection=8/180*Math.PI;Box2D.Common.b2Settings.b2_maxTranslation=2;Box2D.Common.b2Settings.b2_maxTranslationSquared=Box2D.Common.b2Settings.b2_maxTranslation*Box2D.Common.b2Settings.b2_maxTranslation;Box2D.Common.b2Settings.b2_maxRotation=0.5*Math.PI;Box2D.Common.b2Settings.b2_maxRotationSquared=Box2D.Common.b2Settings.b2_maxRotation*
Box2D.Common.b2Settings.b2_maxRotation;Box2D.Common.b2Settings.b2_contactBaumgarte=0.2;Box2D.Common.b2Settings.b2_timeToSleep=0.5;Box2D.Common.b2Settings.b2_linearSleepTolerance=0.01;Box2D.Common.b2Settings.b2_linearSleepToleranceSquared=Box2D.Common.b2Settings.b2_linearSleepTolerance*Box2D.Common.b2Settings.b2_linearSleepTolerance;Box2D.Common.b2Settings.b2_angularSleepTolerance=2/180*Math.PI;Box2D.Common.b2Settings.b2_angularSleepToleranceSquared=Box2D.Common.b2Settings.b2_angularSleepTolerance*
Box2D.Common.b2Settings.b2_angularSleepTolerance;Box2D.Common.b2Settings.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.Math.b2Math.Dot=function(a,b){return a.x*b.x+a.y*b.y};Box2D.Common.Math.b2Math.CrossVV=function(a,b){return a.x*b.y-a.y*b.x};Box2D.Common.Math.b2Math.CrossVF=function(a,b){return Box2D.Common.Math.b2Vec2.Get(b*a.y,-b*a.x)};Box2D.Common.Math.b2Math.CrossFV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(-a*b.y,a*b.x)};Box2D.Common.Math.b2Math.MulMV=function(a,
b){return Box2D.Common.Math.b2Vec2.Get(a.col1.x*b.x+a.col2.x*b.y,a.col1.y*b.x+a.col2.y*b.y)};Box2D.Common.Math.b2Math.MulTMV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(b,a.col1),Box2D.Common.Math.b2Math.Dot(b,a.col2))};Box2D.Common.Math.b2Math.MulX=function(a,b){var c=Box2D.Common.Math.b2Math.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};Box2D.Common.Math.b2Math.MulXT=function(a,b){var c=Box2D.Common.Math.b2Math.SubtractVV(b,a.position),d=c.x*a.R.col1.x+
c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+c.y*a.R.col2.y;c.x=d;return c};Box2D.Common.Math.b2Math.AddVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x+b.x,a.y+b.y)};Box2D.Common.Math.b2Math.SubtractVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x-b.x,a.y-b.y)};Box2D.Common.Math.b2Math.Distance=function(a,b){return Math.sqrt(Box2D.Common.Math.b2Math.DistanceSquared(a,b))};Box2D.Common.Math.b2Math.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};Box2D.Common.Math.b2Math.MulFV=
function(a,b){return Box2D.Common.Math.b2Vec2.Get(a*b.x,a*b.y)};Box2D.Common.Math.b2Math.AddMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AddVV(a.col1,b.col1),Box2D.Common.Math.b2Math.AddVV(a.col2,b.col2))};Box2D.Common.Math.b2Math.MulMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.MulMV(a,b.col1),Box2D.Common.Math.b2Math.MulMV(a,b.col2))};Box2D.Common.Math.b2Math.MulTMM=function(a,b){var c=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,
b.col1),Box2D.Common.Math.b2Math.Dot(a.col2,b.col1)),d=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,b.col2),Box2D.Common.Math.b2Math.Dot(a.col2,b.col2));return Box2D.Common.Math.b2Mat22.FromVV(c,d)};Box2D.Common.Math.b2Math.AbsV=function(a){return Box2D.Common.Math.b2Vec2.Get(Math.abs(a.x),Math.abs(a.y))};Box2D.Common.Math.b2Math.AbsM=function(a){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AbsV(a.col1),Box2D.Common.Math.b2Math.AbsV(a.col2))};Box2D.Common.Math.b2Math.Clamp=
function(a,b,c){return a<b?b:a>c?c:a};Box2D.Common.Math.b2Math.ClampV=function(a,b,c){var d=Box2D.Common.Math.b2Math.Clamp(a.x,b.x,c.x);a=Box2D.Common.Math.b2Math.Clamp(a.y,b.y,c.y);return Box2D.Common.Math.b2Vec2.Get(d,a)};Box2D.Common.Math.b2Mat22=function(){this.col1=Box2D.Common.Math.b2Vec2.Get(0,0);this.col2=Box2D.Common.Math.b2Vec2.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22.FromAngle=function(a){var b=new Box2D.Common.Math.b2Mat22;b.Set(a);return b};Box2D.Common.Math.b2Mat22.FromVV=
function(a,b){var c=new Box2D.Common.Math.b2Mat22;c.SetVV(a,b);return c};Box2D.Common.Math.b2Mat22.prototype.Set=function(a){var b=Math.cos(a);a=Math.sin(a);this.col1.Set(b,a);this.col2.Set(-a,b)};Box2D.Common.Math.b2Mat22.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};Box2D.Common.Math.b2Mat22.prototype.Copy=function(){var a=new Box2D.Common.Math.b2Mat22;a.SetM(this);return a};Box2D.Common.Math.b2Mat22.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2)};
Box2D.Common.Math.b2Mat22.prototype.AddM=function(a){this.col1.Add(a.col1);this.col2.Add(a.col2)};Box2D.Common.Math.b2Mat22.prototype.SetIdentity=function(){this.col1.Set(1,0);this.col2.Set(0,1)};Box2D.Common.Math.b2Mat22.prototype.SetZero=function(){this.col1.Set(0,0);this.col2.Set(0,0)};Box2D.Common.Math.b2Mat22.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};Box2D.Common.Math.b2Mat22.prototype.GetInverse=function(a){var b=this.col1.x*this.col2.y-this.col2.x*this.col1.y;
0!==b&&(b=1/b);a.col1.x=b*this.col2.y;a.col2.x=-b*this.col2.x;a.col1.y=-b*this.col1.y;a.col2.y=b*this.col1.x;return a};Box2D.Common.Math.b2Mat22.prototype.Solve=function(a,b,c){var d=this.col1.x*this.col2.y-this.col2.x*this.col1.y;0!==d&&(d=1/d);a.x=d*(this.col2.y*b-this.col2.x*c);a.y=d*(this.col1.x*c-this.col1.y*b);return a};Box2D.Common.Math.b2Mat22.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};Box2D.Common.Math.b2Mat33=function(a,b,c){this.col1=new Box2D.Common.Math.b2Vec3(0,0,0);this.col2=
new Box2D.Common.Math.b2Vec3(0,0,0);this.col3=new Box2D.Common.Math.b2Vec3(0,0,0);a&&this.col1.SetV(a);b&&this.col2.SetV(b);c&&this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.SetVVV=function(a,b,c){this.col1.SetV(a);this.col2.SetV(b);this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.Copy=function(){return new Box2D.Common.Math.b2Mat33(this.col1,this.col2,this.col3)};Box2D.Common.Math.b2Mat33.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2);this.col3.SetV(a.col3)};
Box2D.Common.Math.b2Mat33.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col1.z+=a.col1.z;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y;this.col2.z+=a.col2.z;this.col3.x+=a.col3.x;this.col3.y+=a.col3.y;this.col3.z+=a.col3.z};Box2D.Common.Math.b2Mat33.prototype.SetIdentity=function(){this.col1.Set(1,0,0);this.col2.Set(0,1,0);this.col3.Set(0,0,1)};Box2D.Common.Math.b2Mat33.prototype.SetZero=function(){this.col1.Set(0,0,0);this.col2.Set(0,0,0);this.col3.Set(0,0,0)};Box2D.Common.Math.b2Mat33.prototype.Solve22=
function(a,b,c){var d=this.col1.x,e=this.col2.x,g=this.col1.y,f=this.col2.y,l=d*f-e*g;0!=l&&(l=1/l);a.x=l*(f*b-e*c);a.y=l*(d*c-g*b);return a};Box2D.Common.Math.b2Mat33.prototype.Solve33=function(a,b,c,d){var e=this.col1.x,g=this.col1.y,f=this.col1.z,l=this.col2.x,k=this.col2.y,h=this.col2.z,m=this.col3.x,n=this.col3.y,p=this.col3.z,q=e*(k*p-h*n)+g*(h*m-l*p)+f*(l*n-k*m);0!=q&&(q=1/q);a.x=q*(b*(k*p-h*n)+c*(h*m-l*p)+d*(l*n-k*m));a.y=q*(e*(c*p-d*n)+g*(d*m-b*p)+f*(b*n-c*m));a.z=q*(e*(k*d-h*c)+g*(h*b-l*
d)+f*(l*c-k*b));return a};Box2D.Common.Math.b2Sweep=function(){this.localCenter=Box2D.Common.Math.b2Vec2.Get(0,0);this.c0=Box2D.Common.Math.b2Vec2.Get(0,0);this.c=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Common.Math.b2Sweep.prototype.Set=function(a){this.localCenter.SetV(a.localCenter);this.c0.SetV(a.c0);this.c.SetV(a.c);this.a0=a.a0;this.a=a.a;this.t0=a.t0};Box2D.Common.Math.b2Sweep.prototype.Copy=function(){var a=new Box2D.Common.Math.b2Sweep;a.localCenter.SetV(this.localCenter);a.c0.SetV(this.c0);
a.c.SetV(this.c);a.a0=this.a0;a.a=this.a;a.t0=this.t0;return a};Box2D.Common.Math.b2Sweep.prototype.GetTransform=function(a,b){void 0===b&&(b=0);a.position.x=(1-b)*this.c0.x+b*this.c.x;a.position.y=(1-b)*this.c0.y+b*this.c.y;a.R.Set((1-b)*this.a0+b*this.a);var c=a.R;a.position.x-=c.col1.x*this.localCenter.x+c.col2.x*this.localCenter.y;a.position.y-=c.col1.y*this.localCenter.x+c.col2.y*this.localCenter.y};Box2D.Common.Math.b2Sweep.prototype.Advance=function(a){void 0===a&&(a=0);if(this.t0<a&&1-this.t0>
Number.MIN_VALUE){var b=(a-this.t0)/(1-this.t0);this.c0.x=(1-b)*this.c0.x+b*this.c.x;this.c0.y=(1-b)*this.c0.y+b*this.c.y;this.a0=(1-b)*this.a0+b*this.a;this.t0=a}};Box2D.Common.Math.b2Transform=function(a,b){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.R=new Box2D.Common.Math.b2Mat22;a&&this.position.SetV(a);b&&this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.SetIdentity=function(){this.position.SetZero();
this.R.SetIdentity()};Box2D.Common.Math.b2Transform.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};Box2D.Common.Math.b2Transform.prototype.GetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};Box2D.Common.Math.b2Vec2=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2._freeCache=[];Box2D.Common.Math.b2Vec2.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,
b)};Box2D.Common.Math.b2Vec2.Free=function(a){Box2D.Common.Math.b2Vec2._freeCache.push(a)};Box2D.Common.Math.b2Vec2.prototype.SetZero=function(){this.y=this.x=0};Box2D.Common.Math.b2Vec2.prototype.Set=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2.prototype.SetV=function(a){this.x=a.x;this.y=a.y};Box2D.Common.Math.b2Vec2.prototype.GetNegative=function(){return Box2D.Common.Math.b2Vec2.Get(-this.x,-this.y)};Box2D.Common.Math.b2Vec2.prototype.NegativeSelf=function(){this.x=-this.x;this.y=
-this.y};Box2D.Common.Math.b2Vec2.prototype.Copy=function(){return Box2D.Common.Math.b2Vec2.Get(this.x,this.y)};Box2D.Common.Math.b2Vec2.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};Box2D.Common.Math.b2Vec2.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y};Box2D.Common.Math.b2Vec2.prototype.Multiply=function(a){this.x*=a;this.y*=a};Box2D.Common.Math.b2Vec2.prototype.MulM=function(a){var b=this.x;this.x=a.col1.x*b+a.col2.x*this.y;this.y=a.col1.y*b+a.col2.y*this.y};Box2D.Common.Math.b2Vec2.prototype.MulTM=
function(a){var b=this.x*a.col1.x+this.y*a.col1.y;this.y=this.x*a.col2.x+this.y*a.col2.y;this.x=b};Box2D.Common.Math.b2Vec2.prototype.CrossVF=function(a){var b=this.x;this.x=a*this.y;this.y=-a*b};Box2D.Common.Math.b2Vec2.prototype.CrossFV=function(a){var b=this.x;this.x=-a*this.y;this.y=a*b};Box2D.Common.Math.b2Vec2.prototype.MinV=function(a){this.x=Math.min(this.x,a.x);this.y=Math.min(this.y,a.y)};Box2D.Common.Math.b2Vec2.prototype.MaxV=function(a){this.x=Math.max(this.x,a.x);this.y=Math.max(this.y,
a.y)};Box2D.Common.Math.b2Vec2.prototype.Abs=function(){this.x=Math.abs(this.x);this.y=Math.abs(this.y)};Box2D.Common.Math.b2Vec2.prototype.Length=function(){return Math.sqrt(this.LengthSquared())};Box2D.Common.Math.b2Vec2.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};Box2D.Common.Math.b2Vec2.prototype.Normalize=function(){var a=this.Length();if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};Box2D.Common.Math.b2Vec2.prototype.IsValid=function(){return isFinite(this.x)&&
isFinite(this.y)};Box2D.Common.Math.b2Vec3=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetZero=function(){this.z=this.y=this.x=0};Box2D.Common.Math.b2Vec3.prototype.Set=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetV=function(a){this.x=a.x;this.y=a.y;this.z=a.z};Box2D.Common.Math.b2Vec3.prototype.GetNegative=function(){return new Box2D.Common.Math.b2Vec3(-this.x,-this.y,-this.z)};Box2D.Common.Math.b2Vec3.prototype.NegativeSelf=
function(){this.x=-this.x;this.y=-this.y;this.z=-this.z};Box2D.Common.Math.b2Vec3.prototype.Copy=function(){return new Box2D.Common.Math.b2Vec3(this.x,this.y,this.z)};Box2D.Common.Math.b2Vec3.prototype.Add=function(a){this.x+=a.x;this.y+=a.y;this.z+=a.z};Box2D.Common.Math.b2Vec3.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y;this.z-=a.z};Box2D.Common.Math.b2Vec3.prototype.Multiply=function(a){this.x*=a;this.y*=a;this.z*=a};Box2D.Collision.Shapes.b2Shape=function(){this.m_radius=Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Collision.Shapes.b2Shape.prototype.GetTypeName=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Copy=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Set=function(a){this.m_radius=a.m_radius};Box2D.Collision.Shapes.b2Shape.prototype.TestPoint=function(){};Box2D.Collision.Shapes.b2Shape.prototype.RayCast=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeAABB=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeMass=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeSubmergedArea=
function(){};Box2D.Collision.Shapes.b2Shape.prototype.SetDistanceProxy=function(){};Box2D.Collision.Shapes.b2Shape.TestOverlap=function(a,b,c,d){var e=new Box2D.Collision.b2DistanceInput;e.proxyA=new Box2D.Collision.b2DistanceProxy;e.proxyA.Set(a);e.proxyB=new Box2D.Collision.b2DistanceProxy;e.proxyB.Set(c);e.transformA=b;e.transformB=d;e.useRadii=!0;a=new Box2D.Collision.b2SimplexCache;a.count=0;b=new Box2D.Collision.b2DistanceOutput;Box2D.Collision.b2Distance.Distance(b,a,e);return b.distance<10*
Number.MIN_VALUE};Box2D.Collision.Shapes.b2Shape.e_startsInsideCollide=-1;Box2D.Collision.Shapes.b2Shape.e_missCollide=0;Box2D.Collision.Shapes.b2Shape.e_hitCollide=1;Box2D.Collision.Shapes.b2CircleShape=function(a){Box2D.Collision.Shapes.b2Shape.call(this);this.m_radius=a;this.m_radiusSquared=a*a;this.m_p=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Collision.Shapes.b2CircleShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2CircleShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2CircleShape.NAME};
Box2D.Collision.Shapes.b2CircleShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2CircleShape(this.m_radius);a.Set(this);return a};Box2D.Collision.Shapes.b2CircleShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,a);a instanceof Box2D.Collision.Shapes.b2CircleShape&&this.m_p.SetV(a.m_p)};Box2D.Collision.Shapes.b2CircleShape.prototype.TestPoint=function(a,b){var c=b.x-(a.position.x+(a.R.col1.x*this.m_p.x+a.R.col2.x*this.m_p.y)),d=b.y-(a.position.y+
(a.R.col1.y*this.m_p.x+a.R.col2.y*this.m_p.y));return c*c+d*d<=this.m_radiusSquared};Box2D.Collision.Shapes.b2CircleShape.prototype.RayCast=function(a,b,c){var d=c.R,e=b.p1.x-(c.position.x+(d.col1.x*this.m_p.x+d.col2.x*this.m_p.y));c=b.p1.y-(c.position.y+(d.col1.y*this.m_p.x+d.col2.y*this.m_p.y));var d=b.p2.x-b.p1.x,g=b.p2.y-b.p1.y,f=e*d+c*g,l=d*d+g*g,k=f*f-l*(e*e+c*c-this.m_radiusSquared);if(0>k||l<Number.MIN_VALUE)return!1;f=-(f+Math.sqrt(k));return 0<=f&&f<=b.maxFraction*l?(f/=l,a.fraction=f,a.normal.x=
e+f*d,a.normal.y=c+f*g,a.normal.Normalize(),!0):!1};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_p.x+c.col2.x*this.m_p.y),c=b.position.y+(c.col1.y*this.m_p.x+c.col2.y*this.m_p.y);a.lowerBound_.Set(d-this.m_radius,c-this.m_radius);a.upperBound_.Set(d+this.m_radius,c+this.m_radius)};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeMass=function(a,b){a.mass=b*Math.PI*this.m_radiusSquared;a.center.SetV(this.m_p);a.I=a.mass*(0.5*
this.m_radiusSquared+(this.m_p.x*this.m_p.x+this.m_p.y*this.m_p.y))};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeSubmergedArea=function(a,b,c,d){c=Box2D.Common.Math.b2Math.MulX(c,this.m_p);var e=-(Box2D.Common.Math.b2Math.Dot(a,c)-b);if(e<-this.m_radius+Number.MIN_VALUE)return 0;if(e>this.m_radius)return d.SetV(c),Math.PI*this.m_radiusSquared;b=e*e;e=this.m_radiusSquared*(Math.asin(e/this.m_radius)+Math.PI/2)+e*Math.sqrt(this.m_radiusSquared-b);b=-2/3*Math.pow(this.m_radiusSquared-b,1.5)/
e;d.x=c.x+a.x*b;d.y=c.y+a.y*b;return e};Box2D.Collision.Shapes.b2CircleShape.prototype.SetDistanceProxy=function(a){a.m_vertices=[this.m_p];a.m_count=1;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.GetLocalPosition=function(){return this.m_p};Box2D.Collision.Shapes.b2CircleShape.prototype.SetLocalPosition=function(a){this.m_p.SetV(a)};Box2D.Collision.Shapes.b2CircleShape.prototype.GetRadius=function(){return this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.SetRadius=
function(a){this.m_radius=a;this.m_radiusSquared=a*a};Box2D.Collision.Shapes.b2CircleShape.NAME="b2CircleShape";Box2D.Collision.Shapes.b2EdgeChainDef=function(){this.vertexCount=0;this.isALoop=!0;this.vertices=[]};Box2D.Collision.Shapes.b2EdgeShape=function(a,b){Box2D.Collision.Shapes.b2Shape.call(this);this.m_nextEdge=this.m_prevEdge=null;this.m_v1=a;this.m_v2=b;this.m_direction=Box2D.Common.Math.b2Vec2.Get(this.m_v2.x-this.m_v1.x,this.m_v2.y-this.m_v1.y);this.m_length=this.m_direction.Normalize();
this.m_normal=Box2D.Common.Math.b2Vec2.Get(this.m_direction.y,-this.m_direction.x);this.m_coreV1=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x-this.m_direction.x)+this.m_v1.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y-this.m_direction.y)+this.m_v1.y);this.m_coreV2=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x+this.m_direction.x)+this.m_v2.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y+this.m_direction.y)+this.m_v2.y);
this.m_cornerDir1=this.m_normal;this.m_cornerDir2=Box2D.Common.Math.b2Vec2.Get(-this.m_normal.x,-this.m_normal.y);this.m_cornerConvex2=this.m_cornerConvex1=!1};c2inherit(Box2D.Collision.Shapes.b2EdgeShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2EdgeShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2EdgeShape.NAME};Box2D.Collision.Shapes.b2EdgeShape.prototype.TestPoint=function(a,b){return!1};Box2D.Collision.Shapes.b2EdgeShape.prototype.RayCast=function(a,b,c){var d=
b.p2.x-b.p1.x,e=b.p2.y-b.p1.y,g=c.R,f=c.position.x+(g.col1.x*this.m_v1.x+g.col2.x*this.m_v1.y),l=c.position.y+(g.col1.y*this.m_v1.x+g.col2.y*this.m_v1.y),k=c.position.y+(g.col1.y*this.m_v2.x+g.col2.y*this.m_v2.y)-l;c=-(c.position.x+(g.col1.x*this.m_v2.x+g.col2.x*this.m_v2.y)-f);var g=100*Number.MIN_VALUE,h=-(d*k+e*c);if(h>g){var f=b.p1.x-f,m=b.p1.y-l,l=f*k+m*c;if(0<=l&&l<=b.maxFraction*h&&(b=-d*m+e*f,-g*h<=b&&b<=h*(1+g)))return a.fraction=l/h,b=Math.sqrt(k*k+c*c),a.normal.x=k/b,a.normal.y=c/b,!0}return!1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_v1.x+c.col2.x*this.m_v1.y),e=b.position.y+(c.col1.y*this.m_v1.x+c.col2.y*this.m_v1.y),g=b.position.x+(c.col1.x*this.m_v2.x+c.col2.x*this.m_v2.y),c=b.position.y+(c.col1.y*this.m_v2.x+c.col2.y*this.m_v2.y);d<g?(a.lowerBound_.x=d,a.upperBound_.x=g):(a.lowerBound_.x=g,a.upperBound_.x=d);e<c?(a.lowerBound_.y=e,a.upperBound_.y=c):(a.lowerBound_.y=c,a.upperBound_.y=e)};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeMass=
function(a,b){a.mass=0;a.center.SetV(this.m_v1);a.I=0};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeSubmergedArea=function(a,b,c,d){void 0===b&&(b=0);var e=Box2D.Common.Math.b2Vec2.Get(a.x*b,a.y*b),g=Box2D.Common.Math.b2Math.MulX(c,this.m_v1);c=Box2D.Common.Math.b2Math.MulX(c,this.m_v2);var f=Box2D.Common.Math.b2Math.Dot(a,g)-b;a=Box2D.Common.Math.b2Math.Dot(a,c)-b;if(0<f){if(0<a)return 0;g.x=-a/(f-a)*g.x+f/(f-a)*c.x;g.y=-a/(f-a)*g.y+f/(f-a)*c.y}else 0<a&&(c.x=-a/(f-a)*g.x+f/(f-a)*c.x,c.y=
-a/(f-a)*g.y+f/(f-a)*c.y);d.x=(e.x+g.x+c.x)/3;d.y=(e.y+g.y+c.y)/3;return 0.5*((g.x-e.x)*(c.y-e.y)-(g.y-e.y)*(c.x-e.x))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetLength=function(){return this.m_length};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex1=function(){return this.m_v1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex2=function(){return this.m_v2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex1=function(){return this.m_coreV1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex2=
function(){return this.m_coreV2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNormalVector=function(){return this.m_normal};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetDirectionVector=function(){return this.m_direction};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner1Vector=function(){return this.m_cornerDir1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner2Vector=function(){return this.m_cornerDir2};Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner1IsConvex=function(){return this.m_cornerConvex1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner2IsConvex=function(){return this.m_cornerConvex2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetFirstVertex=function(a){var b=a.R;return Box2D.Common.Math.b2Vec2.Get(a.position.x+(b.col1.x*this.m_coreV1.x+b.col2.x*this.m_coreV1.y),a.position.y+(b.col1.y*this.m_coreV1.x+b.col2.y*this.m_coreV1.y))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNextEdge=function(){return this.m_nextEdge};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetPrevEdge=function(){return this.m_prevEdge};
Box2D.Collision.Shapes.b2EdgeShape.prototype.Support=function(a,b,c){var d=a.R,e=a.position.x+(d.col1.x*this.m_coreV1.x+d.col2.x*this.m_coreV1.y),g=a.position.y+(d.col1.y*this.m_coreV1.x+d.col2.y*this.m_coreV1.y),f=a.position.x+(d.col1.x*this.m_coreV2.x+d.col2.x*this.m_coreV2.y);a=a.position.y+(d.col1.y*this.m_coreV2.x+d.col2.y*this.m_coreV2.y);return e*b+g*c>f*b+a*c?Box2D.Common.Math.b2Vec2.Get(e,g):Box2D.Common.Math.b2Vec2.Get(f,a)};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetPrevEdge=function(a,
b,c,d){this.m_prevEdge=a;this.m_coreV1=b;this.m_cornerDir1=c;this.m_cornerConvex1=d};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetNextEdge=function(a,b,c,d){this.m_nextEdge=a;this.m_coreV2=b;this.m_cornerDir2=c;this.m_cornerConvex2=d};Box2D.Collision.Shapes.b2EdgeShape.NAME="b2EdgeShape";Box2D.Collision.Shapes.b2MassData=function(){this.mass=0;this.center=Box2D.Common.Math.b2Vec2.Get(0,0);this.I=0};Box2D.Collision.Shapes.b2PolygonShape=function(){Box2D.Collision.Shapes.b2Shape.call(this);this.m_centroid=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_vertices=[];this.m_normals=[]};c2inherit(Box2D.Collision.Shapes.b2PolygonShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2PolygonShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2PolygonShape.NAME};Box2D.Collision.Shapes.b2PolygonShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2PolygonShape;a.Set(this);return a};Box2D.Collision.Shapes.b2PolygonShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,
a);if(a instanceof Box2D.Collision.Shapes.b2PolygonShape){this.m_centroid.SetV(a.m_centroid);this.m_vertexCount=a.m_vertexCount;this.Reserve(this.m_vertexCount);for(var b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a.m_vertices[b]),this.m_normals[b].SetV(a.m_normals[b])}};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a){this.SetAsVector(a)};Box2D.Collision.Shapes.b2PolygonShape.AsArray=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsArray(a);return b};
Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsVector=function(a){var b=a.length;this.m_vertexCount=b;this.Reserve(b);for(b=b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a[b]);for(b=0;b<this.m_vertexCount;++b)a=Box2D.Common.Math.b2Math.SubtractVV(this.m_vertices[b+1<this.m_vertexCount?b+1:0],this.m_vertices[b]),this.m_normals[b].SetV(Box2D.Common.Math.b2Math.CrossVF(a,1)),this.m_normals[b].Normalize();this.m_centroid=Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid(this.m_vertices,
this.m_vertexCount)};Box2D.Collision.Shapes.b2PolygonShape.AsVector=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsVector(a);return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid.SetZero()};
Box2D.Collision.Shapes.b2PolygonShape.AsBox=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsBox(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsOrientedBox=function(a,b,c,d){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid=c;a=new Box2D.Common.Math.b2Mat22;
a.Set(d);c=new Box2D.Common.Math.b2Transform(c,a);for(d=0;d<this.m_vertexCount;++d)this.m_vertices[d]=Box2D.Common.Math.b2Math.MulX(c,this.m_vertices[d]),this.m_normals[d]=Box2D.Common.Math.b2Math.MulMV(c.R,this.m_normals[d])};Box2D.Collision.Shapes.b2PolygonShape.AsOrientedBox=function(a,b,c,d){var e=new Box2D.Collision.Shapes.b2PolygonShape;e.SetAsOrientedBox(a,b,c,d);return e};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,b){this.m_vertexCount=2;this.Reserve(2);this.m_vertices[0].SetV(a);
this.m_vertices[1].SetV(b);this.m_centroid.x=0.5*(a.x+b.x);this.m_centroid.y=0.5*(a.y+b.y);this.m_normals[0]=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(b,a),1);this.m_normals[0].Normalize();this.m_normals[1].x=-this.m_normals[0].x;this.m_normals[1].y=-this.m_normals[0].y};Box2D.Collision.Shapes.b2PolygonShape.AsEdge=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsEdge(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.TestPoint=function(a,
b){var c;c=a.R;for(var d=b.x-a.position.x,e=b.y-a.position.y,g=d*c.col1.x+e*c.col1.y,f=d*c.col2.x+e*c.col2.y,l=0;l<this.m_vertexCount;++l)if(c=this.m_vertices[l],d=g-c.x,e=f-c.y,c=this.m_normals[l],0<c.x*d+c.y*e)return!1;return!0};Box2D.Collision.Shapes.b2PolygonShape.prototype.RayCast=function(a,b,c){var d=0,e=b.maxFraction,g=0,f=0,l,k,g=b.p1.x-c.position.x,f=b.p1.y-c.position.y;l=c.R;var h=g*l.col1.x+f*l.col1.y,m=g*l.col2.x+f*l.col2.y,g=b.p2.x-c.position.x,f=b.p2.y-c.position.y;l=c.R;b=g*l.col1.x+
f*l.col1.y-h;l=g*l.col2.x+f*l.col2.y-m;for(var n=-1,p=0;p<this.m_vertexCount;++p){k=this.m_vertices[p];g=k.x-h;f=k.y-m;k=this.m_normals[p];g=k.x*g+k.y*f;f=k.x*b+k.y*l;if(0==f){if(0>g)return!1}else 0>f&&g<d*f?(d=g/f,n=p):0<f&&g<e*f&&(e=g/f);if(e<d-Number.MIN_VALUE)return!1}return 0<=n?(a.fraction=d,l=c.R,k=this.m_normals[n],a.normal.x=l.col1.x*k.x+l.col2.x*k.y,a.normal.y=l.col1.y*k.x+l.col2.y*k.y,!0):!1};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeAABB=function(a,b){for(var c=b.R,d=this.m_vertices[0],
e=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),g=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),f=e,l=g,k=1;k<this.m_vertexCount;++k)var d=this.m_vertices[k],h=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),d=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),e=e<h?e:h,g=g<d?g:d,f=f>h?f:h,l=l>d?l:d;a.lowerBound_.x=e-this.m_radius;a.lowerBound_.y=g-this.m_radius;a.upperBound_.x=f+this.m_radius;a.upperBound_.y=l+this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeMass=function(a,b){if(2==this.m_vertexCount)a.center.x=
0.5*(this.m_vertices[0].x+this.m_vertices[1].x),a.center.y=0.5*(this.m_vertices[0].y+this.m_vertices[1].y),a.mass=0,a.I=0;else{for(var c=0,d=0,e=0,g=0,f=1/3,l=0;l<this.m_vertexCount;++l)var k=this.m_vertices[l],h=l+1<this.m_vertexCount?this.m_vertices[l+1]:this.m_vertices[0],m=k.x-0,n=k.y-0,p=h.x-0,q=h.y-0,r=m*q-n*p,t=0.5*r,e=e+t,c=c+t*f*(0+k.x+h.x),d=d+t*f*(0+k.y+h.y),k=m,g=g+r*(f*(0.25*(k*k+p*k+p*p)+(0*k+0*p))+0+(f*(0.25*(n*n+q*n+q*q)+(0*n+0*q))+0));a.mass=b*e;a.center.Set(c*(1/e),d*(1/e));a.I=
b*g}};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeSubmergedArea=function(a,b,c,d){var e=Box2D.Common.Math.b2Math.MulTMV(c.R,a),g=b-Box2D.Common.Math.b2Math.Dot(a,c.position),f=[],l=0,k=-1;b=-1;var h=!1;for(a=a=0;a<this.m_vertexCount;++a){f[a]=Box2D.Common.Math.b2Math.Dot(e,this.m_vertices[a])-g;var m=f[a]<-Number.MIN_VALUE;0<a&&(m?h||(k=a-1,l++):h&&(b=a-1,l++));h=m}switch(l){case 0:return h?(a=new Box2D.Collision.Shapes.b2MassData,this.ComputeMass(a,1),d.SetV(Box2D.Common.Math.b2Math.MulX(c,
a.center)),a.mass):0;case 1:-1==k?k=this.m_vertexCount-1:b=this.m_vertexCount-1}a=(k+1)%this.m_vertexCount;e=(b+1)%this.m_vertexCount;g=(0-f[k])/(f[a]-f[k]);f=(0-f[b])/(f[e]-f[b]);k=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[k].x*(1-g)+this.m_vertices[a].x*g,this.m_vertices[k].y*(1-g)+this.m_vertices[a].y*g);b=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[b].x*(1-f)+this.m_vertices[e].x*f,this.m_vertices[b].y*(1-f)+this.m_vertices[e].y*f);f=0;g=Box2D.Common.Math.b2Vec2.Get(0,0);for(l=this.m_vertices[a];a!=
e;)a=(a+1)%this.m_vertexCount,h=a==e?b:this.m_vertices[a],m=0.5*((l.x-k.x)*(h.y-k.y)-(l.y-k.y)*(h.x-k.x)),f+=m,g.x+=m*(k.x+l.x+h.x)/3,g.y+=m*(k.y+l.y+h.y)/3,l=h;g.Multiply(1/f);d.SetV(Box2D.Common.Math.b2Math.MulX(c,g));return f};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetDistanceProxy=function(a){a.m_vertices=this.m_vertices;a.m_count=this.m_vertexCount;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertexCount=function(){return this.m_vertexCount};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertices=
function(){return this.m_vertices};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetNormals=function(){return this.m_normals};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupportVertex=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*
a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return this.m_vertices[b]};Box2D.Collision.Shapes.b2PolygonShape.prototype.Reserve=function(a){this.m_vertices=[];this.m_normals=[];for(var b=this.m_vertices.length;b<a;b++)this.m_vertices[b]=Box2D.Common.Math.b2Vec2.Get(0,0),this.m_normals[b]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid=function(a,b){for(var c=Box2D.Common.Math.b2Vec2.Get(0,0),d=0,e=
1/3,g=0;g<b;++g){var f=a[g],l=g+1<b?a[g+1]:a[0],k=0.5*((f.x-0)*(l.y-0)-(f.y-0)*(l.x-0)),d=d+k;c.x+=k*e*(0+f.x+l.x);c.y+=k*e*(0+f.y+l.y)}c.x*=1/d;c.y*=1/d;return c};Box2D.Collision.Shapes.b2PolygonShape.s_mat=new Box2D.Common.Math.b2Mat22;Box2D.Collision.Shapes.b2PolygonShape.NAME="b2PolygonShape";Box2D.Collision.b2ContactID=function(){this._incidentVertex=this._incidentEdge=this._referenceEdge=this._key=0};Box2D.Collision.b2ContactID.prototype.GetKey=function(){return this._key};Box2D.Collision.b2ContactID.prototype.SetKey=
function(a){this._key=a;this._referenceEdge=this._key&255;this._incidentEdge=(this._key&65280)>>8&255;this._incidentVertex=(this._key&16711680)>>16&255;this._flip=(this._key&4278190080)>>24&255};Box2D.Collision.b2ContactID.prototype.Set=function(a){this.SetKey(a._key)};Box2D.Collision.b2ContactID.prototype.SetReferenceEdge=function(a){this._referenceEdge=a;this._key=this._key&4294967040|this._referenceEdge&255};Box2D.Collision.b2ContactID.prototype.SetIncidentEdge=function(a){this._incidentEdge=a;
this._key=this._key&4294902015|this._incidentEdge<<8&65280};Box2D.Collision.b2ContactID.prototype.SetIncidentVertex=function(a){this._incidentVertex=a;this._key=this._key&4278255615|this._incidentVertex<<16&16711680};Box2D.Collision.b2ContactID.prototype.SetFlip=function(a){this._flip=a;this._key=this._key&16777215|this._flip<<24&4278190080};Box2D.Collision.b2ContactID.prototype.Copy=function(){var a=new Box2D.Collision.b2ContactID;a.Set(this);return a};Box2D.Collision.ClipVertex=function(){this.v=
Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};Box2D.Collision.ClipVertex.prototype.Set=function(a){this.v.SetV(a.v);this.id.Set(a.id)};Box2D.Collision.IBroadPhase="Box2D.Collision.IBroadPhase";Box2D.Collision.b2AABB=function(){this.lowerBound_=Box2D.Common.Math.b2Vec2.Get(0,0);this.upperBound_=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2AABB._freeCache=[];Box2D.Collision.b2AABB.Get=function(){if(0<Box2D.Collision.b2AABB._freeCache.length){var a=Box2D.Collision.b2AABB._freeCache.pop();
a.SetZero();return a}return new Box2D.Collision.b2AABB};Box2D.Collision.b2AABB.Free=function(a){Box2D.Collision.b2AABB._freeCache.push(a)};Box2D.Collision.b2AABB.prototype.SetZero=function(){this.lowerBound_.Set(0,0);this.upperBound_.Set(0,0)};Box2D.Collision.b2AABB.prototype.IsValid=function(){return 0>this.upperBound_.x-this.lowerBound_.x||0>this.upperBound_.y-this.lowerBound_.y?!1:this.lowerBound_.IsValid()&&this.upperBound_.IsValid()};Box2D.Collision.b2AABB.prototype.GetCenter=function(){return Box2D.Common.Math.b2Vec2.Get((this.lowerBound_.x+
this.upperBound_.x)/2,(this.lowerBound_.y+this.upperBound_.y)/2)};Box2D.Collision.b2AABB.prototype.SetCenter=function(a){var b=this.GetCenter();this.lowerBound_.Subtract(b);this.upperBound_.Subtract(b);this.lowerBound_.Add(a);this.upperBound_.Add(a);Box2D.Common.Math.b2Vec2.Free(b)};Box2D.Collision.b2AABB.prototype.GetExtents=function(){return Box2D.Common.Math.b2Vec2.Get((this.upperBound_.x-this.lowerBound_.x)/2,(this.upperBound_.y-this.lowerBound_.y)/2)};Box2D.Collision.b2AABB.prototype.Contains=
function(a){var b;return b=(b=(b=(b=this.lowerBound_.x<=a.lowerBound_.x)&&this.lowerBound_.y<=a.lowerBound_.y)&&a.upperBound_.x<=this.upperBound_.x)&&a.upperBound_.y<=this.upperBound_.y};Box2D.Collision.b2AABB.prototype.RayCast=function(a,b){var c=-Number.MAX_VALUE,d=Number.MAX_VALUE,e=b.p2.x-b.p1.x;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.x<this.lowerBound_.x||this.upperBound_.x<b.p1.x)return!1}else{var g=1/e,e=(this.lowerBound_.x-b.p1.x)*g,g=(this.upperBound_.x-b.p1.x)*g,f=-1;e>g&&(f=e,e=g,g=f,
f=1);e>c&&(a.normal.x=f,a.normal.y=0,c=e);d=Math.min(d,g);if(c>d)return!1}e=b.p2.y-b.p1.y;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.y<this.lowerBound_.y||this.upperBound_.y<b.p1.y)return!1}else if(g=1/e,e=(this.lowerBound_.y-b.p1.y)*g,g*=this.upperBound_.y-b.p1.y,f=-1,e>g&&(f=e,e=g,g=f,f=1),e>c&&(a.normal.y=f,a.normal.x=0,c=e),d=Math.min(d,g),c>d)return!1;a.fraction=c;return!0};Box2D.Collision.b2AABB.prototype.TestOverlap=function(a){return 0<a.lowerBound_.x-this.upperBound_.x||0<a.lowerBound_.y-this.upperBound_.y||
0<this.lowerBound_.x-a.upperBound_.x||0<this.lowerBound_.y-a.upperBound_.y?!1:!0};Box2D.Collision.b2AABB.Combine=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.Combine(a,b);return c};Box2D.Collision.b2AABB.prototype.Combine=function(a,b){this.lowerBound_.x=Math.min(a.lowerBound_.x,b.lowerBound_.x);this.lowerBound_.y=Math.min(a.lowerBound_.y,b.lowerBound_.y);this.upperBound_.x=Math.max(a.upperBound_.x,b.upperBound_.x);this.upperBound_.y=Math.max(a.upperBound_.y,b.upperBound_.y)};Box2D.Collision.b2Collision.ClipSegmentToLine=
function(a,b,c,d){var e=0,g=b[0].v,f=b[1].v,l=c.x*g.x+c.y*g.y-d;c=c.x*f.x+c.y*f.y-d;0>=l&&a[e++].Set(b[0]);0>=c&&a[e++].Set(b[1]);0>l*c&&(c=l/(l-c),d=a[e].v,d.x=g.x+c*(f.x-g.x),d.y=g.y+c*(f.y-g.y),a[e].id=0<l?b[0].id:b[1].id,e++);return e};Box2D.Collision.b2Collision.EdgeSeparation=function(a,b,c,d,e){for(var g=b.R.col1.x*a.m_normals[c].x+b.R.col2.x*a.m_normals[c].y,f=b.R.col1.y*a.m_normals[c].x+b.R.col2.y*a.m_normals[c].y,l=e.R.col1.x*g+e.R.col1.y*f,k=e.R.col2.x*g+e.R.col2.y*f,h=0,m=Number.MAX_VALUE,
n=0;n<d.m_vertexCount;n++){var p=d.m_vertices[n].x*l+d.m_vertices[n].y*k;p<m&&(m=p,h=n)}return(e.position.x+(e.R.col1.x*d.m_vertices[h].x+e.R.col2.x*d.m_vertices[h].y)-(b.position.x+(b.R.col1.x*a.m_vertices[c].x+b.R.col2.x*a.m_vertices[c].y)))*g+(e.position.y+(e.R.col1.y*d.m_vertices[h].x+e.R.col2.y*d.m_vertices[h].y)-(b.position.y+(b.R.col1.y*a.m_vertices[c].x+b.R.col2.y*a.m_vertices[c].y)))*f};Box2D.Collision.b2Collision.FindMaxSeparation=function(a,b,c,d){for(var e=d.position.x+(d.R.col1.x*c.m_centroid.x+
d.R.col2.x*c.m_centroid.y),g=d.position.y+(d.R.col1.y*c.m_centroid.x+d.R.col2.y*c.m_centroid.y),e=e-(b.position.x+(b.R.col1.x*a.m_centroid.x+b.R.col2.x*a.m_centroid.y)),g=g-(b.position.y+(b.R.col1.y*a.m_centroid.x+b.R.col2.y*a.m_centroid.y)),f=e*b.R.col1.x+g*b.R.col1.y,g=e*b.R.col2.x+g*b.R.col2.y,e=0,l=-Number.MAX_VALUE,k=0;k<a.m_vertexCount;++k){var h=a.m_normals[k].x*f+a.m_normals[k].y*g;h>l&&(l=h,e=k)}f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d);g=e-1;0>g&&(g=a.m_vertexCount-1);l=Box2D.Collision.b2Collision.EdgeSeparation(a,
b,g,c,d);k=e+1;k>=a.m_vertexCount&&(k=0);var h=Box2D.Collision.b2Collision.EdgeSeparation(a,b,k,c,d),m=0,n=0;if(l>f&&l>h)for(m=g,n=l;;)if(e=m-1,0>e&&(e=a.m_vertexCount-1),f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),f>n)m=e,n=f;else break;else if(h>f)for(m=k,n=h;;)if(e=m+1,e>=a.m_vertexCount&&(e=0),f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),f>n)m=e,n=f;else break;else m=e,n=f;return{bestEdge:m,separation:n}};Box2D.Collision.b2Collision.FindIncidentEdge=function(a,b,c,d,e,g){void 0===
d&&(d=0);var f=c.R.col1.x*b.m_normals[d].x+c.R.col2.x*b.m_normals[d].y;b=c.R.col1.y*b.m_normals[d].x+c.R.col2.y*b.m_normals[d].y;c=g.R.col1.x*f+g.R.col1.y*b;b=g.R.col2.x*f+g.R.col2.y*b;f=c;c=0;for(var l=Number.MAX_VALUE,k=0;k<e.m_vertexCount;k++){var h=f*e.m_normals[k].x+b*e.m_normals[k].y;h<l&&(l=h,c=k)}f=c+1;f>=e.m_vertexCount&&(f=0);a[0].v.x=g.position.x+(g.R.col1.x*e.m_vertices[c].x+g.R.col2.x*e.m_vertices[c].y);a[0].v.y=g.position.y+(g.R.col1.y*e.m_vertices[c].x+g.R.col2.y*e.m_vertices[c].y);
a[0].id.SetReferenceEdge(d);a[0].id.SetIncidentEdge(c);a[0].id.SetIncidentVertex(0);a[1].v.x=g.position.x+(g.R.col1.x*e.m_vertices[f].x+g.R.col2.x*e.m_vertices[f].y);a[1].v.y=g.position.y+(g.R.col1.y*e.m_vertices[f].x+g.R.col2.y*e.m_vertices[f].y);a[1].id.SetReferenceEdge(d);a[1].id.SetIncidentEdge(f);a[1].id.SetIncidentVertex(1)};Box2D.Collision.b2Collision.MakeClipPointVector=function(){return[new Box2D.Collision.ClipVertex,new Box2D.Collision.ClipVertex]};Box2D.Collision.b2Collision.CollidePolygons=
function(a,b,c,d,e){a.m_pointCount=0;var g=b.m_radius+d.m_radius,f=Box2D.Collision.b2Collision.FindMaxSeparation(b,c,d,e),l=f.bestEdge;if(!(f.separation>g)){var k=Box2D.Collision.b2Collision.FindMaxSeparation(d,e,b,c);if(!(k.separation>g)){var h=b,m=d,n=c,p=e,q=0;a.m_type=Box2D.Collision.b2Manifold.e_faceA;k.separation>0.98*f.separation+0.0010&&(h=d,m=b,n=e,p=c,l=k.bestEdge,a.m_type=Box2D.Collision.b2Manifold.e_faceB,q=1);b=Box2D.Collision.b2Collision.s_incidentEdge;Box2D.Collision.b2Collision.FindIncidentEdge(b,
h,n,l,m,p);m=h.m_vertices[l];l=l+1<h.m_vertexCount?h.m_vertices[l+1]:h.m_vertices[0];Box2D.Collision.b2Collision.s_localTangent.Set(l.x-m.x,l.y-m.y);Box2D.Collision.b2Collision.s_localTangent.Normalize();Box2D.Collision.b2Collision.s_localNormal.x=Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_localNormal.y=-Box2D.Collision.b2Collision.s_localTangent.x;Box2D.Collision.b2Collision.s_planePoint.Set(0.5*(m.x+l.x),0.5*(m.y+l.y));Box2D.Collision.b2Collision.s_tangent.x=n.R.col1.x*
Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.x*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent.y=n.R.col1.y*Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.y*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent2.x=-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_tangent2.y=-Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.x=Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.y=
-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_v11.x=n.position.x+(n.R.col1.x*m.x+n.R.col2.x*m.y);Box2D.Collision.b2Collision.s_v11.y=n.position.y+(n.R.col1.y*m.x+n.R.col2.y*m.y);Box2D.Collision.b2Collision.s_v12.x=n.position.x+(n.R.col1.x*l.x+n.R.col2.x*l.y);Box2D.Collision.b2Collision.s_v12.y=n.position.y+(n.R.col1.y*l.x+n.R.col2.y*l.y);if(!(2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints1,b,Box2D.Collision.b2Collision.s_tangent2,
-Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v11.x-Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v11.y+g)||2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints2,Box2D.Collision.b2Collision.s_clipPoints1,Box2D.Collision.b2Collision.s_tangent,Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v12.x+Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v12.y+g))){a.m_localPlaneNormal.SetV(Box2D.Collision.b2Collision.s_localNormal);
a.m_localPoint.SetV(Box2D.Collision.b2Collision.s_planePoint);n=Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_v11.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_v11.y;for(h=l=0;h<Box2D.Common.b2Settings.b2_maxManifoldPoints;++h)Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_clipPoints2[h].v.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_clipPoints2[h].v.y-n<=g&&(m=Box2D.Collision.b2Collision.s_clipPoints2[h].v.x-
p.position.x,b=Box2D.Collision.b2Collision.s_clipPoints2[h].v.y-p.position.y,a.m_points[l].m_localPoint.x=m*p.R.col1.x+b*p.R.col1.y,a.m_points[l].m_localPoint.y=m*p.R.col2.x+b*p.R.col2.y,a.m_points[l].m_id.Set(Box2D.Collision.b2Collision.s_clipPoints2[h].id),a.m_points[l].m_id.SetFlip(q),l++);a.m_pointCount=l}}}};Box2D.Collision.b2Collision.CollideCircles=function(a,b,c,d,e){a.m_pointCount=0;var g=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-(c.position.x+(c.R.col1.x*b.m_p.x+c.R.col2.x*b.m_p.y));
c=e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-(c.position.y+(c.R.col1.y*b.m_p.x+c.R.col2.y*b.m_p.y));e=b.m_radius+d.m_radius;g*g+c*c>e*e||(a.m_type=Box2D.Collision.b2Manifold.e_circles,a.m_localPoint.SetV(b.m_p),a.m_localPlaneNormal.SetZero(),a.m_pointCount=1,a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0))};Box2D.Collision.b2Collision.CollidePolygonAndCircle=function(a,b,c,d,e){a.m_pointCount=0;var g=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-c.position.x,f=
e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-c.position.y;e=g*c.R.col1.x+f*c.R.col1.y;c=g*c.R.col2.x+f*c.R.col2.y;for(var g=0,f=-Number.MAX_VALUE,l=b.m_radius+d.m_radius,k=0;k<b.m_vertexCount;++k){var h=b.m_normals[k].x*(e-b.m_vertices[k].x)+b.m_normals[k].y*(c-b.m_vertices[k].y);if(h>l)return;h>f&&(f=h,g=k)}h=g+1;h>=b.m_vertexCount&&(h=0);var k=b.m_vertices[g],m=b.m_vertices[h];f<Number.MIN_VALUE?(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.SetV(b.m_normals[g]),
a.m_localPoint.x=0.5*(k.x+m.x),a.m_localPoint.y=0.5*(k.y+m.y),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-k.x)*(m.x-k.x)+(c-k.y)*(m.y-k.y)?(e-k.x)*(e-k.x)+(c-k.y)*(c-k.y)>l*l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-k.x,a.m_localPlaneNormal.y=c-k.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(k),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-m.x)*(k.x-m.x)+(c-m.y)*(k.y-m.y)?(e-m.x)*(e-
m.x)+(c-m.y)*(c-m.y)>l*l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-m.x,a.m_localPlaneNormal.y=c-m.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(m),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):(h=0.5*(k.x+m.x),k=0.5*(k.y+m.y),f=(e-h)*b.m_normals[g].x+(c-k)*b.m_normals[g].y,f>l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=b.m_normals[g].x,a.m_localPlaneNormal.y=b.m_normals[g].y,a.m_localPlaneNormal.Normalize(),
a.m_localPoint.Set(h,k),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)))};Box2D.Collision.b2Collision.TestOverlap=function(a,b){return 0<b.lowerBound_.x-a.upperBound_.x||0<b.lowerBound_.y-a.upperBound_.y||0<a.lowerBound_.x-b.upperBound_.x||0<a.lowerBound_.y-b.upperBound_.y?!1:!0};Box2D.Collision.b2ContactPoint=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.velocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};
Box2D.Collision.b2Distance.Distance=function(a,b,c){var d=new Box2D.Collision.b2Simplex;d.ReadCache(b,c.proxyA,c.transformA,c.proxyB,c.transformB);for(var e=0;20>e;){for(var g=[],f=0;f<d.m_count;f++)g[f]={},g[f].indexA=d.m_vertices[f].indexA,g[f].indexB=d.m_vertices[f].indexB;2==d.m_count?d.Solve2():3==d.m_count&&d.Solve3();if(3==d.m_count)break;f=d.GetSearchDirection();if(f.LengthSquared()<Box2D.Common.b2Settings.MIN_VALUE_SQUARED)break;var l=f.GetNegative();d.m_vertices[d.m_count].indexA=c.proxyA.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformA.R,
l));d.m_vertices[d.m_count].wA=Box2D.Common.Math.b2Math.MulX(c.transformA,c.proxyA.GetVertex(d.m_vertices[d.m_count].indexA));d.m_vertices[d.m_count].indexB=c.proxyB.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformB.R,f));d.m_vertices[d.m_count].wB=Box2D.Common.Math.b2Math.MulX(c.transformB,c.proxyB.GetVertex(d.m_vertices[d.m_count].indexB));d.m_vertices[d.m_count].w=Box2D.Common.Math.b2Math.SubtractVV(d.m_vertices[d.m_count].wB,d.m_vertices[d.m_count].wA);Box2D.Common.Math.b2Vec2.Free(f);Box2D.Common.Math.b2Vec2.Free(l);
e++;l=!1;for(f=0;f<g.length;f++)if(d.m_vertices[d.m_count].indexA==g[f].indexA&&d.m_vertices[d.m_count].indexB==g[f].indexB){l=!0;break}if(l)break;d.m_count++}d.GetWitnessPoints(a.pointA,a.pointB);a.distance=Box2D.Common.Math.b2Math.SubtractVV(a.pointA,a.pointB).Length();d.WriteCache(b);c.useRadii&&(b=c.proxyA.m_radius,c=c.proxyB.m_radius,a.distance>b+c&&a.distance>Number.MIN_VALUE?(a.distance-=b+c,d=Box2D.Common.Math.b2Math.SubtractVV(a.pointB,a.pointA),d.Normalize(),a.pointA.x+=b*d.x,a.pointA.y+=
b*d.y,a.pointB.x-=c*d.x,a.pointB.y-=c*d.y,Box2D.Common.Math.b2Vec2.Free(d)):(c=Box2D.Common.Math.b2Vec2.Get(0,0),c.x=0.5*(a.pointA.x+a.pointB.x),c.y=0.5*(a.pointA.y+a.pointB.y),a.pointA.x=a.pointB.x=c.x,a.pointA.y=a.pointB.y=c.y,a.distance=0,Box2D.Common.Math.b2Vec2.Free(c)))};Box2D.Collision.b2DistanceInput=function(){};Box2D.Collision.b2DistanceOutput=function(){this.pointA=Box2D.Common.Math.b2Vec2.Get(0,0);this.pointB=Box2D.Common.Math.b2Vec2.Get(0,0);this.distance=0};Box2D.Collision.b2DistanceProxy=
function(){};Box2D.Collision.b2DistanceProxy.prototype.Set=function(a){a.SetDistanceProxy(this)};Box2D.Collision.b2DistanceProxy.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_count;d++){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.b2DistanceProxy.prototype.GetSupportVertex=function(a){return this.m_vertices[this.GetSupport(a)]};Box2D.Collision.b2DistanceProxy.prototype.GetVertexCount=
function(){return this.m_count};Box2D.Collision.b2DistanceProxy.prototype.GetVertex=function(a){void 0===a&&(a=0);return this.m_vertices[a]};Box2D.Collision.b2DynamicTree=function(){this.m_root=null;this.m_insertionCount=this.m_path=0};Box2D.Collision.b2DynamicTree.prototype.CreateProxy=function(a,b){var c=Box2D.Collision.b2DynamicTreeNode.Get(b),d=Box2D.Common.b2Settings.b2_aabbExtension,e=Box2D.Common.b2Settings.b2_aabbExtension;c.aabb.lowerBound_.x=a.lowerBound_.x-d;c.aabb.lowerBound_.y=a.lowerBound_.y-
e;c.aabb.upperBound_.x=a.upperBound_.x+d;c.aabb.upperBound_.y=a.upperBound_.y+e;this.InsertLeaf(c);return c};Box2D.Collision.b2DynamicTree.prototype.DestroyProxy=function(a){this.RemoveLeaf(a);a.Destroy()};Box2D.Collision.b2DynamicTree.prototype.MoveProxy=function(a,b,c){if(a.aabb.Contains(b))return!1;this.RemoveLeaf(a);var d=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*Math.abs(c.x);c=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*
Math.abs(c.y);a.aabb.lowerBound_.x=b.lowerBound_.x-d;a.aabb.lowerBound_.y=b.lowerBound_.y-c;a.aabb.upperBound_.x=b.upperBound_.x+d;a.aabb.upperBound_.y=b.upperBound_.y+c;this.InsertLeaf(a);return!0};Box2D.Collision.b2DynamicTree.prototype.Rebalance=function(a){if(null!==this.m_root)for(var b=0;b<a;b++){for(var c=this.m_root,d=0;!c.IsLeaf();)c=this.m_path>>d&1?c.child2:c.child1,d=d+1&31;this.m_path++;this.RemoveLeaf(c);this.InsertLeaf(c)}};Box2D.Collision.b2DynamicTree.prototype.GetFatAABB=function(a){return a.aabb};
Box2D.Collision.b2DynamicTree.prototype.Query=function(a,b){if(null!==this.m_root){var c=[];for(c.push(this.m_root);0<c.length;){var d=c.pop();if(d.aabb.TestOverlap(b))if(d.IsLeaf()){if(!a(d.fixture))break}else c.push(d.child1),c.push(d.child2)}}};Box2D.Collision.b2DynamicTree.prototype.RayCast=function(a,b){if(null!==this.m_root){var c=Box2D.Common.Math.b2Math.SubtractVV(b.p1,b.p2);c.Normalize();var c=Box2D.Common.Math.b2Math.CrossFV(1,c),d=Box2D.Common.Math.b2Math.AbsV(c),e=b.maxFraction,g=b.p1.x+
e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),f=Box2D.Collision.b2AABB.Get();f.lowerBound_.x=Math.min(b.p1.x,g);f.lowerBound_.y=Math.min(b.p1.y,e);f.upperBound_.x=Math.max(b.p1.x,g);f.upperBound_.y=Math.max(b.p1.y,e);var l=[];for(l.push(this.m_root);0<l.length;)if(g=l.pop(),g.aabb.TestOverlap(f)){var e=g.aabb.GetCenter(),k=g.aabb.GetExtents();if(!(0<Math.abs(c.x*(b.p1.x-e.x)+c.y*(b.p1.y-e.y))-d.x*k.x-d.y*k.y))if(g.IsLeaf()){new Box2D.Collision.b2RayCastInput(b.p1,b.p2,b.maxFraction);e=a(b,g.fixture);
if(0==e)break;0<e&&(g=b.p1.x+e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),f.lowerBound_.x=Math.min(b.p1.x,g),f.lowerBound_.y=Math.min(b.p1.y,e),f.upperBound_.x=Math.max(b.p1.x,g),f.upperBound_.y=Math.max(b.p1.y,e))}else l.push(g.child1),l.push(g.child2)}Box2D.Collision.b2AABB.Free(f)}};Box2D.Collision.b2DynamicTree.prototype.InsertLeaf=function(a){this.m_insertionCount++;if(null===this.m_root)this.m_root=a,this.m_root.parent=null;else{var b=this.GetBestSibling(a),c=b.parent,d=Box2D.Collision.b2DynamicTreeNode.Get();
d.parent=c;d.aabb.Combine(a.aabb,b.aabb);if(c)for(b.parent.child1==b?c.child1=d:c.child2=d,d.child1=b,d.child2=a,b.parent=d,a.parent=d;c&&!c.aabb.Contains(d.aabb);)c.aabb.Combine(c.child1.aabb,c.child2.aabb),d=c,c=c.parent;else d.child1=b,d.child2=a,b.parent=d,this.m_root=a.parent=d}};Box2D.Collision.b2DynamicTree.prototype.GetBestSibling=function(a){a=a.aabb.GetCenter();for(var b=this.m_root;!b.IsLeaf();)var c=b.child1,b=b.child2,d=Math.abs((c.aabb.lowerBound_.x+c.aabb.upperBound_.x)/2-a.x)+Math.abs((c.aabb.lowerBound_.y+
c.aabb.upperBound_.y)/2-a.y),e=Math.abs((b.aabb.lowerBound_.x+b.aabb.upperBound_.x)/2-a.x)+Math.abs((b.aabb.lowerBound_.y+b.aabb.upperBound_.y)/2-a.y),b=d<e?c:b;Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Collision.b2DynamicTree.prototype.RemoveLeaf=function(a){if(a==this.m_root)this.m_root=null;else{var b=a.parent,c=b.parent;a=b.child1==a?b.child2:b.child1;if(c)for(c.child1==b?c.child1=a:c.child2=a,a.parent=c;c;){a=c.aabb;c.aabb.Combine(c.child1.aabb,c.child2.aabb);if(a.Contains(c.aabb))break;
c=c.parent}else this.m_root=a,a.parent=null;b.Destroy()}};Box2D.Collision.b2DynamicTreeBroadPhase=function(){this.m_tree=new Box2D.Collision.b2DynamicTree;this.m_moveBuffer=[]};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.CreateProxy=function(a,b){var c=this.m_tree.CreateProxy(a,b);this.BufferMove(c);return c};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.DestroyProxy=function(a){this.UnBufferMove(a);this.m_tree.DestroyProxy(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.MoveProxy=
function(a,b,c){this.m_tree.MoveProxy(a,b,c)&&this.BufferMove(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.TestOverlap=function(a,b){var c=this.m_tree.GetFatAABB(a),d=this.m_tree.GetFatAABB(b);return c.TestOverlap(d)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetFatAABB=function(a){return this.m_tree.GetFatAABB(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetProxyCount=function(){return this.m_tree.length};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UpdatePairs=function(a){for(var b=
[];0<this.m_moveBuffer.length;){var c=this.m_moveBuffer.pop(),d=this.m_tree.GetFatAABB(c);this.m_tree.Query(function(a){a!=c.fixture&&b.push(new Box2D.Collision.b2DynamicTreePair(c.fixture,a));return!0},d)}for(d=0;d<b.length;){var e=b[d];a(e.fixtureA,e.fixtureB);for(d++;d<b.length;){var g=b[d];if(!(g.fixtureA==e.fixtureA&&g.fixtureB==e.fixtureB||g.fixtureA==e.fixtureB&&g.fixtureB==e.fixtureA))break;d++}}};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Query=function(a,b){this.m_tree.Query(a,b)};
Box2D.Collision.b2DynamicTreeBroadPhase.prototype.RayCast=function(a,b){this.m_tree.RayCast(a,b)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Rebalance=function(a){this.m_tree.Rebalance(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.BufferMove=function(a){this.m_moveBuffer.push(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UnBufferMove=function(a){cr.arrayFindRemove(this.m_moveBuffer,a)};Box2D.Collision.b2DynamicTreeBroadPhase.__implements={};Box2D.Collision.b2DynamicTreeBroadPhase.__implements[Box2D.Collision.IBroadPhase]=
!0;Box2D.Collision.b2DynamicTreeNode=function(a){this.aabb=Box2D.Collision.b2AABB.Get();this.fixture=this.parent=this.child2=this.child1=null;"undefined"!=typeof a&&(this.fixture=a)};Box2D.Collision.b2DynamicTreeNode._freeCache=[];Box2D.Collision.b2DynamicTreeNode.Get=function(a){if(0<Box2D.Collision.b2DynamicTreeNode._freeCache.length){var b=Box2D.Collision.b2DynamicTreeNode._freeCache.pop();"undefined"!=typeof a&&(b.fixture=a);b.aabb.SetZero();return b}return new Box2D.Collision.b2DynamicTreeNode(a)};
Box2D.Collision.b2DynamicTreeNode.prototype.Destroy=function(){this.fixture=this.parent=this.child2=this.child1=null;Box2D.Collision.b2DynamicTreeNode._freeCache.push(this)};Box2D.Collision.b2DynamicTreeNode.prototype.IsLeaf=function(){return null===this.child1};Box2D.Collision.b2DynamicTreePair=function(a,b){this.fixtureA=a;this.fixtureB=b};Box2D.Collision.b2Manifold=function(){this.m_type=this.m_pointCount=0;this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=
new Box2D.Collision.b2ManifoldPoint;this.m_localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Manifold.prototype.Reset=function(){for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a].Reset();this.m_localPlaneNormal.SetZero();this.m_localPoint.SetZero();this.m_pointCount=this.m_type=0};Box2D.Collision.b2Manifold.prototype.Set=function(a){this.m_pointCount=a.m_pointCount;for(var b=0;b<Box2D.Common.b2Settings.b2_maxManifoldPoints;b++)this.m_points[b].Set(a.m_points[b]);
this.m_localPlaneNormal.SetV(a.m_localPlaneNormal);this.m_localPoint.SetV(a.m_localPoint);this.m_type=a.m_type};Box2D.Collision.b2Manifold.prototype.Copy=function(){var a=new Box2D.Collision.b2Manifold;a.Set(this);return a};Box2D.Collision.b2Manifold.e_circles=1;Box2D.Collision.b2Manifold.e_faceA=2;Box2D.Collision.b2Manifold.e_faceB=4;Box2D.Collision.b2ManifoldPoint=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_id=new Box2D.Collision.b2ContactID;this.Reset()};Box2D.Collision.b2ManifoldPoint.prototype.Reset=
function(){this.m_localPoint.SetZero();this.m_tangentImpulse=this.m_normalImpulse=0;this.m_id.SetKey(0)};Box2D.Collision.b2ManifoldPoint.prototype.Set=function(a){this.m_localPoint.SetV(a.m_localPoint);this.m_normalImpulse=a.m_normalImpulse;this.m_tangentImpulse=a.m_tangentImpulse;this.m_id.Set(a.m_id)};Box2D.Collision.b2RayCastInput=function(a,b,c){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0);void 0===c&&(c=1);a&&this.p1.SetV(a);b&&this.p2.SetV(b);this.maxFraction=
c};Box2D.Collision.b2RayCastOutput=function(){this.normal=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment=function(){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment.prototype.TestSegment=function(a,b,c,d){void 0===d&&(d=0);var e=c.p1,g=c.p2.x-e.x,f=c.p2.y-e.y;c=this.p2.y-this.p1.y;var l=-(this.p2.x-this.p1.x),k=100*Number.MIN_VALUE,h=-(g*c+f*l);if(h>k){var m=e.x-this.p1.x,n=e.y-this.p1.y,e=m*c+n*l;if(0<=e&&e<=d*h&&(d=-g*n+
f*m,-k*h<=d&&d<=h*(1+k)))return e/=h,d=Math.sqrt(c*c+l*l),a[0]=e,b.Set(c/d,l/d),!0}return!1};Box2D.Collision.b2Segment.prototype.Extend=function(a){this.ExtendForward(a);this.ExtendBackward(a)};Box2D.Collision.b2Segment.prototype.ExtendForward=function(a){var b=this.p2.x-this.p1.x,c=this.p2.y-this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p1.x)/b:0>b?(a.lowerBound_.x-this.p1.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p1.y)/c:0>c?(a.lowerBound_.y-this.p1.y)/c:Number.POSITIVE_INFINITY);
this.p2.x=this.p1.x+b*a;this.p2.y=this.p1.y+c*a};Box2D.Collision.b2Segment.prototype.ExtendBackward=function(a){var b=-this.p2.x+this.p1.x,c=-this.p2.y+this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p2.x)/b:0>b?(a.lowerBound_.x-this.p2.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p2.y)/c:0>c?(a.lowerBound_.y-this.p2.y)/c:Number.POSITIVE_INFINITY);this.p1.x=this.p2.x+b*a;this.p1.y=this.p2.y+c*a};Box2D.Collision.b2SeparationFunction=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2SeparationFunction.prototype.Initialize=function(a,b,c,d,e){this.m_proxyA=b;this.m_proxyB=d;var g,f,l,k=l=f=0,h=0;d=b=0;var m,n,k=0;1==a.count?(this.m_type=Box2D.Collision.b2SeparationFunction.e_points,g=this.m_proxyA.GetVertex(a.indexA[0]),a=this.m_proxyB.GetVertex(a.indexB[0]),n=g,m=c.R,f=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),h=e.position.y+
(m.col1.y*n.x+m.col2.y*n.y),this.m_axis.x=k-f,this.m_axis.y=h-l,this.m_axis.Normalize()):(a.indexB[0]==a.indexB[1]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),a=this.m_proxyB.GetVertex(a.indexB[0]),this.m_localPoint.x=0.5*(b.x+d.x),this.m_localPoint.y=0.5*(b.y+d.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),this.m_axis.Normalize(),n=this.m_axis,m=c.R,b=m.col1.x*
n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=c.R,f=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),h=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),k=(k-f)*b+(h-l)*d):a.indexA[0]==a.indexA[0]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,f=this.m_proxyB.GetVertex(a.indexB[0]),l=this.m_proxyB.GetVertex(a.indexB[1]),g=this.m_proxyA.GetVertex(a.indexA[0]),this.m_localPoint.x=0.5*(f.x+
l.x),this.m_localPoint.y=0.5*(f.y+l.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(l,f),1),this.m_axis.Normalize(),n=this.m_axis,m=e.R,b=m.col1.x*n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),h=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=g,m=c.R,f=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),k=(f-k)*b+(l-h)*d):(b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),
f=this.m_proxyB.GetVertex(a.indexB[0]),l=this.m_proxyB.GetVertex(a.indexB[1]),k=Box2D.Common.Math.b2Math.MulMV(c.R,Box2D.Common.Math.b2Math.SubtractVV(d,b)),h=Box2D.Common.Math.b2Math.MulMV(e.R,Box2D.Common.Math.b2Math.SubtractVV(l,f)),e=k.x*k.x+k.y*k.y,c=h.x*h.x+h.y*h.y,g=Box2D.Common.Math.b2Math.SubtractVV(h,k),a=k.x*g.x+k.y*g.y,g=h.x*g.x+h.y*g.y,h=k.x*h.x+k.y*h.y,m=e*c-h*h,k=0,0!=m&&(k=Box2D.Common.Math.b2Math.Clamp((h*g-a*c)/m,0,1)),0>(h*k+g)/c&&(k=Box2D.Common.Math.b2Math.Clamp((h-a)/e,0,1)),
g=Box2D.Common.Math.b2Vec2.Get(0,0),g.x=b.x+k*(d.x-b.x),g.y=b.y+k*(d.y-b.y),a=Box2D.Common.Math.b2Vec2.Get(0,0),a.x=f.x+k*(l.x-f.x),a.y=f.y+k*(l.y-f.y),0==k||1==k?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(l,f),1),this.m_axis.Normalize(),this.m_localPoint=a):(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),
this.m_localPoint=g)),0>k&&this.m_axis.NegativeSelf())};Box2D.Collision.b2SeparationFunction.prototype.Evaluate=function(a,b){var c,d,e=0;switch(this.m_type){case Box2D.Collision.b2SeparationFunction.e_points:c=Box2D.Common.Math.b2Math.MulTMV(a.R,this.m_axis);d=Box2D.Common.Math.b2Math.MulTMV(b.R,this.m_axis.GetNegative());c=this.m_proxyA.GetSupportVertex(c);d=this.m_proxyB.GetSupportVertex(d);c=Box2D.Common.Math.b2Math.MulX(a,c);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*this.m_axis.x+(d.y-
c.y)*this.m_axis.y;break;case Box2D.Collision.b2SeparationFunction.e_faceA:e=Box2D.Common.Math.b2Math.MulMV(a.R,this.m_axis);c=Box2D.Common.Math.b2Math.MulX(a,this.m_localPoint);d=Box2D.Common.Math.b2Math.MulTMV(b.R,e.GetNegative());d=this.m_proxyB.GetSupportVertex(d);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*e.x+(d.y-c.y)*e.y;break;case Box2D.Collision.b2SeparationFunction.e_faceB:e=Box2D.Common.Math.b2Math.MulMV(b.R,this.m_axis),d=Box2D.Common.Math.b2Math.MulX(b,this.m_localPoint),c=Box2D.Common.Math.b2Math.MulTMV(a.R,
e.GetNegative()),c=this.m_proxyA.GetSupportVertex(c),c=Box2D.Common.Math.b2Math.MulX(a,c),e=(c.x-d.x)*e.x+(c.y-d.y)*e.y}return e};Box2D.Collision.b2SeparationFunction.e_points=1;Box2D.Collision.b2SeparationFunction.e_faceA=2;Box2D.Collision.b2SeparationFunction.e_faceB=4;Box2D.Collision.b2Simplex=function(){this.m_v1=new Box2D.Collision.b2SimplexVertex;this.m_v2=new Box2D.Collision.b2SimplexVertex;this.m_v3=new Box2D.Collision.b2SimplexVertex;this.m_vertices=[this.m_v1,this.m_v2,this.m_v3]};Box2D.Collision.b2Simplex.prototype.ReadCache=
function(a,b,c,d,e){var g,f;this.m_count=a.count;for(var l=this.m_vertices,k=0;k<this.m_count;k++){var h=l[k];h.indexA=a.indexA[k];h.indexB=a.indexB[k];g=b.GetVertex(h.indexA);f=d.GetVertex(h.indexB);h.wA=Box2D.Common.Math.b2Math.MulX(c,g);h.wB=Box2D.Common.Math.b2Math.MulX(e,f);h.w=Box2D.Common.Math.b2Math.SubtractVV(h.wB,h.wA);h.a=0}1<this.m_count&&(a=a.metric,g=this.GetMetric(),g<0.5*a||2*a<g||g<Number.MIN_VALUE)&&(this.m_count=0);0==this.m_count&&(h=l[0],h.indexA=0,h.indexB=0,g=b.GetVertex(0),
f=d.GetVertex(0),h.wA=Box2D.Common.Math.b2Math.MulX(c,g),h.wB=Box2D.Common.Math.b2Math.MulX(e,f),h.w=Box2D.Common.Math.b2Math.SubtractVV(h.wB,h.wA),this.m_count=1)};Box2D.Collision.b2Simplex.prototype.WriteCache=function(a){a.metric=this.GetMetric();a.count=this.m_count;for(var b=this.m_vertices,c=0;c<this.m_count;c++)a.indexA[c]=b[c].indexA,a.indexB[c]=b[c].indexB};Box2D.Collision.b2Simplex.prototype.GetSearchDirection=function(){if(1==this.m_count)return this.m_v1.w.GetNegative();if(2==this.m_count){var a=
Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w);return 0<Box2D.Common.Math.b2Math.CrossVV(a,this.m_v1.w.GetNegative())?Box2D.Common.Math.b2Math.CrossFV(1,a):Box2D.Common.Math.b2Math.CrossVF(a,1)}return Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Simplex.prototype.GetClosestPoint=function(){return 1==this.m_count?this.m_v1.w:2==this.m_count?Box2D.Common.Math.b2Vec2.Get(this.m_v1.a*this.m_v1.w.x+this.m_v2.a*this.m_v2.w.x,this.m_v1.a*this.m_v1.w.y+this.m_v2.a*this.m_v2.w.y):Box2D.Common.Math.b2Vec2.Get(0,
0)};Box2D.Collision.b2Simplex.prototype.GetWitnessPoints=function(a,b){1==this.m_count?(a.SetV(this.m_v1.wA),b.SetV(this.m_v1.wB)):2==this.m_count?(a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x,a.y=this.m_v1.a*this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y,b.x=this.m_v1.a*this.m_v1.wB.x+this.m_v2.a*this.m_v2.wB.x,b.y=this.m_v1.a*this.m_v1.wB.y+this.m_v2.a*this.m_v2.wB.y):3==this.m_count&&(b.x=a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x+this.m_v3.a*this.m_v3.wA.x,b.y=a.y=this.m_v1.a*
this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y+this.m_v3.a*this.m_v3.wA.y)};Box2D.Collision.b2Simplex.prototype.GetMetric=function(){return 1==this.m_count?0:2==this.m_count?Box2D.Common.Math.b2Math.SubtractVV(this.m_v1.w,this.m_v2.w).Length():3==this.m_count?Box2D.Common.Math.b2Math.CrossVV(Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w),Box2D.Common.Math.b2Math.SubtractVV(this.m_v3.w,this.m_v1.w)):0};Box2D.Collision.b2Simplex.prototype.Solve2=function(){var a=this.m_v1.w,b=this.m_v2.w,c=
Box2D.Common.Math.b2Math.SubtractVV(b,a),a=-(a.x*c.x+a.y*c.y);0>=a?this.m_count=this.m_v1.a=1:(b=b.x*c.x+b.y*c.y,0>=b?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):(c=1/(b+a),this.m_v1.a=b*c,this.m_v2.a=a*c,this.m_count=2))};Box2D.Collision.b2Simplex.prototype.Solve3=function(){var a=this.m_v1.w,b=this.m_v2.w,c=this.m_v3.w,d=Box2D.Common.Math.b2Math.SubtractVV(b,a),e=Box2D.Common.Math.b2Math.Dot(a,d),g=Box2D.Common.Math.b2Math.Dot(b,d),e=-e,f=Box2D.Common.Math.b2Math.SubtractVV(c,a),l=Box2D.Common.Math.b2Math.Dot(a,
f),k=Box2D.Common.Math.b2Math.Dot(c,f),l=-l,h=Box2D.Common.Math.b2Math.SubtractVV(c,b),m=Box2D.Common.Math.b2Math.Dot(b,h),h=Box2D.Common.Math.b2Math.Dot(c,h),m=-m,f=Box2D.Common.Math.b2Math.CrossVV(d,f),d=f*Box2D.Common.Math.b2Math.CrossVV(b,c),c=f*Box2D.Common.Math.b2Math.CrossVV(c,a),a=f*Box2D.Common.Math.b2Math.CrossVV(a,b);0>=e&&0>=l?this.m_count=this.m_v1.a=1:0<g&&0<e&&0>=a?(k=1/(g+e),this.m_v1.a=g*k,this.m_v2.a=e*k,this.m_count=2):0<k&&0<l&&0>=c?(g=1/(k+l),this.m_v1.a=k*g,this.m_v3.a=l*g,this.m_count=
2,this.m_v2.Set(this.m_v3)):0>=g&&0>=m?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):0>=k&&0>=h?(this.m_count=this.m_v3.a=1,this.m_v1.Set(this.m_v3)):0<h&&0<m&&0>=d?(g=1/(h+m),this.m_v2.a=h*g,this.m_v3.a=m*g,this.m_count=2,this.m_v1.Set(this.m_v3)):(g=1/(d+c+a),this.m_v1.a=d*g,this.m_v2.a=c*g,this.m_v3.a=a*g,this.m_count=3)};Box2D.Collision.b2SimplexCache=function(){this.indexA=[0,0,0];this.indexB=[0,0,0]};Box2D.Collision.b2SimplexVertex=function(){};Box2D.Collision.b2SimplexVertex.prototype.Set=
function(a){this.wA.SetV(a.wA);this.wB.SetV(a.wB);this.w.SetV(a.w);this.a=a.a;this.indexA=a.indexA;this.indexB=a.indexB};Box2D.Collision.b2TOIInput=function(){this.proxyA=new Box2D.Collision.b2DistanceProxy;this.proxyB=new Box2D.Collision.b2DistanceProxy;this.sweepA=new Box2D.Common.Math.b2Sweep;this.sweepB=new Box2D.Common.Math.b2Sweep};Box2D.Collision.b2TimeOfImpact={};Box2D.Collision.b2TimeOfImpact.TimeOfImpact=function(a){Box2D.Collision.b2TimeOfImpact.b2_toiCalls++;var b=a.proxyA,c=a.proxyB,
d=a.sweepA,e=a.sweepB,g=b.m_radius+c.m_radius;a=a.tolerance;var f=0,l=0,k=0;Box2D.Collision.b2TimeOfImpact.s_cache.count=0;for(Box2D.Collision.b2TimeOfImpact.s_distanceInput.useRadii=!1;;){d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,f);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,f);Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyA=b;Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyB=c;Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformA=Box2D.Collision.b2TimeOfImpact.s_xfA;
Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformB=Box2D.Collision.b2TimeOfImpact.s_xfB;Box2D.Collision.b2Distance.Distance(Box2D.Collision.b2TimeOfImpact.s_distanceOutput,Box2D.Collision.b2TimeOfImpact.s_cache,Box2D.Collision.b2TimeOfImpact.s_distanceInput);if(0>=Box2D.Collision.b2TimeOfImpact.s_distanceOutput.distance){f=1;break}Box2D.Collision.b2TimeOfImpact.s_fcn.Initialize(Box2D.Collision.b2TimeOfImpact.s_cache,b,Box2D.Collision.b2TimeOfImpact.s_xfA,c,Box2D.Collision.b2TimeOfImpact.s_xfB);
var h=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(0>=h){f=1;break}0==l&&(k=h>g?Math.max(g-a,0.75*g):Math.max(h-a,0.02*g));if(h-k<0.5*a){if(0==l){f=1;break}break}var m=f,n=f,p=1;d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,p);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,p);var q=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(q>=k){f=
1;break}for(var r=0;;){var t=0,t=r&1?n+(k-h)*(p-n)/(q-h):0.5*(n+p);d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,t);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,t);var s=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(Math.abs(s-k)<0.025*a){m=t;break}s>k?(n=t,h=s):(p=t,q=s);r++;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters++;if(50==r)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters,
r);if(m<(1+100*Number.MIN_VALUE)*f)break;f=m;l++;Box2D.Collision.b2TimeOfImpact.b2_toiIters++;if(1E3==l)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters,l);return f};Box2D.Collision.b2WorldManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_points=[];for(var a=this.m_pointCount=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2WorldManifold.prototype.Initialize=
function(a,b,c,d,e){if(0!=a.m_pointCount){var g=0,f,l,k=0,h=0,m=0,n=0,p=0;f=0;switch(a.m_type){case Box2D.Collision.b2Manifold.e_circles:l=b.R;f=a.m_localPoint;g=b.position.x+l.col1.x*f.x+l.col2.x*f.y;b=b.position.y+l.col1.y*f.x+l.col2.y*f.y;l=d.R;f=a.m_points[0].m_localPoint;a=d.position.x+l.col1.x*f.x+l.col2.x*f.y;d=d.position.y+l.col1.y*f.x+l.col2.y*f.y;f=a-g;l=d-b;k=f*f+l*l;k>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(k=Math.sqrt(k),this.m_normal.x=f/k,this.m_normal.y=l/k):(this.m_normal.x=1,
this.m_normal.y=0);f=b+c*this.m_normal.y;d-=e*this.m_normal.y;this.m_points[0].x=0.5*(g+c*this.m_normal.x+(a-e*this.m_normal.x));this.m_points[0].y=0.5*(f+d);break;case Box2D.Collision.b2Manifold.e_faceA:l=b.R;f=a.m_localPlaneNormal;k=l.col1.x*f.x+l.col2.x*f.y;h=l.col1.y*f.x+l.col2.y*f.y;l=b.R;f=a.m_localPoint;m=b.position.x+l.col1.x*f.x+l.col2.x*f.y;n=b.position.y+l.col1.y*f.x+l.col2.y*f.y;this.m_normal.x=k;this.m_normal.y=h;for(g=0;g<a.m_pointCount;g++)l=d.R,f=a.m_points[g].m_localPoint,p=d.position.x+
l.col1.x*f.x+l.col2.x*f.y,f=d.position.y+l.col1.y*f.x+l.col2.y*f.y,this.m_points[g].x=p+0.5*(c-(p-m)*k-(f-n)*h-e)*k,this.m_points[g].y=f+0.5*(c-(p-m)*k-(f-n)*h-e)*h;break;case Box2D.Collision.b2Manifold.e_faceB:for(l=d.R,f=a.m_localPlaneNormal,k=l.col1.x*f.x+l.col2.x*f.y,h=l.col1.y*f.x+l.col2.y*f.y,l=d.R,f=a.m_localPoint,m=d.position.x+l.col1.x*f.x+l.col2.x*f.y,n=d.position.y+l.col1.y*f.x+l.col2.y*f.y,this.m_normal.x=-k,this.m_normal.y=-h,g=0;g<a.m_pointCount;g++)l=b.R,f=a.m_points[g].m_localPoint,
p=b.position.x+l.col1.x*f.x+l.col2.x*f.y,f=b.position.y+l.col1.y*f.x+l.col2.y*f.y,this.m_points[g].x=p+0.5*(e-(p-m)*k-(f-n)*h-c)*k,this.m_points[g].y=f+0.5*(e-(p-m)*k-(f-n)*h-c)*h}}};Box2D.Dynamics.b2Body=function(a,b){this.ID="Body"+Box2D.Dynamics.b2Body.NEXT_ID++;this.m_xf=new Box2D.Common.Math.b2Transform;this.m_xf.position.SetV(a.position);this.m_xf.R.Set(a.angle);this.m_sweep=new Box2D.Common.Math.b2Sweep;this.m_sweep.localCenter.SetZero();this.m_sweep.t0=1;this.m_sweep.a0=this.m_sweep.a=a.angle;
this.m_sweep.c.x=this.m_xf.R.col1.x*this.m_sweep.localCenter.x+this.m_xf.R.col2.x*this.m_sweep.localCenter.y;this.m_sweep.c.y=this.m_xf.R.col1.y*this.m_sweep.localCenter.x+this.m_xf.R.col2.y*this.m_sweep.localCenter.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;this.m_sweep.c0.SetV(this.m_sweep.c);this.m_linearVelocity=a.linearVelocity.Copy();this.m_force=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_bullet=a.bullet;this.m_fixedRotation=a.fixedRotation;this.m_allowSleep=
a.allowSleep;this.m_awake=a.awake;this.m_active=a.active;this.m_world=b;this.m_jointList=null;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_controllerCount=0;this.m_angularVelocity=a.angularVelocity;this.m_linearDamping=a.linearDamping;this.m_angularDamping=a.angularDamping;this.m_sleepTime=this.m_torque=0;this.m_type=a.type;this.m_mass=this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invMass=this.m_type==
Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invI=this.m_I=0;this.m_inertiaScale=a.inertiaScale;this.fixtureList=new Box2D.Dynamics.b2FixtureList;this.m_lists=[]};Box2D.Dynamics.b2Body.prototype.CreateFixture=function(a){a=new Box2D.Dynamics.b2Fixture(this,this.m_xf,a);this.m_active&&a.CreateProxy(this.m_world.m_contactManager.m_broadPhase,this.m_xf);this.fixtureList.AddFixture(a);a.m_body=this;0<a.m_density&&this.ResetMassData();this.m_world.m_newFixture=!0;return a};Box2D.Dynamics.b2Body.prototype.CreateFixture2=
function(a,b){void 0===b&&(b=0);var c=new Box2D.Dynamics.b2FixtureDef;c.shape=a;c.density=b;return this.CreateFixture(c)};Box2D.Dynamics.b2Body.prototype.Destroy=function(){Box2D.Common.Math.b2Vec2.Free(this.m_linearVelocity);Box2D.Common.Math.b2Vec2.Free(this.m_force)};Box2D.Dynamics.b2Body.prototype.DestroyFixture=function(a){this.fixtureList.RemoveFixture(a);for(var b=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())a!=b.contact.m_fixtureA&&
a!=b.contact.m_fixtureB||this.m_world.m_contactManager.Destroy(b.contact);this.m_active&&a.DestroyProxy(this.m_world.m_contactManager.m_broadPhase);a.Destroy();a.m_body=null;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.SetPositionAndAngle=function(a,b){this.m_xf.R.Set(b);this.m_xf.position.SetV(a);var c=this.m_xf.R,d=this.m_sweep.localCenter;this.m_sweep.c.x=c.col1.x*d.x+c.col2.x*d.y;this.m_sweep.c.y=c.col1.y*d.x+c.col2.y*d.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;
this.m_sweep.c0.SetV(this.m_sweep.c);this.m_sweep.a0=this.m_sweep.a=b;c=this.m_world.m_contactManager.m_broadPhase;for(d=this.fixtureList.GetFirstNode();d;d=d.GetNextNode())d.fixture.Synchronize(c,this.m_xf,this.m_xf);this.m_world.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2Body.prototype.SetTransform=function(a){this.SetPositionAndAngle(a.position,a.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetTransform=function(){return this.m_xf};Box2D.Dynamics.b2Body.prototype.GetPosition=function(){return this.m_xf.position};
Box2D.Dynamics.b2Body.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetAngle=function(){return this.m_sweep.a};Box2D.Dynamics.b2Body.prototype.SetAngle=function(a){this.SetPositionAndAngle(this.GetPosition(),a)};Box2D.Dynamics.b2Body.prototype.GetWorldCenter=function(){return this.m_sweep.c};Box2D.Dynamics.b2Body.prototype.GetLocalCenter=function(){return this.m_sweep.localCenter};Box2D.Dynamics.b2Body.prototype.SetLinearVelocity=function(a){this.m_type!=
Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_linearVelocity.SetV(a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocity=function(){return this.m_linearVelocity};Box2D.Dynamics.b2Body.prototype.SetAngularVelocity=function(a){void 0===a&&(a=0);this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_angularVelocity=a)};Box2D.Dynamics.b2Body.prototype.GetAngularVelocity=function(){return this.m_angularVelocity};Box2D.Dynamics.b2Body.prototype.GetDefinition=function(){var a=new Box2D.Dynamics.b2BodyDef;
a.type=this.GetType();a.allowSleep=this.m_allowSleep;a.angle=this.GetAngle();a.angularDamping=this.m_angularDamping;a.angularVelocity=this.m_angularVelocity;a.fixedRotation=this.m_fixedRotation;a.bullet=this.m_bullet;a.active=this.m_active;a.awake=this.m_awake;a.linearDamping=this.m_linearDamping;a.linearVelocity.SetV(this.GetLinearVelocity());a.position=this.GetPosition();return a};Box2D.Dynamics.b2Body.prototype.ApplyForce=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),
this.m_force.x+=a.x,this.m_force.y+=a.y,this.m_torque+=(b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x)};Box2D.Dynamics.b2Body.prototype.ApplyTorque=function(a){void 0===a&&(a=0);this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_torque+=a)};Box2D.Dynamics.b2Body.prototype.ApplyImpulse=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_linearVelocity.x+=this.m_invMass*a.x,this.m_linearVelocity.y+=this.m_invMass*a.y,this.m_angularVelocity+=
this.m_invI*((b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x))};Box2D.Dynamics.b2Body.prototype.Split=function(a){for(var b=this.GetLinearVelocity().Copy(),c=this.GetAngularVelocity(),d=this.GetWorldCenter(),e=this.m_world.CreateBody(this.GetDefinition()),g=this.fixtureList.GetFirstNode();g;g=g.GetNextNode()){var f=g.fixture;a(f)&&(this.fixtureList.RemoveFixture(f),e.fixtureList.AddFixture(f))}this.ResetMassData();e.ResetMassData();g=this.GetWorldCenter();a=e.GetWorldCenter();g=Box2D.Common.Math.b2Math.AddVV(b,
Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(g,d)));b=Box2D.Common.Math.b2Math.AddVV(b,Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(a,d)));this.SetLinearVelocity(g);e.SetLinearVelocity(b);this.SetAngularVelocity(c);e.SetAngularVelocity(c);this.SynchronizeFixtures();e.SynchronizeFixtures();return e};Box2D.Dynamics.b2Body.prototype.Merge=function(a){for(var b=a.fixtureList.GetFirstNode();b;b=b.GetNextNode())this.fixtureList.AddFixture(b.fixture),a.fixtureList.RemoveFixture(b.fixture);
a.ResetMassData();this.ResetMassData();this.SynchronizeFixtures()};Box2D.Dynamics.b2Body.prototype.GetMass=function(){return this.m_mass};Box2D.Dynamics.b2Body.prototype.GetInertia=function(){return this.m_I};Box2D.Dynamics.b2Body.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);a.mass=this.m_mass;a.I=this.m_I;a.center.SetV(this.m_sweep.localCenter);return a};Box2D.Dynamics.b2Body.prototype.SetMassData=function(a){if(this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){this.m_invI=
this.m_I=this.m_invMass=0;this.m_mass=a.mass;0>=this.m_mass&&(this.m_mass=1);this.m_invMass=1/this.m_mass;0<a.I&&!this.m_fixedRotation&&(this.m_I=a.I-this.m_mass*(a.center.x*a.center.x+a.center.y*a.center.y),this.m_invI=1/this.m_I);var b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a.center);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=
this.m_angularVelocity*+(this.m_sweep.c.x-b.x)}};Box2D.Dynamics.b2Body.prototype.ResetMassData=function(){this.m_invI=this.m_I=this.m_invMass=this.m_mass=0;this.m_sweep.localCenter.SetZero();if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_type!=Box2D.Dynamics.b2BodyDef.b2_kinematicBody){for(var a=Box2D.Common.Math.b2Vec2.Get(0,0),b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode()){var c=b.fixture;0!=c.m_density&&(c=c.GetMassData(),this.m_mass+=c.mass,a.x+=c.center.x*c.mass,a.y+=
c.center.y*c.mass,this.m_I+=c.I)}0<this.m_mass?(this.m_invMass=1/this.m_mass,a.x*=this.m_invMass,a.y*=this.m_invMass):this.m_invMass=this.m_mass=1;0<this.m_I&&!this.m_fixedRotation?(this.m_I-=this.m_mass*(a.x*a.x+a.y*a.y),this.m_I*=this.m_inertiaScale,this.m_invI=1/this.m_I):this.m_invI=this.m_I=0;b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=
this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=this.m_angularVelocity*+(this.m_sweep.c.x-b.x);Box2D.Common.Math.b2Vec2.Free(a);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Body.prototype.GetWorldPoint=function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;return a};Box2D.Dynamics.b2Body.prototype.GetWorldVector=function(a){return Box2D.Common.Math.b2Math.MulMV(this.m_xf.R,
a)};Box2D.Dynamics.b2Body.prototype.GetLocalPoint=function(a){return Box2D.Common.Math.b2Math.MulXT(this.m_xf,a)};Box2D.Dynamics.b2Body.prototype.GetLocalVector=function(a){return Box2D.Common.Math.b2Math.MulTMV(this.m_xf.R,a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromWorldPoint=function(a){return Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x))};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromLocalPoint=
function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;b=Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x));Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Dynamics.b2Body.prototype.GetLinearDamping=function(){return this.m_linearDamping};Box2D.Dynamics.b2Body.prototype.SetLinearDamping=
function(a){this.m_linearDamping=a};Box2D.Dynamics.b2Body.prototype.GetAngularDamping=function(){return this.m_angularDamping};Box2D.Dynamics.b2Body.prototype.SetAngularDamping=function(a){this.m_angularDamping=a};Box2D.Dynamics.b2Body.prototype.SetType=function(a){if(this.m_type!=a){this.m_type=a;this.ResetMassData();this.m_type==Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0);this.SetAwake(!0);this.m_force.SetZero();this.m_torque=0;for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.FlagForFiltering();for(a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.b2Body.prototype.SetBullet=function(a){this.m_bullet=a};Box2D.Dynamics.b2Body.prototype.IsBullet=function(){return this.m_bullet};Box2D.Dynamics.b2Body.prototype.SetSleepingAllowed=function(a){(this.m_allowSleep=a)||this.SetAwake(!0)};Box2D.Dynamics.b2Body.prototype.SetAwake=function(a){if(this.m_awake!=
a)for(this.m_awake=a,this.m_sleepTime=0,a||(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0,this.m_force.SetZero(),this.m_torque=0),a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)};Box2D.Dynamics.b2Body.prototype.IsAwake=function(){return this.m_awake};Box2D.Dynamics.b2Body.prototype.SetFixedRotation=function(a){this.m_fixedRotation=a;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.IsFixedRotation=function(){return this.m_fixedRotation};Box2D.Dynamics.b2Body.prototype.SetActive=
function(a){if(a!=this.m_active){if(a){this.m_active=!0;a=this.m_world.m_contactManager.m_broadPhase;for(var b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.CreateProxy(a,this.m_xf)}else{this.m_active=!1;a=this.m_world.m_contactManager.m_broadPhase;for(b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.DestroyProxy(a);for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())this.m_world.m_contactManager.Destroy(a.contact)}for(a=
0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.IsActive=function(){return this.m_active};Box2D.Dynamics.b2Body.prototype.IsSleepingAllowed=function(){return this.m_allowSleep};Box2D.Dynamics.b2Body.prototype.GetFixtureList=function(){return this.fixtureList};Box2D.Dynamics.b2Body.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2Body.prototype.GetControllerList=function(){return this.controllerList};Box2D.Dynamics.b2Body.prototype.AddController=
function(a){this.controllerList.AddController(a)};Box2D.Dynamics.b2Body.prototype.RemoveController=function(a){this.controllerList.RemoveController(a)};Box2D.Dynamics.b2Body.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2Body.prototype.GetWorld=function(){return this.m_world};Box2D.Dynamics.b2Body.prototype.SynchronizeFixtures=function(){var a=Box2D.Dynamics.b2Body.s_xf1;a.R.Set(this.m_sweep.a0);var b=a.R,c=this.m_sweep.localCenter;a.position.x=this.m_sweep.c0.x-(b.col1.x*
c.x+b.col2.x*c.y);a.position.y=this.m_sweep.c0.y-(b.col1.y*c.x+b.col2.y*c.y);b=this.m_world.m_contactManager.m_broadPhase;for(c=this.fixtureList.GetFirstNode();c;c=c.GetNextNode())c.fixture.Synchronize(b,a,this.m_xf)};Box2D.Dynamics.b2Body.prototype.SynchronizeTransform=function(){this.m_xf.R.Set(this.m_sweep.a);var a=this.m_xf.R,b=this.m_sweep.localCenter;this.m_xf.position.x=this.m_sweep.c.x-(a.col1.x*b.x+a.col2.x*b.y);this.m_xf.position.y=this.m_sweep.c.y-(a.col1.y*b.x+a.col2.y*b.y)};Box2D.Dynamics.b2Body.prototype.ShouldCollide=
function(a){if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&a.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody)return!1;for(var b=this.m_jointList;b;b=b.next)if(b.other==a&&!1==b.joint.m_collideConnected)return!1;return!0};Box2D.Dynamics.b2Body.prototype.Advance=function(a){this.m_sweep.Advance(a);this.m_sweep.c.SetV(this.m_sweep.c0);this.m_sweep.a=this.m_sweep.a0;this.SynchronizeTransform()};Box2D.Dynamics.b2Body.NEXT_ID=0;Box2D.Dynamics.b2BodyDef=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearVelocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=this.angle=0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=Box2D.Dynamics.b2BodyDef.b2_staticBody;this.active=!0;this.inertiaScale=1};Box2D.Dynamics.b2BodyDef.b2_staticBody=0;Box2D.Dynamics.b2BodyDef.b2_kinematicBody=1;Box2D.Dynamics.b2BodyDef.b2_dynamicBody=2;Box2D.Dynamics.b2BodyList=function(){this.bodyFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyFirstNodes[a]=
null;this.bodyLastNodes=[];for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyLastNodes[a]=null;this.bodyNodeLookup={};this.bodyCount=0};Box2D.Dynamics.b2BodyList.prototype.GetFirstNode=function(a){return this.bodyFirstNodes[a]};Box2D.Dynamics.b2BodyList.prototype.AddBody=function(a){var b=a.ID;null==this.bodyNodeLookup[b]&&(this.CreateNode(a,b,Box2D.Dynamics.b2BodyList.TYPES.allBodies),this.UpdateBody(a),a.m_lists.push(this),this.bodyCount++)};Box2D.Dynamics.b2BodyList.prototype.UpdateBody=
function(a){var b=a.GetType(),c=a.ID,d=a.IsAwake(),e=a.IsActive();b==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&e&&d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies):
this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);e?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies)};Box2D.Dynamics.b2BodyList.prototype.RemoveBody=function(a){var b=a.ID;if(null!=this.bodyNodeLookup[b]){cr.arrayFindRemove(a.m_lists,this);for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.RemoveNode(b,
a);delete this.bodyNodeLookup[b];this.bodyCount--}};Box2D.Dynamics.b2BodyList.prototype.RemoveNode=function(a,b){var c=this.bodyNodeLookup[a];if(null!=c){var d=c[b];null!=d&&(c[b]=null,c=d.GetPreviousNode(),d=d.GetNextNode(),null==c?this.bodyFirstNodes[b]=d:c.SetNextNode(d),null==d?this.bodyLastNodes[b]=c:d.SetPreviousNode(c))}};Box2D.Dynamics.b2BodyList.prototype.CreateNode=function(a,b,c){var d=this.bodyNodeLookup[b];if(null==d){for(var d=[],e=0;e<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;e++)d[e]=
null;this.bodyNodeLookup[b]=d}null==d[c]&&(d[c]=new Box2D.Dynamics.b2BodyListNode(a),a=this.bodyLastNodes[c],null!=a?a.SetNextNode(d[c]):this.bodyFirstNodes[c]=d[c],d[c].SetPreviousNode(a),this.bodyLastNodes[c]=d[c])};Box2D.Dynamics.b2BodyList.prototype.GetBodyCount=function(){return this.bodyCount};Box2D.Dynamics.b2BodyList.TYPES={dynamicBodies:0,nonStaticBodies:1,activeBodies:2,nonStaticActiveAwakeBodies:3,awakeBodies:4,allBodies:5};Box2D.Dynamics.b2BodyListNode=function(a){this.body=a;this.previous=
this.next=null};Box2D.Dynamics.b2BodyListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2BodyListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2BodyListNode.prototype.GetBody=function(){return this.body};Box2D.Dynamics.b2BodyListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2BodyListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2ContactFilter=function(){};Box2D.Dynamics.b2ContactFilter.prototype.ShouldCollide=
function(a,b){var c=a.GetFilterData(),d=b.GetFilterData();return c.groupIndex==d.groupIndex&&0!=c.groupIndex?0<c.groupIndex:0!=(c.maskBits&d.categoryBits)&&0!=(c.categoryBits&d.maskBits)};Box2D.Dynamics.b2ContactFilter.b2_defaultFilter=new Box2D.Dynamics.b2ContactFilter;Box2D.Dynamics.b2ContactImpulse=function(){this.normalImpulses=[];this.tangentImpulses=[]};Box2D.Dynamics.b2ContactListener=function(){};Box2D.Dynamics.b2ContactListener.prototype.BeginContact=function(a){};Box2D.Dynamics.b2ContactListener.prototype.EndContact=
function(a){};Box2D.Dynamics.b2ContactListener.prototype.PreSolve=function(a,b){};Box2D.Dynamics.b2ContactListener.prototype.PostSolve=function(a,b){};Box2D.Dynamics.b2ContactManager=function(a){this.m_world=a;this.m_contactFilter=Box2D.Dynamics.b2ContactFilter.b2_defaultFilter;this.m_contactListener=Box2D.Dynamics.b2ContactListener.b2_defaultListener;this.m_contactFactory=new Box2D.Dynamics.Contacts.b2ContactFactory;this.m_broadPhase=new Box2D.Collision.b2DynamicTreeBroadPhase};Box2D.Dynamics.b2ContactManager.prototype.AddPair=
function(a,b){var c=a.GetBody(),d=b.GetBody();if(c!=d&&d.ShouldCollide(c)&&this.m_contactFilter.ShouldCollide(a,b)){for(c=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);c;c=c.GetNextNode())if(d=c.contact.m_fixtureA,d==a){if(d=c.contact.m_fixtureB,d==b)return}else if(d==b&&(d=c.contact.m_fixtureB,d==a))return;this.m_contactFactory.Create(a,b)}};Box2D.Dynamics.b2ContactManager.prototype.FindNewContacts=function(){var a=this;this.m_broadPhase.UpdatePairs(function(b,
c){a.AddPair(b,c)})};Box2D.Dynamics.b2ContactManager.prototype.Destroy=function(a){var b=a.m_fixtureB;a.m_fixtureA.GetBody();b.GetBody();a.touching&&this.m_contactListener.EndContact(a);0<a.m_manifold.m_pointCount&&(a.m_fixtureA.GetBody().SetAwake(!0),a.m_fixtureB.GetBody().SetAwake(!0));a.RemoveFromLists();this.m_contactFactory.Destroy(a)};Box2D.Dynamics.b2ContactManager.prototype.Collide=function(){for(var a=this.m_world.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode()){var b=a.contact,c=b.m_fixtureA,d=b.m_fixtureB,e=c.GetBody(),g=d.GetBody();if(!1!=e.IsAwake()||!1!=g.IsAwake()){if(b.IsFiltering()){if(!1==g.ShouldCollide(e)){this.Destroy(b);continue}if(!1==this.m_contactFilter.ShouldCollide(c,d)){this.Destroy(b);continue}b.ClearFiltering()}!1==this.m_broadPhase.TestOverlap(c.m_proxy,d.m_proxy)?this.Destroy(b):b.Update(this.m_contactListener)}}};Box2D.Dynamics.b2DestructionListener=function(){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeJoint=
function(a){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeFixture=function(a){};Box2D.Dynamics.b2FilterData=function(){this.categoryBits=1;this.maskBits=65535;this.groupIndex=0};Box2D.Dynamics.b2FilterData.prototype.Copy=function(){var a=new Box2D.Dynamics.b2FilterData;a.categoryBits=this.categoryBits;a.maskBits=this.maskBits;a.groupIndex=this.groupIndex;return a};Box2D.Dynamics.b2Fixture=function(a,b,c){this.ID="Fixture"+Box2D.Dynamics.b2Fixture.NEXT_ID++;this.m_filter=c.filter.Copy();
this.m_aabb=Box2D.Collision.b2AABB.Get();this.m_body=a;this.m_shape=c.shape.Copy();this.m_density=c.density;this.m_friction=c.friction;this.m_restitution=c.restitution;this.m_isSensor=c.isSensor};Box2D.Dynamics.b2Fixture.prototype.GetShape=function(){return this.m_shape};Box2D.Dynamics.b2Fixture.prototype.SetSensor=function(a){if(this.m_isSensor!=a&&(this.m_isSensor=a,null!=this.m_body))for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode()){var b=
a.contact.m_fixtureA,c=a.contact.m_fixtureB;b!=this&&c!=this||a.contact.SetSensor(b.sensor||c.sensor)}};Box2D.Dynamics.b2Fixture.prototype.IsSensor=function(){return this.m_isSensor};Box2D.Dynamics.b2Fixture.prototype.SetFilterData=function(a){this.m_filter=a.Copy();if(null!=this.m_body)for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.m_fixtureA!=this&&a.contact.m_fixtureB!=this||a.contact.FlagForFiltering()};Box2D.Dynamics.b2Fixture.prototype.GetFilterData=
function(){return this.m_filter.Copy()};Box2D.Dynamics.b2Fixture.prototype.GetBody=function(){return this.m_body};Box2D.Dynamics.b2Fixture.prototype.TestPoint=function(a){return this.m_shape.TestPoint(this.m_body.GetTransform(),a)};Box2D.Dynamics.b2Fixture.prototype.RayCast=function(a,b){return this.m_shape.RayCast(a,b,this.m_body.GetTransform())};Box2D.Dynamics.b2Fixture.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);this.m_shape.ComputeMass(a,this.m_density);return a};
Box2D.Dynamics.b2Fixture.prototype.SetDensity=function(a){this.m_density=a};Box2D.Dynamics.b2Fixture.prototype.GetDensity=function(){return this.m_density};Box2D.Dynamics.b2Fixture.prototype.GetFriction=function(){return this.m_friction};Box2D.Dynamics.b2Fixture.prototype.SetFriction=function(a){this.m_friction=a};Box2D.Dynamics.b2Fixture.prototype.GetRestitution=function(){return this.m_restitution};Box2D.Dynamics.b2Fixture.prototype.SetRestitution=function(a){this.m_restitution=a};Box2D.Dynamics.b2Fixture.prototype.GetAABB=
function(){return this.m_aabb};Box2D.Dynamics.b2Fixture.prototype.Destroy=function(){Box2D.Collision.b2AABB.Free(this.m_aabb)};Box2D.Dynamics.b2Fixture.prototype.CreateProxy=function(a,b){this.m_shape.ComputeAABB(this.m_aabb,b);this.m_proxy=a.CreateProxy(this.m_aabb,this)};Box2D.Dynamics.b2Fixture.prototype.DestroyProxy=function(a){null!=this.m_proxy&&(a.DestroyProxy(this.m_proxy),this.m_proxy=null)};Box2D.Dynamics.b2Fixture.prototype.Synchronize=function(a,b,c){if(this.m_proxy){var d=Box2D.Collision.b2AABB.Get(),
e=Box2D.Collision.b2AABB.Get();this.m_shape.ComputeAABB(d,b);this.m_shape.ComputeAABB(e,c);this.m_aabb.Combine(d,e);Box2D.Collision.b2AABB.Free(d);Box2D.Collision.b2AABB.Free(e);b=Box2D.Common.Math.b2Math.SubtractVV(c.position,b.position);a.MoveProxy(this.m_proxy,this.m_aabb,b);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Fixture.NEXT_ID=0;Box2D.Dynamics.b2FixtureDef=function(){this.filter=new Box2D.Dynamics.b2FilterData;this.filter.categoryBits=1;this.filter.maskBits=65535;this.filter.groupIndex=
0;this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1};Box2D.Dynamics.b2FixtureList=function(){this.fixtureLastNode=this.fixtureFirstNode=null;this.fixtureNodeLookup={};this.fixtureCount=0};Box2D.Dynamics.b2FixtureList.prototype.GetFirstNode=function(){return this.fixtureFirstNode};Box2D.Dynamics.b2FixtureList.prototype.AddFixture=function(a){var b=a.ID;if(null==this.fixtureNodeLookup[b]){a=new Box2D.Dynamics.b2FixtureListNode(a);var c=this.fixtureLastNode;null!=c?c.SetNextNode(a):
this.fixtureFirstNode=a;a.SetPreviousNode(c);this.fixtureLastNode=a;this.fixtureNodeLookup[b]=a;this.fixtureCount++}};Box2D.Dynamics.b2FixtureList.prototype.RemoveFixture=function(a){a=a.ID;var b=this.fixtureNodeLookup[a];if(null!=b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.fixtureFirstNode=b:c.SetNextNode(b);null==b?this.fixtureLastNode=c:b.SetPreviousNode(c);delete this.fixtureNodeLookup[a];this.fixtureCount--}};Box2D.Dynamics.b2FixtureList.prototype.GetFixtureCount=function(){return this.fixtureCount};
Box2D.Dynamics.b2FixtureListNode=function(a){this.fixture=a;this.previous=this.next=null};Box2D.Dynamics.b2FixtureListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2FixtureListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2FixtureListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2FixtureListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2Island=function(a,b){this.m_listener=a;this.m_contactSolver=
b;this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Clear=function(){this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Solve=function(a,b,c){this._InitializeVelocities(a,b);this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);this._SolveVelocityConstraints(a);this._SolveBodies(a);this._SolvePositionConstraints(a);
this.Report(this.m_contactSolver.m_constraints);c&&this._SleepIfTired(a)};Box2D.Dynamics.b2Island.prototype._InitializeVelocities=function(a,b){for(var c=0;c<this.m_dynamicBodies.length;c++){var d=this.m_dynamicBodies[c];d.m_linearVelocity.x+=a.dt*(b.x+d.m_invMass*d.m_force.x);d.m_linearVelocity.y+=a.dt*(b.y+d.m_invMass*d.m_force.y);d.m_angularVelocity+=a.dt*d.m_invI*d.m_torque;d.m_linearVelocity.Multiply(Box2D.Common.Math.b2Math.Clamp(1-a.dt*d.m_linearDamping,0,1));d.m_angularVelocity*=Box2D.Common.Math.b2Math.Clamp(1-
a.dt*d.m_angularDamping,0,1)}};Box2D.Dynamics.b2Island.prototype._SolveVelocityConstraints=function(a){this.m_contactSolver.InitVelocityConstraints(a);for(var b=0;b<this.m_joints.length;b++)this.m_joints[b].InitVelocityConstraints(a);for(b=0;b<a.velocityIterations;b++){for(var c=0;c<this.m_joints.length;c++)this.m_joints[c].SolveVelocityConstraints(a);this.m_contactSolver.SolveVelocityConstraints()}for(a=0;a<this.m_joints.length;a++)this.m_joints[a].FinalizeVelocityConstraints();this.m_contactSolver.FinalizeVelocityConstraints()};
Box2D.Dynamics.b2Island.prototype._SolveBodies=function(a){for(var b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],d=a.dt*c.m_linearVelocity.x,e=a.dt*c.m_linearVelocity.y;d*d+e*e>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x=c.m_linearVelocity.x*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y=c.m_linearVelocity.y*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);d=a.dt*c.m_angularVelocity;d*
d>Box2D.Common.b2Settings.b2_maxRotationSquared&&(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}};Box2D.Dynamics.b2Island.prototype._SolvePositionConstraints=function(a){for(var b=0;b<a.positionIterations;b++){for(var c=
this.m_contactSolver.SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=!0,e=0;e<this.m_joints.length;e++)var g=this.m_joints[e].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=d&&g;if(c&&d)break}};Box2D.Dynamics.b2Island.prototype._SleepIfTired=function(a){for(var b=Number.MAX_VALUE,c=0;c<this.m_nonStaticBodies.length;c++){var d=this.m_nonStaticBodies[c];!d.m_allowSleep||Math.abs(d.m_angularVelocity)>Box2D.Common.b2Settings.b2_angularSleepTolerance||Box2D.Common.Math.b2Math.Dot(d.m_linearVelocity,
d.m_linearVelocity)>Box2D.Common.b2Settings.b2_linearSleepToleranceSquared?b=d.m_sleepTime=0:(d.m_sleepTime+=a.dt,b=Math.min(b,d.m_sleepTime))}if(b>=Box2D.Common.b2Settings.b2_timeToSleep)for(a=0;a<this.m_bodies.length;a++)this.m_bodies[a].SetAwake(!1)};Box2D.Dynamics.b2Island.prototype.SolveTOI=function(a){var b=0,c=0;this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);for(var d=this.m_contactSolver,b=0;b<this.m_joints.length;++b)this.m_joints[b].InitVelocityConstraints(a);
for(b=0;b<a.velocityIterations;++b)for(d.SolveVelocityConstraints(),c=0;c<this.m_joints.length;++c)this.m_joints[c].SolveVelocityConstraints(a);for(b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],e=a.dt*c.m_linearVelocity.x,g=a.dt*c.m_linearVelocity.y;e*e+g*g>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x=c.m_linearVelocity.x*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y=c.m_linearVelocity.y*
Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);e=a.dt*c.m_angularVelocity;e*e>Box2D.Common.b2Settings.b2_maxRotationSquared&&(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}for(b=0;b<a.positionIterations;++b){e=
d.SolvePositionConstraints(0.75);g=!0;for(c=0;c<this.m_joints.length;++c)var f=this.m_joints[c].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),g=g&&f;if(e&&g)break}this.Report(d.m_constraints)};Box2D.Dynamics.b2Island.prototype.Report=function(a){if(null!=this.m_listener)for(var b=0;b<this.m_contacts.length;++b){for(var c=this.m_contacts[b],d=a[b],e=new Box2D.Dynamics.b2ContactImpulse,g=0;g<d.pointCount;++g)e.normalImpulses[g]=d.points[g].normalImpulse,e.tangentImpulses[g]=
d.points[g].tangentImpulse;this.m_listener.PostSolve(c,e)}};Box2D.Dynamics.b2Island.prototype.AddBody=function(a){this.m_bodies.push(a);a.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_nonStaticBodies.push(a),a.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&this.m_dynamicBodies.push(a))};Box2D.Dynamics.b2Island.prototype.AddContact=function(a){this.m_contacts.push(a)};Box2D.Dynamics.b2Island.prototype.AddJoint=function(a){this.m_joints.push(a)};Box2D.Dynamics.b2TimeStep=function(a,
b,c,d,e){this.dt=a;var g=0;0<a&&(g=1/a);this.inv_dt=g;this.dtRatio=b;this.positionIterations=c;this.velocityIterations=d;this.warmStarting=e};Box2D.Dynamics.b2World=function(a,b){this.m_contactManager=new Box2D.Dynamics.b2ContactManager(this);this.m_contactSolver=new Box2D.Dynamics.Contacts.b2ContactSolver;this.m_newFixture=this.m_isLocked=!1;this.m_destructionListener=null;this.bodyList=new Box2D.Dynamics.b2BodyList;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.m_jointList=null;
this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_jointCount=0;this.m_continuousPhysics=this.m_warmStarting=!0;this.m_allowSleep=b;this.m_gravity=a;this.m_inv_dt0=0;this.m_groundBody=this.CreateBody(new Box2D.Dynamics.b2BodyDef)};Box2D.Dynamics.b2World.MAX_TOI=1-100*Number.MIN_VALUE;Box2D.Dynamics.b2World.prototype.SetDestructionListener=function(a){this.m_destructionListener=a};Box2D.Dynamics.b2World.prototype.SetContactFilter=function(a){this.m_contactManager.m_contactFilter=
a};Box2D.Dynamics.b2World.prototype.SetContactListener=function(a){this.m_contactManager.m_contactListener=a};Box2D.Dynamics.b2World.prototype.SetBroadPhase=function(a){var b=this.m_contactManager.m_broadPhase;this.m_contactManager.m_broadPhase=a;for(var c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())for(var d=c.body.GetFixtureList().GetFirstNode();d;d=d.GetNextNode()){var e=d.fixture;e.m_proxy=a.CreateProxy(b.GetFatAABB(e.m_proxy),e)}};Box2D.Dynamics.b2World.prototype.GetProxyCount=
function(){return this.m_contactManager.m_broadPhase.GetProxyCount()};Box2D.Dynamics.b2World.prototype.CreateBody=function(a){a=new Box2D.Dynamics.b2Body(a,this);this.bodyList.AddBody(a);return a};Box2D.Dynamics.b2World.prototype.DestroyBody=function(a){for(var b=a.m_jointList;b;){var c=b,b=b.next;this.m_destructionListener&&this.m_destructionListener.SayGoodbyeJoint(c.joint);this.DestroyJoint(c.joint)}for(b=a.GetControllerList().GetFirstNode();b;b=b.GetNextNode())b.controller.RemoveBody(a);for(b=
a.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())this.m_contactManager.Destroy(b.contact);for(b=a.GetFixtureList().GetFirstNode();b;b=b.GetNextNode())this.m_destructionListener&&this.m_destructionListener.SayGoodbyeFixture(b.fixture),a.DestroyFixture(b.fixture);a.Destroy();this.bodyList.RemoveBody(a)};Box2D.Dynamics.b2World.prototype.CreateJoint=function(a){var b=Box2D.Dynamics.Joints.b2Joint.Create(a);b.m_prev=null;if(b.m_next=this.m_jointList)this.m_jointList.m_prev=
b;this.m_jointList=b;this.m_jointCount++;b.m_edgeA.joint=b;b.m_edgeA.other=b.m_bodyB;b.m_edgeA.prev=null;if(b.m_edgeA.next=b.m_bodyA.m_jointList)b.m_bodyA.m_jointList.prev=b.m_edgeA;b.m_bodyA.m_jointList=b.m_edgeA;b.m_edgeB.joint=b;b.m_edgeB.other=b.m_bodyA;b.m_edgeB.prev=null;if(b.m_edgeB.next=b.m_bodyB.m_jointList)b.m_bodyB.m_jointList.prev=b.m_edgeB;b.m_bodyB.m_jointList=b.m_edgeB;var c=a.bodyA,d=a.bodyB;if(!a.collideConnected)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering();return b};Box2D.Dynamics.b2World.prototype.DestroyJoint=function(a){var b=a.m_collideConnected;a.m_prev&&(a.m_prev.m_next=a.m_next);a.m_next&&(a.m_next.m_prev=a.m_prev);a==this.m_jointList&&(this.m_jointList=a.m_next);var c=a.m_bodyA,d=a.m_bodyB;c.SetAwake(!0);d.SetAwake(!0);a.m_edgeA.prev&&(a.m_edgeA.prev.next=a.m_edgeA.next);a.m_edgeA.next&&(a.m_edgeA.next.prev=a.m_edgeA.prev);a.m_edgeA==c.m_jointList&&(c.m_jointList=a.m_edgeA.next);
a.m_edgeA.prev=null;a.m_edgeA.next=null;a.m_edgeB.prev&&(a.m_edgeB.prev.next=a.m_edgeB.next);a.m_edgeB.next&&(a.m_edgeB.next.prev=a.m_edgeB.prev);a.m_edgeB==d.m_jointList&&(d.m_jointList=a.m_edgeB.next);a.m_edgeB.prev=null;a.m_edgeB.next=null;this.m_jointCount--;if(!b)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering()};Box2D.Dynamics.b2World.prototype.GetControllerList=function(){return this.controllerList};
Box2D.Dynamics.b2World.prototype.AddController=function(a){if(null!==a.m_world&&a.m_world!=this)throw Error("Controller can only be a member of one world");this.controllerList.AddController(a);a.m_world=this;return a};Box2D.Dynamics.b2World.prototype.RemoveController=function(a){this.controllerList.RemoveController(a);a.m_world=null;a.Clear()};Box2D.Dynamics.b2World.prototype.CreateController=function(a){return this.AddController(a)};Box2D.Dynamics.b2World.prototype.DestroyController=function(a){this.RemoveController(a)};
Box2D.Dynamics.b2World.prototype.SetWarmStarting=function(a){this.m_warmStarting=a};Box2D.Dynamics.b2World.prototype.SetContinuousPhysics=function(a){this.m_continuousPhysics=a};Box2D.Dynamics.b2World.prototype.GetBodyCount=function(){return this.bodyList.GetBodyCount()};Box2D.Dynamics.b2World.prototype.GetJointCount=function(){return this.m_jointCount};Box2D.Dynamics.b2World.prototype.GetContactCount=function(){return this.contactList.GetContactCount()};Box2D.Dynamics.b2World.prototype.SetGravity=
function(a){this.m_gravity=a};Box2D.Dynamics.b2World.prototype.GetGravity=function(){return this.m_gravity};Box2D.Dynamics.b2World.prototype.GetGroundBody=function(){return this.m_groundBody};Box2D.Dynamics.b2World.prototype.Step=function(a,b,c){this.m_newFixture&&(this.m_contactManager.FindNewContacts(),this.m_newFixture=!1);this.m_isLocked=!0;a=new Box2D.Dynamics.b2TimeStep(a,this.m_inv_dt0*a,b,c,this.m_warmStarting);this.m_contactManager.Collide();0<a.dt&&(this.Solve(a),this.m_continuousPhysics&&
this.SolveTOI(a),this.m_inv_dt0=a.inv_dt);this.m_isLocked=!1};Box2D.Dynamics.b2World.prototype.ClearForces=function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);a;a=a.GetNextNode())a.body.m_force.SetZero(),a.body.m_torque=0};Box2D.Dynamics.b2World.prototype.QueryAABB=function(a,b){this.m_contactManager.m_broadPhase.Query(a,b)};Box2D.Dynamics.b2World.prototype.QueryPoint=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.lowerBound_.Set(b.x-Box2D.Common.b2Settings.b2_linearSlop,
b.y-Box2D.Common.b2Settings.b2_linearSlop);c.upperBound_.Set(b.x+Box2D.Common.b2Settings.b2_linearSlop,b.y+Box2D.Common.b2Settings.b2_linearSlop);this.m_contactManager.m_broadPhase.Query(function(c){return c.TestPoint(b)?a(c):!0},c);Box2D.Collision.b2AABB.Free(c)};Box2D.Dynamics.b2World.prototype.RayCast=function(a,b,c){var d=this.m_contactManager.m_broadPhase,e=new Box2D.Collision.b2RayCastOutput,g=new Box2D.Collision.b2RayCastInput(b,c,1);d.RayCast(function(d,g){if(g.RayCast(e,d)){var k=1-e.fraction,
k=Box2D.Common.Math.b2Vec2.Get(k*b.x+e.fraction*c.x,k*b.y+e.fraction*c.y),h=a(g,k,e.normal,e.fraction);Box2D.Common.Math.b2Vec2.Free(k);return h}return d.maxFraction},g)};Box2D.Dynamics.b2World.prototype.RayCastOne=function(a,b){var c=null;this.RayCast(function(a,b,g,f){c=a;return f},a,b);return c};Box2D.Dynamics.b2World.prototype.RayCastAll=function(a,b){var c=[];this.RayCast(function(a,b,g,f){c.push(a);return 1},a,b);return c};Box2D.Dynamics.b2World.prototype.GetBodyList=function(){return this.bodyList};
Box2D.Dynamics.b2World.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2World.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2World.prototype.IsLocked=function(){return this.m_isLocked};var b2solvearray=[];Box2D.Dynamics.b2World.prototype.Solve=function(a){for(var b=this.controllerList.GetFirstNode();b;b=b.GetNextNode())b.controller.Step(a);for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=
this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())c.body.m_islandFlag=!1;for(var d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);d;d=d.GetNextNode())d.contact.m_islandFlag=!1;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())if(d=c.body,!d.m_islandFlag){b.Clear();b2solvearray.length=0;var e=b2solvearray;
e.push(d);for(d.m_islandFlag=!0;0<e.length;){var g=e.pop();b.AddBody(g);g.IsAwake()||g.SetAwake(!0);if(g.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody){for(d=g.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);d;d=d.GetNextNode()){var f=d.contact;f.m_islandFlag||(b.AddContact(f),f.m_islandFlag=!0,f=f.GetOther(g),f.m_islandFlag||(e.push(f),f.m_islandFlag=!0))}for(d=g.m_jointList;d;d=d.next)!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),
d.joint.m_islandFlag=!0,d.other.m_islandFlag||(e.push(d.other),d.other.m_islandFlag=!0))}}b.Solve(a,this.m_gravity,this.m_allowSleep)}for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())c.body.SynchronizeFixtures();this.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2World.prototype.SolveTOI=function(a){for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=
c.GetNextNode()){var d=c.body;d.m_islandFlag=!1;d.m_sweep.t0=0}for(var e=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_islandFlag=!1,e.contact.m_toi=null;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(;;){var c=this._SolveTOI2(a),g=c.minContact,c=c.minTOI;if(null===g||Box2D.Dynamics.b2World.MAX_TOI<c)break;e=g.m_fixtureA.GetBody();d=g.m_fixtureB.GetBody();Box2D.Dynamics.b2World.s_backupA.Set(e.m_sweep);Box2D.Dynamics.b2World.s_backupB.Set(d.m_sweep);
e.Advance(c);d.Advance(c);g.Update(this.m_contactManager.m_contactListener);g.m_toi=null;if(g.sensor||!g.enabled)e.m_sweep.Set(Box2D.Dynamics.b2World.s_backupA),d.m_sweep.Set(Box2D.Dynamics.b2World.s_backupB),e.SynchronizeTransform(),d.SynchronizeTransform();else if(g.touching){e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(e=d);b.Clear();b2solvearray.length=0;g=b2solvearray;g.push(e);for(e.m_islandFlag=!0;0<g.length;)if(d=g.pop(),b.AddBody(d),d.IsAwake()||d.SetAwake(!0),d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){for(e=
d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);e&&b.m_contactCount!=Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland;e=e.GetNextNode()){var f=e.contact;f.m_islandFlag||(b.AddContact(f),f.m_islandFlag=!0,f=f.GetOther(d),f.m_islandFlag||(f.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(f.Advance(c),f.SetAwake(!0),g.push(f)),f.m_islandFlag=!0))}for(d=d.m_jointList;d;d=d.next)b.m_jointCount!=Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland&&
!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),d.joint.m_islandFlag=!0,d.other.m_islandFlag||(d.other.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(d.other.Advance(c),d.other.SetAwake(!0),g.push(d.other)),d.other.m_islandFlag=!0))}b.SolveTOI(new Box2D.Dynamics.b2TimeStep((1-c)*a.dt,0,a.velocityIterations,a.positionIterations,!1));for(c=0;c<b.m_bodies.length;c++)if(b.m_bodies[c].m_islandFlag=!1,b.m_bodies[c].IsAwake()&&b.m_bodies[c].GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody)for(b.m_bodies[c].SynchronizeFixtures(),
e=b.m_bodies[c].contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_toi=null;for(c=0;c<b.m_contactCount;c++)b.m_contacts[c].m_islandFlag=!1,b.m_contacts[c].m_toi=null;for(c=0;c<b.m_jointCount;c++)b.m_joints[c].m_islandFlag=!1;this.m_contactManager.FindNewContacts()}}};Box2D.Dynamics.b2World.prototype._SolveTOI2=function(a){for(var b=null,c=1,d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts);d;d=
d.GetNextNode()){var e=d.contact;if(!this._SolveTOI2SkipContact(a,e)){var g=1;if(null!=e.m_toi)g=e.m_toi;else{if(e.touching)g=1;else{var g=e.m_fixtureA.GetBody(),f=e.m_fixtureB.GetBody(),l=g.m_sweep.t0;g.m_sweep.t0<f.m_sweep.t0?(l=f.m_sweep.t0,g.m_sweep.Advance(l)):f.m_sweep.t0<g.m_sweep.t0&&(l=g.m_sweep.t0,f.m_sweep.Advance(l));g=e.ComputeTOI(g.m_sweep,f.m_sweep);0<g&&1>g&&(g=(1-g)*l+g)}e.m_toi=g}Number.MIN_VALUE<g&&g<c&&(b=e,c=g)}}return{minContact:b,minTOI:c}};Box2D.Dynamics.b2World.prototype._SolveTOI2SkipContact=
function(a,b){var c=b.m_fixtureA.GetBody(),d=b.m_fixtureB.GetBody();return c.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&c.IsAwake()||d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&d.IsAwake()?!1:!0};Box2D.Dynamics.Contacts.b2Contact=function(a,b){this.ID="Contact"+Box2D.Dynamics.Contacts.b2Contact.NEXT_ID++;this.m_manifold=new Box2D.Collision.b2Manifold;this.m_oldManifold=new Box2D.Collision.b2Manifold;this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||
c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.Reset=function(a,b){this.m_manifold.Reset();this.m_oldManifold.Reset();this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=
c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.AddToLists=function(){this.bodyAList.AddContact(this);this.bodyBList.AddContact(this);
this.worldList.AddContact(this);this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.UpdateLists=function(){var a=!1,b=!1;!this.IsSensor()&&this.IsEnabled()&&(this.IsTouching()&&(a=!0),this.IsContinuous()&&(b=!0));this.bodyAList.UpdateContact(this,a,b);this.bodyBList.UpdateContact(this,a,b);this.worldList.UpdateContact(this,a,b)};Box2D.Dynamics.Contacts.b2Contact.prototype.RemoveFromLists=function(){this.bodyAList.RemoveContact(this);this.bodyBList.RemoveContact(this);this.worldList.RemoveContact(this)};
Box2D.Dynamics.Contacts.b2Contact.prototype.GetManifold=function(){return this.m_manifold};Box2D.Dynamics.Contacts.b2Contact.prototype.GetWorldManifold=function(a){var b=this.m_fixtureA.GetBody(),c=this.m_fixtureB.GetBody(),d=this.m_fixtureA.GetShape(),e=this.m_fixtureB.GetShape();a.Initialize(this.m_manifold,b.GetTransform(),d.m_radius,c.GetTransform(),e.m_radius)};Box2D.Dynamics.Contacts.b2Contact.prototype.IsTouching=function(){return this.touching};Box2D.Dynamics.Contacts.b2Contact.prototype.IsContinuous=
function(){return this.continuous};Box2D.Dynamics.Contacts.b2Contact.prototype.SetSensor=function(a){this.sensor=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsSensor=function(){return this.sensor};Box2D.Dynamics.Contacts.b2Contact.prototype.SetEnabled=function(a){this.enabled=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsEnabled=function(){return this.enabled};Box2D.Dynamics.Contacts.b2Contact.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureA=
function(){return this.m_fixtureA};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureB=function(){return this.m_fixtureB};Box2D.Dynamics.Contacts.b2Contact.prototype.GetOther=function(a){var b=this.m_fixtureA.GetBody();return b!=a?b:this.m_fixtureB.GetBody()};Box2D.Dynamics.Contacts.b2Contact.prototype.FlagForFiltering=function(){this.filtering=!0};Box2D.Dynamics.Contacts.b2Contact.prototype.ClearFiltering=function(){this.filtering=!1};Box2D.Dynamics.Contacts.b2Contact.prototype.IsFiltering=function(){return this.filtering};
Box2D.Dynamics.Contacts.b2Contact.prototype.Update=function(a){var b=this.m_oldManifold;this.m_oldManifold=this.m_manifold;this.m_manifold=b;this.enabled=!0;var b=!1,c=this.IsTouching(),d=this.m_fixtureA.GetBody(),e=this.m_fixtureB.GetBody(),g=this.m_fixtureA.m_aabb.TestOverlap(this.m_fixtureB.m_aabb);if(this.sensor)g&&(b=Box2D.Collision.Shapes.b2Shape.TestOverlap(this.m_fixtureA.GetShape(),d.GetTransform(),this.m_fixtureB.GetShape(),e.GetTransform())),this.m_manifold.m_pointCount=0;else{d.GetType()!=
Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet()||e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||e.IsBullet()?this.continuous=!0:this.continuous=!1;if(g)for(this.Evaluate(),b=0<this.m_manifold.m_pointCount,g=0;g<this.m_manifold.m_pointCount;g++){var f=this.m_manifold.m_points[g];f.m_normalImpulse=0;for(var l=f.m_tangentImpulse=0;l<this.m_oldManifold.m_pointCount;l++){var k=this.m_oldManifold.m_points[l];if(k.m_id.GetKey()==f.m_id.GetKey()){f.m_normalImpulse=k.m_normalImpulse;f.m_tangentImpulse=
k.m_tangentImpulse;break}}}else this.m_manifold.m_pointCount=0;b!=c&&(d.SetAwake(!0),e.SetAwake(!0))}this.touching=b;b!=c&&this.UpdateLists();!c&&b&&a.BeginContact(this);c&&!b&&a.EndContact(this);this.sensor||a.PreSolve(this,this.m_oldManifold)};Box2D.Dynamics.Contacts.b2Contact.prototype.Evaluate=function(){};Box2D.Dynamics.Contacts.b2Contact.prototype.ComputeTOI=function(a,b){Box2D.Dynamics.Contacts.b2Contact.s_input.proxyA.Set(this.m_fixtureA.GetShape());Box2D.Dynamics.Contacts.b2Contact.s_input.proxyB.Set(this.m_fixtureB.GetShape());
Box2D.Dynamics.Contacts.b2Contact.s_input.sweepA=a;Box2D.Dynamics.Contacts.b2Contact.s_input.sweepB=b;Box2D.Dynamics.Contacts.b2Contact.s_input.tolerance=Box2D.Common.b2Settings.b2_linearSlop;return Box2D.Collision.b2TimeOfImpact.TimeOfImpact(Box2D.Dynamics.Contacts.b2Contact.s_input)};Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2Contact.NEXT_ID=0;Box2D.Dynamics.Contacts.b2CircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2CircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2CircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollideCircles(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2ContactConstraint=
function(){this.localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.normalMass=new Box2D.Common.Math.b2Mat22;this.K=new Box2D.Common.Math.b2Mat22;this.points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.points[a]=new Box2D.Dynamics.Contacts.b2ContactConstraintPoint};Box2D.Dynamics.Contacts.b2ContactConstraintPoint=function(){this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);
this.rA=Box2D.Common.Math.b2Vec2.Get(0,0);this.rB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2ContactConstraintPoint.prototype.Reset=function(){this.localPoint.Set(0,0);this.rA.Set(0,0);this.rB.Set(0,0)};Box2D.Dynamics.Contacts.b2ContactFactory=function(){this.m_registers={};this.m_freeContacts={};this.AddType(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Collision.Shapes.b2CircleShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,
Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2PolygonShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Collision.Shapes.b2EdgeShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2EdgeShape.NAME)};
Box2D.Dynamics.Contacts.b2ContactFactory.prototype.AddType=function(a,b,c){this.m_freeContacts[b]=this.m_freeContacts[b]||{};this.m_freeContacts[b][c]=this.m_freeContacts[b][c]||[];this.m_registers[b]=this.m_registers[b]||{};this.m_registers[b][c]=new Box2D.Dynamics.Contacts.b2ContactRegister;this.m_registers[b][c].ctor=a;this.m_registers[b][c].primary=!0;b!=c&&(this.m_registers[c]=this.m_registers[c]||{},this.m_registers[c][b]=new Box2D.Dynamics.Contacts.b2ContactRegister,this.m_registers[c][b].ctor=
a,this.m_registers[c][b].primary=!1)};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Create=function(a,b){var c=a.GetShape().GetTypeName(),d=b.GetShape().GetTypeName(),e=this.m_registers[c][d],g=e.ctor;return null!=g?e.primary?0<this.m_freeContacts[c][d].length?(c=this.m_freeContacts[c][d].pop(),c.Reset(a,b),c):new g(a,b):0<this.m_freeContacts[d][c].length?(c=this.m_freeContacts[d][c].pop(),c.Reset(b,a),c):new g(b,a):null};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Destroy=function(a){var b=
a.m_fixtureA.GetShape().GetTypeName(),c=a.m_fixtureB.GetShape().GetTypeName();this.m_freeContacts[b][c].push(a)};Box2D.Dynamics.Contacts.b2ContactList=function(){this.contactFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactFirstNodes[a]=null;this.contactLastNodes=[];for(a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactLastNodes[a]=null;this.contactNodeLookup={};this.contactCount=0};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetFirstNode=
function(a){return this.contactFirstNodes[a]};Box2D.Dynamics.Contacts.b2ContactList.prototype.AddContact=function(a){var b=a.ID;if(null==this.contactNodeLookup[b]){this.contactNodeLookup[b]=[];for(var c=0;c<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;c++)this.contactNodeLookup[b][c]=null;this.CreateNode(a,b,Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);this.contactCount++}};Box2D.Dynamics.Contacts.b2ContactList.prototype.UpdateContact=function(a,b,c){b?this.CreateNode(a,a.ID,
Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);c?this.CreateNode(a,a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts)};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveContact=function(a){a=a.ID;if(null!=this.contactNodeLookup[a]){for(var b=
0;b<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;b++)this.RemoveNode(a,b);delete this.contactNodeLookup[a];this.contactCount--}};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveNode=function(a,b){var c=this.contactNodeLookup[a];if(null!=c){var d=c[b];if(null!=d){c[b]=null;var c=d.GetPreviousNode(),e=d.GetNextNode();null==c?this.contactFirstNodes[b]=e:c.SetNextNode(e);null==e?this.contactLastNodes[b]=c:e.SetPreviousNode(c);Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode(d)}}};
Box2D.Dynamics.Contacts.b2ContactList.prototype.CreateNode=function(a,b,c){b=this.contactNodeLookup[b];null==b[c]&&(b[c]=Box2D.Dynamics.Contacts.b2ContactListNode.GetNode(a),a=this.contactLastNodes[c],null!=a?(a.SetNextNode(b[c]),b[c].SetPreviousNode(a)):this.contactFirstNodes[c]=b[c],this.contactLastNodes[c]=b[c])};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetContactCount=function(){return this.contactCount};Box2D.Dynamics.Contacts.b2ContactList.TYPES={nonSensorEnabledTouchingContacts:0,nonSensorEnabledContinuousContacts:1,
allContacts:2};Box2D.Dynamics.Contacts.b2ContactListNode=function(a){this.contact=a;this.previous=this.next=null};Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes=[];Box2D.Dynamics.Contacts.b2ContactListNode.GetNode=function(a){if(0<Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.length){var b=Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.pop();b.next=null;b.previous=null;b.contact=a;return b}return new Box2D.Dynamics.Contacts.b2ContactListNode(a)};Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode=
function(a){Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.push(a)};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetContact=function(){return this.contact};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetPreviousNode=
function(){return this.previous};Box2D.Dynamics.Contacts.b2ContactRegister=function(){this.pool=null;this.poolCount=0};Box2D.Dynamics.Contacts.b2PositionSolverManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_separations=[];this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype.Initialize=function(a){switch(a.type){case Box2D.Collision.b2Manifold.e_circles:this._InitializeCircles(a);
break;case Box2D.Collision.b2Manifold.e_faceA:this._InitializeFaceA(a);break;case Box2D.Collision.b2Manifold.e_faceB:this._InitializeFaceB(a)}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeCircles=function(a){var b=a.bodyA.m_xf.R,c=a.localPoint,d=a.bodyA.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),e=a.bodyA.m_xf.position.y+(b.col1.y*c.x+b.col2.y*c.y),b=a.bodyB.m_xf.R,c=a.points[0].localPoint,g=a.bodyB.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),b=a.bodyB.m_xf.position.y+(b.col1.y*
c.x+b.col2.y*c.y),c=g-d,f=b-e,l=c*c+f*f;l>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(l=Math.sqrt(l),this.m_normal.x=c/l,this.m_normal.y=f/l):(this.m_normal.x=1,this.m_normal.y=0);this.m_points[0].x=0.5*(d+g);this.m_points[0].y=0.5*(e+b);this.m_separations[0]=c*this.m_normal.x+f*this.m_normal.y-a.radius};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceA=function(a){this.m_normal.x=a.bodyA.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=
a.bodyA.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.localPoint.x+a.bodyA.m_xf.R.col2.x*a.localPoint.y),c=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.localPoint.x+a.bodyA.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyB.m_xf.R.col2.x*a.points[d].localPoint.y),g=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.points[d].localPoint.x+
a.bodyB.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(g-c)*this.m_normal.y-a.radius;this.m_points[d].x=e;this.m_points[d].y=g}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceB=function(a){this.m_normal.x=a.bodyB.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=a.bodyB.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*
a.localPoint.x+a.bodyB.m_xf.R.col2.x*a.localPoint.y),c=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.localPoint.x+a.bodyB.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.x*a.points[d].localPoint.y),g=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(g-c)*this.m_normal.y-a.radius;
this.m_points[d].Set(e,g)}this.m_normal.x*=-1;this.m_normal.y*=-1};Box2D.Dynamics.Contacts.b2ContactSolver=function(){this.m_constraints=[]};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.Initialize=function(a,b,c){for(this.m_constraintCount=c;this.m_constraints.length<this.m_constraintCount;)this.m_constraints[this.m_constraints.length]=new Box2D.Dynamics.Contacts.b2ContactConstraint;for(a=0;a<c;a++){var d=b[a],e=d.m_fixtureA,g=d.m_fixtureB,f=e.m_shape.m_radius,l=g.m_shape.m_radius,k=e.GetBody(),
h=g.GetBody(),m=d.GetManifold(),n=Box2D.Common.b2Settings.b2MixFriction(e.GetFriction(),g.GetFriction()),p=Box2D.Common.b2Settings.b2MixRestitution(e.GetRestitution(),g.GetRestitution()),q=k.m_linearVelocity.x,r=k.m_linearVelocity.y,t=h.m_linearVelocity.x,s=h.m_linearVelocity.y,u=k.m_angularVelocity,A=h.m_angularVelocity;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.Initialize(m,k.m_xf,f,h.m_xf,l);g=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.x;d=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.y;
e=this.m_constraints[a];e.bodyA=k;e.bodyB=h;e.manifold=m;e.normal.x=g;e.normal.y=d;e.pointCount=m.m_pointCount;e.friction=n;e.restitution=p;e.localPlaneNormal.x=m.m_localPlaneNormal.x;e.localPlaneNormal.y=m.m_localPlaneNormal.y;e.localPoint.x=m.m_localPoint.x;e.localPoint.y=m.m_localPoint.y;e.radius=f+l;e.type=m.m_type;for(f=0;f<e.pointCount;++f){n=m.m_points[f];l=e.points[f];l.normalImpulse=n.m_normalImpulse;l.tangentImpulse=n.m_tangentImpulse;l.localPoint.SetV(n.m_localPoint);var n=l.rA.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].x-
k.m_sweep.c.x,p=l.rA.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].y-k.m_sweep.c.y,E=l.rB.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].x-h.m_sweep.c.x,I=l.rB.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].y-h.m_sweep.c.y,z=n*d-p*g,v=E*d-I*g,z=z*z,v=v*v;l.normalMass=1/(k.m_invMass+h.m_invMass+k.m_invI*z+h.m_invI*v);var F=k.m_mass*k.m_invMass+h.m_mass*h.m_invMass,F=F+(k.m_mass*k.m_invI*z+h.m_mass*h.m_invI*v);l.equalizedMass=1/F;
v=d;F=-g;z=n*F-p*v;v=E*F-I*v;z*=z;v*=v;l.tangentMass=1/(k.m_invMass+h.m_invMass+k.m_invI*z+h.m_invI*v);l.velocityBias=0;n=e.normal.x*(t+-A*I-q- -u*p)+e.normal.y*(s+A*E-r-u*n);n<-Box2D.Common.b2Settings.b2_velocityThreshold&&(l.velocityBias+=-e.restitution*n)}2==e.pointCount&&(s=e.points[0],t=e.points[1],m=k.m_invMass,k=k.m_invI,q=h.m_invMass,h=h.m_invI,r=s.rA.x*d-s.rA.y*g,s=s.rB.x*d-s.rB.y*g,u=t.rA.x*d-t.rA.y*g,t=t.rB.x*d-t.rB.y*g,g=m+q+k*r*r+h*s*s,d=m+q+k*u*u+h*t*t,h=m+q+k*r*u+h*s*t,g*g<100*(g*d-
h*h)?(e.K.col1.Set(g,h),e.K.col2.Set(h,d),e.K.GetInverse(e.normalMass)):e.pointCount=1)}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.InitVelocityConstraints=function(a){for(var b=0;b<this.m_constraintCount;++b){var c=this.m_constraints[b],d=c.bodyA,e=c.bodyB,g=d.m_invMass,f=d.m_invI,l=e.m_invMass,k=e.m_invI,h=c.normal.x,m=c.normal.y,n=m,p=-h,q=0,r=0;if(a.warmStarting)for(r=c.pointCount,q=0;q<r;++q){var t=c.points[q];t.normalImpulse*=a.dtRatio;t.tangentImpulse*=a.dtRatio;var s=t.normalImpulse*
h+t.tangentImpulse*n,u=t.normalImpulse*m+t.tangentImpulse*p;d.m_angularVelocity-=f*(t.rA.x*u-t.rA.y*s);d.m_linearVelocity.x-=g*s;d.m_linearVelocity.y-=g*u;e.m_angularVelocity+=k*(t.rB.x*u-t.rB.y*s);e.m_linearVelocity.x+=l*s;e.m_linearVelocity.y+=l*u}else for(r=c.pointCount,q=0;q<r;++q)d=c.points[q],d.normalImpulse=0,d.tangentImpulse=0}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;a++)this.SolveVelocityConstraints_Constraint(this.m_constraints[a])};
Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_Constraint=function(a){for(var b=a.normal.x,c=a.normal.y,d=0;d<a.pointCount;d++)Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint(a,a.points[d]);if(1==a.pointCount){var d=a.points[0],e=d.normalImpulse-d.normalMass*((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*
d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias),e=0<e?e:0,g=e-d.normalImpulse,f=g*b,c=g*c;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*f;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*c;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(d.rA.x*c-d.rA.y*f);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*f;a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*c;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(d.rB.x*c-d.rB.y*f);d.normalImpulse=e}else for(var d=a.points[0],e=a.points[1],
g=d.normalImpulse,f=e.normalImpulse,l=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias,c=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*e.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*e.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*e.rB.x-a.bodyA.m_linearVelocity.y-
a.bodyA.m_angularVelocity*e.rA.x)*c-e.velocityBias,l=l-(a.K.col1.x*g+a.K.col2.x*f),c=c-(a.K.col1.y*g+a.K.col2.y*f);;){b=-(a.normalMass.col1.x*l+a.normalMass.col2.x*c);if(0<=b){var k=-(a.normalMass.col1.y*l+a.normalMass.col2.y*c);if(0<=k){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-g,k-f);d.normalImpulse=b;e.normalImpulse=k;break}}b=-d.normalMass*l;if(0<=b&&0<=a.K.col1.y*b+c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-g,-f);d.normalImpulse=b;e.normalImpulse=0;break}b=
-e.normalMass*c;if(0<=b&&0<=a.K.col2.x*b+l){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-g,b-f);d.normalImpulse=0;e.normalImpulse=b;break}if(0<=l&&0<=c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-g,-f);d.normalImpulse=0;e.normalImpulse=0;break}break}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint=function(a,b){var c=a.normal.y,d=-a.normal.x,e=a.friction*b.normalImpulse,e=Box2D.Common.Math.b2Math.Clamp(b.tangentImpulse-b.tangentMass*
((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*b.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*b.rA.y)*c+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*b.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*b.rA.x)*d),-e,e),g=e-b.tangentImpulse,c=g*c,d=g*d;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*c;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*d;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*c);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*c;a.bodyB.m_linearVelocity.y+=
a.bodyB.m_invMass*d;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*c);b.tangentImpulse=e};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPointUpdate=function(a,b,c,d,e){var g=d*a.normal.x;d*=a.normal.y;var f=e*a.normal.x;e*=a.normal.y;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*(g+f);a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*(d+e);a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*g+c.rA.x*e-c.rA.y*f);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*
(g+f);a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*(d+e);a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*g+c.rB.x*e-c.rB.y*f);b.normalImpulse=0;c.normalImpulse=0};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.FinalizeVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;++a)for(var b=this.m_constraints[a],c=b.manifold,d=0;d<b.pointCount;++d){var e=c.m_points[d],g=b.points[d];e.m_normalImpulse=g.normalImpulse;e.m_tangentImpulse=g.tangentImpulse}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints=
function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,g=d.bodyB,f=e.m_mass*e.m_invMass,l=e.m_mass*e.m_invI,k=g.m_mass*g.m_invMass,h=g.m_mass*g.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var p=d.points[n],q=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],r=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],
t=q.x-e.m_sweep.c.x,s=q.y-e.m_sweep.c.y,u=q.x-g.m_sweep.c.x,q=q.y-g.m_sweep.c.y,b=b<r?b:r,r=Box2D.Common.Math.b2Math.Clamp(a*(r+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),r=-p.equalizedMass*r,p=r*m.x,r=r*m.y;e.m_sweep.c.x-=f*p;e.m_sweep.c.y-=f*r;e.m_sweep.a-=l*(t*r-s*p);e.SynchronizeTransform();g.m_sweep.c.x+=k*p;g.m_sweep.c.y+=k*r;g.m_sweep.a+=h*(u*r-q*p);g.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints_NEW=
function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,g=d.bodyB,f=e.m_mass*e.m_invMass,l=e.m_mass*e.m_invI,k=g.m_mass*g.m_invMass,h=g.m_mass*g.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var p=d.points[n],q=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],r=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],
t=q.x-e.m_sweep.c.x,s=q.y-e.m_sweep.c.y,u=q.x-g.m_sweep.c.x,q=q.y-g.m_sweep.c.y;r<b&&(b=r);0!=a&&Box2D.Common.Math.b2Math.Clamp(a*(r+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0);r=0*-p.equalizedMass;p=r*m.x;r*=m.y;e.m_sweep.c.x-=f*p;e.m_sweep.c.y-=f*r;e.m_sweep.a-=l*(t*r-s*p);e.SynchronizeTransform();g.m_sweep.c.x+=k*p;g.m_sweep.c.y+=k*r;g.m_sweep.a+=h*(u*r-q*p);g.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact=
function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Evaluate=function(){this.m_fixtureA.GetBody();this.m_fixtureB.GetBody();this.b2CollideEdgeAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,
this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.b2CollideEdgeAndCircle=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolyAndCircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,
a,b)};Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygonAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Reset=
function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Evaluate=function(){this.b2CollidePolyAndEdge(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.b2CollidePolyAndEdge=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolygonContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygons(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Controllers.b2Controller=
function(){this.ID="Controller"+Box2D.Dynamics.Controllers.b2Controller.NEXT_ID++;this.m_world=null;this.bodyList=new Box2D.Dynamics.b2BodyList};Box2D.Dynamics.Controllers.b2Controller.prototype.Step=function(a){};Box2D.Dynamics.Controllers.b2Controller.prototype.AddBody=function(a){this.bodyList.AddBody(a);a.AddController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.RemoveBody=function(a){this.bodyList.RemoveBody(a);a.RemoveController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.Clear=
function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);a;a=a.GetNextNode())this.RemoveBody(a.body)};Box2D.Dynamics.Controllers.b2Controller.prototype.GetBodyList=function(){return this.bodyList};Box2D.Dynamics.Controllers.b2Controller.NEXT_ID=0;Box2D.Dynamics.Controllers.b2BuoyancyController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.normal=Box2D.Common.Math.b2Vec2.Get(0,-1);this.density=this.offset=0;this.velocity=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearDrag=2;this.angularDrag=1;this.useDensity=!1;this.useWorldGravity=!0;this.gravity=null};c2inherit(Box2D.Dynamics.Controllers.b2BuoyancyController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2BuoyancyController.prototype.Step=function(a){this.useWorldGravity&&(this.gravity=this.m_world.GetGravity().Copy());for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){for(var b=a.body,c=Box2D.Common.Math.b2Vec2.Get(0,0),d=Box2D.Common.Math.b2Vec2.Get(0,
0),e=0,g=0,f=b.GetFixtureList().GetFirstNode();f;f=f.GetNextNode()){var l=Box2D.Common.Math.b2Vec2.Get(0,0),k=f.fixture.GetShape().ComputeSubmergedArea(this.normal,this.offset,b.GetTransform(),l),e=e+k;c.x+=k*l.x;c.y+=k*l.y;var h=0,h=1,g=g+k*h;d.x+=k*l.x*h;d.y+=k*l.y*h}e<Number.MIN_VALUE||(c.x/=e,c.y/=e,d.x/=g,d.y/=g,g=this.gravity.GetNegative(),g.Multiply(this.density*e),b.ApplyForce(g,d),g=b.GetLinearVelocityFromWorldPoint(c),g.Subtract(this.velocity),g.Multiply(-this.linearDrag*e),b.ApplyForce(g,
c),b.ApplyTorque(-b.GetInertia()/b.GetMass()*e*b.GetAngularVelocity()*this.angularDrag),Box2D.Common.Math.b2Vec2.Free(c),Box2D.Common.Math.b2Vec2.Free(d))}};Box2D.Dynamics.Controllers.b2ConstantAccelController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.A=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantAccelController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2ConstantAccelController.prototype.Step=function(a){a=Box2D.Common.Math.b2Vec2.Get(this.A.x*
a.dt,this.A.y*a.dt);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=b.GetNextNode()){var c=b.body,d=c.GetLinearVelocity();c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(d.x+a.x,d.y+a.y))}Box2D.Common.Math.b2Vec2.Free(a)};Box2D.Dynamics.Controllers.b2ConstantForceController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.F=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantForceController,Box2D.Dynamics.Controllers.b2Controller);
Box2D.Dynamics.Controllers.b2ConstantForceController.prototype.Step=function(a){for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){var b=a.body;b.ApplyForce(this.F,b.GetWorldCenter())}};Box2D.Dynamics.Controllers.b2ControllerList=function(){this.controllerLastNode=this.controllerFirstNode=null;this.controllerNodeLookup={};this.controllerCount=0};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetFirstNode=function(){return this.controllerFirstNode};
Box2D.Dynamics.Controllers.b2ControllerList.prototype.AddController=function(a){var b=a.ID;if(null==this.controllerNodeLookup[b]){a=new Box2D.Dynamics.Controllers.b2ControllerListNode(a);var c=this.controllerLastNode;null!=c?c.SetNextNode(a):this.controllerFirstNode=a;a.SetPreviousNode(c);this.controllerLastNode=a;this.controllerNodeLookup[b]=a;this.controllerCount++}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.RemoveController=function(a){a=a.ID;var b=this.controllerNodeLookup[a];if(null!=
b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.controllerFirstNode=b:c.SetNextNode(b);null==b?this.controllerLastNode=c:b.SetPreviousNode(c);delete this.controllerNodeLookup[a];this.controllerCount--}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetControllerCount=function(){return this.controllerCount};Box2D.Dynamics.Controllers.b2ControllerListNode=function(a){this.controller=a;this.previous=this.next=null};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetNextNode=
function(a){this.next=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.Controllers.b2GravityController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.G=1;this.invSqr=!0};c2inherit(Box2D.Dynamics.Controllers.b2GravityController,
Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2GravityController.prototype.Step=function(a){var b=a=null,c=0,d=null,e=null,g=0,f=0,l=0,g=null;if(this.invSqr)for(var k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode()){a=k.body;for(var b=a.GetWorldCenter(),c=a.GetMass(),h=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);h;h=h.GetNextNode())if(d=h.body,a.IsAwake()||d.IsAwake())e=d.GetWorldCenter(),g=e.x-b.x,f=e.y-b.y,
l=g*g+f*f,l<Number.MIN_VALUE||(g=Box2D.Common.Math.b2Vec2.Get(g,f),g.Multiply(this.G/l/Math.sqrt(l)*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(g,b),g.Multiply(-1),d.IsAwake()&&d.ApplyForce(g,e),Box2D.Common.Math.b2Vec2.Free(g))}else for(k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode())for(a=bodyNode.body,b=a.GetWorldCenter(),c=a.GetMass(),h=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);h;h=h.GetNextNode())if(d=bodyNode.body,a.IsAwake()||
d.IsAwake())e=d.GetWorldCenter(),g=e.x-b.x,f=e.y-b.y,l=g*g+f*f,l<Number.MIN_VALUE||(g=Box2D.Common.Math.b2Vec2.Get(g,f),g.Multiply(this.G/l*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(g,b),g.Multiply(-1),d.IsAwake()&&d.ApplyForce(g,e),Box2D.Common.Math.b2Vec2.Free(g))};Box2D.Dynamics.Controllers.b2TensorDampingController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.T=new Box2D.Common.Math.b2Mat22;this.maxTimestep=0};c2inherit(Box2D.Dynamics.Controllers.b2TensorDampingController,
Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.SetAxisAligned=function(a,b){this.T.col1.x=-a;this.T.col1.y=0;this.T.col2.x=0;this.T.col2.y=-b;this.maxTimestep=0<a||0<b?1/Math.max(a,b):0};Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.Step=function(a){a=a.dt;if(!(a<=Number.MIN_VALUE)){a>this.maxTimestep&&0<this.maxTimestep&&(a=this.maxTimestep);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=
b.GetNextNode()){var c=b.body,d=c.GetWorldVector(Box2D.Common.Math.b2Math.MulMV(this.T,c.GetLocalVector(c.GetLinearVelocity())));c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(c.GetLinearVelocity().x+d.x*a,c.GetLinearVelocity().y+d.y*a))}}};Box2D.Dynamics.Joints.b2Joint=function(a){this.m_edgeA=new Box2D.Dynamics.Joints.b2JointEdge;this.m_edgeB=new Box2D.Dynamics.Joints.b2JointEdge;this.m_localCenterA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localCenterB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_type=
a.type;this.m_next=this.m_prev=null;this.m_bodyA=a.bodyA;this.m_bodyB=a.bodyB;this.m_collideConnected=a.collideConnected};Box2D.Dynamics.Joints.b2Joint.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorA=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorB=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionForce=function(a){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionTorque=function(a){return 0};
Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyA=function(){return this.m_bodyA};Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyB=function(){return this.m_bodyB};Box2D.Dynamics.Joints.b2Joint.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Joints.b2Joint.prototype.IsActive=function(){return this.m_bodyA.IsActive()&&this.m_bodyB.IsActive()};Box2D.Dynamics.Joints.b2Joint.Create=function(a){return a.Create()};Box2D.Dynamics.Joints.b2Joint.prototype.InitVelocityConstraints=function(a){};
Box2D.Dynamics.Joints.b2Joint.prototype.SolveVelocityConstraints=function(a){};Box2D.Dynamics.Joints.b2Joint.prototype.FinalizeVelocityConstraints=function(){};Box2D.Dynamics.Joints.b2Joint.prototype.SolvePositionConstraints=function(a){return!1};Box2D.Dynamics.Joints.b2Joint.e_unknownJoint=0;Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint=2;Box2D.Dynamics.Joints.b2Joint.e_distanceJoint=3;Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint=4;Box2D.Dynamics.Joints.b2Joint.e_mouseJoint=
5;Box2D.Dynamics.Joints.b2Joint.e_gearJoint=6;Box2D.Dynamics.Joints.b2Joint.e_lineJoint=7;Box2D.Dynamics.Joints.b2Joint.e_weldJoint=8;Box2D.Dynamics.Joints.b2Joint.e_frictionJoint=9;Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit=0;Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit=1;Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit=2;Box2D.Dynamics.Joints.b2Joint.e_equalLimits=3;Box2D.Dynamics.Joints.b2JointDef=function(){this.type=Box2D.Dynamics.Joints.b2Joint.e_unknownJoint;this.bodyB=this.bodyA=null;this.collideConnected=
!1};Box2D.Dynamics.Joints.b2JointEdge=function(){};Box2D.Dynamics.Joints.b2DistanceJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_length=a.length;this.m_frequencyHz=a.frequencyHz;this.m_dampingRatio=a.dampingRatio;this.m_bias=this.m_gamma=this.m_impulse=
0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u.x,a*this.m_impulse*this.m_u.y)};
Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetLength=function(){return this.m_length};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetLength=function(a){this.m_length=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetFrequency=function(){return this.m_frequencyHz};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetFrequency=function(a){this.m_frequencyHz=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetDampingRatio=
function(){return this.m_dampingRatio};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetDampingRatio=function(a){this.m_dampingRatio=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var g=this.m_localAnchor1.x-d.m_sweep.localCenter.x,f=this.m_localAnchor1.y-d.m_sweep.localCenter.y,c=b.col1.x*g+b.col2.x*f,f=b.col1.y*g+b.col2.y*f,g=c;b=e.m_xf.R;var l=this.m_localAnchor2.x-e.m_sweep.localCenter.x,k=this.m_localAnchor2.y-
e.m_sweep.localCenter.y,c=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;this.m_u.x=e.m_sweep.c.x+l-d.m_sweep.c.x-g;this.m_u.y=e.m_sweep.c.y+k-d.m_sweep.c.y-f;c=Math.sqrt(this.m_u.x*this.m_u.x+this.m_u.y*this.m_u.y);c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u.Multiply(1/c):this.m_u.SetZero();b=g*this.m_u.y-f*this.m_u.x;var h=l*this.m_u.y-k*this.m_u.x;b=d.m_invMass+d.m_invI*b*b+e.m_invMass+e.m_invI*h*h;this.m_mass=0!=b?1/b:0;if(0<this.m_frequencyHz){var c=c-this.m_length,h=2*Math.PI*this.m_frequencyHz,
m=this.m_mass*h*h;this.m_gamma=a.dt*(2*this.m_mass*this.m_dampingRatio*h+a.dt*m);this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0;this.m_bias=c*a.dt*m*this.m_gamma;this.m_mass=b+this.m_gamma;this.m_mass=0!=this.m_mass?1/this.m_mass:0}a.warmStarting?(this.m_impulse*=a.dtRatio,a=this.m_impulse*this.m_u.x,b=this.m_impulse*this.m_u.y,d.m_linearVelocity.x-=d.m_invMass*a,d.m_linearVelocity.y-=d.m_invMass*b,d.m_angularVelocity-=d.m_invI*(g*b-f*a),e.m_linearVelocity.x+=e.m_invMass*a,e.m_linearVelocity.y+=e.m_invMass*
b,e.m_angularVelocity+=e.m_invI*(l*b-k*a)):this.m_impulse=0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_localAnchor1.x-this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,
c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,g=-this.m_mass*(this.m_u.x*(this.m_bodyB.m_linearVelocity.x-this.m_bodyB.m_angularVelocity*e-(this.m_bodyA.m_linearVelocity.x-this.m_bodyA.m_angularVelocity*b))+this.m_u.y*(this.m_bodyB.m_linearVelocity.y+this.m_bodyB.m_angularVelocity*d-(this.m_bodyA.m_linearVelocity.y+this.m_bodyA.m_angularVelocity*a))+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=g;c=g*this.m_u.x;
g*=this.m_u.y;this.m_bodyA.m_linearVelocity.x-=this.m_bodyA.m_invMass*c;this.m_bodyA.m_linearVelocity.y-=this.m_bodyA.m_invMass*g;this.m_bodyA.m_angularVelocity-=this.m_bodyA.m_invI*(a*g-b*c);this.m_bodyB.m_linearVelocity.x+=this.m_bodyB.m_invMass*c;this.m_bodyB.m_linearVelocity.y+=this.m_bodyB.m_invMass*g;this.m_bodyB.m_angularVelocity+=this.m_bodyB.m_invI*(d*g-e*c)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolvePositionConstraints=function(a){if(0<this.m_frequencyHz)return!0;a=this.m_localAnchor1.x-
this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,g=this.m_bodyB.m_sweep.c.x+d-this.m_bodyA.m_sweep.c.x-
a,f=this.m_bodyB.m_sweep.c.y+e-this.m_bodyA.m_sweep.c.y-b,c=Math.sqrt(g*g+f*f),g=g/c,f=f/c,c=Box2D.Common.Math.b2Math.Clamp(c-this.m_length,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),l=-this.m_mass*c;this.m_u.Set(g,f);g=l*this.m_u.x;f=l*this.m_u.y;this.m_bodyA.m_sweep.c.x-=this.m_bodyA.m_invMass*g;this.m_bodyA.m_sweep.c.y-=this.m_bodyA.m_invMass*f;this.m_bodyA.m_sweep.a-=this.m_bodyA.m_invI*(a*f-b*g);this.m_bodyB.m_sweep.c.x+=this.m_bodyB.m_invMass*
g;this.m_bodyB.m_sweep.c.y+=this.m_bodyB.m_invMass*f;this.m_bodyB.m_sweep.a+=this.m_bodyB.m_invI*(d*f-e*g);this.m_bodyA.SynchronizeTransform();this.m_bodyB.SynchronizeTransform();return Math.abs(c)<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2DistanceJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_distanceJoint;this.length=
1;this.dampingRatio=this.frequencyHz=0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(d));a=d.x-c.x;c=d.y-c.y;this.length=Math.sqrt(a*a+c*c);this.dampingRatio=this.frequencyHz=0};Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2DistanceJoint(this)};
Box2D.Dynamics.Joints.b2FrictionJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_linearMass=new Box2D.Common.Math.b2Mat22;this.m_linearImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);this.m_linearMass.SetZero();this.m_angularMass=0;this.m_linearImpulse.SetZero();this.m_angularImpulse=0;this.m_maxForce=
a.maxForce;this.m_maxTorque=a.maxTorque};c2inherit(Box2D.Dynamics.Joints.b2FrictionJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return new b2Vec2(a*this.m_linearImpulse.x,
a*this.m_linearImpulse.y)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_angularImpulse};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxForce=function(a){void 0===a&&(a=0);this.m_maxForce=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxForce=function(){return this.m_maxForce};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxTorque=function(a){void 0===a&&(a=0);this.m_maxTorque=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxTorque=
function(){return this.m_maxTorque};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var g=this.m_localAnchorA.x-d.m_sweep.localCenter.x,f=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*g+b.col2.x*f,f=b.col1.y*g+b.col2.y*f,g=c;b=e.m_xf.R;var l=this.m_localAnchorB.x-e.m_sweep.localCenter.x,k=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;b=d.m_invMass;var c=
e.m_invMass,h=d.m_invI,m=e.m_invI,n=new Box2D.Common.Math.b2Mat22;n.col1.x=b+c;n.col2.x=0;n.col1.y=0;n.col2.y=b+c;n.col1.x+=h*f*f;n.col2.x+=-h*g*f;n.col1.y+=-h*g*f;n.col2.y+=h*g*g;n.col1.x+=m*k*k;n.col2.x+=-m*l*k;n.col1.y+=-m*l*k;n.col2.y+=m*l*l;n.GetInverse(this.m_linearMass);this.m_angularMass=h+m;0<this.m_angularMass&&(this.m_angularMass=1/this.m_angularMass);a.warmStarting?(this.m_linearImpulse.x*=a.dtRatio,this.m_linearImpulse.y*=a.dtRatio,this.m_angularImpulse*=a.dtRatio,a=this.m_linearImpulse,
d.m_linearVelocity.x-=b*a.x,d.m_linearVelocity.y-=b*a.y,d.m_angularVelocity-=h*(g*a.y-f*a.x+this.m_angularImpulse),e.m_linearVelocity.x+=c*a.x,e.m_linearVelocity.y+=c*a.y,e.m_angularVelocity+=m*(l*a.y-k*a.x+this.m_angularImpulse)):(this.m_linearImpulse.SetZero(),this.m_angularImpulse=0)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB,g=d.m_linearVelocity,f=d.m_angularVelocity,l=e.m_linearVelocity,k=e.m_angularVelocity,h=
d.m_invMass,m=e.m_invMass,n=d.m_invI,p=e.m_invI;b=d.m_xf.R;var q=this.m_localAnchorA.x-d.m_sweep.localCenter.x,r=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*q+b.col2.x*r,r=b.col1.y*q+b.col2.y*r,q=c;b=e.m_xf.R;var t=this.m_localAnchorB.x-e.m_sweep.localCenter.x,s=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*t+b.col2.x*s,s=b.col1.y*t+b.col2.y*s,t=c;b=0;var c=-this.m_angularMass*(k-f),u=this.m_angularImpulse;b=a.dt*this.m_maxTorque;this.m_angularImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_angularImpulse+
c,-b,b);c=this.m_angularImpulse-u;f-=n*c;k+=p*c;b=Box2D.Common.Math.b2Math.MulMV(this.m_linearMass,Box2D.Common.Math.b2Vec2.Get(-(l.x-k*s-g.x+f*r),-(l.y+k*t-g.y-f*q)));c=this.m_linearImpulse.Copy();this.m_linearImpulse.Add(b);b=a.dt*this.m_maxForce;this.m_linearImpulse.LengthSquared()>b*b&&(this.m_linearImpulse.Normalize(),this.m_linearImpulse.Multiply(b));b=Box2D.Common.Math.b2Math.SubtractVV(this.m_linearImpulse,c);g.x-=h*b.x;g.y-=h*b.y;f-=n*(q*b.y-r*b.x);l.x+=m*b.x;l.y+=m*b.y;k+=p*(t*b.y-s*b.x);
d.m_angularVelocity=f;e.m_angularVelocity=k};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolvePositionConstraints=function(a){return!0};Box2D.Dynamics.Joints.b2FrictionJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_frictionJoint;this.maxTorque=this.maxForce=0};c2inherit(Box2D.Dynamics.Joints.b2FrictionJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c))};Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2FrictionJoint(this)};Box2D.Dynamics.Joints.b2GearJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_J=new Box2D.Dynamics.Joints.b2Jacobian;var b=a.joint1.m_type,c=a.joint2.m_type;this.m_prismatic2=this.m_revolute2=this.m_prismatic1=this.m_revolute1=null;var d=0,e=0;this.m_ground1=a.joint1.GetBodyA();this.m_bodyA=a.joint1.GetBodyB();b==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute1=a.joint1,this.m_groundAnchor1.SetV(this.m_revolute1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_revolute1.m_localAnchor2),
d=this.m_revolute1.GetJointAngle()):(this.m_prismatic1=a.joint1,this.m_groundAnchor1.SetV(this.m_prismatic1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_prismatic1.m_localAnchor2),d=this.m_prismatic1.GetJointTranslation());this.m_ground2=a.joint2.GetBodyA();this.m_bodyB=a.joint2.GetBodyB();c==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute2=a.joint2,this.m_groundAnchor2.SetV(this.m_revolute2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_revolute2.m_localAnchor2),e=this.m_revolute2.GetJointAngle()):
(this.m_prismatic2=a.joint2,this.m_groundAnchor2.SetV(this.m_prismatic2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_prismatic2.m_localAnchor2),e=this.m_prismatic2.GetJointTranslation());this.m_ratio=a.ratio;this.m_constant=d+this.m_ratio*e;this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2GearJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorB=
function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_J.linearB.x,a*this.m_impulse*this.m_J.linearB.y)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);var b=this.m_bodyB.m_xf.R,c=this.m_localAnchor1.x-this.m_bodyB.m_sweep.localCenter.x,d=this.m_localAnchor1.y-this.m_bodyB.m_sweep.localCenter.y,
e=b.col1.x*c+b.col2.x*d,d=b.col1.y*c+b.col2.y*d;return a*(this.m_impulse*this.m_J.angularB-e*this.m_impulse*this.m_J.linearB.y+d*this.m_impulse*this.m_J.linearB.x)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2GearJoint.prototype.SetRatio=function(a){void 0===a&&(a=0);this.m_ratio=a};Box2D.Dynamics.Joints.b2GearJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_ground1,c=this.m_ground2,d=this.m_bodyA,e=this.m_bodyB,g=0,
f=0,l=0,k=0,h=l=0,m=0;this.m_J.SetZero();this.m_revolute1?(this.m_J.angularA=-1,m+=d.m_invI):(b=b.m_xf.R,f=this.m_prismatic1.m_localXAxis1,g=b.col1.x*f.x+b.col2.x*f.y,f=b.col1.y*f.x+b.col2.y*f.y,b=d.m_xf.R,l=this.m_localAnchor1.x-d.m_sweep.localCenter.x,k=this.m_localAnchor1.y-d.m_sweep.localCenter.y,h=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=h*f-k*g,this.m_J.linearA.Set(-g,-f),this.m_J.angularA=-l,m+=d.m_invMass+d.m_invI*l*l);this.m_revolute2?(this.m_J.angularB=-this.m_ratio,m+=this.m_ratio*
this.m_ratio*e.m_invI):(b=c.m_xf.R,f=this.m_prismatic2.m_localXAxis1,g=b.col1.x*f.x+b.col2.x*f.y,f=b.col1.y*f.x+b.col2.y*f.y,b=e.m_xf.R,l=this.m_localAnchor2.x-e.m_sweep.localCenter.x,k=this.m_localAnchor2.y-e.m_sweep.localCenter.y,h=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=h*f-k*g,this.m_J.linearB.Set(-this.m_ratio*g,-this.m_ratio*f),this.m_J.angularB=-this.m_ratio*l,m+=this.m_ratio*this.m_ratio*(e.m_invMass+e.m_invI*l*l));this.m_mass=0<m?1/m:0;a.warmStarting?(d.m_linearVelocity.x+=d.m_invMass*
this.m_impulse*this.m_J.linearA.x,d.m_linearVelocity.y+=d.m_invMass*this.m_impulse*this.m_J.linearA.y,d.m_angularVelocity+=d.m_invI*this.m_impulse*this.m_J.angularA,e.m_linearVelocity.x+=e.m_invMass*this.m_impulse*this.m_J.linearB.x,e.m_linearVelocity.y+=e.m_invMass*this.m_impulse*this.m_J.linearB.y,e.m_angularVelocity+=e.m_invI*this.m_impulse*this.m_J.angularB):this.m_impulse=0};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=this.m_J.Compute(a.m_linearVelocity,
a.m_angularVelocity,b.m_linearVelocity,b.m_angularVelocity),c=-this.m_mass*c;this.m_impulse+=c;a.m_linearVelocity.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_linearVelocity.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_angularVelocity+=a.m_invI*c*this.m_J.angularA;b.m_linearVelocity.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_linearVelocity.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_angularVelocity+=b.m_invI*c*this.m_J.angularB};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;
var b=this.m_bodyB,c=0,d=0,c=this.m_revolute1?this.m_revolute1.GetJointAngle():this.m_prismatic1.GetJointTranslation(),d=this.m_revolute2?this.m_revolute2.GetJointAngle():this.m_prismatic2.GetJointTranslation(),c=-this.m_mass*(this.m_constant-(c+this.m_ratio*d));a.m_sweep.c.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_sweep.c.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_sweep.a+=a.m_invI*c*this.m_J.angularA;b.m_sweep.c.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_sweep.c.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_sweep.a+=
b.m_invI*c*this.m_J.angularB;a.SynchronizeTransform();b.SynchronizeTransform();return 0<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2GearJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.type=Box2D.Dynamics.Joints.b2Joint.e_gearJoint;this.joint2=this.joint1=null;this.ratio=1};c2inherit(Box2D.Dynamics.Joints.b2GearJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2GearJointDef.prototype.Initialize=function(a,b,c){this.joint1=a;this.bodyA=a.GetBodyA();
this.joint2=b;this.bodyB=b.GetBodyA();this.ratio=c};Box2D.Dynamics.Joints.b2GearJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2GearJoint(this)};Box2D.Dynamics.Joints.b2Jacobian=function(){this.linearA=Box2D.Common.Math.b2Vec2.Get(0,0);this.linearB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Joints.b2Jacobian.prototype.SetZero=function(){this.linearA.SetZero();this.angularA=0;this.linearB.SetZero();this.angularB=0};Box2D.Dynamics.Joints.b2Jacobian.prototype.Set=function(a,
b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);this.linearA.SetV(a);this.angularA=b;this.linearB.SetV(c);this.angularB=d};Box2D.Dynamics.Joints.b2Jacobian.prototype.Compute=function(a,b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);return this.linearA.x*a.x+this.linearA.y*a.y+this.angularA*b+(this.linearB.x*c.x+this.linearB.y*c.y)+this.angularB*d};Box2D.Dynamics.Joints.b2LineJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat22;this.m_impulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;this.m_localYAxis1.y=
this.m_localXAxis1.x;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2LineJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x),a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.y))};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionTorque=
function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointSpeed=function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,g=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=g;c=b.m_xf.R;var f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,g=c.col1.x*f+c.col2.x*l,l=c.col1.y*f+c.col2.y*l,f=g;c=b.m_sweep.c.x+f-(a.m_sweep.c.x+d);var g=b.m_sweep.c.y+l-(a.m_sweep.c.y+e),k=a.GetWorldVector(this.m_localXAxis1),h=a.m_linearVelocity,m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*k.y+g*a*k.x+(k.x*(m.x+-b*l-h.x- -a*e)+k.y*(m.y+b*
f-h.y-a*d))};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetUpperLimit=function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetLimits=
function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);
this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMaxMotorForce=function(){return this.m_maxMotorForce};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorForce=function(){return this.m_motorImpulse};
Box2D.Dynamics.Joints.b2LineJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var g=b.GetTransform();c.GetTransform();d=b.m_xf.R;var f=this.m_localAnchor1.x-this.m_localCenterA.x,l=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*f+d.col2.x*l,l=d.col1.y*f+d.col2.y*l,f=e;d=c.m_xf.R;var k=this.m_localAnchor2.x-this.m_localCenterB.x,h=this.m_localAnchor2.y-this.m_localCenterB.y,
e=d.col1.x*k+d.col2.x*h,h=d.col1.y*k+d.col2.y*h,k=e;d=c.m_sweep.c.x+k-b.m_sweep.c.x-f;e=c.m_sweep.c.y+h-b.m_sweep.c.y-l;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(g.R,this.m_localXAxis1));this.m_a1=(d+f)*this.m_axis.y-(e+l)*this.m_axis.x;this.m_a2=k*this.m_axis.y-h*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass=
this.m_motorMass>Number.MIN_VALUE?1/this.m_motorMass:0;this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(g.R,this.m_localYAxis1));this.m_s1=(d+f)*this.m_perp.y-(e+l)*this.m_perp.x;this.m_s2=k*this.m_perp.y-h*this.m_perp.x;g=this.m_invMassA;f=this.m_invMassB;l=this.m_invIA;k=this.m_invIB;this.m_K.col1.x=g+f+l*this.m_s1*this.m_s1+k*this.m_s2*this.m_s2;this.m_K.col1.y=l*this.m_s1*this.m_a1+k*this.m_s2*this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=g+f+l*this.m_a1*this.m_a1+k*this.m_a2*this.m_a2;
this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.y=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.y=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.y=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+
this.m_impulse.y)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+(this.m_motorImpulse+this.m_impulse.y)*this.m_a1,g=this.m_impulse.x*this.m_s2+(this.m_motorImpulse+this.m_impulse.y)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*g):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolveVelocityConstraints=
function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,g=c.m_linearVelocity,f=c.m_angularVelocity,l=0,k=0,h=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(g.x-d.x)+this.m_axis.y*(g.y-d.y)+this.m_a2*f-this.m_a1*e)),l=this.m_motorImpulse,k=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-k,k),m=this.m_motorImpulse-l,l=
m*this.m_axis.x,k=m*this.m_axis.y,h=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*l,d.y-=this.m_invMassA*k,e-=this.m_invIA*h,g.x+=this.m_invMassB*l,g.y+=this.m_invMassB*k,f+=this.m_invIB*m);k=this.m_perp.x*(g.x-d.x)+this.m_perp.y*(g.y-d.y)+this.m_s2*f-this.m_s1*e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(h=this.m_axis.x*(g.x-d.x)+this.m_axis.y*(g.y-d.y)+this.m_a2*f-this.m_a1*e,l=this.m_impulse.Copy(),a=this.m_K.Solve(Box2D.Common.Math.b2Vec2.Get(0,0),-k,
-h),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.y=Math.max(this.m_impulse.y,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.y=Math.min(this.m_impulse.y,0)),k=-k-(this.m_impulse.y-l.y)*this.m_K.col2.x,h=0,h=0!=this.m_K.col1.x?k/this.m_K.col1.x+l.x:l.x,this.m_impulse.x=h,a.x=this.m_impulse.x-l.x,a.y=this.m_impulse.y-l.y,l=a.x*this.m_perp.x+a.y*this.m_axis.x,k=a.x*this.m_perp.y+a.y*this.m_axis.y,h=a.x*this.m_s1+
a.y*this.m_a1,m=a.x*this.m_s2+a.y*this.m_a2):(a=0,a=0!=this.m_K.col1.x?-k/this.m_K.col1.x:0,this.m_impulse.x+=a,l=a*this.m_perp.x,k=a*this.m_perp.y,h=a*this.m_s1,m=a*this.m_s2);d.x-=this.m_invMassA*l;d.y-=this.m_invMassA*k;e-=this.m_invIA*h;g.x+=this.m_invMassB*l;g.y+=this.m_invMassB*k;f+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(g);c.m_angularVelocity=f};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,g=b.m_sweep.a,f,l=0,k=0,h=0,m=0,n=f=0,p=0,k=!1,q=0,r=Box2D.Common.Math.b2Mat22.FromAngle(d),h=Box2D.Common.Math.b2Mat22.FromAngle(g);f=r;var p=this.m_localAnchor1.x-this.m_localCenterA.x,t=this.m_localAnchor1.y-this.m_localCenterA.y,l=f.col1.x*p+f.col2.x*t,t=f.col1.y*p+f.col2.y*t,p=l;f=h;h=this.m_localAnchor2.x-this.m_localCenterB.x;m=this.m_localAnchor2.y-this.m_localCenterB.y;l=f.col1.x*h+f.col2.x*m;m=f.col1.y*h+f.col2.y*m;h=l;f=e.x+h-c.x-p;
l=e.y+m-c.y-t;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(r,this.m_localXAxis1);this.m_a1=(f+p)*this.m_axis.y-(l+t)*this.m_axis.x;this.m_a2=h*this.m_axis.y-m*this.m_axis.x;var s=this.m_axis.x*f+this.m_axis.y*l;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(q=Box2D.Common.Math.b2Math.Clamp(s,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=Math.abs(s),k=!0):s<=this.m_lowerTranslation?
(q=Box2D.Common.Math.b2Math.Clamp(s-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),n=this.m_lowerTranslation-s,k=!0):s>=this.m_upperTranslation&&(q=Box2D.Common.Math.b2Math.Clamp(s-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=s-this.m_upperTranslation,k=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(r,this.m_localYAxis1);this.m_s1=(f+p)*this.m_perp.y-(l+t)*this.m_perp.x;
this.m_s2=h*this.m_perp.y-m*this.m_perp.x;r=Box2D.Common.Math.b2Vec2.Get(0,0);t=this.m_perp.x*f+this.m_perp.y*l;n=Math.max(n,Math.abs(t));p=0;k?(k=this.m_invMassA,h=this.m_invMassB,m=this.m_invIA,f=this.m_invIB,this.m_K.col1.x=k+h+m*this.m_s1*this.m_s1+f*this.m_s2*this.m_s2,this.m_K.col1.y=m*this.m_s1*this.m_a1+f*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=k+h+m*this.m_a1*this.m_a1+f*this.m_a2*this.m_a2,this.m_K.Solve(r,-t,-q)):(k=this.m_invMassA,h=this.m_invMassB,m=this.m_invIA,
f=this.m_invIB,q=k+h+m*this.m_s1*this.m_s1+f*this.m_s2*this.m_s2,r.x=0!=q?-t/q:0,r.y=0);q=r.x*this.m_perp.x+r.y*this.m_axis.x;k=r.x*this.m_perp.y+r.y*this.m_axis.y;t=r.x*this.m_s1+r.y*this.m_a1;r=r.x*this.m_s2+r.y*this.m_a2;c.x-=this.m_invMassA*q;c.y-=this.m_invMassA*k;d-=this.m_invIA*t;e.x+=this.m_invMassB*q;e.y+=this.m_invMassB*k;g+=this.m_invIB*r;a.m_sweep.a=d;b.m_sweep.a=g;a.SynchronizeTransform();b.SynchronizeTransform();return n<=Box2D.Common.b2Settings.b2_linearSlop&&p<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2LineJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_lineJoint;this.localAxisA.Set(1,0);this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2LineJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2LineJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.localAxisA=this.bodyA.GetLocalVector(d)};Box2D.Dynamics.Joints.b2LineJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2LineJoint(this)};Box2D.Dynamics.Joints.b2PrismaticJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat33;this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;
this.m_localYAxis1.y=this.m_localXAxis1.x;this.m_refAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJoint,
Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x),
a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointSpeed=
function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-a.m_sweep.localCenter.y,g=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=g;c=b.m_xf.R;var f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,g=c.col1.x*f+c.col2.x*l,l=c.col1.y*f+c.col2.y*l,f=g;c=b.m_sweep.c.x+f-(a.m_sweep.c.x+d);var g=b.m_sweep.c.y+l-(a.m_sweep.c.y+e),k=a.GetWorldVector(this.m_localXAxis1),h=a.m_linearVelocity,
m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*k.y+g*a*k.x+(k.x*(m.x+-b*l-h.x- -a*e)+k.y*(m.y+b*f-h.y-a*d))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetUpperLimit=
function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=
a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorForce=
function(){return this.m_motorImpulse};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var g=b.GetTransform();c.GetTransform();d=b.m_xf.R;var f=this.m_localAnchor1.x-this.m_localCenterA.x,l=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*f+d.col2.x*l,l=d.col1.y*f+d.col2.y*l,f=e;d=c.m_xf.R;var k=this.m_localAnchor2.x-this.m_localCenterB.x,
h=this.m_localAnchor2.y-this.m_localCenterB.y,e=d.col1.x*k+d.col2.x*h,h=d.col1.y*k+d.col2.y*h,k=e;d=c.m_sweep.c.x+k-b.m_sweep.c.x-f;e=c.m_sweep.c.y+h-b.m_sweep.c.y-l;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(g.R,this.m_localXAxis1));this.m_a1=(d+f)*this.m_axis.y-(e+l)*this.m_axis.x;this.m_a2=k*this.m_axis.y-h*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*
this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass>Number.MIN_VALUE&&(this.m_motorMass=1/this.m_motorMass);this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(g.R,this.m_localYAxis1));this.m_s1=(d+f)*this.m_perp.y-(e+l)*this.m_perp.x;this.m_s2=k*this.m_perp.y-h*this.m_perp.x;g=this.m_invMassA;f=this.m_invMassB;l=this.m_invIA;k=this.m_invIB;this.m_K.col1.x=g+f+l*this.m_s1*this.m_s1+k*this.m_s2*this.m_s2;this.m_K.col1.y=l*this.m_s1+k*this.m_s2;this.m_K.col1.z=l*this.m_s1*this.m_a1+k*this.m_s2*
this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=l+k;this.m_K.col2.z=l*this.m_a1+k*this.m_a2;this.m_K.col3.x=this.m_K.col1.z;this.m_K.col3.y=this.m_K.col2.z;this.m_K.col3.z=g+f+l*this.m_a1*this.m_a1+k*this.m_a2*this.m_a2;this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&
(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.z=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.z=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,
this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,g=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,
b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*g):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolveVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,g=c.m_linearVelocity,f=c.m_angularVelocity,l=0,k=0,h=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&
(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(g.x-d.x)+this.m_axis.y*(g.y-d.y)+this.m_a2*f-this.m_a1*e)),l=this.m_motorImpulse,a=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-a,a),m=this.m_motorImpulse-l,l=m*this.m_axis.x,k=m*this.m_axis.y,h=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*l,d.y-=this.m_invMassA*k,e-=this.m_invIA*h,g.x+=this.m_invMassB*l,g.y+=this.m_invMassB*k,f+=this.m_invIB*m);h=this.m_perp.x*(g.x-d.x)+this.m_perp.y*(g.y-
d.y)+this.m_s2*f-this.m_s1*e;k=f-e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(a=this.m_axis.x*(g.x-d.x)+this.m_axis.y*(g.y-d.y)+this.m_a2*f-this.m_a1*e,l=this.m_impulse.Copy(),a=this.m_K.Solve33(new Box2D.Common.Math.b2Vec3(0,0,0),-h,-k,-a),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.z=Math.max(this.m_impulse.z,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=Math.min(this.m_impulse.z,
0)),h=-h-(this.m_impulse.z-l.z)*this.m_K.col3.x,k=-k-(this.m_impulse.z-l.z)*this.m_K.col3.y,k=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),h,k),k.x+=l.x,k.y+=l.y,this.m_impulse.x=k.x,this.m_impulse.y=k.y,a.x=this.m_impulse.x-l.x,a.y=this.m_impulse.y-l.y,a.z=this.m_impulse.z-l.z,l=a.x*this.m_perp.x+a.z*this.m_axis.x,k=a.x*this.m_perp.y+a.z*this.m_axis.y,h=a.x*this.m_s1+a.y+a.z*this.m_a1,m=a.x*this.m_s2+a.y+a.z*this.m_a2):(a=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-h,-k),this.m_impulse.x+=
a.x,this.m_impulse.y+=a.y,l=a.x*this.m_perp.x,k=a.x*this.m_perp.y,h=a.x*this.m_s1+a.y,m=a.x*this.m_s2+a.y);d.x-=this.m_invMassA*l;d.y-=this.m_invMassA*k;e-=this.m_invIA*h;g.x+=this.m_invMassB*l;g.y+=this.m_invMassB*k;f+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(g);c.m_angularVelocity=f};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,g=b.m_sweep.a,
f,l=0,k=0,h=0,m=l=f=0,n=0,k=!1,p=0,q=Box2D.Common.Math.b2Mat22.FromAngle(d),r=Box2D.Common.Math.b2Mat22.FromAngle(g);f=q;var n=this.m_localAnchor1.x-this.m_localCenterA.x,t=this.m_localAnchor1.y-this.m_localCenterA.y,l=f.col1.x*n+f.col2.x*t,t=f.col1.y*n+f.col2.y*t,n=l;f=r;r=this.m_localAnchor2.x-this.m_localCenterB.x;h=this.m_localAnchor2.y-this.m_localCenterB.y;l=f.col1.x*r+f.col2.x*h;h=f.col1.y*r+f.col2.y*h;r=l;f=e.x+r-c.x-n;l=e.y+h-c.y-t;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(q,
this.m_localXAxis1);this.m_a1=(f+n)*this.m_axis.y-(l+t)*this.m_axis.x;this.m_a2=r*this.m_axis.y-h*this.m_axis.x;var s=this.m_axis.x*f+this.m_axis.y*l;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(p=Box2D.Common.Math.b2Math.Clamp(s,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=Math.abs(s),k=!0):s<=this.m_lowerTranslation?(p=Box2D.Common.Math.b2Math.Clamp(s-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),m=this.m_lowerTranslation-s,k=!0):s>=this.m_upperTranslation&&(p=Box2D.Common.Math.b2Math.Clamp(s-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=s-this.m_upperTranslation,k=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(q,this.m_localYAxis1);this.m_s1=(f+n)*this.m_perp.y-(l+t)*this.m_perp.x;this.m_s2=r*this.m_perp.y-h*this.m_perp.x;q=new Box2D.Common.Math.b2Vec3(0,0,0);t=this.m_perp.x*
f+this.m_perp.y*l;r=g-d-this.m_refAngle;m=Math.max(m,Math.abs(t));n=Math.abs(r);k?(k=this.m_invMassA,h=this.m_invMassB,f=this.m_invIA,l=this.m_invIB,this.m_K.col1.x=k+h+f*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2,this.m_K.col1.y=f*this.m_s1+l*this.m_s2,this.m_K.col1.z=f*this.m_s1*this.m_a1+l*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=f+l,this.m_K.col2.z=f*this.m_a1+l*this.m_a2,this.m_K.col3.x=this.m_K.col1.z,this.m_K.col3.y=this.m_K.col2.z,this.m_K.col3.z=k+h+f*this.m_a1*
this.m_a1+l*this.m_a2*this.m_a2,this.m_K.Solve33(q,-t,-r,-p)):(k=this.m_invMassA,h=this.m_invMassB,f=this.m_invIA,l=this.m_invIB,p=f*this.m_s1+l*this.m_s2,s=f+l,this.m_K.col1.Set(k+h+f*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2,p,0),this.m_K.col2.Set(p,s,0),p=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-t,-r),q.x=p.x,q.y=p.y,q.z=0);p=q.x*this.m_perp.x+q.z*this.m_axis.x;k=q.x*this.m_perp.y+q.z*this.m_axis.y;t=q.x*this.m_s1+q.y+q.z*this.m_a1;q=q.x*this.m_s2+q.y+q.z*this.m_a2;c.x-=this.m_invMassA*
p;c.y-=this.m_invMassA*k;d-=this.m_invIA*t;e.x+=this.m_invMassB*p;e.y+=this.m_invMassB*k;g+=this.m_invIB*q;a.m_sweep.a=d;b.m_sweep.a=g;a.SynchronizeTransform();b.SynchronizeTransform();return m<=Box2D.Common.b2Settings.b2_linearSlop&&n<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2PrismaticJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,
0);this.type=Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint;this.localAxisA.Set(1,0);this.referenceAngle=0;this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);
this.localAxisA=this.bodyA.GetLocalVector(d);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PrismaticJoint(this)};Box2D.Dynamics.Joints.b2PulleyJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_ground=this.m_bodyA.m_world.m_groundBody;this.m_groundAnchor1.x=a.groundAnchorA.x-this.m_ground.m_xf.position.x;this.m_groundAnchor1.y=a.groundAnchorA.y-this.m_ground.m_xf.position.y;this.m_groundAnchor2.x=a.groundAnchorB.x-this.m_ground.m_xf.position.x;this.m_groundAnchor2.y=a.groundAnchorB.y-this.m_ground.m_xf.position.y;this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);
this.m_ratio=a.ratio;this.m_constant=a.lengthA+this.m_ratio*a.lengthB;this.m_maxLength1=Math.min(a.maxLengthA,this.m_constant-this.m_ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength);this.m_maxLength2=Math.min(a.maxLengthB,(this.m_constant-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.m_ratio);this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u2.x,a*this.m_impulse*this.m_u2.y)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorA=
function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor1);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorB=function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor2);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength1=function(){var a=this.m_bodyA.GetWorldPoint(this.m_localAnchor1),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor1.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y);return Math.sqrt(b*
b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength2=function(){var a=this.m_bodyB.GetWorldPoint(this.m_localAnchor2),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor2.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor2.y);return Math.sqrt(b*b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d;d=b.m_xf.R;var e=
this.m_localAnchor1.x-b.m_sweep.localCenter.x,g=this.m_localAnchor1.y-b.m_sweep.localCenter.y,f=d.col1.x*e+d.col2.x*g,g=d.col1.y*e+d.col2.y*g,e=f;d=c.m_xf.R;var l=this.m_localAnchor2.x-c.m_sweep.localCenter.x,k=this.m_localAnchor2.y-c.m_sweep.localCenter.y,f=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=f;d=c.m_sweep.c.x+l;var f=c.m_sweep.c.y+k,h=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,m=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y;this.m_u1.Set(b.m_sweep.c.x+e-(this.m_ground.m_xf.position.x+
this.m_groundAnchor1.x),b.m_sweep.c.y+g-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y));this.m_u2.Set(d-h,f-m);d=this.m_u1.Length();f=this.m_u2.Length();d>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/d):this.m_u1.SetZero();f>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/f):this.m_u2.SetZero();0<this.m_constant-d-this.m_ratio*f?(this.m_state=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse=0):this.m_state=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d<
this.m_maxLength1?(this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse1=0):this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;f<this.m_maxLength2?(this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse2=0):this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d=e*this.m_u1.y-g*this.m_u1.x;f=l*this.m_u2.y-k*this.m_u2.x;this.m_limitMass1=b.m_invMass+b.m_invI*d*d;this.m_limitMass2=c.m_invMass+c.m_invI*f*f;this.m_pulleyMass=
this.m_limitMass1+this.m_ratio*this.m_ratio*this.m_limitMass2;this.m_limitMass1=1/this.m_limitMass1;this.m_limitMass2=1/this.m_limitMass2;this.m_pulleyMass=1/this.m_pulleyMass;a.warmStarting?(this.m_impulse*=a.dtRatio,this.m_limitImpulse1*=a.dtRatio,this.m_limitImpulse2*=a.dtRatio,a=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.x,d=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.y,f=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*this.m_u2.x,h=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*
this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*a,b.m_linearVelocity.y+=b.m_invMass*d,b.m_angularVelocity+=b.m_invI*(e*d-g*a),c.m_linearVelocity.x+=c.m_invMass*f,c.m_linearVelocity.y+=c.m_invMass*h,c.m_angularVelocity+=c.m_invI*(l*h-k*f)):this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,g=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=g;c=b.m_xf.R;var f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,g=c.col1.x*f+c.col2.x*l,l=c.col1.y*f+c.col2.y*l,f=g,k=g=c=0,h=0;c=h=c=h=k=g=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,g=a.m_linearVelocity.y+a.m_angularVelocity*d,k=b.m_linearVelocity.x+-b.m_angularVelocity*l,h=b.m_linearVelocity.y+b.m_angularVelocity*
f,c=-(this.m_u1.x*c+this.m_u1.y*g)-this.m_ratio*(this.m_u2.x*k+this.m_u2.y*h),h=this.m_pulleyMass*-c,c=this.m_impulse,this.m_impulse=Math.max(0,this.m_impulse+h),h=this.m_impulse-c,c=-h*this.m_u1.x,g=-h*this.m_u1.y,k=-this.m_ratio*h*this.m_u2.x,h=-this.m_ratio*h*this.m_u2.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*g,a.m_angularVelocity+=a.m_invI*(d*g-e*c),b.m_linearVelocity.x+=b.m_invMass*k,b.m_linearVelocity.y+=b.m_invMass*h,b.m_angularVelocity+=b.m_invI*(f*h-l*k));this.m_limitState1==
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,g=a.m_linearVelocity.y+a.m_angularVelocity*d,c=-(this.m_u1.x*c+this.m_u1.y*g),h=-this.m_limitMass1*c,c=this.m_limitImpulse1,this.m_limitImpulse1=Math.max(0,this.m_limitImpulse1+h),h=this.m_limitImpulse1-c,c=-h*this.m_u1.x,g=-h*this.m_u1.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*g,a.m_angularVelocity+=a.m_invI*(d*g-e*c));this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&
(k=b.m_linearVelocity.x+-b.m_angularVelocity*l,h=b.m_linearVelocity.y+b.m_angularVelocity*f,c=-(this.m_u2.x*k+this.m_u2.y*h),h=-this.m_limitMass2*c,c=this.m_limitImpulse2,this.m_limitImpulse2=Math.max(0,this.m_limitImpulse2+h),h=this.m_limitImpulse2-c,k=-h*this.m_u2.x,h=-h*this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*k,b.m_linearVelocity.y+=b.m_invMass*h,b.m_angularVelocity+=b.m_invI*(f*h-l*k))};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c,d=this.m_ground.m_xf.position.x+this.m_groundAnchor1.x,e=this.m_ground.m_xf.position.y+this.m_groundAnchor1.y,g=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,f=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y,l=0,k=0,h=0,m=0,n=c=0,p=0,q=0,r=n=q=c=n=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,l=this.m_localAnchor1.x-a.m_sweep.localCenter.x,k=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*l+c.col2.x*k,k=c.col1.y*l+c.col2.y*k,l=n,c=
b.m_xf.R,h=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*h+c.col2.x*m,m=c.col1.y*h+c.col2.y*m,h=n,c=a.m_sweep.c.x+l,n=a.m_sweep.c.y+k,p=b.m_sweep.c.x+h,q=b.m_sweep.c.y+m,this.m_u1.Set(c-d,n-e),this.m_u2.Set(p-g,q-f),c=this.m_u1.Length(),n=this.m_u2.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/c):this.m_u1.SetZero(),n>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/n):this.m_u2.SetZero(),c=this.m_constant-
c-this.m_ratio*n,r=Math.max(r,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),q=-this.m_pulleyMass*c,c=-q*this.m_u1.x,n=-q*this.m_u1.y,p=-this.m_ratio*q*this.m_u2.x,q=-this.m_ratio*q*this.m_u2.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(l*n-k*c),b.m_sweep.c.x+=b.m_invMass*p,b.m_sweep.c.y+=b.m_invMass*q,b.m_sweep.a+=b.m_invI*(h*q-m*p),a.SynchronizeTransform(),b.SynchronizeTransform());
this.m_limitState1==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,l=this.m_localAnchor1.x-a.m_sweep.localCenter.x,k=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*l+c.col2.x*k,k=c.col1.y*l+c.col2.y*k,l=n,c=a.m_sweep.c.x+l,n=a.m_sweep.c.y+k,this.m_u1.Set(c-d,n-e),c=this.m_u1.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u1.x*=1/c,this.m_u1.y*=1/c):this.m_u1.SetZero(),c=this.m_maxLength1-c,r=Math.max(r,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),q=-this.m_limitMass1*c,c=-q*this.m_u1.x,n=-q*this.m_u1.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(l*n-k*c),a.SynchronizeTransform());this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=b.m_xf.R,h=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*h+c.col2.x*m,m=c.col1.y*h+c.col2.y*m,h=n,p=b.m_sweep.c.x+h,q=b.m_sweep.c.y+m,this.m_u2.Set(p-
g,q-f),n=this.m_u2.Length(),n>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u2.x*=1/n,this.m_u2.y*=1/n):this.m_u2.SetZero(),c=this.m_maxLength2-n,r=Math.max(r,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),q=-this.m_limitMass2*c,p=-q*this.m_u2.x,q=-q*this.m_u2.y,b.m_sweep.c.x+=b.m_invMass*p,b.m_sweep.c.y+=b.m_invMass*q,b.m_sweep.a+=b.m_invI*(h*q-m*p),b.SynchronizeTransform());return r<Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength=1;Box2D.Dynamics.Joints.b2PulleyJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.groundAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.groundAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint;this.groundAnchorA.Set(-1,1);this.groundAnchorB.Set(1,1);this.localAnchorA.Set(-1,0);this.localAnchorB.Set(1,
0);this.maxLengthB=this.lengthB=this.maxLengthA=this.lengthA=0;this.ratio=1;this.collideConnected=!0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Initialize=function(a,b,c,d,e,g,f){void 0===f&&(f=0);this.bodyA=a;this.bodyB=b;this.groundAnchorA.SetV(c);this.groundAnchorB.SetV(d);this.localAnchorA=this.bodyA.GetLocalPoint(e);this.localAnchorB=this.bodyB.GetLocalPoint(g);a=e.x-c.x;c=e.y-c.y;this.lengthA=Math.sqrt(a*
a+c*c);c=g.x-d.x;d=g.y-d.y;this.lengthB=Math.sqrt(c*c+d*d);this.ratio=f;f=this.lengthA+this.ratio*this.lengthB;this.maxLengthA=f-this.ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength;this.maxLengthB=(f-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.ratio};Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PulleyJoint(this)};Box2D.Dynamics.Joints.b2RevoluteJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.K=
new Box2D.Common.Math.b2Mat22;this.K1=new Box2D.Common.Math.b2Mat22;this.K2=new Box2D.Common.Math.b2Mat22;this.K3=new Box2D.Common.Math.b2Mat22;this.impulse3=new Box2D.Common.Math.b2Vec3(0,0,0);this.impulse2=Box2D.Common.Math.b2Vec2.Get(0,0);this.reduced=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchor1.SetV(a.localAnchorA);
this.m_localAnchor2.SetV(a.localAnchorB);this.m_referenceAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=0;this.m_lowerAngle=a.lowerAngle;this.m_upperAngle=a.upperAngle;this.m_maxMotorTorque=a.maxMotorTorque;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointAngle=
function(){return this.m_bodyB.m_sweep.a-this.m_bodyA.m_sweep.a-this.m_referenceAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointSpeed=function(){return this.m_bodyB.m_angularVelocity-this.m_bodyA.m_angularVelocity};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableLimit=function(a){this.m_enableLimit=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetLowerLimit=function(){return this.m_lowerAngle};
Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetUpperLimit=function(){return this.m_upperAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_lowerAngle=a;this.m_upperAngle=b};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsMotorEnabled=function(){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);return this.m_enableMotor};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableMotor=function(a){this.m_enableMotor=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMotorSpeed=
function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMaxMotorTorque=function(a){void 0===a&&(a=0);this.m_maxMotorTorque=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorTorque=function(){return this.m_maxMotorTorque};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.InitVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d,e=0;d=b.m_xf.R;var g=this.m_localAnchor1.x-b.m_sweep.localCenter.x,f=this.m_localAnchor1.y-b.m_sweep.localCenter.y,e=d.col1.x*g+d.col2.x*f,f=d.col1.y*g+d.col2.y*f,g=e;d=c.m_xf.R;var l=this.m_localAnchor2.x-c.m_sweep.localCenter.x,k=this.m_localAnchor2.y-c.m_sweep.localCenter.y,e=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=e;d=b.m_invMass;var e=c.m_invMass,h=b.m_invI,m=c.m_invI;this.m_mass.col1.x=d+e+f*f*h+k*k*m;this.m_mass.col2.x=-f*g*h-k*l*m;this.m_mass.col3.x=-f*
h-k*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=d+e+g*g*h+l*l*m;this.m_mass.col3.y=g*h+l*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=h+m;this.m_motorMass=1/(h+m);this.m_enableMotor||(this.m_motorImpulse=0);if(this.m_enableLimit){var n=c.m_sweep.a-b.m_sweep.a-this.m_referenceAngle;Math.abs(this.m_upperAngle-this.m_lowerAngle)<2*Box2D.Common.b2Settings.b2_angularSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:n<=
this.m_lowerAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit):n>=this.m_upperAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)}else this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;a.warmStarting?
(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x,n=this.m_impulse.y,b.m_linearVelocity.x-=d*a,b.m_linearVelocity.y-=d*n,b.m_angularVelocity-=h*(g*n-f*a+this.m_motorImpulse+this.m_impulse.z),c.m_linearVelocity.x+=e*a,c.m_linearVelocity.y+=e*n,c.m_angularVelocity+=m*(l*n-k*a+this.m_motorImpulse+this.m_impulse.z)):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolveVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d=0,e=d=0,g=0,f=0,l=0,k=b.m_linearVelocity,h=b.m_angularVelocity,m=c.m_linearVelocity,n=c.m_angularVelocity,p=b.m_invMass,q=c.m_invMass,r=b.m_invI,t=c.m_invI;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(e=this.m_motorMass*-(n-h-this.m_motorSpeed),g=this.m_motorImpulse,f=a.dt*this.m_maxMotorTorque,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+e,-f,f),e=this.m_motorImpulse-g,h-=r*e,n+=t*e);if(this.m_enableLimit&&
this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){a=b.m_xf.R;e=this.m_localAnchor1.x-b.m_sweep.localCenter.x;g=this.m_localAnchor1.y-b.m_sweep.localCenter.y;d=a.col1.x*e+a.col2.x*g;g=a.col1.y*e+a.col2.y*g;e=d;a=c.m_xf.R;f=this.m_localAnchor2.x-c.m_sweep.localCenter.x;l=this.m_localAnchor2.y-c.m_sweep.localCenter.y;d=a.col1.x*f+a.col2.x*l;l=a.col1.y*f+a.col2.y*l;f=d;a=m.x+-n*l-k.x- -h*g;var s=m.y+n*f-k.y-h*e;this.m_mass.Solve33(this.impulse3,-a,-s,-(n-h));this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?
this.m_impulse.Add(this.impulse3):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(d=this.m_impulse.z+this.impulse3.z,0>d&&(this.m_mass.Solve22(this.reduced,-a,-s),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(d=this.m_impulse.z+this.impulse3.z,0<d&&(this.m_mass.Solve22(this.reduced,
-a,-s),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0));k.x-=p*this.impulse3.x;k.y-=p*this.impulse3.y;h-=r*(e*this.impulse3.y-g*this.impulse3.x+this.impulse3.z);m.x+=q*this.impulse3.x;m.y+=q*this.impulse3.y;n+=t*(f*this.impulse3.y-l*this.impulse3.x+this.impulse3.z)}else a=b.m_xf.R,e=this.m_localAnchor1.x-b.m_sweep.localCenter.x,g=this.m_localAnchor1.y-b.m_sweep.localCenter.y,
d=a.col1.x*e+a.col2.x*g,g=a.col1.y*e+a.col2.y*g,e=d,a=c.m_xf.R,f=this.m_localAnchor2.x-c.m_sweep.localCenter.x,l=this.m_localAnchor2.y-c.m_sweep.localCenter.y,d=a.col1.x*f+a.col2.x*l,l=a.col1.y*f+a.col2.y*l,f=d,this.m_mass.Solve22(this.impulse2,-(m.x+-n*l-k.x- -h*g),-(m.y+n*f-k.y-h*e)),this.m_impulse.x+=this.impulse2.x,this.m_impulse.y+=this.impulse2.y,k.x-=p*this.impulse2.x,k.y-=p*this.impulse2.y,h-=r*(e*this.impulse2.y-g*this.impulse2.x),m.x+=q*this.impulse2.x,m.y+=q*this.impulse2.y,n+=t*(f*this.impulse2.y-
l*this.impulse2.x);b.m_linearVelocity.SetV(k);b.m_angularVelocity=h;c.m_linearVelocity.SetV(m);c.m_angularVelocity=n};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolvePositionConstraints=function(a){var b=0,c;a=this.m_bodyA;var d=this.m_bodyB,e=0,g=c=0,f=0,l=0;if(this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){var b=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,k=0;this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?(b=Box2D.Common.Math.b2Math.Clamp(b-
this.m_lowerAngle,-Box2D.Common.b2Settings.b2_maxAngularCorrection,Box2D.Common.b2Settings.b2_maxAngularCorrection),k=-this.m_motorMass*b,e=Math.abs(b)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(b-=this.m_lowerAngle,e=-b,b=Box2D.Common.Math.b2Math.Clamp(b+Box2D.Common.b2Settings.b2_angularSlop,-Box2D.Common.b2Settings.b2_maxAngularCorrection,0),k=-this.m_motorMass*b):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(e=b-=this.m_upperAngle,b=Box2D.Common.Math.b2Math.Clamp(b-
Box2D.Common.b2Settings.b2_angularSlop,0,Box2D.Common.b2Settings.b2_maxAngularCorrection),k=-this.m_motorMass*b);a.m_sweep.a-=a.m_invI*k;d.m_sweep.a+=d.m_invI*k;a.SynchronizeTransform();d.SynchronizeTransform()}c=a.m_xf.R;k=this.m_localAnchor1.x-a.m_sweep.localCenter.x;b=this.m_localAnchor1.y-a.m_sweep.localCenter.y;g=c.col1.x*k+c.col2.x*b;b=c.col1.y*k+c.col2.y*b;k=g;c=d.m_xf.R;var h=this.m_localAnchor2.x-d.m_sweep.localCenter.x,m=this.m_localAnchor2.y-d.m_sweep.localCenter.y,g=c.col1.x*h+c.col2.x*
m,m=c.col1.y*h+c.col2.y*m,h=g,f=d.m_sweep.c.x+h-a.m_sweep.c.x-k,l=d.m_sweep.c.y+m-a.m_sweep.c.y-b,n=f*f+l*l;c=Math.sqrt(n);var g=a.m_invMass,p=d.m_invMass,q=a.m_invI,r=d.m_invI,t=10*Box2D.Common.b2Settings.b2_linearSlop;n>t*t&&(n=1/(g+p),f=n*-f,l=n*-l,a.m_sweep.c.x-=0.5*g*f,a.m_sweep.c.y-=0.5*g*l,d.m_sweep.c.x+=0.5*p*f,d.m_sweep.c.y+=0.5*p*l,f=d.m_sweep.c.x+h-a.m_sweep.c.x-k,l=d.m_sweep.c.y+m-a.m_sweep.c.y-b);this.K1.col1.x=g+p;this.K1.col2.x=0;this.K1.col1.y=0;this.K1.col2.y=g+p;this.K2.col1.x=q*
b*b;this.K2.col2.x=-q*k*b;this.K2.col1.y=-q*k*b;this.K2.col2.y=q*k*k;this.K3.col1.x=r*m*m;this.K3.col2.x=-r*h*m;this.K3.col1.y=-r*h*m;this.K3.col2.y=r*h*h;this.K.SetM(this.K1);this.K.AddM(this.K2);this.K.AddM(this.K3);this.K.Solve(Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse,-f,-l);f=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.x;l=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.y;a.m_sweep.c.x-=a.m_invMass*f;a.m_sweep.c.y-=a.m_invMass*l;a.m_sweep.a-=a.m_invI*(k*l-b*f);d.m_sweep.c.x+=d.m_invMass*
f;d.m_sweep.c.y+=d.m_invMass*l;d.m_sweep.a+=d.m_invI*(h*l-m*f);a.SynchronizeTransform();d.SynchronizeTransform();return c<=Box2D.Common.b2Settings.b2_linearSlop&&e<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Dynamics.Joints.b2RevoluteJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint;
this.localAnchorA.SetZero();this.localAnchorB.SetZero();this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-
this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2RevoluteJoint(this)};Box2D.Dynamics.Joints.b2WeldJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);
this.m_referenceAngle=a.referenceAngle};c2inherit(Box2D.Dynamics.Joints.b2WeldJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};
Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionTorque=function(a){return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2WeldJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var g=this.m_localAnchorA.x-d.m_sweep.localCenter.x,f=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*g+b.col2.x*f,f=b.col1.y*g+b.col2.y*f,g=c;b=e.m_xf.R;var l=this.m_localAnchorB.x-e.m_sweep.localCenter.x,k=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*
l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;b=d.m_invMass;var c=e.m_invMass,h=d.m_invI,m=e.m_invI;this.m_mass.col1.x=b+c+f*f*h+k*k*m;this.m_mass.col2.x=-f*g*h-k*l*m;this.m_mass.col3.x=-f*h-k*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=b+c+g*g*h+l*l*m;this.m_mass.col3.y=g*h+l*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=h+m;a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_impulse.z*=a.dtRatio,d.m_linearVelocity.x-=
b*this.m_impulse.x,d.m_linearVelocity.y-=b*this.m_impulse.y,d.m_angularVelocity-=h*(g*this.m_impulse.y-f*this.m_impulse.x+this.m_impulse.z),e.m_linearVelocity.x+=c*this.m_impulse.x,e.m_linearVelocity.y+=c*this.m_impulse.y,e.m_angularVelocity+=m*(l*this.m_impulse.y-k*this.m_impulse.x+this.m_impulse.z)):this.m_impulse.SetZero()};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB,e=a.m_linearVelocity,g=a.m_angularVelocity,f=d.m_linearVelocity,
l=d.m_angularVelocity,k=a.m_invMass,h=d.m_invMass,m=a.m_invI,n=d.m_invI;b=a.m_xf.R;var p=this.m_localAnchorA.x-a.m_sweep.localCenter.x,q=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*p+b.col2.x*q,q=b.col1.y*p+b.col2.y*q,p=c;b=d.m_xf.R;var r=this.m_localAnchorB.x-d.m_sweep.localCenter.x,t=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*r+b.col2.x*t,t=b.col1.y*r+b.col2.y*t,r=c;b=f.x-l*t-e.x+g*q;var c=f.y+l*r-e.y-g*p,s=l-g,u=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(u,
-b,-c,-s);this.m_impulse.Add(u);e.x-=k*u.x;e.y-=k*u.y;g-=m*(p*u.y-q*u.x+u.z);f.x+=h*u.x;f.y+=h*u.y;l+=n*(r*u.y-t*u.x+u.z);a.m_angularVelocity=g;d.m_angularVelocity=l};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolvePositionConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB;b=a.m_xf.R;var e=this.m_localAnchorA.x-a.m_sweep.localCenter.x,g=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*e+b.col2.x*g,g=b.col1.y*e+b.col2.y*g,e=c;b=d.m_xf.R;var f=this.m_localAnchorB.x-d.m_sweep.localCenter.x,
l=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*f+b.col2.x*l,l=b.col1.y*f+b.col2.y*l,f=c;b=a.m_invMass;var c=d.m_invMass,k=a.m_invI,h=d.m_invI,m=d.m_sweep.c.x+f-a.m_sweep.c.x-e,n=d.m_sweep.c.y+l-a.m_sweep.c.y-g,p=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,q=10*Box2D.Common.b2Settings.b2_linearSlop,r=Math.sqrt(m*m+n*n),t=Math.abs(p);r>q&&(k*=1,h*=1);this.m_mass.col1.x=b+c+g*g*k+l*l*h;this.m_mass.col2.x=-g*e*k-l*f*h;this.m_mass.col3.x=-g*k-l*h;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=
b+c+e*e*k+f*f*h;this.m_mass.col3.y=e*k+f*h;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=k+h;q=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(q,-m,-n,-p);a.m_sweep.c.x-=b*q.x;a.m_sweep.c.y-=b*q.y;a.m_sweep.a-=k*(e*q.y-g*q.x+q.z);d.m_sweep.c.x+=c*q.x;d.m_sweep.c.y+=c*q.y;d.m_sweep.a+=h*(f*q.y-l*q.x+q.z);a.SynchronizeTransform();d.SynchronizeTransform();return r<=Box2D.Common.b2Settings.b2_linearSlop&&t<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2WeldJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_weldJoint;this.referenceAngle=0};c2inherit(Box2D.Dynamics.Joints.b2WeldJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));
this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c));this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2WeldJoint(this)};Box2D.Collision.b2Collision.s_incidentEdge=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints1=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints2=Box2D.Collision.b2Collision.MakeClipPointVector();
Box2D.Collision.b2Collision.s_localTangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_localNormal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_planePoint=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_normal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent2=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_v11=Box2D.Common.Math.b2Vec2.Get(0,
0);Box2D.Collision.b2Collision.s_v12=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2TimeOfImpact.b2_toiCalls=0;Box2D.Collision.b2TimeOfImpact.b2_toiIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=0;Box2D.Collision.b2TimeOfImpact.s_cache=new Box2D.Collision.b2SimplexCache;Box2D.Collision.b2TimeOfImpact.s_distanceInput=new Box2D.Collision.b2DistanceInput;Box2D.Collision.b2TimeOfImpact.s_xfA=
new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_xfB=new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_fcn=new Box2D.Collision.b2SeparationFunction;Box2D.Collision.b2TimeOfImpact.s_distanceOutput=new Box2D.Collision.b2DistanceOutput;Box2D.Dynamics.b2Body.s_xf1=new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2ContactListener.b2_defaultListener=new Box2D.Dynamics.b2ContactListener;Box2D.Dynamics.b2ContactManager.s_evalCP=new Box2D.Collision.b2ContactPoint;Box2D.Dynamics.b2World.s_xf=
new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2World.s_backupA=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.b2World.s_backupB=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold=new Box2D.Collision.b2WorldManifold;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm=new Box2D.Dynamics.Contacts.b2PositionSolverManifold}cr.b2Separator=function(){};
cr.b2Separator.det=function(a,b,c,d,e,g){return a*d+c*g+e*b-b*c-d*e-g*a};cr.b2Separator.hitRay=function(a,b,c,d,e,g,f,l){var k=c-a,h=d-b,m=f-e,n=l-g,m=(m*(g-b)-n*(e-a))/(h*m-k*n),k=a+m*k,h=b+m*h;a=cr.b2Separator.isOnSegment(c,d,a,b,k,h);e=cr.b2Separator.isOnSegment(k,h,e,g,f,l);return a&&e?Box2D.Common.Math.b2Vec2.Get(k,h):null};
cr.b2Separator.isOnSegment=function(a,b,c,d,e,g){return(c+0.1>=a&&a>=e-0.1||c-0.1<=a&&a<=e+0.1)&&(d+0.1>=b&&b>=g-0.1||d-0.1<=b&&b<=g+0.1)&&cr.b2Separator.isOnLine(a,b,c,d,e,g)};cr.b2Separator.isOnLine=function(a,b,c,d,e,g){return 0.1<Math.abs(e-c)?0.1>Math.abs((g-d)/(e-c)*(a-c)+d-b):0.1>Math.abs(a-c)};cr.b2Separator.pointsMatch=function(a,b,c,d){return 0.1>Math.abs(c-a)&&0.1>Math.abs(d-b)};
cr.b2Separator.Separate=function(a,b){var c=Box2D.Common.Math.b2Vec2,d=cr.b2Separator.calcShapes(a),e=[],g,f,l,k,h,m,n,p,q;h=0;for(m=d.length;h<m;h++){f=d[h];g=[];g.length=f.length;n=q=0;for(p=f.length;n<p;n++)l=f[n],k=f[(n+1)%p],q+=l.x*k.y-l.y*k.x,g[n]=c.Get(l.x,l.y);q=Math.abs(q/2);q>=0.0010*b&&e.push(g)}return e};
cr.b2Separator.calcShapes=function(a){var b=[],c=0,d=0,e=0,g=0,f=0,l=f=0,k=0,h=0,m=0,g=0,n,p,q,r=g=c=0,t=0,e=[],k=[],s=!1,u=[],A=[];for(A.push(a);A.length;){b=A[0];d=b.length;s=!0;for(c=0;c<d;c++)if(h=c,m=c<d-1?c+1:c+1-d,g=c<d-2?c+2:c+2-d,a=b[h],n=b[m],g=b[g],g=cr.b2Separator.det(a.x,a.y,n.x,n.y,g.x,g.y),0>g){s=!1;k=1E9;for(e=0;e<d;e++)e!==h&&e!==m&&(c=e,g=e<d-1?e+1:0,f=b[c],l=b[g],p=cr.b2Separator.hitRay(a.x,a.y,n.x,n.y,f.x,f.y,l.x,l.y))&&(f=n.x-p.x,l=n.y-p.y,f=f*f+l*l,f<k&&(t=c,r=g,q=p,k=f));if(1E9===
k)return[];e=[];k=[];c=t;g=r;f=b[c];l=b[g];cr.b2Separator.pointsMatch(q.x,q.y,l.x,l.y)||e.push(q);cr.b2Separator.pointsMatch(q.x,q.y,f.x,f.y)||k.push(q);t=-1;for(r=h;;){if(r!==g)e.push(b[r]);else{if(0>t||t>=d)return[];cr.b2Separator.isOnSegment(l.x,l.y,b[t].x,b[t].y,a.x,a.y)||e.push(b[r]);break}t=r;0>r-1?r=d-1:r--}e.reverse();t=-1;for(r=m;;){if(r!==c)k.push(b[r]);else{if(0>t||t>=d)return[];r!==c||cr.b2Separator.isOnSegment(f.x,f.y,b[t].x,b[t].y,n.x,n.y)||k.push(b[r]);break}t=r;r+1>d-1?r=0:r++}A.push(e,
k);A.shift();break}s&&u.push(A.shift())}return u};
cr.behaviors.Physics=function(a){for(var b=0;4E3>b;b++)Box2D.Common.Math.b2Vec2._freeCache.push(new Box2D.Common.Math.b2Vec2(0,0));this.runtime=a;this.world=new Box2D.Dynamics.b2World(Box2D.Common.Math.b2Vec2.Get(0,10),!0);this.worldG=10;this.lastUpdateTick=-1;a=new Box2D.Dynamics.b2ContactListener;a.behavior=this;a.BeginContact=function(a){var b=a.m_fixtureA.GetBody().c2userdata;a=a.m_fixtureB.GetBody().c2userdata;this.behavior.runtime.registerCollision(b.inst,a.inst)};this.world.SetContactListener(a);
a=new Box2D.Dynamics.b2ContactFilter;a.behavior=this;a.ShouldCollide=function(a,b){if(this.behavior.allCollisionsEnabled)return!0;var e=a.GetBody().c2userdata.inst.type,g=b.GetBody().c2userdata.inst.type,f=e.extra.Physics_DisabledCollisions;return f&&f.contains(g)?!1:(f=g.extra.Physics_DisabledCollisions)&&f.contains(e)?!1:!0};this.world.SetContactFilter(a);this.steppingMode=0;this.velocityIterations=8;this.positionIterations=3;this.allCollisionsEnabled=!0};
(function(){function a(){}function b(){}function c(a,b,c){c?((c=a.extra.Physics_DisabledCollisions)&&c.remove(b),(c=b.extra.Physics_DisabledCollisions)&&c.remove(a)):(a.extra.Physics_DisabledCollisions||(a.extra.Physics_DisabledCollisions=new cr.ObjectSet),a.extra.Physics_DisabledCollisions.add(b),b.extra.Physics_DisabledCollisions||(b.extra.Physics_DisabledCollisions=new cr.ObjectSet),b.extra.Physics_DisabledCollisions.add(a))}function d(){}var e=Box2D.Common.Math.b2Vec2,g=Box2D.Dynamics.b2BodyDef,
f=Box2D.Dynamics.b2FixtureDef,l=Box2D.Collision.Shapes.b2PolygonShape,k=Box2D.Collision.Shapes.b2CircleShape,h=Box2D.Dynamics.Joints.b2DistanceJointDef,m=Box2D.Dynamics.Joints.b2RevoluteJointDef,n=cr.behaviors.Physics.prototype;n.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};n.Type.prototype.onCreate=function(){};n.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.world=this.behavior.world};var p=n.Instance.prototype;p.onCreate=
function(){this.immovable=0!==this.properties[0];this.collisionmask=this.properties[1];this.preventRotation=0!==this.properties[2];this.density=this.properties[3];this.friction=this.properties[4];this.restitution=this.properties[5];this.linearDamping=this.properties[6];this.angularDamping=this.properties[7];this.bullet=0!==this.properties[8];this.enabled=0!==this.properties[9];this.body=null;this.inst.update_bbox();this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;
this.lastHeight=this.lastWidth=0;this.recreateBody=this.lastTickOverride=!1;this.lastAnimation=null;this.lastAnimationFrame=-1;this.myJoints?(this.myJoints.length=0,this.myCreatedJoints.length=0,this.joiningMe.clear()):(this.myJoints=[],this.myCreatedJoints=[],this.joiningMe=new cr.ObjectSet);var a=this;this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};p.postCreate=function(){this.inst.update_bbox();this.createBody();
this.lastAnimation=this.inst.cur_animation;this.lastAnimationFrame=this.inst.cur_frame};p.onDestroy=function(){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.runtime.removeDestroyCallback(this.myDestroyCallback)};p.saveToJSON=function(){var a={e:this.enabled,im:this.immovable,pr:this.preventRotation,d:this.density,fr:this.friction,re:this.restitution,ld:this.linearDamping,ad:this.angularDamping,b:this.bullet,
mcj:this.myCreatedJoints};if(this.enabled){var b=e.Get(0,0);b.SetV(this.body.GetLinearVelocity());a.vx=b.x;a.vy=b.y;a.om=this.body.GetAngularVelocity()}return a};p.loadFromJSON=function(a){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.enabled=a.e;this.immovable=a.im;this.preventRotation=a.pr;this.density=a.d;this.friction=a.fr;this.restitution=a.re;this.linearDamping=a.ld;this.angularDamping=a.ad;this.bullet=
a.b;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;this.lastWidth=this.inst.width;this.lastHeight=this.inst.height;this.enabled&&(this.createBody(),this.body.SetLinearVelocity(e.Get(a.vx,a.vy)),this.body.SetAngularVelocity(a.om),0===a.vx&&0===a.vy&&0===a.om||this.body.SetAwake(!0),this.myCreatedJoints=a.mcj)};p.afterLoad=function(){this.enabled&&this.recreateMyJoints();this.behavior.lastUpdateTick=this.runtime.tickcount-1};p.onInstanceDestroyed=function(a){var b,
c,d,e=a.uid;d=b=0;for(c=this.myCreatedJoints.length;b<c;b++)this.myCreatedJoints[d]=this.myCreatedJoints[b],d<this.myJoints.length&&(this.myJoints[d]=this.myJoints[b]),this.myCreatedJoints[b].params[1]==e?this.world.DestroyJoint(this.myJoints[b]):d++;this.myCreatedJoints.length=d;d<this.myJoints.length&&(this.myJoints.length=d);this.joiningMe.remove(a)};p.destroyMyJoints=function(){var a,b;a=0;for(b=this.myJoints.length;a<b;a++)this.world.DestroyJoint(this.myJoints[a]);this.myJoints.length=0};p.recreateMyJoints=
function(){var a,b,c;a=0;for(b=this.myCreatedJoints.length;a<b;a++)switch(c=this.myCreatedJoints[a],c.type){case 0:this.doCreateDistanceJoint(c.params[0],c.params[1],c.params[2],c.params[3],c.params[4]);break;case 1:this.doCreateRevoluteJoint(c.params[0],c.params[1]);break;case 2:this.doCreateLimitedRevoluteJoint(c.params[0],c.params[1],c.params[2],c.params[3])}};p.destroyBody=function(){this.body&&(this.destroyMyJoints(),this.world.DestroyBody(this.body),this.body=null,this.inst.extra.box2dbody=
null)};var q=[];p.createBody=function(){if(this.enabled){var a=this.inst,b=!1,c=null,d=null,h,m,n,p,v,F,x,y,B,w,G,C,D;if(this.body){b=!0;c=e.Get(0,0);c.SetV(this.body.GetLinearVelocity());d=this.body.GetAngularVelocity();y=this.joiningMe.valuesRef();h=0;for(m=y.length;h<m;h++)B=y[h].extra.box2dbody.c2userdata,B.destroyMyJoints();this.destroyBody()}B=new f;B.density=this.density;B.friction=this.friction;B.restitution=this.restitution;h=new g;h.type=this.immovable?0:2;a.update_bbox();h.position.x=0.02*
a.bquad.midX();h.position.y=0.02*a.bquad.midY();h.angle=a.angle;h.fixedRotation=this.preventRotation;h.linearDamping=this.linearDamping;h.angularDamping=this.angularDamping;h.bullet=this.bullet;y=this.inst.collision_poly&&!this.inst.collision_poly.is_empty();this.body=this.world.CreateBody(h);this.body.c2userdata=this;h=this.collisionmask;y||this.inst.tilemap_exists||0!==this.collisionmask||(h=1);m=Math.max(Math.abs(a.width),1);n=Math.max(Math.abs(a.height),1);w=0>a.width;G=0>a.height;if(0===h)if(a.tilemap_exists)for(C=
a.bquad.midX()-a.x,x=a.bquad.midY()-a.y,a.getAllCollisionRects(q),y=[],h=0,m=q.length;h<m;++h){w=q[h];G=w.rc;if(w.poly){if(!w.poly.convexpolys){v=w.poly.pts_cache;p=w.poly.pts_count;for(n=0;n<p;++n)y.push(e.Get(v[2*n],v[2*n+1]));n=w.id&3758096384;(-2147483648===n||1073741824===n||536870912===n||n&-2147483648&&n&1073741824&&n&536870912)&&y.reverse();w.poly.convexpolys=cr.b2Separator.Separate(y,(G.right-G.left)*(G.bottom-G.top));n=0;for(p=y.length;n<p;++n)e.Free(y[n]);y.length=0}n=0;for(p=w.poly.convexpolys.length;n<
p;++n){D=w.poly.convexpolys[n];v=0;for(F=D.length;v<F;++v)y.push(e.Get(0.02*(G.left+D[v].x-C),0.02*(G.top+D[v].y-x)));B.shape=new l;B.shape.SetAsArray(y,y.length);this.body.CreateFixture(B);v=0;for(F=y.length;v<F;++v)e.Free(y[v]);y.length=0}}else y.push(e.Get(0.02*(G.left-C),0.02*(G.top-x))),y.push(e.Get(0.02*(G.right-C),0.02*(G.top-x))),y.push(e.Get(0.02*(G.right-C),0.02*(G.bottom-x))),y.push(e.Get(0.02*(G.left-C),0.02*(G.bottom-x))),B.shape=new l,B.shape.SetAsArray(y,y.length),this.body.CreateFixture(B);
n=0;for(p=y.length;n<p;++n)e.Free(y[n]);y.length=0}else{h=a.angle;a.angle=0;a.set_bbox_changed();a.update_bbox();C=a.bquad.midX()-a.x;x=a.bquad.midY()-a.y;a.angle=h;a.set_bbox_changed();a.collision_poly.cache_poly(w?-m:m,G?-n:n,0);v=a.collision_poly.pts_cache;p=a.collision_poly.pts_count;y=[];y.length=p;for(h=0;h<p;h++)y[h]=e.Get(v[2*h]-C,v[2*h+1]-x);w!==G&&y.reverse();C=cr.b2Separator.Separate(y,m*n);for(h=0;h<p;h++)e.Free(y[h]);if(C.length)for(h=0,m=C.length;h<m;h++){y=C[h];n=0;for(p=y.length;n<
p;n++)x=y[n],x.x*=0.02,x.y*=0.02;B.shape=new l;B.shape.SetAsArray(y,y.length);this.body.CreateFixture(B);n=0;for(p=y.length;n<p;n++)e.Free(y[n])}else B.shape=new l,B.shape.SetAsBox(0.01*m,0.01*n),this.body.CreateFixture(B)}else 1===h?(B.shape=new l,B.shape.SetAsBox(0.01*m,0.01*n)):B.shape=new k(0.01*Math.min(m,n)),this.body.CreateFixture(B);a.extra.box2dbody=this.body;this.lastWidth=a.width;this.lastHeight=a.height;if(b)for(this.body.SetLinearVelocity(c),this.body.SetAngularVelocity(d),e.Free(c),
this.recreateMyJoints(),y=this.joiningMe.valuesRef(),h=0,m=y.length;h<m;h++)B=y[h].extra.box2dbody.c2userdata,B.recreateMyJoints();q.length=0}};p.tick=function(){if(this.enabled){var a=this.inst,b;0===this.behavior.steppingMode?b=this.runtime.timescale/60:(b=this.runtime.getDt(this.inst),b>1/30&&(b=1/30));this.runtime.tickcount>this.behavior.lastUpdateTick&&0<this.runtime.timescale&&(this.world.Step(b,this.behavior.velocityIterations,this.behavior.positionIterations),this.world.ClearForces(),this.behavior.lastUpdateTick=
this.runtime.tickcount);if(this.recreateBody||a.width!==this.lastWidth||a.height!==this.lastHeight||a.cur_animation!==this.lastAnimation||a.cur_frame!==this.lastAnimationFrame||a.tilemap_exists&&a.physics_changed)this.createBody(),this.recreateBody=!1,this.lastAnimation=a.cur_animation,this.lastAnimationFrame=a.cur_frame,a.tilemap_exists&&a.physics_changed&&(a.physics_changed=!1);b=a.angle!==this.lastKnownAngle;if(a.x!==this.lastKnownX||a.y!==this.lastKnownY){a.update_bbox();var c=a.bquad.midX(),
d=a.bquad.midY(),f=c-this.lastKnownX,g=d-this.lastKnownY;this.body.SetPosition(e.Get(0.02*c,0.02*d));this.body.SetLinearVelocity(e.Get(f,g));this.lastTickOverride=!0;this.body.SetAwake(!0)}else this.lastTickOverride&&(this.lastTickOverride=!1,this.body.SetLinearVelocity(e.Get(0,0)),this.body.SetPosition(e.Get(0.02*a.bquad.midX(),0.02*a.bquad.midY())));b&&(this.body.SetAngle(a.angle),this.body.SetAwake(!0));c=this.body.GetPosition();b=c.x/0.02;c=c.y/0.02;d=this.body.GetAngle();if(b!==a.x||c!==a.y||
d!==a.angle)if(a.x=b,a.y=c,a.angle=d,a.set_bbox_changed(),a.update_bbox(),b=a.bquad.midX()-a.x,c=a.bquad.midY()-a.y,0!==b||0!==c)a.x-=b,a.y-=c,a.set_bbox_changed();this.lastKnownX=a.x;this.lastKnownY=a.y;this.lastKnownAngle=a.angle}};p.getInstImgPointX=function(a){return-1!==a&&this.inst.getImagePoint?0===a&&this.body?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:this.inst.getImagePoint(a,!0):this.inst.x};p.getInstImgPointY=function(a){return-1!==a&&this.inst.getImagePoint?0===a&&
this.body?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:this.inst.getImagePoint(a,!1):this.inst.y};a.prototype.IsSleeping=function(){return this.enabled?!this.body.IsAwake():!1};a.prototype.CompareVelocity=function(a,b,c){if(!this.enabled)return!1;var d=this.body.GetLinearVelocity();0===a?d=d.x/0.02:1===a?d=d.y/0.02:(a=d.x/0.02,d=d.y/0.02,d=cr.distanceTo(0,0,a,d));return cr.do_cmp(d,b,c)};a.prototype.CompareAngularVelocity=function(a,b){if(!this.enabled)return!1;var c=cr.to_degrees(this.body.GetAngularVelocity());
return cr.do_cmp(c,a,b)};a.prototype.CompareMass=function(a,b){if(!this.enabled)return!1;var c=this.body.GetMass()/0.02;return cr.do_cmp(c,a,b)};a.prototype.IsEnabled=function(){return this.enabled};n.cnds=new a;b.prototype.ApplyForce=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(a,b),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyForceToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);
b=cr.angleTo(f,d,b,c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d))}};b.prototype.ApplyForceAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyImpulse=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyImpulse(e.Get(a,b),e.Get(0.02*d,0.02*c));this.lastTickOverride=
!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);b=cr.angleTo(f,d,b,c);this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);
this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyTorque=function(a){this.enabled&&this.body.ApplyTorque(cr.to_radians(a))};b.prototype.ApplyTorqueToAngle=function(a,b){this.enabled&&(a=cr.to_radians(a),b=cr.to_radians(b),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.ApplyTorqueToPosition=function(a,b,c){this.enabled&&
(a=cr.to_radians(a),b=cr.angleTo(this.inst.x,this.inst.y,b,c),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.SetAngularVelocity=function(a){this.enabled&&(this.body.SetAngularVelocity(cr.to_radians(a)),this.body.SetAwake(!0))};b.prototype.CreateDistanceJoint=function(a,b,c,d,e){b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody&&(this.myCreatedJoints.push({type:0,params:[a,b.uid,c,d,e]}),this.doCreateDistanceJoint(a,
b.uid,c,d,e))};p.doCreateDistanceJoint=function(a,b,c,d,f){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var g=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var k;b.getImagePoint?(k=b.getImagePoint(c,!0),c=b.getImagePoint(c,!1)):(k=b.x,c=b.y);var l=g-k,m=a-c,n=new h;n.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*g,0.02*a),e.Get(0.02*k,0.02*c));n.length=0.02*Math.sqrt(l*l+m*m);n.dampingRatio=d;
n.frequencyHz=f;this.myJoints.push(this.world.CreateJoint(n))}};b.prototype.CreateRevoluteJoint=function(a,b){if(b&&this.enabled){var c=b.getFirstPicked(this.inst);c&&c!=this.inst&&c.extra.box2dbody&&(this.myCreatedJoints.push({type:1,params:[a,c.uid]}),this.doCreateRevoluteJoint(a,c.uid))}};p.doCreateRevoluteJoint=function(a,b){if(this.enabled){var c=this.runtime.getObjectByUID(b);if(c&&c!=this.inst&&c.extra.box2dbody){c.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var d=this.getInstImgPointX(a),
f=this.getInstImgPointY(a),g=new m;g.Initialize(this.body,c.extra.box2dbody,e.Get(0.02*d,0.02*f));this.myJoints.push(this.world.CreateJoint(g))}}};b.prototype.CreateLimitedRevoluteJoint=function(a,b,c,d){b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody&&(this.myCreatedJoints.push({type:2,params:[a,b.uid,c,d]}),this.doCreateLimitedRevoluteJoint(a,b.uid,c,d))};p.doCreateLimitedRevoluteJoint=function(a,b,c,d){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&
b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var f=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var g=new m;g.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*f,0.02*a));g.enableLimit=!0;g.lowerAngle=cr.to_radians(c);g.upperAngle=cr.to_radians(d);this.myJoints.push(this.world.CreateJoint(g))}};b.prototype.SetWorldGravity=function(a){if(a!==this.behavior.worldG){this.world.SetGravity(e.Get(0,a));this.behavior.worldG=a;var b,c=this.behavior.my_instances.valuesRef();
a=0;for(b=c.length;a<b;a++)c[a].extra.box2dbody&&c[a].extra.box2dbody.SetAwake(!0)}};b.prototype.SetSteppingMode=function(a){this.behavior.steppingMode=a};b.prototype.SetIterations=function(a,b){1>a&&(a=1);1>b&&(b=1);this.behavior.velocityIterations=a;this.behavior.positionIterations=b};b.prototype.SetVelocity=function(a,b){this.enabled&&(this.body.SetLinearVelocity(e.Get(0.02*a,0.02*b)),this.body.SetAwake(!0),this.lastTickOverride=!1,this.lastKnownX=this.inst.x,this.lastKnownY=this.inst.y)};b.prototype.SetDensity=
function(a){this.enabled&&this.density!==a&&(this.density=a,this.recreateBody=!0)};b.prototype.SetFriction=function(a){this.enabled&&this.friction!==a&&(this.friction=a,this.recreateBody=!0)};b.prototype.SetElasticity=function(a){this.enabled&&this.restitution!==a&&(this.restitution=a,this.recreateBody=!0)};b.prototype.SetLinearDamping=function(a){this.enabled&&this.linearDamping!==a&&(this.linearDamping=a,this.body.SetLinearDamping(a))};b.prototype.SetAngularDamping=function(a){this.enabled&&this.angularDamping!==
a&&(this.angularDamping=a,this.body.SetAngularDamping(a))};b.prototype.SetImmovable=function(a){this.enabled&&this.immovable!==(0!==a)&&(this.immovable=0!==a,this.body.SetType(this.immovable?0:2),this.body.SetAwake(!0))};b.prototype.EnableCollisions=function(a,b){if(a&&this.enabled){var d,e;if(a.is_family)for(d=0,e=a.members.length;d<e;d++)c(this.inst.type,a.members[d],0!==b);else c(this.inst.type,a,0!==b);this.behavior.allCollisionsEnabled=!1}};b.prototype.SetPreventRotate=function(a){this.enabled&&
this.preventRotation!==(0!==a)&&(this.preventRotation=0!==a,this.body.SetFixedRotation(this.preventRotation),this.body.m_torque=0,this.body.SetAngularVelocity(0),this.body.SetAwake(!0))};b.prototype.SetBullet=function(a){this.enabled&&this.bullet!==(0!==a)&&(this.bullet=0!==a,this.body.SetBullet(this.bullet),this.body.SetAwake(!0))};b.prototype.RemoveJoints=function(){this.enabled&&(this.destroyMyJoints(),this.myCreatedJoints.length=0,this.joiningMe.clear())};b.prototype.SetEnabled=function(a){this.enabled&&
0===a?(this.destroyBody(),this.enabled=!1):this.enabled||1!==a||(this.enabled=!0,this.createBody())};n.acts=new b;d.prototype.VelocityX=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().x/0.02:0)};d.prototype.VelocityY=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().y/0.02:0)};d.prototype.AngularVelocity=function(a){a.set_float(this.enabled?cr.to_degrees(this.body.GetAngularVelocity()):0)};d.prototype.Mass=function(a){a.set_float(this.enabled?this.body.GetMass()/
0.02:0)};d.prototype.CenterOfMassX=function(a){a.set_float(this.enabled?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:0)};d.prototype.CenterOfMassY=function(a){a.set_float(this.enabled?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:0)};d.prototype.Density=function(a){a.set_float(this.enabled?this.density:0)};d.prototype.Friction=function(a){a.set_float(this.enabled?this.friction:0)};d.prototype.Elasticity=function(a){a.set_float(this.enabled?this.restitution:0)};d.prototype.LinearDamping=
function(a){a.set_float(this.enabled?this.linearDamping:0)};d.prototype.AngularDamping=function(a){a.set_float(this.enabled?this.angularDamping:0)};n.exps=new d})();cr.behaviors.Pin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Pin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var e=d.Instance.prototype;e.onCreate=function(){this.pinObject=null;this.pinObjectUid=-1;this.mode=this.lastKnownAngle=this.theirStartAngle=this.myStartAngle=this.pinDist=this.pinAngle=0;var a=this;this.recycled||
(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};e.saveToJSON=function(){return{uid:this.pinObject?this.pinObject.uid:-1,pa:this.pinAngle,pd:this.pinDist,msa:this.myStartAngle,tsa:this.theirStartAngle,lka:this.lastKnownAngle,m:this.mode}};e.loadFromJSON=function(a){this.pinObjectUid=a.uid;this.pinAngle=a.pa;this.pinDist=a.pd;this.myStartAngle=a.msa;this.theirStartAngle=a.tsa;this.lastKnownAngle=a.lka;this.mode=a.m};e.afterLoad=
function(){this.pinObject=-1===this.pinObjectUid?null:this.runtime.getObjectByUID(this.pinObjectUid);this.pinObjectUid=-1};e.onInstanceDestroyed=function(a){this.pinObject==a&&(this.pinObject=null)};e.onDestroy=function(){this.pinObject=null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};e.tick=function(){};e.tick2=function(){if(this.pinObject){this.lastKnownAngle!==this.inst.angle&&(this.myStartAngle=cr.clamp_angle(this.myStartAngle+(this.inst.angle-this.lastKnownAngle)));var a=this.inst.x,
b=this.inst.y;if(3===this.mode||4===this.mode){var c=cr.distanceTo(this.inst.x,this.inst.y,this.pinObject.x,this.pinObject.y);if(c>this.pinDist||4===this.mode&&c<this.pinDist)b=cr.angleTo(this.pinObject.x,this.pinObject.y,this.inst.x,this.inst.y),a=this.pinObject.x+Math.cos(b)*this.pinDist,b=this.pinObject.y+Math.sin(b)*this.pinDist}else a=this.pinObject.x+Math.cos(this.pinObject.angle+this.pinAngle)*this.pinDist,b=this.pinObject.y+Math.sin(this.pinObject.angle+this.pinAngle)*this.pinDist;this.lastKnownAngle=
c=cr.clamp_angle(this.myStartAngle+(this.pinObject.angle-this.theirStartAngle));0!==this.mode&&1!==this.mode&&3!==this.mode&&4!==this.mode||this.inst.x===a&&this.inst.y===b||(this.inst.x=a,this.inst.y=b,this.inst.set_bbox_changed());0!==this.mode&&2!==this.mode||this.inst.angle===c||(this.inst.angle=c,this.inst.set_bbox_changed())}};a.prototype.IsPinned=function(){return!!this.pinObject};d.cnds=new a;b.prototype.Pin=function(a,b){if(a){var c=a.getFirstPicked(this.inst);c&&(this.pinObject=c,this.pinAngle=
cr.angleTo(c.x,c.y,this.inst.x,this.inst.y)-c.angle,this.pinDist=cr.distanceTo(c.x,c.y,this.inst.x,this.inst.y),this.lastKnownAngle=this.myStartAngle=this.inst.angle,this.theirStartAngle=c.angle,this.mode=b)}};b.prototype.Unpin=function(){this.pinObject=null};d.acts=new b;c.prototype.PinnedUID=function(a){a.set_int(this.pinObject?this.pinObject.uid:-1)};d.exps=new c})();cr.behaviors.Platform=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Platform.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.simjump=this.simright=this.simleft=this.ignoreInput=this.jumped=this.jumpkey=this.rightkey=this.leftkey=!1;this.lastFloorObject=null;this.loadFloorObject=-1;this.lastFloorY=this.lastFloorX=0;this.floorIsJumpthru=
!1;this.fallthrough=this.animMode=0;this.firstTick=!0;this.dy=this.dx=0};var e=d.Instance.prototype;e.updateGravity=function(){this.downx=Math.cos(this.ga);this.downy=Math.sin(this.ga);this.rightx=Math.cos(this.ga-Math.PI/2);this.righty=Math.sin(this.ga-Math.PI/2);this.downx=cr.round6dp(this.downx);this.downy=cr.round6dp(this.downy);this.rightx=cr.round6dp(this.rightx);this.righty=cr.round6dp(this.righty);this.g1=this.g;0>this.g&&(this.downx*=-1,this.downy*=-1,this.g=Math.abs(this.g))};e.onCreate=
function(){this.maxspeed=this.properties[0];this.acc=this.properties[1];this.dec=this.properties[2];this.jumpStrength=this.properties[3];this.g1=this.g=this.properties[4];this.maxFall=this.properties[5];this.defaultControls=1===this.properties[6];this.enabled=0!==this.properties[7];this.wasOnFloor=!1;this.wasOverJumpthru=this.runtime.testOverlapJumpThru(this.inst);this.ga=cr.to_radians(90);this.updateGravity();var a=this;this.defaultControls&&!this.runtime.isDomFree&&(jQuery(document).keydown(function(b){a.onKeyDown(b)}),
jQuery(document).keyup(function(b){a.onKeyUp(b)}));this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};e.saveToJSON=function(){return{ii:this.ignoreInput,lfx:this.lastFloorX,lfy:this.lastFloorY,lfo:this.lastFloorObject?this.lastFloorObject.uid:-1,am:this.animMode,en:this.enabled,fall:this.fallthrough,ft:this.firstTick,dx:this.dx,dy:this.dy,ms:this.maxspeed,acc:this.acc,dec:this.dec,js:this.jumpStrength,g:this.g,g1:this.g1,
mf:this.maxFall,wof:this.wasOnFloor,woj:this.wasOverJumpthru,ga:this.ga}};e.loadFromJSON=function(a){this.ignoreInput=a.ii;this.lastFloorX=a.lfx;this.lastFloorY=a.lfy;this.loadFloorObject=a.lfo;this.animMode=a.am;this.enabled=a.en;this.fallthrough=a.fall;this.firstTick=a.ft;this.dx=a.dx;this.dy=a.dy;this.maxspeed=a.ms;this.acc=a.acc;this.dec=a.dec;this.jumpStrength=a.js;this.g=a.g;this.g1=a.g1;this.maxFall=a.mf;this.wasOnFloor=a.wof;this.wasOverJumpthru=a.woj;this.ga=a.ga;this.simjump=this.simright=
this.simleft=this.jumped=this.jumpkey=this.rightkey=this.leftkey=!1;this.updateGravity()};e.afterLoad=function(){this.lastFloorObject=-1===this.loadFloorObject?null:this.runtime.getObjectByUID(this.loadFloorObject)};e.onInstanceDestroyed=function(a){this.lastFloorObject==a&&(this.lastFloorObject=null)};e.onDestroy=function(){this.lastFloorObject=null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};e.onKeyDown=function(a){switch(a.which){case 38:a.preventDefault();this.jumpkey=!0;break;
case 37:a.preventDefault();this.leftkey=!0;break;case 39:a.preventDefault(),this.rightkey=!0}};e.onKeyUp=function(a){switch(a.which){case 38:a.preventDefault();this.jumped=this.jumpkey=!1;break;case 37:a.preventDefault();this.leftkey=!1;break;case 39:a.preventDefault(),this.rightkey=!1}};e.getGDir=function(){return 0>this.g?-1:1};e.isOnFloor=function(){var a=null,b=null,c,d;c=this.inst.x;d=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();if(this.lastFloorObject&&
this.runtime.testOverlap(this.inst,this.lastFloorObject))return this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed(),this.lastFloorObject;(a=this.runtime.testOverlapSolid(this.inst))||0!==this.fallthrough||(b=this.runtime.testOverlapJumpThru(this.inst,!0));this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();if(a){if(this.runtime.testOverlap(this.inst,a))return null;this.floorIsJumpthru=!1;return a}if(b&&b.length){d=a=0;for(c=b.length;a<c;a++)b[d]=b[a],this.runtime.testOverlap(this.inst,b[a])||
d++;if(1<=d)return this.floorIsJumpthru=!0,b[0]}return null};e.tick=function(){};e.posttick=function(){var a=this.runtime.getDt(this.inst),b,c,d,e,m,n,p,q,r;this.jumpkey||this.simjump||(this.jumped=!1);var t=this.leftkey||this.simleft;d=this.rightkey||this.simright;var s=(this.jumpkey||this.simjump)&&!this.jumped;this.simjump=this.simright=this.simleft=!1;if(this.enabled){this.ignoreInput&&(s=d=t=!1);q=this.lastFloorObject;r=!1;this.firstTick&&((this.runtime.testOverlapSolid(this.inst)||this.runtime.testOverlapJumpThru(this.inst))&&
this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,4,!0),this.firstTick=!1);!q||0!==this.dy||q.y===this.lastFloorY&&q.x===this.lastFloorX||(b=q.x-this.lastFloorX,c=q.y-this.lastFloorY,this.inst.x+=b,this.inst.y+=c,this.inst.set_bbox_changed(),this.lastFloorX=q.x,this.lastFloorY=q.y,r=!0,this.runtime.testOverlapSolid(this.inst)&&this.runtime.pushOutSolid(this.inst,-b,-c,2.5*Math.sqrt(b*b+c*c)));var u=this.isOnFloor();if(c=this.runtime.testOverlapSolid(this.inst))if(this.runtime.pushOutSolidNearest(this.inst,
Math.max(this.inst.width,this.inst.height)/2))this.runtime.registerCollision(this.inst,c);else return;u?(0<this.dy&&(this.wasOnFloor||(this.runtime.pushInFractional(this.inst,-this.downx,-this.downy,u,16),this.wasOnFloor=!0),this.dy=0),q!=u?(this.lastFloorObject=u,this.lastFloorX=u.x,this.lastFloorY=u.y,this.runtime.registerCollision(this.inst,u)):r&&(c=this.runtime.testOverlapSolid(this.inst))&&(this.runtime.registerCollision(this.inst,c),0!==b&&(0<b?this.runtime.pushOutSolid(this.inst,-this.rightx,
-this.righty):this.runtime.pushOutSolid(this.inst,this.rightx,this.righty)),this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy)),s&&(q=this.inst.x,r=this.inst.y,this.inst.x-=this.downx,this.inst.y-=this.downy,this.inst.set_bbox_changed(),this.runtime.testOverlapSolid(this.inst)?s=!1:(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnJump,this.inst),this.animMode=2,this.dy=-this.jumpStrength,this.jumped=!0),this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed())):(this.lastFloorObject=
null,this.dy+=this.g*a,this.dy>this.maxFall&&(this.dy=this.maxFall),s&&(this.jumped=!0));this.wasOnFloor=!!u;t==d&&(0>this.dx?(this.dx+=this.dec*a,0<this.dx&&(this.dx=0)):0<this.dx&&(this.dx-=this.dec*a,0>this.dx&&(this.dx=0)));t&&!d&&(this.dx=0<this.dx?this.dx-(this.acc+this.dec)*a:this.dx-this.acc*a);d&&!t&&(this.dx=0>this.dx?this.dx+(this.acc+this.dec)*a:this.dx+this.acc*a);this.dx>this.maxspeed?this.dx=this.maxspeed:this.dx<-this.maxspeed&&(this.dx=-this.maxspeed);t=!1;0!==this.dx&&(q=this.inst.x,
r=this.inst.y,b=this.dx*a*this.rightx,c=this.dx*a*this.righty,this.inst.x+=this.rightx*(1<this.dx?1:-1)-this.downx,this.inst.y+=this.righty*(1<this.dx?1:-1)-this.downy,this.inst.set_bbox_changed(),e=!1,m=this.runtime.testOverlapSolid(this.inst),this.inst.x=q+b,this.inst.y=r+c,this.inst.set_bbox_changed(),d=this.runtime.testOverlapSolid(this.inst),!d&&u&&(d=this.runtime.testOverlapJumpThru(this.inst))&&(this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed(),this.runtime.testOverlap(this.inst,d)?
(d=null,e=!1):e=!0,this.inst.x=q+b,this.inst.y=r+c,this.inst.set_bbox_changed()),d?(b=Math.abs(this.dx*a)+2,m||!this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,b,e,d))?(this.runtime.registerCollision(this.inst,d),b=Math.max(Math.abs(2.5*this.dx*a),30),this.runtime.pushOutSolid(this.inst,this.rightx*(0>this.dx?1:-1),this.righty*(0>this.dx?1:-1),b,!1)?!u||e||this.floorIsJumpthru||(q=this.inst.x,r=this.inst.y,this.inst.x+=this.downx,this.inst.y+=this.downy,this.runtime.testOverlapSolid(this.inst)?
this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,3,!1)||(this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed()):(this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed())):(this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed()),e||(this.dx=0)):!m&&15>Math.abs(this.dy)&&(this.dy=0,u||(t=!0)):(q=this.isOnFloor(),u&&!q?(c=Math.ceil(Math.abs(this.dx*a))+2,q=this.inst.x,r=this.inst.y,this.inst.x+=this.downx*c,this.inst.y+=this.downy*c,this.inst.set_bbox_changed(),this.runtime.testOverlapSolid(this.inst)||
this.runtime.testOverlapJumpThru(this.inst)?this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,c+2,!0):(this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed())):q&&0===this.dy&&this.runtime.pushInFractional(this.inst,-this.downx,-this.downy,q,16)));if(0!==this.dy){q=this.inst.x;r=this.inst.y;this.inst.x+=this.dy*a*this.downx;this.inst.y+=this.dy*a*this.downy;b=this.inst.x;d=this.inst.y;this.inst.set_bbox_changed();c=this.runtime.testOverlapSolid(this.inst);e=!1;if(!c&&0<this.dy&&!u){if((e=
0<this.fallthrough?null:this.runtime.testOverlapJumpThru(this.inst,!0))&&e.length){if(this.wasOverJumpthru){this.inst.x=q;this.inst.y=r;this.inst.set_bbox_changed();p=m=0;for(n=e.length;m<n;m++)e[p]=e[m],this.runtime.testOverlap(this.inst,e[m])||p++;e.length=p;this.inst.x=b;this.inst.y=d;this.inst.set_bbox_changed()}1<=e.length&&(c=e[0])}e=!!c}c&&(this.runtime.registerCollision(this.inst,c),b=e?Math.abs(2.5*this.dy*a+10):Math.max(Math.abs(2.5*this.dy*a+10),30),this.runtime.pushOutSolid(this.inst,
this.downx*(0>this.dy?1:-1),this.downy*(0>this.dy?1:-1),b,e,c)?(this.lastFloorObject=c,this.lastFloorX=c.x,this.lastFloorY=c.y,(this.floorIsJumpthru=e)&&(t=!0),this.dy=0):(this.inst.x=q,this.inst.y=r,this.inst.set_bbox_changed(),this.wasOnFloor=!0,e||(this.dy=0)))}3!==this.animMode&&0<this.dy&&!u&&(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnFall,this.inst),this.animMode=3);if(u||t)3===this.animMode||t||s&&0===this.dy?(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnLand,
this.inst),this.animMode=0===this.dx&&0===this.dy?0:1):(0!==this.animMode&&0===this.dx&&0===this.dy&&(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnStop,this.inst),this.animMode=0),1===this.animMode||0===this.dx&&0===this.dy||s||(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnMove,this.inst),this.animMode=1));0<this.fallthrough&&this.fallthrough--;this.wasOverJumpthru=this.runtime.testOverlapJumpThru(this.inst)}};a.prototype.IsMoving=function(){return 0!==this.dx||0!==this.dy};
a.prototype.CompareSpeed=function(a,b){var c=Math.sqrt(this.dx*this.dx+this.dy*this.dy);return cr.do_cmp(c,a,b)};a.prototype.IsOnFloor=function(){if(0!==this.dy)return!1;var a=null,b=null,c,d;c=this.inst.x;d=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();(a=this.runtime.testOverlapSolid(this.inst))||0!==this.fallthrough||(b=this.runtime.testOverlapJumpThru(this.inst,!0));this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();if(a)return!this.runtime.testOverlap(this.inst,
a);if(b&&b.length){d=a=0;for(c=b.length;a<c;a++)b[d]=b[a],this.runtime.testOverlap(this.inst,b[a])||d++;if(1<=d)return!0}return!1};a.prototype.IsByWall=function(a){var b=!1,c=this.inst.x,d=this.inst.y;this.inst.x-=3*this.downx;this.inst.y-=3*this.downy;this.inst.set_bbox_changed();if(this.runtime.testOverlapSolid(this.inst))return this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed(),!1;0===a?(this.inst.x-=2*this.rightx,this.inst.y-=2*this.righty):(this.inst.x+=2*this.rightx,this.inst.y+=2*this.righty);
this.inst.set_bbox_changed();b=this.runtime.testOverlapSolid(this.inst);this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();return b};a.prototype.IsJumping=function(){return 0>this.dy};a.prototype.IsFalling=function(){return 0<this.dy};a.prototype.OnJump=function(){return!0};a.prototype.OnFall=function(){return!0};a.prototype.OnStop=function(){return!0};a.prototype.OnMove=function(){return!0};a.prototype.OnLand=function(){return!0};d.cnds=new a;b.prototype.SetIgnoreInput=function(a){this.ignoreInput=
a};b.prototype.SetMaxSpeed=function(a){this.maxspeed=a;0>this.maxspeed&&(this.maxspeed=0)};b.prototype.SetAcceleration=function(a){this.acc=a;0>this.acc&&(this.acc=0)};b.prototype.SetDeceleration=function(a){this.dec=a;0>this.dec&&(this.dec=0)};b.prototype.SetJumpStrength=function(a){this.jumpStrength=a;0>this.jumpStrength&&(this.jumpStrength=0)};b.prototype.SetGravity=function(a){this.g1!==a&&(this.g=a,this.updateGravity(),this.runtime.testOverlapSolid(this.inst)&&(this.runtime.pushOutSolid(this.inst,
this.downx,this.downy,10),this.inst.x+=2*this.downx,this.inst.y+=2*this.downy,this.inst.set_bbox_changed()),this.lastFloorObject=null)};b.prototype.SetMaxFallSpeed=function(a){this.maxFall=a;0>this.maxFall&&(this.maxFall=0)};b.prototype.SimulateControl=function(a){switch(a){case 0:this.simleft=!0;break;case 1:this.simright=!0;break;case 2:this.simjump=!0}};b.prototype.SetVectorX=function(a){this.dx=a};b.prototype.SetVectorY=function(a){this.dy=a};b.prototype.SetGravityAngle=function(a){a=cr.to_radians(a);
a=cr.clamp_angle(a);this.ga!==a&&(this.ga=a,this.updateGravity(),this.lastFloorObject=null)};b.prototype.SetEnabled=function(a){this.enabled!==(1===a)&&(this.enabled=1===a,this.enabled||(this.lastFloorObject=null))};b.prototype.FallThrough=function(){var a=this.inst.x,b=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();var c=this.runtime.testOverlapJumpThru(this.inst,!1);this.inst.x=a;this.inst.y=b;this.inst.set_bbox_changed();c&&(this.fallthrough=3,this.lastFloorObject=
null)};d.acts=new b;c.prototype.Speed=function(a){a.set_float(Math.sqrt(this.dx*this.dx+this.dy*this.dy))};c.prototype.MaxSpeed=function(a){a.set_float(this.maxspeed)};c.prototype.Acceleration=function(a){a.set_float(this.acc)};c.prototype.Deceleration=function(a){a.set_float(this.dec)};c.prototype.JumpStrength=function(a){a.set_float(this.jumpStrength)};c.prototype.Gravity=function(a){a.set_float(this.g)};c.prototype.GravityAngle=function(a){a.set_float(cr.to_degrees(this.ga))};c.prototype.MaxFallSpeed=
function(a){a.set_float(this.maxFall)};c.prototype.MovingAngle=function(a){a.set_float(cr.to_degrees(Math.atan2(this.dy,this.dx)))};c.prototype.VectorX=function(a){a.set_float(this.dx)};c.prototype.VectorY=function(a){a.set_float(this.dy)};d.exps=new c})();cr.behaviors.Rotate=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Rotate.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.speed=cr.to_radians(this.properties[0]);this.acc=cr.to_radians(this.properties[1])};d.saveToJSON=function(){return{speed:this.speed,acc:this.acc}};d.loadFromJSON=
function(a){this.speed=a.speed;this.acc=a.acc};d.tick=function(){var a=this.runtime.getDt(this.inst);0!==a&&(0!==this.acc&&(this.speed+=this.acc*a),0!==this.speed&&(this.inst.angle=cr.clamp_angle(this.inst.angle+this.speed*a),this.inst.set_bbox_changed()))};c.cnds=new function(){};a.prototype.SetSpeed=function(a){this.speed=cr.to_radians(a)};a.prototype.SetAcceleration=function(a){this.acc=cr.to_radians(a)};c.acts=new a;b.prototype.Speed=function(a){a.set_float(cr.to_degrees(this.speed))};b.prototype.Acceleration=
function(a){a.set_float(cr.to_degrees(this.acc))};c.exps=new b})();cr.behaviors.Sin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Sin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.i=0};var e=d.Instance.prototype,g=2*Math.PI,f=Math.PI/2,l=3*Math.PI/2;e.onCreate=function(){this.active=1===this.properties[0];this.movement=this.properties[1];this.wave=this.properties[2];this.period=
this.properties[3];this.period+=Math.random()*this.properties[4];0===this.period?this.i=0:(this.i=this.properties[5]/this.period*g,this.i+=Math.random()*this.properties[6]/this.period*g);this.mag=this.properties[7];this.mag+=Math.random()*this.properties[8];this.ratio=this.initialValue2=this.initialValue=0;this.init()};e.saveToJSON=function(){return{i:this.i,a:this.active,mv:this.movement,w:this.wave,p:this.period,mag:this.mag,iv:this.initialValue,iv2:this.initialValue2,r:this.ratio,lkv:this.lastKnownValue,
lkv2:this.lastKnownValue2}};e.loadFromJSON=function(a){this.i=a.i;this.active=a.a;this.movement=a.mv;this.wave=a.w;this.period=a.p;this.mag=a.mag;this.initialValue=a.iv;this.initialValue2=a.iv2||0;this.ratio=a.r;this.lastKnownValue=a.lkv;this.lastKnownValue2=a.lkv2||0};e.init=function(){switch(this.movement){case 0:this.initialValue=this.inst.x;break;case 1:this.initialValue=this.inst.y;break;case 2:this.initialValue=this.inst.width;this.ratio=this.inst.height/this.inst.width;break;case 3:this.initialValue=
this.inst.width;break;case 4:this.initialValue=this.inst.height;break;case 5:this.initialValue=this.inst.angle;this.mag=cr.to_radians(this.mag);break;case 6:this.initialValue=this.inst.opacity;break;case 7:this.initialValue=0;break;case 8:this.initialValue=this.inst.x,this.initialValue2=this.inst.y}this.lastKnownValue=this.initialValue;this.lastKnownValue2=this.initialValue2};e.waveFunc=function(a){a%=g;switch(this.wave){case 0:return Math.sin(a);case 1:return a<=f?a/f:a<=l?1-2*(a-f)/Math.PI:(a-l)/
f-1;case 2:return 2*a/g-1;case 3:return-2*a/g+1;case 4:return a<Math.PI?-1:1}return 0};e.tick=function(){var a=this.runtime.getDt(this.inst);if(this.active&&0!==a){0===this.period?this.i=0:(this.i+=a/this.period*g,this.i%=g);switch(this.movement){case 0:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue);this.inst.x=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.x;break;case 1:this.inst.y!==this.lastKnownValue&&(this.initialValue+=
this.inst.y-this.lastKnownValue);this.inst.y=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.y;break;case 2:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;this.inst.height=this.inst.width*this.ratio;break;case 3:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 4:this.inst.height=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 5:this.inst.angle!==this.lastKnownValue&&(this.initialValue=cr.clamp_angle(this.initialValue+
(this.inst.angle-this.lastKnownValue)));this.inst.angle=cr.clamp_angle(this.initialValue+this.waveFunc(this.i)*this.mag);this.lastKnownValue=this.inst.angle;break;case 6:this.inst.opacity=this.initialValue+this.waveFunc(this.i)*this.mag/100;0>this.inst.opacity?this.inst.opacity=0:1<this.inst.opacity&&(this.inst.opacity=1);break;case 8:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue),this.inst.y!==this.lastKnownValue2&&(this.initialValue2+=this.inst.y-this.lastKnownValue2),
this.inst.x=this.initialValue+Math.cos(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.inst.y=this.initialValue2+Math.sin(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.lastKnownValue=this.inst.x,this.lastKnownValue2=this.inst.y}this.inst.set_bbox_changed()}};e.onSpriteFrameChanged=function(a,b){switch(this.movement){case 2:this.initialValue*=b.width/a.width;this.ratio=b.height/b.width;break;case 3:this.initialValue*=b.width/a.width;break;case 4:this.initialValue*=b.height/a.height}};a.prototype.IsActive=
function(){return this.active};a.prototype.CompareMovement=function(a){return this.movement===a};a.prototype.ComparePeriod=function(a,b){return cr.do_cmp(this.period,a,b)};a.prototype.CompareMagnitude=function(a,b){return 5===this.movement?cr.do_cmp(this.mag,a,cr.to_radians(b)):cr.do_cmp(this.mag,a,b)};a.prototype.CompareWave=function(a){return this.wave===a};d.cnds=new a;b.prototype.SetActive=function(a){this.active=1===a};b.prototype.SetPeriod=function(a){this.period=a};b.prototype.SetMagnitude=
function(a){this.mag=a;5===this.movement&&(this.mag=cr.to_radians(this.mag))};b.prototype.SetMovement=function(a){5===this.movement&&(this.mag=cr.to_degrees(this.mag));this.movement=a;this.init()};b.prototype.SetWave=function(a){this.wave=a};d.acts=new b;c.prototype.CyclePosition=function(a){a.set_float(this.i/g)};c.prototype.Period=function(a){a.set_float(this.period)};c.prototype.Magnitude=function(a){5===this.movement?a.set_float(cr.to_degrees(this.mag)):a.set_float(this.mag)};c.prototype.Value=
function(a){a.set_float(this.waveFunc(this.i)*this.mag)};d.exps=new c})();cr.behaviors.scrollto=function(a){this.runtime=a;this.shakeMode=this.shakeEnd=this.shakeStart=this.shakeMag=0};
(function(){function a(){}var b=cr.behaviors.scrollto.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var c=b.Instance.prototype;c.onCreate=function(){this.enabled=0!==this.properties[0]};c.saveToJSON=function(){return{smg:this.behavior.shakeMag,ss:this.behavior.shakeStart,se:this.behavior.shakeEnd,smd:this.behavior.shakeMode}};
c.loadFromJSON=function(a){this.behavior.shakeMag=a.smg;this.behavior.shakeStart=a.ss;this.behavior.shakeEnd=a.se;this.behavior.shakeMode=a.smd};c.tick=function(){};c.tick2=function(){if(this.enabled){var a=this.behavior.my_instances.values(),b=0,c=0,f,l;f=0;for(l=a.length;f<l;f++)b+=a[f].x,c+=a[f].y;f=this.inst.layer.layout;var k=this.runtime.kahanTime.sum,h=l=0;k>=this.behavior.shakeStart&&k<this.behavior.shakeEnd&&(l=this.behavior.shakeMag*Math.min(this.runtime.timescale,1),0===this.behavior.shakeMode&&
(l*=1-(k-this.behavior.shakeStart)/(this.behavior.shakeEnd-this.behavior.shakeStart)),k=2*Math.random()*Math.PI,h=Math.random()*l,l=Math.cos(k)*h,h*=Math.sin(k));f.scrollToX(b/a.length+l);f.scrollToY(c/a.length+h)}};a.prototype.Shake=function(a,b,c){this.behavior.shakeMag=a;this.behavior.shakeStart=this.runtime.kahanTime.sum;this.behavior.shakeEnd=this.behavior.shakeStart+b;this.behavior.shakeMode=c};a.prototype.SetEnabled=function(a){this.enabled=0!==a};b.acts=new a})();
cr.behaviors.solid=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.solid.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.inst.extra.solidEnabled=0!==this.properties[0]};d.tick=function(){};a.prototype.IsEnabled=function(){return this.inst.extra.solidEnabled};c.cnds=new a;b.prototype.SetEnabled=
function(a){this.inst.extra.solidEnabled=!!a};c.acts=new b})();
cr.getProjectModel=function(){return[null,"Company",[[cr.plugins_.Audio,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.CJSAds,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Clay,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Browser,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Button,!1,!0,!0,!0,!1,!1,!1,!1,!1],[cr.plugins_.Keyboard,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Mouse,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.NodeWebkit,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Sprite,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Spritefont2,
!1,!0,!0,!0,!0,!0,!0,!0,!0],[cr.plugins_.Touch,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.win8,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Text,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.TiledBg,!1,!0,!0,!0,!0,!0,!0,!0,!0]],[["t0",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground2.png",132,1],null,[],!1,!1,6625479861821423,[],null],["t1",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6980030699019702,[["start-sheet0.png",5327,0,0,181,54,1,0.5027624368667603,0.5,[],[-0.4861878454685211,-0.4444443881511688,
0.4751385450363159,-0.4259259104728699,0.4751385450363159,0.4259259700775147,-0.005524426698684692,0.4814810156822205,-0.4861878454685211,0.4444440007209778],0]]]],[],!1,!1,7807367254508016,[],null],["t2",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,881257284420238,[["billytheball-sheet0.png",29685,0,0,426,217,1,0.5,0.5023041367530823,[],[-0.4859155118465424,-0.474654346704483,0,-0.4976958334445953,0.3943660259246826,-0.2949311435222626,0.4953050017356873,-0.004608124494552612,0.3943660259246826,
0.2903228402137756,0,0.4838708639144898,-0.4765258133411408,0.4516128897666931,-0.4953051507472992,-0.004608124494552612],0]]]],[],!1,!1,7745266627980507,[],null],["t3",cr.plugins_.Button,!1,[],0,0,null,null,[],!1,!1,9496454053120666,[],null],["t4",cr.plugins_.TiledBg,!1,[],0,0,["fundoneutro.png",94,4],null,[],!1,!1,0xd5d0954bc2115,[],null],["t5",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7210948983452336,[["choosealevel-sheet0.png",15637,0,0,549,69,1,0.500910758972168,0.5072463750839233,
[],[-0.4808743596076965,-0.347826361656189,0.4936252236366272,-0.4637680649757385,0.4918032288551331,0.4347826242446899,-0.4826958477497101,0.3478256464004517,-0.4990892708301544,-0.01449236273765564],0]]]],[],!1,!1,0xac4e3dbd8f6eb,[],null],["t6",cr.plugins_.Sprite,!1,[618509894706943,0xd4036d2c7a92],0,0,null,[["Default",5,!1,1,0,!1,8533138112404272,[["niveis-sheet0.png",182124,0,0,634,312,1,0.5,0.467948704957962,[],[-0.4794952869415283,-0.4262819886207581,0.4779180288314819,-0.4230768978595734,0.4921140074729919,
0.03205129504203796,0.4668769836425781,0.4647432863712311,-0.4668769836425781,0.4647432863712311,-0.4936908483505249,0.03205129504203796],0]]]],[],!1,!1,0x637af5f8afbec,[],null],["t7",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6c28e8e2e5105,[["pause-sheet0.png",9267,0,0,70,77,1,0.5,0.5064935088157654,[],[-0.3428570032119751,-0.3636364936828613,0,-0.5064935088157654,0.3428570032119751,-0.3636364936828613,0.4714289903640747,-0.01298749446868897,0.2571430206298828,0.2727274894714356,
0,0.3506494760513306,-0.2571430206298828,0.2727274894714356,-0.4571428894996643,-0.01298749446868897],0]]]],[],!1,!1,0xfeefa64312983,[],null],["t8",cr.plugins_.Sprite,!1,[6218814685263208,9722165920948636,9428360030750324],2,0,null,[["Comum",5,!1,1,0,!1,650378707997712,[["gameball-sheet0.png",12204,0,0,82,82,1,0.5121951103210449,0.5121951103210449,[["Topo",0.5121951103210449,0.1463414579629898],["Meio",0.5121951103210449,0.5487805008888245],["Baixo",0.5121951103210449,0.9146341681480408]],[-0.3658541142940521,
-0.3658541142940521,-0.01219511032104492,-0.5121951103210449,0.3414638638496399,-0.3658541142940521,0.335365891456604,0.22865891456604,0.1981709003448486,0.3597558736801148,-0.01219511032104492,0.4878048896789551,-0.2439021170139313,0.3506098985671997,-0.3414630889892578,0.2256098985671997],0],["gameball-sheet1.png",13241,0,0,82,82,1,0.5121951103210449,0.5121951103210449,[],[-0.3753530979156494,-0.3341131210327148,-0.01745811104774475,-0.4984965026378632,0.3509628772735596,-0.3341131210327148,0.4772788882255554,
-0.01904410123825073,0.3509628772735596,0.309722900390625,-0.01745811104774475,0.4741058945655823,-0.3753530979156494,0.309722900390625,-0.5016688108444214,-0.01904410123825073],0]]]],[["Platform",cr.behaviors.Platform,4844730019903901],["ScrollTo",cr.behaviors.scrollto,0x8706aa9d35d03]],!1,!1,0xe1c1a3ee6b77e,[],null],["t9",cr.plugins_.Sprite,!1,[8055623684924081],1,0,null,[["Default",5,!1,1,0,!1,6241255429638815,[["healthkiller-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Solid",cr.behaviors.solid,
703880319418878]],!1,!1,8189242991413847,[],null],["t10",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x8317e7634a3d5,[["wall-sheet0.png",156,0,0,256,256,1,0.5,0.5,[],[],4]]]],[["Solid",cr.behaviors.solid,9494938349875008]],!1,!1,850625543259116,[],null],["t11",cr.plugins_.Sprite,!1,[],1,0,null,[["Media",5,!1,1,0,!1,0xd61c4334eba8c,[["ground-sheet0.png",8156,1,32,128,28,1,0.5,0.5,[],[-0.4609375,-0.3214290142059326,0,-0.4285714030265808,0.453125,-0.2857140004634857,0.4765629768371582,
0,0.453125,0.2857139706611633,0,0.4285709857940674,-0.453125,0.2857139706611633,-0.484375,0],0]]],["Grande",5,!1,1,0,!1,8979115248449266,[["ground-sheet0.png",8156,1,1,160,30,1,0.5,0.5333333611488342,[],[-0.432812511920929,-0.4000003635883331,0.4296879768371582,-0.4083333611488342,0.4296879768371582,0.3249996304512024,-0.432812511920929,0.3333336114883423],0]]],["Menor",5,!1,1,0,!1,4753258273063138,[["ground-sheet0.png",8156,162,1,92,28,1,0.5,0.5714285969734192,[],[-0.445652186870575,-0.3928576111793518,
0,-0.5,0.4456520080566406,-0.3928576111793518,0.5,-0.07142859697341919,0.4565219879150391,0.2857143878936768,0,0.3928573727607727,-0.445652186870575,0.2500004172325134,-0.5,-0.07142859697341919],0]]]],[["Solid",cr.behaviors.solid,6636595487169293]],!1,!1,9981482348451040,[],null],["t12",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xbec3efba4f9b,[["esquerda-sheet0.png",139,0,0,180,179,1,-0.8222222328186035,-0.3687150776386261,[],[0.9666662216186523,0.5139660835266113,1.322222232818604,
0.3687150776386261,1.677778244018555,0.5139660835266113,1.822222232818604,0.8659220933914185,1.677778244018555,1.223464131355286,1.322222232818604,1.368715047836304,0.9666662216186523,1.223464131355286,0.8222222328186035,0.8659220933914185],3]]]],[],!1,!1,7932311797340204,[],null],["t13",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,998508998987502,[["esquerda-sheet0.png",139,0,0,180,179,1,0.5,0.5027933120727539,[],[-0.3555560111999512,-0.3575423061847687,0,-0.5027933120727539,0.3555560111999512,
-0.3575423061847687,0.5,-0.005586326122283936,0.3555560111999512,0.3519557118415833,0,0.4972066879272461,-0.3555560111999512,0.3519557118415833,-0.5,-0.005586326122283936],3]]]],[],!1,!1,7161841537095824,[],null],["t14",cr.plugins_.Sprite,!1,[589414728851341,0xd1efd8da628a3],1,0,null,[["Default",5,!1,1,0,!1,8956396605031464,[["estrelas-sheet0.png",9304,0,0,78,77,1,0.5,0.5064935088157654,[],[-0.1794869899749756,-0.1818185150623322,0,-0.4155844151973724,0.1923080086708069,-0.1948055028915405,0.3846150040626526,
-0.01298749446868897,0.3076919913291931,0.2987014651298523,0,0.3506494760513306,-0.2564100027084351,0.2467535138130188,-0.3846150040626526,-0.01298749446868897],0]]]],[["Rotate",cr.behaviors.Rotate,8404113713136962]],!1,!1,5157501146141021,[],null],["t15",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7815962254160654,[["teste-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Solid",cr.behaviors.solid,0x9c0a994ce9d89]],!1,!1,0x511dc2c13278f,[],null],["t16",cr.plugins_.Sprite,!1,[],0,
0,null,[["Default",5,!1,1,0,!1,811540948196131,[["rede-sheet0.png",7964,0,0,106,72,1,0.5,0.5138888955116272,[],[-0.5,-0.5138888955116272,0,-0.3888888955116272,0.4811319708824158,-0.4861111044883728,0.3301889896392822,-0.0138888955116272,0.2924529910087585,0.1805551052093506,0,0.4444441199302673,-0.3018870055675507,0.1944441199302673,-0.3301889896392822,-0.0138888955116272],0]]]],[],!1,!1,5526804953687255,[],null],["t17",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8593995597907197,[],null],["t18",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4897499985827632,[["tabela-sheet0.png",13733,0,0,131,99,1,0.5038167834281921,0.5050504803657532,[],[-0.4274808764457703,-0.4040404856204987,-0.007633775472640991,-0.4949494898319244,0.4503812193870544,-0.4444443881511688,0.4351142048835754,0.4141415357589722,-0.007633775472640991,0.4949495196342468,-0.4580152928829193,0.4343435168266296,-0.4198472797870636,-0.01010146737098694],0]]]],[],!1,!1,0xd112d3cd704db,[],null],["t19",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,9653677333534202,[["challengecompleted-sheet0.png",187290,0,0,717,472,1,0.4993026554584503,0.5190678238868713,[],[-0.3458856344223023,-0.2860168218612671,3.576278686523438E-7,-0.4173728227615356,0.3082283437252045,-0.2266948223114014,0.3891213238239288,-0.01906782388687134,0.3403073251247406,0.2372881770133972,3.576278686523438E-7,0.336864173412323,-0.3403066396713257,0.2394071817398071,-0.4044630527496338,-0.01906782388687134],0]]]],[],!1,!1,0x9f556db0ba32e,
[],null],["t20",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,5059737341020084,[["rotatinglight-sheet0.png",19258,0,0,768,742,1,0.5,0.5,[],[-0.01432299613952637,0.002695024013519287,0,-0.006738990545272827,0.03645801544189453,-0.02021598815917969,0.006510019302368164,0,0.0429689884185791,0.02695399522781372,0,0.008086025714874268,-0.03255200386047363,0.01617300510406494,-0.01041701436042786,0],0]]]],[["Rotate",cr.behaviors.Rotate,0x91c216e6a17f],["Sine",cr.behaviors.Sin,0x76665ebf1427b]],
!1,!1,542312839828239,[],null],["t21",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,0xd393964adf9c0,[["lateraldarede-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],4]]]],[["Solid",cr.behaviors.solid,0x77e7f9b8b4525],["Physics",cr.behaviors.Physics,9348297751847736]],!1,!1,9697418289058196,[],null],["t22",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7824723381489161,[["fundodarede-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xb317073b87d6f,[],null],["t23",cr.plugins_.Keyboard,
!1,[],0,0,null,null,[],!1,!1,0xb96c6a9c74e91,[],null,[]],["t24",cr.plugins_.Touch,!1,[],0,0,null,null,[],!1,!1,7660015010880796,[],null,[1]],["t25",cr.plugins_.Mouse,!1,[],0,0,null,null,[],!1,!1,0x4e9a408409775,[],null,[]],["t26",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7159968058543057,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]],["Blocked",5,!1,1,0,!1,0xc9b7afbf3452c,[["level1-sheet1.png",5413,0,0,60,80,1,2.733333349227905,-0.300000011920929,[],[-2.53333330154419,
0.4500000178813934,-2.233333349227905,0.3375000059604645,-1.933333396911621,0.4500000178813934,-1.78333330154419,0.800000011920929,-1.833333373069763,1.225000023841858,-2.233333349227905,1.262500047683716,-2.633333444595337,1.225000023841858,-2.683333396911621,0.800000011920929],0]]]],[],!1,!1,0xc62057e1d0c3c,[],null],["t27",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7708530460656947,[["shop-sheet0.png",7891,0,0,273,71,1,0.5018315315246582,0.5070422291755676,[],[-0.4688645303249359,
-0.3802812099456787,-0.003663539886474609,-0.422535240650177,0.4652014970779419,-0.3802812099456787,0.4945054650306702,-0.01408421993255615,0.4358974695205689,0.2535207867622376,-0.003663539886474609,0.3802817463874817,-0.4761905372142792,0.3943657875061035],0]]]],[],!1,!1,464921996449305,[],null],["t28",cr.plugins_.NodeWebkit,!1,[],0,0,null,null,[],!1,!1,0x8b46a5c09d975,[],null,[]],["t29",cr.plugins_.win8,!1,[],0,0,null,null,[],!1,!1,0xdc10381f2a2e,[],null,[1,1,1,1]],["t30",cr.plugins_.TiledBg,!1,
[],0,0,["tiledbackground.png",121,1],null,[],!1,!1,0xca4ab5d84104,[],null],["t31",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5761263999140404,[["world1-sheet0.png",150,0,0,209,208,1,0.5023923516273499,0.5,[["Imagepoint 1",0.5023923516273499,0.5]],[],3]]]],[["DragDrop",cr.behaviors.DragnDrop,5265600092712533]],!1,!1,0xc86306a763b78,[],null],["t32",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,482497259094907,[["world3-sheet0.png",150,0,0,209,209,1,0.5023923516273499,0.5023923516273499,
[],[],3]]]],[],!1,!1,8509734875283181,[],null],["t33",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xff862c2c984b7,[["world2-sheet0.png",149,0,0,208,208,1,0.5,0.5,[],[],3]]]],[],!1,!1,0x74a7d30fe7675,[],null],["t34",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6158615830068252,[["barrapause-sheet0.png",19298,0,0,936,277,1,0.5,0.5018050670623779,[],[-0.4935897290706635,-0.4801443815231323,0.4935899972915649,-0.4801443815231323,0.5,-0.003610074520111084,0.464743971824646,0.3790609240531921,
-0.4615384936332703,0.368230938911438,-0.5,-0.003610074520111084],0]]]],[],!1,!1,6010877534005461,[],null],["t35",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8209395605124605,[["brown-sheet0.png",26443,0,0,133,147,1,0.5037593841552734,0.5102040767669678,[],[-0.3458643853664398,-0.3673470616340637,-0.007518380880355835,-0.5102040767669678,0.3458645939826965,-0.3741500973701477,0.4586465954780579,-0.01360508799552918,0.2556396126747131,0.2721089124679565,-0.007518380880355835,0.340135931968689,
-0.255639374256134,0.2653059363365173,-0.4661653935909271,-0.01360508799552918],0]]]],[],!1,!1,4651478242678819,[],null],["t36",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground3.png",121,1],null,[],!1,!1,0x968a05a1d37e,[],null],["t37",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xc3e43e0408faf,[["purple-sheet0.png",29179,0,0,133,147,1,0.5037593841552734,0.5034013390541077,[],[-0.3458643853664398,-0.3605443239212036,-0.007518380880355835,-0.49659863114357,0.3383455872535706,-0.3605443239212036,
0.4511275887489319,-0.006802350282669067,0.2556396126747131,0.2789116501808167,-0.007518380880355835,0.3469386696815491,-0.2631573677062988,0.2789116501808167,-0.4661653935909271,-0.006802350282669067],0]]]],[],!1,!1,5117342458780179,[],null],["t38",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6127895743830998,[["voltar-sheet0.png",9531,0,0,70,77,1,0.5,0.5064935088157654,[],[-0.3428570032119751,-0.3636364936828613,0,-0.5064935088157654,0.3428570032119751,-0.3636364936828613,0.4714289903640747,
-0.01298749446868897,0.2571430206298828,0.2727274894714356,0,0.3506494760513306,-0.2571430206298828,0.2727274894714356,-0.4571428894996643,-0.01298749446868897],0]]]],[],!1,!1,6044213231449093,[],null],["t39",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground4.png",386743,0],null,[],!1,!1,7067233600753367,[],null],["t40",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8961697973156886,[["restart-sheet0.png",26166,0,0,149,164,1,0.5033556818962097,0.5060975551605225,[],[-0.3489936888217926,-0.3658535480499268,
-0.006711691617965698,-0.5,0.3422822952270508,-0.3658535480499268,0.456376314163208,-0.006097555160522461,0.2550333142280579,0.274390459060669,-0.006711691617965698,0.3414634466171265,-0.2617446780204773,0.274390459060669,-0.4630871713161469,-0.006097555160522461],0]]]],[],!1,!1,8059932365032083,[],null],["t41",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa54e34a7bbf9f,[["home-sheet0.png",28813,0,0,149,164,1,0.5033556818962097,0.5060975551605225,[],[-0.3489936888217926,-0.3658535480499268,
-0.006711691617965698,-0.5,0.3422822952270508,-0.3658535480499268,0.456376314163208,-0.006097555160522461,0.2550333142280579,0.274390459060669,-0.006711691617965698,0.3414634466171265,-0.2617446780204773,0.274390459060669,-0.4630871713161469,-0.006097555160522461],0]]]],[],!1,!1,9325495996025704,[],null],["t42",cr.plugins_.Sprite,!1,[],0,0,null,[["On",5,!1,1,0,!1,683238039493723,[["som-sheet0.png",27168,0,0,149,164,1,0.5033556818962097,0.5060975551605225,[],[-0.3489936888217926,-0.3658535480499268,
-0.006711691617965698,-0.5,0.3422822952270508,-0.3658535480499268,0.456376314163208,-0.006097555160522461,0.2550333142280579,0.274390459060669,-0.006711691617965698,0.3414634466171265,-0.2617446780204773,0.274390459060669,-0.4630871713161469,-0.006097555160522461],0]]],["Off",5,!1,1,0,!1,0x4483a306b8b28,[["som-sheet1.png",27458,0,0,149,164,1,0.5033556818962097,0.5060975551605225,[],[-0.3489936888217926,-0.3658535480499268,-0.006711691617965698,-0.5,0.3422822952270508,-0.3658535480499268,0.456376314163208,
-0.006097555160522461,0.2550333142280579,0.274390459060669,-0.006711691617965698,0.3414634466171265,-0.2617446780204773,0.274390459060669,-0.4630871713161469,-0.006097555160522461],0]]]],[],!1,!1,0xfe41090797a17,[],null],["t43",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6140584827383469,[["continue-sheet0.png",26147,0,0,149,164,1,0.5033556818962097,0.5060975551605225,[],[-0.3489936888217926,-0.3658535480499268,-0.006711691617965698,-0.5,0.3422822952270508,-0.3658535480499268,0.456376314163208,
-0.006097555160522461,0.2550333142280579,0.274390459060669,-0.006711691617965698,0.3414634466171265,-0.2617446780204773,0.274390459060669,-0.4630871713161469,-0.006097555160522461],0]]]],[],!1,!1,7728847649878446,[],null],["t44",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6564803687463974,[["som-sheet1.png",27458,0,0,149,164,1,0.5033556818962097,0.5,[],[-0.3489936888217926,-0.3597559928894043,-0.006711691617965698,-0.4939024448394775,0.3422822952270508,-0.3597559928894043,0.456376314163208,
0,0.2550333142280579,0.2804880142211914,-0.006711691617965698,0.3475610017776489,-0.2617446780204773,0.2804880142211914,-0.4630871713161469,0],0]]]],[],!1,!1,7187892836341634,[],null],["t45",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8078265997974283,[["shopping-sheet0.png",2152,0,0,87,83,1,0.5057471394538879,0.5060241222381592,[],[-0.459770143032074,-0.4578313231468201,-0.01149412989616394,-0.5060241222381592,0.4482758641242981,-0.4578313231468201,0.4827588796615601,-0.01204812526702881,
0.4482758641242981,0.4457828998565674,-0.01149412989616394,0.4939758777618408,-0.459770143032074,0.4457828998565674,-0.5057471394538879,-0.01204812526702881],0]]]],[],!1,!1,7619198621117575,[],null],["t46",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground5.png",112,4],null,[],!1,!1,5471937401389654,[],null],["t47",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5546946386696013,[["play-sheet0.png",238448,0,0,338,413,1,0.5059171319007874,0.501210629940033,[],[-0.4467455446720123,-0.4358353316783905,
-0.005917131900787354,-0.4987893104553223,0.4142008423805237,-0.4358353316783905,0.4142008423805237,-0.00242161750793457,0.4437868595123291,0.2881353497505188,-0.005917131900787354,0.4503633975982666,-0.3964501321315765,0.2905573844909668,-0.4704141318798065,-0.00242161750793457],0]]]],[["Sine2",cr.behaviors.Sin,0x7e2e96f5da520]],!1,!1,0xaa83c019d537f,[],null],["t48",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf2ae0f6ce8624,[["barrapause-sheet0.png",19298,0,0,936,277,1,0.5,0.5018050670623779,
[],[-0.4935897290706635,-0.4801443815231323,0.4935899972915649,-0.4801443815231323,0.5,-0.003610074520111084,0.4978629946708679,0.3574009537696838,-0.4967948794364929,0.3718409538269043,-0.5,-0.003610074520111084],0]]]],[],!1,!1,6581520526653589,[],null],["t49",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8295739795548624,[["cimadarede-sheet0.png",8435,0,0,106,84,1,0.5,3.940476179122925,[],[-0.3490570187568665,-3.750000238418579,0,-3.940476179122925,0.3490570187568665,-3.750000238418579,
0.3773580193519592,-3.440476179122925,0.2924529910087585,-3.202381134033203,0,-2.988095283508301,-0.2924529910087585,-3.202381134033203,-0.3584910035133362,-3.440476179122925],0]]]],[],!1,!1,0x6c7ab2011e047,[],null],["t50",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xcadf33f141be1,[["blue-sheet0.png",27980,0,0,133,147,1,0.5037593841552734,0.5034013390541077,[],[-0.3458643853664398,-0.3605443239212036,-0.007518380880355835,-0.49659863114357,0.3383455872535706,-0.3605443239212036,0.4586465954780579,
-0.006802350282669067,0.2556396126747131,0.2789116501808167,-0.007518380880355835,0.3469386696815491,-0.2631573677062988,0.2789116501808167,-0.4661653935909271,-0.006802350282669067],0]]]],[],!1,!1,4720928992315822,[],null],["t51",cr.plugins_.Audio,!1,[],0,0,null,null,[],!1,!1,0x8ff640988ea4f,[],null,[0,0,1,1,600,600,1E4,1,5E3,1]],["t52",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6260038797116344,[],null],["t53",cr.plugins_.CJSAds,!1,[],0,0,null,null,[],!1,!1,5323798871836582,[],null,[0,1]],["t54",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x3e9be0fe516e3,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,9868627458972828,[],null],["t55",cr.plugins_.Sprite,!1,[],2,0,null,[["Menor",5,!1,1,0,!1,4531525270064888,[["groundmove-sheet0.png",12872,162,1,88,30,1,0.5,0.5,[],[-0.4005681872367859,-0.4541667103767395,0.4034090042114258,-0.4583334028720856,0.4659090042114258,0,0.4545450210571289,0.3666669726371765,0,0.300000011920929,-0.4545454978942871,0.3666669726371765,
-0.4659090936183929,0],0]]],["Media",5,!1,1,0,!1,7030827834479176,[["groundmove-sheet0.png",12872,1,125,128,28,1,0.5,0.5,[],[-0.4111328125,-0.5,0.4130859971046448,-0.5,0.4765629768371582,0,0.46875,0.357142984867096,0,0.3214290142059326,-0.46875,0.357142984867096,-0.4765625,0],0]]],["Maior",5,!1,1,0,!1,7431979716611437,[["groundmove-sheet0.png",12872,1,1,160,30,1,0.5062500238418579,0.5333333611488342,[],[-0.4273438155651093,-0.4875000715255737,0.432030975818634,-0.4833333492279053,0.4749999642372131,
-0.03333336114883423,0.46875,0.3333336114883423,-0.00625002384185791,0.2666666507720947,-0.4812500178813934,0.3333336114883423,-0.487500011920929,-0.03333336114883423],0]]],["Sine",8,!0,1,0,!1,0x6e0b3f9f0f5c6,[["groundmove-sheet0.png",12872,99,156,88,30,1,0.5,0.5,[],[-0.3622159957885742,-0.4541667103767395,0.3877840042114258,-0.4541667103767395,0.4659090042114258,0,0.4545450210571289,0.3666669726371765,0,0.300000011920929,-0.4545454978942871,0.3666669726371765,-0.4659090936183929,0],0],["groundmove-sheet0.png",
12872,157,32,97,30,1,0.5051546096801758,0.5,[],[-0.4432989060878754,-0.300000011920929,-0.0103096067905426,-0.3666670024394989,0.443299412727356,-0.3333330154418945,0.4639173746109009,0,0.4536083936691284,0.3666669726371765,-0.0103096067905426,0.1666669845581055,-0.4639174938201904,0.3666669726371765,-0.4742268025875092,0],0],["groundmove-sheet0.png",12872,133,63,112,30,1,0.5,0.5,[],[-0.4464285969734192,-0.300000011920929,0,-0.3666670024394989,0.4553570151329041,-0.3333330154418945,0.4732139706611633,
0,0.4642859697341919,0.3666669726371765,0,0.1666669845581055,-0.4642857015132904,0.3666669726371765,-0.4732142984867096,0],0],["groundmove-sheet0.png",12872,1,63,131,30,1,0.5038167834281921,0.5,[],[-0.4580152928829193,-0.300000011920929,-0.007633775472640991,-0.3666670024394989,0.4580152034759522,-0.3333330154418945,0.4732822179794312,0,0.4656491875648499,0.3666669726371765,-0.007633775472640991,0.1666669845581055,-0.4732823967933655,0.3666669726371765,-0.4809159934520721,0],0],["groundmove-sheet0.png",
12872,1,32,155,30,1,0.5032258033752441,0.5,[],[-0.4645161032676697,-0.300000011920929,-0.006451815366744995,-0.3666670024394989,0.4645162224769592,-0.3333330154418945,0.4774191975593567,0,0.4709681868553162,0.3666669726371765,-0.006451815366744995,0.1666669845581055,-0.4774193167686462,0.3666669726371765,-0.4838710129261017,0],0],["groundmove-sheet0.png",12872,1,94,131,30,1,0.5038167834281921,0.5,[],[-0.4580152928829193,-0.300000011920929,-0.007633775472640991,-0.3666670024394989,0.4580152034759522,
-0.3333330154418945,0.4732822179794312,0,0.4656491875648499,0.3666669726371765,-0.007633775472640991,0.1666669845581055,-0.4732823967933655,0.3666669726371765,-0.4809159934520721,0],0],["groundmove-sheet0.png",12872,133,94,112,30,1,0.5,0.5,[],[-0.4464285969734192,-0.300000011920929,0,-0.3666670024394989,0.4553570151329041,-0.3333330154418945,0.4732139706611633,0,0.4642859697341919,0.3666669726371765,0,0.1666669845581055,-0.4642857015132904,0.3666669726371765,-0.4732142984867096,0],0],["groundmove-sheet0.png",
12872,130,125,112,30,1,0.5,0.5,[],[-0.4464285969734192,-0.300000011920929,0,-0.3666670024394989,0.4553570151329041,-0.3333330154418945,0.4732139706611633,0,0.4642859697341919,0.3666669726371765,0,0.1666669845581055,-0.4642857015132904,0.3666669726371765,-0.4732142984867096,0],0],["groundmove-sheet0.png",12872,1,154,97,30,1,0.5051546096801758,0.5,[],[-0.4432989060878754,-0.300000011920929,-0.0103096067905426,-0.3666670024394989,0.443299412727356,-0.3333330154418945,0.4639173746109009,0,0.4536083936691284,
0.3666669726371765,-0.0103096067905426,0.1666669845581055,-0.4639174938201904,0.3666669726371765,-0.4742268025875092,0],0]]]],[["Sine",cr.behaviors.Sin,9302515855992466],["Solid",cr.behaviors.solid,401078454029385]],!1,!1,0xacfc48bab11fd,[],null],["t56",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,9900664153893400,[["groundrot-sheet0.png",3693,0,0,128,28,1,0.5,0.5357142686843872,[],[-0.4511719048023224,-0.4464285671710968,0.4589840173721314,-0.4374999701976776,0.4570310115814209,0.3482147455215454,
-0.4492186903953552,0.3482147455215454],0]]]],[["Rotate",cr.behaviors.Rotate,0xfef7f59137f52],["Solid",cr.behaviors.solid,7698183929388566]],!1,!1,0xfb4167401c60e,[],null],["t57",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x868b2bdb9db71,[["sprite-sheet0.png",237215,805,1,801,481,1,0.4981273412704468,0.4968814849853516,[],[-0.4968788921833038,-0.4948024749755859,0.5006246566772461,-0.4948024749755859,0.5006246566772461,0.5010395050048828,-0.4968788921833038,0.5010395050048828],0]]],
["Animation2",5,!1,1,0,!1,9171729062802012,[["sprite-sheet0.png",237215,805,483,801,481,1,0.4981273412704468,0.4968814849853516,[],[-0.4968788921833038,-0.4948024749755859,0.5006246566772461,-0.4948024749755859,0.5006246566772461,0.5010395050048828,-0.4981273412704468,0.5031185150146484],0]]],["Animation3",5,!1,1,0,!1,7083971110546084,[["sprite-sheet0.png",237215,1,484,801,481,1,0.4893882572650909,0.4303534328937531,[],[-0.488139808177948,-0.4282744228839874,0.5093637704849243,-0.4282744228839874,
0.5106117725372314,0.5696465969085693,-0.488139808177948,0.5675675868988037],0]]],["Animation4",5,!1,1,0,!1,0x465071956fe1a,[["sprite-sheet0.png",237215,803,965,801,481,1,0.4993757903575897,0.4989604949951172,[],[-0.4981273412704468,-0.4968814849853516,0.4993762075901032,-0.4968814849853516,0.4993762075901032,0.4989604949951172,-0.4981273412704468,0.4989604949951172],0]]],["Animation5",5,!1,1,0,!1,6135889573079838,[["sprite-sheet0.png",237215,1,966,801,481,1,0.4993757903575897,0.4989604949951172,
[],[-0.4981273412704468,-0.4968814849853516,0.5006241798400879,-0.4989604949951172,0.4993762075901032,0.4989604949951172,-0.4981273412704468,0.4989604949951172],0]]],["Animation6",5,!1,1,0,!1,8903252431950876,[["sprite-sheet0.png",237215,803,1447,801,481,1,0.4993757903575897,0.4989604949951172,[],[-0.4981273412704468,-0.4968814849853516,0.5006241798400879,-0.4989604949951172,0.4993762075901032,0.4989604949951172,-0.4981273412704468,0.4989604949951172],0]]],["Animation7",5,!1,1,0,!1,0xb1904d29a7740,
[["sprite-sheet0.png",237215,1,1,803,482,1,0.5018680095672607,0.4937759339809418,[],[-0.5006226897239685,-0.4917012453079224,0.4968869686126709,-0.4917012453079224,0.4968869686126709,0.5041490793228149,-0.5006226897239685,0.5041490793228149],0]]]],[["Fade",cr.behaviors.Fade,0xc5404549bc549]],!1,!1,0x5fc966fe17a35,[],null],["t58",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8602385857409393,[["sprite2-sheet0.png",39088,0,0,311,318,1,0.4758842587471008,0.4874213933944702,[],[-0.4758842587471008,
-0.3710694015026093,-0.03537026047706604,-0.4874213933944702,0.5241157412528992,-0.4874213933944702,-0.4758842587471008,0.5125786066055298,0.5241157412528992,0.5125786066055298,-0.03537026047706604,0.5125786066055298,-0.4758842587471008,0.5125786066055298,-0.4758842587471008,0.5125786066055298],0]]]],[],!1,!1,0xa64b840eb5f1f,[],null],["t59",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x42063036eab2c,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0xe1c555ac881e9,
[],null],["t60",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x76c2deefe5365,[["sprite4-sheet0.png",128586,0,0,955,323,1,0.500523567199707,0.5015479922294617,[],[-0.4973821938037872,-0.492260068655014,-0.001047581434249878,-0.4984520077705383,0.4513084292411804,-0.3591330051422119,0.2984294295310974,-0.00309598445892334,0.4753924608230591,0.427245020866394,-0.001047581434249878,0.4860680103302002,-0.4607329666614533,0.3808050155639648,-0.2565445601940155,-0.00309598445892334],0]]]],[],
!1,!1,9431343161211724,[],null],["t61",cr.plugins_.Sprite,!1,[],0,0,null,[["preto",5,!1,1,0,!1,0x63f3bfec7ac8,[["sprite5-sheet0.png",1565,0,0,87,30,1,0.5057471394538879,0.5333333611488342,[],[-0.459770143032074,-0.4000003635883331,-0.01149412989616394,-0.5000000596046448,0.4482758641242981,-0.4000003635883331,0.4827588796615601,-0.03333336114883423,0.4022988677024841,0.1999996304512024,-0.01149412989616394,0.4333336353302002,-0.482758641242981,0.3999996185302734,-0.459770143032074,-0.03333336114883423],
0]]],["white",5,!1,1,0,!1,6507976712061498,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,7007710886632642,[],null],["t62",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7465821651179119,[["sprite6-sheet0.png",2120,0,0,77,77,1,0.5064935088157654,0.5064935088157654,[],[-0.350649505853653,-0.350649505853653,-0.01298749446868897,-0.493506520986557,0.3376625180244446,-0.350649505853653,0.4805194735527039,-0.01298749446868897,0.3376625180244446,0.3376625180244446,-0.01298749446868897,
0.4805194735527039,-0.350649505853653,0.3376625180244446,-0.493506520986557,-0.01298749446868897],0]]]],[["Rotate",cr.behaviors.Rotate,6091738345866009]],!1,!1,882196518152687,[],null],["t63",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,483182078062685,[["sprite7-sheet0.png",12045,0,0,335,208,1,0.5014925599098206,0.5,[],[-0.3761195540428162,-0.2980769872665405,-0.002985566854476929,-0.4951923191547394,0.3850744366645813,-0.3173080086708069,0.4716414213180542,0,0.4805974364280701,0.4711539745330811,
-0.002985566854476929,0.2067310214042664,-0.4776119589805603,0.4615380167961121,-0.47164186835289,0],0]]]],[],!1,!1,6299246994836582,[],null],["t64",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6642965576533094,[["sprite8-sheet0.png",35514,0,0,361,89,1,0.5013850331306458,0.516853928565979,[],[-0.4819944202899933,-0.516853928565979,0.002769947052001953,-0.516853928565979,0.4986149668693543,-0.516853928565979,0.4986149668693543,-0.02247193455696106,0.4986149668693543,0.2921350598335266,
-0.005540043115615845,0.3033710718154907,-0.4792243242263794,0.3370790481567383,-0.4736842215061188,0.03370809555053711],0]]]],[],!1,!1,9758434222863038,[],null],["t65",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb4a37c13fddc8,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0x634ca94e9c0f6,[],null],["t66",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8500511521337783,[["touchesquerda-sheet0.png",1496,0,0,70,68,1,0.5,0.5,[],[-0.3428570032119751,-0.3382350206375122,
0,-0.4852941036224365,0.3428570032119751,-0.3382350206375122,0.4857140183448792,0,0.357142984867096,0.3529409766197205,0,0.485293984413147,-0.3428570032119751,0.3382350206375122,-0.4857142865657806,0],0]]]],[],!1,!1,0x98a8f9f36eda6,[],null],["t67",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7313455347108418,[["touchesquerda-sheet0.png",1496,0,0,70,68,1,0.5,0.5,[],[-0.3428570032119751,-0.3382350206375122,0,-0.4852941036224365,0.3428570032119751,-0.3382350206375122,0.4857140183448792,
0,0.357142984867096,0.3529409766197205,0,0.485293984413147,-0.3428570032119751,0.3382350206375122,-0.4857142865657806,0],0]]]],[],!1,!1,4525586257373055,[],null],["t68",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7ac5c92b4c84,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0x59d8aac95a219,[],null],["t69",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground6.png",558,0],null,[],!1,!1,0xebe49610585ea,[],null],["t70",cr.plugins_.Sprite,!1,[],0,0,null,[["zero",5,!1,1,0,
!1,0x819c1d114fd43,[["sprite12-sheet0.png",7286,1,1,108,35,1,0.5092592835426331,0.5142857432365417,[],[-0.407407283782959,-0.1999997496604919,-0.009259283542633057,-0.4857143461704254,0.3981477022171021,-0.228571742773056,0.4629626870155335,-0.02857175469398499,0.4351847171783447,0.3142852783203125,-0.009259283542633057,0.3428572416305542,-0.4351851940155029,0.2571432590484619,-0.4814814925193787,-0.02857175469398499],0]]],["um",5,!1,1,0,!1,0xec9f83e25e0a5,[["sprite12-sheet0.png",7286,1,37,108,35,
1,0.5,0.5142857432365417,[],[-0.4074074029922485,-0.228571742773056,0,-0.4857143461704254,0.4074069857597351,-0.228571742773056,0.4722219705581665,-0.02857175469398499,0.4444440007209778,0.3142852783203125,0,0.3428572416305542,-0.4351851940155029,0.2857142686843872,-0.4814814925193787,-0.02857175469398499],0]]],["dois",5,!1,1,0,!1,9404646922045012,[["sprite12-sheet0.png",7286,1,73,108,35,1,0.5,0.5142857432365417,[],[-0.4074074029922485,-0.228571742773056,0,-0.5142857432365417,0.4074069857597351,-0.228571742773056,
0.4722219705581665,-0.02857175469398499,0.4444440007209778,0.3142852783203125,0,0.3714282512664795,-0.4351851940155029,0.2857142686843872,-0.4814814925193787,-0.02857175469398499],0]]],["tres",5,!1,1,0,!1,0x77980ad09f06f,[["sprite12-sheet1.png",4920,0,0,108,35,1,0.5,0.5142857432365417,[],[-0.4074074029922485,-0.228571742773056,0,-0.5142857432365417,0.4166669845581055,-0.2571427524089813,0.4814810156822205,-0.02857175469398499,0.4537039995193481,0.3428572416305542,0,0.3714282512664795,-0.4351851940155029,
0.2857142686843872,-0.4814814925193787,-0.02857175469398499],0]]]],[],!1,!1,0xdaa8309c83b47,[],null],["t71",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8964053045330112,[["sprite14-sheet0.png",15818,0,0,283,64,1,0.6289752721786499,0.875,[],[-0.6007066965103149,-0.75,0.3109537363052368,-0.609375,0.3639577031135559,-0.375,0.3215547204017639,-0.09375,-0.1307422816753388,-0.15625,-0.5689045786857605,-0.140625,-0.6289752721786499,-0.375],0]]]],[],!1,!1,7521873816476131,[],null],["t72",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x4ea506b1eebd8,[["sprite15-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],4]]]],[],!1,!1,0xa2195daa469dc,[],null],["t73",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8164077955076588,[],null],["t74",cr.plugins_.Browser,!1,[],0,0,null,null,[],!1,!1,42761899219029,[],null,[]],["t75",cr.plugins_.Sprite,!1,[4577155036998978],3,0,null,[["Default",5,!1,1,0,!1,0xfcc72817203cf,[["bluelevelsball-sheet0.png",12203,0,0,82,82,1,0.5121951103210449,0.5121951103210449,[],[-0.3658541142940521,
-0.3658541142940521,-0.01219511032104492,-0.5121951103210449,0.3414638638496399,-0.3658541142940521,0.4756098985671997,-0.01219511032104492,0.3292678594589233,0.3292678594589233,-0.01219511032104492,0.4756098985671997,-0.3536581099033356,0.3292678594589233,-0.5121951103210449,-0.01219511032104492],0]]],["Dor",5,!1,1,0,!1,0x91f9596a37dba,[["bluelevelsball-sheet1.png",4250,0,0,57,57,1,0.5087719559669495,0.5087719559669495,[],[-0.3581699728965759,-0.3572569489479065,-0.008771955966949463,-0.5027113556861877,
0.340626060962677,-0.3572569489479065,0.4852040410041809,-0.01180195808410645,0.340626060962677,0.3397130370140076,-0.008771955966949463,0.4912280440330505,-0.3581699728965759,0.3397130370140076,-0.5027478337287903,-0.01180195808410645],0]]]],[["Physics",cr.behaviors.Physics,0x98da154fec8bc],["Pin",cr.behaviors.Pin,0x5bcea044b3a75],["Flash",cr.behaviors.Flash,633399872190357]],!1,!1,0x840f1d991f428,[],null],["t76",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,0xbc83a19321724,[["chao-sheet0.png",
155,0,0,250,250,1,0.5,0.5,[],[-0.4600000083446503,-0.4600000083446503,0,-0.5,0.4599999785423279,-0.4600000083446503,0.5,0,0.4599999785423279,0.4599999785423279,0,0.5,-0.4600000083446503,0.4599999785423279,-0.5,0],1]]]],[["Physics",cr.behaviors.Physics,5292712559697089],["Pin",cr.behaviors.Pin,5387343762310066]],!1,!1,0x985124406c8bb,[],null],["t77",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x8dea3615b1055,[["gangorra-sheet0.png",1168,0,0,137,29,1,0.5036496520042419,0.517241358757019,
[],[-0.3795616626739502,0.0689656138420105,-0.007299661636352539,-0.2068963646888733,0.3722623586654663,0.0689656138420105,0.4963503479957581,-0.03448235988616943,0.4525543451309204,0.2758616209030151,-0.007299661636352539,0.0689656138420105,-0.4598540663719177,0.2758616209030151,-0.5036496520042419,-0.03448235988616943],0]]]],[["Physics",cr.behaviors.Physics,0x99f2dc163471a]],!1,!1,8109675879343268,[],null],["t78",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,784576406406045,[["support-sheet0.png",
5471,0,0,101,112,1,0.5049505233764648,0.5,[],[-0.3267325162887573,-0.08928599953651428,-0.2079205214977264,-0.4017857909202576,0.148514449596405,-0.2410709857940674,0.4059404730796814,0,0.3069304823875427,0.375,-0.009900510311126709,0.5,-0.3663365244865418,0.357142984867096,-0.425742506980896,0.03571397066116333],0]]]],[["Physics",cr.behaviors.Physics,6033615311739613]],!1,!1,6628835173007263,[],null],["t79",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",10,!1,1,0,!1,7404525503997871,[["sprite16-sheet0.png",
39852,1,88,142,71,1,0.5,0.5070422291755676,[],[-0.3521130084991455,-0.2112672328948975,0,-0.4084506332874298,0.3521130084991455,-0.2112672328948975,0.4295769929885864,-0.01408421993255615,0.4084510207176209,0.3098587989807129,0.2200700044631958,-0.0352112352848053,-0.007041990756988525,-0.2183102369308472,-0.2112680077552795,-0.02816921472549439,-0.4084506928920746,0.3098587989807129,-0.429577499628067,-0.01408421993255615],0],["sprite16-sheet0.png",39852,1,160,142,71,1,0.5,0.5070422291755676,[],
[],0],["sprite16-sheet1.png",54955,1,1,142,71,1,0.5,0.5070422291755676,[],[],0],["sprite16-sheet1.png",54955,1,73,142,71,1,0.5,0.5070422291755676,[],[],0],["sprite16-sheet1.png",54955,1,145,142,71,1,0.5,0.5070422291755676,[],[],0],["sprite16-sheet2.png",54371,1,1,142,71,1,0.5,0.5070422291755676,[],[],0],["sprite16-sheet2.png",54371,1,73,142,71,1,0.5,0.5070422291755676,[],[],0],["sprite16-sheet2.png",54371,1,145,142,71,1,0.5,0.5070422291755676,[],[-0.3521130084991455,-0.2112672328948975,0,-0.4084506332874298,
0.3521130084991455,-0.2112672328948975,0.4295769929885864,-0.01408421993255615,0.4084510207176209,0.3098587989807129,0.2200700044631958,-0.0352112352848053,-0.007041990756988525,-0.2183102369308472,-0.2112680077552795,-0.02816921472549439,-0.4084506928920746,0.3098587989807129,-0.429577499628067,-0.01408421993255615],0]]],["Passed",5,!1,1,0,!1,5040254285874687,[["sprite16-sheet0.png",39852,1,1,125,86,1,0.5040000081062317,0.5116279125213623,[],[-0.4079999923706055,-0.3720929026603699,-0.008000016212463379,
-0.5116279125213623,0.3920000195503235,-0.3604649305343628,0.4800000190734863,-0.01162791252136231,0.4559999704360962,0.4302321076393127,-0.008000016212463379,0.3604651093482971,-0.464000016450882,0.4302321076393127,-0.4880000054836273,-0.01162791252136231],0]]]],[],!1,!1,0xad53681590823,[],null],["t80",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6925609b35bca,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,5501946725818131,[],null],["t81",cr.plugins_.Sprite,!1,
[],0,0,null,[["Default",5,!1,1,0,!1,0xb8ac5e039379,[["pino-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xd22c52dfba5e5,[],null],["t82",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xe70d8529459ce,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,8513620217166607,[],null],["t83",cr.plugins_.Spritefont2,!1,[],0,0,["spritefont.png",1138,0],null,[],!1,!1,859155933336856,[],null],["t84",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xed5e9bddd9784,
[["sprite18-sheet0.png",2723,0,0,162,74,1,0.7654321193695068,0.5,[],[-0.7408907413482666,-0.4470416009426117,-0.006148099899291992,-0.4733381867408752,0.2345678806304932,-0.4470416009426117,0.2345678806304932,0.4470419883728027,-0.006148099899291992,0.4601899981498718,-0.7408907413482666,0.4470419883728027],0]]]],[],!1,!1,0xdd117c7b9fc9c,[],null],["t85",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6139558619460577,[["sprite19-sheet0.png",1406,0,0,37,36,1,0.5135135054588318,0.5,[],[-0.3513514995574951,
-0.3333330154418945,-0.02702751755714417,-0.5,0.3243244886398315,-0.3333330154418945,0.4594594836235046,0,0.3243244886398315,0.3333330154418945,-0.02702751755714417,0.5,-0.3513514995574951,0.3333330154418945,-0.4864864945411682,0],0]]]],[],!1,!1,6721267862500651,[],null],["t86",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x5c94d1318ad68,[["sprite20-sheet0.png",1718,0,0,159,41,1,0.5031446814537048,0.5121951103210449,[],[-0.4213836789131165,-0.4695121049880981,0.4198113083839417,-0.4756098091602325,
0.421384334564209,-0.3658531308174133,0.4811323285102844,-0.3841460943222046,0.4874223470687866,-0.2103661000728607,0.3647803068161011,-0.02439010143280029,0.3317613005638123,0.4390239119529724,0.007861316204071045,0.4390239119529724,-0.3294026851654053,0.4359759092330933,-0.3580976724624634,-0.06250011920928955,-0.4858488738536835,-0.1768290996551514,-0.4905658960342407,-0.3841460943222046,-0.4213835000991821,-0.3780481219291687],0]]]],[["Physics",cr.behaviors.Physics,0x6d8b5cdc52b21]],!1,!1,0x7175c6e050070,
[],null],["t87",cr.plugins_.Sprite,!1,[],1,0,null,[["Maior",5,!1,1,0,!1,0x7873d82886e81,[["espinhos-sheet0.png",31132,1,1,156,59,1,0.5,1,[],[-0.3653849959373474,-0.6440680027008057,0,-0.6949149966239929,0.339743971824646,-0.5762709975242615,0.3461539745330811,-0.5084750056266785,0.4743589758872986,-0.06779700517654419,0,-0.01694899797439575,-0.474359005689621,-0.06779700517654419,-0.3846150040626526,-0.5084750056266785],0]]],["Medio",5,!1,1,0,!1,8107501889562185,[["espinhos-sheet0.png",31132,1,61,
124,59,1,0.5,0.508474588394165,[],[-0.3709679841995239,-0.2372885942459106,0,-0.3220335841178894,0.3387100100517273,-0.1694915890693665,0.354839026927948,-0.01694959402084351,0.4677420258522034,0.4237284064292908,0,0.4745764136314392,-0.4677419066429138,0.4237284064292908,-0.3951610028743744,-0.01694959402084351],0]]],["Menor",5,!1,1,0,!1,0x61b534f58a01f,[["espinhos-sheet0.png",31132,158,1,92,58,1,0.5,0.5,[],[-0.2826089859008789,-0.1551719903945923,0,-0.3793100118637085,0.2608699798583984,-0.1379309892654419,
0.4565219879150391,0.4310349822044373,0,0.4827589988708496,-0.4565216898918152,0.4310349822044373],0]]]],[["Physics",cr.behaviors.Physics,9272255911964226]],!1,!1,811004045655892,[],null],["t88",cr.plugins_.Spritefont2,!1,[],0,0,["spritefont2.png",1325,0],null,[],!1,!1,5317592007571644,[],null],["t89",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6560467325514965,[["angulo-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,39463009513277]],!1,!1,7411378270891452,
[],null],["t90",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9299723838670714,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0xd059fb7996fe3,[],null],["t91",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8832776129119759,[["gravity-sheet0.png",155,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.01999999955296516,0.4799999892711639],["Imagepoint 2",0.972000002861023,0.4799999892711639]],[],1]]]],[],!1,!1,376866767831465,[],null],["t92",cr.plugins_.Sprite,!1,[],
0,0,null,[["Default",5,!1,1,0,!1,0xb6dd09eb6f185,[["fundo-sheet0.png",350264,0,0,972,598,1,0.5,0.5,[],[],1]]]],[],!1,!1,9494145282733184,[],null],["t93",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5773003417025807,[["casafundo-sheet0.png",8280,0,0,374,270,1,0.5,0.5,[],[-0.3850269913673401,-0.340740978717804,0,-0.3925929963588715,0.3689839839935303,-0.3185189962387085,0.3877009749412537,0,0.3716580271720886,0.3222219944000244,0,0.4962959885597229,-0.3689839839935303,0.3185189962387085],
0]]]],[],!1,!1,4960362396600325,[],null],["t94",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9343152532258456,[["piscina-sheet0.png",74062,0,0,972,161,1,0.5,0.5031055808067322,[],[-0.4475308954715729,-0.1863355934619904,0,-0.1801245808601379,0.4526749849319458,-0.2173915803432465,0.5,-0.006211578845977783,0.5,0.4968944191932678,-0.5,0.4968944191932678,-0.5,-0.006211578845977783],0]]]],[],!1,!1,7603114715272484,[],null],["t95",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,
5211154880242595,[["grade-sheet0.png",203157,0,0,972,257,1,0.5,0.5019454956054688,[],[-0.491769552230835,-0.4708170890808106,0,-0.3929964900016785,0.4753090143203735,-0.4085603058338165,0.5,0.4980545043945313,-0.5,0.4980545043945313],0]]]],[],!1,!1,9991583011937914,[],null],["t96",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6873573320089642,[["casa-sheet0.png",54616,0,0,252,371,1,0.5,0.5013477206230164,[],[-0.3928570151329041,-0.4285714030265808,0,-0.4959568679332733,0.4841269850730896,
-0.4905660152435303,0.5,0.4986522793769836,-0.3650789856910706,0.4070082902908325,-0.4285714030265808,-0.002695709466934204],0]]]],[],!1,!1,8664768361967652,[],null],["t97",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5833698506946465,[["lixeira-sheet0.png",16621,0,0,159,180,1,0.5031446814537048,0.5,[],[-0.4213836789131165,-0.4277777969837189,-0.006289690732955933,-0.4777778089046478,0.484276294708252,-0.4888888895511627,0.484276294708252,0,0.4088053107261658,0.4222220182418823,-0.006289690732955933,
0.3055559992790222,-0.2955976724624634,0.3166670203208923],0]]]],[],!1,!1,9699454099097016,[],null],["t98",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4867060160443452,[["fundostart-sheet0.png",656538,0,0,854,512,1,0.5,0.5,[],[],1]]]],[],!1,!1,7079573457640054,[],null],["t99",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x504b457a01e85,[["fundochallenges-sheet0.png",737928,0,0,972,598,1,0.5,0.5016722679138184,[],[],1]]]],[],!1,!1,5623327148012767,[],null],["t100",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x8e51a46881921,[["fundoworld-sheet0.png",478995,0,0,972,598,1,0.5,0.5,[],[],1]]]],[],!1,!1,5749112068604689,[],null],["t101",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x46c97d5b0209a,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0xf6ee73b293dbf,[],null],["t102",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8064736398779173,[["sprite21-sheet0.png",34328,0,0,500,49,1,0.5,0.5102040767669678,[],[-0.5,-0.5102040767669678,
0,-0.5102040767669678,0.5,-0.5102040767669678,0.5,-0.02040806412696838,0.5,0.4897959232330322,-0.01399999856948853,0.469387948513031,-0.5,0.4897959232330322],0]]]],[],!1,!1,0x827d794dc29b4,[],null],["t103",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,490306139629564,[["sprite22-sheet0.png",2951,0,0,29,182,1,0.517241358757019,0.5,[],[-0.4827585518360138,-0.4945054948329926,-0.03448235988616943,-0.4945054948329926,0.2758616209030151,-0.4670329988002777,0.482758641242981,0.5,-0.03448235988616943,
0.5,-0.3448273539543152,0.472527027130127,-0.1379313468933106,0],0]]]],[],!1,!1,7531370324136732,[],null],["t104",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4666405273666107,[["sprite23-sheet0.png",330440,0,0,600,477,1,0.5,0.50104820728302,[],[-0.02666699886322022,0.09433978796005249,0,-0.486373096704483,0.1899999976158142,-0.11111119389534,0.3799999952316284,-0.002096205949783325,0.4333329796791077,0.415094792842865,0,0.4402518272399902,-0.4283332824707031,0.4088047742843628,-0.3666670024394989,
-0.002096205949783325],0]]]],[],!1,!1,0xc2358d12f840e,[],null],["t105",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6104381033723303,[["sprite24-sheet0.png",5973,0,0,314,52,1,0.5,0.5,[],[0,-0.09615400433540344,0.1146500110626221,0,0,0.5,-0.03821700811386108,0],0]]]],[],!1,!1,554768657074573,[],null],["t106",cr.plugins_.Sprite,!1,[0x986ff23ac7779],2,0,null,[["Default",5,!1,1,0,!1,0x59870031af3e1,[["gangorra1-sheet0.png",3269,0,0,209,34,1,0.5023923516273499,0.8823529481887817,[],[-0.4892344474792481,
-0.5808819532394409,-0.4419856667518616,-0.8566176295280457,-0.4351078569889069,-0.5900739431381226,-0.3347793519496918,-0.8759191036224365,-0.004784345626831055,-0.8823529481887817,0.4641146659851074,-0.676470935344696,0.2679426670074463,-0.3823529481887817,0.3875596523284912,-0.5588239431381226,-0.004784345626831055,0.1176470518112183,-0.2870813608169556,-0.3823529481887817],0]]]],[["Physics",cr.behaviors.Physics,6094294564689574],["Pin",cr.behaviors.Pin,5712887097418853]],!1,!1,8235002322514142,
[],null],["t107",cr.plugins_.Sprite,!1,[0xc0c9d4d10d0dc],1,0,null,[["Default",5,!1,1,0,!1,0x9ee300c5f156e,[["basegangorra-sheet0.png",3517,0,0,76,30,1,0.5,0.5,[],[0.3996710181236267,0.3166660070419312,0.5,0.3125,0.5,0.5,-0.5,0.5,-0.4983552396297455,0.3083329796791077,-0.3659539818763733,0.3098959922790527],0]]]],[["Physics",cr.behaviors.Physics,9519282177142388]],!1,!1,0xb539c4a294cdb,[],null],["t108",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf2c0fa1d9c77a,[["level1-sheet0.png",
168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0x65a8130acac9b,[],null],["t109",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9106240038926708,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0x91d3616c8388d,[],null],["t110",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x70a7ca29f7847,[["level1-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,5958207875101591,[],null],["t111",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9144682363144088,
[["sprite27-sheet0.png",170482,0,0,634,312,1,0.5,0.5,[],[-0.4794952869415283,-0.4583333134651184,0.4779180288314819,-0.4551281929016113,0.4921140074729919,0,0.4668769836425781,0.4326919913291931,-0.4668769836425781,0.4326919913291931,-0.4936908483505249,0],0]]]],[],!1,!1,7707803254097929,[],null],["t112",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6077536771608844,[["sprite28-sheet0.png",164718,0,0,634,312,1,0.5,0.5,[],[-0.4779179990291596,-0.4551281929016113,0.4779180288314819,-0.4551281929016113,
0.4921140074729919,0,0.4668769836425781,0.4326919913291931,-0.4668769836425781,0.4326919913291931,-0.4936908483505249,0],0]]]],[],!1,!1,615730195571442,[],null],["t113",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9440426685659340,[["sprite28-sheet0.png",164718,0,0,634,312,1,0.5,0.5,[],[-0.4779179990291596,-0.4551281929016113,0.4779180288314819,-0.4551281929016113,0.4921140074729919,0,0.4668769836425781,0.4326919913291931,-0.4668769836425781,0.4326919913291931,-0.4936908483505249,0],
0]]]],[],!1,!1,83620575576758,[],null],["t114",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb4d3fd503131f,[["facebook-sheet0.png",31348,258,1,250,250,1,0.5,0.5,[],[-0.4319999814033508,-0.4319999814033508,0,-0.492000013589859,0.4319999814033508,-0.4319999814033508,0.4679999947547913,0,0.4160000085830689,0.4160000085830689,0,0.4599999785423279,-0.4160000085830689,0.4160000085830689,-0.4679999947547913,0],0]]],["OK",5,!1,1,0,!1,0xaa1850edac800,[["facebook-sheet0.png",31348,1,1,256,256,
1,0.5,0.5,[],[-0.421875,-0.421875,0,-0.4804686903953552,0.421875,-0.421875,0.4570310115814209,0,0.40625,0.40625,0,0.4492189884185791,-0.40625,0.40625,-0.4570311903953552,0],0]]]],[],!1,!1,895826254808014,[],null],["t115",cr.plugins_.Clay,!1,[],0,0,null,null,[],!1,!1,4621032213992182,[],null,["billytheball",1,0,1]],["t116",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5384877424765502,[["sprite30-sheet0.png",2079,0,0,86,27,1,0.5,0.5185185074806213,[],[-0.4772726893424988,-0.4470899105072022,
0.4772729873657227,-0.4470899105072022,0.4886360168457031,-0.01851850748062134,0.4545450210571289,0.3743385076522827,0,0.410052478313446,-0.4545454978942871,0.3743385076522827,-0.4886364042758942,-0.01851850748062134],0]]]],[],!1,!1,8904223875896659,[],null],["t117",cr.plugins_.TiledBg,!1,[],2,0,["tiledbackground7.png",2079,0],null,[["Pin",cr.behaviors.Pin,415579531599507],["Physics",cr.behaviors.Physics,9367717809375154]],!1,!1,433918042431737,[],null],["t118",cr.plugins_.Sprite,!1,[0x7e876f95b14c8],
0,0,null,[["off",5,!1,1,0,!1,7895169806852317,[["sprite31-sheet0.png",623,0,0,38,52,1,0.5,0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0,0.5,0.5,0.01644700765609741,0.5,-0.5,0.5,-0.5,0.002403974533081055],0]]],["on",5,!1,1,0,!1,4702079395568807,[["sprite31-sheet1.png",624,0,0,38,52,1,0.5,0.5,[],[-0.4736841917037964,-0.4807691872119904,0.4473680257797241,-0.4615384936332703,0.5,0,0.4473680257797241,0.4615380167961121,0,0.4807689785957336,-0.4473683834075928,0.4615380167961121,-0.5,0],0]]]],[],!1,!1,0x7cac71ead2d2e,
[],null],["t119",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x530b864cccd58,[["buraminhoca-sheet0.png",4120,0,0,95,99,1,0.5052631497383118,0.5050504803657532,[],[-0.2736841440200806,-0.2828284800052643,0.2736838459968567,-0.292929470539093,0.3684208393096924,-0.01010146737098694,0.1368418335914612,0.151515543460846,-0.0105261504650116,0.2727274894714356,-0.1894741356372833,0.1919195055961609,-0.2842101454734802,-0.01010146737098694],0]]]],[["Rotate",cr.behaviors.Rotate,5907029747983537]],
!1,!1,8526105908025265,[],null],["t120",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9000953284799164,[["espinhos-sheet0.png",31132,1,1,156,59,1,0.5,0.508474588394165,[],[-0.3653849959373474,-0.1525425910949707,0,-0.203389585018158,0.339743971824646,-0.08474558591842651,0.3461539745330811,-0.01694959402084351,0.4743589758872986,0.4237284064292908,0,0.4745764136314392,-0.474359005689621,0.4237284064292908,-0.3846150040626526,-0.01694959402084351],0]]]],[["Solid",cr.behaviors.solid,7381253102399316]],
!1,!1,6744238496303041,[],null],["t121",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x629376caf97bb,[["espinhos-sheet0.png",31132,158,1,92,58,1,0.5,0.5,[],[-0.2826089859008789,-0.1551719903945923,0,-0.3793100118637085,0.2608699798583984,-0.1206899881362915,0.2826089859008789,0,0.4565219879150391,0.4310349822044373,0,0.4827589988708496,-0.4565216898918152,0.4310349822044373,-0.3152170181274414,0],0]]]],[["Sine",cr.behaviors.Sin,0x6cb1d12d8bc66]],!1,!1,5764949101830305,[],null],["t122",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7633993622065266,[["sprite34-sheet0.png",4669,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,5676151261046041,[],null],["t123",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,5680514550251596,[["serragiratoria-sheet0.png",3043,0,0,100,100,1,0.5,0.5,[],[-0.3299999833106995,-0.3299999833106995,0,-0.5,0.3399999737739563,-0.3400000035762787,0.4599999785423279,0,0.3399999737739563,0.3399999737739563,0,0.4900000095367432,-0.3400000035762787,
0.3399999737739563,-0.4600000083446503,0],0]]]],[["Rotate",cr.behaviors.Rotate,8855732368702471],["Sine",cr.behaviors.Sin,8166445620235598]],!1,!1,0xa3d44d2034d0d,[],null],["t124",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7194140484147072,[["sprite36-sheet0.png",4063,0,0,160,30,1,0.1062500029802322,0.5333333611488342,[["Imagepoint 1",0.90625,0.5333333611488342]],[-0.06875000149011612,-0.3333333730697632,0.393750011920929,-0.4333333671092987,0.8562500476837158,-0.3333333730697632,0.875,
-0.03333336114883423,0.8562500476837158,0.2666666507720947,0.393750011920929,0.3666666150093079,-0.06875000149011612,0.2666666507720947,-0.08750000596046448,-0.03333336114883423],0]]]],[["Physics",cr.behaviors.Physics,0xb0a2eb0b37396]],!1,!1,6096344234098589,[],null],["t125",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,628973766966104,[["sprite37-sheet0.png",3194,0,0,92,28,1,0.1521739065647125,0.5714285969734192,[["Imagepoint 1",0.8695651888847351,0.5357142686843872]],[-0.09782610833644867,
-0.3928576111793518,0.3478260934352875,-0.4642856121063232,0.7934781312942505,-0.3928576111793518,0.8369561433792114,-0.07142859697341919,0.7934781312942505,0.2500004172325134,0.3478260934352875,0.3571423888206482,-0.1086956113576889,0.2857143878936768,-0.1521739065647125,-0.07142859697341919],0]]]],[],!1,!1,5094067451298387,[],null],["t126",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xf33eb4c0a640c,[["groundrot-sheet0.png",3693,0,0,128,28,1,0.1328125,0.5,[["Imagepoint 1",0.8828125,
0.5]],[-0.09375,-0.3214290142059326,0.3671875,-0.4285714030265808,0.8203125,-0.2857140004634857,0.8437504768371582,0,0.8203125,0.2857139706611633,0.3671875,0.3928570151329041,-0.0859375,0.2857139706611633,-0.1171875,0],0]]]],[["Sine",cr.behaviors.Sin,5696948515741641]],!1,!1,0xc7f3c1cc39f88,[],null],["t127",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,7307984087142318,[["serragiratoria-sheet0.png",3043,0,0,100,100,1,0.5,0.5,[],[-0.3299999833106995,-0.3299999833106995,0,-0.5,0.3399999737739563,
-0.3400000035762787,0.4599999785423279,0,0.3399999737739563,0.3399999737739563,0,0.4900000095367432,-0.3400000035762787,0.3399999737739563,-0.4600000083446503,0],0]]]],[["Rotate",cr.behaviors.Rotate,0x76e145727600],["Sine",cr.behaviors.Sin,0xfec376564e76c]],!1,!1,0x7610e0a81e869,[],null],["t128",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7522933447406164,[["sprite40-sheet0.png",273,0,0,35,16,1,0.5142857432365417,0.5,[],[-0.349999725818634,-0.5,-0.02857175469398499,-0.5,0.3000002503395081,
-0.49609375,0.4857142567634583,0,0.4857142567634583,0.4335939884185791,-0.5142857432365417,0.4414060115814209,-0.5142857432365417,-0.0976560115814209],0]]]],[["Physics",cr.behaviors.Physics,8518612635866141]],!1,!1,9465789193608068,[],null],["t129",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,9721112741859418,[["serragiratoria-sheet0.png",3043,0,0,100,100,1,0.5,0.5,[],[-0.3299999833106995,-0.3299999833106995,0,-0.5,0.3399999737739563,-0.3400000035762787,0.4599999785423279,0,0.3399999737739563,
0.3399999737739563,0,0.4900000095367432,-0.3400000035762787,0.3399999737739563,-0.4600000083446503,0],0]]]],[["Rotate",cr.behaviors.Rotate,0xbea6fe5a079b7],["Sine",cr.behaviors.Sin,0xfba47236b3a3d]],!1,!1,0xce6f438bc9275,[],null]],[],[["Company",854,480,!0,"CompanyEvents",8329237130376641,[["Layer 0",0,0xa6c175d6b4d4a,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[496.5,244,0,1597,1030,0,0,1,0.5,0.5,0,0,[]],72,878,[],[],[0,"Default",0,1]],[[-156,-152.72607421875,0,1258.962036132813,737.7109375,0,0,1,0,0,0,
0,[]],4,116,[],[],[0,0]],[[466,240,0,283,64,0,0,1,0.6289752721786499,0.875,0,0,[]],71,874,[],[],[0,"Default",0,1]]],[]]],[],[]],["Loading",854,480,!0,"LoadingEvents",8258678571383995,[["Layer 0",0,0x51d02b5c9df0b,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[-262,-125,0,1297,760,0,0,1,0,0,0,0,[]],4,857,[],[],[0,0]],[[768,432,0,66,66,0,0,1,0.5064935088157654,0.5064935088157654,0,0,[]],62,858,[],[[300,0]],[0,"Default",0,1]]],[]]],[],[]],["StartScreen",854,480,!0,"StartScreenEvents",0xbfcee7c1a4676,[["Layer 0",
0,0x94342e334a9fb,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[427,244,0,972,598,0,0,1,0.5,0.5,0,0,[]],100,0,[],[],[0,"Default",0,1]],[[-187,-507,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,123,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[422,441,0,500,49,0,0,1,0.5,0.5102040767669678,0,0,[]],102,863,[],[],[0,"Default",0,1]],[[421,227,0,338,413,0,0,1,0.5059171319007874,0.501210629940033,0,0,[]],47,118,[],[[1,6,0,0,0,0,0,0,0]],[0,"Default",0,1]]],[]]],[],[]],["Beta Version",854,480,!0,"GameEventsBlue",0x626b22c994146,
[["Layer 0",0,6629910155257735,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[-318,-126,0,1334,817,0,0,1,0,0,0,0,[]],46,640,[],[],[0,0]],[[-287,-126,0,1419,777,0,0,1,0,0,0,0,[]],4,681,[],[],[0,0]],[[429,153,0,380.9136352539063,194.0334777832031,0,0,1,0.5,0.5023041367530823,0,0,[]],2,745,[],[],[0,"Default",0,1]],[[131,314,0,599,85,0,0,1,0,0,0,0,[]],73,746,[],[],["This is a BETA version, Full Version coming soon. Touch here to go back",0,"bold 20pt Comic Sans MS","rgb(255,255,255)",1,0,0,0,0]],[[55,60,0,70,
77,0,0,1,0.5,0.5064935088157654,0,0,[]],38,2004,[],[],[0,"Default",0,1]]],[]]],[],[]],["Worlds",854,480,!0,"WorldsEvents",0x62a2ab9199877,[["Layer 0",0,0x3fe74be94a9f7,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[427,244,0,972,598,0,0,1,0.5,0.5,0,0,[]],100,1268,[],[],[0,"Default",0,1]],[[424,250,0,600,477,0,0,1,0.5,0.50104820728302,0,0,[]],104,2,[],[],[0,"Default",0,1]],[[214,375,0,167,165,0,0,1,0.5023923516273499,0.5,0,0,[]],31,3,[],[[1,1]],[0,"Default",0,1]],[[640,378,0,167,165,0,0,1,0.5023923516273499,
0.5023923516273499,0,0,[]],32,7,[],[],[0,"Default",0,1]],[[428.5,376.5,0,167,165,0,0,1,0.5,0.5,0,0,[]],33,112,[],[],[0,"Default",0,1]],[[56,59,0,70,77,0,0,1,0.5,0.5064935088157654,0,0,[]],38,35,[],[],[0,"Default",0,1]]],[]]],[],[]],["Shopping",854,480,!0,"ShoppingEvents",5737971242535462,[["Layer 0",0,0x5bf62aadf9a62,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[427,244,0,972,598,0,0,1,0.5,0.5,0,0,[]],100,98,[],[],[0,"Default",0,1]],[[-410,786,0,1626,990,0,0,1,0,0,0,0,[]],4,70,[],[],[0,0]],[[56,59,0,70,77,
0,0,1,0.5,0.5064935088157654,0,0,[]],38,121,[],[],[0,"Default",0,1]]],[]]],[],[]],["Cutscene",854,480,!0,"CutsceneEvents",0x710cc60092145,[["Layer 0",0,5138181498795875,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[374,193,0,2704,1969,0,0,1,0.5,0.5,0,0,[]],72,879,[],[],[0,"Default",0,1]],[[-234,-1079,0,1297,760,0,0,1,0,0,0,0,[]],4,873,[],[],[0,0]],[[428,239,0,798.0074462890625,477.0247802734375,0,0,1,0.4981273412704468,0.4968814849853516,0,0,[]],57,854,[],[[1,1,1,0,0]],[0,"Default",0,1]],[[781,453,0,62.61582946777344,
21.59166526794434,0,0,1,0.5057471394538879,0.5333333611488342,0,0,[]],61,855,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevelMenu",854,480,!0,"GameEventsBlue",7077381426736044,[["Levels fundo",0,4843615243473795,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[427,244,0,972,598,0,0,1,0.5,0.5,0,0,[]],100,4,[],[],[0,"Default",0,1]],[[436,299,0,634,312,0,0,1,0.5,0.467948704957962,0,0,[]],6,6,[[1],[1]],[],[0,"Default",0,1]],[[56,59,0,70,77,0,0,1,0.5,0.5064935088157654,0,0,[]],38,159,[],[],[0,"Default",0,1]],[[434,
86,0,133,147,0,0,1,0.5037593841552734,0.5102040767669678,0,0,[]],35,97,[],[],[0,"Default",0,1]]],[]],["Estrelas",1,0x81cdef827a4a5,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]],["Levels Choose",2,0xecf7216eb2fdf,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[165,192,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,15,[],[],[0,"Default",0,1]],[[275,192,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,41,[],[],[0,"Default",0,1]],[[385,191,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],
26,46,[],[],[0,"Default",0,1]],[[493,192,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,82,[],[],[0,"Default",0,1]],[[711,193,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,84,[],[],[0,"Default",0,1]],[[167,297,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,85,[],[],[0,"Default",0,1]],[[274,296,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,86,[],[],[0,"Default",0,1]],[[383,297,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,87,[],[],[0,"Default",
0,1]],[[492,296,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,88,[],[],[0,"Default",0,1]],[[603,298,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,89,[],[],[0,"Default",0,1]],[[711,299,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,90,[],[],[0,"Default",0,1]],[[164,409,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,91,[],[],[0,"Default",0,1]],[[274,410,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,92,[],[],[0,"Default",0,1]],[[385,409,
0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,93,[],[],[0,"Default",0,1]],[[492,412,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,94,[],[],[0,"Default",0,1]],[[602,409,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,95,[],[],[0,"Default",0,1]],[[712,408,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,96,[],[],[0,"Default",0,1]],[[1085,180,0,71.13623046875,69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,83,[],[],[0,"Default",0,1]],[[599,193,0,71.13623046875,
69.8659439086914,0,0,1,0.5,0.5,0,0,[]],26,99,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel1",854,480,!0,"BlueLevel1Events",0xbcad0c64fa78e,[["pl5 fundo",0,0x8eb073bb1f641,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,1260,[],[],[0,"Default",0,1]]],[]],["pl4 casa",1,6035078977873537,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[229,282,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,1264,[],[],[0,"Default",0,1]]],[]],["pl3 cerca",2,7225731620363469,
!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.861572265625,296.9994506835938,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,1267,[],[],[0,"Default",0,1]]],[]],["pl2 lixeira",3,7554263011644334,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,1272,[],[],[0,"Default",0,1]]],[]],["pl1 garagem",4,9923459386059756,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4332275390625,284.0005493164063,
0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,1265,[],[],[0,"Default",0,1]]],[]],["Layer 0",5,7909399299471309,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[102,40,0,111,30,0,0,1,0,0,0,0,[]],52,9,[],[],["Level 1",0,"bold 16pt Trebuchet MS","rgb(255,255,255)",0,0,0,0,0]],[[405,161,0,202.0477447509766,125.4505386352539,0,0,1,0.5014925599098206,0.5,0,0,[]],63,482,[],[],[0,"Default",0,1]],[[414,66,0,361,89,0,0,1,0.5013850331306458,0.516853928565979,0,0,[]],64,860,[],[],[0,"Default",0,1]],[[364.118408203125,
144.6737213134766,0,42,42,0,0.007844389416277409,1,0.5,0.5,0,0,[]],66,861,[],[],[0,"Default",0,1]],[[447.5083923339844,145.18798828125,0,42,42,0,0,1,0.5,0.5,0,0,[]],67,862,[],[],[0,"Default",0,1]]],[]],["piscina",6,0x6f00e89a75d0b,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,1266,[],[],[0,"Default",0,1]]],[]],["Game",7,0x43a2af6c690f0,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[747.1254272460938,347.6976928710938,0,29,108.9259033203125,
0,0,1,0.517241358757019,0.5,0,0,[]],103,1,[],[],[0,"Default",0,1]],[[735,264,0,102.2435836791992,67.22383117675781,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,25,[],[],[0,"Default",0,1]],[[724.860595703125,487.5377197265625,0,82.82232666015625,54.86715698242188,0,0,1,0.5,3.940476179122925,0,0,[]],49,77,[],[],[0,"Default",0,1]],[[254,315.1019592285156,0,45,44,0,0,1,0.5,0.5064935088157654,0,0,[]],14,20,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[603,276,0,45,44,0,0,1,0.5,0.5064935088157654,
0,0,[]],14,21,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[448,303,0,45,44,0,0,1,0.5,0.5064935088157654,0,0,[]],14,22,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[70,377.8877258300781,0,126,22,0,0,1,0.5,0.5,0,0,[]],11,13,[],[[1]],[0,"Default",0,1]],[[256,388,0,126,22,0,0,1,0.5,0.5,0,0,[]],11,14,[],[[1]],[0,"Default",0,1]],[[452,386,0,126,22,0,0,1,0.5,0.5,0,0,[]],11,16,[],[[1]],[0,"Default",0,1]],[[610,337,0,126,22,0,0,1,0.5,0.5,0,0,[]],11,17,[],[[1]],[0,"Default",0,1]],[[378,-17,0,126,22,0,0,1,0.5,0.5,0,
0,[]],11,18,[],[[1]],[0,"Default",0,1]],[[505,625,0,1634,14,0,0,1,0.5,0.5,0,0,[]],9,19,[[3]],[[1]],[0,"Default",0,1]],[[725.4337768554688,310.8108520507813,0,82.84976959228516,47.83740997314453,0,0,1,0.5,0.5138888955116272,0,0,[]],16,31,[],[],[0,"Default",0,1]],[[695.7314453125,308.6682434082031,0,2.372452735900879,49.13095474243164,0,-0.4217792451381683,1,0.5,0.5,0,0,[]],21,24,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[754.2720336914062,307.554931640625,0,2.372452735900879,45.86328887939453,
0,0.503050684928894,1,0.5,0.5,0,0,[]],21,27,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[723.783447265625,319.6083068847656,0,43.060791015625,4.834136962890625,0,0,1,0.5,0.5,0,0,[]],22,28,[],[],[0,"Default",0,1]],[[724.1065063476562,325.2760925292969,0,2.372452735900879,39.75285339355469,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,29,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[487,-190,0,33,43,0,0,1,0.5,0.5,0,0,[]],17,23,[],[],["0",0,"bold 20pt Comic Sans MS","rgb(255,255,255)",
1,0,1,0,0]],[[83,319,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,26,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]]],[]],["grama",8,4889694252053618,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[798,377,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,1271,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,0x6348cbb6cacbb,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,106,[],[],[0,"Default",0,1]],
[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,107,[],[],[0,"Default",0,1]]],[]],["gui",10,8396298689489166,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[56,59,0,70,77,0,0,1,0.5,0.5064935088157654,0,0,[]],7,32,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,38,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[690,437,0,66,66,0,0,1,0.5064935088157654,0.5064935088157654,0,0,[]],62,864,[],[[300,0]],[1,"Default",0,1]],[[-617.69189453125,603.9722900390625,0,625.488525390625,
411.7581481933594,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,39,[],[],[1,"Default",0,1]],[[-595.5071411132812,907.4928588867188,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,813,[],[],[0,"Default",0,1]],[[465.6000061035156,1141.800048828125,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,700,[],[],[0,"Default",0,1]],[[175.6000061035156,1138.300048828125,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1389,[],[],[0,"Default",0,1]],[[367.6000061035156,
1138.300048828125,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1390,[],[],[0,"Default",0,1]],[[559.5999755859375,1138.300048828125,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1731,[],[],[0,"Default",0,1]],[[751.5999755859375,1138.300048828125,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1732,[],[],[0,"Default",0,1]]],[]],["estrelas",11,5279234266959003,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[780,34,0,108,35,0,0,1,0.5092592835426331,0.5142857432365417,
0,0,[]],70,859,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel2",854,480,!0,"BlueLevel2Events",9493802784677528,[["Fundo",0,6258593506222693,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[],[]],["Ceu",1,7689772152099634,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,135,[],[],[0,"Default",0,1]]],[]],["Casa",2,7418547521769374,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,
0,0,[]],93,2023,[],[],[0,"Default",0,1]]],[]],["Cerca",3,4508069577457386,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,2024,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,69539230121264,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,2025,[],[],[0,"Default",0,1]]],[]],["Garagem",5,6918820457385919,!0,[255,255,255],
!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,2026,[],[],[0,"Default",0,1]]],[]],["Piscina",6,8968155672572459,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,2027,[],[],[0,"Default",0,1]]],[]],["Game",7,0x50b003bf62c56,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[227,140,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,45,[[0],[5]],[[180,0]],[0,"Default",0,1]],
[[333,271,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,47,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[431,143,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,48,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[72,264,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,49,[],[[1]],[0,"Default",0,1]],[[211.1341552734375,352.7032470703125,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,50,[],[[1]],[0,"Default",0,1]],[[466.1341857910156,348.7032470703125,0,100.8000030517578,20.53333282470703,
0,0,1,0.5,0.5,0,0,[]],11,51,[],[[1]],[0,"Default",0,1]],[[505,625,0,1634,14,0,0,1,0.5,0.5,0,0,[]],9,54,[[3]],[[1]],[0,"Default",0,1]],[[225.1341552734375,207.7032470703125,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,193,[],[[1]],[0,"Default",0,1]],[[433.1341857910156,211.7032470703125,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,192,[],[[1]],[0,"Default",0,1]],[[734.3629760742188,348.5045776367188,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,
1304,[],[],[0,"Default",0,1]],[[732,264,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,44,[],[],[0,"Default",0,1]],[[722,488,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,61,[],[],[0,"Default",0,1]],[[721.9019775390625,311.4703369140625,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,66,[],[],[0,"Default",0,1]],[[694.1962890625,312.6046447753906,0,2.372452735900879,54.49265670776367,0,-0.4393978118896484,
1,0.5,0.5,0,0,[]],21,55,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[749.4129028320312,312.0304870605469,0,3.269827127456665,53.47713088989258,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,56,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[721.1329956054688,324.465576171875,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,57,[],[],[0,"Default",0,1]],[[720.6270751953125,334.9408264160156,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],
21,58,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[68,192,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,62,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]]],[]],["Grama",8,9020553626751144,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,1286,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,0xbf0b69f06ff72,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,
0.5027933120727539,0,0,[]],13,68,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,67,[],[],[0,"Default",0,1]]],[]],["gui",10,9329649474860634,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,108,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,109,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,
0,0,[]],19,111,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,187,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,188,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,189,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,190,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,
0,[]],43,191,[],[],[0,"Default",0,1]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,483,[],[],["Level 2",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,856,[],[],[0,"Default",0,1]],[[-507,788,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,814,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel3",854,480,!0,"BlueLevel3Events",0x9a35de27b86d5,[["Fundo",0,8979746848013957,!0,[255,
255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[],[]],["Ceu",1,464028977760378,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,1464,[],[],[0,"Default",0,1]]],[]],["Casa",2,6093266984023176,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,1465,[],[],[0,"Default",0,1]]],[]],["Cerca",3,0xfb031a15adfcc,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,
0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,1466,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,4981061778763618,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,1467,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0xf7843bff5af3,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,1468,[],[],[0,"Default",0,1]]],[]],["Piscina",
6,0x4d68b5623ff19,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,1469,[],[],[0,"Default",0,1]]],[]],["Game",7,0xc7eb4f204eeed,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[505,625,0,1634,14,0,0,1,0.5,0.5,0,0,[]],9,1609,[[3]],[[1]],[0,"Default",0,1]],[[92,149,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1477,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[76,295,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1539,[[0],[5]],[[180,0]],[0,"Default",
0,1]],[[350,147,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1540,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[83,366,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,1541,[],[[1]],[0,"Default",0,1]],[[347,362,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,1542,[],[[1]],[0,"Default",0,1]],[[352,203,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,1543,[],[[1]],[0,"Default",0,1]],[[348,261,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,1613,
[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[88,209,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,1614,[],[[1]],[0,"Default",0,1]],[[503,287,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,1831,[],[[1]],[0,"Default",0,1]],[[771,348,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,1835,[],[],[0,"Default",0,1]],[[769,264,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1836,[],[],[0,
"Default",0,1]],[[758,488,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,1837,[],[],[0,"Default",0,1]],[[758,311,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1838,[],[],[0,"Default",0,1]],[[730,311,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1839,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[785,310,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1840,[],
[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[757,324,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1841,[],[],[0,"Default",0,1]],[[756,335,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1845,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,0x6627d5f415500,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,1945,[],[],[0,"Default",0,1]]],[]],
["Direcionais",9,7356073817935625,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1987,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2017,[],[],[0,"Default",0,1]]],[]],["gui",10,945186783801069,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2018,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2019,[],[[60,0],[1,6,0,4,0,0,0,70,
0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2020,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2021,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2022,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2050,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],42,2051,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2052,[],[],[0,"Default",0,1]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2054,[],[],["Level 3",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1615,[],[],[0,"Default",0,1]],[[-500,795,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,815,[],[],[0,"Default",0,1]]],[]]],
[],[]],["BlueLevel4",854,480,!0,"BlueLevel4Events",0x8b1db0ff9563e,[["Fundo",0,6917951999557671,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,53,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,210,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,
250,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,251,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,252,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,321,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,322,[],
[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,323,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,324,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2028,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,
0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2029,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2030,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2031,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2033,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[1729,-126,0,126,22,0,0,1,0.5,0.5,0,0,[]],11,2034,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,0x7da58a8a0d1d5,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,2056,[],[],[0,"Default",0,1]]],[]],["Casa",2,9996295057720276,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,2057,[],[],[0,"Default",0,1]]],[]],["Cerca",3,8229417593445875,!0,[255,255,255],!0,0.07999999821186066,0,1,
!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,2058,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,9023142113195620,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,2059,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0xc35678f5817d4,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,
[]],96,2060,[],[],[0,"Default",0,1]]],[]],["Piscina",6,7507834164383572,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,2061,[],[],[0,"Default",0,1]]],[]],["Game",7,8945565358589037,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2062,[],[],[0,"Default",0,1]],[[1599,-80,0,126,22,0,0,1,0.5,0.5,0,0,[]],11,2063,[],[[1]],[0,"Default",0,1]],[[544,-127,0,100.8000030517578,
20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2064,[],[[1]],[0,"Default",0,1]],[[790.5,625,0,3223,14,0,0,1,0.5,0.5,0,0,[]],9,2065,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2066,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2067,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,
2068,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2069,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2070,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2071,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,2072,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2073,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2074,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2075,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,
0,0,[]],16,2076,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2077,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2078,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2079,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,
0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2080,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[80,217,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,232,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[760,360,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2081,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[764,183,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2082,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[72,413,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2083,[],[[1]],[0,"Default",
0,1]],[[753,244,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2084,[],[[1]],[0,"Default",0,1]],[[759,423,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2085,[],[[1]],[0,"Default",0,1]],[[394,318,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2086,[],[[1]],[0,"Default",0,1]],[[74,361,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2087,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[75,282,0,100.8000030517578,
20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2088,[],[[1]],[0,"Default",0,1]],[[619,374,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2089,[],[[1]],[0,"Default",0,1]],[[575,167,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2090,[],[[1]],[0,"Default",0,1]],[[529,291,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2091,[],[[1]],[0,"Default",0,1]],[[214,380,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2092,[],[[1]],[0,"Default",0,1]],[[400,
254,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2093,[],[],[0,"Default",0,1]],[[400,170,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2094,[],[],[0,"Default",0,1]],[[410,393,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2095,[],[],[0,"Default",0,1]],[[410,217,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2096,[],[],[0,"Default",0,1]],[[383,217,0,2.372452735900879,52.66129302978516,
0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2097,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[437,216,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2114,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[410,230,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2115,[],[],[0,"Default",0,1]],[[409,240,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2116,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]]],[]],["Grama",8,5543926171545548,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,2098,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,6353489776739497,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2099,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2100,[],[],[0,"Default",0,1]]],[]],["gui",10,6062643563095764,
!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2101,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2102,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2103,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2104,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],40,2105,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2106,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2107,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2108,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2109,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2110,[],[],["Level 4",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",
0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2111,[],[],[0,"Default",0,1]],[[-551,834,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,816,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel5",854,480,!0,"BlueLevel5Events",7199788491895585,[["Fundo",0,0x3e1b9c2ed686e,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,2117,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2118,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2119,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2120,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,
2121,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2122,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2123,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2124,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,
0,0,1,0.5,0.5,0,0,[]],22,2125,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2126,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2127,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2128,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2129,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2130,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2131,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,8296279200574095,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,2132,[],
[],[0,"Default",0,1]]],[]],["Casa",2,5118033523899949,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,2133,[],[],[0,"Default",0,1]]],[]],["Cerca",3,0xf3f891aaffd9,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,2134,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,6440945511589141,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,
[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,2135,[],[],[0,"Default",0,1]]],[]],["Garagem",5,9272350183903564,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,2136,[],[],[0,"Default",0,1]]],[]],["Piscina",6,8515257914099528,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,2137,[],[],[0,"Default",0,1]]],[]],["Game",
7,0x8308fd27eb021,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2138,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2139,[],[[1]],[0,"Default",0,1]],[[439.5,625,0,2657,14,0,0,1,0.5,0.5,0,0,[]],9,2141,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2142,[],[],[0,"Default",0,1]],
[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2143,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2144,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2145,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2146,[],[[1],[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2147,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2148,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2149,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,2150,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2151,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2152,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2153,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,
1,0.5,0.5,0,0,[]],21,2154,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2155,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2156,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[435,370,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2157,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[797,302,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,
2158,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[795,184,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2159,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[101,440,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2160,[],[[1]],[0,"Default",0,1]],[[438,436,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2161,[],[[1]],[0,"Default",0,1]],[[827,230,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2162,[],[[1]],[0,"Default",0,1]],[[751,432,0,100.8000030517578,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,2163,[],[[1]],[0,"Default",0,1]],[[98,306,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2164,[],[[1]],[0,"Default",0,1]],[[105,362,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2165,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[819,350,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2166,[],[[1]],[0,"Default",0,1]],[[420,230,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2167,[],[[1]],
[0,"Default",0,1]],[[642,199,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2168,[],[[1]],[0,"Default",0,1]],[[567,302,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2169,[],[[1]],[0,"Default",0,1]],[[260,184,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2170,[],[[1]],[0,"Default",0,1]],[[97,244,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2171,[],[],[0,"Default",0,1]],[[97,160,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,
0.5050504803657532,0,0,[]],18,2172,[],[],[0,"Default",0,1]],[[107,383,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2173,[],[],[0,"Default",0,1]],[[107,207,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2174,[],[],[0,"Default",0,1]],[[80,207,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2175,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[134,206,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,
1,0.5,0.5,0,0,[]],21,2176,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[107,220,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2177,[],[],[0,"Default",0,1]],[[106,230,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2193,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,9947042432256386,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,2178,
[],[],[0,"Default",0,1]]],[]],["Direcionais",9,9592082127561984,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2179,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2180,[],[],[0,"Default",0,1]]],[]],["gui",10,9922016139909062,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2181,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2182,
[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2183,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2184,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2185,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2186,[],[],[0,"Default",0,1]],[[503,864,0,87,83,
0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2187,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2188,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2189,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2190,[],[],["Level 5",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2191,[],[],[0,"Default",0,1]],
[[-491,818,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,822,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel6",854,480,!0,"BlueLevel6Events",8698780491289761,[["Fundo",0,63465313388266,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2140,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2194,[],
[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2195,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2196,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2197,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2198,[],[],[0,
"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2199,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2200,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2201,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,
0.5,0.5,0,0,[]],21,2202,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2203,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2204,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2205,[],[],[0,"Default",0,1]],[[1602,
-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2206,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2207,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,9181053713292464,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,2208,[],[],[0,"Default",0,1]]],[]],["Casa",2,0x873ace83120c4,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,
196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,2209,[],[],[0,"Default",0,1]]],[]],["Cerca",3,8513498681147878,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,2210,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,7497115157590004,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,2211,[],[],[0,"Default",0,1]]],[]],["Garagem",5,
48622464615862,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,2212,[],[],[0,"Default",0,1]]],[]],["Piscina",6,8546324495123328,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,2213,[],[],[0,"Default",0,1]]],[]],["Game",7,6476217605911974,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,
0,[]],103,2214,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2215,[],[[1]],[0,"Default",0,1]],[[424.5,625,0,3131,14,0,0,1,0.5,0.5,0,0,[]],9,2216,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2217,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2218,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2219,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2220,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2221,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2222,[],[],[0,"Default",0,1]],
[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2223,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2224,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2225,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2226,[],[],[0,"Default",
0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2227,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2228,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2229,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,
[]],22,2230,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2231,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[302,236,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2232,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[820,185,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2233,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[455,274,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2234,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[108,
193,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2235,[],[[1]],[0,"Default",0,1]],[[411,410,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2236,[],[[1]],[0,"Default",0,1]],[[840,239,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2237,[],[[1]],[0,"Default",0,1]],[[101,465,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2238,[],[[1]],[0,"Default",0,1]],[[107,112,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2239,[[1],[3],
[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[420,227,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2240,[],[[1]],[0,"Default",0,1]],[[567,300,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2241,[],[[1]],[0,"Default",0,1]],[[238,363,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2242,[],[[1]],[0,"Default",0,1]],[[101,404,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2243,[],[],[0,"Default",0,1]],[[101,320,0,-102.2440032958984,
67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2244,[],[],[0,"Default",0,1]],[[111,543,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2245,[],[],[0,"Default",0,1]],[[111,367,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2246,[],[],[0,"Default",0,1]],[[84,367,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2247,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[138,366,0,
2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2248,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[111,380,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2249,[],[],[0,"Default",0,1]],[[110,390,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2250,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,7595222011901242,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,
0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,2254,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,825599431795709,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2255,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2256,[],[],[0,"Default",0,1]]],[]],["gui",10,8233694426957229,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2257,[],[],[0,"Default",
0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2258,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2259,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2260,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2261,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,
0,[]],41,2262,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2263,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2264,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2265,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2266,[],[],["Level 6",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,
0,0,[]],70,2267,[],[],[0,"Default",0,1]],[[-505,803,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,827,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel7",854,480,!0,"BlueLevel7Events",9393545353788384,[["Fundo",0,7167781679881444,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,42,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,
1,0.5,3.940476179122925,0,0,[]],49,59,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,60,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,63,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,64,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,
0,0,[]],16,65,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,75,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,110,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,158,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,194,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,195,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,196,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,197,[],[],[0,"Default",0,1]],[[1602,-322,
0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,198,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,199,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,7095728819625496,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,200,[],[],[0,"Default",0,1]]],[]],["Casa",2,6197620449031375,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,
196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,201,[],[],[0,"Default",0,1]]],[]],["Cerca",3,0x661dda8a1d7ae,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,202,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,8224424520001137,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,203,[],[],[0,"Default",0,1]]],[]],["Garagem",5,450678596503763,
!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,204,[],[],[0,"Default",0,1]]],[]],["Piscina",6,4976825172666471,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,205,[],[],[0,"Default",0,1]]],[]],["Game",7,0xec11642dca2b8,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,206,[],
[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,207,[],[[1]],[0,"Default",0,1]],[[566.5,625,0,3173,14,0,0,1,0.5,0.5,0,0,[]],9,208,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,209,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,211,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,
0,0,1,0.5,0.5138888955116272,0,0,[]],16,212,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,213,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,217,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,218,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,
28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,219,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,221,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,222,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,223,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,224,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,225,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,226,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,227,[],[],[0,"Default",0,1]],[[1582,
-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,228,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[65,399,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,230,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[808,314,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,231,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[398,397,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,233,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[96.54647827148438,218.6713562011719,0,124,21,0,0.2348227202892304,
1,0.5,0.5,0,0,[]],11,234,[],[[1]],[0,"Default",0,1]],[[396.5999755859375,458,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,235,[],[[1]],[0,"Default",0,1]],[[820,381,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,236,[],[[1]],[0,"Default",0,1]],[[382.9000244140625,297,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,238,[],[[1]],[0,"Default",0,1]],[[63,123,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,239,[[1],[3],[1]],[[400,1800,1800,
750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[618.9000244140625,298,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,240,[],[[1]],[0,"Default",0,1]],[[709.4000244140625,455,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,241,[],[[1]],[0,"Default",0,1]],[[77.5999984741211,454,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,242,[],[[1]],[0,"Default",0,1]],[[396,234,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,243,[],[],[0,"Default",0,1]],
[[394,149,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,244,[],[],[0,"Default",0,1]],[[383,373,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,245,[],[],[0,"Default",0,1]],[[383,196,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,248,[],[],[0,"Default",0,1]],[[355,196,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,249,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[410,196,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,253,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[382,209,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,254,[],[],[0,"Default",0,1]],[[381,220,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,255,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,4658042300128055,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,
0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,257,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,0xfeac705283434,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,258,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,259,[],[],[0,"Default",0,1]]],[]],["gui",10,7542318398578363,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,260,[],[],[0,"Default",0,1]],
[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,261,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,262,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,263,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,264,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,
265,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,266,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,283,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,294,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,295,[],[],["Level 7",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,
0,0,[]],70,296,[],[],[0,"Default",0,1]],[[-550,827,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,828,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel8",854,480,!0,"BlueLevel8Events",0xed742d87df285,[["Fundo",0,5096250035054643,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,161,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,
0.5,3.940476179122925,0,0,[]],49,185,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,186,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,214,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,215,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,
0,0,[]],16,216,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,229,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,246,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,247,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,
-1.570796489715576,1,0.5,0.5,0,0,[]],21,297,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,298,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,299,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,300,[],[],[0,"Default",
0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,301,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,302,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,4605956238656257,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,303,[],[],[0,"Default",0,1]]],[]],["Casa",2,0x536ecbb51861f,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,
0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,304,[],[],[0,"Default",0,1]]],[]],["Cerca",3,8039336546495116,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,305,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,0x9be37e67ff142,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,306,[],[],[0,"Default",0,1]]],
[]],["Garagem",5,391730561772496,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,307,[],[],[0,"Default",0,1]]],[]],["Piscina",6,4654453074140035,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,310,[],[],[0,"Default",0,1]]],[]],["Game",7,665977002743898,!0,[255,255,255],!0,0.1800000071525574,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,
0.5,0,0,[]],103,311,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,315,[],[[1]],[0,"Default",0,1]],[[685.5,625,0,4423,14,0,0,1,0.5,0.5,0,0,[]],9,316,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,317,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,318,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,319,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,326,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,346,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,347,[],[],[0,"Default",0,1]],[[1744,
-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,349,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,350,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,351,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,352,[],[],[0,"Default",0,1]],[[1584,
-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,353,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,354,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,355,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,356,[],[],
[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,358,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[97,302,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,359,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[465,344,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,360,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[450,102,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,361,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[108.6360015869141,206.9990234375,
0,118,21,0,0.2348227202892304,1,0.5,0.5,0,0,[]],11,362,[],[[1]],[0,"Default",0,1]],[[431.4000244140625,160,0,122,21,0,0,1,0.5,0.5,0,0,[]],11,363,[],[[1]],[0,"Default",0,1]],[[846,379,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,365,[],[[1]],[0,"Default",0,1]],[[277,469,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,366,[],[[1]],[0,"Default",0,1]],[[89,121,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,367,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,
1,1],[1]],[0,"Default",0,1]],[[609,225,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,368,[],[[1]],[0,"Default",0,1]],[[463.9000244140625,429,0,119,21,0,0,1,0.5,0.5,0,0,[]],11,369,[],[[1]],[0,"Default",0,1]],[[108,355,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,370,[],[[1]],[0,"Default",0,1]],[[278,410,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,374,[],[],[0,"Default",0,1]],[[278,326,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,
0.5050504803657532,0,0,[]],18,380,[],[],[0,"Default",0,1]],[[288,549,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,382,[],[],[0,"Default",0,1]],[[288,373,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,396,[],[],[0,"Default",0,1]],[[261,373,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,408,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[315,372,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,
1,0.5,0.5,0,0,[]],21,409,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[288,386,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,411,[],[],[0,"Default",0,1]],[[287,396,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,412,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,912848770389614,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,413,[],[],
[0,"Default",0,1]]],[]],["Direcionais",9,0x75b7c85c6813e,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,414,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,415,[],[],[0,"Default",0,1]]],[]],["gui",10,4796168588284402,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,416,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,417,[],[[60,
0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,418,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,421,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,422,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,423,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,
0.5060975551605225,0,0,[]],42,424,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,425,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,426,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,428,[],[],["Level 8",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,429,[],[],[0,"Default",0,1]],[[-544,852,0,75.41883087158203,
75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,829,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel9",854,480,!0,"BlueLevel9Events",5082494327421495,[["Fundo",0,6050508339240112,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,37,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,43,[],[],[0,"Default",0,1]],[[1435,-343,
0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,71,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,72,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,73,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,74,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,
52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,76,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,78,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,79,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,80,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,81,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,104,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,115,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,430,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,431,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,483771096395476,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,432,[],[],[0,"Default",0,1]]],[]],["Casa",2,5905478688161614,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,433,[],[],[0,
"Default",0,1]]],[]],["Cerca",3,0x985349889ae02,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,434,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,7044154363136211,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,437,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0xb237585fa7cf4,!0,[255,255,255],!0,0.1700000017881393,0,1,
!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,444,[],[],[0,"Default",0,1]]],[]],["Piscina",6,0x7973b33476d5a,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,445,[],[],[0,"Default",0,1]]],[]],["Game",7,7437659350144908,!0,[255,255,255],!0,0.3499999940395355,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,459,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,
20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,471,[],[[1]],[0,"Default",0,1]],[[515.5,625,0,3273,14,0,0,1,0.5,0.5,0,0,[]],9,472,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,474,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,475,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,476,
[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,477,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,478,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,479,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,480,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,481,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,484,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,485,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,
0,0,[]],16,486,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,487,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,488,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,490,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,
-1.570796489715576,1,0.5,0.5,0,0,[]],21,492,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[30,336,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,493,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[372,350,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,494,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[762,383,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,495,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[38,214,0,127,21,0,0.2348227202892304,1,0.5,0.5,0,0,[]],11,496,[],[[1]],[0,"Default",0,1]],[[375,
279,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,497,[],[[1]],[0,"Default",0,1]],[[574,206,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,499,[],[[1]],[0,"Default",0,1]],[[759,449,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,500,[],[[1]],[0,"Default",0,1]],[[-4,127,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,508,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[539,369,0,100.8000030517578,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,515,[],[[1]],[0,"Default",0,1]],[[357,422,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,516,[],[[1]],[0,"Default",0,1]],[[806,183,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,530,[],[[1]],[0,"Default",0,1]],[[28,404,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,542,[],[[1]],[0,"Default",0,1]],[[1011,330,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,543,[],[[1]],[0,"Default",0,1]],[[1008,267,0,29,108.9260025024414,
0,0,1,0.517241358757019,0.5,0,0,[]],103,545,[],[],[0,"Default",0,1]],[[1006,182,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,546,[],[],[0,"Default",0,1]],[[995,406,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,547,[],[],[0,"Default",0,1]],[[995,229,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,548,[],[],[0,"Default",0,1]],[[967,229,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,
1,0.5,0.5,0,0,[]],21,549,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1022,229,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,550,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[994,242,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,563,[],[],[0,"Default",0,1]],[[993,253,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2038,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",
8,0x3e06b02dcbc23,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,551,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,0x7486b6fb64972,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,552,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,867,[],[],[0,"Default",0,1]]],[]],["gui",10,0x497edaaa4eec9,!0,[255,255,255],!0,0,0,1,
!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,868,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,869,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,871,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,875,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,876,[],[],
[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,880,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,881,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,882,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2032,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2035,[],[],["Level 9",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,
0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2036,[],[],[0,"Default",0,1]],[[-496,778,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,830,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel10",854,480,!0,"BlueLevel10Events",4776412350263829,[["Fundo",0,0xf8f30509a866e,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,282,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,284,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,285,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,293,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,325,
[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,327,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,328,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,329,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,
0,0,1,0.5,0.5,0,0,[]],22,330,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,331,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,332,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,435,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,554,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,556,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,557,[],[[1]],[0,"Default",0,1]]],[]],["Ceu",1,0x7b95263cd7ccb,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,558,[],[],[0,"Default",
0,1]]],[]],["Casa",2,9415546706613582,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,559,[],[],[0,"Default",0,1]]],[]],["Cerca",3,8894372159474108,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,560,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,7004671704326991,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,
152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,561,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0x81ad2c4d9a4bf,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,562,[],[],[0,"Default",0,1]]],[]],["Piscina",6,6462575900586945,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,564,[],[],[0,"Default",0,1]]],[]],["Game",7,8310461099023144,!0,[255,255,255],
!0,0.449999988079071,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,572,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,579,[],[[1]],[0,"Default",0,1]],[[568.5,625,0,2905,14,0,0,1,0.5,0.5,0,0,[]],9,580,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,593,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,
0,0,1,0.5,3.940476179122925,0,0,[]],49,594,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,606,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,607,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,609,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,
-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,610,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,611,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,612,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,613,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,
54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,614,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,615,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,616,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,617,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,627,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2037,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[248,129,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2039,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[599,331,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2040,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[917,125,0,32,32,0,0,1,0.5,0.5064935088157654,
0,0,[]],14,2041,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[262,197,0,123,21,0,0,1,0.5,0.5,0,0,[]],11,2042,[],[[1]],[0,"Default",0,1]],[[29,216,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2043,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[0]],[0,"Default",0,1]],[[589,393,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2044,[],[[1]],[0,"Default",0,1]],[[227,372,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2045,[],[[1]],[0,"Default",0,1]],[[930,195,
0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2046,[],[[1]],[0,"Default",0,1]],[[18,368,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2047,[],[[1]],[0,"Default",0,1]],[[1248,172,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2048,[],[],[0,"Default",0,1]],[[435,300,0,90,18,0,0,1,0.5,0.5,0,0,[]],55,2049,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[696,221,0,89,18,0,0,1,0.5,0.5,0,0,[]],55,2055,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[1173,412,0,100.8000030517578,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,2112,[],[[1]],[0,"Default",0,1]],[[1170,349,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2113,[],[],[0,"Default",0,1]],[[1168,264,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2192,[],[],[0,"Default",0,1]],[[1157,488,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2251,[],[],[0,"Default",0,1]],[[1157,311,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,
2252,[],[],[0,"Default",0,1]],[[1129,311,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2253,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1184,311,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2268,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1156,324,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2269,[],[],[0,"Default",0,1]],[[1155,335,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,2270,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,7679561218063961,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,8829514074618753,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2272,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2273,[],[],[0,"Default",0,1]]],[]],["gui",10,0xb1a36b0f4c54f,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,
47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2274,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2275,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2276,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2277,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2278,[],[],[0,"Default",
0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2279,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2280,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2281,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2282,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2283,[],[],["Level 10",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,
28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2284,[],[],[0,"Default",0,1]],[[-554,789,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,831,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel11",854,480,!0,"BlueLevel11Events",5423652890564156,[["Fundo",0,6817361437241878,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],
18,122,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,125,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,129,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,130,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,131,[],[],
[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,132,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,133,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,134,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,
0.5,0.5,0,0,[]],22,160,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,308,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,309,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,312,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,313,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,314,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,7976201731973925,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,505,[],[],[0,"Default",0,1]]],[]],["Casa",2,893737966741913,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,
196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,620,[],[],[0,"Default",0,1]]],[]],["Cerca",3,0x60ea72ffb1a02,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,621,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,8965192141997559,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[653,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,622,[],[],[0,"Default",0,1]]],[]],["Garagem",5,7013230241450412,
!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[821.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,624,[],[],[0,"Default",0,1]]],[]],["Piscina",6,9883909274403648,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[431,430,0,1195,154,0,0,1,0.5,0.5031055808067322,0,0,[]],94,628,[],[],[0,"Default",0,1]]],[]],["Game",7,9596408100428952,!0,[255,255,255],!0,0.449999988079071,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,634,[],
[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,641,[],[[1]],[0,"Default",0,1]],[[643,625,0,4228,14,0,0,1,0.5,0.5,0,0,[]],9,642,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,655,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,656,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,
0,0,1,0.5,0.5138888955116272,0,0,[]],16,657,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,658,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,660,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,668,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,
28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,669,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,670,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,672,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,673,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,674,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,675,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,676,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,677,[],[],[0,"Default",0,1]],[[1582,
-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,678,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[574,311.0000305175781,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,679,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[244,297,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,682,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[893,303,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,683,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[550.0999755859375,370,0,92,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,684,[],[[1]],[0,"Default",0,1]],[[-66,299,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2285,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[0]],[0,"Default",0,1]],[[-77,373,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2286,[],[[1]],[0,"Default",0,1]],[[255,368,0,101,25,0,0,1,0.5,0.5,0,0,[]],55,2287,[],[[1,2,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[1092,291,0,89,25,0,0,1,0.5,0.5,0,0,[]],55,2288,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[912,369,
0,101,25,0,0,1,0.5,0.5,0,0,[]],55,2289,[],[[1,2,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[1026,190,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2299,[],[],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,320,[],[[1]],[0,"Default",0,1]],[[70,180,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,333,[],[],[0,"Default",0,1]],[[71,95,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,334,[],[],[0,"Default",0,1]],
[[81,318,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,335,[],[],[0,"Default",0,1]],[[81,142,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,336,[],[],[0,"Default",0,1]],[[53,143,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,337,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[108,142,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,338,[],[[1],[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[81,155,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,511,[],[],[0,"Default",0,1]],[[80,165,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,512,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[65,243,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,540,[],[[1]],[0,"Default",0,1]],[[915,221,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,541,[],[[1]],[0,"Default",0,1]],[[307,201,0,92,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,553,[],[[1]],[0,"Default",0,1]],[[620,219,0,101,25,0,0,1,0.5,0.5,0,0,[]],55,555,[],[[1,2,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]]],[]],["Grama",8,0x435952c3b7ba1,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[707.301025390625,376.6665649414063,0,-274.9115295410156,52,0,0,1,0.5,0.5,0,0,[]],105,2302,[],[],[0,"Default",0,1]]],[]],["Direcionais",9,8833387820471638,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2303,[],[],[0,"Default",
0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2304,[],[],[0,"Default",0,1]]],[]],["gui",10,0x90f099381414a,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2305,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2306,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2307,[],[],[1,"Default",0,1]],
[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2308,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2309,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2310,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2311,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2312,[],[],[0,"Default",0,
1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2313,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2314,[],[],["Level 11",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2315,[],[],[0,"Default",0,1]],[[-583,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,832,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel12",854,480,!0,"BlueLevel12Events",0x4e8557ec8403f,[["Fundo",
0,0x7d0bd505eca2e,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,565,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,768,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,769,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,
0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,807,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,808,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,847,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,848,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,
52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,888,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,901,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,906,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,907,[],[[1],[1,0,0,1,0.5,0.2,0,
0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,908,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,909,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,910,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,7346024909416016,!0,[255,255,255],!0,0,0,1,!1,1,
0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,911,[],[],[0,"Default",0,1]]],[]],["Casa",2,7191290509158029,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,912,[],[],[0,"Default",0,1]]],[]],["Cerca",3,727058298968941,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,913,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,5513047427003913,
!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[746,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,914,[],[],[0,"Default",0,1]]],[]],["Garagem",5,7801307013189794,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,915,[],[],[0,"Default",0,1]]],[]],["Piscina",6,0xd9a5b76e54f2a,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[486.5,430,0,1254,154,0,0,1,0.5,0.5031055808067322,0,
0,[]],94,916,[],[],[0,"Default",0,1]]],[]],["Game",7,9218773466636304,!0,[255,255,255],!0,0.550000011920929,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,917,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,918,[],[[1]],[0,"Default",0,1]],[[612,625,0,4456,14,0,0,1,0.5,0.5,0,0,[]],9,919,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,920,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,921,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2290,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2291,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,
1,0.5,0.5,0,0,[]],21,2292,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2293,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2294,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2295,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,
0.5038167834281921,0.5050504803657532,0,0,[]],18,2296,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2297,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2298,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2300,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,
52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2301,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2316,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2317,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2328,[],[[1]],[0,"Default",0,1]],[[64,163,0,32,
32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,274,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[344,330,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2318,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[638,87,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2319,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[63,222,0,123,21,0,0,1,0.5,0.5,0,0,[]],11,2320,[],[[1]],[0,"Default",0,1]],[[34,332,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2321,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[0]],[0,"Default",
0,1]],[[289,180,0,107,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2322,[],[[1]],[0,"Default",0,1]],[[640,136,0,92,21,0,0,1,0.5,0.5,0,0,[]],11,2323,[],[[1]],[0,"Default",0,1]],[[23,406,0,107,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2324,[],[[1]],[0,"Default",0,1]],[[1277,191,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2325,[],[],[0,"Default",0,1]],[[341,400,0,74.1050033569336,20,0,0,1,0.5,0.5,0,0,[]],55,2326,[],[[1,2,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[792,340,0,74.1050033569336,20,0,0,1,0.5,0.5,0,0,[]],
55,2327,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[473,312,0,74.1050033569336,20,0,0,1,0.5,0.5,0,0,[]],55,2330,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[980,262,0,114,20.56430053710938,0,0,1,0.5,0.5357142686843872,0,0,[]],56,2331,[],[[180,0],[1]],[0,"Default",0,1]],[[832,161,0,74.1050033569336,20,0,0,1,0.5,0.5,0,0,[]],55,2332,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[1202,401,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2333,[],[[1]],[0,"Default",0,1]],
[[1199,338,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2334,[],[],[0,"Default",0,1]],[[1198,253,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2335,[],[],[0,"Default",0,1]],[[1187,477,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2336,[],[],[0,"Default",0,1]],[[1187,300,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2337,[],[],[0,"Default",0,1]],[[1159,301,0,2.372452735900879,
52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2338,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1214,300,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2339,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1186,313,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2340,[],[],[0,"Default",0,1]],[[1185,324,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2357,[],[[1],[1,0,0,1,0.5,0.2,0,
0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,5708660276693742,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,0xea855d65a567b,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2342,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2343,[],[],[0,"Default",0,1]]],[]],["gui",10,0xa0a4441da621e,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2344,
[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2345,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2346,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2347,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2348,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],41,2349,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2350,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2351,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2352,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2353,[],[],["Level 12",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,
0.5142857432365417,0,0,[]],70,2354,[],[],[0,"Default",0,1]],[[-549,821,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,834,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel13",854,480,!0,"BlueLevel13Events",4689720217315423,[["Fundo",0,0xae5f4a843ce45,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,267,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,
0,0,1,0.5,3.940476179122925,0,0,[]],49,268,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,269,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,270,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,271,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,
0,0,[]],16,272,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,275,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,276,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,277,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,
-1.570796489715576,1,0.5,0.5,0,0,[]],21,278,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,279,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,280,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,281,[],[],[0,"Default",
0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,286,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,8207281689979014,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,287,[],[],[0,"Default",0,1]]],[]],["Casa",2,9024499951130682,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,288,[],[],[0,"Default",0,1]]],[]],["Cerca",
3,4760419564810711,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,289,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,9951079017648484,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[746,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,290,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0xc32c44503ec85,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,
284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,339,[],[],[0,"Default",0,1]]],[]],["Piscina",6,5592684798582183,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[570,458.310546875,0,1421,254,0,0,1,0.5,0.5031055808067322,0,0,[]],94,340,[],[],[0,"Default",0,1]]],[]],["Game",7,461280869453149,!0,[255,255,255],!0,0.6000000238418579,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,341,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,342,[],[[1]],[0,"Default",0,1]],[[677.5,625,0,3753,14,0,0,1,0.5,0.5,0,0,[]],9,343,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,379,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,381,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,383,[],[],[0,"Default",
0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,384,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,386,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,387,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,
[]],21,388,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,389,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,390,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,391,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,
0,[]],16,392,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,394,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,395,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,397,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,398,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,399,[],[[1]],[0,"Default",0,1]],[[174,132,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,400,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[404,299,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,401,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[875,100,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,402,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[161,191,
0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,405,[],[[1]],[0,"Default",0,1]],[[1434,223,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,427,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[388,146,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,569,[],[[1]],[0,"Default",0,1]],[[874.4000244140625,152,0,90,21,0,0,1,0.5,0.5,0,0,[]],11,2329,[],[[1]],[0,"Default",0,1]],[[1428,294,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,
0,0,[]],11,2341,[],[[1]],[0,"Default",0,1]],[[-38,189,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2355,[],[],[0,"Default",0,1]],[[401,369,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2356,[],[[1,2,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[533,281,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2360,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[1197,211.8298645019531,0,117,20.82797241210938,0,0,1,0.5,0.5357142686843872,0,0,[]],56,2361,[],[[-180,0],[1]],[0,"Default",0,1]],
[[1011,130,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2362,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[-14,357,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2363,[],[],[0,"Default",0,1]],[[-13,272,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2364,[],[],[0,"Default",0,1]],[[-3,495,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2365,[],[],[0,"Default",0,1]],[[-3,319,0,-82.21199798583984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2366,[],[],[0,"Default",0,1]],[[-31,320,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2367,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[24,319,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2368,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3,332,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2369,[],[],[0,"Default",0,1]],[[-4,342,
0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2370,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-19,420,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2371,[],[[1]],[0,"Default",0,1]]],[]],["Grama",8,0x853db9dbf1993,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,0xe09b6d2c43aef,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2372,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,
832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2373,[],[],[0,"Default",0,1]]],[]],["gui",10,8585597267352504,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2374,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2375,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2376,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,
0,0,1,0.5,0.5018050670623779,0,0,[]],34,2377,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2378,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2379,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2380,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2381,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,
760,0,0,1,0,0,0,0,[]],4,2382,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2383,[],[],["Level 13",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2384,[],[],[0,"Default",0,1]],[[-578,769,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,835,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel14",854,480,!0,"BlueLevel14Events",6911824859822472,[["Fundo",0,0xbbdcfa5bb40ad,
!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,291,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,292,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,344,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,
0.5050504803657532,0,0,[]],18,345,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,357,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,364,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,371,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,
0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,372,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,385,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,403,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,406,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,407,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,442,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,443,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,0x613124087695e,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,
0,0,1,0.5,0.5,0,0,[]],92,446,[],[],[0,"Default",0,1]]],[]],["Casa",2,0x4c453430790ad,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,447,[],[],[0,"Default",0,1]]],[]],["Cerca",3,0x84a15106991a5,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,448,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,6713230451957375,!0,[255,255,255],!0,0.1500000059604645,
0,1,!1,1,0,0,[[[746,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,449,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0x7e402a6751a37,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,450,[],[],[0,"Default",0,1]]],[]],["Piscina",6,5961420596637883,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[570,458.310546875,0,1421,254,0,0,1,0.5,0.5031055808067322,0,0,[]],94,454,[],[],[0,"Default",
0,1]]],[]],["Game",7,5011752451324774,!0,[255,255,255],!0,0.6000000238418579,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,455,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,456,[],[[1]],[0,"Default",0,1]],[[71.5,625,0,4817,14,0,0,1,0.5,0.5,0,0,[]],9,457,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,458,[],[],[0,"Default",
0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,460,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,461,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,462,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,463,[],[[1],
[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,464,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,465,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,466,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,467,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,468,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,469,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,470,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,
0.5,0.5,0,0,[]],21,513,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,514,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,517,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,518,[],[[1]],[0,"Default",0,1]],[[75,106,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,519,
[[0],[5]],[[180,0]],[0,"Default",0,1]],[[1288,92,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,520,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[8,356,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,521,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[1075,356,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,525,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[0]],[0,"Default",0,1]],[[2,408,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2271,[],[[1]],[0,"Default",0,1]],[[1064,430,
0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2358,[],[[1]],[0,"Default",0,1]],[[21,261,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2359,[],[],[0,"Default",0,1]],[[77,167.2777709960938,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,2385,[],[[1,2,0,4,0,0,0,80,0],[1]],[0,"Default",0,1]],[[885,290.2777709960938,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,2386,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[1278,190.2777709960938,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,2387,[],[[1,2,0,4,0,0,0,80,0],[1]],[0,"Default",0,1]],
[[277,315.2777709960938,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,2388,[],[[1,1,0,4,0,0,0,80,0],[1]],[0,"Default",0,1]],[[1063,198.5264434814453,0,131,22,0,0,1,0.5,0.5357142686843872,0,0,[]],56,2389,[],[[180,0],[1]],[0,"Default",0,1]],[[877,114.2777709960938,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,2390,[],[[1,1,0,4,0,0,0,50,0],[1]],[0,"Default",0,1]],[[515,147.5264434814453,0,131,22,0,0,1,0.5,0.5357142686843872,0,0,[]],56,2391,[],[[180,0],[1]],[0,"Default",0,1]],[[529,413,0,100.8000030517578,20.53300094604492,0,
0,1,0.5,0.5,0,0,[]],11,2392,[],[[1]],[0,"Default",0,1]],[[526,350,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2393,[],[],[0,"Default",0,1]],[[525,265,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2394,[],[],[0,"Default",0,1]],[[514,489,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2395,[],[],[0,"Default",0,1]],[[514,312,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2396,[],
[],[0,"Default",0,1]],[[486,313,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2397,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[541,312,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2398,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[513,325,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2413,[],[],[0,"Default",0,1]],[[512,336,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,
0.5,0,0,[]],21,2414,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,5659563234228075,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,0xf437093dc6676,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2399,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2400,[],[],[0,"Default",0,1]]],[]],["gui",10,8282132844672189,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,
62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2401,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2402,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2403,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2404,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2405,[],[],[0,"Default",
0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2406,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2407,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2408,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2409,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2410,[],[],["Level 14",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,
28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2411,[],[],[0,"Default",0,1]],[[-581,798,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,837,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel15",854,480,!0,"BlueLevel15Events",5856103224228891,[["Fundo",0,6279523950272401,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],
18,124,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,373,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,375,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,376,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,377,[],[],
[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,378,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,404,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,522,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,
0.5,0.5,0,0,[]],22,526,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,527,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,528,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,529,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,531,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,532,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,0xb93822c06d884,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,533,[],[],[0,"Default",0,1]]],[]],["Casa",2,0xc56c83c10fb8f,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,
196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,534,[],[],[0,"Default",0,1]]],[]],["Cerca",3,9996155643973828,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,535,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,61745310742803,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[746,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,536,[],[],[0,"Default",0,1]]],[]],["Garagem",5,977667798249767,
!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,537,[],[],[0,"Default",0,1]]],[]],["Piscina",6,0x89a04cda04f51,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[570,458.310546875,0,1421,254,0,0,1,0.5,0.5031055808067322,0,0,[]],94,538,[],[],[0,"Default",0,1]]],[]],["Game",7,0xa60bcd69d58f1,!0,[255,255,255],!0,0.6000000238418579,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,
539,[],[],[0,"Default",0,1]],[[1599,-80,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,566,[],[[1]],[0,"Default",0,1]],[[447.5,625,0,4807,14,0,0,1,0.5,0.5,0,0,[]],9,582,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,583,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,584,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,
0,0,1,0.5,0.5138888955116272,0,0,[]],16,585,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,586,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,587,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,588,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,
28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,589,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,590,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,591,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,592,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,595,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,596,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,597,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,599,[],[],[0,"Default",0,1]],[[1582,
-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,600,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,601,[],[[1]],[0,"Default",0,1]],[[119,-6,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,602,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[1147,12,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,603,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[120,502,0,32,32,0,0,1,0.5,0.5064935088157654,
0,0,[]],14,604,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[726,502,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,605,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[114,554,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,623,[],[[1]],[0,"Default",0,1]],[[715,576,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,643,[],[[1]],[0,"Default",0,1]],[[121,55,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,644,[],[[1]],[0,
"Default",0,1]],[[1148,70,0,100.8000030517578,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2412,[],[[1]],[0,"Default",0,1]],[[-58,379,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2415,[],[],[0,"Default",0,1]],[[698,164,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2416,[],[[1,2,0,4,0,0,0,80,0],[1]],[0,"Default",0,1]],[[404,436,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2417,[],[[1,1,0,4,0,0,0,130,0],[1]],[0,"Default",0,1]],[[535,268,0,74.10526275634766,15.55555534362793,0,0,
1,0.5,0.5,0,0,[]],55,2418,[],[[1,1,0,3,0,0,0,130,0],[1]],[0,"Default",0,1]],[[335,77,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2419,[],[[1,1,0,5,0,0,0,80,0],[1]],[0,"Default",0,1]],[[963,317,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2420,[],[[1,1,0,4,0,0,0,130,0],[1]],[0,"Default",0,1]],[[935,80,0,74.10526275634766,15.55555534362793,0,0,1,0.5,0.5,0,0,[]],55,2421,[],[[1,1,0,4,0,0,0,130,0],[1]],[0,"Default",0,1]],[[1232,568,0,100.8000030517578,20.53300094604492,
0,0,1,0.5,0.5,0,0,[]],11,2422,[],[[1]],[0,"Default",0,1]],[[1229,505,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2423,[],[],[0,"Default",0,1]],[[1228,420,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2424,[],[],[0,"Default",0,1]],[[1217,644,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2425,[],[],[0,"Default",0,1]],[[1217,467,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,
2426,[],[],[0,"Default",0,1]],[[1189,468,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2427,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1244,467,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2428,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1216,480,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2429,[],[],[0,"Default",0,1]],[[1215,491,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,2444,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,0x9e92d920ee183,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,9674828362507884,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2430,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2431,[],[],[0,"Default",0,1]]],[]],["gui",10,7201025629648607,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,
47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2432,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2433,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2434,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2435,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2436,[],[],[0,"Default",
0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2437,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2438,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2439,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2440,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2441,[],[],["Level 15",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,
28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2442,[],[],[0,"Default",0,1]],[[-519,841,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,838,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel16",854,480,!0,"BlueLevel16Events",0x78f6ed366d721,[["Fundo",0,0xec227f89f06f5,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],
18,30,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,127,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,393,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,410,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,419,[],[],[0,
"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,420,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,436,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,523,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,
0.5,0,0,[]],22,567,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,568,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,571,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,573,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,574,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,575,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,9544031962450832,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,581,[],[],[0,"Default",0,1]]],[]],["Casa",2,6192408215944848,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,
196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,645,[],[],[0,"Default",0,1]]],[]],["Cerca",3,4615223239574132,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,646,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,382651933178519,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[746,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,647,[],[],[0,"Default",0,1]]],[]],["Garagem",5,9995254808042642,
!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,648,[],[],[0,"Default",0,1]]],[]],["Piscina",6,4731746716084812,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[570,458.310546875,0,1421,254,0,0,1,0.5,0.5031055808067322,0,0,[]],94,649,[],[],[0,"Default",0,1]]],[]],["Game",7,0xf495a2800c7a3,!0,[255,255,255],!0,0.6000000238418579,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,
659,[],[],[0,"Default",0,1]],[[1599,-80,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,665,[],[[1]],[0,"Default",0,1]],[[527.5,625,0,3723,14,0,0,1,0.5,0.5,0,0,[]],9,666,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,667,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,688,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,
0,0,1,0.5,0.5138888955116272,0,0,[]],16,705,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,706,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,707,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,708,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,
28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,709,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,710,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,724,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,725,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,727,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,728,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,729,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,730,[],[],[0,"Default",0,1]],[[1582,
-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,749,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,750,[],[[1]],[0,"Default",0,1]],[[1028,496,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,751,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[1027,60,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,752,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[404,37,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,755,
[[0],[5]],[[180,0]],[0,"Default",0,1]],[[625,474,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,2443,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[398,89,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2445,[],[[1]],[0,"Default",0,1]],[[614,548,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2446,[],[[1]],[0,"Default",0,1]],[[1030,557,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2447,[],[[1]],[0,"Default",0,1]],[[1028,118,0,92,20.53300094604492,0,0,1,
0.5,0.5,0,0,[]],11,2448,[],[[1]],[0,"Default",0,1]],[[-159,351,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,2449,[],[],[0,"Default",0,1]],[[719,81,0,74,23,0,0,1,0.5,0.5,0,0,[]],55,2450,[],[[1,2,0,2,0,0,0,60,0],[1]],[0,"Default",0,1]],[[807,439,0,74,23,0,0,1,0.5,0.5,0,0,[]],55,2451,[],[[1,1,0,4,0,0,0,130,0],[1]],[0,"Default",0,1]],[[1200,190,0,74,23,0,0,1,0.5,0.5,0,0,[]],55,2452,[],[[1,1,0,2,0,0,0,140,0],[1]],[0,"Default",0,1]],[[81,25,0,131,23,0,0,1,0.5,0.5357142686843872,0,0,[]],56,2453,[],[[-180,0],[1]],[0,
"Default",0,1]],[[1032,310,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2454,[],[[1]],[0,"Default",0,1]],[[-42,348,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2455,[],[],[0,"Default",0,1]],[[-41,263,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2456,[],[],[0,"Default",0,1]],[[-31,486,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2457,[],[],[0,"Default",0,1]],[[-31,310,0,-82.21199798583984,47.83700180053711,
0,0,1,0.5,0.5138888955116272,0,0,[]],16,2458,[],[],[0,"Default",0,1]],[[-59,311,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2459,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4,310,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2460,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-31,323,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2461,[],[],[0,"Default",0,1]],[[-32,333,0,2.372452735900879,
28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2462,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-47,411,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2463,[],[[1]],[0,"Default",0,1]]],[]],["Grama",8,7379515740487827,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,6811633309641744,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2465,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,
0,0,[]],12,2466,[],[],[0,"Default",0,1]]],[]],["gui",10,9659884675612220,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2467,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2468,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2469,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2470,[],
[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2471,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2472,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2473,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2474,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2475,[],[],[0,0]],[[97,
19,0,111,30,0,0,1,0,0,0,0,[]],52,2476,[],[],["Level 16",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2477,[],[],[0,"Default",0,1]],[[-576,811,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,839,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel17",854,480,!0,"BlueLevel17Events",489575852569267,[["Fundo",0,6146538825217359,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,
1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2464,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2479,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2480,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2481,[],[],[0,
"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2482,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2483,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2484,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,
2485,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2486,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2487,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2488,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,
52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2489,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2490,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2491,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,9318129775549098,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,2492,[],[],
[0,"Default",0,1]]],[]],["Casa",2,9570239895779844,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,2493,[],[],[0,"Default",0,1]]],[]],["Cerca",3,7109428064272692,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,2494,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,0xf2ef3891e8531,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[746,
332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,2495,[],[],[0,"Default",0,1]]],[]],["Garagem",5,9459522004144608,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,2496,[],[],[0,"Default",0,1]]],[]],["Piscina",6,0xa43a81b1bb5d0,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[570,458.310546875,0,1421,254,0,0,1,0.5,0.5031055808067322,0,0,[]],94,2497,[],[],[0,"Default",0,1]]],[]],["Game",
7,0x846a58c63f4df,!0,[255,255,255],!0,0.6000000238418579,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2498,[],[],[0,"Default",0,1]],[[1599,-80,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2499,[],[[1]],[0,"Default",0,1]],[[527.5,625,0,3723,14,0,0,1,0.5,0.5,0,0,[]],9,2500,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2501,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,
54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2502,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2503,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2504,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2505,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2506,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2507,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2508,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,2509,[],[],[0,"Default",
0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2510,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2511,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2512,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2513,[],[[1],
[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2514,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2515,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,2516,[],[[1]],[0,"Default",0,1]],[[925,448,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,237,[[0],[5]],[[180,0]],[0,"Default",0,1]],
[[927,58,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,256,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-151,451,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,273,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[472,447,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,348,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,1,1],[1]],[0,"Default",0,1]],[[-157,503,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,438,[],[[1]],[0,"Default",0,1]],[[461,521,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,439,
[],[[1]],[0,"Default",0,1]],[[927,509,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,440,[],[[1]],[0,"Default",0,1]],[[928,116,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,441,[],[[1]],[0,"Default",0,1]],[[-262,340,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,451,[],[],[0,"Default",0,1]],[[713,213.2777709960938,0,74,23,0,0,1,0.5,0.5,0,0,[]],55,498,[],[[1,2,0,2,0,0,0,60,0],[1]],[0,"Default",0,1]],[[704,427.2777709960938,0,74,23,0,0,1,0.5,0.5,0,0,[]],55,524,[],[[1,1,0,4,0,0,0,110,0],[1]],[0,"Default",0,1]],
[[1072,244.2777709960938,0,74,23,0,0,1,0.5,0.5,0,0,[]],55,544,[],[[1,1,0,2,0,0,0,140,0],[1]],[0,"Default",0,1]],[[653,61.27645111083984,0,131,29,0,0,1,0.5,0.5357142686843872,0,0,[]],56,576,[],[[-180,0],[1]],[0,"Default",0,1]],[[507,290,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,577,[],[[1]],[0,"Default",0,1]],[[152,454,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,578,[],[],[0,"Default",0,1]],[[153,369,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,598,[],[],[0,"Default",0,1]],[[163,592,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,608,[],[],[0,"Default",0,1]],[[163,416,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,618,[],[],[0,"Default",0,1]],[[135,417,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,619,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[190,416,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,
0.5,0,0,[]],21,629,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[163,429,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,630,[],[],[0,"Default",0,1]],[[162,439,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,671,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[147,517,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,713,[],[[1]],[0,"Default",0,1]]],[]],["Grama",8,4852458264394233,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",
9,8485883347245008,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2540,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2541,[],[],[0,"Default",0,1]]],[]],["gui",10,0x9e9daf7524133,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2542,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2543,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",
0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2544,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2545,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2546,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2547,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,
0,[]],42,2548,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2549,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2550,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],52,2551,[],[],["Level 17",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2552,[],[],[0,"Default",0,1]],[[-525,809,0,75.41883087158203,75.41883087158203,
0,0,1,0.5,0.5,0,0,[]],114,840,[],[],[0,"Default",0,1]]],[]]],[],[]],["BlueLevel18",854,480,!0,"BlueLevel18Events",9310758294666514,[["Fundo",0,0xaa2a82d46fa23,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[1445,-390,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,36,[],[],[0,"Default",0,1]],[[1434,-167,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,69,[],[],[0,"Default",0,1]],[[1435,-343,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,105,[],[],[0,"Default",0,1]],[[1593,-393,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,119,[],[],[0,"Default",0,1]],[[1603,-169,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,137,[],[],[0,"Default",0,1]],[[1604,-346,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,156,[],[],[0,"Default",0,1]],[[1406,-343,0,2.372452735900879,52.66129302978516,
0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,163,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1461,-344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,182,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1433,-330,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,220,[],[],[0,"Default",0,1]],[[1433,-320,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,452,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[1576,-344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,453,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1631,-346,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,473,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1603,-333,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,489,[],[],[0,"Default",0,1]],[[1602,-322,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,
[]],21,491,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Ceu",1,5066619992960297,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[427,210,0,854,480,0,0,1,0.5,0.5,0,0,[]],92,501,[],[],[0,"Default",0,1]]],[]],["Casa",2,0x5cb081497c314,!0,[255,255,255],!0,0.02999999932944775,0,1,!1,1,0,0,[[[374,285,0,272.4403991699219,196.6815643310547,0,0,1,0.5,0.5,0,0,[]],93,570,[],[],[0,"Default",0,1]]],[]],["Cerca",3,0x87fa97561b58e,!0,[255,255,255],!0,0.07999999821186066,0,1,!1,1,0,0,[[[395.8619995117188,
296.9989929199219,0,942,238,0,0,1,0.5,0.5019454956054688,0,0,[]],95,715,[],[],[0,"Default",0,1]]],[]],["Lixeira",4,0xf5489f069a8e8,!0,[255,255,255],!0,0.1500000059604645,0,1,!1,1,0,0,[[[746,332,0,134.4358673095703,152.1915435791016,0,0,1,0.5031446814537048,0.5,0,0,[]],97,736,[],[],[0,"Default",0,1]]],[]],["Garagem",5,0x58e48f0711738,!0,[255,255,255],!0,0.1700000017881393,0,1,!1,1,0,0,[[[923.4329833984375,284.0010070800781,0,311,298,0,0,1,0.5,0.5013477206230164,0,0,[]],96,756,[],[],[0,"Default",0,
1]]],[]],["Piscina",6,614131506000636,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[[[570,458.310546875,0,1421,254,0,0,1,0.5,0.5031055808067322,0,0,[]],94,757,[],[],[0,"Default",0,1]]],[]],["Game",7,8605211513965245,!0,[255,255,255],!0,0.6000000238418579,0,1,!1,1,0,0,[[[1734,-189,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,758,[],[],[0,"Default",0,1]],[[1599,-80,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,759,[],[[1]],[0,"Default",0,1]],[[527.5,625,0,3723,14,0,0,1,0.5,0.5,0,0,[]],
9,760,[[3]],[[1]],[0,"Default",0,1]],[[1735,-274,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,761,[],[],[0,"Default",0,1]],[[1745,-51,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,762,[],[],[0,"Default",0,1]],[[1745,-227,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,763,[],[],[0,"Default",0,1]],[[1717,-226,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,
764,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1772,-227,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,765,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1745,-214,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,766,[],[],[0,"Default",0,1]],[[1744,-204,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,767,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1596,-143,0,29,108.9260025024414,
0,0,1,0.517241358757019,0.5,0,0,[]],103,770,[],[],[0,"Default",0,1]],[[1595,-228,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,771,[],[],[0,"Default",0,1]],[[1584,-4,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,772,[],[],[0,"Default",0,1]],[[1584,-181,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,773,[],[],[0,"Default",0,1]],[[1556,-180,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,
1,0.5,0.5,0,0,[]],21,774,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1611,-181,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,775,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1583,-168,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,776,[],[],[0,"Default",0,1]],[[1582,-157,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,782,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,-126,
0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,787,[],[[1]],[0,"Default",0,1]],[[357,444,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,788,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[355,-20,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,789,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[32,431,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,790,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[367,221,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],8,791,[[1],[3],[1]],[[400,1800,1800,750,1500,1200,
1,1],[1]],[0,"Default",0,1]],[[26,483,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,792,[],[[1]],[0,"Default",0,1]],[[356,295,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,793,[],[[1]],[0,"Default",0,1]],[[359,505,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,794,[],[[1]],[0,"Default",0,1]],[[356,38,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,795,[],[[1]],[0,"Default",0,1]],[[-79,320,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,796,[],[],[0,"Default",0,1]],[[-110,318,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,
797,[],[[1,1,0,2,0,0,0,140,0],[1]],[0,"Default",0,1]],[[747,276,0,131,19,0,0,1,0.5,0.5357142686843872,0,0,[]],56,798,[],[[180,0],[1]],[0,"Default",0,1]],[[176,406,0,92,20.53300094604492,0,1.570796370506287,1,0.5,0.5,0,0,[]],11,799,[],[[1]],[0,"Default",0,1]],[[114,129,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,800,[],[[1,1,0,2,0,0,0,140,0],[1]],[0,"Default",0,1]],[[529,362,0,74,21,0,0,1,0.5,0.5,0,0,[]],55,801,[],[[1,1,0,2,0,0,0,140,0],[1]],[0,"Default",0,1]],[[896,185,0,131,19,0,0,1,0.5,0.5357142686843872,
0,0,[]],56,802,[],[[-180,0],[1]],[0,"Default",0,1]],[[1187,445,0,92,20.53300094604492,0,0,1,0.5,0.5,0,0,[]],11,803,[],[[1]],[0,"Default",0,1]],[[1184,382,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,804,[],[],[0,"Default",0,1]],[[1183,297,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,805,[],[],[0,"Default",0,1]],[[1172,521,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,806,[],[],[0,"Default",0,1]],[[1172,
344,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,809,[],[],[0,"Default",0,1]],[[1144,345,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2478,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1199,344,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2517,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1171,357,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2518,[],[],
[0,"Default",0,1]],[[1170,368,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2533,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Grama",8,5733282999457156,!0,[255,255,255],!0,0.25,0,1,!1,1,0,0,[],[]],["Direcionais",9,0x4ec7a6bb2025f,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2519,[],[],[0,"Default",0,1]],[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2520,[],[],[0,
"Default",0,1]]],[]],["gui",10,6393113165277681,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2521,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2522,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2523,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2524,[],[],[0,"Default",0,1]],[[119,
864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2525,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2526,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2527,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2528,[],[],[0,"Default",0,1]],[[-335,-1046,0,1297,760,0,0,1,0,0,0,0,[]],4,2529,[],[],[0,0]],[[97,19,0,111,30,0,0,1,0,0,0,0,[]],
52,2530,[],[],["Level 18",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2531,[],[],[0,"Default",0,1]],[[-477,791,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,841,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevelMenu",854,480,!0,"GameEventsBlue",0x9a775a41dd96c,[["LevelsFundo",0,9667262600500900,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[427,244,0,972,598,0,0,1,0.5,0.5,0,
0,[]],100,5,[],[],[0,"Default",0,1]],[[56,59,0,71,71,0,0,1,0.5,0.5064935088157654,0,0,[]],38,157,[],[],[0,"Default",0,1]],[[439,83,0,133,147,0,0,1,0.5037593841552734,0.5034013390541077,0,0,[]],50,126,[],[],[0,"Default",0,1]],[[439,305,0,634,312,0,0,1,0.5,0.5,0,0,[]],111,503,[],[],[0,"Default",0,1]]],[]],["Estrelas",1,0x5bccc2a25bba0,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]],["LevelsChoose",2,0xa8e78c4452e5a,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[163,191,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,138,[],[],[0,
"Default",0,1]],[[276,192,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,139,[],[],[0,"Default",0,1]],[[386,191,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,140,[],[],[0,"Default",0,1]],[[489,191,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,141,[],[],[0,"Default",0,1]],[[602,191,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,142,[],[],[0,"Default",0,1]],[[708,192,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,143,[],[],[0,"Default",0,1]],[[164,295,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,144,[],[],[0,"Default",0,1]],[[273,294,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,145,[],[],
[0,"Default",0,1]],[[384,294,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,146,[],[],[0,"Default",0,1]],[[491,294,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,147,[],[],[0,"Default",0,1]],[[597,294,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,148,[],[],[0,"Default",0,1]],[[710,295,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,149,[],[],[0,"Default",0,1]],[[163,408,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,150,[],[],[0,"Default",0,1]],[[275,407,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,151,[],[],[0,"Default",0,1]],[[384,407,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,152,[],
[],[0,"Default",0,1]],[[491,407,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,153,[],[],[0,"Default",0,1]],[[603,408,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,154,[],[],[0,"Default",0,1]],[[709,408,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,155,[],[],[0,"Default",0,1]],[[439,296,0,250,250,0,0,1,0.5,0.5,0,0,[]],110,502,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel1",854,480,!0,"RedLevel1Events",818740681148946,[["Fundo",0,9949451026573900,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,
0,0,1,0,0,0,0,[]],36,625,[],[],[0,0]]],[]],["Game",1,0x98bff885ba23f,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[293,260,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,685,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[648,172,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,686,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[177,165,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,687,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[148,
265,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,731,[],[],[0,"Default",0,1]],[[736,28,0,84.77986907958984,27.47495841979981,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,506,[],[],[0,"Default",0,1]],[[73,147,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,697,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[187,201,0,371,-12,0,0,1,0.5,0.5,0,0,[]],76,689,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[455.4196166992188,163.3665313720703,0,195,-12,0,-0.41358283162117,
1,0.5,0.5,0,0,[]],76,690,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[639,236,0,141,-12,0,0,1,0.5,0.5,0,0,[]],76,702,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[481,262,0,195,-12,0,-0.2660599052906036,1,0.5,0.5,0,0,[]],76,703,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[300,289,0,180,-12,0,0,1,0.5,0.5,0,0,[]],76,704,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[38,-156,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,979,[[3]],[[1]],[0,"Default",0,1]],[[-440,117,
0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,980,[[3]],[[1]],[0,"Default",0,1]],[[1374,250,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,981,[[3]],[[1]],[0,"Default",0,1]],[[78.69225311279297,464.2058410644531,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,626,[],[[1]],[0,"Default",0,1]],[[83.69225311279297,400.2058410644531,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,692,[],[],[0,"Default",0,1]],[[83.69225311279297,316.2058410644531,0,-102.2440032958984,
67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,693,[],[],[0,"Default",0,1]],[[93.69225311279297,539.205810546875,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,694,[],[],[0,"Default",0,1]],[[93.69225311279297,363.2058410644531,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,695,[],[],[0,"Default",0,1]],[[66.69225311279297,363.2058410644531,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,
[]],21,696,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[120.692253112793,362.2058410644531,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,701,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[93.69225311279297,376.2058410644531,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,748,[],[],[0,"Default",0,1]],[[92.69225311279297,386.2058410644531,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1977,[],
[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,7166458515814176,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,734,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,735,[],[],[0,"Default",0,1]]],[]],["gui",3,0xb4e80d6e17833,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,57,0,70,77,0,0,1,0.5,0.5064935088157654,0,0,[]],7,737,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,
1,0.5,0.5,0,0,[]],20,738,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,739,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,740,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,741,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,742,[],[],[0,"Default",0,
1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,743,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,744,[],[],[0,"Default",0,1]],[[99,36,0,111,30,0,0,1,0,0,0,0,[]],52,747,[],[],["Level 1",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,691,[[3]],[[1]],[0,"Default",0,1]],[[-522,705,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,843,[],[],[0,"Default",
0,1]]],[]]],[],[]],["RedLevel2",854,480,!0,"RedLevel2Events",7439857487148638,[["Fundo",0,8751243077593613,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,711,[],[],[0,0]]],[]],["Game",1,0x6a582db78eb66,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[473,429,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,714,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[648,188,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,716,[[0],[5]],[[180,0]],[0,"Default",0,
1]],[[162,245,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,718,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,719,[[3]],[[1]],[0,"Default",0,1]],[[148,265,0,73,56,0,0,1,0.5,0.5,0,0,[]],54,925,[],[],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,926,[],[],[0,"Default",0,1]],[[425,471,0,371,-12,0,0,1,0.5,0.5,0,0,[]],76,928,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[103,308,
0,114,-12,0,-1.507731676101685,1,0.5,0.5,0,0,[]],76,929,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[639,236,0,141,-12,0,0,1,0.5,0.5,0,0,[]],76,930,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[396,283,0,385,-12,0,-0.2641940414905548,1,0.5,0.5,0,0,[]],76,931,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[169,417,0,180,-12,0,0.6515335440635681,1,0.5,0.5,0,0,[]],76,932,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[570,434,0,50,50,0,0,1,0.5121951103210449,
0.5121951103210449,0,0,[]],75,927,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[-32,-510,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,982,[[3]],[[1]],[0,"Default",0,1]],[[-510,-237,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,983,[[3]],[[1]],[0,"Default",0,1]],[[1304,-104,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,984,[[3]],[[1]],[0,"Default",0,1]],[[803,466,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,712,[],[[1]],[0,"Default",0,1]],[[800,403,0,29,108.9260025024414,
0,0,1,0.517241358757019,0.5,0,0,[]],103,720,[],[],[0,"Default",0,1]],[[798,318,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,721,[],[],[0,"Default",0,1]],[[787,542,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,722,[],[],[0,"Default",0,1]],[[787,365,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,723,[],[],[0,"Default",0,1]],[[759,365,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,
1,0.5,0.5,0,0,[]],21,732,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[814,365,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,753,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[786,378,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,754,[],[],[0,"Default",0,1]],[[785,389,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1981,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",
2,480610271964412,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,933,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,934,[],[],[0,"Default",0,1]]],[]],["gui",3,477593373287189,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,935,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,936,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],
[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,937,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,938,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,939,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,940,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,
941,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,942,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,943,[],[],["Level 2",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[345,622,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,978,[[3]],[[1]],[0,"Default",0,1]],[[-619,700,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,844,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel3",854,480,!0,"RedLevel3Events",0xe9d041952ec2f,
[["Fundo",0,0xcc9e92547edcd,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,944,[],[],[0,0]]],[]],["Game",1,7605254178229117,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[633,333,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,946,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[125,146,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,947,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,
0,0,[]],70,960,[],[],[0,"Default",0,1]],[[462,471,0,371,-12,0,0,1,0.5,0.5,0,0,[]],76,962,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[667,424,0,114,-12,0,-1.097128748893738,1,0.5,0.5,0,0,[]],76,963,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[692,156,0,141,-12,0,0,1,0.5,0.5,0,0,[]],76,964,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[419,156,0,385,-12,0,0.2064454257488251,1,0.5,0.5,0,0,[]],76,965,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[206,417,
0,180,-12,0,0.6515335440635681,1,0.5,0.5,0,0,[]],76,966,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[123,180,0,102,-12,0,0,1,0.5,0.5,0,0,[]],76,959,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[687,72,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,961,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,985,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,986,[[3]],
[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,987,[[3]],[[1]],[0,"Default",0,1]],[[56,464,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,777,[],[[1]],[0,"Default",0,1]],[[61,400,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,778,[],[],[0,"Default",0,1]],[[61,316,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,779,[],[],[0,"Default",0,1]],[[71,539,0,-82.8219985961914,54.86700057983398,
0,0,1,0.5,3.940476179122925,0,0,[]],49,780,[],[],[0,"Default",0,1]],[[71,363,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,781,[],[],[0,"Default",0,1]],[[44,363,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,783,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[98,362,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,784,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[71,376,0,25.21820068359375,
11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,785,[],[],[0,"Default",0,1]],[[70,386,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,948,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,5282787142338314,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,967,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,968,[],[],[0,"Default",0,1]]],[]],["gui",
3,0x68d1ab887454d,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,969,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,970,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,971,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,972,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,
0.5060975551605225,0,0,[]],40,973,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,974,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,975,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,976,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,977,[],[],["Level 3",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,
14,0,0,1,0.5,0.5,0,0,[]],9,949,[[3]],[[1]],[0,"Default",0,1]],[[-490,718,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,845,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel4",854,480,!0,"RedLevel4Events",292256918002277,[["Fundo",0,0xf77c240b4f395,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,988,[],[],[0,0]]],[]],["Game",1,5067760045342685,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[487,265,0,32,32,0,0,1,0.5,0.5064935088157654,
0,0,[]],14,990,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[125,146,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,991,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[415,150,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,992,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1002,[],[],[0,"Default",0,1]],[[158,351,0,371,-12,0,0.4553513526916504,1,0.5,0.5,0,0,[]],76,1003,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",
0,1]],[[362,391,0,114,-12,0,-0.7098489999771118,1,0.5,0.5,0,0,[]],76,1004,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[692,121,0,74,-12,0,0,1,0.5,0.5,0,0,[]],76,1005,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[547,165,0,98,-12,0,0.005905103869736195,1,0.5,0.5,0,0,[]],76,1006,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[276,157,0,180,-12,0,0.4608925580978394,1,0.5,0.5,0,0,[]],76,1007,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[123,180,0,102,-12,
0,0,1,0.5,0.5,0,0,[]],76,1008,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[687,72,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1009,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1010,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1011,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1012,[[3]],[[1]],[0,"Default",0,1]],[[419,
194,0,102,-12,0,0,1,0.5,0.5,0,0,[]],76,1025,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[568,464,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,786,[],[[1]],[0,"Default",0,1]],[[565,401,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,810,[],[],[0,"Default",0,1]],[[563,316,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,811,[],[],[0,"Default",0,1]],[[552,540,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,
0,0,[]],49,817,[],[],[0,"Default",0,1]],[[552,363,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,818,[],[],[0,"Default",0,1]],[[524,363,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,819,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[579,363,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,820,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[551,376,0,25.21820068359375,11.3631591796875,
0,0,1,0.5,0.5,0,0,[]],22,821,[],[],[0,"Default",0,1]],[[550,387,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1982,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,0x6cca27de099f8,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1013,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1014,[],[],[0,"Default",0,1]]],[]],["gui",3,710155590108584,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1015,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1016,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1017,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1018,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],40,1019,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1020,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1021,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1022,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1023,[],[],["Level 4",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,
0.5,0,0,[]],9,1024,[[3]],[[1]],[0,"Default",0,1]],[[-512,662,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,846,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel5",854,480,!0,"RedLevel5Events",5772712304990607,[["Fundo",0,0x9541321056381,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1026,[],[],[0,0]]],[]],["Game",1,4641442639844939,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[130,288,0,32,32,0,0,1,0.5,0.5064935088157654,0,
0,[]],14,1028,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[277,129,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1029,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[497,359,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1030,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1040,[],[],[0,"Default",0,1]],[[309,367,0,262,-12,0,0.23641636967659,1,0.5,0.5,0,0,[]],76,1041,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",
0,1]],[[519,126,0,98,-12,0,0,1,0.5,0.5,0,0,[]],76,1044,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1048,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1049,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1050,[[3]],[[1]],[0,"Default",0,1]],[[483,398,0,102,-12,0,0,1,0.5,0.5,0,0,[]],76,1051,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[203,-296,
0,170,20,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1043,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[202,-277,0,14,-30,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1046,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[247,216,0,11,-65,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1064,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[286,180,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1065,[],[[0,0,0,0.5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[58,456,0,100.8000030517578,
20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,823,[],[[1]],[0,"Default",0,1]],[[63,392,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,824,[],[],[0,"Default",0,1]],[[63,308,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,825,[],[],[0,"Default",0,1]],[[73,531,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,826,[],[],[0,"Default",0,1]],[[73,355,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,
0,[]],16,833,[],[],[0,"Default",0,1]],[[46,355,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,836,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[100,354,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,853,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[73,368,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,866,[],[],[0,"Default",0,1]],[[72,378,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,
1,0.5,0.5,0,0,[]],21,1983,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[341.5851745605469,234.8688201904297,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,1984,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[528,49,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1047,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[339.9339904785156,233.4340057373047,0,16.88194274902344,16.88194274902344,0,0,1,0.5,
0.5,0,0,[]],108,1986,[],[],[0,"Default",0,1]],[[339.0163879394531,256.426513671875,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,1045,[],[[1]],[0,"Default",0,1]],[[339.9344787597656,233.4339447021484,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,1985,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,795131794233766,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1052,[],[],[0,"Default",0,1]],[[790,
298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1053,[],[],[0,"Default",0,1]]],[]],["gui",3,0x9263f700f7fb1,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1054,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1055,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1056,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,
0.5018050670623779,0,0,[]],34,1057,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1058,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1059,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1060,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1061,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,
0,[]],52,1062,[],[],["Level 5",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1063,[[3]],[[1]],[0,"Default",0,1]],[[-570.908203125,653.2651977539062,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,849,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel6",854,480,!0,"RedLevel6Events",0x854b4895491b2,[["Fundo",0,0xcb4c42f8d6479,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,
0,[]],36,1042,[],[],[0,0]]],[]],["Game",1,4828834413734534,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[399,211,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1067,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[69,136,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1068,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[746,220,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1069,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,
1079,[],[],[0,"Default",0,1]],[[381,256,0,262,-12,0,-0.1884646564722061,1,0.5,0.5,0,0,[]],76,1080,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[433,107,0,98,-12,0,0.005905103869736195,1,0.5,0.5,0,0,[]],76,1081,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1084,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1085,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,
0.5,0,0,[]],9,1086,[[3]],[[1]],[0,"Default",0,1]],[[55,241,0,11,-65,0,-0.4181988537311554,1,0.5,0.5,0,0,[]],76,1090,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[110,187,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1091,[],[[0,0,0,0.5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[745,318,0,11,-65,0,0.3193423449993134,1,0.5,0.5,0,0,[]],76,1107,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[699,256,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1108,[],[[0,2,0,0.5,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[437,465,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,870,[],[[1]],[0,"Default",0,1]],[[442,401,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,872,[],[],[0,"Default",0,1]],[[442,317,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,877,[],[],[0,"Default",0,1]],[[452,540,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,883,[],[],[0,"Default",0,1]],[[452,364,0,-82.21199798583984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,884,[],[],[0,"Default",0,1]],[[425,364,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,885,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[479,363,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,886,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[452,377,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,887,[],[],[0,"Default",0,1]],[[451,387,
0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2537,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[647,319,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,2538,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[646,318,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],108,2539,[],[],[0,"Default",0,1]],[[645,341,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2553,[],[[1]],
[0,"Default",0,1]],[[646,318,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,2554,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[149,240,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,2555,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[148,239,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],108,2556,[],[],[0,"Default",0,1]],[[147,262,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,2557,[],[[1]],[0,"Default",0,1]],
[[148,239,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,2558,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[437,58,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1083,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]]],[]],["Direcionais",2,5535899787357685,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1092,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1093,[],[],[0,
"Default",0,1]]],[]],["gui",3,7706176325919401,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1094,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1095,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1096,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1097,[],[],[0,"Default",0,1]],[[119,
864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1098,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1099,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1100,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1101,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1102,[],[],["Level 6",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",
0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1103,[[3]],[[1]],[0,"Default",0,1]],[[-549,673,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,850,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel7",854,480,!0,"RedLevel7Events",8519442405895388,[["Fundo",0,7776614743210173,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1087,[],[],[0,0]]],[]],["Game",1,7197006368063864,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[375,
239,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1110,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[100,217,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1111,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[691,269,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1112,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1122,[],[],[0,"Default",0,1]],[[387,141,0,189,-12,0,-0.266246885061264,1,0.5,0.5,0,0,[]],76,1123,[],
[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[151,284,0,193,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1125,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1127,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1128,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1129,[[3]],[[1]],[0,"Default",0,1]],[[43,253,0,11,-65,0,-0.4931335747241974,1,0.5,0.5,
0,0,[]],76,1132,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[112,79,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1133,[],[[0,2,0,0.5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[643,337,0,193,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1134,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[741,308,0,11,-65,0,0.3193423449993134,1,0.5,0.5,0,0,[]],76,1137,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[686,124,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1138,[],
[[0,2,0,0.5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[107,122,0,84,-12,0,0,1,0.5,0.5,0,0,[]],76,1124,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[685,170,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1151,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[350,467,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,889,[],[[1]],[0,"Default",0,1]],[[355,403,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,890,[],[],[0,"Default",0,1]],[[355,319,0,-102.2440032958984,
67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,891,[],[],[0,"Default",0,1]],[[365,542,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,892,[],[],[0,"Default",0,1]],[[365,366,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,893,[],[],[0,"Default",0,1]],[[338,366,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,894,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[392,365,0,2.372452735900879,
52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,895,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[365,379,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,896,[],[],[0,"Default",0,1]],[[364,389,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2559,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[151,265,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,2560,[[0]],[[0,0,0,1,0.5,
0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[150,264,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],108,2561,[],[],[0,"Default",0,1]],[[150,264,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,2562,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[638,319,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,2563,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[637,318,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],108,2564,[],[],
[0,"Default",0,1]],[[637,318,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,2565,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[437,58,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1126,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]]],[]],["Direcionais",2,5205520686159181,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1139,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,
[]],13,1140,[],[],[0,"Default",0,1]]],[]],["gui",3,7263847763659653,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1141,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1142,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1143,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1144,[],[],[0,
"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1145,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1146,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1147,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1148,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1149,[],[],["Level 7",0,"bold 16pt Comic Sans MS",
"rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1150,[[3]],[[1]],[0,"Default",0,1]],[[-561,661,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,851,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel8",854,480,!0,"RedLevel8Events",664647849584926,[["Fundo",0,7005811451768276,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1152,[],[],[0,0]]],[]],["Game",1,0x3c7aa9085bd44,!0,[255,255,255],!0,1,1,
1,!1,1,0,0,[[[567,217,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1154,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[119,166,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1155,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1166,[],[],[0,"Default",0,1]],[[326.9224243164063,160.4487915039063,0,189,-12,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1167,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[511.7825927734375,
292.5029296875,0,163.4349975585938,-11,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1168,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1170,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1171,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1172,[[3]],[[1]],[0,"Default",0,1]],[[414.6423950195313,262.3133239746094,0,11,-74.84780883789062,0,-0.4737171828746796,
1,0.5,0.5,0,0,[]],76,1175,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[433,197,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1176,[],[[0,2,0,0.2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[197.5,303.0006713867188,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1177,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[92,272,0,11.49414253234863,-76.22297668457031,0,2.761845827102661,1,0.5,0.5,0,0,[]],76,1180,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[122,217,
0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1181,[],[[0,2,0,0.1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[726,120,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1183,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[513.54443359375,274.4016723632813,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,1082,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[512.54443359375,273.4016723632813,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],
108,1088,[],[],[0,"Default",0,1]],[[512.54443359375,273.4016723632813,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,1089,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[191.8143310546875,282.4998474121094,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,1104,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[190.8143310546875,281.4998474121094,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,1105,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[242,235,
0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1156,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[757.7842407226562,467.7071228027344,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,897,[],[[1]],[0,"Default",0,1]],[[754.7842407226562,404.7071228027344,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,898,[],[],[0,"Default",0,1]],[[752.7842407226562,319.7071228027344,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,899,[],[],[0,"Default",
0,1]],[[741.7842407226562,543.7071533203125,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,900,[],[],[0,"Default",0,1]],[[741.7842407226562,366.7071228027344,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,902,[],[],[0,"Default",0,1]],[[713.7842407226562,366.7071228027344,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,903,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[768.7842407226562,366.7071228027344,
0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,904,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[740.7842407226562,379.7071228027344,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,905,[],[],[0,"Default",0,1]],[[739.7842407226562,390.7071228027344,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1106,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[727,77,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,
0,0,[]],75,1169,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[429.422607421875,99.35545349121094,0,101.7110900878906,52.66530990600586,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1182,[],[],[0,"Default",0,1]],[[249.229736328125,78.6988525390625,0,107.7200622558594,57.17396926879883,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1196,[],[],[0,"Default",0,1]]],[]],["Direcionais",2,8275112405187719,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,
0,0,[]],12,1184,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1185,[],[],[0,"Default",0,1]]],[]],["gui",3,0xe6c9381f5a9ce,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1186,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1187,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1188,[],[],[1,
"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1189,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1190,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1191,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1192,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1193,[],[],
[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1194,[],[],["Level 8",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1195,[[3]],[[1]],[0,"Default",0,1]],[[-506.6566772460938,656.15380859375,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,852,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel9",854,480,!0,"RedLevel9Events",6192611476810805,[["Fundo",0,8227380696460456,!0,[255,255,255],!1,0,0,1,!1,1,0,0,[[[-160,-116,0,
1148,728,0,0,1,0,0,0,0,[]],36,117,[],[],[0,0]]],[]],["Game",1,5473482695130633,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[618,267,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1199,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[177,304,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1200,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[389,63,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1201,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,
0,0,[]],70,1211,[],[],[0,"Default",0,1]],[[385,298,0,189,-12,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1212,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[563,342,0,163.4349975585938,-11,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1213,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1215,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1216,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,
1.567617535591126,1,0.5,0.5,0,0,[]],9,1217,[[3]],[[1]],[0,"Default",0,1]],[[560.5748291015625,462.7149658203125,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1218,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[560.1588134765625,482.7149963378906,0,14,-30,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1219,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[457,318,0,11,-74.84780883789062,0,-0.8326725363731384,1,0.5,0.5,0,0,[]],76,1220,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],
[0,"Default",0,1]],[[480.9205932617188,244.5366821289063,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1221,[],[[0,0,0,0.2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[256,441,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1222,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[245.416015625,480.9999694824219,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1223,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[245,501,0,14,-30,0,2.027169975917786E-4,1,0.5,0.5,0,0,
[]],76,1224,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[147,410,0,11.49414253234863,-76.22297668457031,0,2.600147247314453,1,0.5,0.5,0,0,[]],76,1225,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[180,355,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1226,[],[[0,2,0,0.05,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[65,169,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1227,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[176,447,0,14,-20,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],
76,1230,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[261.8343505859375,147.099365234375,0,221,-12,0,-0.3243683874607086,1,0.5,0.5,0,0,[]],76,1245,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[36.5491828918457,220.1697082519531,0,23.97381591796875,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1247,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[101.9259719848633,216.4696960449219,0,17.21182250976563,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1246,[],[[1,1,0,1,0.5,
0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[269.6470031738281,209.4693145751953,0,20.96835327148438,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1248,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[332.484375,208.7860107421875,0,20.96836853027344,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1249,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[438.4978637695313,159.6590881347656,0,18.71453857421875,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1250,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],
[0,"Default",0,1]],[[505.7507934570313,159.5564880371094,0,23.97381591796875,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1251,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[703,427.25927734375,0,28.4814453125,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1252,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[773,429.25927734375,0,28.4814453125,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1253,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[468,140,0,34,3,0,2.027169975917786E-4,
1,0.5,0.5,0,0,[]],76,1254,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[298,188,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1255,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[741,452,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1256,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[68.506103515625,194.0011138916016,0,45.01221084594727,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1257,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[52.67684936523438,
465.2525024414063,0,100.8000030517578,20.53333282470703,0,0,1,0.5,0.5,0,0,[]],11,923,[],[[1]],[0,"Default",0,1]],[[57.67684936523438,401.2525024414063,0,-29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,924,[],[],[0,"Default",0,1]],[[57.67684936523438,317.2525024414063,0,-102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,945,[],[],[0,"Default",0,1]],[[67.67684936523438,540.2525024414062,0,-82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,
0,0,[]],49,950,[],[],[0,"Default",0,1]],[[67.67684936523438,364.2525024414063,0,-82.21199798583984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,951,[],[],[0,"Default",0,1]],[[40.67684936523438,364.2525024414063,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,952,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[94.67684936523438,363.2525024414063,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,953,[],[[1],[1,0,
0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[67.67684936523438,377.2525024414063,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,954,[],[],[0,"Default",0,1]],[[66.67684936523438,387.2525024414063,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1130,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[69,130,0,50,50,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1214,[[0]],[[0,2,0,1.5,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[66.26802062988281,
207,0,101.7109985351563,52.66500091552734,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1243,[],[],[0,"Default",0,1]],[[301,200,0,101.7109985351563,52.66500091552734,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1229,[],[],[0,"Default",0,1]],[[473,150,0,101.7109985351563,52.66500091552734,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1228,[],[],[0,"Default",0,1]],[[737.9212646484375,439.9733276367188,0,101.7109985351563,52.66500091552734,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1244,[],[],[0,"Default",
0,1]],[[737.2428588867188,437.7364196777344,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1258,[],[],[0,"Default",0,1]],[[248.2682189941406,422.7005004882813,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,1131,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[247.2681884765625,421.7005004882813,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],108,1135,[],[],[0,"Default",0,1]],[[247.2681884765625,421.7005004882813,0,76,30,0,0,1,0.5,0.5,0,0,[]],
107,1136,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[564.1663818359375,323.4014587402344,0,169.9821929931641,27.65260314941406,0,0,1,0.5023923516273499,0.8823529481887817,0,0,[]],106,1173,[[0]],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[563.1663208007812,322.4014587402344,0,16.88194274902344,16.88194274902344,0,0,1,0.5,0.5,0,0,[]],108,1174,[],[],[0,"Default",0,1]],[[563.1663208007812,322.4014587402344,0,76,30,0,0,1,0.5,0.5,0,0,[]],107,1178,[[0]],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[472,150,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1179,[],[],[0,"Default",0,1]]],[]],["Direcionais",2,7843791802437103,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1231,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1232,[],[],[0,"Default",0,1]]],[]],["gui",3,9443480436492296,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1233,[],
[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1234,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1235,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1236,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1237,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],41,1238,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1239,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1240,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1241,[],[],["Level 9",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1242,[[3]],[[1]],[0,"Default",0,1]],[[-535,671,0,75.41883087158203,75.41883087158203,0,0,
1,0.5,0.5,0,0,[]],114,1994,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel10",854,480,!0,"RedLevel10Events",9415423230616416,[["Fundo",0,9130118445276976,!0,[255,255,255],!1,0,0,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1259,[],[],[0,0]]],[]],["Game",1,0xc56992f56a8a3,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[575,299,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1261,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[159,119,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1262,[[0],[5]],[[180,
0]],[0,"Default",0,1]],[[294,11,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1263,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[369,223,0,189,-12,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1274,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-19,52,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1276,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[256,441,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1284,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",
0,1]],[[245.416015625,408,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1285,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[147,410,0,11.49414253234863,-76.22297668457031,0,2.600147247314453,1,0.5,0.5,0,0,[]],76,1287,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[180,355,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1288,[],[[0,2,0,0.1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-23,99,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1289,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],
[0,"Default",0,1]],[[244,424,0,14,-26,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1290,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[123,63,0,221,-12,0,-0.3450743854045868,1,0.5,0.5,0,0,[]],76,1291,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[700,77,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1294,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[762,77,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1295,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],
[[428,58,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1296,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[496,56,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1297,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[374,472,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1298,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[441,474,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1299,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[458,29,0,34,3,0,2.027169975917786E-4,
1,0.5,0.5,0,0,[]],76,1300,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[728,47,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1301,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[409,502,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1302,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[731,78,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1305,[],[],[0,"Default",0,1]],[[463,58,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1306,[],[],[0,"Default",0,1]],[[406,
475,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1307,[],[],[0,"Default",0,1]],[[406,488,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1308,[],[],[0,"Default",0,1]],[[540,385,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1269,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[607,387,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1270,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[575,415,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1275,[],[[1,1,0,1,0.5,0.2,0,0.01,
0,1],[]],[0,"Default",0,1]],[[572,388,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1280,[],[],[0,"Default",0,1]],[[572,401,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1281,[],[],[0,"Default",0,1]],[[572,405,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1282,[],[],[0,"Default",0,1]],[[760,354,0,120.1949996948242,154.8190002441406,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,955,[],[],[0,"Default",0,1]],[[741,534,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,956,[],
[],[0,"Default",0,1]],[[741,357,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,957,[],[],[0,"Default",0,1]],[[713,357,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,958,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[768,357,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,989,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[740,370,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,
0,0,[]],22,993,[],[],[0,"Default",0,1]],[[739,381,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,994,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[757,441,0,108.7316284179688,25.35012817382813,0,0,1,0.5,0.5,0,0,[]],11,995,[],[[1]],[0,"Default",0,1]]],[]],["Direcionais",2,9397081028795724,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1309,[],[],[0,"Default",0,1]],[[790,298,0,779,830,
0,0,1,0.5,0.5027933120727539,0,0,[]],13,1310,[],[],[0,"Default",0,1]]],[]],["gui",3,5585479158725462,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1311,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1312,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1313,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,
0,0,[]],34,1314,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1315,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1316,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1317,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1318,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1319,[],[],
["Level 10",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1320,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1273,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1277,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1278,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,
1,0.5,0.5,0,0,[]],9,1279,[[3]],[[1]],[0,"Default",0,1]],[[281,-138,0,405,54,0,0,1,0,0,0,0,[]],83,1371,[],[],[25,30,"0123456789:","0123456789:",1,0,0,0,0,0,0,0]],[[-550,702,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2532,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel11",854,480,!0,"RedLevel11Events",6080442317997186,[["Fundo",0,7303904102117518,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1283,[],[],[0,0]]],[]],
["Game",1,7791312413131512,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[508,38,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1292,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-9,214,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1293,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[169,1,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1303,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[389,46,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1328,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],
[[83,487,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1329,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[72,454,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1330,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-26,456,0,11.49414253234863,-76.22297668457031,0,2.600147247314453,1,0.5,0.5,0,0,[]],76,1331,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[7,401,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1332,[],[[0,2,0,0.1,0.5,0.2,0,0.01,0,1]],
[0,"Default",0,1]],[[397,110,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1333,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[71,470,0,14,-26.00000190734863,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1334,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[451,-218,0,221,-12,0,-0.3450743854045868,1,0.5,0.5,0,0,[]],76,1335,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[700,24,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1336,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,
1]],[[762,24,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1337,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[35,129,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1338,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[103,127,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1339,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[380,400,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1340,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[447,402,0,39,-3,0,
1.570796370506287,1,0.5,0.5,0,0,[]],76,1341,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[65,100,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1342,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[729,-8,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1343,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[415,430,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1344,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[732,23,0,84,73,0,0,1,0.5,0.5070422291755676,
0,0,[]],79,1345,[],[],[0,"Default",0,1]],[[70,129,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1346,[],[],[0,"Default",0,1]],[[412,403,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1347,[],[],[0,"Default",0,1]],[[412,416,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1348,[],[],[0,"Default",0,1]],[[216,545,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1349,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[283,547,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1350,[],[[1,1,0,1,
0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[251,575,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1351,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[248,548,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1352,[],[],[0,"Default",0,1]],[[248,561,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1353,[],[],[0,"Default",0,1]],[[248,565,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1354,[],[],[0,"Default",0,1]],[[254,282,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1375,[],[[1,1,0,1,0.5,
0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[243,249,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1376,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[145,251,0,11.49414253234863,-76.22297668457031,0,2.600147247314453,1,0.5,0.5,0,0,[]],76,1377,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[178,196,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1378,[],[[0,2,0,0.1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[242,265,0,14,-26.00000190734863,0,2.027169975917786E-4,1,0.5,
0.5,0,0,[]],76,1379,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[593,292,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1380,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[582,259,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1381,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[484,261,0,11.49414253234863,-76.22297668457031,0,2.600147247314453,1,0.5,0.5,0,0,[]],76,1382,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[517,206,0,57,62,
0,0,1,0.5049505233764648,0.5,0,0,[]],78,1383,[],[[0,2,0,0.1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[581,275,0,14,-26.00000190734863,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1384,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[787,494,0,120.1949996948242,154.8190002441406,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,996,[],[],[0,"Default",0,1]],[[768,674,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,997,[],[],[0,"Default",0,1]],[[768,497,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,998,[],[],[0,"Default",0,1]],[[740,497,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,999,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[795,497,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1E3,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[767,510,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1001,[],[],[0,"Default",0,1]],[[766,521,
0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1027,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[784,581,0,108.7316284179688,25.35012817382813,0,0,1,0.5,0.5,0,0,[]],11,1031,[],[[1]],[0,"Default",0,1]]],[]],["Direcionais",2,443155080590948,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1355,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1356,[],[],
[0,"Default",0,1]]],[]],["gui",3,424782069997124,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1357,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1358,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1359,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1360,[],[],[0,"Default",0,1]],[[119,
864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1361,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1362,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1363,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1364,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1365,[],[],["Level 11",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",
0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1366,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1367,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1368,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1369,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1370,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,
435.2523498535156,0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1373,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1372,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-581,669,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2611,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel12",854,480,!0,"RedLevel12Events",8354392313363872,[["Fundo",0,0xff93340c54188,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,
[]],36,1374,[],[],[0,0]]],[]],["Game",1,6240017843800138,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[554,-30,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1386,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-65,216,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1387,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[733,351,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1388,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[49,3,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1397,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,
0,1],[],[]],[0,"Default",0,1]],[[27,489,0,186,-12,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1398,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[16,456,0,164,28,0,0,1,0.5036496520042419,0.517241358757019,0,0,[]],77,1399,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-82,458,0,11.49414253234863,-76.22297668457031,0,2.600147247314453,1,0.5,0.5,0,0,[]],76,1400,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-49,403,0,57,62,0,0,1,0.5049505233764648,0.5,0,0,[]],78,1401,[],
[[0,2,0,0.1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[131,54,0,238,-12,0,0,1,0.5,0.5,0,0,[]],76,1402,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[15,472,0,14,-26,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1403,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[283,43,0,72,-12,0,-0.3450743854045868,1,0.5,0.5,0,0,[]],76,1404,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[706,272,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1405,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],
[0,"Default",0,1]],[[768,272,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1406,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[35,129,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1407,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[103,127,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1408,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[719,133,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1409,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[786,
135,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1410,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[65,100,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1411,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[735,240,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1412,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[754,163,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1413,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[738,271,0,84,73,0,0,
1,0.5,0.5070422291755676,0,0,[]],79,1414,[],[],[0,"Default",0,1]],[[70,129,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1415,[],[],[0,"Default",0,1]],[[751,136,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1416,[],[],[0,"Default",0,1]],[[751,149,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1417,[],[],[0,"Default",0,1]],[[165,545,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1418,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[232,547,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,
[]],76,1419,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[200,575,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1420,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[197,548,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1421,[],[],[0,"Default",0,1]],[[197,561,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1422,[],[],[0,"Default",0,1]],[[197,565,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1423,[],[],[0,"Default",0,1]],[[314,545,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1327,
[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[381,547,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1396,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[349,575,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1424,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[346,548,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1425,[],[],[0,"Default",0,1]],[[346,561,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1426,[],[],[0,"Default",0,1]],[[464,545,0,39,-3,0,1.570796370506287,
1,0.5,0.5,0,0,[]],76,1427,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[531,547,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1428,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[499,575,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1429,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[496,548,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1430,[],[],[0,"Default",0,1]],[[496,561,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1431,[],[],[0,"Default",0,1]],
[[311,138,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1454,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[373,138,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1455,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[340,106,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1456,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[343,137,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1457,[],[],[0,"Default",0,1]],[[478.25,146.25,0,39,-3,0,1.570796370506287,1,0.5,0.5,
0,0,[]],76,1458,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[540.25,146.25,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1459,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[507.25,114.25,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1460,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[510,145,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1461,[],[],[0,"Default",0,1]],[[754,484,0,120.1949996948242,154.8190002441406,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,1032,[],[],[0,"Default",0,1]],[[735,664,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,1033,[],[],[0,"Default",0,1]],[[735,487,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1034,[],[],[0,"Default",0,1]],[[707,487,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1035,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[762,487,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,
0.5,0,0,[]],21,1036,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[734,500,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1037,[],[],[0,"Default",0,1]],[[733,511,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1038,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[751,571,0,108.7316284179688,25.35012817382813,0,0,1,0.5,0.5,0,0,[]],11,1039,[],[[1]],[0,"Default",0,1]],[[729,433,0,159,41,0,0.3717358708381653,1,0.5031446814537048,0.5121951103210449,
0,0,[]],86,1432,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,0x3f0915c732147,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1434,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1435,[],[],[0,"Default",0,1]]],[]],["gui",3,0xe8d87cf8a6a95,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1436,[],[],[0,"Default",0,1]],[[-965,
695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1437,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1438,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1439,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1440,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1441,
[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1442,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1443,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1444,[],[],["Level 12",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1445,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,
0.5142857432365417,0,0,[]],70,1446,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1447,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1448,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1449,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,435.2523498535156,0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1450,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1451,[],[],[25,
30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-554,663,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2612,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel13",854,480,!0,"RedLevel13Events",516810207249671,[["Fundo",0,0xd54fbe2f7ab4a,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1433,[],[],[0,0]]],[]],["Game",1,0xcf62f88237d08,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[857,221,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,
1453,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[419,158,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1462,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-5,268,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1463,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[431.5,599,0,203,-12,0,0,1,0.5,0.5,0,0,[]],76,1476,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[306,574,0,72,-12,0,0.7446535229682922,1,0.5,0.5,0,0,[]],76,1478,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",
0,1]],[[835,63,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1479,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[897,63,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1480,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[35,129,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1481,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[103,127,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1482,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[169,328,0,39,-3,
0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1483,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[236,330,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1484,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[65,100,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1485,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[864,31,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1486,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[204,358,0,34,3,0,2.027169975917786E-4,
1,0.5,0.5,0,0,[]],76,1487,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[201,344,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1491,[],[],[0,"Default",0,1]],[[21,553,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1492,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[88,555,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1493,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[56,583,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1494,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",
0,1]],[[53,569,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1496,[],[],[0,"Default",0,1]],[[53,573,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1497,[],[],[0,"Default",0,1]],[[725,542,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1498,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[792,544,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1499,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[760,572,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1500,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",
0,1]],[[757,558,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1502,[],[],[0,"Default",0,1]],[[604,541,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1503,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[671,543,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1504,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[639,571,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1505,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[636,557,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1507,[],[],[0,"Default",
0,1]],[[268,-63,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1508,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[330,-63,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1509,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[297,-95,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1510,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[498,-57,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1512,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[560,-57,0,39,
-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1513,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[527,-89,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1514,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[30,337,0,159,41,0,-0.3732041716575623,1,0.5031446814537048,0.5121951103210449,0,0,[]],86,1474,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[862,321,0,159,41,0,0.3717358708381653,1,0.5031446814537048,0.5121951103210449,0,0,[]],86,1516,[],[[1,1,0,1,0.5,0.2,0,0.01,0,
1]],[0,"Default",0,1]],[[415,541,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1471,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[867,62,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1488,[],[],[0,"Default",0,1]],[[70,129,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1489,[],[],[0,"Default",0,1]],[[201,331,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1490,[],[],[0,"Default",0,1]],[[53,556,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,
0,0,[]],79,1495,[],[],[0,"Default",0,1]],[[757,545,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1501,[],[],[0,"Default",0,1]],[[636,544,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1506,[],[],[0,"Default",0,1]],[[300,-64,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1511,[],[],[0,"Default",0,1]],[[530,-58,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1515,[],[],[0,"Default",0,1]],[[433,400,0,102.2437973022461,67.22403717041016,0,0,1,0.5038167834281921,0.5050504803657532,
0,0,[]],18,1066,[],[],[0,"Default",0,1]],[[414,580,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,1070,[],[],[0,"Default",0,1]],[[414,403,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1071,[],[],[0,"Default",0,1]],[[386,403,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1072,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[441,403,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,
0.5,0,0,[]],21,1073,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[413,416,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1074,[],[],[0,"Default",0,1]],[[412,427,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1075,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[430,486.0300903320313,0,109,21,0,0,1,0.5,0.5,0,0,[]],11,1076,[],[[1]],[0,"Default",0,1]],[[324,360,0,116,47,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1535,[],[[1,0,0,1,
0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[525,352,0,116,50,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1472,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,6581094115218233,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1097,-417,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1517,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1518,[],[],[0,"Default",0,1]]],[]],["gui",3,6806784887510046,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,
47,0,48.22222137451172,54.73493957519531,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1519,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1520,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1521,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1522,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],40,1523,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1524,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1525,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1526,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1527,[],[],["Level 13",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,
0.5,0,0,[]],9,1528,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,84.77986907958984,27.47495841979981,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1529,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1530,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1531,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1532,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,435.2523498535156,0,116,42,
0,0,1,0.7654321193695068,0.5,0,0,[]],84,1533,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1534,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-565,676,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2613,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel14",854,480,!0,"RedLevel14Events",8571476469026486,[["Fundo",0,0xade65ebde1551,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1473,[],[],[0,0]]],
[]],["Game",1,467769811376334,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[320.5045166015625,435.4399719238281,0,122,57,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1475,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[857,221,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1536,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[419,158,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1537,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[68,214,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1538,[[0],[5]],[[180,0]],[0,
"Default",0,1]],[[415,44,0,203,-12,0,0,1,0.5,0.5,0,0,[]],76,1546,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[835,63,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1548,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[897,63,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1549,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[35,129,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1550,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[103,127,0,39,-3,0,1.570796370506287,
1,0.5,0.5,0,0,[]],76,1551,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[214,243,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1552,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[281,245,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1553,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[65,100,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1554,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[864,31,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,
1555,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[249,273,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1556,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[35,430,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1558,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[102,432,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1559,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[70,460,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1560,[],[[1,1,0,1,0.5,
0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[578,239,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1563,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[645,241,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1564,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[613,269,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1565,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[842,376,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1567,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],
[0,"Default",0,1]],[[909,378,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1568,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[877,406,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1569,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[374,-101,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1571,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[436,-101,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1572,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],
[[403,-133,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1573,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[399,94,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1574,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[461,94,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1575,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[428,62,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1576,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[853,585,0,271,-12,
0,0,1,0.5,0.5,0,0,[]],76,1608,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[547.99609375,431.6112060546875,0,117,55,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1578,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[416,354,0,159,41,0,0.3717358708381653,1,0.5031446814537048,0.5121951103210449,0,0,[]],86,1579,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[382,-7,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1580,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",
0,1]],[[867,62,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1581,[],[],[0,"Default",0,1]],[[70,129,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1582,[],[],[0,"Default",0,1]],[[255.5935821533203,232.2187194824219,0,103,55,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1583,[],[],[0,"Default",0,1]],[[67,433,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1584,[],[],[0,"Default",0,1]],[[610,242,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1585,[],[],
[0,"Default",0,1]],[[610,255,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1566,[],[],[0,"Default",0,1]],[[874,379,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1586,[],[],[0,"Default",0,1]],[[406,-102,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1587,[],[],[0,"Default",0,1]],[[431,93,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1588,[],[],[0,"Default",0,1]],[[760,530,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1607,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",
0,1]],[[246,259,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1557,[],[],[0,"Default",0,1]],[[67,446,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1561,[],[],[0,"Default",0,1]],[[67,450,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1562,[],[],[0,"Default",0,1]],[[874,392,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1570,[],[],[0,"Default",0,1]],[[446,479,0,120.1949996948242,154.8190002441406,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1077,[],[],[0,"Default",0,1]],[[427,659,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,
0,0,[]],49,1078,[],[],[0,"Default",0,1]],[[427,482,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1109,[],[],[0,"Default",0,1]],[[399,482,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1113,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[454,482,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1114,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[426,495,0,25.21820068359375,11.3631591796875,
0,0,1,0.5,0.5,0,0,[]],22,1115,[],[],[0,"Default",0,1]],[[425,506,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1116,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[443,566,0,108.7316284179688,25.35012817382813,0,0,1,0.5,0.5,0,0,[]],11,1117,[],[[1]],[0,"Default",0,1]]],[]],["Direcionais",2,9804973722969958,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1098,-422,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1589,[],[],[0,"Default",0,1]],[[790,
298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1590,[],[],[0,"Default",0,1]]],[]],["gui",3,6055794994616357,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1591,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1592,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1593,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,
0.5,0.5018050670623779,0,0,[]],34,1594,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1595,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1596,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1597,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1598,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,
0,0,0,[]],52,1599,[],[],["Level 14",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1600,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1601,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1602,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1603,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,
14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1604,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,435.2523498535156,0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1605,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1606,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-535,679,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2614,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel18",854,480,!0,"RedLevel18Events",0x802af2a8f8fcb,[["Fundo",0,857993016767735,!0,[255,
255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1547,[],[],[0,0]]],[]],["Game",1,6149606275487892,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[323.0040283203125,435.3887939453125,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1577,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[441,305,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1610,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-13,-50,0,32,32,0,0,1,0.5,0.5064935088157654,
0,0,[]],14,1611,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[645,22,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1612,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[415,44,0,203,-12,0,0,1,0.5,0.5,0,0,[]],76,1620,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[612,-66,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1621,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[674,-66,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1622,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],
[[-45,-143,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1623,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[23,-145,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1624,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-58,517,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1625,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[9,519,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1626,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-15,-172,0,34,3,0,2.027169975917786E-4,
1,0.5,0.5,0,0,[]],76,1627,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[641,-98,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1628,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-23,547,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1629,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[162,451,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1630,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[229,453,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],
76,1631,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[197,481,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1632,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[612,470,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1633,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[679,472,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1634,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[647,500,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1635,[],[[1,1,
0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[842,466,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1636,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[909,468,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1637,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[877,496,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1638,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[399,94,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1642,[],[[1,1,0,1,0.5,0.2,0,0.01,0,
1],[]],[0,"Default",0,1]],[[461,94,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1643,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[428,62,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1644,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[601,577,0,763,-12,0,0,1,0.5,0.5,0,0,[]],76,1645,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[535,432,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1646,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[382,-7,0,
57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1648,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[644,-67,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1649,[],[],[0,"Default",0,1]],[[-10,-143,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1650,[],[],[0,"Default",0,1]],[[-26,520,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1651,[],[],[0,"Default",0,1]],[[194,454,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1652,[],[],[0,"Default",
0,1]],[[644,473,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1653,[],[],[0,"Default",0,1]],[[644,486,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1654,[],[],[0,"Default",0,1]],[[874,469,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1655,[],[],[0,"Default",0,1]],[[431,93,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1657,[],[],[0,"Default",0,1]],[[-26,533,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1659,[],[],[0,"Default",0,1]],[[194,467,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1660,[],[],
[0,"Default",0,1]],[[874,482,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1662,[],[],[0,"Default",0,1]],[[-138.9959716796875,127.3887939453125,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1903,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[71.0040283203125,161.3887939453125,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1904,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[297,218,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1905,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,
1]],[[745,125,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1906,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-92,215,0,110,-12,0,0.464797168970108,1,0.5,0.5,0,0,[]],76,1907,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[708.583251953125,266.83984375,0,110,-12,0,0.4687196910381317,1,0.5,0.5,0,0,[]],76,1908,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[86,435,0,117,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1909,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[186,230,0,110,-12,0,-0.3741801083087921,1,0.5,0.5,0,0,[]],76,1910,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[191,466,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1658,[],[],[0,"Default",0,1]],[[764,538,0,45,45,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1661,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[441.0975341796875,423.9102783203125,0,102.0779190063477,67.3026351928711,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1203,[],[],[0,"Default",0,1]],
[[422.0975341796875,603.9102783203125,0,82.62699890136719,55.04800033569336,0,0,1,0.5,3.940476179122925,0,0,[]],49,1204,[],[],[0,"Default",0,1]],[[422.0975341796875,426.9102783203125,0,82.01748657226562,48.01800155639648,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1205,[],[],[0,"Default",0,1]],[[393.0975341796875,426.9102783203125,0,2.17745304107666,52.84229278564453,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1206,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[448.0975341796875,426.9102783203125,
0,2.17745304107666,52.69826889038086,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1207,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[421.0975341796875,439.9102783203125,0,25.02320098876953,11.54415893554688,0,0,1,0.5,0.5,0,0,[]],22,1208,[],[],[0,"Default",0,1]],[[420.0975341796875,450.9102783203125,0,2.17745304107666,29.10066223144531,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1209,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[438.0975341796875,510.9102783203125,0,108.5366287231445,
25.5311279296875,0,0,1,0.5,0.5,0,0,[]],11,1210,[],[[1]],[0,"Default",0,1]],[[416,354,0,159,41,0,0.3717358708381653,1,0.5031446814537048,0.5121951103210449,0,0,[]],86,1647,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,6351773072858888,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1098,-422,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1663,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1664,[],[],[0,"Default",0,1]]],[]],
["gui",3,0xeca43af763567,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1665,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1666,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1667,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1668,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,
0.5060975551605225,0,0,[]],40,1669,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1670,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1671,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1672,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1673,[],[],["Level 18",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,
0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1674,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1675,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1676,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1677,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1678,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,435.2523498535156,
0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1679,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1680,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-562,663,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2615,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel16",854,480,!0,"RedLevel16Events",0xd1a1fb2658948,[["Fundo",0,5039282972242113,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1681,[],[],
[0,0]]],[]],["Game",1,9709970354846856,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[342,435,0,79,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1682,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[435,469,0,94.03279113769531,182.1026916503906,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1683,[],[],[0,"Default",0,1]],[[674,364,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1684,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[243,369,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1685,[[0],[5]],
[[180,0]],[0,"Default",0,1]],[[70,355,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1686,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[401,460,0,2.372452735900879,66.38139343261719,0,-0.301027238368988,1,0.5,0.5,0,0,[]],21,1687,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[465,461,0,2.372452735900879,66.38139343261719,0,0.2984699010848999,1,0.5,0.5,0,0,[]],21,1688,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[431,461,0,43.060791015625,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],
22,1689,[],[],[0,"Default",0,1]],[[434,489,0,2.372452735900879,46.12565612792969,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1690,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[434,454,0,86.14299774169922,8.461999893188477,0,0,1,0.5,3.940476179122925,0,0,[]],49,1691,[],[],[0,"Default",0,1]],[[434,458,0,86.14286041259766,74.57943725585938,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1693,[],[],[0,"Default",0,1]],[[214,427,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1699,[],[[1,1,0,1,0.5,
0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[281,429,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1700,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[249,457,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1703,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[35,430,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1704,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[102,432,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1705,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],
[0,"Default",0,1]],[[70,460,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1706,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[640,442,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1710,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[707,444,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1711,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[675,472,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1712,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],
[[374,-101,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1713,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[436,-101,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1714,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[403,-133,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1715,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[529,432,0,79,52,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1720,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[416,354,0,159,41,
0,0.3717358708381653,1,0.5031446814537048,0.5121951103210449,0,0,[]],86,1721,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[397,-19,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1722,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[246,430,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1725,[],[],[0,"Default",0,1]],[[67,433,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1726,[],[],[0,"Default",0,1]],[[672,445,0,84,73,0,3.139418601989746,
1,0.5,0.5070422291755676,0,0,[]],79,1729,[],[],[0,"Default",0,1]],[[406,-102,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1730,[],[],[0,"Default",0,1]],[[246,443,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1733,[],[],[0,"Default",0,1]],[[67,446,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1734,[],[],[0,"Default",0,1]],[[67,450,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1735,[],[],[0,"Default",0,1]],[[672,458,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1736,[],[],[0,"Default",0,1]]],[]],["Direcionais",2,8087099831150416,!0,[255,255,255],
!0,1,1,1,!1,1,0,0,[[[-1098,-422,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1737,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1738,[],[],[0,"Default",0,1]]],[]],["gui",3,8202277819983627,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1739,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1740,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,
411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1741,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1742,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1743,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1744,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1745,[],[],[0,"Default",0,
1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1746,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1747,[],[],["Level 16",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1748,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1749,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1750,[[3]],[[1]],
[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1751,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1752,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,435.2523498535156,0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1753,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1754,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-556,698,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2616,
[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel17",854,480,!0,"RedLevel17Events",0xa19064e07256c,[["Fundo",0,0x6f22e6832de70,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1755,[],[],[0,0]]],[]],["Game",1,892226415671406,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[323.947998046875,498.5422973632813,0,113,43,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1709,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[616,264,0,32,32,0,0,1,0.5,0.5064935088157654,
0,0,[]],14,1717,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[693,118,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1718,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[432,284,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1719,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[535.9491577148438,497.05810546875,0,113,43,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1769,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[72,79,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],
75,1771,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[63,122,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1780,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[209,86,0,221,-12,0,-0.3450743854045868,1,0.5,0.5,0,0,[]],76,1781,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[735,180,0,39,-3,0,0.5152940154075623,1,0.5,0.5,0,0,[]],76,1696,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[763,125,0,39,-3,0,0.5152940154075623,1,0.5,0.5,0,0,[]],76,1697,[],[[1,1,0,1,0.5,0.2,
0,0.01,0,1],[]],[0,"Default",0,1]],[[770,175,0,34,3,0,-1.055299639701843,1,0.5,0.5,0,0,[]],76,1698,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[751,152,0,84,73,0,2.083916187286377,1,0.5,0.5070422291755676,0,0,[]],79,1701,[],[],[0,"Default",0,1]],[[754,166,0,39,17,0,-1.05550229549408,1,0.5,0.5,0,0,[]],80,1702,[],[],[0,"Default",0,1]],[[670.00390625,15.34786987304688,0,113,43,0,-1.070006251335144,1,0.5,1,0,0,[]],87,1707,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[648.88427734375,
197.8221740722656,0,99,50,0,-1.142374157905579,1,0.5,1,0,0,[]],87,1708,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[74,283,0,90,-12,0,0,1,0.5,0.5,0,0,[]],76,1782,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[220,247,0,221,-12,0,-0.3450743854045868,1,0.5,0.5,0,0,[]],76,1783,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[544,336,0,113,43,0,-1.142374157905579,1,0.5,1,0,0,[]],87,1784,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[45,174,0,39,-3,0,1.570796370506287,
1,0.5,0.5,0,0,[]],76,1785,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[107,174,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1786,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[74,142,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1787,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[77,173,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1788,[],[],[0,"Default",0,1]],[[394.25,-120.75,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1789,[],[[1,1,0,1,0.5,0.2,
0,0.01,0,1],[]],[0,"Default",0,1]],[[456.25,-120.75,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1790,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[423.25,-152.75,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1791,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[426,-121,0,84,73,0,0,1,0.5,0.5070422291755676,0,0,[]],79,1792,[],[],[0,"Default",0,1]],[[662,323,0,39,-3,0,0.5152940154075623,1,0.5,0.5,0,0,[]],76,1793,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],
[[690,268,0,39,-3,0,0.5152940154075623,1,0.5,0.5,0,0,[]],76,1794,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[697,318,0,34,3,0,-1.055299639701843,1,0.5,0.5,0,0,[]],76,1795,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[678,295,0,84,73,0,2.083916187286377,1,0.5,0.5070422291755676,0,0,[]],79,1796,[],[],[0,"Default",0,1]],[[681,309,0,39,17,0,-1.05550229549408,1,0.5,0.5,0,0,[]],80,1797,[],[],[0,"Default",0,1]],[[442.9364013671875,513.2969970703125,0,102.2437973022461,67.22403717041016,
0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1160,[],[],[0,"Default",0,1]],[[423.9364013671875,693.2970581054688,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,1161,[],[],[0,"Default",0,1]],[[423.9364013671875,516.2969970703125,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1162,[],[],[0,"Default",0,1]],[[395.6190185546875,516.3853759765625,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1163,[],
[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[450.6171875,516.0224609375,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1164,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[422.9364013671875,529.2969970703125,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1165,[],[],[0,"Default",0,1]],[[421.9364013671875,540.2969970703125,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1198,[],[[1],[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[440.2603759765625,600.4378051757812,0,108.7316284179688,25.35012817382813,0,0,1,0.5,0.5,0,0,[]],11,1202,[],[[1]],[0,"Default",0,1]],[[414.9444274902344,417.1944274902344,0,159,41,0,0.3717358708381653,1,0.5031446814537048,0.5121951103210449,0,0,[]],86,1770,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,759823365688311,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1098,-422,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1811,
[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1812,[],[],[0,"Default",0,1]]],[]],["gui",3,7662051742816516,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1813,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1814,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1815,[],[],[1,"Default",0,1]],
[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1816,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1817,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1818,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1819,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1820,[],[],[0,"Default",0,
1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1821,[],[],["Level 17",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1822,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1823,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1824,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1825,[[3]],[[1]],[0,"Default",
0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1826,[[3]],[[1]],[0,"Default",0,1]],[[104.578727722168,435.2523498535156,0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1827,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1828,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-566,741,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2617,[],[],[0,"Default",0,1]]],[]]],[],[]],["RedLevel15",854,480,!0,"RedLevel15Events",0xd9da570b29e88,[["Fundo",0,
5415732344860811,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-160,-116,0,1148,728,0,0,1,0,0,0,0,[]],36,1829,[],[],[0,0]]],[]],["Game",1,7757311257618587,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[321.5042724609375,435.4194946289063,0,120,59,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1830,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[748,338,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1832,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[419,158,
0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1833,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[89,310,0,44.57143020629883,50.28571319580078,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1834,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[543,49,0,133,-12,0,0,1,0.5,0.5,0,0,[]],76,1842,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[56,402,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1852,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[123,404,0,39,-3,0,1.570796370506287,
1,0.5,0.5,0,0,[]],76,1853,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[91,432,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],76,1854,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[720,415,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1855,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[787,417,0,39,-3,0,1.570796370506287,1,0.5,0.5,0,0,[]],76,1856,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[755,445,0,34,3,0,2.027169975917786E-4,1,0.5,0.5,0,0,[]],
76,1857,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[540,431,0,115,59,0,-0.02046450972557068,1,0.5,1,0,0,[]],87,1868,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[550,-20,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1870,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[752,431,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1876,[],[],[0,"Default",0,1]],[[88,418,0,39,17,0,0,1,0.5,0.5,0,0,[]],80,1882,[],[],[0,"Default",0,1]],[[88,422,0,39,17,0,0,1,0.5,0.5,0,
0,[]],80,1883,[],[],[0,"Default",0,1]],[[217,140,0,149,-12,0,0,1,0.5,0.5,0,0,[]],76,1639,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[174.5,83.5,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1640,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[893,189,0,146,-12,0,0,1,0.5,0.5,0,0,[]],76,1641,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[902,122,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1656,[[0]],[[0,2,0,1,0.5,0.2,0,0.01,
0,1],[],[]],[0,"Default",0,1]],[[88,405,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1874,[],[],[0,"Default",0,1]],[[752,418,0,84,73,0,3.139418601989746,1,0.5,0.5070422291755676,0,0,[]],79,1875,[],[],[0,"Default",0,1]],[[441,482,0,102.2437973022461,67.22403717041016,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1118,[],[],[0,"Default",0,1]],[[422,662,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,1119,[],[],[0,"Default",0,1]],[[422,485,0,82.21248626708984,
47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1120,[],[],[0,"Default",0,1]],[[394,485,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1121,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[449,485,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1153,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[421,498,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1157,[],[],[0,"Default",0,1]],[[420,
509,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1158,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[438,569,0,108.7316284179688,25.35012817382813,0,0,1,0.5,0.5,0,0,[]],11,1159,[],[[1]],[0,"Default",0,1]]],[]],["Direcionais",2,7717479110021099,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1098,-422,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1885,[],[],[0,"Default",0,1]],[[790,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1886,
[],[],[0,"Default",0,1]]],[]],["gui",3,5014277252301282,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1887,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1888,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1889,[],[],[1,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1890,[],[],[0,"Default",0,
1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1891,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1892,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1893,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1894,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1895,[],[],["Level 15",0,"bold 16pt Comic Sans MS",
"rgb(255,255,255)",0,0,0,0,0]],[[802.5,625,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1896,[[3]],[[1]],[0,"Default",0,1]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1897,[],[],[0,"Default",0,1]],[[-13,-244,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1898,[[3]],[[1]],[0,"Default",0,1]],[[-491,29,0,2995,14,0,1.594130516052246,1,0.5,0.5,0,0,[]],9,1899,[[3]],[[1]],[0,"Default",0,1]],[[1323,162,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1900,[[3]],[[1]],[0,
"Default",0,1]],[[104.578727722168,435.2523498535156,0,116,42,0,0,1,0.7654321193695068,0.5,0,0,[]],84,1901,[],[],[0,"Default",0,1]],[[68,419,0,57,33,0,0,1,0,0,0,0,[]],83,1902,[],[],[25,30,"0123456789:","30",1,0,1,1,0,0,0,0]],[[-522,720,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2618,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevelMenu",854,480,!0,"GameEventsBlue",8289248042733039,[["a2",0,0xe14dd1af9be23,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]],["a",1,0xb86939ad60428,!0,[255,
255,255],!1,1,1,1,!1,1,0,0,[[[416,246,0,972,598,0,0,1,0.5,0.5,0,0,[]],100,10,[],[],[0,"Default",0,1]]],[]],["LevelsFundo",2,0x69ccb53e8a995,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[437,85,0,133,147,0,0,1,0.5037593841552734,0.5034013390541077,0,0,[]],37,183,[],[],[0,"Default",0,1]]],[]],["Estrelas",3,5006608601735959,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[441,309,0,634,312,0,0,1,0.5,0.5,0,0,[]],112,136,[],[],[0,"Default",0,1]]],[]],["LevelsChoose",4,0x9532b828c5432,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[166,
191,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,164,[],[],[0,"Default",0,1]],[[274,189,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,165,[],[],[0,"Default",0,1]],[[386,192,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,166,[],[],[0,"Default",0,1]],[[602,191,0,83,80,0,0,1,0.5,0.5,0,0,[]],26,168,[],[],[0,"Default",0,1]],[[711,191,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,169,[],[],[0,"Default",0,1]],[[166,293,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,170,[],[],[0,"Default",0,1]],[[275,293,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,171,[],[],[0,"Default",0,1]],[[385,
295,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,172,[],[],[0,"Default",0,1]],[[492,292,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,173,[],[],[0,"Default",0,1]],[[600,295,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,174,[],[],[0,"Default",0,1]],[[713,294,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,175,[],[],[0,"Default",0,1]],[[166,405,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,176,[],[],[0,"Default",0,1]],[[276,405,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,177,[],[],[0,"Default",0,1]],[[386,406,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,178,[],[],[0,"Default",0,1]],[[492,
404,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,179,[],[],[0,"Default",0,1]],[[604,409,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,180,[],[],[0,"Default",0,1]],[[712,406,0,83,86,0,0,1,0.5,0.5,0,0,[]],26,181,[],[],[0,"Default",0,1]],[[56,59,0,71,71,0,0,1,0.5,0.5064935088157654,0,0,[]],38,184,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevel2",854,480,!0,"GreenLevel2Event",0x7a081399b60ee,[["Fundo",0,7200776807081241,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-5,-9,0,865,496,0,0,1,0,0,0,0,[]],
39,2598,[],[],[0,0]],[[815,578,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,2599,[[3]],[[1]],[0,"Default",0,1]],[[12,-51,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,2600,[[3]],[[1]],[0,"Default",0,1]],[[-130,191,0,2995,14,0,1.570796370506287,1,0.5,0.5,0,0,[]],9,2601,[[3]],[[1]],[0,"Default",0,1]],[[962,156,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,2602,[[3]],[[1]],[0,"Default",0,1]]],[]],["Game",1,9867656149380508,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[505,77,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2604,
[[0],[5]],[[180,0]],[0,"Default",0,1]],[[590,434,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2605,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[738,75,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2606,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-834,65,0,250,250,0,0,1,0.5,0.5,0,0,[]],89,2607,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[157,409,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,2608,[],[],[0,"Default",0,1]],[[155,324,0,102.2440032958984,67.2239990234375,0,0,1,
0.5038167834281921,0.5050504803657532,0,0,[]],18,2609,[],[],[0,"Default",0,1]],[[145,547,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,2610,[],[],[0,"Default",0,1]],[[144,371,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,2624,[],[],[0,"Default",0,1]],[[191,174,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,2625,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[246,174,0,2.372452735900879,52.51726913452148,
0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,2626,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[143,384,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,2627,[],[],[0,"Default",0,1]],[[217,198,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,2628,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[773,479,0,481,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2629,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[64,483,0,481,22,0,-1.570796489715576,
1,0,0,0,0,[]],117,2630,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[67,458,0,713,22,0,0,1,0,0,0,0,[]],117,2631,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[68,1,0,713,22,0,0,1,0,0,0,0,[]],117,2632,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[463,229,0,206,22,0,0,1,0,0,0,0,[]],117,2633,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[644,150,0,142,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2634,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[458,128,0,206,22,0,0,1,0,0,0,0,[]],117,2635,[],[[],[1,0,0,1,
0.5,0.2,0,0.01,0,1]],[0,0]],[[454,251,0,122,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2636,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[646.0000610351562,476,0,245,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2637,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[382,434,0,38,52,0,0,1,0.5,0.5,0,0,[]],118,2638,[[0]],[],[0,"Default",0,1]],[[214,122,0,83,22,0,0,1,0,0,0,0,[]],117,2639,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[215,477,0,353,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2640,[],[[],[1,0,0,1,
0.5,0.2,0,0.01,0,1]],[0,0]],[[519,190,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2641,[],[[180,0]],[0,"Default",0,1]],[[723,412,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2642,[],[[180,0]],[0,"Default",0,1]],[[-23,426,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2643,[],[[180,0]],[0,"Default",0,1]],[[590.5631713867188,75.76081848144531,0,80.1473617553711,
83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2644,[],[[180,0]],[0,"Default",0,1]],[[264,71.68887329101562,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,2645,[[1]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[117.4061660766602,368.7216186523438,0,5.280762195587158,-48.60602569580078,0,-0.4365518093109131,1,0.5,0.5,0,0,[]],76,2646,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[171.8530578613281,371.6309204101563,0,5.280762195587158,
-48.60602569580078,0,0.4048660397529602,1,0.5,0.5,0,0,[]],76,2647,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-526,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2648,[],[],[0,"Default",0,1]]],[]],["Direcionais",2,0xf7b163a524821,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1050,-423,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2649,[],[],[0,"Default",0,1]],[[845,285,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2650,[],[],[0,"Default",0,1]]],
[]],["gui",3,4677162775196385,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2651,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,2652,[],[],["Level 2",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2653,[],[],[0,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2654,[],[],[0,"Default",0,1]],[[119,
864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2655,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2656,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2657,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2658,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2659,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",
0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2660,[],[],[1,"Default",0,1]],[[437,1359,0,855,250,0,0,1,0.5,0.5,0,0,[]],91,2661,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevel1",854,480,!0,"GreenLevel1Event",7594817400253096,[["Fundo",0,8516993128192785,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-10.4134521484375,-8.317718505859375,0,870,497.1467895507813,0,0,1,0,0,0,0,[]],39,8,[],[],[0,0]],[[815,578,0,2995,
14,0,0,1,0.5,0.5,0,0,[]],9,52,[[3]],[[1]],[0,"Default",0,1]],[[12,-51,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,113,[[3]],[[1]],[0,"Default",0,1]],[[-130,191,0,2995,14,0,1.570796370506287,1,0.5,0.5,0,0,[]],9,120,[[3]],[[1]],[0,"Default",0,1]],[[962,156,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,162,[[3]],[[1]],[0,"Default",0,1]]],[]],["Game",1,0x433bb2662d93b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[623,74,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,504,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[326,
186,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,650,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-834,65,0,250,250,0,0,1,0.5,0.5,0,0,[]],89,652,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[197,404,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,653,[],[],[0,"Default",0,1]],[[195,319,0,102.2440032958984,67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,654,[],[],[0,"Default",0,1]],[[185,542,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,
0,0,[]],49,661,[],[],[0,"Default",0,1]],[[184,366,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,662,[],[],[0,"Default",0,1]],[[231,169,0,2.372452735900879,52.66129302978516,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,663,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[286,169,0,2.372452735900879,52.51726913452148,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,664,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[183,379,0,25.21820068359375,11.3631591796875,
0,0,1,0.5,0.5,0,0,[]],22,698,[],[],[0,"Default",0,1]],[[257,193,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,699,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[104,478,0,481,22,0,-1.570796489715576,1,0,0,0,0,[]],117,717,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[107,453,0,599,22,0,0,1,0,0,0,0,[]],117,726,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[108,-4,0,597,22,0,0,1,0,0,0,0,[]],117,733,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[684,145,0,142,
22,0,-1.570796489715576,1,0,0,0,0,[]],117,1321,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[498,123,0,206,22,0,0,1,0,0,0,0,[]],117,1322,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[494.0000610351563,349,0,225,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1323,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[686,474,0,140.8183898925781,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1324,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-886,-305,0,38,52,0,0,1,0.5,0.5,0,0,[]],118,1325,[[0]],[],[0,"Default",0,1]],
[[254,117,0,135,22,0,0,1,0,0,0,0,[]],117,1326,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[255,472,0,353,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1385,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[323,405,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1391,[],[[180,0]],[0,"Default",0,1]],[[629,403,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1392,[],[[180,0]],[0,"Default",0,1]],[[304,67,0,57,57,0,0,1,
0.5121951103210449,0.5121951103210449,0,0,[]],75,1393,[[1]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[158,364,0,5.280762195587158,-48.60602569580078,0,-0.4365518093109131,1,0.5,0.5,0,0,[]],76,1394,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[212,367,0,5.280762195587158,-48.60602569580078,0,0.4048660397529602,1,0.5,0.5,0,0,[]],76,1395,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-526,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,1452,
[],[],[0,"Default",0,1]],[[369,472,0,353,22,0,-1.570796489715576,1,0,0,0,0,[]],117,167,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[450,399,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,651,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[495.6124877929688,330,0,209.3875122070313,22,0,0,1,0,0,0,0,[]],117,865,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]]],[]],["Direcionais",2,0xc78b2eca31c69,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1070,-414,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,
1470,[],[],[0,"Default",0,1]],[[821,285,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1544,[],[],[0,"Default",0,1]]],[]],["gui",3,7125094605461903,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1545,[],[],[0,"Default",0,1]],[[137,25,0,111,30,0,0,1,0,0,0,0,[]],52,1616,[],[],["Level 1",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1617,[],
[],[0,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1618,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1619,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1692,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1716,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1723,
[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1724,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1727,[],[],[1,"Default",0,1]],[[437,1359,0,855,250,0,0,1,0.5,0.5,0,0,[]],91,1728,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevel3",854,480,!0,"GameLevel3Event",0xfcd525818d05e,[["Fundo",0,9120991202317338,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,
0,0,[[[-6,-8,0,878,505,0,0,1,0,0,0,0,[]],39,507,[],[],[0,0]],[[815,578,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,509,[[3]],[[1]],[0,"Default",0,1]],[[12,-51,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,510,[[3]],[[1]],[0,"Default",0,1]],[[-130,191,0,2995,14,0,1.570796370506287,1,0.5,0.5,0,0,[]],9,631,[[3]],[[1]],[0,"Default",0,1]],[[962,156,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,632,[[3]],[[1]],[0,"Default",0,1]]],[]],["Game",1,0xc3851d21770ca,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[629,265,0,32,32,0,0,1,0.5,
0.5064935088157654,0,0,[]],14,635,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[289,364,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,636,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[731,360,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,637,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-834,65,0,250,250,0,0,1,0.5,0.5,0,0,[]],89,638,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[746,550,0,29,108.9260025024414,0,0,1,0.517241358757019,0.5,0,0,[]],103,639,[],[],[0,"Default",0,1]],[[744,465,0,102.2440032958984,
67.2239990234375,0,0,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,812,[],[],[0,"Default",0,1]],[[734,688,0,82.8219985961914,54.86700057983398,0,0,1,0.5,3.940476179122925,0,0,[]],49,1197,[],[],[0,"Default",0,1]],[[733,512,0,82.21248626708984,47.83700180053711,0,0,1,0.5,0.5138888955116272,0,0,[]],16,1694,[],[],[0,"Default",0,1]],[[700.88671875,503.2491455078125,0,2,72,0,-0.4393978118896484,1,0.5,0.5,0,0,[]],21,1695,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[773.33154296875,498.1728515625,
0,2,91,0,0.5063315033912659,1,0.5,0.5,0,0,[]],21,1756,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[732,525,0,25.21820068359375,11.3631591796875,0,0,1,0.5,0.5,0,0,[]],22,1757,[],[],[0,"Default",0,1]],[[733,537,0,2.372452735900879,28.91966247558594,0,-1.570796489715576,1,0.5,0.5,0,0,[]],21,1758,[],[[1],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[800.0001220703125,607,0,607,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1759,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[64,483,0,527,
22,0,-1.570796489715576,1,0,0,0,0,[]],117,1760,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[67,458,0,623,22,0,0,1,0,0,0,0,[]],117,1761,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[210.9181518554688,1,0,609.0818481445312,22,0,0,1,0,0,0,0,[]],117,1762,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[73,317,0,501,22,0,0,1,0,0,0,0,[]],117,1763,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[185,183,0,494,22,0,0,1,0,0,0,0,[]],117,1767,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[668.0001220703125,613,0,
610,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1772,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[798,223,0,38,52,0,-1.570796489715576,1,0.5,0.5,0,0,[]],118,1773,[[0]],[],[0,"Default",0,1]],[[147.7116241455078,23.50498580932617,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1776,[],[[180,0]],[0,"Default",0,1]],[[-23,426,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1778,[],[[180,0]],[0,"Default",0,1]],[[615,
76,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1779,[],[[180,0]],[0,"Default",0,1]],[[132,415,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1798,[[1]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[707,510,0,5.280762195587158,-48.60602569580078,0,-0.4365518093109131,1,0.5,0.5,0,0,[]],76,1799,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[761,513,0,5.280762195587158,-48.60602569580078,0,0.4048660397529602,1,0.5,
0.5,0,0,[]],76,1846,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]],[[-526,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,1859,[],[],[0,"Default",0,1]],[[331,345,0,92,58,0,3.138959407806397,1,0.5,0.5,0,0,[]],121,1774,[],[[1,0,0,6,0,0,0,200,0]],[0,"Default",0,1]],[[744,75,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1764,[],[[180,0]],[0,"Default",0,1]],[[673,591,0,148,22,0,0,1,0,0,0,0,[]],117,1768,[],[[],[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,0]],[[209.9087677001953,15.55416870117188,0,74,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1775,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[64,-60,0,168.3938903808594,22,0,0,1,0,0,0,0,[]],117,1777,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[331,312,0,92,58,0,0.01218058727681637,1,0.5,0.5,0,0,[]],121,1920,[],[[1,0,0,6,0,0,0,200,0]],[0,"Default",0,1]],[[397,31,0,92,58,0,3.138959407806397,1,0.5,0.5,0,0,[]],121,1921,[],[[1,0,0,6,0,0,0,130,0]],[0,"Default",0,1]]],[]],["Direcionais",2,
7746303424356599,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1069,-438,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1879,[],[],[0,"Default",0,1]],[[826,298,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1880,[],[],[0,"Default",0,1]]],[]],["gui",3,0xd8981fae6ba5c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1881,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,1884,[],[],["Level 3",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",
0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1911,[],[],[0,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1912,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1913,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,1914,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],42,1915,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1916,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1917,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1918,[],[],[1,"Default",0,1]],[[437,1359,0,855,250,0,0,1,0.5,0.5,0,0,[]],91,1919,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevel4",854,480,!0,"GreenLevel4Event",
7186154650259704,[["Fundo",0,0x40ec2e2827c6e,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-11,-10,0,873,499,0,0,1,0,0,0,0,[]],39,1922,[],[],[0,0]],[[596,657,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1925,[[3]],[[1]],[0,"Default",0,1]],[[12,-51,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1957,[[3]],[[1]],[0,"Default",0,1]],[[-130,191,0,2995,14,0,1.570796370506287,1,0.5,0.5,0,0,[]],9,1958,[[3]],[[1]],[0,"Default",0,1]],[[962,156,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1976,[[3]],[[1]],
[0,"Default",0,1]]],[]],["Game",1,4924625957928456,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[901,339,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1979,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[495.9298095703125,148.7039031982422,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1980,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-834,65,0,250,250,0,0,1,0.5,0.5,0,0,[]],89,1988,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[135.6117706298828,-60.81398010253906,0,29,108.9260025024414,0,3.141592741012573,
1,0.517241358757019,0.5,0,0,[]],103,1989,[],[],[0,"Default",0,1]],[[138.6117706298828,18.18601989746094,0,102.2440032958984,67.2239990234375,0,3.141592741012573,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1990,[],[],[0,"Default",0,1]],[[-384,289,0,82.8219985961914,54.86700057983398,0,3.141592741012573,1,0.5,3.940476179122925,0,0,[]],49,1991,[],[],[0,"Default",0,1]],[[149.6117706298828,-29.81398010253906,0,82.21248626708984,47.83700180053711,0,3.141592741012573,1,0.5,0.5138888955116272,0,0,
[]],16,1992,[],[],[0,"Default",0,1]],[[148,-55,0,25.21820068359375,11.3631591796875,0,3.141592741012573,1,0.5,0.5,0,0,[]],22,1996,[],[],[0,"Default",0,1]],[[836.9999389648438,547,0,292.6801147460938,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1998,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[63.99995422363281,245,0,375,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1999,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[469,104,0,68,22,0,0,1,0,0,0,0,[]],117,2E3,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[196.7947387695313,
-2,0,647.6596069335938,22,0,0,1,0,0,0,0,[]],117,2001,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-37.26776123046875,235,0,123.2677612304688,22,0,0,1,0,0,0,0,[]],117,2002,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[922,436,0,38,52,0,-1.570796489715576,1,0.5,0.5,0,0,[]],118,2005,[[0]],[],[0,"Default",0,1]],[[146,399,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2007,[],[[180,0]],[0,"Default",0,1]],[[775,90,0,80.1473617553711,83.52198791503906,0,0,
1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2008,[],[[180,0]],[0,"Default",0,1]],[[503,68,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,2009,[[1]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[114.6117706298828,-31.81398010253906,0,5.280762195587158,-48.60602569580078,0,-2.756443500518799,1,0.5,0.5,0,0,[]],76,2010,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[1,"Default",0,1]],[[181.6117706298828,-29.81398010253906,0,5.280762195587158,-48.60602569580078,0,2.673397064208984,
1,0.5,0.5,0,0,[]],76,2011,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[1,"Default",0,1]],[[-526,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,2012,[],[],[0,"Default",0,1]],[[938,53,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2014,[],[[180,0]],[0,"Default",0,1]],[[195.3338928222656,-0.74267578125,0,134.6276702880859,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2016,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[64.65007019042969,-136.6625213623047,
0,144.5453338623047,22,0,0,1,0,0,0,0,[]],117,2536,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[313.3948974609375,262.5667724609375,0,221,22,0,-0.7989349365234375,1,0,0,0,0,[]],117,1930,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[541.0479736328125,105.0147857666016,0,70.4146728515625,22,0,1.491360306739807,1,0,0,0,0,[]],117,2015,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[405.6424255371094,289.3846435546875,0,178.8435363769531,22,0,-0.7989349365234375,1,0,0,0,0,[]],117,2053,[],[[],[1,0,0,1,0.5,
0.2,0,0.01,0,1]],[0,0]],[[334.5231628417969,263.0379638671875,0,68,22,0,1.491360306739807,1,0,0,0,0,[]],117,2584,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[334.1573181152344,316.8800659179688,0,90.58193969726562,22,0,0.8134952783584595,1,0,0,0,0,[]],117,2585,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[380.0668029785156,375.0751647949219,0,72.5421142578125,22,0,0,1,0,0,0,0,[]],117,2586,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[437,381,0,178.8435363769531,22,0,-0.7989349365234375,1,0,0,0,0,
[]],117,2587,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[562,253,0,282,22,0,0,1,0,0,0,0,[]],117,2588,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[606,280,0,92,58,0,3.138959407806397,1,0.5,0.5,0,0,[]],121,2013,[],[[1,0,0,7,0,0,0,200,0]],[0,"Default",0,1]],[[606,247,0,92,58,0,0.01218058727681637,1,0.5,0.5,0,0,[]],121,2566,[],[[1,0,0,7,0,0,0,200,0]],[0,"Default",0,1]],[[671,302,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,2583,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-38.0000114440918,548,0,312,
22,0,-1.570796489715576,1,0,0,0,0,[]],117,1978,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[84.27322387695312,336,0,250.7267761230469,22,0,0,1,0,0,0,0,[]],117,2589,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[321,526,0,189,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2590,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[82.99996948242188,456.9996643066406,0,119.9996643066406,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2591,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[86,436,0,140,22,0,0,1,0,0,0,0,[]],
117,2592,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[401,470,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,2593,[],[[180,0]],[0,"Default",0,1]],[[-9,315,0,92,58,0,1.572512984275818,1,0.5,0.5,0,0,[]],121,2567,[],[[1,1,0,6,0,0,0,170,0]],[0,"Default",0,1]],[[837.7568969726562,171.6538696289063,0,173,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2594,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[839,149,0,125,22,0,0,1,0,0,0,0,[]],117,2595,[],[[],[1,0,0,1,
0.5,0.2,0,0.01,0,1]],[0,0]],[[941.7596435546875,546.3198852539062,0,396,22,0,-1.570796489715576,1,0,0,0,0,[]],117,2596,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[656,535,0,100,100,0,-1.013705492019653,1,0.5,0.5,0,0,[]],123,100,[],[[180,0],[1,0,0,4,0,0,0,120,0]],[0,"Default",0,1]],[[-29.093017578125,526.434326171875,0,872,22,0,0,1,0,0,0,0,[]],117,2003,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[653,537,0,160,30,0,3.141592741012573,1,0.1062500029802322,0.5333333611488342,0,0,[]],124,1869,[],[[0,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[783,537,0,160,30,0,3.141592741012573,1,0.1062500029802322,0.5333333611488342,0,0,[]],124,1871,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,0x764ea2ec9461d,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1079,-475,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2568,[],[],[0,"Default",0,1]],[[870,258,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2569,[],[],[0,"Default",0,1]]],[]],["gui",3,0x69cd987e43b3d,!0,
[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2570,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,2571,[],[],["Level 4",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2572,[],[],[0,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2573,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,
0.5060975551605225,0,0,[]],40,2574,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2575,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,2576,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2577,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2578,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,
411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2579,[],[],[1,"Default",0,1]],[[437,1359,0,855,250,0,0,1,0.5,0.5,0,0,[]],91,2580,[],[],[0,"Default",0,1]],[[428,240,0,973,610,0,0,1,0.5,0.5,0,0,[]],90,2581,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevel5",854,480,!0,"GreenLevel4Event",0x5ac709e291121,[["Fundo",0,620106800101951,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-11,-10,0,873,499,0,0,1,0,0,0,0,[]],39,101,[],[],[0,0]],[[596,657,0,2995,14,
0,0,1,0.5,0.5,0,0,[]],9,102,[[3]],[[1]],[0,"Default",0,1]],[[12,-51,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,114,[[3]],[[1]],[0,"Default",0,1]],[[-130,191,0,2995,14,0,1.570796370506287,1,0.5,0.5,0,0,[]],9,633,[[3]],[[1]],[0,"Default",0,1]],[[962,156,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1765,[[3]],[[1]],[0,"Default",0,1]]],[]],["Game",1,0xb55fcfbb29f76,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[878,376,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1766,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[482,
154,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1800,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-834,65,0,250,250,0,0,1,0.5,0.5,0,0,[]],89,1801,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[135.6117706298828,-60.81398010253906,0,29,108.9260025024414,0,3.141592741012573,1,0.517241358757019,0.5,0,0,[]],103,1802,[],[],[0,"Default",0,1]],[[138.6117706298828,18.18601989746094,0,102.2440032958984,67.2239990234375,0,3.141592741012573,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1803,[],
[],[0,"Default",0,1]],[[149,-205,0,82.8219985961914,54.86700057983398,0,3.141592741012573,1,0.5,3.940476179122925,0,0,[]],49,1804,[],[],[0,"Default",0,1]],[[148,-55,0,25.21820068359375,11.3631591796875,0,3.141592741012573,1,0.5,0.5,0,0,[]],22,1806,[],[],[0,"Default",0,1]],[[805.0000610351562,315,0,210,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1807,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[63.99995422363281,245,0,375,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1808,[],[[],[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,0]],[[352.6596069335938,103,0,452,22,0,0,1,0,0,0,0,[]],117,1810,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-37.26776123046875,235,0,123.2677612304688,22,0,0,1,0,0,0,0,[]],117,1843,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[364,425,0,583.8651733398438,22,0,0,1,0,0,0,0,[]],117,1844,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[1050,735,0,38,52,0,0,1,0.5,0.5,0,0,[]],118,1847,[[0]],[],[0,"Default",0,1]],[[288,470,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,
0,0,[]],119,1848,[],[[180,0]],[0,"Default",0,1]],[[452,48,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1849,[],[[180,0]],[0,"Default",0,1]],[[297,35,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1850,[[1]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,1]],[[114.6117706298828,-31.81398010253906,0,5.280762195587158,-48.60602569580078,0,-2.756443500518799,1,0.5,0.5,0,0,[]],76,1851,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[1,"Default",
0,1]],[[181.6117706298828,-29.81398010253906,0,5.280762195587158,-48.60602569580078,0,2.673397064208984,1,0.5,0.5,0,0,[]],76,1858,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[1,"Default",0,1]],[[-526,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,1860,[],[],[0,"Default",0,1]],[[873,209,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1861,[],[[180,0]],[0,"Default",0,1]],[[64.65007019042969,-136.6625213623047,0,144.5453338623047,22,0,0,1,0,
0,0,0,[]],117,1863,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[484,395,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1923,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[-38.00001525878906,544,0,308,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1924,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[196,260,0,511,22,0,0,1,0,0,0,0,[]],117,1926,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[351,124,0,165,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1928,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[132,467,0,80.14700317382812,
83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1931,[],[[180,0]],[0,"Default",0,1]],[[356.9670104980469,544.7096557617188,0,118.6164855957031,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1933,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[823,135,0,125,22,0,0,1,0,0,0,0,[]],117,1934,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[926,430,0,292,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1935,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[478,177,0,100,100,0,0,1,0.5,0.5,0,0,[]],123,
1936,[],[[300,0],[0,0,0,4,0,0,0,120,0]],[0,"Default",0,1]],[[478.9478759765625,272.5945739746094,0,128,28,0,-1.570796489715576,1,0.1328125,0.5,0,0,[]],126,1809,[],[[1,0,0,4,0,0,0,50,0]],[0,"Default",0,1]],[[198.2724609375,-41.36373901367188,0,174.2729034423828,22,0,0,1,0,0,0,0,[]],117,1864,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[207,248,0,100,100,0,0,1,0.5,0.5,0,0,[]],127,1865,[],[[180,0],[1,1,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[195.3339996337891,536.629638671875,0,672,22,0,-1.570796489715576,
1,0,0,0,0,[]],117,1862,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[206,184,0,160,30,0,1.570796370506287,1,0.1062500029802322,0.5333333611488342,0,0,[]],124,1866,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-34,523,0,413,22,0,0,1,0,0,0,0,[]],117,1867,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[800,266,0,92,58,0,-1.570796489715576,1,0.5,0.5,0,0,[]],121,1932,[],[[1,1,0,6,0,0,0,200,0]],[0,"Default",0,1]],[[149.6117706298828,-29.81398010253906,0,82.21248626708984,47.83700180053711,0,3.141592741012573,
1,0.5,0.5138888955116272,0,0,[]],16,1805,[],[],[0,"Default",0,1]]],[]],["Direcionais",2,938394012227187,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1079,-475,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,1937,[],[],[0,"Default",0,1]],[[818,282,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,1938,[],[],[0,"Default",0,1]]],[]],["gui",3,0xc5fbdc9aee3f7,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,1939,[],[],[0,"Default",0,1]],[[97,30,0,
111,30,0,0,1,0,0,0,0,[]],52,1940,[],[],["Level 4",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,1941,[],[],[0,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,1942,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,1943,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,
0,[]],41,1944,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],42,1946,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,1947,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,1948,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,1949,[],[],[1,"Default",0,1]],[[437,1359,0,855,250,
0,0,1,0.5,0.5,0,0,[]],91,1950,[],[],[0,"Default",0,1]]],[]]],[],[]],["GreenLevel6",854,480,!0,"GreenLevel4Event",9137926859587264,[["Fundo",0,7867807277886406,!0,[255,255,255],!1,0.800000011920929,0.800000011920929,1,!1,1,0,0,[[[-11,-10,0,873,499,0,0,1,0,0,0,0,[]],39,1872,[],[],[0,0]],[[596,657,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1873,[[3]],[[1]],[0,"Default",0,1]],[[12,-51,0,2995,14,0,0,1,0.5,0.5,0,0,[]],9,1877,[[3]],[[1]],[0,"Default",0,1]],[[-130,191,0,2995,14,0,1.570796370506287,1,0.5,0.5,0,0,[]],
9,1878,[[3]],[[1]],[0,"Default",0,1]],[[962,156,0,2995,14,0,1.567617535591126,1,0.5,0.5,0,0,[]],9,1927,[[3]],[[1]],[0,"Default",0,1]]],[]],["Game",1,0x6de84259c6b73,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[361.467041015625,4.571151733398438,0,100,100,0,0,1,0.5,0.5,0,0,[]],129,1974,[],[[180,0],[1,0,0,4,0,0,0,50,0]],[0,"Default",0,1]],[[438,545,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1929,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[482,154,0,32,28,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1951,[[0],
[5]],[[180,0]],[0,"Default",0,1]],[[-834,65,0,250,250,0,0,1,0.5,0.5,0,0,[]],89,1952,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[350,-180,0,29,108.9260025024414,0,3.141592741012573,1,0.517241358757019,0.5,0,0,[]],103,1953,[],[],[0,"Default",0,1]],[[387,-116,0,102.2440032958984,67.2239990234375,0,3.141592741012573,1,0.5038167834281921,0.5050504803657532,0,0,[]],18,1954,[],[],[0,"Default",0,1]],[[364,-325,0,82.8219985961914,54.86700057983398,0,3.141592741012573,1,0.5,3.940476179122925,0,0,
[]],49,1955,[],[],[0,"Default",0,1]],[[363,-175,0,25.21820068359375,11.3631591796875,0,3.141592741012573,1,0.5,0.5,0,0,[]],22,1956,[],[],[0,"Default",0,1]],[[52,417,0,421.52685546875,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1960,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[183.6595458984375,103,0,621,22,0,0,1,0,0,0,0,[]],117,1961,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[364,425,0,462.955810546875,22,0,0,1,0,0,0,0,[]],117,1963,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[689.0350341796875,
239.5449523925781,0,38,52,0,0,1,0.5,0.5,0,0,[]],118,1964,[[0]],[],[0,"Default",0,1]],[[288,470,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1965,[],[[180,0]],[0,"Default",0,1]],[[452,48,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1966,[],[[180,0]],[0,"Default",0,1]],[[120,190,0,57,57,0,0,1,0.5121951103210449,0.5121951103210449,0,0,[]],75,1967,[[1]],[[0,2,0,1,0.5,0.2,0,0.01,0,1],[],[]],[0,"Default",0,
1]],[[329,-151,0,5.280762195587158,-48.60602569580078,0,-2.756443500518799,1,0.5,0.5,0,0,[]],76,1968,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[1,"Default",0,1]],[[396,-149,0,5.280762195587158,-48.60602569580078,0,2.673397064208984,1,0.5,0.5,0,0,[]],76,1969,[],[[1,1,0,1,0.5,0.2,0,0.01,0,1],[]],[1,"Default",0,1]],[[-526,812,0,75.41883087158203,75.41883087158203,0,0,1,0.5,0.5,0,0,[]],114,1970,[],[],[0,"Default",0,1]],[[873,209,0,80.1473617553711,83.52198791503906,0,0,1,0.5052631497383118,0.5050504803657532,
0,0,[]],119,1971,[],[[180,0]],[0,"Default",0,1]],[[1233,418,0,32,32,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1973,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[61,260,0,646,22,0,0,1,0,0,0,0,[]],117,1975,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[132,467,0,80.14700317382812,83.52200317382812,0,0,1,0.5052631497383118,0.5050504803657532,0,0,[]],119,1995,[],[[180,0]],[0,"Default",0,1]],[[543,177,0,100,96,0,0,1,0.5,0.5,0,0,[]],123,2534,[],[[300,0],[0,0,0,4,0,0,0,120,0]],[0,"Default",0,1]],[[543.9478759765625,
272.5945739746094,0,128,24,0,-1.570796489715576,1,0.1328125,0.5,0,0,[]],126,2535,[],[[1,5,0,14,1,0,0,400,0]],[0,"Default",0,1]],[[87,-275,0,100,100,0,0,1,0.5,0.5,0,0,[]],127,2597,[],[[180,0],[1,1,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[64,116,0,160,30,0,0,1,0.1062500029802322,0.5333333611488342,0,0,[]],124,2619,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1064,21,0,92,58,0,-1.570796489715576,1,0.5,0.5,0,0,[]],121,2621,[],[[1,1,0,6,0,0,0,200,0]],[0,"Default",0,1]],[[364,-149,0,82.21248626708984,
47.83700180053711,0,3.141592741012573,1,0.5,0.5138888955116272,0,0,[]],16,2622,[],[],[0,"Default",0,1]],[[773.2728881835938,421.0905151367188,0,35,16,0,0,1,0.5142857432365417,0.5,0,0,[]],128,1972,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[585,47,0,32,28,0,0,1,0.5,0.5064935088157654,0,0,[]],14,1993,[[0],[5]],[[180,0]],[0,"Default",0,1]],[[318,173,0,100,96,0,0,1,0.5,0.5,0,0,[]],123,1997,[],[[300,0],[0,0,0,4,0,0,0,120,0]],[0,"Default",0,1]],[[317,269,0,128,24,0,-1.570796489715576,1,0.1328125,
0.5,0,0,[]],126,2620,[],[[1,5,1,14,1,0,0,400,0]],[0,"Default",0,1]],[[805.2631225585938,447.3336486816406,0,452.48974609375,22,0,-1.570796489715576,1,0,0,0,0,[]],117,1959,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[52.89254760742188,-6,0,774,22,0,0,1,0,0,0,0,[]],117,2582,[],[[],[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[303.1828308105469,5.403030395507813,0,160,30,0,0,1,0.1062500029802322,0.5333333611488342,0,0,[]],124,1962,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Direcionais",2,
8273988160836444,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1079,-475,0,819,832,0,0,1,-0.8222222328186035,-0.3687150776386261,0,0,[]],12,2623,[],[],[0,"Default",0,1]],[[818,282,0,779,830,0,0,1,0.5,0.5027933120727539,0,0,[]],13,2662,[],[],[0,"Default",0,1]]],[]],["gui",3,0x3c3039cb1db7f,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[51,47,0,62,59,0,0,1,0.5,0.5064935088157654,0,0,[]],7,2663,[],[],[0,"Default",0,1]],[[97,30,0,111,30,0,0,1,0,0,0,0,[]],52,2664,[],[],["Level 4",0,"bold 16pt Comic Sans MS","rgb(255,255,255)",
0,0,0,0,0]],[[736,28,0,103.6198425292969,32.18495178222656,0,0,1,0.5092592835426331,0.5142857432365417,0,0,[]],70,2665,[],[],[0,"Default",0,1]],[[409,867.5,0,1472,128,0,0,1,0.5,0.5018050670623779,0,0,[]],34,2666,[],[],[0,"Default",0,1]],[[119,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],40,2667,[],[],[0,"Default",0,1]],[[311,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],41,2668,[],[],[0,"Default",0,1]],[[503,864,0,87,83,0,0,1,0.5033556818962097,0.5060975551605225,
0,0,[]],42,2669,[],[],[0,"Default",0,1]],[[695,864,0,89,85,0,0,1,0.5033556818962097,0.5060975551605225,0,0,[]],43,2670,[],[],[0,"Default",0,1]],[[-965,695,0,768,742,0,0,1,0.5,0.5,0,0,[]],20,2671,[],[[60,0],[1,6,0,4,0,0,0,70,0]],[0,"Default",0,1]],[[-572,575,0,625.489013671875,411.7579956054688,0,0,1,0.4993026554584503,0.5190678238868713,0,0,[]],19,2672,[],[],[1,"Default",0,1]],[[437,1359,0,855,250,0,0,1,0.5,0.5,0,0,[]],91,2673,[],[],[0,"Default",0,1]]],[]]],[],[]]],[["AudioEvents",[[1,"Audio",0,1,
!1,!1,0xb38f5df841d1,!1],[0,null,!1,null,9523265378531768,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,933475838151867,!1,[[4,42]]],[51,cr.plugins_.Audio.prototype.cnds.IsSilent,null,0,!1,!0,!1,5576025536053892,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6004218890482577,!1,[[11,"Audio"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9152760494445586,!1,[[11,"Audio"],[7,[0,0]]]]]],[0,null,!1,null,8748251573441521,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0x6787e683b2d2e,!1,[[4,42]]],[51,cr.plugins_.Audio.prototype.cnds.IsSilent,null,0,!1,!1,!1,6242825371348497,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7903584872737041,!1,[[11,"Audio"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9791727014690460,!1,[[11,"Audio"],[7,[0,1]]]]]],[0,null,!1,null,0xde3374c5004f4,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5301213187364979,!1,[[11,"Audio"],[8,0],[7,[0,0]]]]],[[42,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,553021322571314,!1,[[1,[2,"off"]],[3,1]]],[51,cr.plugins_.Audio.prototype.acts.SetSilent,null,7136776290038263,!1,[[3,0]]]]],[0,null,!1,null,439813254746285,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5941323824862011,!1,[[11,"Audio"],[8,0],[7,[0,1]]]]],[[42,cr.plugins_.Sprite.prototype.acts.SetAnim,null,35856013382872,!1,[[1,[2,"on"]],[3,1]]],[51,cr.plugins_.Audio.prototype.acts.SetSilent,null,7272357345352388,!1,[[3,1]]]]]]],["CompanyEvents",[[1,"musica",0,0,!1,!1,8918069676894397,
!1],[0,null,!1,null,9952854453036368,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7129081411772186,!1,[[0,[0,2]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6272848816041785,!1,[[6,"StartScreen"]]]]],[0,null,!1,null,0x8ba18e60c1ea5,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xbc7de863ca395,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xa9fd3ab72594f,!1,[[11,"NewBilly"],[7,[0,1]]]]]]]],["ShoppingEvents",[[0,null,!1,null,5953429104642891,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5571546731864015,!1]],[[8,cr.plugins_.Sprite.prototype.acts.SetSize,null,6517130442510326,!1,[[0,[0,50]],[0,[0,50]]]]]],[0,null,!1,null,5402657364784829,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x5efc2e9b32f21,!1,[[4,38]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xc599d5280062,!1,[[6,"Worlds"]]]]]]],["StartScreenEvents",[[0,null,!1,null,6984909440568644,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0xda63cc127a1d7,!1,[[4,47]]]],[[-1,cr.system_object.prototype.acts.LoadState,null,0xb52f319d759ce,!1,[[1,[2,"mysave"]]]],[51,cr.plugins_.Audio.prototype.acts.Play,null,5942803599328599,!1,[[2,["menu click 3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,8811144984981106,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,296875815365321,!1,[[4,47]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x49a8cba2b8d60,!1,[[6,"Worlds"]]]]],[2,"AudioEvents",!1],
[0,null,!1,null,20604812688061,[[-1,cr.system_object.prototype.cnds.OnLoadFinished,null,1,!1,!1,!1,0x9aa3e6667c270,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xcdf8b171160e3,!1,[[11,"musica"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x6820ba42c0053,!1,[[11,"musica"],[7,[0,1]]]]]],[0,null,!1,null,6311327589704438,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x71e57e91871d,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,
0x948f231410131,!1,[[11,"NewBilly"],[7,[0,1]]]]]]]],["WorldsEvents",[[1,"NewBilly",0,0,!1,!1,0xafa7b23f474a4,!1],[0,null,!1,null,7161477615438537,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,4871192983366238,!1]],[[8,cr.plugins_.Sprite.prototype.acts.SetSize,null,6628878418110834,!1,[[0,[0,50]],[0,[0,50]]]]]],[0,null,!1,null,5699468616796702,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8930972941572128,!1,[[4,31]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,9524994996686952,!1,[[6,"BlueLevelMenu"]]],[51,cr.plugins_.Audio.prototype.acts.Play,null,0x4fa638e3cfd21,!1,[[2,["menu click 3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,0xb166d73eb2da0,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9291532954788356,!1,[[4,33]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6722191054954457,!1,[[6,"Beta Version"]]],[51,cr.plugins_.Audio.prototype.acts.Play,null,7389184558120117,!1,[[2,["menu click 3",!1]],[3,0],[0,[0,0]],
[1,[2,""]]]]]],[0,null,!1,null,957496496281189,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,729002998925387,!1,[[4,32]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8109880719647515,!1,[[6,"Beta Version"]]],[51,cr.plugins_.Audio.prototype.acts.Play,null,8963488738020788,!1,[[2,["menu click 3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,0x933c48293ab21,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5600794012594511,!1]],[[-1,cr.system_object.prototype.acts.SaveState,
null,8616716218811762,!1,[[1,[2,"Save"]]]],[-1,cr.system_object.prototype.acts.SaveState,null,0x9bf1dff3bcfab,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x9ac6e4aba32ef,!1,[[0,[1,1]]]],[53,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xa16e2dd1dea43,!1,[[3,1]]]]],[0,null,!1,null,4956266228149243,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x7ba8b198937ab,!1]],[]],[0,null,!1,null,9645883573262544,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,8029025643611443,!1,[[4,38]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5378823847717474,!1,[[6,"StartScreen"]]]]],[0,null,!1,null,6889074942999172,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xe7cba7b7d3ee4,!1,[[4,45]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9262978408543392,!1,[[6,"Shopping"]]]]]]],["CutsceneEvents",[[0,null,!1,null,0xb0df795509046,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,0xe4683e86fe790,
!1,[[8,0],[0,[0,5]]]]],[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8193152244069802,!1,[[1,[2,"Animation2"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetY,null,0x4b5481fb831fa,!1,[[0,[0,240]]]],[57,cr.behaviors.Fade.prototype.acts.RestartFade,"Fade",7397482500727674,!1]]],[0,null,!1,null,0xec6300a1ae697,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,9922920502273002,!1,[[8,0],[0,[0,9]]]]],[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x5b8f12b48621c,!1,[[1,[2,
"Animation3"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetY,null,0xa9d7b4826a6b3,!1,[[0,[0,240]]]],[57,cr.behaviors.Fade.prototype.acts.RestartFade,"Fade",9516794421687414,!1]]],[0,null,!1,null,7061538895519351,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,8590644203702517,!1,[[8,0],[0,[0,13]]]]],[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7240042747740758,!1,[[1,[2,"Animation4"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetY,null,7388212257311692,!1,[[0,[0,240]]]],
[57,cr.behaviors.Fade.prototype.acts.RestartFade,"Fade",7669610317357448,!1]]],[0,null,!1,null,7778570849675753,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,4692506383530947,!1,[[8,0],[0,[0,17]]]]],[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x4c8fb3959c01c,!1,[[1,[2,"Animation5"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetY,null,592335702018963,!1,[[0,[0,240]]]],[57,cr.behaviors.Fade.prototype.acts.RestartFade,"Fade",0xa637322c29688,!1]]],[0,null,!1,null,0x8f57894f0d153,
[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,9050622439854584,!1,[[8,0],[0,[0,21]]]]],[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x7dfe65a39df6b,!1,[[1,[2,"Animation6"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetY,null,0xf93d26d781987,!1,[[0,[0,240]]]],[57,cr.behaviors.Fade.prototype.acts.RestartFade,"Fade",5510794652467321,!1]]],[0,null,!1,null,0xaad74e6ef45f1,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,4516474699380204,!1,[[8,0],[0,[0,25]]]]],
[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6071260759379591,!1,[[1,[2,"Animation7"]],[3,1]]],[4,cr.plugins_.TiledBg.prototype.acts.SetPos,null,8803559396165876,!1,[[0,[0,-277]],[0,[0,-156]]]],[57,cr.plugins_.Sprite.prototype.acts.SetY,null,6987971241792602,!1,[[0,[0,240]]]],[57,cr.behaviors.Fade.prototype.acts.RestartFade,"Fade",6367179901202162,!1]]],[0,null,!1,null,0x3f24d747b0b06,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,7192377109152003,!1,[[8,0],[0,[0,29]]]]],
[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x51a70af0e1aaa,!1,[[6,"StartScreen"]]]]],[0,null,!1,null,9707815424615580,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7853581700440041,!1,[[4,61]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xf0c0d4848e4aa,!1,[[6,"StartScreen"]]]]]]],["LoadingEvents",[[0,null,!1,null,8839349440758593,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x6208f843f31f3,!1,[[0,[0,3]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,8177488575341035,!1,[[6,"Cutscene"]]]]]]],["GameEvents",[[1,"GameBallX",0,0,!1,!1,7938566919822621,!1],[1,"GameBallY",0,0,!1,!1,8329465399331051,!1],[2,"ShoppingEvents",!1],[1,"StarsCatcheds",0,0,!1,!1,0xc11c6ddaf7c9d,!1],[0,null,!1,null,9993588921162826,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x562e9deeed225,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8773588117285371,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[16,cr.plugins_.Sprite.prototype.acts.MoveToTop,
null,8983450727472023,!1],[21,cr.behaviors.solid.prototype.acts.SetEnabled,"Solid",4549138453613797,!1,[[3,1]]]]],[0,null,!1,null,9623870571360704,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5399372407293014,!1]],[[8,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0xcf8bf75164af,!1],[21,cr.behaviors.solid.prototype.acts.SetEnabled,"Solid",9309958801531358,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x3bc1f5d2d9ae1,!1,[[11,"GameBallX"],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,
!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8150690345882102,!1,[[11,"GameBallY"],[7,[20,8,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0x8253f86761fc7,[[8,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,987416890668764,!1,[[4,22]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa934ce6e3f24c,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[19,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6859009871391385,!1,[[3,1]]],[19,cr.plugins_.Sprite.prototype.acts.SetPos,
null,4971622271393155,!1,[[0,[0,400]],[0,[0,240]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPos,null,520992425746633,!1,[[0,[0,400]],[0,[0,240]]]],[114,cr.plugins_.Sprite.prototype.acts.SetPos,null,9531147711656532,!1,[[0,[0,400]],[0,[0,420]]]],[8,cr.behaviors.Platform.prototype.acts.SetIgnoreInput,"Platform",0x89f86eaca0625,!1,[[3,1]]]]],[0,null,!1,null,0xde55a50c81aeb,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,4541001191303331,!1]],[[-1,cr.system_object.prototype.acts.SetVar,
null,0x8d6fe4891984e,!1,[[11,"StarsCatcheds"],[7,[0,0]]]],[9,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x397d3022bccc6,!1,[[3,0]]]]],[0,null,!1,null,7002366383487574,[[8,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7811672094458846,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,6857663813802162,!1]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,7080034070195723,!1,[[2,["ok - 1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,0xeab5e542074fb,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,5894493446935739,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,7195910062223301,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x90cc6be14c7f5,!1]],[[17,cr.plugins_.Text.prototype.acts.SetText,null,0x9f295b40c513f,!1,[[7,[23,"StarsCatcheds"]]]]]],[0,null,!1,null,4857522417061866,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5ff501b2faba6,!1,[[4,9]]]],[[8,cr.plugins_.Sprite.prototype.acts.SetPos,
null,5052800875536155,!1,[[0,[23,"GameBallX"]],[0,[23,"GameBallY"]]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7194736314590668,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,6996819916900549,!1,[[11,"StarsCatcheds"],[7,[0,0]]]]]],[0,null,!1,null,0x51c8c78652f5c,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5918781896250378,!1,[[4,7]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetY,null,0xf2eb23bd298cf,!1,[[0,[0,240]]]],[41,cr.plugins_.Sprite.prototype.acts.SetY,
null,0x61d8e47664a99,!1,[[0,[0,240]]]],[42,cr.plugins_.Sprite.prototype.acts.SetY,null,0x8cd63de1f032c,!1,[[0,[0,240]]]],[43,cr.plugins_.Sprite.prototype.acts.SetY,null,9289290463000004,!1,[[0,[0,240]]]],[34,cr.plugins_.Sprite.prototype.acts.SetY,null,6309126535619586,!1,[[0,[0,240]]]]]],[0,null,!1,null,9938389761814102,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6886615476079616,!1,[[4,43]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetY,null,4546007556308049,!1,[[0,[0,2E3]]]],
[41,cr.plugins_.Sprite.prototype.acts.SetY,null,0xc13465fa40af1,!1,[[0,[0,2E3]]]],[42,cr.plugins_.Sprite.prototype.acts.SetY,null,6403812434816754,!1,[[0,[0,2E3]]]],[43,cr.plugins_.Sprite.prototype.acts.SetY,null,662701378873934,!1,[[0,[0,2E3]]]],[34,cr.plugins_.Sprite.prototype.acts.SetY,null,0xdb3ed807d05,!1,[[0,[0,2E3]]]]]],[0,null,!1,null,5352176931673001,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4578373421178271,!1,[[4,40]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,
null,0xe60d738f60f5d,!1]]],[0,null,!1,null,0xbe8e6f55d8961,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7054693194892346,!1,[[4,41]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,918671280333404,!1,[[6,"Worlds"]]]]],[0,null,!1,null,0x58d3f737ec308,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7050681894267318,!1,[[4,12]]]],[[8,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",9090624489613644,!1,[[3,0]]]]],[0,null,!1,null,742972733779188,
[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xb7287731cd2fa,!1,[[4,13]]]],[[8,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",7390988849387924,!1,[[3,1]]]]],[1,"WorldBlocks",0,0,!1,!1,7821056121351293,!1],[0,null,!1,null,0x575662741c06c,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,45864081667562,!1]],[[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4879321321700471,!1,[[3,0]]],[21,cr.plugins_.Sprite.prototype.acts.SetVisible,null,
4957284345487133,!1,[[3,0]]]]],[0,null,!1,null,0xd733ec5610834,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7340417406976311,!1]],[]],[2,"AudioEvents",!1],[0,null,!1,null,0x55e19e538f935,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x6497f66580a88,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5962981666304295,!1,[[11,"StarsCatcheds"],[8,1],[7,[0,3]]]]],[[21,cr.behaviors.solid.prototype.acts.SetEnabled,"Solid",5580062562665524,!1,[[3,0]]],[8,
cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0xc928082ae117b,!1]]],[0,null,!1,null,7136027228850211,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7278406914242391,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,1]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4572116665400331,!1,[[1,[2,"um"]],[3,1]]]]],[0,null,!1,null,0x562df46b1fc92,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd0e33d244382c,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,0]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0x52cd8d13a3040,!1,[[1,[2,"zero"]],[3,1]]]]],[0,null,!1,null,0x967e91e436e4c,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6160044665755042,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,2]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xd6fba0782717c,!1,[[1,[2,"dois"]],[3,1]]]]],[0,null,!1,null,6308884310897925,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xc5e448a5677aa,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6697379783971643,!1,[[1,[2,"tres"]],[3,1]]]]],[0,null,!1,null,5993902879655289,[[-1,cr.system_object.prototype.cnds.OnLayoutEnd,null,1,!1,!1,!1,590673815914062,!1]],[[53,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,8879687442185621,!1,[[3,1]]]]],[0,null,!1,null,0x6736d97724098,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xbf789aedd25d3,!1]],[[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xcdec9d0043a49,!1],[-1,cr.system_object.prototype.acts.SaveState,null,
5584184156462818,!1,[[1,[2,"mysave"]]]]]],[0,null,!1,null,6718057494735677,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xd0616604ebc29,!1],[8,cr.behaviors.Platform.prototype.cnds.IsOnFloor,"Platform",0,!1,!1,!1,0xfdf4bae14042f,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x63170059a12ed,!1]],[[8,cr.behaviors.Platform.prototype.acts.SetJumpStrength,"Platform",0x8d8461c633c64,!1,[[0,[0,450]]]],[8,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",
0xce15720160369,!1,[[3,2]]],[51,cr.plugins_.Audio.prototype.acts.Play,null,6859966604270907,!1,[[2,["comedia efeito mola",!1]],[3,0],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,0xa61979b664b83,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf5d0cf7ace5fe,!1,[[4,7]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,4624511273814307,!1,[[0,[0,0]]]]]],[0,null,!1,null,0xb21770c9d6ca8,[[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9963468649587362,!1]],[[-1,
cr.system_object.prototype.acts.SetTimescale,null,6229710931255716,!1,[[0,[0,1]]]]]],[0,null,!1,null,0xf01858a468751,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4806857493385296,!1,[[0,[0,5]]]]],[[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,4752315293251929,!1]]],[0,null,!1,null,5056674639919209,[[8,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!0,!1,5930681267736653,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x64ccb087a5b2e,!1,[[0,[0,3]]]],
[8,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,466483601148328,!1]],[[8,cr.plugins_.Sprite.prototype.acts.SetPos,null,7262529826108629,!1,[[0,[23,"GameBallX"]],[0,[23,"GameBallY"]]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6082973394022513,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,8196415771126791,!1,[[11,"StarsCatcheds"],[7,[0,0]]]]]],[0,null,!1,null,8629061439068295,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x77e9d9219fe88,
!1,[[4,11]]]],[[8,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x86b8ba59c1c03,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xe851cbd00290f,!1,[[0,[1,0.1]]]],[8,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x759e4e0f648da,!1,[[0,[0,0]]]]]],[0,null,!1,null,4976065953648665,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5970434959020759,!1],[11,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,0,!1,!1,!1,6589307377497807,!1,[[8,5],[0,[1,100.9]]]],[-1,
cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,6573567972634029,!1,[[4,11]]],[11,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xd8428cf90bf92,!1,[[0,[20,11,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[[11,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5535683467686567,!1,[[1,[2,"Grande"]],[3,1]]]]],[0,null,!1,null,6712111060725973,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x647f445b0bf3e,!1],[11,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,
0,!1,!1,!1,0xad22e5686c2ec,!1,[[8,3],[0,[1,100.8]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,6738563688805154,!1,[[4,11]]],[11,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8618313398018484,!1,[[0,[20,11,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[[11,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5716062530442343,!1,[[1,[2,"Media"]],[3,1]]]]],[0,null,!1,null,9947781070850278,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xd03c935aaefa3,!1],
[11,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,0,!1,!1,!1,9907912941748286,!1,[[8,2],[0,[0,93]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,0x76a44b63736f1,!1,[[4,11]]],[11,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5628404296985811,!1,[[0,[20,11,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[[11,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7671254360595886,!1,[[1,[2,"Menor"]],[3,1]]]]],[0,null,!1,null,0x466b8c57e3c7d,[[55,cr.plugins_.Sprite.prototype.cnds.CompareWidth,
null,0,!1,!1,!1,9780916387210628,!1,[[8,4],[0,[0,150]]]],[55,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8672741859459539,!1,[[0,[20,55,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[55,cr.behaviors.Sin.prototype.cnds.CompareMovement,"Sine",0,!1,!0,!1,0x73e91efe9c61d,!1,[[3,2]]]],[[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9285046784097052,!1,[[1,[2,"Maior"]],[3,1]]]]],[0,null,!1,null,9622810374572544,[[55,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,0,!1,!1,!1,
0xbb7b0b39d9a36,!1,[[8,3],[0,[0,150]]]],[55,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9255664556911218,!1,[[0,[20,55,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[55,cr.behaviors.Sin.prototype.cnds.CompareMovement,"Sine",0,!1,!0,!1,0xee56b296101d0,!1,[[3,2]]]],[[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xb3ba09a6cb469,!1,[[1,[2,"Media"]],[3,1]]]]],[0,null,!1,null,0xdf74f55fc83c4,[[55,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,0,!1,!1,!1,4710894989002989,!1,
[[8,3],[0,[0,88]]]],[55,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9474961062198202,!1,[[0,[20,55,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[55,cr.behaviors.Sin.prototype.cnds.CompareMovement,"Sine",0,!1,!0,!1,4879040028715509,!1,[[3,2]]]],[[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5117412038832623,!1,[[1,[2,"Menor"]],[3,1]]]]],[0,null,!1,null,0x4a823d764f2be,[[55,cr.behaviors.Sin.prototype.cnds.CompareMovement,"Sine",0,!1,!1,!1,673026010242927,!1,[[3,2]]],[55,cr.behaviors.Sin.prototype.cnds.IsActive,
"Sine",0,!1,!1,!1,9060430616101892,!1],[55,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6207169816064927,!1,[[0,[20,55,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[-1,cr.system_object.prototype.cnds.For,null,0,!0,!1,!1,0xb5bfe3f7d5727,!1,[[1,[2,"teste"]],[0,[0,1]],[0,[0,10]]]]],[[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6767767506322942,!1,[[1,[2,"Sine"]],[3,1]]],[55,cr.behaviors.Sin.prototype.acts.SetActive,"Sine",0xdf008627dbcc4,!1,[[3,0]]]]],[0,null,!1,null,5030912076220298,
[[24,cr.plugins_.Touch.prototype.cnds.CompareAcceleration,null,0,!1,!1,!1,0x4e1781ca73c0b,!1,[[3,0],[8,4],[0,[0,10]]]],[24,cr.plugins_.Touch.prototype.cnds.CompareOrientation,null,0,!1,!1,!1,7585633278260697,!1,[[3,2],[8,4],[0,[0,0]]]]],[[8,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",5652804396231402,!1,[[3,0]]]]],[0,null,!1,null,7302720891769429,[[24,cr.plugins_.Touch.prototype.cnds.CompareAcceleration,null,0,!1,!1,!1,4706164934074826,!1,[[3,0],[8,2],[0,[0,-10]]]],[24,cr.plugins_.Touch.prototype.cnds.CompareOrientation,
null,0,!1,!1,!1,0x57c04478e43a7,!1,[[3,2],[8,2],[0,[0,0]]]]],[[8,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",7830249499482176,!1,[[3,1]]]]],[0,null,!1,null,8290037275771042,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9089184225735422,!1,[[4,114]]]],[[114,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xcb7ec769f5411,!1,[[1,[2,"ok"]],[3,1]]]]]]],["GameEventsBlue",[[0,null,!1,null,7119011879444339,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,
0,!1,!1,!1,0xe5c3358abf687,!1,[[4,38]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6182518071893826,!1,[[6,"Worlds"]]]]],[0,null,!1,null,0x578626ddc961b,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8013550545021321,!1,[[4,26]]]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,0xd81986640f750,!1,[[2,["menu click 3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,885867444296383,!1]]],[0,[!0,"NewBlueLevels"],!1,null,5866300639955517,
[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5866300639955517,!1,[[1,[2,"NewBlueLevels"]]]]],[],[[0,[!0,"BrownLevelBlocks"],!1,null,0x8f292d511413f,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x8f292d511413f,!1,[[1,[2,"BrownLevelBlocks"]]]]],[],[[0,[!0,"GoLevel1"],!1,null,8200073778385829,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8200073778385829,!1,[[1,[2,"GoLevel1"]]]]],[],[[0,null,!1,null,5050976788760783,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6469311748165441,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5005492473494139,!1,[[0,[0,15]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xb149ec88170a7,!1,[[6,"BlueLevel1"]]]]]]],[0,[!0,"Level2"],!1,null,322886050372952,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,322886050372952,!1,[[1,[2,"Level2"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,41]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5275507047527403,!1,[[6,"BlueLevel1"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,0]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,41]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,1]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,41]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level3"],!1,null,4705517487480514,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4705517487480514,!1,[[1,[2,"Level3"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,46]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,0x5cda799674d44,!1,[[6,"BlueLevel3"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,1]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,46]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,2]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,46]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level4"],!1,null,728474106764618,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,728474106764618,!1,[[1,[2,"Level4"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,82]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9979611345447228,!1,[[6,"BlueLevel4"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,2]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,82]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,3]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,82]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level5"],!1,null,9811534539982184,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9811534539982184,!1,[[1,[2,"Level5"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,99]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,0xa6880c7fe9bd6,!1,[[6,"BlueLevel5"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,3]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,99]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,4]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,99]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level6"],!1,null,0xce8202365c961,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xce8202365c961,!1,[[1,[2,"Level6"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,84]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6548286093860132,!1,[[6,"BlueLevel6"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,4]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0x7aa5060c91598,!1,[[0,[0,84]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,5]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x6b46c636d6e9b,!1,[[0,[0,84]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level7"],!1,null,0x8e12132394759,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x8e12132394759,!1,[[1,[2,"Level7"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,85]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,5964799193273365,!1,[[6,"BlueLevel7"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,5]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5265892744601245,!1,[[0,[0,85]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,6]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,970369892706942,!1,[[0,[0,85]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level8"],!1,null,5634016429661979,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5634016429661979,!1,[[1,[2,"Level8"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,86]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8325046412603094,!1,[[6,"BlueLevel8"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,6]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,86]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,7]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,86]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level9"],!1,null,6959076644802657,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6959076644802657,!1,[[1,[2,"Level9"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,87]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,5925580838943829,!1,[[6,"BlueLevel9"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,7]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,87]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,8]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,87]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level10"],!1,null,9316762890094656,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9316762890094656,!1,[[1,[2,"Level10"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,88]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8055547582662817,!1,[[6,"BlueLevel10"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,8]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,88]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,9]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,88]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level11"],!1,null,8408433145514378,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8408433145514378,!1,[[1,[2,"Level11"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,89]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,0xe869b011cdbd8,!1,[[6,"BlueLevel11"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,9]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,89]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,10]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,89]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level12"],!1,null,7990557851979101,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7990557851979101,!1,[[1,[2,"Level12"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,90]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7363688704456212,!1,[[6,"BlueLevel12"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,10]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,90]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,11]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,90]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level13"],!1,null,8990178776007642,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8990178776007642,!1,[[1,[2,"Level13"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,91]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,9155461841713224,!1,[[6,"BlueLevel13"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,11]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,91]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,12]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,91]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level14"],!1,null,429295256983896,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,429295256983896,!1,[[1,[2,"Level14"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,92]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8857613171482711,!1,[[6,"BlueLevel14"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,12]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,92]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,13]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,92]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level15"],!1,null,0xf1cabd9b535ae,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xf1cabd9b535ae,!1,[[1,[2,"Level15"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,93]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,6738186397836121,!1,[[6,"BlueLevel15"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,13]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,93]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,14]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,93]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level16"],!1,null,9102301238495132,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9102301238495132,!1,[[1,[2,"Level16"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,94]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x7fd64293d3ead,!1,[[6,"BlueLevel16"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,14]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,94]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,15]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,94]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],
[0,[!0,"Level17"],!1,null,6710580687895728,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6710580687895728,!1,[[1,[2,"Level17"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,95]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,5086029809708076,!1,[[6,"BlueLevel17"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,15]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,95]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,16]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,95]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"Level18"],!1,null,5211464021307655,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5211464021307655,!1,[[1,[2,"Level18"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,
!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,96]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6767458366386054,!1,[[6,"BlueLevel18"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,16]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,96]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,17]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,96]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]]]]]],
[0,[!0,"BlueLevels"],!1,null,0x55d57a1b8a0bd,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x55d57a1b8a0bd,!1,[[1,[2,"BlueLevels"]]]]],[],[[0,[!0,"BlueLevelsBlocks"],!1,null,9613690645923724,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9613690645923724,!1,[[1,[2,"BlueLevelsBlocks"]]]]],[],[[0,[!0,"BlueLevel1"],!1,null,322886050372952,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,322886050372952,!1,[[1,[2,"BlueLevel1"]]]]],[],[[0,null,
!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,138]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xfa94fff6c6db1,!1,[[6,"RedLevel1"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,17]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,138]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,18]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,
!1,[[0,[0,138]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel2"],!1,null,0x877e1af4addf3,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x877e1af4addf3,!1,[[1,[2,"BlueLevel2"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,
139]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7663081032148473,!1,[[6,"RedLevel2"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,18]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,139]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,19]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,139]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel3"],!1,null,8717018224326057,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,8717018224326057,!1,[[1,[2,"BlueLevel3"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,140]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,663051934737858,!1,[[6,"RedLevel3"]]]]],[0,null,
!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,19]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,140]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,20]]]],
[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,140]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel4"],!1,null,8939285103837612,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8939285103837612,!1,[[1,[2,"BlueLevel4"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,141]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5758003506123344,!1,[[6,"RedLevel4"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,20]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,141]]]]],
[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,21]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,141]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel5"],!1,null,0x464694bc09565,
[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x464694bc09565,!1,[[1,[2,"BlueLevel5"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,142]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,5618982642675866,!1,[[6,"RedLevel5"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,21]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x46e31e4cba020,!1,[[0,[0,142]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,22]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6721177658629923,!1,[[0,[0,142]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel6"],!1,null,5856189500980372,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5856189500980372,!1,[[1,[2,"BlueLevel6"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,
!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,143]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xd83affb0cb00,!1,[[6,"RedLevel6"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,22]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,7679261163778752,!1,[[0,[0,143]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,23]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x8093026c55d0e,!1,[[0,[0,143]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,
1]]]]]]],[0,[!0,"BlueLevel7"],!1,null,0xc762d9eb6e3d,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc762d9eb6e3d,!1,[[1,[2,"BlueLevel7"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,144]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],
[[-1,cr.system_object.prototype.acts.GoToLayout,null,9965592336861154,!1,[[6,"RedLevel7"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,23]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,7437147318000831,!1,[[0,[0,144]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,24]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6673436216559315,!1,[[0,[0,144]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel8"],!1,null,0xebb0fd2410fe9,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xebb0fd2410fe9,!1,[[1,[2,"BlueLevel8"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,145]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x491d16b28113b,!1,[[6,"RedLevel8"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,24]]]],
[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x9dd8e4cbfc017,!1,[[0,[0,145]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,25]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5564314371715084,!1,[[0,[0,145]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel9"],!1,null,0xfea098535aa8,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xfea098535aa8,!1,[[1,[2,"BlueLevel9"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,146]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,
!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9309420810954768,!1,[[6,"RedLevel9"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,25]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,146]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,
null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,26]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,146]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel10"],!1,null,0x4b9918350f27d,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x4b9918350f27d,!1,[[1,[2,"BlueLevel10"]]]]],
[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,147]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xad7aea6476906,!1,[[6,"RedLevel10"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,26]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,147]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,27]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,
!1,[[0,[0,147]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel11"],!1,null,7231124378551554,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7231124378551554,!1,[[1,[2,"BlueLevel11"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,
[0,148]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6599802960773176,!1,[[6,"RedLevel11"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,27]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,148]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,28]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,148]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel12"],!1,null,5938801043766178,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,5938801043766178,!1,[[1,[2,"BlueLevel12"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,82]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,4955331823431394,!1,[[6,"RedLevel12"]]]]],[0,
null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,28]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,149]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,29]]]],
[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,149]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel13"],!1,null,0x3d597a967ffb7,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x3d597a967ffb7,!1,[[1,[2,"BlueLevel13"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,150]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5518674501210326,!1,[[6,"RedLevel13"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,29]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,150]]]]],
[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,30]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,150]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel14"],!1,null,0x5125c5ff18a55,
[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x5125c5ff18a55,!1,[[1,[2,"BlueLevel14"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,151]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,5140222191046228,!1,[[6,"RedLevel14"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,30]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,151]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,
!1,[[11,"WorldBlocks"],[8,5],[7,[0,31]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,151]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel15"],!1,null,0xdff032e58c76f,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xdff032e58c76f,!1,[[1,[2,"BlueLevel15"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,
!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,152]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9398035773787328,!1,[[6,"RedLevel15"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,31]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,152]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,32]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,152]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,
1]]]]]]],[0,[!0,"BlueLevel16"],!1,null,7499088361512804,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7499088361512804,!1,[[1,[2,"BlueLevel16"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,153]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],
[[-1,cr.system_object.prototype.acts.GoToLayout,null,5815329882553682,!1,[[6,"RedLevel16"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,32]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,153]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,33]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,153]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel17"],!1,null,6013290078837488,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6013290078837488,!1,[[1,[2,"BlueLevel17"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,154]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8526916560611528,!1,[[6,"RedLevel17"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,33]]]],
[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,154]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,34]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,154]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"BlueLevel18"],!1,null,5102025279509988,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5102025279509988,!1,[[1,[2,"BlueLevel18"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,155]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,
0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x4377a22a5ef96,!1,[[6,"RedLevel18"]]]]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,34]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,155]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],
[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,35]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,155]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]]]],[0,[!0,"GoingToLevels2"],!1,null,9433706240146204,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9433706240146204,!1,[[1,
[2,"GoingToLevels2"]]]]],[],[[0,[!0,"GoLevel19"],!1,null,8200073778385829,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8200073778385829,!1,[[1,[2,"GoLevel19"]]]]],[],[[0,null,!1,null,5050976788760783,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6469311748165441,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5005492473494139,!1,[[0,[0,41]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x49b6b5d76635d,!1,[[6,"BlueLevel1"]]]]]]]]]]],
[0,[!0,"PurpleLevels"],!1,null,0x584b2128863ab,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x584b2128863ab,!1,[[1,[2,"PurpleLevels"]]]]],[],[[0,[!0,"PurpleLevelBlocks"],!1,null,9613690645923724,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9613690645923724,!1,[[1,[2,"PurpleLevelBlocks"]]]]],[],[[0,[!0,"PurpleLevel1"],!1,null,322886050372952,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,322886050372952,!1,[[1,[2,"PurpleLevel1"]]]]],[],
[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,164]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,35]]]],[26,
cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,164]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,36]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,164]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,
0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel2"],!1,null,6241808989265675,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6241808989265675,!1,[[1,[2,"PurpleLevel2"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,165]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,
0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,36]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,165]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,37]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,165]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel3"],!1,null,6092439289082847,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6092439289082847,!1,[[1,[2,"PurpleLevel3"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,166]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,37]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,
166]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,38]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,166]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel4"],!1,null,7059275826041033,
[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7059275826041033,!1,[[1,[2,"PurpleLevel4"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,167]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,38]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,167]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,39]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,
!1,[[0,[0,167]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel5"],!1,null,5535694413124204,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5535694413124204,!1,[[1,[2,"PurpleLevel5"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,
[[0,[0,168]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,39]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,168]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,40]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,168]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel6"],!1,null,6056778886874041,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6056778886874041,!1,[[1,[2,"PurpleLevel6"]]]]],[],[[0,null,!1,
null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,169]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,40]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,169]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,41]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,169]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,
1]]]]]]],[0,[!0,"PurpleLevel7"],!1,null,6786267367429244,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6786267367429244,!1,[[1,[2,"PurpleLevel7"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,170]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],
[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,41]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,170]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],
[7,[0,42]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,170]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel8"],!1,null,769285379876869,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,769285379876869,!1,[[1,[2,"PurpleLevel8"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,
26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,171]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,42]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,171]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,43]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,171]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel9"],!1,null,9794977767896500,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,9794977767896500,!1,[[1,[2,"PurpleLevel9"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,172]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,43]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,172]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,44]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,
[[0,[0,172]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel10"],!1,null,5450943492018362,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5450943492018362,!1,[[1,[2,"PurpleLevel10"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,
[0,173]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,44]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,173]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,45]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,173]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel11"],!1,null,4940197416186412,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4940197416186412,!1,[[1,[2,"PurpleLevel11"]]]]],[],[[0,null,
!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,174]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,45]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,174]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,46]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,174]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,
1]]]]]]],[0,[!0,"PurpleLevel12"],!1,null,0xa6b980268af77,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xa6b980268af77,!1,[[1,[2,"PurpleLevel12"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,175]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],
[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,46]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,175]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],
[7,[0,47]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,175]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel13"],!1,null,0xdf7025da02c65,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xdf7025da02c65,!1,[[1,[2,"PurpleLevel13"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,
[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,176]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,47]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,176]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,48]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,176]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel14"],!1,null,6313015585991954,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,6313015585991954,!1,[[1,[2,"PurpleLevel14"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,177]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,48]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,177]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,49]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,
!1,[[0,[0,177]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel15"],!1,null,8597827313847623,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8597827313847623,!1,[[1,[2,"PurpleLevel15"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,
[[0,[0,178]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,49]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,178]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,50]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,178]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel16"],!1,null,0xf8b81b9cc271f,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xf8b81b9cc271f,!1,[[1,[2,"PurpleLevel16"]]]]],[],[[0,null,!1,
null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,179]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,50]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,179]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,51]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,179]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,
1]]]]]]],[0,[!0,"PurpleLevel17"],!1,null,0xaf6bd8acb5b3b,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xaf6bd8acb5b3b,!1,[[1,[2,"PurpleLevel17"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,180]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],
[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,51]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,180]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],
[7,[0,52]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,180]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]],[0,[!0,"PurpleLevel18"],!1,null,7115091041047961,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7115091041047961,!1,[[1,[2,"PurpleLevel18"]]]]],[],[[0,null,!1,null,0xe39ed99d70a7f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6735403612285038,!1,
[[4,26]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9556679255098972,!1,[[0,[0,181]]]],[26,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,8471717238010694,!1,[[1,[2,"Default"]]]]],[]],[0,null,!1,null,0xdec27420b3b76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x92190de5f5376,!1,[[11,"WorldBlocks"],[8,3],[7,[0,52]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xf0239f9b6649a,!1,[[0,[0,181]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6578848375677236,!1,[[1,[2,"Blocked"]],[3,1]]]]],[0,null,!1,null,9469263093966392,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9169888014878952,!1,[[11,"WorldBlocks"],[8,5],[7,[0,53]]]],[26,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5672627303695019,!1,[[0,[0,181]]]]],[[26,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe67322965a062,!1,[[1,[2,"Default"]],[3,1]]]]]]]]]]],[0,null,!1,null,5225910980718419,[],[]]]],["BlueLevel1Events",[[2,"GameEvents",!1],[0,
null,!1,null,6364971280096536,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x767bd5e40650f,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8769857808581337,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8242862889068802,!1,[[6,"BlueLevel2"]]]]],[0,null,!1,null,576904306332475,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x46e78d75b8ca9,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,
0x3f51121b8d6d1,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,311193587379864,!1,[[11,"WorldBlocks"],[8,0],[7,[0,18]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x6e1077543967f,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,6352548010935841,[[23,cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,null,1,!1,!1,!1,0xbae03ec764249,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x4325f76ac53e0,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,
5647372709114516,!1,[[6,"BlueLevel2"]]]]],[0,null,!1,null,7595055266218424,[[23,cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,null,1,!1,!1,!1,7727849746005544,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5520606762240558,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x8753c48045edb,!1,[[11,"WorldBlocks"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x8f85e25c0e089,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,4820097170786279,
[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5232911308359757,!1]],[]],[0,null,!1,null,0x5b32615c71019,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x9bd7c50d83eb,!1,[[4,12]]]],[[66,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x664bd29ef4de2,!1,[[3,1]]],[67,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7974249020310946,!1,[[3,0]]]]],[0,null,!1,null,0x8dbf1ab7eeada,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,9495782399851988,
!1,[[4,12]]]],[[66,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x608997b1df6c6,!1,[[3,0]]]]],[0,null,!1,null,4829881956229209,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xbedb24f5c7a59,!1,[[4,13]]]],[[66,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9914180546484780,!1,[[3,0]]],[67,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7774023832151846,!1,[[3,1]]]]],[0,null,!1,null,0x3e7788329a527,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,
!1,4759033957228526,!1,[[4,13]]]],[[67,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4770920441651888,!1,[[3,0]]]]],[0,null,!1,null,8293164706159299,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9575902646938748,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,6856198990785395,!1,[[1,[2,"I've reached Level 1 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],
[3,0]]]]]]],["BlueLevel2Events",[[2,"GameEvents",!1],[0,null,!1,null,8468579076880144,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9563402901675892,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xf6deae6fa8d44,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8446952794115746,!1,[[6,"BlueLevel3"]]]]],[0,null,!1,null,5909160772621044,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,771138259414859,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,0xcaaab08f27877,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe055c2747d1e2,!1,[[11,"WorldBlocks"],[8,3],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,737726699283671,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,5736463500633475,[[23,cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,null,1,!1,!1,!1,0xe3ff332cfc0ed,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5973948964223183,!1],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xfd5e549998dc9,!1,[[11,"WorldBlocks"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x4b51a81e2b541,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,5202274588287329,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6722433881546435,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,0x8a09f0d132cd5,!1,[[1,[2,"I've reached Level 2 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],
[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel3Events",[[2,"GameEvents",!1],[0,null,!1,null,8894302848496645,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7680073015865341,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8293836113160418,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xa8aafa6804fab,!1,[[6,"BlueLevel4"]]]]],[0,null,!1,null,8353097332435914,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,9511715782756580,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xa515b371b3d03,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,763596181526785,!1,[[11,"WorldBlocks"],[8,3],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9374349108747032,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xb6261612e16a6,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7828835632200239,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,
null,8460979376522056,!1,[[1,[2,"I've reached Level 3 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel4Events",[[2,"GameEvents",!1],[0,null,!1,null,0xc3d6c0a9eb87c,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3e855d7f5f098,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x536fddc66e8e4,
!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7429255029428678,!1,[[6,"BlueLevel5"]]]]],[0,null,!1,null,5498586535501149,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x504d06a607760,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x814dc0f562ad0,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5322825423337786,!1,[[11,"WorldBlocks"],[8,3],[7,[0,3]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9737215085558056,
!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,5211432238067119,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xe0bf7c9311af0,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,5898257482895968,!1,[[1,[2,"I've reached Level 4 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel5Events",[[2,
"GameEvents",!1],[0,null,!1,null,0x512f38766bf25,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8914718488197308,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,7126663802636763,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xc1dd95cf4abb9,!1,[[6,"BlueLevel6"]]]]],[0,null,!1,null,6746566698753043,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,517505813762488,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,983636443319868,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9664346625398380,!1,[[11,"WorldBlocks"],[8,3],[7,[0,4]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6563400658369989,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,8213732596126044,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4802762882442277,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,9983692646534176,!1,[[1,[2,"I've reached Level 5 on the Blue Pack at Billy the Ball"]],
[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel6Events",[[2,"GameEvents",!1],[0,null,!1,null,7438313491045135,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9721546898506320,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6184165930053991,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5493857838729667,!1,[[6,"BlueLevel7"]]]]],
[0,null,!1,null,8786266121311298,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7782192039231452,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5072619297018889,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3c5b16bddb56a,!1,[[11,"WorldBlocks"],[8,3],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,8433474078906276,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xf1602c3a25759,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0x54bcae1f3dc5f,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,9007687251613164,!1,[[1,[2,"I've reached Level 6 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel7Events",[[2,"GameEvents",!1],[0,null,!1,null,0x71eba0ecf6146,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xef3c5b93a8e8a,
!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6577177535032243,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6876520881001381,!1,[[6,"BlueLevel8"]]]]],[0,null,!1,null,0x66cc06a4e523d,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,897304934897868,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xae66e399f6e6d,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x613570daafeb9,!1,[[11,"WorldBlocks"],
[8,3],[7,[0,6]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7827429415261455,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xa5ca400d8e46d,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x7489ebadcaff9,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,0xdc34adf3f2499,!1,[[1,[2,"I've reached Level 7 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],
[3,0]]]]]]],["BlueLevel8Events",[[2,"GameEvents",!1],[0,null,!1,null,0xe4cb9fb7a991e,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x426592c4e1b16,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6588893382998339,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7219404458931671,!1,[[6,"BlueLevel9"]]]]],[0,null,!1,null,0xdd3d2b862cab1,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf8c796f2750a8,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,961692704267592,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd95b3a5e10bb7,!1,[[11,"WorldBlocks"],[8,3],[7,[0,7]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xabeff2ed4f3e8,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xf0640f4b8b886,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf8292f7b3ec45,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,9117237681485148,!1,[[1,[2,"I've reached Level 8 on the Blue Pack at Billy the Ball"]],
[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel9Events",[[1,"Camera",0,0,!1,!1,300511925265841,!1],[1,"Camerax",0,0,!1,!1,0x54748057bbb56,!1],[1,"Cameray",0,0,!1,!1,0x734f684bbd83a,!1],[2,"GameEvents",!1],[0,null,!1,null,7159341917140531,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x63feccc118348,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,8295945792706577,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,286353962402229,!1,[[6,"BlueLevel10"]]]]],[0,null,!1,null,5224127293538328,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9029351005257728,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5894011264124944,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xf629fc4281756,!1,[[11,"WorldBlocks"],[8,3],[7,[0,8]]]]],[[-1,cr.system_object.prototype.acts.AddVar,
null,6700747054745456,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,8335135424219668,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,300430903944932,!1,[[4,11]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8731013139152228,!1,[[11,"Camerax"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,627000650322614,!1,[[11,"Cameray"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0xae846ce6c1356,
[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xda5942edc1d96,!1]],[[-1,cr.system_object.prototype.acts.SetLayerParallax,null,7784083229519357,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0x7a6add8de4702,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,8151891167924062,!1,[[0,[23,"Camera"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc0d49dcdbefcd,!1,[[11,"Camera"],[7,
[20,54,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5890217519257913,!1,[[11,"Camerax"],[7,[0,0]]]]]],[0,null,!1,null,0xc0e62ce568715,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,0xe3422b20a79c8,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8232483035199181,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xef1c63848d6e7,!1,[[11,"Camera"],[8,5],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,
!1,null]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0x9e543d3c44b6,!1,[[11,"Camera"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,9131793163615018,!1,[[0,[23,"Camera"]]]]]],[0,null,!1,null,8497004326126555,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7294516637902195,!1,[[11,"Camera"],[8,3],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8125777305385225,!1,[[11,"Camerax"],[7,[0,1]]]]]],[0,null,
!1,null,0xef24a62e24000,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xcc2de8796b24f,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7b6f0170553c2,!1,[[11,"Camerax"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.ScrollX,null,8976026188196187,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,5345005334330274,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x863f5e70b428b,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,
null,9860829970420300,!1,[[1,[2,"I've reached Level 9 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel10Events",[[2,"GameEvents",!1],[0,null,!1,null,4586145189204732,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xd7fb24eddd939,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,4944211668073511,
!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8502425378447876,!1,[[6,"BlueLevel11"]]]]],[0,null,!1,null,5058973403535438,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9184700795854784,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x8a4cba01a043,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,773033887467118,!1,[[11,"WorldBlocks"],[8,3],[7,[0,9]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7370467088508284,
!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,8157564512417436,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd405a68fb8c46,!1,[[4,11]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,537414426920446,!1,[[11,"Camerax"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x5ce01a4cba652,!1,[[11,"Cameray"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,7690186550938646,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0x68ad38f77fe31,!1]],[[-1,cr.system_object.prototype.acts.SetLayerParallax,null,9867202900306972,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,827486929130473,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,0x7fb714ae2966f,!1,[[0,[23,"Camera"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x6986fa2e35363,!1,[[11,"Camera"],[7,[20,54,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,0xba69ed5bd2700,!1,[[11,"Camerax"],[7,[0,0]]]]]],[0,null,!1,null,421727222520258,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,5657101152252154,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8023335009065509,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,492614151119566,!1,[[11,"Camera"],[8,5],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SubVar,
null,5303035795813734,!1,[[11,"Camera"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,4704148699766587,!1,[[0,[23,"Camera"]]]]]],[0,null,!1,null,7093365896537194,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,703340505786666,!1,[[11,"Camera"],[8,3],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xe074799bde9c4,!1,[[11,"Camerax"],[7,[0,1]]]],[54,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xca3094861107d,
!1],[8,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x8a674ed51ed41,!1,[[3,1]]]]],[0,null,!1,null,7619775517108418,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5919880994609647,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7245351323086676,!1,[[11,"Camerax"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.ScrollX,null,8394397563242595,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,0x58c87f69a7f5c,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0x44fc1286b943d,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,8213731616901336,!1,[[1,[2,"I've reached Level 1o on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel11Events",[[2,"GameEvents",!1],[0,null,!1,null,0x4ef503a424253,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5574194498656425,
!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x654b9fe69c04c,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xb2349e25bdcd7,!1,[[6,"BlueLevel12"]]]]],[0,null,!1,null,0xfa9737b36c30b,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xdcba5d22421c0,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8805561820483659,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8896369358260502,!1,[[11,"WorldBlocks"],
[8,3],[7,[0,10]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7157672362359322,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,689768661348791,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc4b8554f04fd3,!1,[[4,11]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8958284209448706,!1,[[11,"Camerax"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8588512569792762,!1,[[11,"Cameray"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.Y,
!1,null]]]]]],[0,null,!1,null,6283739271250736,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x70a165e334bd6,!1]],[[-1,cr.system_object.prototype.acts.SetLayerParallax,null,7559660283616132,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,9665272811176700,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,8890177945138293,!1,[[0,[23,"Camera"]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x8e62abca2b2f1,!1,[[11,"Camera"],[7,[20,54,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8762930570513373,!1,[[11,"Camerax"],[7,[0,0]]]]]],[0,null,!1,null,6770070985509464,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,781143976215169,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x4cbbb6bce86af,!1,[[0,[1,0.0050]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xcadda3e417fc3,!1,[[11,"Camera"],[8,
5],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,7128584861785222,!1,[[11,"Camera"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,8153310495267202,!1,[[0,[23,"Camera"]]]]]],[0,null,!1,null,7640659571611912,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9294312964943924,!1,[[11,"Camera"],[8,3],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6129584751452167,
!1,[[11,"Camerax"],[7,[0,1]]]],[54,cr.plugins_.Sprite.prototype.acts.Destroy,null,8968419353311593,!1],[8,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x9025c20b0030e,!1,[[3,1]]]]],[0,null,!1,null,6451687771440281,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x6ff5de47525b9,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x4f0cae4e3a754,!1,[[11,"Camerax"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.ScrollX,null,8224435418694334,!1,[[0,
[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,7663577086627308,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6637938032906228,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,0xd1232725528dd,!1,[[1,[2,"I've reached Level 11 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel12Events",
[[2,"GameEvents",!1],[0,null,!1,null,435412270579558,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6660768103848755,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6307669235270244,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6610233722105532,!1,[[6,"BlueLevel13"]]]]],[0,null,!1,null,0xa0706a2be8ee6,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc271137cc81d2,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,8346593304579616,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7641324270248243,!1,[[11,"WorldBlocks"],[8,3],[7,[0,11]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9545638912083612,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,8143939676088707,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9146071789576620,!1,[[4,11]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9810285200280566,!1,[[11,"Camerax"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.X,
!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xa470245a0f297,!1,[[11,"Cameray"],[7,[20,11,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0x9cb8970e0f781,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7553447342153816,!1]],[[-1,cr.system_object.prototype.acts.SetLayerParallax,null,8076770658229084,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0xedbf5048eca16,!1,[[5,[2,"Direcionais"]],[0,[0,0]],
[0,[0,0]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,0x544051780c0b6,!1,[[0,[23,"Camera"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4790715709930437,!1,[[11,"Camera"],[7,[20,54,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x98e68261b9f12,!1,[[11,"Camerax"],[7,[0,0]]]]]],[0,null,!1,null,7738824938316058,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,8424799905966438,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,
!1,!1,!1,0xf5993801b0dea,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xc2b13d1f96f79,!1,[[11,"Camera"],[8,5],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xf7db181402416,!1,[[11,"Camera"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,8171404962175402,!1,[[0,[23,"Camera"]]]]]],[0,null,!1,null,4538182988562351,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd0ccf3050cbe6,
!1,[[11,"Camera"],[8,3],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9692414785317208,!1,[[11,"Camerax"],[7,[0,1]]]],[54,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x95aadc6671ca3,!1]]],[0,null,!1,null,8520077595163615,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6181634255725181,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8856738214547606,!1,[[11,"Camerax"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.ScrollX,
null,472678540722791,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,9219985955648954,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8742650007912581,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,0x731296bc58c06,!1,[[1,[2,"I've reached Level 12 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],
[3,0]]]]]]],["BlueLevel13Events",[[2,"GameEvents",!1],[0,null,!1,null,0x4ae8a989e2294,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5187462769194729,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x5c1d26fa76f89,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xcd04c80d2519d,!1,[[6,"BlueLevel14"]]]]],[0,null,!1,null,0xeb083f25eca5f,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf73d06cd5a5c7,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,7479837816638262,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8090093769089249,!1,[[11,"WorldBlocks"],[8,3],[7,[0,12]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x44443a3d94dc0,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x5ad82368f5fb1,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,463462377566649,!1]],[[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0xf10f1aaf29853,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,
cr.system_object.prototype.acts.SetLayerParallax,null,8925570937563654,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,9506133033913472,!1,[[0,[23,"Camera"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5002564292203494,!1,[[11,"Camera"],[7,[20,54,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x94f82f37e7de9,!1,[[11,"Camerax"],[7,[0,0]]]]]],[0,null,!1,null,7592752360553551,[[-1,cr.system_object.prototype.cnds.While,
null,0,!0,!1,!1,0x7b9fc1f2ffe5a,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xf4a98d02ab474,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5106180125360644,!1,[[11,"Camera"],[8,3],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9759021760951184,!1,[[11,"Camera"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,5786305982513593,!1,[[0,[23,"Camera"]]]]]],[0,null,!1,null,0xa29af4f6675d6,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4973000693301323,!1,[[11,"Camera"],[8,5],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xe751dd3d3dd9d,!1,[[11,"Camerax"],[7,[0,1]]]],[54,cr.plugins_.Sprite.prototype.acts.Destroy,null,5969987486136574,!1]]],[0,null,!1,null,571558771353738,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6041631644931183,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,9646100520406284,!1,[[11,"Camerax"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.ScrollX,null,0xb5870bea48028,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,6539109822076245,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5684141956687168,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,0x68daa0f5e275b,!1,[[1,[2,"I've reached Level 13 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],
[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel14Events",[[2,"GameEvents",!1],[0,null,!1,null,8190510440918504,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5406078694405433,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x71f2cdafc58ca,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xc785bdee12f65,!1,[[6,"BlueLevel15"]]]]],[0,null,!1,null,0xe59883920e8cd,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,5067339163433985,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,586700879898814,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7202915288287456,!1,[[11,"WorldBlocks"],[8,3],[7,[0,13]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9211518897527120,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,6034989241227782,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x871054f75d081,!1]],[[-1,cr.system_object.prototype.acts.SetLayerParallax,
null,7829326668751427,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,5647079782463891,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,0xa8ae3a2cfb03a,!1,[[0,[23,"Camera"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc616635e655f2,!1,[[11,"Camera"],[7,[20,54,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7879001257863642,!1,[[11,"Camerax"],[7,
[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerScale,null,9372213081379128,!1,[[5,[2,"game"]],[0,[1,0.8]]]]]],[0,null,!1,null,9647970640162856,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,0xaf40629b3f7ba,!1],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x59851ae0d9a8b,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6319118802961959,!1,[[11,"Camera"],[8,3],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.AddVar,
null,5305091789402681,!1,[[11,"Camera"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.ScrollX,null,0x78274fbd92680,!1,[[0,[23,"Camera"]]]]]],[0,null,!1,null,0xe40a20622cf5e,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6615887003063332,!1,[[11,"Camera"],[8,5],[7,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5628967766335221,!1,[[11,"Camerax"],[7,[0,1]]]],[54,cr.plugins_.Sprite.prototype.acts.Destroy,null,9705662731770992,
!1]]],[0,null,!1,null,5060533688359264,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8048370243453324,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xadd2cd96a7292,!1,[[11,"Camerax"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.ScrollX,null,0xc54f0c9eb550f,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,5665878771810807,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5510488134838389,!1,[[4,114]]]],
[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,7535280695447895,!1,[[1,[2,"I've reached Level 14 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel15Events",[[1,"Scale",0,0.2,!1,!1,0x3cba93fbc8802,!1],[2,"GameEvents",!1],[0,null,!1,null,0xc5a1668e4c5f3,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xdaf95d3c1985,
!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6020606495023534,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6498197595434795,!1,[[6,"BlueLevel16"]]]]],[0,null,!1,null,0xa14cd824b74bc,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x850a9ce50dc2b,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xd0cf9b137aa52,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5845895125102719,!1,[[11,"WorldBlocks"],
[8,3],[7,[0,14]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,4560188005509557,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x5a74bed1e74f1,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xdb92f4855da80,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb97d2a65d89fb,!1,[[11,"Scale"],[7,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,9156562204789584,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,
null,8879924734711745,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]]]],[0,null,!1,null,8484176024643723,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x4ecb78f08670b,!1]],[[-1,cr.system_object.prototype.acts.ScrollX,null,6702354016227446,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,0xeb595563f5432,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,414551737156456,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x956a129643d14,
!1,[[11,"Scale"],[8,2],[7,[1,0.51]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0xe0b1f33b2d8ab,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0xb17a247f8d13f,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,0xa236e6ab59a69,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x96151fffdf915,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xfe9b2384d5a76,!1,[[11,"Scale"],[8,4],[7,[1,0.51]]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xdb10512ffa5c4,!1,[[11,"Scale"],[8,2],[7,[1,0.8]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x9e101c3bffdf5,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,0x6ad5d153de4af,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5958285704816511,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe871b3afe1923,!1,[[11,"Scale"],[8,4],[7,[1,0.7]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xede3f11ce0240,!1,[[11,"Scale"],[7,[1,
0.7]]]]]],[0,null,!1,null,6600892684897163,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6492316994568861,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,5443926410371185,!1,[[5,[2,"Game"]],[0,[23,"Scale"]]]]]],[0,null,!1,null,0x97ea2292ce3c3,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xbc44d789f17a5,!1,[[8,2],[0,[0,50]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,9973597142519736,!1,[[0,[0,0]]]]]],[0,null,!1,null,0xdb195925d4f5b,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0xce513da7a5ab5,!1,[[8,4],[0,[0,250]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,8902581963176147,!1,[[0,[0,240]]]]]],[0,null,!1,null,8790139517976244,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x93ecdb914442c,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,0xb55eefbf7fdd8,!1,[[1,[2,"I've reached Level 15 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],
[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel16Events",[[2,"GameEvents",!1],[0,null,!1,null,0x4aa5ba6ff5ac1,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xa3814880a0523,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5341055893290206,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xcec3462d9e84f,!1,[[6,"BlueLevel17"]]]]],[0,null,!1,null,0x6011e3ccd06b8,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,9124837524746984,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x91f440535da09,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x834a7e3bf3a44,!1,[[11,"WorldBlocks"],[8,3],[7,[0,15]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6261889873411578,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,6770423831315142,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,935356207166811,!1]],[[-1,cr.system_object.prototype.acts.SetVar,
null,5961042358767207,!1,[[11,"Scale"],[7,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0xb3596c52c7c55,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0x44be3639da591,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]]]],[0,null,!1,null,0xe3dac3bea8334,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x671b3799278a6,!1]],[[-1,cr.system_object.prototype.acts.ScrollX,null,9239876009028604,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,
!1,null]]]]]],[0,null,!1,null,0xb02955aa19c73,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x4b03ad44b95d5,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb49d7fd927f8a,!1,[[11,"Scale"],[8,2],[7,[1,0.51]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x775691acbc9a0,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5319194754613743,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,4896576562482667,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0x8da825d722403,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6431325765009708,!1,[[11,"Scale"],[8,4],[7,[1,0.51]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8949885104783922,!1,[[11,"Scale"],[8,2],[7,[1,0.7]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,914431936547E4,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,630145132584964,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8027576228152949,!1,[[0,[1,
0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x96a908df9156b,!1,[[11,"Scale"],[8,4],[7,[1,0.7]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9157295243664452,!1,[[11,"Scale"],[7,[1,0.7]]]]]],[0,null,!1,null,0xa7108ff2dc6aa,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5655525218980592,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0x987544a99ed3f,!1,[[5,[2,"Game"]],[0,[23,"Scale"]]]]]],[0,null,!1,null,9678785069555604,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,724959067367605,!1,[[8,2],[0,[0,50]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,8900641537179169,!1,[[0,[0,0]]]]]],[0,null,!1,null,8161371090608239,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xfd9c9101509e1,!1,[[8,4],[0,[0,250]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,6840090917682062,!1,[[0,[0,240]]]]]],[0,null,!1,null,4799658389044239,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xba83a175881af,!1,[[4,114]]]],[[115,
cr.plugins_.Clay.prototype.acts.facebook_post,null,0xaf933c3bcc895,!1,[[1,[2,"I've reached Level 16 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel17Events",[[2,"GameEvents",!1],[0,null,!1,null,0x5d2354328f0af,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5789356466205051,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,743931402046053,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xa377e6230d587,!1,[[6,"BlueLevel18"]]]]],[0,null,!1,null,0xd7b7a183798b8,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x7d80f8653358d,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,796667195084103,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6725315272662208,!1,[[11,"WorldBlocks"],[8,3],[7,[0,16]]]]],[[-1,cr.system_object.prototype.acts.AddVar,
null,6544664027710299,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xdb441a38e810,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9468882699384740,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,7816214934599752,!1,[[11,"Scale"],[7,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,7090589550027087,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0x581b36477ba22,!1,[[5,[2,"Direcionais"]],[0,[0,0]],
[0,[0,0]]]]]],[0,null,!1,null,0x85d06d264f6eb,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5529564427605088,!1]],[[-1,cr.system_object.prototype.acts.ScrollX,null,6460188812082291,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]]],[0,null,!1,null,9415282588356068,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6453761701223889,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7c9a9cb5bde0f,!1,[[11,"Scale"],[8,2],[7,[1,0.51]]]]],[[-1,
cr.system_object.prototype.acts.Wait,null,7291830106238052,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5273777827258129,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,0x65b5569c79c9d,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9342916207474324,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x627c8c87f60ee,!1,[[11,"Scale"],[8,4],[7,[1,0.51]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6779191457209494,!1,
[[11,"Scale"],[8,2],[7,[1,0.8]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6880072574272993,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,7198418889080934,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,453678636824689,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,315861989644917,!1,[[11,"Scale"],[8,4],[7,[1,0.8]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,4974088108174321,!1,[[11,"Scale"],[7,[1,0.8]]]]]],[0,null,!1,null,425599519874756,
[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xcc04eb1edacec,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,6408749199548525,!1,[[5,[2,"Game"]],[0,[23,"Scale"]]]]]],[0,null,!1,null,0x9c50f4b5c0cca,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6239199575892963,!1,[[8,2],[0,[0,50]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,0xea78e21dc1524,!1,[[0,[0,0]]]]]],[0,null,!1,null,0x9c4d4fa0c2af6,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,null,
0,!1,!1,!1,317010048241412,!1,[[8,4],[0,[0,200]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,6520545202378925,!1,[[0,[0,240]]]]]],[0,null,!1,null,0xff7f447b42bea,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xe003ff67d4f3d,!1,[[4,114]]]],[[115,cr.plugins_.Clay.prototype.acts.facebook_post,null,5478652061446837,!1,[[1,[2,"I've reached Level 17 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],
[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["BlueLevel18Events",[[2,"GameEvents",!1],[0,null,!1,null,7014770719725717,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,671054488165204,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5937078894050642,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8515284679202274,!1,[[6,"Worlds"]]]]],[0,null,!1,null,6699889693224114,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,8797253983070143,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8648953749759772,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xef8632dca7c0b,!1,[[11,"WorldBlocks"],[8,3],[7,[0,17]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7693307056197929,!1,[[11,"WorldBlocks"],[7,[0,2]]]]]],[0,null,!1,null,9969469349859720,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7131877084302518,!1]],[[-1,cr.system_object.prototype.acts.SetVar,
null,9887400028926176,!1,[[11,"Scale"],[7,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0x5bd6c4941b30e,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,5381432323363234,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]]]],[0,null,!1,null,0x4e7aa37d70735,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6621873517395058,!1]],[[-1,cr.system_object.prototype.acts.ScrollX,null,7115065308103432,!1,[[0,[20,8,cr.plugins_.Sprite.prototype.exps.X,
!1,null]]]]]],[0,null,!1,null,9360834408758100,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7347116700691521,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8349677182845625,!1,[[11,"Scale"],[8,2],[7,[1,0.51]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,6528428091835778,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6385962996580019,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,958501754703138,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,9616468483377776,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,512353781276635,!1,[[11,"Scale"],[8,4],[7,[1,0.51]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7af801703e221,!1,[[11,"Scale"],[8,2],[7,[1,0.8]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,8189570117951371,!1,[[11,"Scale"],[7,[1,0.01]]]]]],[0,null,!1,null,7320683102284138,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xe8bfe9d93dcff,!1,[[0,
[1,0.01]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5bded2b04d58,!1,[[11,"Scale"],[8,4],[7,[1,0.8]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5825797297149905,!1,[[11,"Scale"],[7,[1,0.8]]]]]],[0,null,!1,null,9254655077906896,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xfa1bb4e95e2e8,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,7685878971716119,!1,[[5,[2,"Game"]],[0,[23,"Scale"]]]]]],[0,null,!1,null,0x81646b903fa10,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0x527a353ab07cb,!1,[[8,2],[0,[0,50]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,0xdf6d5746d3dc5,!1,[[0,[0,0]]]]]],[0,null,!1,null,6791114223971555,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6157952757274619,!1,[[8,4],[0,[0,230]]]]],[[-1,cr.system_object.prototype.acts.ScrollY,null,5938676006824021,!1,[[0,[0,240]]]]]],[0,null,!1,null,8975064853558611,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x545b2c31e3344,!1,[[4,114]]]],[[115,
cr.plugins_.Clay.prototype.acts.facebook_post,null,5550507646983611,!1,[[1,[2,"I've reached Level 18 on the Blue Pack at Billy the Ball"]],[1,[2,"https://play.google.com/store/apps/details?id=com.Solarium.BillyTheBallDemo"]],[1,[2,"http://s27.postimg.org/fofy2vmsj/challengecompleted.png"]],[3,0]]]]]]],["GameEventsRed",[[2,"AudioEvents",!1],[0,null,!1,null,0xc4f9cb91b34d1,[[23,cr.plugins_.Keyboard.prototype.cnds.IsKeyDown,null,0,!1,!1,!1,5619438604127735,!1,[[9,39]]]],[[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,
"Physics",5984830048506645,!1,[[0,[0,10]],[0,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,7907232736735152,[[23,cr.plugins_.Keyboard.prototype.cnds.IsKeyDown,null,0,!1,!1,!1,6278036277352444,!1,[[9,37]]]],[[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",8970974868927803,!1,[[0,[0,10]],[0,[0,180]],[7,[0,0]]]]]],[0,null,!1,null,0x82d4a516f2cfe,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9339039466949444,!1,[[4,13]]]],[[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,
"Physics",0xdc440b725d67c,!1,[[0,[0,10]],[0,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,0x3bdfc197bcdd8,[[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9877474400237756,!1,[[4,12]]]],[[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",24234273377522,!1,[[0,[0,10]],[0,[0,180]],[7,[0,0]]]]]],[0,null,!1,null,4824662052275349,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,334958490231284,!1,[[4,9]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,
null,0xade3f271c1be9,!1]]],[0,null,!1,null,8151150472222144,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,289937035196125,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,9576289578169844,!1]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,8872911799319022,!1,[[2,["ok - 1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6557595898410316,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x86444a8002ae9,
!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,0xe58a1d13dc28e,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x78658499ffab7,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,9460047771217656,!1]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,0xf12b6e31ace98,!1,[[2,["ok - 1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5857589734313413,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,
9226854847053796,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,805897584313481,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7929516980121866,!1,[[4,7]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetY,null,0x7b581fb399345,!1,[[0,[0,240]]]],[41,cr.plugins_.Sprite.prototype.acts.SetY,null,5959466927748631,!1,[[0,[0,240]]]],[42,cr.plugins_.Sprite.prototype.acts.SetY,null,4653280475965232,!1,[[0,[0,240]]]],[43,cr.plugins_.Sprite.prototype.acts.SetY,null,0x67bc88ac0321f,!1,
[[0,[0,240]]]],[34,cr.plugins_.Sprite.prototype.acts.SetY,null,0xecdf2e2c78d74,!1,[[0,[0,240]]]]]],[0,null,!1,null,718505775862103,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4637934084912371,!1,[[4,43]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetY,null,0xead9c029edc45,!1,[[0,[0,2E3]]]],[41,cr.plugins_.Sprite.prototype.acts.SetY,null,7428154700533114,!1,[[0,[0,2E3]]]],[42,cr.plugins_.Sprite.prototype.acts.SetY,null,9291279952698738,!1,[[0,[0,2E3]]]],[43,cr.plugins_.Sprite.prototype.acts.SetY,
null,0xa32b557d6f662,!1,[[0,[0,2E3]]]],[34,cr.plugins_.Sprite.prototype.acts.SetY,null,0x80bce318f9668,!1,[[0,[0,2E3]]]]]],[0,null,!1,null,6940769495236264,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5421009522295814,!1,[[4,40]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,0xb15b456b7558f,!1]]],[0,null,!1,null,7055504608423329,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3957fa42f31c5,!1,[[4,41]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,6338582092433176,!1,[[6,"Worlds"]]]]],[0,null,!1,null,0x8dd4a2cb32902,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9831921356263226,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x39075ae74d232,!1,[[11,"StarsCatcheds"],[7,[0,0]]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9462253640983864,!1,[[3,0]]],[21,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6987009114374359,!1,[[3,0]]],[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xc2d6f1aaeee98,
!1],[-1,cr.system_object.prototype.acts.SaveState,null,6878644847861467,!1,[[1,[2,"mysave"]]]],[75,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x6abe0c295d014,!1,[[3,0]]]]],[0,null,!1,null,0xb9d6224530a25,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7879377442382261,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7809265349656496,!1,[[11,"StarsCatcheds"],[8,1],[7,[0,3]]]]],[[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",322339574182978,
!1,[[3,0]]]]],[0,null,!1,null,8548799530231376,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6acad20fa9d91,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,0]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9973521776576580,!1,[[1,[2,"zero"]],[3,1]]]]],[0,null,!1,null,0xcc6e8e2bfdd9c,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa39ea717a812b,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,1]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x5445e5b5abd93,!1,[[1,[2,
"um"]],[3,1]]]]],[0,null,!1,null,0x8136e44f3873,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6743742856498236,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,2]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x8f3c2e6689514,!1,[[1,[2,"dois"]],[3,1]]]]],[0,null,!1,null,6127118145754375,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9617340059976754,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9939242622853904,!1,[[1,
[2,"tres"]],[3,1]]]]],[0,null,!1,null,7344046363850849,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9196161004118538,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5524896575291912,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[16,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,4980768002009979,!1],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0xfa1ce6e2ba557,!1,[[3,1]]]]],[0,null,!1,null,7918651264096686,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0xaeb3cdf4c43b9,!1]],[[8,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,8900862881023356,!1],[-1,cr.system_object.prototype.acts.SetVar,null,0xf4aefc328fe87,!1,[[11,"GameBallX"],[7,[20,75,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6986886572765504,!1,[[11,"GameBallY"],[7,[20,75,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",4531479657970453,!1,[[3,0]]],[79,cr.plugins_.Sprite.prototype.acts.StopAnim,
null,8261884004247211,!1]]],[0,null,!1,null,0xea9f2b73bf7ab,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8664397400811366,!1,[[4,22]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xbb5c52b368b4,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[19,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xfd2ffa8a852b2,!1,[[3,1]]],[19,cr.plugins_.Sprite.prototype.acts.SetPos,null,8836119498451229,!1,[[0,[0,400]],[0,[0,240]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPos,
null,0xa18c8034f01c2,!1,[[0,[0,400]],[0,[0,240]]]],[8,cr.behaviors.Platform.prototype.acts.SetIgnoreInput,"Platform",6080579094168581,!1,[[3,1]]],[75,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8827180889852714,!1,[[3,1]]]]],[0,null,!1,null,4777388819964132,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,472385326454999,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5676530994876591,!1,[[11,"StarsCatcheds"],[8,1],[7,[0,3]]]]],[[8,cr.plugins_.Sprite.prototype.acts.MoveToTop,
null,898927253334022,!1],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0xf4167ff5e7b3d,!1,[[3,0]]]]],[0,null,!1,null,5882999886216502,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6293567880789761,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,708930884540826,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[16,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,4821378242578059,!1],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",9877441050523606,
!1,[[3,1]]]]],[0,null,!1,null,5687826590454668,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x652913aac7805,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,7905116262547464,!1,[[1,[2,"mysave"]]]]]],[0,null,!1,null,6390821578056136,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5343409600969554,!1,[[4,7]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x3d7241c83473f,!1,[[0,[0,0]]]]]],[0,null,!1,null,463748599505485,[[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,7867368118964644,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc7f85157400e8,!1,[[0,[0,1]]]]]],[0,null,!1,null,8191997490583648,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6059401025307742,!1,[[4,76]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9219213979280234,!1]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,5683102710607974,!1,[[2,["bump1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,8913927087365483,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,6675101368195831,!1,[[0,[0,5]]]]],[[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0x9faaf924f8de,!1]]],[0,null,!1,null,8218133784096063,[[87,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,0,!1,!1,!1,0x6194a1e0b9f4,!1,[[8,2],[0,[0,100]]]],[87,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x8fa7433653fad,!1,[[0,[20,87,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[[87,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7038633890228742,!1,[[1,[2,"medio"]],[3,
1]]]]],[0,null,!1,null,0xd301eb2d781a8,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8270310769017482,!1,[[4,107]]],[107,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x8afdc16dcc3e1,!1,[[10,0],[8,0],[7,[0,0]]]],[106,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,853568725233055,!1,[[10,0],[8,0],[7,[0,0]]]]],[],[[0,null,!1,null,5830640418290986,[[107,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xfa5ab6544dec5,!1,[[0,[20,107,
cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[106,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8447766297873926,!1,[[0,[20,106,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[[107,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xaad1d28a1c0bf,!1,[[7,[0,0]],[4,106],[0,[0,-25]],[0,[0,25]]]],[107,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x8d67d637b1a4b,!1,[[10,0],[7,[0,1]]]],[106,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,87966580344307,
!1,[[10,0],[7,[0,1]]]]]]]],[0,null,!1,null,0xa247233b79b6e,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,9056953058537414,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.StartAnim,null,0xc39b3135904dd,!1,[[3,0]]]]],[0,null,!1,null,0xc86a6ee7365d4,[[78,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9241723691629166,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.StartAnim,null,8690931764921495,!1,[[3,0]]]]],[0,null,!1,null,9670717740379296,[[-1,cr.system_object.prototype.cnds.ForEach,
null,0,!0,!1,!1,569456675696073,!1,[[4,76]]],[76,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x626dec3747e7c,!1,[[4,79]]]],[],[[0,null,!1,null,0x9cb715a0c996c,[[76,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8431064422218903,!1,[[0,[20,76,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6376436849908988,!1,[[3,0]]]]]]]]],["RedLevel1Events",[[2,"GameEventsRed",!1],[0,null,!1,null,553102607126347,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6233909602853131,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9365237975661118,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xbcc0e86596c94,!1,[[6,"RedLevel2"]]]]],[0,null,!1,null,0xf177c5c79863a,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9689395256891866,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x57eadf7fb8743,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,0x4e5e576a04ed6,!1,[[11,"WorldBlocks"],[8,3],[7,[0,18]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xfa0031fa3430b,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]]]],["RedLevel2Events",[[2,"GameEventsRed",!1],[0,null,!1,null,0x92ff5e8d12335,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9247725104128202,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xede8c92480f68,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9275378122483458,!1,[[6,
"RedLevel3"]]]]],[0,null,!1,null,8593098674902758,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9190292391286682,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,428318378514766,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x854507cdf1d00,!1,[[11,"WorldBlocks"],[8,3],[7,[0,19]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x5d136ca02f427,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]]]],["RedLevel3Events",[[2,"GameEventsRed",!1],
[0,null,!1,null,874478886540525,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6501491090158008,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xf355014794c58,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x4ece90d390078,!1,[[6,"BlueLevel3"]]]]],[0,null,!1,null,0xbb5b6357b7b55,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,435715085626777,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,
!1,0xacdb4efeff0ce,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7957549594795486,!1,[[11,"WorldBlocks"],[8,3],[7,[0,20]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,8873178964809774,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]]]],["RedLevel4Events",[[2,"GameEventsRed",!1],[0,null,!1,null,8795732927684922,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x989cbbefc35f8,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x6f2ac443a1f22,
!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5228542400902081,!1,[[6,"RedLevel5"]]]]],[0,null,!1,null,0xa377e026f4242,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x47ce317f25d0e,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xeafdc0703d093,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,305504222413419,!1,[[11,"WorldBlocks"],[8,3],[7,[0,21]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,738648416255983,!1,
[[11,"WorldBlocks"],[7,[0,1]]]]]]]],["RedLevel5Events",[[2,"GameEventsRed",!1],[0,null,!1,null,5976494817698234,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3afb4eec2c142,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9137623223912844,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,960238832835332,!1,[[6,"RedLevel6"]]]]],[0,null,!1,null,348429591241718,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x7c496e386e422,
!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x810c696600efd,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5239329486022163,!1,[[11,"WorldBlocks"],[8,3],[7,[0,22]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9286083394032288,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x571dd75f3ff8d,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xd82afd1eba99f,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,
null,0,!1,!1,!1,0xdc0785b0ee38e,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5904926398953771,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,295811557758981,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]]]],["RedLevel6Events",[[2,"GameEventsRed",!1],[0,null,!1,null,0x51e095eccdd90,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9546288763704888,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x8ace86d1ef2ae,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,4639149597981497,!1,[[6,"BlueLevel7"]]]]],[0,null,!1,null,0x51949ded8227e,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x4a2e6090d3954,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6305226642605933,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6284594825569757,!1,[[11,"WorldBlocks"],[8,3],[7,[0,23]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xe0e1b8db75629,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,
0xe2b09be6309f0,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8573545034207272,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,9637446158605804,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6589427155768782,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,8630208761534472,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]]]],["RedLevel7Events",[[2,"GameEventsRed",!1],[0,null,!1,null,9687264342356068,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0xd250c1dd8dc28,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,7805434421138031,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8236922606586188,!1,[[6,"RedLevel8"]]]]],[0,null,!1,null,9356048587279516,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5554153282823505,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5530776669734774,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,7298476848431104,!1,[[11,"WorldBlocks"],[8,3],[7,[0,24]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,472663909533241,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x5ff16d43a952a,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7527543962853726,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,0x3eeb8c84fc64b,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4757014856982219,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,
null,0x488d33b2dff33,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,0x58b10902e8927,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5126720530387286,!1,[[4,106]]],[106,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9384479943816040,!1,[[0,[0,2560]]]],[76,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xcafe95219da80,!1,[[0,[0,1124]]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe59d3f960b75a,!1]]],[0,null,!1,null,307539425088092,[[75,
cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7970728403085194,!1,[[4,106]]],[106,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xa559de0c94d20,!1,[[0,[0,2563]]]],[76,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5112809487547664,!1,[[0,[0,1151]]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,7674751789887301,!1]]],[0,null,!1,null,5202029149233634,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7289769578690376,!1]],[[78,cr.behaviors.Physics.prototype.acts.SetDensity,
"Physics",684252814268682,!1,[[0,[0,2]]]]]]]],["RedLevel8Events",[[2,"GameEventsRed",!1],[0,null,!1,null,0x4f6682395d8b6,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,849659238656811,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6500306507154708,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9158668894137196,!1,[[6,"RedLevel9"]]]]],[0,null,!1,null,9979339565297940,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x4c414bf5efc07,
!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5085289697401107,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8768332685630919,!1,[[11,"WorldBlocks"],[8,3],[7,[0,25]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,490171908424894,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x6eb6dd206228b,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,4823057902152335,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,
null,0,!1,!1,!1,0x43ced80ac6322,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8749317426119368,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,795049908346155,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,4972681708690644,[[78,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x93764ddad9b0f,!1,[[4,79]]],[79,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xd9efb33612c12,!1,[[0,[0,1182]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPos,null,
0xe267a49b752a2,!1,[[0,[0,243]],[0,[0,82]]]]]]]],["RedLevel9Events",[[2,"GameEventsRed",!1],[0,null,!1,null,7329607595175173,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6039791011479231,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xb98d356e0ba87,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,305791381387155,!1,[[6,"RedLevel10"]]]]],[0,null,!1,null,0xe6a4e5835a315,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,
9985506514599308,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,33044481162763,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xfd3e5beafc20c,!1,[[11,"WorldBlocks"],[8,3],[7,[0,26]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6530524590610294,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,9527977930818448,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8622564731352655,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,
null,0,!1,!1,!1,6591715588131329,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6376568070887323,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x91ad6c73cce93,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,5022234877487877,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,9013374476897544,!1,[[4,79]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xde68567f9c9d5,!1,[[0,[0,1179]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPos,
null,9120672610592464,!1,[[0,[0,301]],[0,[0,230]]]]]],[0,null,!1,null,9017654423234024,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x9c7dd5ea74f83,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xab716a8b47c64,!1,[[0,[0,1258]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,7402639816893917,!1,[[0,[0,67]],[0,[0,226]]]]]]]],["RedLevel10Events",[[2,"GameEventsRed",!1],[0,null,!1,null,5358583963194216,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,7366590141552868,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,7310682676076115,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6822135293212441,!1,[[6,"RedLevel11"]]]]],[0,null,!1,null,4598388545535561,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7042836706739267,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,7085621662011161,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,0xa9e985a9febb5,!1,[[11,"WorldBlocks"],[8,3],[7,[0,27]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9356235956785016,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,9176488099232732,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x4a7f08e01a432,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,5789967365459932,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6070620904538109,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,
null,7231872933553305,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,5116112602636746,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7532443069101528,!1,[[4,79]]],[79,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8769161732795173,!1,[[0,[0,1228]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPos,null,8002625628530235,!1,[[0,[0,301]],[0,[0,219]]]]]],[0,null,!1,null,0x70bf333ed1fe8,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,6861799146555248,
!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xeb004dac531d9,!1,[[0,[0,1258]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,8025790157473101,!1,[[0,[0,67]],[0,[0,226]]]]]],[0,null,!1,null,0xceddef80ca3d5,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x74fe667c31719,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0xf2e4be1362cee,!1,[[5,[2,"game"]],[0,[1,0.8]]]]]],[0,null,!1,null,9263549690424772,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7506712870398633,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xc6c5f86fa1418,!1,[[0,[0,1308]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,6084630389822072,!1,[[0,[0,463]],[0,[0,58]]]]]],[0,null,!1,null,6164440837892547,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x461c3e1023dad,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xa2a4eb280d7a9,!1,[[0,[0,1281]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,5288573231546303,!1,[[0,[0,731]],[0,[0,78]]]]]]]],["RedLevel11Events",[[1,"Tempo",0,0,!1,!1,9930603439693080,!1],[2,"GameEventsRed",!1],[0,null,!1,null,9982205062712668,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x5f04f5ae360a1,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,469218462148055,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x621719b79ccae,!1,[[6,"RedLevel12"]]]]],[0,null,!1,null,0x59ca5e69589ec,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0x6d89e44afbf1,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9638253789390576,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5631305098270934,!1,[[11,"WorldBlocks"],[8,3],[7,[0,28]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,9986913073129056,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x3adb6dcf6268d,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,4884040540167553,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,
null,0,!1,!1,!1,0x643002b154d3b,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8517734439020279,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,9317174459883762,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,6852126737766331,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x6c9c431d151c3,!1,[[4,79]]],[79,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xc1caa65289741,!1,[[0,[0,1228]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPos,
null,8214840692899974,!1,[[0,[0,301]],[0,[0,219]]]]]],[0,null,!1,null,8956214456247844,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8619252310739526,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9484704797894452,!1,[[0,[0,1258]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,9109456037942816,!1,[[0,[0,67]],[0,[0,226]]]]]],[0,null,!1,null,8433808311095165,[],[[-1,cr.system_object.prototype.acts.SetVar,null,8781916046910706,!1,[[11,"Scale"],
[7,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0x90f480bcd578d,!1,[[5,[2,"gui"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,0x85b3f4fd4d5a,!1,[[5,[2,"Direcionais"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayerParallax,null,7490344713748974,!1,[[5,[2,"Fundo"]],[0,[0,0]],[0,[0,0]]]]]],[0,null,!1,null,5784733132385239,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x43939ec799be5,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,
null,7413406229249107,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc6da371d2b592,!1,[[11,"Tempo"],[7,[0,21]]]]]],[0,null,!1,null,0xa1557ed94337b,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xf52464b374f2a,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5700802896426852,!1,[[0,[0,1348]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,6238158831669205,!1,[[0,[0,70]],[0,[0,129]]]]]],[0,null,!1,null,0x609495dec8f0c,
[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x83935f254be85,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x8831abdbbcc24,!1,[[0,[0,1353]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x7781c3447bd55,!1,[[0,[0,731]],[0,[0,25]]]]]],[0,null,!1,null,902453462777603,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8326193929026633,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0xd4a458ea6771d,!1,[[7,[23,"Tempo"]]]]]],
[0,null,!1,null,0xabbd933b9ac6e,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6391042723734673,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x71fc6da372b54,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x9ffbbe7345507,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,0x69b1b44b659b,!1,[[11,"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,7919488641258074,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x45417d22e2176,
!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,5643112550957211,!1]]]]],["RedLevel12Events",[[1,"Oculos",0,100,!1,!1,5956567121139558,!1],[2,"GameEventsRed",!1],[0,null,!1,null,9744225777669988,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xd43c1f1f3a212,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x3c5b2e3d0f56e,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,346222423178285,!1,[[6,"RedLevel13"]]]]],
[0,null,!1,null,0x8f57e75358e92,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7460085990227406,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x66a1cb2002415,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,708055428081435,!1,[[11,"WorldBlocks"],[8,3],[7,[0,29]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6584320519168654,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,5489313852067231,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xbb76ed68f8f6b,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,7011165440825806,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8884956265574056,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,0xd6ee0e8ea689,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,0xfd54bd2da1830,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x5b18e8013faab,!1,[[4,79]]],[79,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,
!1,!1,!0,7425790634980228,!1,[[0,[0,1228]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPos,null,5005919231185798,!1,[[0,[0,301]],[0,[0,219]]]]]],[0,null,!1,null,9473842221123876,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,9413995705070378,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xfc401f617001a,!1,[[0,[0,1258]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,6684375239109036,!1,[[0,[0,67]],[0,[0,226]]]]]],[0,null,!1,null,0xc5bbbc944aaa0,
[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9154892166323040,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0x557d1a7541968,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6599948317425585,!1,[[11,"Tempo"],[7,[0,21]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x4f1eea181a879,!1,[[11,"Oculos"],[7,[0,100]]]]]],[0,null,!1,null,7451029840004038,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7629871680233128,
!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x801f6c62db851,!1,[[0,[0,1417]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,8554423870414017,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,6049493003391104,!1,[[0,[0,70]],[0,[0,129]]]],[-1,cr.system_object.prototype.acts.SubVar,null,955877340711167,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,5884774948024346,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7840124171727893,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8382454369173854,!1,[[0,[0,1422]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,6565108866233894,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,7118758158634134,!1,[[0,[0,343]],[0,[0,137]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x60a863ac046a5,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0xb51576e18b445,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,6884164990550952,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x84f53d4a687f8,!1,[[0,[0,1426]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5172074290466115,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,5867273245275539,!1,[[0,[0,738]],[0,[0,271]]]],[-1,cr.system_object.prototype.acts.SubVar,null,8995087209183772,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0x7f4f840a09449,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xec92a581d8d0d,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x39f01406d21b7,!1,[[0,[0,1431]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,6091141404988878,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xc537558645e8a,!1,[[0,[0,510]],[0,[0,145]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xd9b09de3ee64b,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0x8864e39e4d5c3,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,0x9524c7b0fcac9,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0x986ebbabf3c9f,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,0x87a8a8ae82259,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x6feb2ab575fe4,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,7845029445675296,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x60cc4fbf2caf,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xecce309593405,!1,[[11,
"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,5996737018770631,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xdd1f2eacaacbf,!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,0xa540fdd45e47e,!1]]],[0,null,!1,null,0x91bfdf41c5d8,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x424c91d077c45,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xf39f09edae325,!1,[[1,[2,"passed"]],[3,1]]]]],[0,null,!1,null,8739834297589726,
[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x6f138bdb7cc33,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,0xccbc46d1456b9,!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,5653378190482079,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa4757a2dfd25f,!1,[[11,"Oculos"],[8,0],[7,[0,20]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xcbb415a991ef5,!1]]]]],["RedLevel13Events",[[2,"GameEventsRed",!1],[0,null,!1,null,9265651122930996,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0x4c2637c545cbe,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9822985461760076,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9040922337893560,!1,[[6,"RedLevel14"]]]]],[0,null,!1,null,9130163402378076,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4543763302819677,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,4821424307814355,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,9663923018216122,!1,[[11,"WorldBlocks"],[8,3],[7,[0,30]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,5899685392820851,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xddd1ababeaacf,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8823807553962675,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,9924779166880576,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8242566566695741,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,
null,8640735841534902,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,0x91d51b17d1ded,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,5032966101417998,!1,[[4,79]]],[79,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6387269370183187,!1,[[0,[0,1228]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x3e48a7af0d3d6,!1,[[0,[0,301]],[0,[0,219]]]]]],[0,null,!1,null,4856550732858154,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,5567755094267194,
!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xce0e9aeef15e,!1,[[0,[0,1258]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,428082412420245,!1,[[0,[0,67]],[0,[0,226]]]]]],[0,null,!1,null,4618605113837514,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9600192040615288,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0xb4baa1d95c442,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8240718131832643,
!1,[[11,"Tempo"],[7,[0,60]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4705722260202531,!1,[[11,"Oculos"],[7,[0,100]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",8131762424103112,!1,[[4,76],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5202245302617896,!1,[[4,87],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x58b4800deda93,!1,[[4,86],[3,1]]]]],[0,null,!1,null,5835360334088414,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0x4e328b42b2e29,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9617863079510514,!1,[[0,[0,1497]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,712137704647249,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,667840195379491,!1,[[0,[0,70]],[0,[0,129]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x70d55ce288482,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0x70cbd0a2b69bd,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0x4358b77af07fc,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x4f64196c071d6,!1,[[0,[0,1491]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,0xfa34a5e3d411a,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,8129431881978087,!1,[[0,[0,530]],[0,[0,-58]]]],[-1,cr.system_object.prototype.acts.SubVar,null,5961248129270834,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,762089321132815,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7719965047695571,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6041470626062354,!1,[[0,[0,1502]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,6570040097111782,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x788d24bc0b23c,!1,[[0,[0,867]],[0,[0,62]]]],[-1,cr.system_object.prototype.acts.SubVar,null,6731105125282512,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,4511322401766384,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0x425b39aa89105,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x407797f745e3d,!1,[[0,[0,1507]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,7284274234730483,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,644963549733935,!1,[[0,[0,300]],[0,[0,-64]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xae24b143fcbb3,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0xdf74e48391e1,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,9378048780518392,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,6951443439243676,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,0x8e64424fe82c6,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6914994563227345,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,831651262368676,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8267020456278376,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xae45a319def83,!1,
[[11,"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,8174076763406571,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8436646883368558,!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,332576807015114,!1]]],[0,null,!1,null,8600393881159612,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,6224501727280931,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7618011706116278,!1,[[1,[2,"passed"]],[3,1]]]]],[0,null,!1,null,
939456118440563,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9577192274564648,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,8690104111960158,!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,0xbb6d54dc08781,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,921482952114172,!1,[[11,"Oculos"],[8,0],[7,[0,20]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,8098357387850801,!1]]],[0,null,!1,null,6491320588765238,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xd4376ea86adc9,!1,[[4,87]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xeb635cbf28e23,!1,[[1,[2,"Dor"]],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",5325545081740771,!1,[[0,[0,40]],[0,[0,270]],[7,[0,0]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x9408f5369a869,!1,[[4,76],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x5a8751e1a2893,!1,[[4,87],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",0xba9da360f7b8,!1,[[4,86],[3,0]]],[75,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,614341576629852,!1]]]]],["RedLevel14Events",[[2,"GameEventsRed",!1],[0,null,!1,null,9641023278850832,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xeb7f0fd6c048f,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9952659108980116,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5560051823322132,!1,[[6,"RedLevel15"]]]]],[0,null,!1,null,0xaafba411f3103,
[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x82ece0fc38d97,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,4587193340796313,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3ffad369d853b,!1,[[11,"WorldBlocks"],[8,3],[7,[0,31]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7502529806601976,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,9410457098624184,[[78,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,
!1,!1,!1,799592509588016,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,9503345090348404,!1]],[[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x738f166a0767f,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,8379900046652198,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,4735038775450291,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7197116790066133,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,5936774946340543,
!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb13e6d2875849,!1,[[11,"Tempo"],[7,[0,15]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9023704312006178,!1,[[11,"Oculos"],[7,[0,100]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xdff1998268249,!1,[[4,76],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x98dd5642831c9,!1,[[4,87],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xce97c5e4af433,
!1,[[4,86],[3,1]]]]],[0,null,!1,null,9463907317566532,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,5668101068863225,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8684370381895723,!1,[[0,[0,1566]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,7094870466663595,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,5143660405811783,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,734186464170963,!1,[[0,[0,70]],[0,[0,129]]]],[-1,cr.system_object.prototype.acts.SubVar,null,7477452285713712,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,8198831217122445,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8967624653290865,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9763882561463936,!1,[[0,[0,1562]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,0xb6da5ea480499,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!1,!1,5353684021001086,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x70f75796d443,!1,[[0,[0,406]],[0,[0,-102]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x4deba7b2b922f,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,7386021127729381,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,5196183011789973,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5355630534381483,!1,[[0,[0,1557]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!0,!1,6481587077511187,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0xfcc928811f241,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x43c3b33587b6f,!1,[[0,[0,867]],[0,[0,62]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9101221038546176,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0xb0ad824143e51,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,4897494820709445,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,0x417252bade208,!1,[[0,[0,1570]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,6878513858891419,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,4635114812560706,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x609a703127873,!1,[[0,[0,431]],[0,[0,93]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xb0f421359b7b1,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,9783245792410378,[[-1,
cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5516545859217499,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,5917816693497696,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,0x93b934aec22,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9508981969953552,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,6839790878994322,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,7514476521396767,!1]],[[-1,cr.system_object.prototype.acts.SubVar,
null,0x7157b97af3e1b,!1,[[11,"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,8631246768410258,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x82f1abac74e0e,!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,7423971005264545,!1]]],[0,null,!1,null,8643442504601119,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,425799099491683,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7386355275947654,!1,[[1,[2,"passed"]],
[3,1]]]]],[0,null,!1,null,0x65e24532c46a,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7032109222549909,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,0xea1036b7f39ac,!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,4566463096879502,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5504221150284588,!1,[[11,"Oculos"],[8,0],[7,[0,20]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,521068575170576,!1]]],[0,null,!1,null,4608600884155149,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,4534187674418299,!1,[[4,87]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5640654626714214,!1,[[1,[2,"Dor"]],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",9402608161492848,!1,[[0,[0,40]],[0,[0,270]],[7,[0,0]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x61eb519720f09,!1,[[4,76],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5055567338244377,!1,[[4,87],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",9138772488781112,!1,[[4,86],[3,0]]],[75,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,7074760240718342,!1]]]]],["RedLevel18Events",[[2,"GameEventsRed",!1],[0,null,!1,null,9402873241452472,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5324226070324159,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,436671915750796,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x8b32cdd4cb806,!1,[[6,"RedLevel16"]]]]],[0,null,!1,null,6261649779775041,
[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6273996693794359,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,832348944376997,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7896977809115695,!1,[[11,"WorldBlocks"],[8,3],[7,[0,35]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,860841556800853,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,8248260821965813,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,
!1,!1,4569564432254676,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,4537013411285109,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8523639601619486,!1,[[11,"Tempo"],[7,[0,99]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5402074988428157,!1,[[11,"Oculos"],[7,[0,100]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5737564880515456,!1,[[4,76],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",883125506273962,
!1,[[4,87],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",88881959383179,!1,[[4,86],[3,1]]]]],[0,null,!1,null,0x7da0caeecbb4f,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7051424276918792,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6553022830964664,!1,[[0,[0,1659]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,9203642305740392,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!1,!1,4663014953223795,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xd7862896f4dc1,!1,[[0,[0,644]],[0,[0,-67]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x8b18a4fa69fa0,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,8978658269852416,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x6f45d54967025,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xd0c00102b1fb1,!1,[[0,[0,1662]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!0,!1,7499361162488971,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0x9907a168f60f0,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,7659047468525918,!1,[[0,[0,-10]],[0,[0,-143]]]],[-1,cr.system_object.prototype.acts.SubVar,null,7311441331601144,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0xcb2be914e4e67,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x5320f4d589ff4,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,9840225145505328,!1,[[0,[0,1658]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5318933595237082,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0xcef2280a93697,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,7146530738716651,!1,[[0,[0,644]],[0,[0,-67]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9955887082203536,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,6435584118510618,[[75,
cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,866901252196158,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,9388771159245160,!1,[[0,[0,1654]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,4966063494024632,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,7582918052459811,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,8705754647073216,!1,[[0,[0,431]],[0,[0,
93]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xf585d95bfeefc,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,3856782730089,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xc4fdf19cb3a79,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,8447051571690564,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,7332793454807371,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,511327269930371,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,
!1,5573950268338105,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xfaaeef1eb8f1,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,26607788432161,!1,[[11,"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,9005977357350801,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5229190948117475,!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,7440022661982772,!1]]],[0,null,!1,null,4662848175853284,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,5194502007401093,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6769958052014103,!1,[[1,[2,"passed"]],[3,1]]]]],[0,null,!1,null,5120569561476622,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6551083273945026,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,6033895436978815,!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,0x49f672c479f0e,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9bfe7ce866cb,!1,[[11,"Oculos"],[8,0],[7,
[0,20]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,4716658357886622,!1]]],[0,null,!1,null,7381177079338692,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7795299033445374,!1,[[4,87]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7704740423658905,!1,[[1,[2,"Dor"]],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",5494847422433683,!1,[[0,[0,40]],[0,[0,270]],[7,[0,0]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",
0xbad211f0bc0eb,!1,[[4,76],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xe9069ce31fba2,!1,[[4,87],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7548302647360097,!1,[[4,86],[3,0]]],[75,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,576172001620744,!1]]]]],["RedLevel16Events",[[2,"GameEventsRed",!1],[0,null,!1,null,5921748079474728,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xda28fdc49ef9,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,0xdb6880d2544b5,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7040207662318233,!1,[[6,"RedLevel17"]]]]],[0,null,!1,null,7248765636991414,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x7a944d263427a,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xf496efc20134d,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8494290517150105,!1,[[11,"WorldBlocks"],[8,3],[7,[0,33]]]]],[[-1,cr.system_object.prototype.acts.AddVar,
null,0xec8254718cfa7,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xd7602ce9db0c2,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x92478f6d68b4f,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0xe5876ce002e31,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,816971570618837,!1,[[11,"Tempo"],[7,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8738117500708354,!1,[[11,"Oculos"],[7,[0,100]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",5943093686887938,!1,[[4,76],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xbde3ce74d2824,!1,[[4,87],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",532427080942587,!1,[[4,86],[3,1]]]]],[0,null,!1,null,0xc903a116a6601,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,9114043153612296,!1,[[4,80]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,0xb1e92791c7f97,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!1,!1,6964525210194882,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,6249342945536399,!1,[[0,[0,406]],[0,[0,-102]]]],[-1,cr.system_object.prototype.acts.SubVar,null,5141566157631706,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,5219204633665365,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9471049177651022,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,9913104333715932,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,6247028864222274,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9044239959367760,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,4575918532966367,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xf67b8d5c236d5,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,8330761655481624,!1,[[11,"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,5191995775322394,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9586628739402896,!1,[[11,"Tempo"],[8,0],[7,
[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,7954907909087985,!1]]],[0,null,!1,null,0xa36317a277e4a,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8821296314434597,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8600002886981234,!1,[[1,[2,"passed"]],[3,1]]]]],[0,null,!1,null,0x504d3260763cf,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,476204350249392,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,9239695241617588,
!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,5586493318883832,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x4d24dcb450567,!1,[[11,"Oculos"],[8,0],[7,[0,40]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,836523641738093,!1]]],[0,null,!1,null,0xd596487adabb7,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7683366770400135,!1,[[4,87]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5182791797989289,!1,[[1,[2,"Dor"]],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,
"Physics",4808258196829484,!1,[[0,[0,40]],[0,[0,270]],[7,[0,0]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xdee2e08cfe433,!1,[[4,76],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5924505179024164,!1,[[4,87],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x87ff7eac02e73,!1,[[4,86],[3,0]]],[75,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,768740760478564,!1]]]]],["RedLevel17Events",[[2,"GameEventsRed",!1],[0,null,
!1,null,8776238729206186,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7576950139495024,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,7945362796747462,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7248333117891326,!1,[[6,"RedLevel18"]]]]],[0,null,!1,null,9530098417567360,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x806e6f172c50a,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,919745930975385,
!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd4c69e07302eb,!1,[[11,"WorldBlocks"],[8,3],[7,[0,34]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,4829249049338359,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0x6044061093867,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5524058031332007,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,5349990462639511,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,
7193368882269632,!1,[[11,"Tempo"],[7,[0,20]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6837989968439046,!1,[[11,"Oculos"],[7,[0,100]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6607487288297534,!1,[[4,76],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7362719738089666,!1,[[4,87],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5721560959702128,!1,[[4,86],[3,1]]]]],[0,null,!1,null,6902927631024257,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0x3bccd91f661c6,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x8ed5160725eea,!1,[[0,[0,1702]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5430732950022386,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,5975246520626931,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x9621d768a59a7,!1,[[0,[0,77]],[0,[0,173]]]],[-1,cr.system_object.prototype.acts.SubVar,
null,5785248154190289,!1,[[11,"Oculos"],[7,[0,30]]]]]],[0,null,!1,null,8540392996319106,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,9933597546276060,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6609518888450045,!1,[[0,[0,1797]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,4612619375763677,!1,[[1,[2,"Default"]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,5932807923876713,!1,[[1,[2,"Default"]]]]],
[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,9748604807105818,!1,[[0,[0,406]],[0,[0,-121]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xa7f726eb576a9,!1,[[11,"Oculos"],[7,[0,30]]]]]],[0,null,!1,null,0x785a52e3b535d,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7782440520810531,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0x71d351e32661,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,5949169029541476,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,
7980377568899226,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xe70844c9895cb,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x6ab2a4bfeaa11,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,5411434048623233,!1,[[11,"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,0xafdbe60b4d165,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5211841814318515,!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,
null,0xad30f8a3a846c,!1]]],[0,null,!1,null,5425570539996949,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x3a45b8899606f,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7173355167728879,!1,[[1,[2,"passed"]],[3,1]]]]],[0,null,!1,null,5322323984038432,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x91373d567aac3,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,0x9653bfe25aaa8,!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,0x8ecc0acb898f2,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6751893945555628,!1,[[11,"Oculos"],[8,0],[7,[0,40]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,6373017022347145,!1]]],[0,null,!1,null,9166968319344976,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x86aa85cfbf2f4,!1,[[4,87]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7733167249923909,!1,[[1,[2,"Dor"]],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",6099247532690121,
!1,[[0,[0,40]],[0,[0,270]],[7,[0,0]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6781052960996625,!1,[[4,76],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",401722315250595,!1,[[4,87],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x628a5668c1a7f,!1,[[4,86],[3,0]]],[75,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0x958d51e28e6ef,!1]]]]],["RedLevel15Events",[[2,"GameEventsRed",!1],[0,null,!1,null,755957722569061,[[24,
cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9581199744040828,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9700290892757588,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9830020931440812,!1,[[6,"RedLevel16"]]]]],[0,null,!1,null,0x438d8476c09b9,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6580968079292583,!1,[[4,19]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x423896c7e1409,!1],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x83a9cd6cdb8ef,!1,[[11,"WorldBlocks"],[8,3],[7,[0,35]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x799974bbbe955,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,0xf000d6138736e,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7737125459424852,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0x7d63fe2ea32f1,!1,[[5,[2,"game"]],[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x484c91e56c50f,!1,[[11,"Tempo"],[7,[0,15]]]],[-1,
cr.system_object.prototype.acts.SetVar,null,7076570777595095,!1,[[11,"Oculos"],[7,[0,100]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",9223733840446796,!1,[[4,76],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6208009447949326,!1,[[4,87],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xbf4a18e1f3fe6,!1,[[4,86],[3,1]]]]],[0,null,!1,null,5578042639787382,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,
!1,0x85b476c8d0d2a,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8209365204171859,!1,[[0,[0,1566]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5055354174362388,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,4512332608368404,!1,[[0,[0,70]],[0,[0,129]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9025854393677562,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0x53db9925a1f0b,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,876033212636481,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,652908333453801,!1,[[0,[0,1562]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,6394239675653533,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xa13d2d396e264,!1,[[0,[0,406]],[0,[0,-102]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9120790618777282,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,0xb220b6f31371f,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0x48cffa24e6530,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5599200906399083,!1,[[0,[0,1557]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,8629310292031091,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,948264189394291,!1,[[0,[0,867]],[0,[0,62]]]],[-1,cr.system_object.prototype.acts.SubVar,null,435749365104562,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,7158955717405962,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,6552509572073633,!1,[[4,80]]],[80,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8839943213133464,!1,[[0,[0,1570]]]],[79,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,7512912865709881,!1,[[1,[2,"Default"]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xb4016d701756f,!1,[[0,[0,431]],[0,[0,93]]]],[-1,cr.system_object.prototype.acts.SubVar,null,7693141726332556,!1,[[11,"Oculos"],[7,[0,20]]]]]],[0,null,!1,null,9040519174107968,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,0xc7c34a0631677,!1]],[[83,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0x6941ef52dc0f8,!1,[[7,[23,"Tempo"]]]]]],[0,null,!1,null,0x630fe3c24eed7,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7359670608230677,!1,[[0,[0,1]]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xba91d8c0f5946,!1],[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,6764063831898446,!1]],[[-1,cr.system_object.prototype.acts.SubVar,null,0x4934555f23ea4,!1,[[11,
"Tempo"],[7,[0,1]]]]]],[0,null,!1,null,0xd02ccbf288760,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9547450744209238,!1,[[11,"Tempo"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,6901948236474247,!1]]],[0,null,!1,null,0x7f0bafaedf4c3,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,8917810815691313,!1,[[4,79]]]],[[79,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x837ce92940eb6,!1,[[1,[2,"passed"]],[3,1]]]]],[0,null,!1,null,6417470756507498,
[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,597599079382493,!1]],[[86,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,0xd2189ad2b0dc3,!1,[[0,[23,"Oculos"]]]]]],[0,null,!1,null,4541002394184479,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xf534d158f1c09,!1,[[11,"Oculos"],[8,0],[7,[0,20]]]]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,98122880698013,!1]]],[0,null,!1,null,0xfbb9cfba507f8,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,
!0,8201556635014978,!1,[[4,87]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4708172055534175,!1,[[1,[2,"Dor"]],[3,1]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",6837521266524373,!1,[[0,[0,40]],[0,[0,270]],[7,[0,0]]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xbad4652f8ef0a,!1,[[4,76],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",8918961042571847,!1,[[4,87],[3,0]]],[75,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",0x48e4b2f1797b3,!1,[[4,86],[3,0]]],[75,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0x6413234ffa21b,!1]]]]],["GameEventsGreen",[[1,"Angulo",0,0,!1,!1,8146663804560898,!1],[1,"Forca",0,10,!1,!1,0xd9bc1dd5647ab,!1],[1,"Rotacao",0,0,!1,!1,0x8445756df0f74,!1],[2,"AudioEvents",!1],[0,null,!1,null,0x92ec71ecae565,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x6ecd510e052e3,!1,[[4,14]]],[14,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,8631372062264258,
!1]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,0x7532320e7e3bc,!1,[[2,["ok - 1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x7ecb24d28b9cd,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.AddVar,null,7252591038508716,!1,[[11,"StarsCatcheds"],[7,[0,1]]]]]],[0,null,!1,null,0xd3a8a1f4550e3,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5423742275278253,!1,[[4,7]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetY,null,9972076320723248,
!1,[[0,[0,240]]]],[41,cr.plugins_.Sprite.prototype.acts.SetY,null,4794454914220141,!1,[[0,[0,240]]]],[42,cr.plugins_.Sprite.prototype.acts.SetY,null,5373077387794136,!1,[[0,[0,240]]]],[43,cr.plugins_.Sprite.prototype.acts.SetY,null,5755940027964581,!1,[[0,[0,240]]]],[34,cr.plugins_.Sprite.prototype.acts.SetY,null,0x4924909701d58,!1,[[0,[0,240]]]]]],[0,null,!1,null,0x553b2e544079a,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8212286502644643,!1,[[4,43]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetY,
null,6474394846035287,!1,[[0,[0,2E3]]]],[41,cr.plugins_.Sprite.prototype.acts.SetY,null,527673181147536,!1,[[0,[0,2E3]]]],[42,cr.plugins_.Sprite.prototype.acts.SetY,null,0x774ae2753eb30,!1,[[0,[0,2E3]]]],[43,cr.plugins_.Sprite.prototype.acts.SetY,null,9177377243784332,!1,[[0,[0,2E3]]]],[34,cr.plugins_.Sprite.prototype.acts.SetY,null,0x580b2eddf07d3,!1,[[0,[0,2E3]]]]]],[0,null,!1,null,23484553399226,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4675814618058507,!1,[[4,40]]]],
[[-1,cr.system_object.prototype.acts.RestartLayout,null,347913830589434,!1]]],[0,null,!1,null,0xb1edd894b5d20,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf808bf346ecd7,!1,[[4,41]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x448e0d20983b2,!1,[[6,"Worlds"]]]]],[0,null,!1,null,0xd9bd67ac8612b,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,4661065128381542,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,6472354260224895,!1,[[11,"StarsCatcheds"],
[7,[0,0]]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9190170597965520,!1,[[3,0]]],[21,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9316628286099388,!1,[[3,0]]],[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,8123849043092188,!1],[-1,cr.system_object.prototype.acts.SaveState,null,9384342326874384,!1,[[1,[2,"mysave"]]]],[75,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x88fd46167aca4,!1,[[3,0]]]]],[0,null,!1,null,0x9e49752dc1dac,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,0xf9633eeea188f,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8065786328630762,!1,[[11,"StarsCatcheds"],[8,1],[7,[0,3]]]]],[[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0x90e4d5cc76762,!1,[[3,0]]]]],[0,null,!1,null,0x760251505e161,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6015491604098929,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,0]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8827441427921554,!1,[[1,[2,"zero"]],[3,1]]]]],
[0,null,!1,null,0x7ae867ab0242f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe3c1f50ef34dd,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,1]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8918394527605223,!1,[[1,[2,"um"]],[3,1]]]]],[0,null,!1,null,0x79b9142bccb0,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,699547610157771,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,2]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6760496171742266,!1,[[1,[2,"dois"]],[3,1]]]]],
[0,null,!1,null,0x4c964d2daca9c,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5255360908024762,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xcfcb476dd0253,!1,[[1,[2,"tres"]],[3,1]]]]],[0,null,!1,null,5862798129353302,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9013771292212386,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,555610444079746,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[16,cr.plugins_.Sprite.prototype.acts.MoveToTop,
null,0x4ee8189fc55d8,!1],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",8462596832646886,!1,[[3,1]]]]],[0,null,!1,null,0x96e880c628e99,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xe39bf149935b7,!1]],[[8,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,7073266666971556,!1],[-1,cr.system_object.prototype.acts.SetVar,null,0xb0dfc0152cdab,!1,[[11,"GameBallX"],[7,[20,75,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,
5695490491658245,!1,[[11,"GameBallY"],[7,[20,75,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0x4ddc8c568779d,!1,[[3,0]]]]],[0,null,!1,null,7517042286141792,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x5cd29ab84f175,!1,[[4,22]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7987476756295128,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[19,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9184283318308084,
!1,[[3,1]]],[19,cr.plugins_.Sprite.prototype.acts.SetPos,null,4574861568902348,!1,[[0,[0,400]],[0,[0,240]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xd1b5859e896e,!1,[[0,[0,400]],[0,[0,240]]]],[114,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xef0bfb34af48e,!1,[[0,[0,400]],[0,[0,420]]]],[8,cr.behaviors.Platform.prototype.acts.SetIgnoreInput,"Platform",499354969322802,!1,[[3,1]]],[75,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",5195157828675234,!1,[[3,1]]]]],[0,null,!1,null,
0x75ce782a213b0,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x5ca5c40c3a33c,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xdcae901edaa17,!1,[[11,"StarsCatcheds"],[8,1],[7,[0,3]]]]],[[8,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,6867433807203577,!1],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",7415622932665926,!1,[[3,0]]]]],[0,null,!1,null,0x936f6c1d3bce6,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x5e3c220d0d3ac,!1],
[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,643469435616651,!1,[[11,"StarsCatcheds"],[8,0],[7,[0,3]]]]],[[16,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,5184738807527522,!1],[21,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",8367370014222638,!1,[[3,1]]]]],[0,null,!1,null,0xe4594811053cf,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5942433230469309,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,0xf7d3573c54f43,!1,[[1,[2,"mysave"]]]],
[75,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",0x49583d27a6405,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4568033064252969,!1,[[11,"Audio"],[7,[0,0]]]]]],[0,null,!1,null,9730046891912694,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xbb2edb2a34274,!1,[[4,7]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xaa8a580865e64,!1,[[0,[0,0]]]]]],[0,null,!1,null,9210855390319412,[[34,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,
0,!1,!0,!1,0x9c375fb24928c,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8516304049981193,!1,[[0,[0,1]]]]]],[0,null,!1,null,8446725515922215,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xba25697c4546,!1,[[4,76]]],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,5897519937501001,!1]],[[51,cr.plugins_.Audio.prototype.acts.Play,null,627239301083566,!1,[[2,["bump1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,9953370708574660,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,8772272758153728,!1,[[0,[0,1]]]]],[[53,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0x3cc0e17b7e3d5,!1]]],[0,null,!1,null,8200886860054923,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9280709145003696,!1],[118,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9930448708641158,!1,[[10,0],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetLayerAngle,null,7871219298573846,!1,[[5,[2,"game"]],[0,[20,89,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null]]]],[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x6f96c510f10b1,!1,[[10,0],[7,[6,[19,cr.system_object.prototype.exps["int"],[[23,"Angulo"]]],[7,[22,75,"Physics",cr.behaviors.Physics.prototype.exps.Density,!1,null],[0,10]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xbfe6b0cd69f1,!1,[[11,"Angulo"],[7,[4,[19,cr.system_object.prototype.exps.layerangle,[[2,"game"]]],[0,90]]]]],[75,cr.behaviors.Physics.prototype.acts.ApplyForce,"Physics",5156822283474149,!1,[[0,[6,[19,cr.system_object.prototype.exps.cos,
[[19,cr.system_object.prototype.exps["int"],[[23,"Angulo"]]]]],[21,75,!1,null,0]]],[0,[6,[19,cr.system_object.prototype.exps.sin,[[19,cr.system_object.prototype.exps["int"],[[23,"Angulo"]]]]],[21,75,!1,null,0]]],[7,[0,0]]]]]],[0,null,!1,null,0x915b2b80e726c,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9056602699614460,!1],[118,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5269972113733569,!1,[[10,0],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetLayerAngle,
null,9240146926630554,!1,[[5,[2,"game"]],[0,[20,89,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]]]],[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5736601364647507,!1,[[10,0],[7,[6,[19,cr.system_object.prototype.exps["int"],[[23,"Angulo"]]],[7,[22,75,"Physics",cr.behaviors.Physics.prototype.exps.Density,!1,null],[0,-10]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb3d1737fa1c10,!1,[[11,"Angulo"],[7,[4,[19,cr.system_object.prototype.exps.layerangle,[[2,"game"]]],[0,90]]]]],
[75,cr.behaviors.Physics.prototype.acts.ApplyForce,"Physics",0xf2d4617d491d4,!1,[[0,[6,[19,cr.system_object.prototype.exps.cos,[[19,cr.system_object.prototype.exps["int"],[[23,"Angulo"]]]]],[21,75,!1,null,0]]],[0,[6,[19,cr.system_object.prototype.exps.sin,[[19,cr.system_object.prototype.exps["int"],[[23,"Angulo"]]]]],[21,75,!1,null,0]]],[7,[0,0]]]]]],[0,null,!1,null,8233721814604727,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xab4fb59a04cd,!1,[[0,[1,0.0010]]]],[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,5449603484549307,!1,[[4,12]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xfc9f0fd6d86a9,!1,[[11,"Angulo"],[7,[0,1]]]],[89,cr.behaviors.Physics.prototype.acts.SetAngularVelocity,"Physics",0x6ec3510770724,!1,[[0,[0,140]]]]]],[0,null,!1,null,5180282070808272,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6828974889396335,!1,[[0,[1,0.0010]]]],[24,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x419a0d1844f3b,!1,[[4,13]]]],[[-1,cr.system_object.prototype.acts.AddVar,
null,0x8751a544a1717,!1,[[11,"Angulo"],[7,[0,1]]]],[89,cr.behaviors.Physics.prototype.acts.SetAngularVelocity,"Physics",454260659447864,!1,[[0,[0,-140]]]]]],[0,null,!1,null,6976831836535404,[[24,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!0,!1,558343766432954,!1]],[[89,cr.behaviors.Physics.prototype.acts.SetAngularVelocity,"Physics",5521585150734477,!1,[[0,[0,0]]]]]],[0,null,!1,null,5150189715324974,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x513042e44d05d,!1,[[0,[1,0.0010]]]],
[23,cr.plugins_.Keyboard.prototype.cnds.IsKeyDown,null,0,!1,!1,!1,7394406430145003,!1,[[9,37]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,6582496865320537,!1,[[11,"Angulo"],[7,[0,1]]]],[89,cr.behaviors.Physics.prototype.acts.SetAngularVelocity,"Physics",0xf574a75ed37ac,!1,[[0,[0,140]]]]]],[0,null,!1,null,6015011340035552,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xd3021476ef5d6,!1,[[0,[1,0.0010]]]],[23,cr.plugins_.Keyboard.prototype.cnds.IsKeyDown,null,0,!1,!1,!1,0xa3a4c367e6e00,
!1,[[9,39]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6203689305552821,!1,[[11,"Angulo"],[7,[0,1]]]],[89,cr.behaviors.Physics.prototype.acts.SetAngularVelocity,"Physics",5444942702692759,!1,[[0,[0,-140]]]]]],[0,null,!1,null,0xed03b7455266d,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x39dd0ce18f035,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,9435968191114124,!1,[[11,"StarsCatcheds"],[7,[0,0]]]],[9,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xf399840ba7b32,
!1,[[3,0]]]]],[0,null,!1,null,7941408352947205,[[75,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7991588125257365,!1,[[4,9]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,0xe052cc375dbc,!1]]],[0,null,!1,null,6468245755942122,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6863890614687455,!1,[[4,118]]],[118,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8046205215281836,!1,[[10,0],[8,0],[7,[0,0]]]]],[[118,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,678945408535518,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0x87e81a85ed663,[[118,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8821157464023732,!1,[[10,0],[8,0],[7,[0,1]]]]],[[118,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7570190724742422,!1,[[1,[2,"on"]],[3,1]]]]],[0,null,!1,null,7259384224698682,[[118,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0xe9639f64c5816,!1,[[1,[2,"on"]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9303119072876976,
!1,[[0,[0,10]]]]],[[118,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7635444632616062,!1,[[1,[2,"off"]],[3,1]]],[118,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x7b6e9dcc576df,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,7683575448789066,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,0x3abe6523aacaa,!1,[[4,76]]],[76,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5701686231956368,!1,[[0,[20,76,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[76,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,5954449277886399,!1,[[4,49]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5843551145847403,!1,[[3,0]]]]],[0,null,!1,null,0xc6924b6d755c4,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8074443504443359,!1,[[4,114]]]],[[114,cr.plugins_.Sprite.prototype.acts.SetAnim,null,418354333132628,!1,[[1,[2,"ok"]],[3,1]]]]],[0,null,!1,null,9334247038829072,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7205198487481011,!1,[[4,121]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,
null,8799669187340689,!1]]]]],["GreenLevel1Event",[[2,"GameEventsGreen",!1],[0,null,!1,null,0x5ee645099549a,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5089348444684448,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,9403710175154488,!1,[[5,[2,"game"]],[0,[1,0.6]]]]]],[0,null,!1,null,0x3a32cc6c26310,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,5864379321011555,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xbb955af345362,
!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xa0334dba68ce9,!1,[[6,"GreenLevel2"]]]]],[0,null,!1,null,7430856764120008,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,7744681899739173,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9960521410747496,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5400904606243657,!1,[[11,"WorldBlocks"],[8,3],[7,[0,36]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,8208429246455557,!1,[[11,
"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,5822469774818164,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7590963524789042,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,289642458524592,!1,[[0,[0,1392]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,5805749520727791,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,"Flash",7967276452695386,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,5133063197586551,!1,[[0,[0,323]],[0,[0,405]]]]]],[0,null,!1,null,848627297090364,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4983215839013316,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,8037350044944893,!1,[[0,[0,1391]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,6004748391202342,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,"Flash",0xd8cf7906fd51d,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,0xfc96e1cf07f78,!1,[[0,[0,629]],[0,[0,403]]]]]]]],["GreenLevel2Event",[[2,"GameEventsGreen",!1],[0,null,!1,null,0xe5e2dc7509103,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x65cf8a0e4726a,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,5851047408913672,!1,[[5,[2,"game"]],[0,[1,0.6]]]]]],[0,null,!1,null,0x4157d6fa07c60,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,6058887381702368,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,
0,!1,!1,!1,6135888627349429,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8188520819744151,!1,[[6,"GreenLevel3"]]]]],[0,null,!1,null,5109060227068825,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,0x854f594944960,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5425531212689944,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8542254908864883,!1,[[11,"WorldBlocks"],[8,3],[7,[0,37]]]]],[[-1,cr.system_object.prototype.acts.AddVar,
null,0xba3074f58d713,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,6617084784853873,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8274747116755429,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,6233344759157875,!1,[[0,[0,2644]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,5241594846302625,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,"Flash",8510528036983546,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,7229734749819105,!1,[[0,[0,519]],[0,[0,190]]]]]],[0,null,!1,null,0x88a9c446c54d2,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd4e49a658edd9,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,943661487612032,!1,[[0,[0,2641]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,0x61e4e6c26e6ba,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,"Flash",0x8923a2afc0871,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,4661830942913944,!1,[[0,[0,591]],[0,[0,78]]]]]],[0,null,!1,null,0x68e0507647556,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4888935238998692,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,739521283039982,!1,[[0,[0,2642]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,8631751221495526,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,"Flash",859109844360757,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,
null,8369783000906557,!1,[[0,[0,26]],[0,[0,407]]]]]],[0,null,!1,null,0x8061c78869250,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7358706039701013,!1,[[4,9]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,894192990595234,!1]]]]],["GameLevel3Event",[[2,"GameEventsGreen",!1],[0,null,!1,null,0x486dd292cdb96,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5497103155131016,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,7173922383213373,
!1,[[5,[2,"game"]],[0,[1,0.6]]]]]],[0,null,!1,null,9627407491654612,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,0xfdac2b4fced1f,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xd22885fe4bf19,!1]],[]],[0,null,!1,null,7150339171418731,[[24,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,7825950340461528,!1],[19,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5076363269925266,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,6312606856218478,!1,[[11,"WorldBlocks"],[8,3],[7,[0,37]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,4919378676972684,!1,[[11,"WorldBlocks"],[7,[0,1]]]]]],[0,null,!1,null,5643733113716037,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5747008646361485,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x980aab582bfe5,!1,[[0,[0,1779]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,0xe304a2d91fd95,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,
"Flash",0xcd096acc296f5,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xbd0a416413fae,!1,[[0,[0,744]],[0,[0,75]]]]]],[0,null,!1,null,8625368952426941,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5222210823906711,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xd43275c4be341,!1,[[0,[0,1764]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,0xcce27190c1785,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,
"Flash",4539270832325762,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,5934289387415999,!1,[[0,[0,615]],[0,[0,76]]]]]],[0,null,!1,null,7932805490246589,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xcef647a9e0b1d,!1,[[4,119]]],[119,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x8aeb6b60be440,!1,[[0,[0,1776]]]],[75,cr.behaviors.Flash.prototype.cnds.IsFlashing,"Flash",0,!1,!0,!1,0xb8b37109ae8be,!1]],[[75,cr.behaviors.Flash.prototype.acts.Flash,
"Flash",9228494499118904,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[75,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x3fffccd18180d,!1,[[0,[0,-23]],[0,[0,426]]]]]],[0,null,!1,null,7324714994067743,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9324874171143576,!1,[[4,9]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,7478226057862336,!1]]]]],["GreenLevel4Event",[[2,"GameEventsGreen",!1],[0,null,!1,null,5578588675379432,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,7337451378518858,!1]],[[-1,cr.system_object.prototype.acts.SetLayerScale,null,0x69574765e764d,!1,[[5,[2,"game"]],[0,[1,0.5]]]]]],[0,null,!1,null,8125340909489127,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7722724525169521,!1]],[[123,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5394756888749399,!1,[[4,126],[7,[0,1]]]]]]]]],"",!0,854,480,4,!0,!0,!0,"1.0.0.0",!1,!1,2,2,2674,!0,!0,[]]};

createCocoonJSRuntime();

})();
